! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Parameter Module File
! 
! Generated by KPP-2.2.1_rs5 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : kpp_achem_gas_Parameters.f90
! Time                 : Fri Oct  5 10:08:19 2012
! Working directory    : /gpfsm/dnb32/adarmeno/models/geos-5/ganymed-1.0-UNSTABLE/src/GEOSgcs_GridComp/GEOSgcm_GridComp/GEOSagcm_GridComp/GEOSphysics_GridComp/GEOSchem_GridComp/GEOSachem_GridComp/kpp/gas
! Equation file        : kpp_achem_gas.kpp
! Output root filename : kpp_achem_gas
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE kpp_achem_gas_Parameters

  USE kpp_achem_gas_Precision
  PUBLIC
  SAVE


! NSPEC - Number of chemical species
  INTEGER, PARAMETER :: NSPEC = 8 
! NVAR - Number of Variable species
  INTEGER, PARAMETER :: NVAR = 5 
! NVARACT - Number of Active species
  INTEGER, PARAMETER :: NVARACT = 3 
! NFIX - Number of Fixed species
  INTEGER, PARAMETER :: NFIX = 3 
! NREACT - Number of reactions
  INTEGER, PARAMETER :: NREACT = 5 
! NVARST - Starting of variables in conc. vect.
  INTEGER, PARAMETER :: NVARST = 1 
! NFIXST - Starting of fixed in conc. vect.
  INTEGER, PARAMETER :: NFIXST = 6 
! NONZERO - Number of nonzero entries in Jacobian
  INTEGER, PARAMETER :: NONZERO = 8 
! LU_NONZERO - Number of nonzero entries in LU factoriz. of Jacobian
  INTEGER, PARAMETER :: LU_NONZERO = 8 
! CNVAR - (NVAR+1) Number of elements in compressed row format
  INTEGER, PARAMETER :: CNVAR = 6 
! CNEQN - (NREACT+1) Number stoicm elements in compressed col format
  INTEGER, PARAMETER :: CNEQN = 6 
! NHESS - Length of Sparse Hessian
  INTEGER, PARAMETER :: NHESS = 1 
! NLOOKAT - Number of species to look at
  INTEGER, PARAMETER :: NLOOKAT = 8 
! NMONITOR - Number of species to monitor
  INTEGER, PARAMETER :: NMONITOR = 7 
! NMASS - Number of atoms to check mass balance
  INTEGER, PARAMETER :: NMASS = 1 

! Index declaration for variable species in C and VAR
!   VAR(ind_spc) = C(ind_spc)

  INTEGER, PARAMETER :: ind_DMS = 1 
  INTEGER, PARAMETER :: ind_SO2 = 2 
  INTEGER, PARAMETER :: ind_NH3 = 3 
  INTEGER, PARAMETER :: ind_H2SO4 = 4 
  INTEGER, PARAMETER :: ind_MSA = 5 

! Index declaration for fixed species in C
!   C(ind_spc)

  INTEGER, PARAMETER :: ind_NO3 = 6 
  INTEGER, PARAMETER :: ind_OH = 7 
  INTEGER, PARAMETER :: ind_H2O = 8 

! Index declaration for fixed species in FIX
!    FIX(indf_spc) = C(ind_spc) = C(NVAR+indf_spc)

  INTEGER, PARAMETER :: indf_NO3 = 1 
  INTEGER, PARAMETER :: indf_OH = 2 
  INTEGER, PARAMETER :: indf_H2O = 3 

! NJVRP - Length of sparse Jacobian JVRP
  INTEGER, PARAMETER :: NJVRP = 5 

! NSTOICM - Length of Sparse Stoichiometric Matrix
  INTEGER, PARAMETER :: NSTOICM = 10 

END MODULE kpp_achem_gas_Parameters

