!**********************************************************************
      SUBROUTINE AerosolOH(BOH, dustrat, I,J,L,K)
!**********************************************************************
      IMPLICIT NONE
#     include "CMN_OH"
      INTEGER I,J,L,K
!****************************************************
! Created by Bryan Duncan.
!****************************************************
! This SR calculates the percent reduction of OH from the
! presence of absorbing/reflecting aerosols.  The percentages
! are from the work of Randall Martin.
!
!****************************************************
! List of Variables & Arrays
!
! BOH = array holding tropospheric parameterized OH.
!
      REAL*8 BOH(:,:,:)
      REAL*8 dustrat(:,:,:,:)
!
! PercentRed = array holding the percent reduction in OH
!     from an atmosphere with and without aerosols
!
!****************************************************
!
      IF(L.LE.18) BOH(I,J,L) = BOH(I,J,L) * dustrat(I,J,L,K)
      print*, 'DUSTstrat factor ', dustrat(I,J,L,K)
!
!***************************************************************
!
      RETURN
      END
