!**********************************************************************
      SUBROUTINE CLEANISOP(NDFUNCS)
!**********************************************************************
      IMPLICIT NONE
#     include "CMN_OH"
      INTEGER NDFUNCS,NALL,K
!**********************************************************************
! Select proper identification number of parameterization needed for
!   box characterized by unpolluted conditions with isoprene using
!   SR PARAMC. Store this value in COCOUNT. Then select the corresponding
!   polynomials and store in NDFUNCS.
!**********************************************************************
!   Created by Bryan Duncan.
!**********************************************************************
! C) Clean
!***************************************************
!  C1) Surface
!***************************************************
!
      IF(OH_PRESS.GE.PRESSES(1)) THEN
!
! Determine the identification number of the appropriate parameterization.
!
        CALL PARAMC(OH_LAT,OH_SEASON,COCOUNT,NSEAS,NLATS,ALATS)
!
! Error Check.
!
         IF(COCOUNT.EQ.0) THEN
           PRINT*,'COCOUNT=0 in SR CLEANISOP'
           STOP
         ENDIF
!
! Determine the polynomials associated with selected identification
!   number.
!
            NALL=3*NPARAMA+3*NPARAMB
         IF(COCOUNT.GT.1) THEN
          DO K=NALL+1,NALL+COCOUNT-1
           NDFUNCS=NDFUNCS+NDONE(K)
          ENDDO
         ENDIF
!
          COCOUNT=COCOUNT+NALL
!
! Error Check.
!
            NALL=NALL+NPARAMC
         IF(COCOUNT.GT.NALL) THEN
           PRINT*,'COCOUNT=',COCOUNT
           PRINT*,'NALL   =',NALL
           PRINT*,'COCOUNT > NALL in SR CLEANISOP'
           STOP
         ENDIF
!
            GOTO 321
!
      ENDIF
!
!***************************************************
!  END C1
!***************************************************
! Sum of all NDONE functions in C).
!
            NDFUNCS=NDFUNCS+NDFUNCSC1
!
!***************************************************
!  C2) Middle Troposphere
!***************************************************
!
      IF(OH_PRESS.LT.PRESSES(1).AND.OH_PRESS.GE.PRESSES(2)) THEN
!
! Determine the identification number of the appropriate parameterization.
!
        CALL PARAMC(OH_LAT,OH_SEASON,COCOUNT,NSEAS,NLATS,ALATS)
!
! Error Check.
!
         IF(COCOUNT.EQ.0) THEN
           PRINT*,'COCOUNT=0 in SR CLEANISOP'
           STOP
         ENDIF
!
! Determine the polynomials associated with selected identification
!   number.
!
            NALL=3*NPARAMA+3*NPARAMB+NPARAMC
         IF(COCOUNT.GT.1) THEN
          DO K=NALL+1,NALL+COCOUNT-1
           NDFUNCS=NDFUNCS+NDONE(K)
          ENDDO
         ENDIF
!
          COCOUNT=COCOUNT+NALL
!
! Error Check.
!
            NALL=NALL+NPARAMC
         IF(COCOUNT.GT.NALL) THEN
           PRINT*,'COCOUNT=',COCOUNT
           PRINT*,'NALL   =',NALL
           PRINT*,'COCOUNT > NALL in SR CLEANISOP'
           STOP
         ENDIF
!
            GOTO 321
!
      ENDIF
!
!***************************************************
!  END C2
!***************************************************
!
            NDFUNCS=NDFUNCS+NDFUNCSC2
!
!***************************************************
!  C3) Upper Troposphere
!***************************************************
!
      IF(OH_PRESS.LT.PRESSES(2)) THEN
!
! Determine the identification number of the appropriate parameterization.
!
        CALL PARAMC(OH_LAT,OH_SEASON,COCOUNT,NSEAS,NLATS,ALATS)
!
! Error Check.
!
         IF(COCOUNT.EQ.0) THEN
           PRINT*,'COCOUNT=0 in SR CLEANISOP'
           STOP
         ENDIF
!
! Determine the polynomials associated with selected identification
!   number.
!
            NALL=3*NPARAMA+3*NPARAMB+2*NPARAMC
         IF(COCOUNT.GT.1) THEN
          DO K=NALL+1,NALL+COCOUNT-1
           NDFUNCS=NDFUNCS+NDONE(K)
          ENDDO
         ENDIF
!
          COCOUNT=COCOUNT+NALL
!
! Error Check.
!
            NALL=NALL+NPARAMC
         IF(COCOUNT.GT.NALL) THEN
           PRINT*,'COCOUNT=',COCOUNT
           PRINT*,'NALL   =',NALL
           PRINT*,'COCOUNT > NALL in SR CLEANISOP'
           STOP
         ENDIF
!
            GOTO 321
!
      ENDIF
!
!***************************************************
!  END C3
!***************************************************
!
            NDFUNCS=NDFUNCS+NDFUNCSC3
!
!***************************************************
! Error check.
!
      PRINT*,'********************************'
      PRINT*,'Stopped in SR CLEANISOP!'
      PRINT*,'No parameterization was chosen!'
      PRINT*,'********************************'
      STOP
!
!***************************************************
 321  RETURN

      END SUBROUTINE CLEANISOP
