!**********************************************************************
      SUBROUTINE MODPOLLUTED(NDFUNCS)
!**********************************************************************
      IMPLICIT NONE
#     include "CMN_OH"
      INTEGER NDFUNCS,NALL,K
!**********************************************************************
! Select proper identification number of parameterization needed for
!   box characterized by unpolluted conditions with isoprene using
!   SR PARAMD-F. Store this value in COCOUNT. Then select the corresponding
!   polynomials and store in NDFUNCS.
!**********************************************************************
!   Created by Bryan Duncan.
!**********************************************************************
! D) Moderately Polluted
!***************************************************
!  D1) Surface
!***************************************************
!
      IF(OH_PRESS.GE.PRESSES(1)) THEN
!
! Determine the identification number of the appropriate parameterization.
!
        CALL PARAMD(OH_LAT,OH_SEASON,COCOUNT,NSEAS,NLATS,ALATS)
!
! Error Check.
!
         IF(COCOUNT.EQ.0) THEN
           PRINT*,'No parameterization was chosen!'
           PRINT*,'COCOUNT=0 in SR MODPOLLUTED'
           STOP
         ENDIF
!
! Determine the polynomials associated with selected identification
!   number.
!
            NALL=3*NPARAMA+3*NPARAMB+3*NPARAMC
         IF(COCOUNT.GT.1) THEN
          DO K=NALL+1,NALL+COCOUNT-1
           NDFUNCS=NDFUNCS+NDONE(K)
          ENDDO
         ENDIF
!
          COCOUNT=COCOUNT+NALL
!
! Error Check.
!
            NALL=NALL+NPARAMD
         IF(COCOUNT.GT.NALL) THEN
           PRINT*,'COCOUNT=',COCOUNT
           PRINT*,'NALL   =',NALL
           PRINT*,'COCOUNT > NALL in SR MODPOLLUTED'
           STOP
         ENDIF
!
            GOTO 321
!
      ENDIF
!
!***************************************************
!  END D1
!***************************************************
!  F1) Middle Troposphere
!***************************************************
!
      IF(OH_PRESS.LT.PRESSES(1).AND.OH_PRESS.GE.PRESSES(2)) THEN
!
! Determine the identification number of the appropriate parameterization.
!
        CALL PARAMF(OH_LAT,OH_SEASON,COCOUNT,NSEAS,NLATS,ALATS)
!
! Error Check.
!
         IF(COCOUNT.EQ.0) THEN
           PRINT*,'COCOUNT=0 in SR MODPOLLUTED'
           STOP
         ENDIF
!
! Determine the polynomials associated with selected identification
!   number.
!
            NALL=3*NPARAMA+3*NPARAMB+3*NPARAMC+NPARAMD+NPARAME
         IF(COCOUNT.GT.1) THEN
          DO K=NALL+1,NALL+COCOUNT-1
           NDFUNCS=NDFUNCS+NDONE(K)
          ENDDO
         ENDIF
!
          COCOUNT=COCOUNT+NALL
!
! Error Check.
!
            NALL=NALL+NPARAMF
         IF(COCOUNT.GT.NALL) THEN
           PRINT*,'COCOUNT=',COCOUNT
           PRINT*,'NALL   =',NALL
           PRINT*,'COCOUNT > NALL in SR MODPOLLUTED'
           STOP
         ENDIF
!
            GOTO 321
!
      ENDIF
!
!***************************************************
!  END F1
!***************************************************
! Error check.
!
      PRINT*,'********************************'
      PRINT*,'Stopped in SR MODPOLLUTED!'
      PRINT*,'No parameterization was chosen!'
      PRINT*,'********************************'
      STOP
!
!***************************************************
 321  RETURN

      END SUBROUTINE MODPOLLUTED
