!**********************************************************************
      SUBROUTINE read_dustrat (unitNum, fileName, dustrat, MLONBX, MLATBX)
!**********************************************************************
      IMPLICIT NONE
#     include "CMN_OH"

      INTEGER :: unitNum
      INTEGER :: MLONBX, MLATBX
      REAL*8  :: dustrat (MLONBX, MLATBX, 18, 12)
      CHARACTER (len=*) :: fileName

      INTEGER I,J,L,K
!****************************************************
! Created by Bryan Duncan.
!****************************************************
! This SR reads in information needed for SR AerosolOH.
!****************************************************
! List of Variables & Arrays
!
!  = array holding the percent reduction in OH
!     from an atmosphere with and without aerosols
!
!****************************************************
      print*,'Reading in info for OH reduction by aerosols'
      print*,'in SR read_percentages.'
!
!bnd      OPEN(NGENERICFILE,FILE='oh.dust.ratio',STATUS='OLD') 

      OPEN(UNIT=unitNum, FILE=TRIM(fileName),STATUS='OLD')

      ! unitNum = NGENERICFILE
      ! OPEN(NGENERICFILE,FILE='oh.allaer.ratio',STATUS='OLD') 
!
      dustrat(:,:,:,:)=1.
!
      DO K=1,12
         DO I=1,MLONBX
            DO J=1,MLATBX
               DO L=1,18
                  READ(unitNum,*) dustrat(I,J,L,K)
               ENDDO
            ENDDO
         ENDDO
      ENDDO
!
      CLOSE(unitNum)
      print*,'Leaving SR read_percentages.'
!       
!***************************************************************
!
      RETURN
      END SUBROUTINE read_dustrat
