!**********************************************************************
      SUBROUTINE read_srefl (unitNum, fileName)
!**********************************************************************
      IMPLICIT NONE
#     include "CMN_CO"

      INTEGER :: unitNum
      CHARACTER (len=*) :: fileName

      INTEGER :: J, M
!****************************************************
! Created by Bryan Duncan.
!****************************************************
!*****************************************************************************
! Read in reflectivity table (Srefl.table)
! Table data used to convert user's optical depths to
!   flux fractions - see get_fluxfraction.f.
!*****************************************************************************

      OPEN(UNIT=unitNum, FILE=TRIM(fileName),STATUS='OLD')

      !OPEN (UNIT=unitNum,FILE='Srefl.table',STATUS='old')
      REWIND(unitNum)
!     
      READ(unitNum,9)
 9    FORMAT(////)

      DO M=1,NREFL
         READ(unitNum,100) OPTDEPTH(M),(RFLC(M,J),J=1,NREFLCOL)
      END DO
!     
 100     FORMAT(3X,F6.3,5(F8.3))

      CLOSE(unitNum)
!       
!***************************************************************
!
      RETURN
      END SUBROUTINE read_srefl
