!**********************************************************************
      SUBROUTINE REMOTE(NDFUNCS)
!**********************************************************************
      IMPLICIT NONE
#     include "CMN_OH"
      INTEGER NDFUNCS,NALL,K
!**********************************************************************
! Select proper identification number of parameterization needed for 
!   box characterized by remote conditions and no isoprene using
!   SR PARAMB. Store this value in COCOUNT. Then select the corresponding 
!   polynomials and store in NDFUNCS.
!**********************************************************************
!   Created by Bryan Duncan.
!**********************************************************************
! B) Remote
!***************************************************
!  B1) Surface
!***************************************************
!
      IF(OH_PRESS.GE.PRESSES(1)) THEN
!
! Determine the identification number of the appropriate parameterization.
!
        CALL PARAMB(OH_LAT,OH_SEASON,COCOUNT,NSEAS,NLATS,ALATS)
!
! Error Check.
!
         IF(COCOUNT.EQ.0) THEN
           PRINT*,'COCOUNT=0!'
           PRINT*,'No parameterization was chosen!'
           PRINT*,'Stopped in SR REMOTE.'
           STOP 
         ENDIF
!
! Determine the polynomials associated with selected identification
!   number.
!
         IF(COCOUNT.GT.1) THEN
          DO K=1,COCOUNT-1
           NDFUNCS=NDFUNCS+NDONE(K)
          ENDDO
         ENDIF
!
! Error Check.
!
            NALL=NPARAMB
         IF(COCOUNT.GT.NALL) THEN
           PRINT*,'COCOUNT=',COCOUNT
           PRINT*,'NALL   =',NALL
           PRINT*,'COCOUNT > NALL in SR REMOTE'
           STOP
         ENDIF
!
            GOTO 321
!
      ENDIF
!
!***************************************************
!  END B1
!***************************************************
! Sum of all NDONE functions in B).
!
            NDFUNCS=NDFUNCS+NDFUNCSB1
!
!***************************************************
!  B2) Middle Troposphere
!***************************************************
!
     IF(OH_PRESS.LT.PRESSES(1).AND.OH_PRESS.GE.PRESSES(2)) THEN
!
! Determine the identification number of the appropriate parameterization.
!
        CALL PARAMB(OH_LAT,OH_SEASON,COCOUNT,NSEAS,NLATS,ALATS)
!
! Error Check.
!
         IF(COCOUNT.EQ.0) THEN
           PRINT*,'COCOUNT=0!'
           PRINT*,'No parameterization was chosen!'
           PRINT*,'Stopped in SR REMOTE.'
           STOP
         ENDIF
!
! Determine the polynomials associated with selected identification
!   number.
!
            NALL=NPARAMB
         IF(COCOUNT.GT.1) THEN
          DO K=NALL+1,NALL+COCOUNT-1
           NDFUNCS=NDFUNCS+NDONE(K)
          ENDDO
         ENDIF
!
          COCOUNT=COCOUNT+NALL
!
! Error Check.
!
            NALL=NALL+NPARAMB
         IF(COCOUNT.GT.NALL) THEN
           PRINT*,'COCOUNT=',COCOUNT
           PRINT*,'NALL   =',NALL
           PRINT*,'COCOUNT > NALL in SR REMOTE'
           STOP
         ENDIF
!
            GOTO 321
!
      ENDIF
!
!***************************************************
!  END B2
!***************************************************
! Sum of all NDONE functions in B).
!
            NDFUNCS=NDFUNCS+NDFUNCSB2
!
!***************************************************
!  B3) Upper Troposphere
!***************************************************
!
      IF(OH_PRESS.LT.PRESSES(2)) THEN
!
! Determine the identification number of the appropriate parameterization.
!
        CALL PARAMB(OH_LAT,OH_SEASON,COCOUNT,NSEAS,NLATS,ALATS)
!
! Error Check.
!
         IF(COCOUNT.EQ.0) THEN
           PRINT*,'COCOUNT=0!'
           PRINT*,'No parameterization was chosen!'
           PRINT*,'Stopped in SR REMOTE.'
           STOP
         ENDIF
!
! Determine the polynomials associated with selected identification
!   number.
!
            NALL=2*NPARAMB
         IF(COCOUNT.GT.1) THEN
          DO K=NALL+1,NALL+COCOUNT-1
           NDFUNCS=NDFUNCS+NDONE(K)
          ENDDO
         ENDIF
!
          COCOUNT=COCOUNT+NALL
!
! Error Check.
!
            NALL=NALL+NPARAMB
         IF(COCOUNT.GT.NALL) THEN
           PRINT*,'COCOUNT=',COCOUNT
           PRINT*,'NALL   =',NALL
           PRINT*,'COCOUNT > NALL in SR REMOTE'
           STOP
         ENDIF
!
            GOTO 321
!
      ENDIF
!
!***************************************************
!  END B3
!***************************************************
! Sum of all NDONE functions in B).
!
            NDFUNCS=NDFUNCS+NDFUNCSB3
!
!***************************************************
! Error check.
!    
      PRINT*,'********************************'
      PRINT*,'Stopped in SR REMOTE!'
      PRINT*,'No parameterization was chosen!'
      PRINT*,'********************************'
      STOP
!
!***************************************************
 321  RETURN
      END SUBROUTINE REMOTE
