!                           DISCLAIMER
!
!   This file was generated by TAF version 1.9.30
!
!   FASTOPT DISCLAIMS  ALL  WARRANTIES,  EXPRESS  OR  IMPLIED,
!   INCLUDING (WITHOUT LIMITATION) ALL IMPLIED  WARRANTIES  OF
!   MERCHANTABILITY  OR FITNESS FOR A PARTICULAR PURPOSE, WITH
!   RESPECT TO THE SOFTWARE AND USER PROGRAMS.   IN  NO  EVENT
!   SHALL  FASTOPT BE LIABLE FOR ANY LOST OR ANTICIPATED PROF-
!   ITS, OR ANY INDIRECT, INCIDENTAL, EXEMPLARY,  SPECIAL,  OR
!   CONSEQUENTIAL  DAMAGES, WHETHER OR NOT FASTOPT WAS ADVISED
!   OF THE POSSIBILITY OF SUCH DAMAGES.
!
!                           Haftungsbeschraenkung
!   FastOpt gibt ausdruecklich keine Gewaehr, explizit oder indirekt,
!   bezueglich der Brauchbarkeit  der Software  fuer einen bestimmten
!   Zweck.   Unter  keinen  Umstaenden   ist  FastOpt   haftbar  fuer
!   irgendeinen Verlust oder nicht eintretenden erwarteten Gewinn und
!   allen indirekten,  zufaelligen,  exemplarischen  oder  speziellen
!   Schaeden  oder  Folgeschaeden  unabhaengig  von einer eventuellen
!   Mitteilung darueber an FastOpt.
!
module     ada2b_edge_mod
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.30  **
!******************************************************************
!******************************************************************
!==============================================
! referencing used modules
!==============================================
use pre_direct_new
use fv_grid_utils_mod, only : edge_e,edge_n,edge_s,edge_w,ne_corner,nw_corner,se_corner,sw_corner,van2
use fv_grid_tools_mod, only : dxa,dya,grid_type
use fv_mp_mod, only : gid
use a2b_edge_mod

!==============================================
! all entries are defined explicitly
!==============================================
implicit none

contains
subroutine ada2b_ord2_kill( adqin, adqout, npx, npy, is, ie, js, je, ng, replace )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.38  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r3 = 1./3.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: ie
integer, intent(in) :: is
integer, intent(in) :: je
integer, intent(in) :: js
integer, intent(in) :: ng
real, intent(inout) :: adqin(is-ng:ie+ng,js-ng:je+ng)
real, intent(inout) :: adqout(is-ng:ie+ng,js-ng:je+ng)
integer, intent(in) :: npx
integer, intent(in) :: npy
logical,optional, intent(in) :: replace

!==============================================
! declare local variables
!==============================================
real :: adq1(npx)
real :: adq2(npy)
integer :: i
integer :: ie1
integer :: is1
integer :: is2
integer :: j
integer :: je1
integer :: js1
integer :: js2

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
adq1(:) = 0.
adq2(:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
if (present(replace)) then
  if (replace) then
    do j = js, je+1
      do i = is, ie+1
        adqout(i,j) = adqout(i,j)+adqin(i,j)
        adqin(i,j) = 0.
      end do
    end do
  endif
endif
if (grid_type .lt. 3) then
  is1 = max(1,is-1)
  js1 = max(1,js-1)
  is2 = max(2,is)
  js2 = max(2,js)
  ie1 = min(npx-1,ie+1)
  je1 = min(npy-1,je+1)
  if (je+1 .eq. npy) then
    do i = is2, ie1
      adq1(i-1) = adq1(i-1)+adqout(i,npy)*edge_n(i)
      adq1(i) = adq1(i)+adqout(i,npy)*(1.-edge_n(i))
      adqout(i,npy) = 0.
    end do
    do i = is1, ie1
      adqin(i,npy-1) = adqin(i,npy-1)+0.5*adq1(i)
      adqin(i,npy) = adqin(i,npy)+0.5*adq1(i)
      adq1(i) = 0.
    end do
  endif
  if (js .eq. 1) then
    do i = is2, ie1
      adq1(i-1) = adq1(i-1)+adqout(i,1)*edge_s(i)
      adq1(i) = adq1(i)+adqout(i,1)*(1.-edge_s(i))
      adqout(i,1) = 0.
    end do
    do i = is1, ie1
      adqin(i,1) = adqin(i,1)+0.5*adq1(i)
      adqin(i,0) = adqin(i,0)+0.5*adq1(i)
      adq1(i) = 0.
    end do
  endif
  if (ie+1 .eq. npx) then
    do j = js2, je1
      adq2(j-1) = adq2(j-1)+adqout(npx,j)*edge_e(j)
      adq2(j) = adq2(j)+adqout(npx,j)*(1.-edge_e(j))
      adqout(npx,j) = 0.
    end do
    do j = js1, je1
      adqin(npx-1,j) = adqin(npx-1,j)+0.5*adq2(j)
      adqin(npx,j) = adqin(npx,j)+0.5*adq2(j)
      adq2(j) = 0.
    end do
  endif
  if (is .eq. 1) then
    do j = js2, je1
      adq2(j-1) = adq2(j-1)+adqout(1,j)*edge_w(j)
      adq2(j) = adq2(j)+adqout(1,j)*(1.-edge_w(j))
      adqout(1,j) = 0.
    end do
    do j = js1, je1
      adqin(1,j) = adqin(1,j)+0.5*adq2(j)
      adqin(0,j) = adqin(0,j)+0.5*adq2(j)
      adq2(j) = 0.
    end do
  endif
  if (nw_corner) then
    adqin(1,npy-1) = adqin(1,npy-1)+adqout(1,npy)*r3
    adqin(0,npy-1) = adqin(0,npy-1)+adqout(1,npy)*r3
    adqin(1,npy) = adqin(1,npy)+adqout(1,npy)*r3
    adqout(1,npy) = 0.
  endif
  if (ne_corner) then
    adqin(npx-1,npy-1) = adqin(npx-1,npy-1)+adqout(npx,npy)*r3
    adqin(npx,npy-1) = adqin(npx,npy-1)+adqout(npx,npy)*r3
    adqin(npx-1,npy) = adqin(npx-1,npy)+adqout(npx,npy)*r3
    adqout(npx,npy) = 0.
  endif
  if (se_corner) then
    adqin(npx-1,1) = adqin(npx-1,1)+adqout(npx,1)*r3
    adqin(npx,1) = adqin(npx,1)+adqout(npx,1)*r3
    adqin(npx-1,0) = adqin(npx-1,0)+adqout(npx,1)*r3
    adqout(npx,1) = 0.
  endif
  if (sw_corner) then
    adqin(1,1) = adqin(1,1)+adqout(1,1)*r3
    adqin(0,1) = adqin(0,1)+adqout(1,1)*r3
    adqin(1,0) = adqin(1,0)+adqout(1,1)*r3
    adqout(1,1) = 0.
  endif
  do j = js2, je1
    do i = is2, ie1
      adqin(i-1,j-1) = adqin(i-1,j-1)+0.25*adqout(i,j)
      adqin(i,j-1) = adqin(i,j-1)+0.25*adqout(i,j)
      adqin(i-1,j) = adqin(i-1,j)+0.25*adqout(i,j)
      adqin(i,j) = adqin(i,j)+0.25*adqout(i,j)
      adqout(i,j) = 0.
    end do
  end do
else
  do j = js, je+1
    do i = is, ie+1
      adqin(i-1,j-1) = adqin(i-1,j-1)+0.25*adqout(i,j)
      adqin(i,j-1) = adqin(i,j-1)+0.25*adqout(i,j)
      adqin(i-1,j) = adqin(i-1,j)+0.25*adqout(i,j)
      adqin(i,j) = adqin(i,j)+0.25*adqout(i,j)
      adqout(i,j) = 0.
    end do
  end do
endif

end subroutine ada2b_ord2_kill


subroutine ada2b_ord4( adqin, adqout, npx, npy, is, ie, js, je, ng, replace )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.38  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: a1 = 0.5625
real, parameter :: a2 = -0.0625
real, parameter :: b1 = 7./12.
real, parameter :: b2 = -(1./12.)
real, parameter :: c1 = 2./3.
real, parameter :: c2 = -(1./6.)
real, parameter :: d1 = 0.375
real, parameter :: d2 = -(1./24.)

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: ie
integer, intent(in) :: is
integer, intent(in) :: je
integer, intent(in) :: js
integer, intent(in) :: ng
real, intent(inout) :: adqin(is-ng:ie+ng,js-ng:je+ng)
real, intent(inout) :: adqout(is-ng:ie+ng,js-ng:je+ng)
integer, intent(in) :: npx
integer, intent(in) :: npy
logical,optional, intent(in) :: replace

!==============================================
! declare local variables
!==============================================
real :: adqx(is:ie+1,js-ng:je+ng)
real :: adqxx(is-ng:ie+ng,js-ng:je+ng)
real :: adqy(is-ng:ie+ng,js:je+1)
real :: adqyy(is-ng:ie+ng,js-ng:je+ng)
real :: gratio
integer :: i
integer :: j

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
adqx(:,:) = 0.
adqxx(:,:) = 0.
adqy(:,:) = 0.
adqyy(:,:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
if (present(replace)) then
  if (replace) then
    do j = js, je+1
      do i = is, ie+1
        adqout(i,j) = adqout(i,j)+adqin(i,j)
        adqin(i,j) = 0.
      end do
    end do
  endif
endif
if (grid_type .lt. 3) then
  do j = max(2,js), min(npy-1,je+1)
    do i = max(2,is), min(npx-1,ie+1)
      adqxx(i,j) = adqxx(i,j)+0.5*adqout(i,j)
      adqyy(i,j) = adqyy(i,j)+0.5*adqout(i,j)
      adqout(i,j) = 0.
    end do
    if (ie+1 .eq. npx) then
      adqout(npx,j) = adqout(npx,j)+adqyy(npx-1,j)*c2
      adqy(npx-2,j) = adqy(npx-2,j)+adqyy(npx-1,j)*c1
      adqy(npx-1,j) = adqy(npx-1,j)+adqyy(npx-1,j)*c1
      adqyy(npx-2,j) = adqyy(npx-2,j)+adqyy(npx-1,j)*c2
      adqyy(npx-1,j) = 0.
    endif
    if (is .eq. 1) then
      adqout(1,j) = adqout(1,j)+adqyy(2,j)*c2
      adqy(2,j) = adqy(2,j)+adqyy(2,j)*c1
      adqy(1,j) = adqy(1,j)+adqyy(2,j)*c1
      adqyy(3,j) = adqyy(3,j)+adqyy(2,j)*c2
      adqyy(2,j) = 0.
    endif
    do i = max(3,is), min(npx-2,ie+1)
      adqy(i-2,j) = adqy(i-2,j)+adqyy(i,j)*a2
      adqy(i-1,j) = adqy(i-1,j)+adqyy(i,j)*a1
      adqy(i+1,j) = adqy(i+1,j)+adqyy(i,j)*a2
      adqy(i,j) = adqy(i,j)+adqyy(i,j)*a1
      adqyy(i,j) = 0.
    end do
  end do
  if (je+1 .eq. npy) then
    do i = max(2,is), min(npx-1,ie+1)
      adqout(i,npy) = adqout(i,npy)+adqxx(i,npy-1)*c2
      adqx(i,npy-2) = adqx(i,npy-2)+adqxx(i,npy-1)*c1
      adqx(i,npy-1) = adqx(i,npy-1)+adqxx(i,npy-1)*c1
      adqxx(i,npy-2) = adqxx(i,npy-2)+adqxx(i,npy-1)*c2
      adqxx(i,npy-1) = 0.
    end do
  endif
  if (js .eq. 1) then
    do i = max(2,is), min(npx-1,ie+1)
      adqout(i,1) = adqout(i,1)+adqxx(i,2)*c2
      adqx(i,2) = adqx(i,2)+adqxx(i,2)*c1
      adqx(i,1) = adqx(i,1)+adqxx(i,2)*c1
      adqxx(i,3) = adqxx(i,3)+adqxx(i,2)*c2
      adqxx(i,2) = 0.
    end do
  endif
  do j = max(3,js), min(npy-2,je+1)
    do i = max(2,is), min(npx-1,ie+1)
      adqx(i,j-2) = adqx(i,j-2)+adqxx(i,j)*a2
      adqx(i,j-1) = adqx(i,j-1)+adqxx(i,j)*a1
      adqx(i,j+1) = adqx(i,j+1)+adqxx(i,j)*a2
      adqx(i,j) = adqx(i,j)+adqxx(i,j)*a1
      adqxx(i,j) = 0.
    end do
  end do
  if (je+1 .eq. npy) then
    if (ie+1 .eq. npx) then
      adqout(npx-2,npy) = adqout(npx-2,npy)+adqout(npx-1,npy)*c2
      adqout(npx,npy) = adqout(npx,npy)+adqout(npx-1,npy)*c2
      adqy(npx-2,npy) = adqy(npx-2,npy)+adqout(npx-1,npy)*c1
      adqy(npx-1,npy) = adqy(npx-1,npy)+adqout(npx-1,npy)*c1
      adqout(npx-1,npy) = 0.
    endif
    if (is .eq. 1) then
      adqout(3,npy) = adqout(3,npy)+adqout(2,npy)*c2
      adqout(1,npy) = adqout(1,npy)+adqout(2,npy)*c2
      adqy(2,npy) = adqy(2,npy)+adqout(2,npy)*c1
      adqy(1,npy) = adqy(1,npy)+adqout(2,npy)*c1
      adqout(2,npy) = 0.
    endif
    do i = max(3,is), min(npx-2,ie+1)
      adqy(i-2,npy) = adqy(i-2,npy)+adqout(i,npy)*a2
      adqy(i-1,npy) = adqy(i-1,npy)+adqout(i,npy)*a1
      adqy(i+1,npy) = adqy(i+1,npy)+adqout(i,npy)*a2
      adqy(i,npy) = adqy(i,npy)+adqout(i,npy)*a1
      adqout(i,npy) = 0.
    end do
    do i = max(1,is-2), min(npx-1,ie+2)
      gratio = dya(i,npy-2)/dya(i,npy-1)
      adqin(i,npy-2) = adqin(i,npy-2)+adqy(i,npy-1)*(3/(2.+2.*gratio))
      adqin(i,npy-1) = adqin(i,npy-1)+adqy(i,npy-1)*(3.*gratio/(2.+2.*gratio))
      adqy(i,npy-2) = adqy(i,npy-2)-adqy(i,npy-1)/(2.+2.*gratio)
      adqy(i,npy) = adqy(i,npy)-adqy(i,npy-1)*(gratio/(2.+2.*gratio))
      adqy(i,npy-1) = 0.
      adqin(i,npy-2) = adqin(i,npy-2)+adqy(i,npy)*((-0.5)/(1.+gratio))
      adqin(i,npy-1) = adqin(i,npy-1)+adqy(i,npy)*(0.5*(2+gratio)/(1.+gratio))
      adqin(i,npy+1) = adqin(i,npy+1)+adqy(i,npy)*((-0.5)/(1.+gratio))
      adqin(i,npy) = adqin(i,npy)+adqy(i,npy)*(0.5*(2+gratio)/(1.+gratio))
      adqy(i,npy) = 0.
    end do
  endif
  if (js .eq. 1) then
    if (ie+1 .eq. npx) then
      adqout(npx-2,1) = adqout(npx-2,1)+adqout(npx-1,1)*c2
      adqout(npx,1) = adqout(npx,1)+adqout(npx-1,1)*c2
      adqy(npx-2,1) = adqy(npx-2,1)+adqout(npx-1,1)*c1
      adqy(npx-1,1) = adqy(npx-1,1)+adqout(npx-1,1)*c1
      adqout(npx-1,1) = 0.
    endif
    if (is .eq. 1) then
      adqout(3,1) = adqout(3,1)+adqout(2,1)*c2
      adqout(1,1) = adqout(1,1)+adqout(2,1)*c2
      adqy(2,1) = adqy(2,1)+adqout(2,1)*c1
      adqy(1,1) = adqy(1,1)+adqout(2,1)*c1
      adqout(2,1) = 0.
    endif
    do i = max(3,is), min(npx-2,ie+1)
      adqy(i-2,1) = adqy(i-2,1)+adqout(i,1)*a2
      adqy(i-1,1) = adqy(i-1,1)+adqout(i,1)*a1
      adqy(i+1,1) = adqy(i+1,1)+adqout(i,1)*a2
      adqy(i,1) = adqy(i,1)+adqout(i,1)*a1
      adqout(i,1) = 0.
    end do
    do i = max(1,is-2), min(npx-1,ie+2)
      gratio = dya(i,2)/dya(i,1)
      adqin(i,2) = adqin(i,2)+adqy(i,2)*(3/(2.+2.*gratio))
      adqin(i,1) = adqin(i,1)+adqy(i,2)*(3.*gratio/(2.+2.*gratio))
      adqy(i,3) = adqy(i,3)-adqy(i,2)/(2.+2.*gratio)
      adqy(i,1) = adqy(i,1)-adqy(i,2)*(gratio/(2.+2.*gratio))
      adqy(i,2) = 0.
      adqin(i,-1) = adqin(i,-1)+adqy(i,1)*((-0.5)/(1.+gratio))
      adqin(i,2) = adqin(i,2)+adqy(i,1)*((-0.5)/(1.+gratio))
      adqin(i,1) = adqin(i,1)+adqy(i,1)*(0.5*(2+gratio)/(1.+gratio))
      adqin(i,0) = adqin(i,0)+adqy(i,1)*(0.5*(2+gratio)/(1.+gratio))
      adqy(i,1) = 0.
    end do
  endif
  do j = max(3,js), min(npy-2,je+1)
    do i = max(1,is-2), min(npx-1,ie+2)
      adqin(i,j-2) = adqin(i,j-2)+adqy(i,j)*b2
      adqin(i,j-1) = adqin(i,j-1)+adqy(i,j)*b1
      adqin(i,j+1) = adqin(i,j+1)+adqy(i,j)*b2
      adqin(i,j) = adqin(i,j)+adqy(i,j)*b1
      adqy(i,j) = 0.
    end do
  end do
  if (ie+1 .eq. npx) then
    if (je+1 .eq. npy) then
      adqout(npx,npy-2) = adqout(npx,npy-2)+adqout(npx,npy-1)*c2
      adqout(npx,npy) = adqout(npx,npy)+adqout(npx,npy-1)*c2
      adqx(npx,npy-2) = adqx(npx,npy-2)+adqout(npx,npy-1)*c1
      adqx(npx,npy-1) = adqx(npx,npy-1)+adqout(npx,npy-1)*c1
      adqout(npx,npy-1) = 0.
    endif
    if (js .eq. 1) then
      adqout(npx,3) = adqout(npx,3)+adqout(npx,2)*c2
      adqout(npx,1) = adqout(npx,1)+adqout(npx,2)*c2
      adqx(npx,2) = adqx(npx,2)+adqout(npx,2)*c1
      adqx(npx,1) = adqx(npx,1)+adqout(npx,2)*c1
      adqout(npx,2) = 0.
    endif
    do j = max(3,js), min(npy-2,je+1)
      adqx(npx,j-2) = adqx(npx,j-2)+adqout(npx,j)*a2
      adqx(npx,j-1) = adqx(npx,j-1)+adqout(npx,j)*a1
      adqx(npx,j+1) = adqx(npx,j+1)+adqout(npx,j)*a2
      adqx(npx,j) = adqx(npx,j)+adqout(npx,j)*a1
      adqout(npx,j) = 0.
    end do
    do j = max(1,js-2), min(npy-1,je+2)
      gratio = dxa(npx-2,j)/dxa(npx-1,j)
      adqin(npx-2,j) = adqin(npx-2,j)+adqx(npx-1,j)*(3/(2.+2.*gratio))
      adqin(npx-1,j) = adqin(npx-1,j)+adqx(npx-1,j)*(3.*gratio/(2.+2.*gratio))
      adqx(npx-2,j) = adqx(npx-2,j)-adqx(npx-1,j)/(2.+2.*gratio)
      adqx(npx,j) = adqx(npx,j)-adqx(npx-1,j)*(gratio/(2.+2.*gratio))
      adqx(npx-1,j) = 0.
      adqin(npx-2,j) = adqin(npx-2,j)+adqx(npx,j)*((-0.5)/(1.+gratio))
      adqin(npx-1,j) = adqin(npx-1,j)+adqx(npx,j)*(0.5*(2+gratio)/(1.+gratio))
      adqin(npx+1,j) = adqin(npx+1,j)+adqx(npx,j)*((-0.5)/(1.+gratio))
      adqin(npx,j) = adqin(npx,j)+adqx(npx,j)*(0.5*(2+gratio)/(1.+gratio))
      adqx(npx,j) = 0.
    end do
  endif
  if (is .eq. 1) then
    if (je+1 .eq. npy) then
      adqout(1,npy-2) = adqout(1,npy-2)+adqout(1,npy-1)*c2
      adqout(1,npy) = adqout(1,npy)+adqout(1,npy-1)*c2
      adqx(1,npy-2) = adqx(1,npy-2)+adqout(1,npy-1)*c1
      adqx(1,npy-1) = adqx(1,npy-1)+adqout(1,npy-1)*c1
      adqout(1,npy-1) = 0.
    endif
    if (js .eq. 1) then
      adqout(1,3) = adqout(1,3)+adqout(1,2)*c2
      adqout(1,1) = adqout(1,1)+adqout(1,2)*c2
      adqx(1,2) = adqx(1,2)+adqout(1,2)*c1
      adqx(1,1) = adqx(1,1)+adqout(1,2)*c1
      adqout(1,2) = 0.
    endif
    do j = max(3,js), min(npy-2,je+1)
      adqx(1,j-2) = adqx(1,j-2)+adqout(1,j)*a2
      adqx(1,j-1) = adqx(1,j-1)+adqout(1,j)*a1
      adqx(1,j+1) = adqx(1,j+1)+adqout(1,j)*a2
      adqx(1,j) = adqx(1,j)+adqout(1,j)*a1
      adqout(1,j) = 0.
    end do
    do j = max(1,js-2), min(npy-1,je+2)
      gratio = dxa(2,j)/dxa(1,j)
      adqin(2,j) = adqin(2,j)+adqx(2,j)*(3/(2.+2.*gratio))
      adqin(1,j) = adqin(1,j)+adqx(2,j)*(3.*gratio/(2.+2.*gratio))
      adqx(3,j) = adqx(3,j)-adqx(2,j)/(2.+2.*gratio)
      adqx(1,j) = adqx(1,j)-adqx(2,j)*(gratio/(2.+2.*gratio))
      adqx(2,j) = 0.
      adqin(-1,j) = adqin(-1,j)+adqx(1,j)*((-0.5)/(1.+gratio))
      adqin(2,j) = adqin(2,j)+adqx(1,j)*((-0.5)/(1.+gratio))
      adqin(1,j) = adqin(1,j)+adqx(1,j)*(0.5*(2+gratio)/(1.+gratio))
      adqin(0,j) = adqin(0,j)+adqx(1,j)*(0.5*(2+gratio)/(1.+gratio))
      adqx(1,j) = 0.
    end do
  endif
  do j = max(1,js-2), min(npy-1,je+2)
    do i = max(3,is), min(npx-2,ie+1)
      adqin(i-2,j) = adqin(i-2,j)+adqx(i,j)*b2
      adqin(i-1,j) = adqin(i-1,j)+adqx(i,j)*b1
      adqin(i+1,j) = adqin(i+1,j)+adqx(i,j)*b2
      adqin(i,j) = adqin(i,j)+adqx(i,j)*b1
      adqx(i,j) = 0.
    end do
  end do
  if (nw_corner) then
    adqin(-1,npy-2) = adqin(-1,npy-2)+adqout(1,npy)*d2
    adqin(2,npy-2) = adqin(2,npy-2)+adqout(1,npy)*d2
    adqin(1,npy-1) = adqin(1,npy-1)+adqout(1,npy)*d1
    adqin(0,npy-1) = adqin(0,npy-1)+adqout(1,npy)*d1
    adqin(2,npy+1) = adqin(2,npy+1)+adqout(1,npy)*d2
    adqin(1,npy) = adqin(1,npy)+adqout(1,npy)*d1
    adqout(1,npy) = 0.
  endif
  if (ne_corner) then
    adqin(npx-2,npy-2) = adqin(npx-2,npy-2)+adqout(npx,npy)*d2
    adqin(npx+1,npy-2) = adqin(npx+1,npy-2)+adqout(npx,npy)*d2
    adqin(npx-1,npy-1) = adqin(npx-1,npy-1)+adqout(npx,npy)*d1
    adqin(npx,npy-1) = adqin(npx,npy-1)+adqout(npx,npy)*d1
    adqin(npx-2,npy+1) = adqin(npx-2,npy+1)+adqout(npx,npy)*d2
    adqin(npx-1,npy) = adqin(npx-1,npy)+adqout(npx,npy)*d1
    adqout(npx,npy) = 0.
  endif
  if (se_corner) then
    adqin(npx-2,-1) = adqin(npx-2,-1)+adqout(npx,1)*d2
    adqin(npx-2,2) = adqin(npx-2,2)+adqout(npx,1)*d2
    adqin(npx+1,2) = adqin(npx+1,2)+adqout(npx,1)*d2
    adqin(npx-1,1) = adqin(npx-1,1)+adqout(npx,1)*d1
    adqin(npx,1) = adqin(npx,1)+adqout(npx,1)*d1
    adqin(npx-1,0) = adqin(npx-1,0)+adqout(npx,1)*d1
    adqout(npx,1) = 0.
  endif
  if (sw_corner) then
    adqin(2,-1) = adqin(2,-1)+adqout(1,1)*d2
    adqin(-1,2) = adqin(-1,2)+adqout(1,1)*d2
    adqin(2,2) = adqin(2,2)+adqout(1,1)*d2
    adqin(1,1) = adqin(1,1)+adqout(1,1)*d1
    adqin(0,1) = adqin(0,1)+adqout(1,1)*d1
    adqin(1,0) = adqin(1,0)+adqout(1,1)*d1
    adqout(1,1) = 0.
  endif
else
  do j = js, je+1
    do i = is, ie+1
      adqx(i,j-2) = adqx(i,j-2)+0.5*adqout(i,j)*a2
      adqx(i,j-1) = adqx(i,j-1)+0.5*adqout(i,j)*a1
      adqx(i,j+1) = adqx(i,j+1)+0.5*adqout(i,j)*a2
      adqx(i,j) = adqx(i,j)+0.5*adqout(i,j)*a1
      adqy(i-2,j) = adqy(i-2,j)+0.5*adqout(i,j)*a2
      adqy(i-1,j) = adqy(i-1,j)+0.5*adqout(i,j)*a1
      adqy(i+1,j) = adqy(i+1,j)+0.5*adqout(i,j)*a2
      adqy(i,j) = adqy(i,j)+0.5*adqout(i,j)*a1
      adqout(i,j) = 0.
    end do
  end do
  do j = js, je+1
    do i = is-2, ie+2
      adqin(i,j-2) = adqin(i,j-2)+adqy(i,j)*b2
      adqin(i,j-1) = adqin(i,j-1)+adqy(i,j)*b1
      adqin(i,j+1) = adqin(i,j+1)+adqy(i,j)*b2
      adqin(i,j) = adqin(i,j)+adqy(i,j)*b1
      adqy(i,j) = 0.
    end do
  end do
  do j = js-2, je+2
    do i = is, ie+1
      adqin(i-2,j) = adqin(i-2,j)+adqx(i,j)*b2
      adqin(i-1,j) = adqin(i-1,j)+adqx(i,j)*b1
      adqin(i+1,j) = adqin(i+1,j)+adqx(i,j)*b2
      adqin(i,j) = adqin(i,j)+adqx(i,j)*b1
      adqx(i,j) = 0.
    end do
  end do
endif

end subroutine ada2b_ord4

subroutine ada2b_ord2( adqin, adqout, npx, npy, is, ie, js, je, ng, replace )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.39  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r3 = 1./3.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: ie
integer, intent(in) :: is
integer, intent(in) :: je
integer, intent(in) :: js
integer, intent(in) :: ng
real, intent(inout) :: adqin(is-ng:ie+ng,js-ng:je+ng)
real, intent(inout) :: adqout(is-ng:ie+ng,js-ng:je+ng)
integer, intent(in) :: npx
integer, intent(in) :: npy
logical,optional, intent(in) :: replace

!==============================================
! declare local variables
!==============================================
real :: adq1(npx)
real :: adq2(npy)
integer :: i
integer :: ie1
integer :: is1
integer :: is2
integer :: j
integer :: je1
integer :: js1
integer :: js2

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
adq1(:) = 0.
adq2(:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
if (present(replace)) then
  if (replace) then
    do j = js, je+1
      do i = is, ie+1
        adqout(i,j) = adqout(i,j)+adqin(i,j)
        adqin(i,j) = 0.
      end do
    end do
  endif
endif
if (grid_type .lt. 3) then
  is1 = max(1,is-1)
  js1 = max(1,js-1)
  is2 = max(2,is)
  js2 = max(2,js)
  ie1 = min(npx-1,ie+1)
  je1 = min(npy-1,je+1)
  if (je+1 .eq. npy) then
    do i = is2, ie1
      adq1(i-1) = adq1(i-1)+adqout(i,npy)*edge_n(i)
      adq1(i) = adq1(i)+adqout(i,npy)*(1.-edge_n(i))
      adqout(i,npy) = 0.
    end do
    do i = is1, ie1
      adqin(i,npy-1) = adqin(i,npy-1)+0.5*adq1(i)
      adqin(i,npy) = adqin(i,npy)+0.5*adq1(i)
      adq1(i) = 0.
    end do
  endif
  if (js .eq. 1) then
    do i = is2, ie1
      adq1(i-1) = adq1(i-1)+adqout(i,1)*edge_s(i)
      adq1(i) = adq1(i)+adqout(i,1)*(1.-edge_s(i))
      adqout(i,1) = 0.
    end do
    do i = is1, ie1
      adqin(i,1) = adqin(i,1)+0.5*adq1(i)
      adqin(i,0) = adqin(i,0)+0.5*adq1(i)
      adq1(i) = 0.
    end do
  endif
  if (ie+1 .eq. npx) then
    do j = js2, je1
      adq2(j-1) = adq2(j-1)+adqout(npx,j)*edge_e(j)
      adq2(j) = adq2(j)+adqout(npx,j)*(1.-edge_e(j))
      adqout(npx,j) = 0.
    end do
    do j = js1, je1
      adqin(npx-1,j) = adqin(npx-1,j)+0.5*adq2(j)
      adqin(npx,j) = adqin(npx,j)+0.5*adq2(j)
      adq2(j) = 0.
    end do
  endif
  if (is .eq. 1) then
    do j = js2, je1
      adq2(j-1) = adq2(j-1)+adqout(1,j)*edge_w(j)
      adq2(j) = adq2(j)+adqout(1,j)*(1.-edge_w(j))
      adqout(1,j) = 0.
    end do
    do j = js1, je1
      adqin(1,j) = adqin(1,j)+0.5*adq2(j)
      adqin(0,j) = adqin(0,j)+0.5*adq2(j)
      adq2(j) = 0.
    end do
  endif
  if (nw_corner) then
    adqin(1,npy-1) = adqin(1,npy-1)+adqout(1,npy)*r3
    adqin(0,npy-1) = adqin(0,npy-1)+adqout(1,npy)*r3
    adqin(1,npy) = adqin(1,npy)+adqout(1,npy)*r3
    adqout(1,npy) = 0.
  endif
  if (ne_corner) then
    adqin(npx-1,npy-1) = adqin(npx-1,npy-1)+adqout(npx,npy)*r3
    adqin(npx,npy-1) = adqin(npx,npy-1)+adqout(npx,npy)*r3
    adqin(npx-1,npy) = adqin(npx-1,npy)+adqout(npx,npy)*r3
    adqout(npx,npy) = 0.
  endif
  if (se_corner) then
    adqin(npx-1,1) = adqin(npx-1,1)+adqout(npx,1)*r3
    adqin(npx,1) = adqin(npx,1)+adqout(npx,1)*r3
    adqin(npx-1,0) = adqin(npx-1,0)+adqout(npx,1)*r3
    adqout(npx,1) = 0.
  endif
  if (sw_corner) then
    adqin(1,1) = adqin(1,1)+adqout(1,1)*r3
    adqin(0,1) = adqin(0,1)+adqout(1,1)*r3
    adqin(1,0) = adqin(1,0)+adqout(1,1)*r3
    adqout(1,1) = 0.
  endif
  do j = js2, je1
    do i = is2, ie1
      adqin(i-1,j-1) = adqin(i-1,j-1)+0.25*adqout(i,j)
      adqin(i,j-1) = adqin(i,j-1)+0.25*adqout(i,j)
      adqin(i-1,j) = adqin(i-1,j)+0.25*adqout(i,j)
      adqin(i,j) = adqin(i,j)+0.25*adqout(i,j)
      adqout(i,j) = 0.
    end do
  end do
else
  do j = js, je+1
    do i = is, ie+1
      adqin(i-1,j-1) = adqin(i-1,j-1)+0.25*adqout(i,j)
      adqin(i,j-1) = adqin(i,j-1)+0.25*adqout(i,j)
      adqin(i-1,j) = adqin(i-1,j)+0.25*adqout(i,j)
      adqin(i,j) = adqin(i,j)+0.25*adqout(i,j)
      adqout(i,j) = 0.
    end do
  end do
endif

end subroutine ada2b_ord2


end module     ada2b_edge_mod


