!=======================================================================
!
! $Id: setkin_smv2.h,v 1.1.1.1.22.1 2009-09-16 16:26:33 enielsen Exp $
!
! CODE DEVELOPER
!   Peter Connell, LLNL
!   connell2@llnl.gov
!
! FILE
!   setkin_smv2.h
!
! DESCRIPTION
!   This include file contains the primary description of the chemical
!   mechanism in the form of SMV2 data statements.
!
!  Chemistry input file:    10/2006
!  Reaction dictionary:     GMI_Combo_rxns_124species_JPL06.db
!  Setkin files generated:  Thu Feb  7 17:16:01 2008
!
!=======================================================================
!
!.... Species names
!

      data (NAMESP2(JGAS,1), JGAS = 0, 50) / &
     & "              ", "          CH2O", "           CH4",  & 
     & "            CO", "             H", "            H2",  & 
     & "         HCOOH", "          HNO2", "          HNO3",  & 
     & "          HNO4", "           H2O", "           HO2",  & 
     & "          H2O2", "           MO2", "           MOH",  & 
     & "            MP", "             N", "           N2O",  & 
     & "            NO", "           NO2", "           NO3",  & 
     & "          N2O5", "             O", "           O1D",  & 
     & "            O3", "            OH", "            Br",  & 
     & "          BrCl", "           BrO", "        BrONO2",  & 
     & "           HBr", "          HOBr", "            Cl",  & 
     & "           Cl2", "           ClO", "         Cl2O2",  & 
     & "        ClONO2", "           HCl", "          HOCl",  & 
     & "          OClO", "         CH3Br", "         CH3Cl",  & 
     & "       CH3CCl3", "          CCl4", "         CFCl3",  & 
     & "        CF2Cl2", "        CFC113", "        CFC114",  & 
     & "        CFC115", "        HCFC22", "      HCFC141b" /

      data (NAMESP2(JGAS,1), JGAS = 51, 101) / &
     & "      HCFC142b", "        CF2Br2", "       CF2ClBr",  & 
     & "         CF3Br", "         H2402", "          A3O2",  & 
     & "          ACTA", "          ALD2", "          ALK4",  & 
     & "          ATO2", "          B3O2", "          C2H6",  & 
     & "          C3H8", "           EOH", "          ETO2",  & 
     & "           ETP", "          GCO3", "          GLYC",  & 
     & "          GLYX", "            GP", "          GPAN",  & 
     & "           HAC", "          IALD", "          IAO2",  & 
     & "           IAP", "          INO2", "          INPN",  & 
     & "          ISN1", "          ISNP", "          ISOP",  & 
     & "           KO2", "          MACR", "          MAN2",  & 
     & "          MAO3", "          MAOP", "           MAP",  & 
     & "          MCO3", "           MEK", "          MGLY",  & 
     & "          MRO2", "           MRP", "           MVK",  & 
     & "          MVN2", "           PAN", "           PMN",  & 
     & "           PO2", "            PP", "           PPN",  & 
     & "          PRN1", "          PRPE", "          PRPN" /

      data (NAMESP2(JGAS,1), JGAS = 102, 120) / &
     & "          R4N1", "          R4N2", "          R4O2",  & 
     & "           R4P", "          RA3P", "          RB3P",  & 
     & "          RCHO", "          RCO3", "         RCOOH",  & 
     & "          RIO1", "          RIO2", "           RIP",  & 
     & "           ROH", "            RP", "          VRO2",  & 
     & "           VRP", "          ACET", "            N2",  & 
     & "            O2" /
!
!.... Species indices for user within SMVGEAR
!
      IH2O      = 10
      INITROGEN = 119
      IOXYGEN   = 120
      IMGAS     = 121
!
!.... O2, N2, and M appear as reactants
!
      NMN2(1)   =  1
      NMO2(1)   =  4
      NMAIR(1)  =  0
      NM3BOD(1) =  0

      NREACN2(1, 1) = 3

      NREACO2(1:4, 1) = (/ 1 ,4 ,21 ,47 /)

      NREACAIR(:,:) = 0
      NREAC3B (:,:) = 0
      LGAS3BOD(:,:) = 0
!
!.... Species indices in thermal reactions
!
      data (IRM(1, i, 1), i=1,150) / &
     &   22,    22,    23,    23,    23,    23,    10,     5,    17,    17,   & 
     &    2,     2,     2,    23,    23,    23,    23,    23,    23,    23,   & 
     &    4,     4,    22,    11,     4,    18,    24,    11,    19,    25,   & 
     &   25,    11,    12,    11,    11,    10,     5,     3,     2,    13,   & 
     &   11,    13,    13,    15,    15,     1,    16,    16,    19,    20,   & 
     &   19,     8,    18,     7,    11,     9,     9,    11,    18,    20,   & 
     &   19,    21,     6,    14,    19,     1,    24,     5,    12,    11,   & 
     &   11,    22,    25,    25,    11,    11,    18,    19,    34,    34,   & 
     &   34,    34,    35,    25,    25,    22,    25,    32,    24,    11,   & 
     &    1,    22,    11,    18,    19,    28,    28,    28,    28,    25,   & 
     &    1,     2,     1,    25,    25,    25,    25,    25,    32,    25,   & 
     &   25,    20,    19,    94,    18,    25,    18,    25,    25,    18,   & 
     &   18,    25,    18,    18,    18,    18,    18,    18,    18,    18,   & 
     &   18,    18,    18,    18,    18,    18,    18,    18,    18,    18,   & 
     &   18,    20,    25,    25,    25,    19,    19,    19,    98,    71 /

      data (IRM(1, i, 1), i=151,300) / &
     &   18,    18,    18,    20,    25,    13,    13,    11,    11,    11,   & 
     &   11,    11,    11,    11,    11,    11,    11,    11,    11,    11,   & 
     &   11,    11,    25,    13,    20,    13,    13,    13,    13,    13,   & 
     &   13,    13,    13,    13,    13,    13,    13,    13,    13,    13,   & 
     &   25,    25,    65,    65,    11,    11,    11,    11,    11,    11,   & 
     &   11,    11,    25,    24,    95,    25,    24,    25,    20,    25,   & 
     &   25,    20,    20,    25,    25,    25,    25,    56,    87,    56,   & 
     &   87,    24,    24,    24,    20,    20,    20,    20,    13,    13,   & 
     &   13,    13,    13,    13,    25,    25,    25,    25,    25,    25,   & 
     &   25,    25,    25,    25,    25,    25,    25,    25,    25,    25,   & 
     &   20,    25,    24,    87,    13,    13,    87,    60,    81,    87,   & 
     &   87,    74,    78,    87,    87,    61,    87,    87,    83,    76,   & 
     &   87,    87,    60,    81,    87,    87,    74,    87,    87,    87,   & 
     &   78,    87,    83,    76,    87,    61,    65,    65,    87,    67,   & 
     &   84,    21,    36,    29,    36,    37,    31,    21,    36,    29 /

      data (IRM(1, i, 1), i=301,321) / &
     &   36,   37,   31,   36,   29,   36,   37,   29,   31,   36,  & 
     &   29,   36,   37,   29,   31,    8,   20,   11,   19,   20,  & 
     &   21 /

      data (IRM(2, i, 1), i=1,150) / &
     &    0,    24,     0,     0,    24,    24,    23,    23,    23,    23,   & 
     &   23,    23,    23,    45,    46,    47,    48,    49,    50,    51,   & 
     &    0,    24,    25,    22,    11,    24,    25,    24,    24,    25,   & 
     &   25,    25,    25,    18,    11,    11,    25,    25,    25,    18,   & 
     &   13,    13,    13,    25,    25,    25,     0,    18,    22,    22,   & 
     &   25,    25,    25,    25,    19,     0,    25,    20,    20,    25,   & 
     &   20,     0,    25,    25,    20,    20,    32,    32,    32,    32,   & 
     &   32,    34,    34,    34,    34,    34,    34,    34,    34,    34,   & 
     &   34,    34,     0,    37,    38,    36,    36,    36,    26,    26,   & 
     &   26,    28,    28,    28,    28,    34,    34,    34,    28,    30,   & 
     &   22,    32,    32,    41,    42,    49,    50,    51,    41,    40,   & 
     &   58,    58,    87,     0,    87,    62,    65,    63,    63,    56,   & 
     &   96,    59,   104,   104,   102,    60,    81,   112,   112,   111,   & 
     &  111,    74,   116,   116,    90,    90,    93,    83,    61,    76,   & 
     &   99,    59,   103,    57,   108,   109,    67,    84,     0,     0 /

      data (IRM(2, i, 1), i=151,300) / &
     &  109,    67,    84,   108,   118,    56,    96,   104,   102,    60,   & 
     &   81,   112,   111,    74,    78,   116,    90,    93,    83,    61,   & 
     &   76,    99,    88,    65,    88,   104,   102,    60,    81,   112,   & 
     &  111,    74,    78,   116,    90,    93,    83,    61,    76,    99,   & 
     &   64,   114,    65,    65,    65,    56,    96,    87,    87,   109,   & 
     &   67,    84,   100,   100,     0,    95,    95,    68,   100,    69,   & 
     &   89,    69,    89,    80,    92,    82,    72,    87,    96,    87,   & 
     &   96,    80,    92,    82,    80,    92,    82,    82,   109,    67,   & 
     &   84,   109,    67,    84,    77,   101,    66,   106,   107,   105,   & 
     &  115,    97,    70,   113,    75,    79,   117,    91,    85,    86,   & 
     &   62,    73,    73,    87,    87,    87,   104,    87,    87,   112,   & 
     &  111,    87,    87,   116,    90,    87,   102,    93,    87,    87,   & 
     &   99,   104,    87,    87,   112,   111,    87,   116,    90,   102,   & 
     &   87,    93,    87,    87,    99,    87,    87,    87,   109,    87,   & 
     &   87,     0,     0,     0,    37,    38,    37,     0,     0,     0 /

      data (IRM(2, i, 1), i=301,321) / &
     &   37,   38,   37,    0,    0,   37,   38,   37,   37,    0,  & 
     &    0,   37,   38,   37,   37,    0,   20,    0,    0,    0,  & 
     &    0 /

      data (IRM(3, i, 1), i=1,150) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,    11,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(3, i, 1), i=151,300) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(3, i, 1), i=301,321) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0 /

      data (IRM(4, i, 1), i=1,321) / 321*0 /

      data (IRM(5, i, 1), i=1,150) / &
     &   24,   120,   119,    22,   120,    22,    25,     4,   119,    18,   & 
     &   13,     1,     1,    32,    32,    32,    32,    32,    32,    32,   & 
     &   11,   120,     4,   120,    25,    19,    11,   120,    20,    10,   & 
     &   12,    10,    10,    19,    12,    10,     4,     4,    10,     1,   & 
     &   15,     1,     1,    10,     1,     3,    18,   119,    18,    19,   & 
     &    8,    10,     7,    10,     9,    11,    10,    19,    19,    11,   & 
     &   21,    19,    10,     1,    18,     3,    34,     4,    37,    37,   & 
     &   34,    32,    32,    37,    38,    37,    32,    36,    32,    33,   & 
     &   32,    35,    34,    32,    34,    34,    38,    33,    28,    30,   & 
     &    3,    26,    31,    26,    29,    26,    26,    27,    26,    26,   & 
     &    3,    37,     3,    32,    32,    32,    32,    32,     3,    26,   & 
     &   10,     8,    94,    87,    13,    65,    58,    61,    56,    11,   & 
     &   58,   104,    56,   103,    58,     1,    58,     1,     8,     1,   & 
     &    8,     1,     1,     8,     1,     8,     1,     1,   118,     1,   & 
     &   58,     8,    10,    10,    10,    98,    71,    95,    19,    67 /

      data (IRM(5, i, 1), i=151,300) / &
     &   65,     1,     1,     8,    60,     1,    58,   105,   103,    87,   & 
     &   89,   113,   113,    75,    79,   117,    91,    79,    79,   107,   & 
     &   77,   101,    10,    58,     8,    56,    58,     1,    58,     1,   & 
     &    1,     1,     1,     1,     1,     1,     1,   118,     1,    58,   & 
     &   58,    11,    58,    58,    66,   106,    97,    57,    86,    24,   & 
     &   70,    85,    96,    58,    84,     1,     1,    67,    99,     3,   & 
     &    3,     3,     3,   112,   116,    84,    11,    11,    58,    57,   & 
     &   57,     1,    58,     1,    76,    93,    83,     8,     1,     1,   & 
     &    1,     1,     1,     1,    76,    99,    58,    56,    61,    25,   & 
     &   58,    25,     1,    74,    74,    78,    25,    90,    84,     1,   & 
     &   65,    11,     1,    13,     1,    57,    56,     1,    58,     1,   & 
     &    1,     1,    68,     1,     1,   118,    58,     1,     1,     1,   & 
     &   58,    57,    57,    57,    57,    57,    57,    57,    57,    57,   & 
     &   57,    57,    57,    57,    57,   118,    58,    57,    65,     1,   & 
     &    1,     8,     8,     8,    33,    33,    27,     8,     8,     8 /

      data (IRM(5, i, 1), i=301,321) / &
     &   33,   33,   27,    8,    8,   33,   33,   27,   27,    8,  & 
     &    8,   33,   33,   27,   27,   19,   19,   12,    7,    8,  & 
     &    8 /

      data (IRM(6, i, 1), i=1,150) / &
     &    0,     0,    22,   120,     0,   120,     0,    25,   120,     0,   & 
     &   25,     4,     5,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,    25,   120,    25,     0,   120,   120,    25,   120,    22,   & 
     &    0,   120,    11,    25,   120,    12,    10,     0,    13,    11,   & 
     &  120,    14,    11,    13,    10,    10,    22,    22,   120,   120,   & 
     &    0,    20,     0,    19,     0,    19,    19,   120,     0,    19,   & 
     &    0,    20,    11,    11,    19,     8,   120,    37,    11,   120,   & 
     &   25,   120,    11,   120,   120,    24,    19,     0,   120,   120,   & 
     &   39,     0,     0,    10,    10,    20,    20,    20,   120,   120,   & 
     &   30,   120,   120,    19,     0,    39,    32,   120,   120,    10,   & 
     &   11,    13,    37,    10,    10,    10,    10,    10,    37,    10,   & 
     &   87,    87,     0,    19,    19,    10,    11,     0,     0,    19,   & 
     &    1,     0,   118,     0,     1,    11,    87,    11,     0,    11,   & 
     &    0,     3,    68,     0,     3,     0,    68,    89,    11,     8,   & 
     &    1,   104,   102,    13,   109,     0,     0,     0,   109,    19 /

      data (IRM(6, i, 1), i=151,300) / &
     &   19,    11,    11,   109,    10,    11,     1,     0,     0,    13,   & 
     &   13,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,    81,     1,    81,   118,     1,    11,     1,    11,   & 
     &   11,     3,    68,    68,     3,    11,    11,     1,     8,     1,   & 
     &   11,   108,    11,    64,     0,     0,     0,    24,     0,   110,   & 
     &   24,    24,     0,     1,    19,    72,    11,    69,     0,    11,   & 
     &   87,     8,     8,     0,     0,    90,    89,    13,     1,   108,   & 
     &   72,     3,     1,     3,     0,     0,     0,    84,    65,    11,   & 
     &   11,   110,   110,   110,     0,     0,    65,    25,    25,   104,   & 
     &   25,    96,    67,   111,    25,    19,   108,    25,    25,    87,   & 
     &    8,    74,    68,     0,    11,     1,   118,    11,    87,    11,   & 
     &   11,     3,    72,    68,     3,    11,     1,    11,    89,     8,   & 
     &    1,    88,    88,    88,    88,    88,    88,    88,    88,    19,   & 
     &   19,    19,    19,    19,    19,    57,    11,    58,    13,    11,   & 
     &   87,     0,    38,    31,     8,    10,    10,     0,    38,    31 /

      data (IRM(6, i, 1), i=301,321) / &
     &    8,   10,   10,   38,   31,    8,   10,    8,   10,   38,  & 
     &   31,    8,   10,    8,   10,   25,  120,    0,    8,    0,  & 
     &    0 /

      data (IRM(7, i, 1), i=1,150) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,    11,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,   120,     0,     0,     0,    19,   & 
     &    0,   120,     0,     0,    25,    11,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,   120,    25,     0,     0,   & 
     &    0,     0,     0,     0,   120,    11,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &   11,     0,     0,     0,     0,     0,   120,     0,     0,     0,   & 
     &   25,     0,    11,    11,     0,     0,     0,     0,    11,    11,   & 
     &    0,     0,     0,     0,     0,     0,    19,     0,     0,   108,   & 
     &   11,     0,    58,     0,    19,    87,    19,    73,     0,    73,   & 
     &    0,    68,    11,     0,    72,     0,     8,    19,    19,    11,   & 
     &   19,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(7, i, 1), i=151,300) / &
     &    0,    19,    19,     0,     0,    14,    72,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,    64,     0,    58,    11,    87,    11,    73,   & 
     &   73,    68,    72,    11,    72,    87,    89,    11,    11,    11,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,   115,   & 
     &  110,   110,     0,     3,     0,    11,    19,    11,     0,     0,   & 
     &    0,    11,    87,     0,     0,     0,     0,   108,    11,     0,   & 
     &  108,    11,     3,    11,     0,     0,     0,     0,    11,     0,   & 
     &   87,     0,     0,     0,     0,     0,    25,   108,   108,   108,   & 
     &  109,   108,    25,   112,   108,    25,   116,   108,   108,    25,   & 
     &    0,    84,    69,     0,    13,     0,    58,    87,    13,    73,   & 
     &   73,    68,    13,    11,    72,    13,    13,    87,    13,    11,   & 
     &   13,     0,     0,     0,     0,     0,     0,     0,     0,   108,   & 
     &  108,   108,   108,   108,   108,     0,    13,     0,     0,    13,   & 
     &   13,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(7, i, 1), i=301,321) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0 /

      data (IRM(8, i, 1), i=1,150) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &   19,     0,    61,     0,   104,    89,   103,    82,     0,    19,   & 
     &    0,    69,    87,     0,    11,     0,    11,     0,     0,    82,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(8, i, 1), i=151,300) / &
     &    0,     0,     0,     0,     0,   108,    11,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,    11,     0,    61,    14,    88,    87,    82,   & 
     &   88,    69,    11,    87,    11,    89,    14,    14,    82,    14,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     5,     0,    19,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,    13,     0,   & 
     &    0,    82,    11,    89,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,   108,     0,     0,     0,     0,   & 
     &    0,     0,    72,     0,     0,     0,    61,    89,     0,    82,   & 
     &   13,    69,    19,    87,    11,     0,    19,    89,    19,    82,   & 
     &   19,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(8, i, 1), i=301,321) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0 /

      data (IRM(9, i, 1), i=1,150) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,    65,     0,   108,    19,     0,    92,     0,     0,   & 
     &    0,    72,    89,     0,    89,     0,    87,     0,     0,    92,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(9, i, 1), i=151,300) / &
     &    0,     0,     0,     0,     0,   114,    14,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,    14,     0,     1,    19,    89,    88,    88,   & 
     &   14,    72,    14,    88,    88,    14,    19,   114,    14,    19,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,    11,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,    92,    89,    24,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     6,     0,     0,     0,    65,    13,     0,    13,   & 
     &    0,    72,     0,    89,    89,     0,   104,    13,     0,    13,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(9, i, 1), i=301,321) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0 /

      data (IRM(10, i, 1), i=1,150) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,    11,     0,     0,   103,     0,    19,     0,     0,   & 
     &    0,     8,    19,     0,    19,     0,    89,     0,     0,    19,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(10, i, 1), i=151,300) / &
     &    0,     0,     0,     0,     0,     0,   108,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,    65,   104,    14,    14,    14,   & 
     &  114,    11,    19,    89,    89,    19,   108,     0,    92,   108,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,    13,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,    24,    24,    25,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,    89,     0,     0,     0,    11,     0,     0,    92,   & 
     &    0,    11,     0,    13,    13,     0,   108,    19,     0,    92,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(10, i, 1), i=301,321) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0 /

      data (IRM(11, i, 1), i=1,150) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,    88,     0,     0,     0,     0,   111,     0,     0,   & 
     &    0,    11,     0,     0,     0,     0,    19,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(11, i, 1), i=151,300) / &
     &    0,     0,     0,     0,     0,     0,   114,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,    11,   108,   114,   114,    92,   & 
     &    0,    88,   108,    14,    14,   108,   114,     0,    19,   114,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,    25,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,    25,    25,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,    24,     0,     0,     0,    88,     0,     0,   111,   & 
     &    0,    89,     0,     0,     0,     0,     0,     0,     0,    19,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(11, i, 1), i=301,321) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0 /

      data (IRM(12, i, 1), i=1,150) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,    13,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,    89,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(12, i, 1), i=151,300) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,    88,   114,     0,     0,   111,   & 
     &    0,    89,   114,   114,   114,   114,     0,     0,   108,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,   100,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,    25,     0,     0,     0,    13,     0,     0,     0,   & 
     &    0,    13,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(12, i, 1), i=301,321) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0 /

      data (IRM(13, i, 1), i=1,150) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,    19,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,    19,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(13, i, 1), i=151,300) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,    13,     0,     0,     0,   114,   & 
     &    0,    14,     0,     0,     0,     0,     0,     0,   114,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,   108,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(13, i, 1), i=301,321) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0 /

      data (IRM(14, i, 1), i=1,150) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,   108,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(14, i, 1), i=151,300) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,    14,     0,     0,     0,     0,   & 
     &    0,   114,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(14, i, 1), i=301,321) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0 /

      data (IRM(15, i, 1), i=1,150) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(15, i, 1), i=151,300) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,   108,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(15, i, 1), i=301,321) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0 /

      data (IRM(16, i, 1), i=1,150) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(16, i, 1), i=151,300) / &
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,   114,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   & 
     &    0,     0,     0,     0,     0,     0,     0,     0,     0,     0 /

      data (IRM(16, i, 1), i=301,321) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0 /

!
!.... Stoichiometric coefficients in thermal reactions ....
!
      data (FKOEF(1, i, 1), i=1,321) / &
     & 321*1.0d0 /

      data (FKOEF(2, i, 1), i=1,321) / &
     & 321*1.0d0 /

      data (FKOEF(3, i, 1), i=1,321) / &
     & 321*1.0d0 /

      data (FKOEF(4, i, 1), i=1,321) / &
     & 321*1.0d0 /

      data (FKOEF(5, i, 1), i=1,100) / &
     &  1.000D+00,  2.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  &
     &  2.000D+00,  2.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  3.000D+00,  &
     &  2.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  &
     &  1.000D+00,  1.000D+00,  2.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  2.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  2.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  1.000D+00 /

      data (FKOEF(5, i, 1), i=101,200) / &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  3.000D+00,  &
     &  1.000D+00,  2.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  5.000D-02,  1.000D+00,  7.500D-01,  &
     &  1.900D-01,  9.300D-01,  6.900D-01,  1.000D+00,  7.500D-01,  &
     &  1.000D+00,  3.500D-01,  2.800D-01,  1.000D+00,  1.700D-01,  &
     &  1.000D+00,  3.000D-01,  1.000D+00,  1.000D+00,  1.500D-01,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  4.000D+00,  1.000D+00,  1.000D+00,  &
     &  7.500D-01,  5.000D-01,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  7.500D-01,  1.000D+00,  &
     &  3.000D-02,  3.800D-01,  8.500D-01,  5.000D-01,  1.100D+00,  &
     &  1.130D+00,  9.500D-01,  7.500D-01,  8.900D-01,  8.400D-01,  &
     &  1.250D+00,  1.250D+00,  7.500D-01,  8.300D-01,  5.000D-01,  &
     &  1.000D+00,  1.000D+00,  2.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  3.000D-01 /

      data (FKOEF(5, i, 1), i=201,300) / &
     &  7.000D-01,  7.000D-01,  1.000D+00,  5.000D-01,  1.000D+00,  &
     &  2.230D+00,  6.000D-01,  8.000D-01,  1.000D+00,  2.000D+00,  &
     &  1.000D+00,  2.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  5.000D-01,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  9.000D-01,  4.000D-02,  7.000D-01,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  &
     &  2.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  5.000D-01,  5.000D-01,  5.000D-01,  5.000D-01,  &
     &  5.000D-01,  5.000D-01,  5.000D-01,  5.000D-01,  5.000D-01,  &
     &  5.000D-01,  5.000D-01,  5.000D-01,  5.000D-01,  5.000D-01,  &
     &  1.000D+00,  1.500D-01,  1.200D-01,  2.000D+00,  1.000D+00,  &
     &  1.000D+00,  5.000D-02,  2.000D-01,  1.000D+00,  6.900D-01,  &
     &  7.500D-01,  4.000D-01,  1.000D+00,  2.800D-01,  1.700D-01,  &
     &  1.000D+00,  7.500D-01,  1.000D+00,  1.000D+00,  1.500D-01,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  2.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  2.000D+00,  1.000D+00,  1.000D+00 /

      data (FKOEF(5, i, 1), i=301,321) / &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  2.000D+00,  5.000D-01,  5.000D-01,  1.000D+00,  &
     &  2.000D+00 /

      data (FKOEF(6, i, 1), i=1,100) / &
     &  0.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  &
     &  1.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  0.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  2.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  0.000D+00,  1.000D+00,  0.000D+00,  1.000D+00,  0.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00 /

      data (FKOEF(6, i, 1), i=101,200) / &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  1.000D+00,  0.000D+00,  3.200D-01,  0.000D+00,  3.900D-01,  &
     &  7.700D-01,  9.300D-01,  8.640D-01,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  2.700D-01,  7.200D-01,  0.000D+00,  8.300D-01,  &
     &  0.000D+00,  6.000D-01,  1.000D+00,  1.000D+00,  8.500D-01,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.250D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  1.000D+00,  7.500D-01,  1.000D+00,  &
     &  1.600D-01,  9.500D-01,  9.000D-01,  7.500D-01,  9.300D-01,  &
     &  1.000D+00,  1.500D-01,  5.000D-01,  3.600D-01,  4.200D-01,  &
     &  7.500D-01,  5.000D-01,  7.500D-01,  4.250D-01,  1.250D+00,  &
     &  1.000D+00,  1.000D+00,  2.000D+00,  1.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  1.000D+00,  0.000D+00,  3.000D-01 /

      data (FKOEF(6, i, 1), i=201,300) / &
     &  3.000D-01,  3.000D-01,  0.000D+00,  5.350D-01,  1.000D+00,  &
     &  5.900D-01,  1.000D+00,  2.000D-01,  0.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  &
     &  5.000D-01,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  6.500D-01,  5.000D-02,  8.000D-01,  2.000D-01,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  &
     &  0.000D+00,  5.000D-01,  5.000D-01,  5.000D-01,  5.000D-01,  &
     &  5.000D-01,  5.000D-01,  5.000D-01,  1.000D-01,  5.000D-01,  &
     &  5.000D-01,  5.000D-01,  5.000D-01,  5.000D-01,  5.000D-01,  &
     &  1.000D+00,  4.400D-01,  2.800D-01,  0.000D+00,  1.000D+00,  &
     &  1.000D+00,  3.200D-01,  8.000D-01,  1.000D+00,  8.640D-01,  &
     &  1.000D+00,  2.900D-01,  1.000D+00,  7.200D-01,  8.300D-01,  &
     &  1.000D+00,  3.900D-01,  5.000D-01,  1.000D+00,  8.500D-01,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  0.000D+00,  1.000D+00,  1.000D+00 /

      data (FKOEF(6, i, 1), i=301,321) / &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  0.000D+00,  5.000D-01,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(7, i, 1), i=1,100) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(7, i, 1), i=101,200) / &
     &  1.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  1.000D+00,  0.000D+00,  3.200D-01,  0.000D+00,  2.000D+00,  &
     &  1.900D-01,  9.300D-01,  1.270D-01,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  2.400D-01,  2.800D-01,  0.000D+00,  8.300D-01,  &
     &  0.000D+00,  1.000D-01,  2.000D+00,  1.000D+00,  8.000D-01,  &
     &  2.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  &
     &  2.500D-01,  1.600D-01,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  2.500D-01,  0.000D+00,  &
     &  1.600D-01,  5.000D-01,  1.000D-01,  5.000D-01,  6.000D-02,  &
     &  5.000D-01,  1.300D-01,  5.000D-01,  6.400D-01,  4.200D-01,  &
     &  2.500D-01,  5.000D-01,  1.000D+00,  9.000D-01,  5.000D-01,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  7.000D-01 /

      data (FKOEF(7, i, 1), i=201,300) / &
     &  3.000D-01,  3.000D-01,  0.000D+00,  4.200D-01,  0.000D+00,  &
     &  2.000D+00,  1.000D+00,  2.000D-01,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  &
     &  3.500D-01,  6.000D-02,  5.000D-02,  2.750D-01,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  0.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  5.000D-01,  5.000D-01,  5.000D-01,  5.000D-01,  &
     &  5.000D-01,  5.000D-01,  5.000D-01,  4.000D-01,  5.000D-01,  &
     &  5.000D-01,  5.000D-01,  5.000D-01,  5.000D-01,  5.000D-01,  &
     &  0.000D+00,  4.100D-01,  2.000D-01,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  3.200D-01,  2.000D-01,  1.000D+00,  1.270D-01,  &
     &  1.000D+00,  2.600D-01,  1.000D+00,  2.800D-01,  8.300D-01,  &
     &  1.000D+00,  1.000D+00,  5.000D-01,  1.000D+00,  8.000D-01,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  0.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(7, i, 1), i=301,321) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(8, i, 1), i=1,100) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(8, i, 1), i=101,200) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  1.000D+00,  0.000D+00,  1.800D-01,  0.000D+00,  3.000D-01,  &
     &  7.700D-01,  7.000D-02,  2.880D-01,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  1.700D-01,  7.200D-01,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  3.000D-01,  0.000D+00,  0.000D+00,  1.000D-01,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  7.500D-01,  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  0.000D+00,  &
     &  9.000D-02,  2.500D-01,  2.500D-01,  5.000D-01,  1.400D-01,  &
     &  2.500D-01,  9.000D-02,  5.000D-01,  3.600D-01,  1.000D+00,  &
     &  2.500D-01,  2.500D-01,  2.500D-01,  5.000D-02,  2.500D-01,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(8, i, 1), i=201,300) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  6.500D-02,  0.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  0.000D+00,  &
     &  0.000D+00,  3.870D-01,  6.000D-02,  8.000D-01,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  5.000D-01,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  2.000D-01,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.800D-01,  8.000D-01,  0.000D+00,  2.880D-01,  &
     &  1.000D+00,  1.800D-01,  1.000D+00,  7.200D-01,  1.000D+00,  &
     &  0.000D+00,  1.000D+00,  5.000D-01,  1.000D+00,  1.000D-01,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(8, i, 1), i=301,321) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(9, i, 1), i=1,100) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(9, i, 1), i=101,200) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  3.200D-01,  0.000D+00,  5.700D-01,  &
     &  9.600D-01,  0.000D+00,  4.020D-01,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  3.300D-01,  2.800D-01,  0.000D+00,  1.700D-01,  &
     &  0.000D+00,  6.000D-01,  0.000D+00,  0.000D+00,  5.000D-02,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  2.500D-01,  2.500D-01,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  2.500D-01,  0.000D+00,  &
     &  7.500D-01,  1.000D+00,  4.000D-01,  2.500D-01,  2.500D-01,  &
     &  2.500D-01,  1.800D-01,  2.500D-01,  2.500D-01,  2.500D-01,  &
     &  2.500D-01,  1.000D+00,  2.500D-01,  2.500D-01,  1.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(9, i, 1), i=201,300) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  3.000D-01,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.590D-01,  8.200D-01,  2.000D-01,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  2.000D-01,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  3.200D-01,  1.000D+00,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  3.600D-01,  0.000D+00,  2.800D-01,  1.700D-01,  &
     &  0.000D+00,  3.000D-01,  1.000D+00,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(9, i, 1), i=301,321) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(10, i, 1), i=1,100) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(10, i, 1), i=101,200) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  2.700D-01,  0.000D+00,  0.000D+00,  &
     &  4.000D-02,  0.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  8.000D-02,  1.000D+00,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  3.000D-01,  0.000D+00,  0.000D+00,  1.150D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  9.000D-02,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  1.600D-01,  1.500D-01,  2.500D-01,  2.500D-01,  2.500D-01,  &
     &  2.500D-01,  1.000D+00,  1.000D+00,  1.400D-01,  9.000D-02,  &
     &  1.000D+00,  2.500D-01,  0.000D+00,  3.000D-02,  2.500D-01,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(10, i, 1), i=201,300) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  3.050D-01,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.000D-01,  2.000D-01,  2.150D-01,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  6.000D-01,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  2.700D-01,  0.000D+00,  0.000D+00,  4.020D-01,  &
     &  0.000D+00,  1.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  &
     &  0.000D+00,  5.700D-01,  1.000D+00,  0.000D+00,  5.000D-02,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(10, i, 1), i=301,321) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(11, i, 1), i=1,100) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(11, i, 1), i=101,200) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  1.900D-01,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  1.360D-01,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  9.200D-01,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.900D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  2.500D-01,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  6.400D-01,  5.400D-01,  2.500D-01,  2.500D-01,  2.000D-01,  &
     &  0.000D+00,  2.500D-01,  2.500D-01,  2.500D-01,  2.500D-01,  &
     &  2.500D-01,  2.500D-01,  0.000D+00,  5.750D-01,  2.500D-01,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(11, i, 1), i=201,300) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  1.350D-01,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  2.700D-01,  8.000D-02,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  3.000D-01,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.900D-01,  0.000D+00,  0.000D+00,  1.360D-01,  &
     &  0.000D+00,  5.800D-01,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  1.500D-01,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(11, i, 1), i=301,321) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(12, i, 1), i=1,100) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(12, i, 1), i=101,200) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  1.800D-01,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  5.300D-01,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  3.500D-01,  2.500D-01,  0.000D+00,  0.000D+00,  7.000D-02,  &
     &  0.000D+00,  2.900D-01,  2.500D-01,  2.500D-01,  2.500D-01,  &
     &  2.500D-01,  0.000D+00,  0.000D+00,  2.500D-01,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(12, i, 1), i=201,300) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  7.000D-02,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  1.000D-01,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.180D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(12, i, 1), i=301,321) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(13, i, 1), i=1,100) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(13, i, 1), i=101,200) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  9.200D-01,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  9.000D-02,  0.000D+00,  0.000D+00,  0.000D+00,  2.500D-01,  &
     &  0.000D+00,  2.500D-01,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  2.500D-01,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(13, i, 1), i=201,300) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.300D-01,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(13, i, 1), i=301,321) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(14, i, 1), i=1,100) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(14, i, 1), i=101,200) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  1.300D-01,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  2.500D-01,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  2.500D-01,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(14, i, 1), i=201,300) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(14, i, 1), i=301,321) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(15, i, 1), i=1,100) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(15, i, 1), i=101,200) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  7.000D-02,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(15, i, 1), i=201,300) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(15, i, 1), i=301,321) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(16, i, 1), i=1,100) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(16, i, 1), i=101,200) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  2.500D-01,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(16, i, 1), i=201,300) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00 /

      data (FKOEF(16, i, 1), i=301,321) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

!
!.... Species indices in photolysis reactions ....
!
      data (IRM(1, i, 1), i=322,402) / &
     &  120,   24,   24,   11,   10,   18,   17,   19,   12,   15,  & 
     &    1,    1,    8,    7,    9,   20,   20,   21,   21,    9,  & 
     &   33,   39,   35,   38,   36,   36,   27,   28,   31,   29,  & 
     &   29,   41,   43,   42,   44,   45,   46,   47,   48,   50,  & 
     &   51,   40,   54,   52,   55,   53,   58,   58,   94,  108,  & 
     &  118,   88,   68,   69,   69,   69,   89,   89,   92,   92,  & 
     &   92,   82,   82,   72,   77,  101,   66,  106,  107,  105,  & 
     &   97,  115,   70,  113,   75,   79,  117,   91,   85,  103,  & 
     &   86 /

      data (IRM(2, i, 1), i=322,402) / &
     & 81*0 /

      data (IRM(3, i, 1), i=322,402) / &
     & 81*0 /

      data (IRM(4, i, 1), i=322,402) / &
     & 81*0 /

      data (IRM(5, i, 1), i=322,402) / &
     &   22,   22,   23,   22,    4,   16,  119,   18,   25,    1,  & 
     &    3,    3,   19,   18,   20,   19,   18,   19,   18,   11,  & 
     &   32,   34,   32,   32,   32,   34,   26,   26,   26,   26,  & 
     &   28,   32,   32,   32,   32,   32,   32,   32,   32,   32,  & 
     &   32,   26,   26,   26,   26,   26,    3,    2,   87,    3,  & 
     &   87,   65,    1,    3,    3,    1,    3,   58,    3,    1,  & 
     &   84,   11,    1,    1,   11,   11,   58,   11,   11,   11,  & 
     &   11,   58,    1,    1,    3,   11,    1,    1,   11,   56,  & 
     &   13 /

      data (IRM(6, i, 1), i=322,402) / &
     &    0,  120,  120,   25,   25,   22,   23,   22,    0,   11,  & 
     &    4,    5,   25,   25,   25,   24,  120,   20,   20,   19,  & 
     &    0,   22,  120,   25,   20,   19,   32,   22,   25,   20,  & 
     &   19,   13,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,   13,    0,    0,    0,   32,   11,    3,   19,   65,  & 
     &   13,   87,    3,    5,   11,    3,   11,    3,  100,    3,  & 
     &   13,   84,    3,   11,   19,   19,   11,   25,   25,   25,  & 
     &   25,   11,   11,   11,   68,   19,   68,    3,   25,  118,  & 
     &   25 /

      data (IRM(7, i, 1), i=322,402) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,   25,  & 
     &   11,    0,    0,    0,    0,    0,    0,    0,   24,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,   13,    0,    0,   11,  & 
     &    0,    0,   11,    0,    0,    0,   87,    0,    0,   11,  & 
     &    0,    0,   11,   87,   25,   25,   25,  108,  108,  108,  & 
     &  108,   25,   25,   73,    5,   25,   11,   72,  108,   58,  & 
     &    0 /

      data (IRM(8, i, 1), i=322,402) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,   87,  & 
     &    0,    0,   87,    0,  108,  108,    0,    0,    0,    0,  & 
     &    0,    0,    0,   82,   72,  108,   87,   11,    0,   61,  & 
     &    0 /

      data (IRM(9, i, 1), i=322,402) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,   89,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,   92,   11,    0,   89,   89,    0,   65,  & 
     &    0 /

      data (IRM(10, i, 1), i=322,402) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,   25,   89,    0,   25,   25,    0,   11,  & 
     &    0 /

      data (IRM(11, i, 1), i=322,402) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,  111,   25,    0,    0,    0,    0,   88,  & 
     &    0 /

      data (IRM(12, i, 1), i=322,402) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,   13,  & 
     &    0 /

      data (IRM(13, i, 1), i=322,402) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,   19,  & 
     &    0 /

      data (IRM(14, i, 1), i=322,402) / &
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  & 
     &    0,    0,    0,    0,    0,    0,    0,    0,    0,  108,  & 
     &    0 /

      data (IRM(15, i, 1), i=322,402) / 81*0 /
      data (IRM(16, i, 1), i=322,402) / 81*0 /
!
!.... Stoichiometric coefficients in photolysis reactions ....
!
      data (FKOEF(1, i, 1), i=322,402) / &
     & 81*1.0d0 /

      data (FKOEF(2, i, 1), i=322,402) / &
     & 81*1.0d0 /

      data (FKOEF(3, i, 1), i=322,402) / &
     & 81*1.0d0 /

      data (FKOEF(4, i, 1), i=322,402) / &
     & 81*1.0d0 /

      data (FKOEF(5, i, 1), i=322,402) / &
     &  2.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  2.000D+00,  1.000D+00,  2.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  4.000D+00,  3.000D+00,  3.000D+00,  &
     &  2.000D+00,  3.000D+00,  2.000D+00,  1.000D+00,  2.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  2.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  2.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  0.000D+00,  &
     &  1.000D+00 /

      data (FKOEF(6, i, 1), i=322,402) / &
     &  0.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  0.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  2.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  0.000D+00,  &
     &  1.000D+00 /

      data (FKOEF(7, i, 1), i=322,402) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  0.000D+00,  2.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  0.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  1.000D+00,  &
     &  1.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(8, i, 1), i=322,402) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  1.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  1.000D+00,  0.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(9, i, 1), i=322,402) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(10, i, 1), i=322,402) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  0.000D+00,  &
     &  0.000D+00,  1.000D+00,  1.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(11, i, 1), i=322,402) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(12, i, 1), i=322,402) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(13, i, 1), i=322,402) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  1.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(14, i, 1), i=322,402) / &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  0.000D+00,  &
     &  0.000D+00 /

      data (FKOEF(15, i, 1), i=322,402) / 81*0.0d0 /

      data (FKOEF(16, i, 1), i=322,402) / 81*0.0d0 /


!                                  --^--

