module     adfv_mapz_mod
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.33  **
!******************************************************************
!******************************************************************
!==============================================
! referencing used modules
!==============================================
use constants_mod, only : grav,pi,radius,rdgas,rvgas
use fv_grid_tools_mod, only : area,dx,dy,rdxa,rdya
use fv_grid_utils_mod, only : ptop,ptop_min,cubed_to_latlon, g_sum
use fv_fill_mod, only : fillz
use fv_mp_mod, only : domain,gid
use mpp_domains_mod, only : mpp_update_domains
use fv_mapz_mod

   use fv_timing_mod,     only: timing_on, timing_off

!==============================================
! all entries are defined explicitly
!==============================================
implicit none

contains
subroutine adcompute_total_energy( is, ie, js, je, isd, ied, jsd, jed, km, u, adu, v, adv, w, adw, delz, addelz, pt, adpt, delp, &
&addelp, q, adq, pe, peln, hs, r_vir, cp, rg, adte_2d, ua, adua, va, adva, sphum, hydrostatic )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.50  **
!******************************************************************
!******************************************************************
!==============================================
! referencing used modules
!==============================================
use fv_grid_utils_mod, only : adcubed_to_latlon

!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: ied
integer, intent(in) :: isd
integer, intent(in) :: jed
integer, intent(in) :: jsd
integer, intent(in) :: km
real, intent(inout) :: addelp(isd:ied,jsd:jed,km)
integer, intent(in) :: ie
integer, intent(in) :: is
integer, intent(in) :: je
integer, intent(in) :: js
real, intent(inout) :: addelz(is:ie,js:je,km)
real, intent(inout) :: adpt(isd:ied,jsd:jed,km)
integer, intent(in) :: sphum
real, intent(inout) :: adq(isd:ied,jsd:jed,km,sphum)
real, intent(inout) :: adte_2d(is:ie,js:je)
real, intent(inout) :: adu(isd:ied,jsd:jed+1,km)
real, intent(inout) :: adua(isd:ied,jsd:jed,km)
real, intent(inout) :: adv(isd:ied+1,jsd:jed,km)
real, intent(inout) :: adva(isd:ied,jsd:jed,km)
real, intent(inout) :: adw(isd:ied,jsd:jed,km)
real, intent(in) :: cp
real, intent(in) :: delp(isd:ied,jsd:jed,km)
real, intent(in) :: delz(is:ie,js:je,km)
real, intent(in) :: hs(isd:ied,jsd:jed)
logical, intent(in) :: hydrostatic
real, intent(in) :: pe(is-1:ie+1,km+1,js-1:je+1)
real, intent(in) :: peln(is:ie,km+1,js:je)
real, intent(in) :: pt(isd:ied,jsd:jed,km)
real, intent(in) :: q(isd:ied,jsd:jed,km,sphum)
real, intent(in) :: r_vir
real, intent(in) :: rg
real, intent(inout) :: u(isd:ied,jsd:jed+1,km)
real, intent(out) :: ua(isd:ied,jsd:jed,km)
real, intent(inout) :: v(isd:ied+1,jsd:jed,km)
real, intent(out) :: va(isd:ied,jsd:jed,km)
real, intent(in) :: w(isd:ied,jsd:jed,km)

!==============================================
! declare local variables
!==============================================
real :: adgztop(is:ie)
real :: adphiz(is:ie,km+1)
real :: cv
integer :: i
integer :: j
integer :: k
real :: phiz(is:ie,km+1)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
adgztop(:) = 0.
adphiz(:,:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
cv = cp-rg
call cubed_to_latlon( u,v,ua,va,dx,dy,rdxa,rdya,km )
do j = je, js, -1
  if (hydrostatic) then
    do k = km, 1, -1
      do i = is, ie
        addelp(i,j,k) = addelp(i,j,k)+adte_2d(i,j)*(0.5*(ua(i,j,k)**2+va(i,j,k)**2)+cp*pt(i,j,k)*(1.+r_vir*q(i,j,k,sphum)))
        adpt(i,j,k) = adpt(i,j,k)+adte_2d(i,j)*delp(i,j,k)*cp*(1.+r_vir*q(i,j,k,sphum))
        adq(i,j,k,sphum) = adq(i,j,k,sphum)+adte_2d(i,j)*delp(i,j,k)*cp*pt(i,j,k)*r_vir
        adua(i,j,k) = adua(i,j,k)+adte_2d(i,j)*delp(i,j,k)*ua(i,j,k)
        adva(i,j,k) = adva(i,j,k)+adte_2d(i,j)*delp(i,j,k)*va(i,j,k)
      end do
    end do
    do i = is, ie
      adgztop(i) = adgztop(i)-adte_2d(i,j)*pe(i,1,j)
      adte_2d(i,j) = 0.
    end do
    do i = is, ie
      do k = 1, km
        adpt(i,j,k) = adpt(i,j,k)+adgztop(i)*(peln(i,k+1,j)-peln(i,k,j))*rg*(1.+r_vir*q(i,j,k,sphum))
        adq(i,j,k,sphum) = adq(i,j,k,sphum)+adgztop(i)*(peln(i,k+1,j)-peln(i,k,j))*rg*pt(i,j,k)*r_vir
      end do
      adgztop(i) = 0.
    end do
  else
    do i = is, ie
      phiz(i,km+1) = hs(i,j)
      do k = km, 1, -1
        phiz(i,k) = phiz(i,k+1)-grav*delz(i,j,k)
      end do
    end do
    do k = km, 1, -1
      do i = is, ie
        addelp(i,j,k) = addelp(i,j,k)+adte_2d(i,j)*(cv*pt(i,j,k)*(1.+r_vir*q(i,j,k,sphum))+0.5*(phiz(i,k)+phiz(i,k+1)+ua(i,j,k)**2+&
&va(i,j,k)**2+w(i,j,k)**2))
        adphiz(i,k+1) = adphiz(i,k+1)+0.5*adte_2d(i,j)*delp(i,j,k)
        adphiz(i,k) = adphiz(i,k)+0.5*adte_2d(i,j)*delp(i,j,k)
        adpt(i,j,k) = adpt(i,j,k)+adte_2d(i,j)*delp(i,j,k)*cv*(1.+r_vir*q(i,j,k,sphum))
        adq(i,j,k,sphum) = adq(i,j,k,sphum)+adte_2d(i,j)*delp(i,j,k)*cv*pt(i,j,k)*r_vir
        adua(i,j,k) = adua(i,j,k)+adte_2d(i,j)*delp(i,j,k)*ua(i,j,k)
        adva(i,j,k) = adva(i,j,k)+adte_2d(i,j)*delp(i,j,k)*va(i,j,k)
        adw(i,j,k) = adw(i,j,k)+adte_2d(i,j)*delp(i,j,k)*w(i,j,k)
      end do
    end do
    do i = is, ie
      adte_2d(i,j) = 0.
    end do
    do i = is, ie
      do k = 1, km
        addelz(i,j,k) = addelz(i,j,k)-adphiz(i,k)*grav
        adphiz(i,k+1) = adphiz(i,k+1)+adphiz(i,k)
        adphiz(i,k) = 0.
      end do
      adphiz(i,km+1) = 0.
    end do
  endif
end do
call adcubed_to_latlon( adu,adv,adua,adva,dx,dy,rdxa,rdya,km )

end subroutine adcompute_total_energy


subroutine adcs_limiters( im, a4, ada4, iv )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.50  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r12 = 1./12.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: im
real, intent(inout) :: a4(4,im)
real, intent(inout) :: ada4(4,im)
integer, intent(in) :: iv

!==============================================
! declare local variables
!==============================================
real :: a6da
real :: ada6da
real :: adda1
real :: adda2
real :: adfmin
real :: da1
real :: da2
real :: fmin
integer :: i

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
ada6da = 0.
adda1 = 0.
adda2 = 0.
adfmin = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
if (iv .eq. 0) then
  do i = im, 1, -1
    adfmin = 0.
    if (abs(a4(3,i)-a4(2,i)) .lt. (-a4(4,i))) then
      fmin = a4(1,i)+0.25*(a4(3,i)-a4(2,i))**2/a4(4,i)+a4(4,i)*r12
      if (fmin .lt. 0.) then
        if (a4(1,i) .lt. a4(3,i) .and. a4(1,i) .lt. a4(2,i)) then
          ada4(4,i) = 0.
          ada4(1,i) = ada4(1,i)+ada4(2,i)
          ada4(2,i) = 0.
          ada4(1,i) = ada4(1,i)+ada4(3,i)
          ada4(3,i) = 0.
        else if (a4(3,i) .gt. a4(2,i)) then
          ada4(4,i) = ada4(4,i)-ada4(3,i)
          ada4(2,i) = ada4(2,i)+ada4(3,i)
          ada4(3,i) = 0.
          ada4(2,i) = ada4(2,i)+3*ada4(4,i)
          ada4(1,i) = ada4(1,i)-3*ada4(4,i)
          ada4(4,i) = 0.
        else
          ada4(4,i) = ada4(4,i)-ada4(2,i)
          ada4(3,i) = ada4(3,i)+ada4(2,i)
          ada4(2,i) = 0.
          ada4(3,i) = ada4(3,i)+3*ada4(4,i)
          ada4(1,i) = ada4(1,i)-3*ada4(4,i)
          ada4(4,i) = 0.
        endif
      endif
      ada4(4,i) = ada4(4,i)+adfmin*((-(0.25*(a4(3,i)-a4(2,i))**2/(a4(4,i)*a4(4,i))))+r12)
      ada4(3,i) = ada4(3,i)+adfmin*(0.5*(a4(3,i)-a4(2,i))/a4(4,i))
      ada4(2,i) = ada4(2,i)+adfmin*((-0.5)*(a4(3,i)-a4(2,i))/a4(4,i))
      ada4(1,i) = ada4(1,i)+adfmin
      adfmin = 0.
    endif
  end do
else
  do i = im, 1, -1
    ada6da = 0.
    adda1 = 0.
    adda2 = 0.
    if ((a4(1,i)-a4(2,i))*(a4(1,i)-a4(3,i)) .ge. 0.) then
      ada4(4,i) = 0.
      ada4(1,i) = ada4(1,i)+ada4(3,i)
      ada4(3,i) = 0.
      ada4(1,i) = ada4(1,i)+ada4(2,i)
      ada4(2,i) = 0.
    else
      da1 = a4(3,i)-a4(2,i)
      da2 = da1**2
      a6da = a4(4,i)*da1
      if (a6da .lt. (-da2)) then
        ada4(4,i) = ada4(4,i)-ada4(3,i)
        ada4(2,i) = ada4(2,i)+ada4(3,i)
        ada4(3,i) = 0.
        ada4(2,i) = ada4(2,i)+3*ada4(4,i)
        ada4(1,i) = ada4(1,i)-3*ada4(4,i)
        ada4(4,i) = 0.
      else if (a6da .gt. da2) then
        ada4(4,i) = ada4(4,i)-ada4(2,i)
        ada4(3,i) = ada4(3,i)+ada4(2,i)
        ada4(2,i) = 0.
        ada4(3,i) = ada4(3,i)+3*ada4(4,i)
        ada4(1,i) = ada4(1,i)-3*ada4(4,i)
        ada4(4,i) = 0.
      endif
      ada4(4,i) = ada4(4,i)+ada6da*da1
      adda1 = adda1+ada6da*a4(4,i)
      ada6da = 0.
      adda1 = adda1+2*adda2*da1
      adda2 = 0.
      ada4(3,i) = ada4(3,i)+adda1
      ada4(2,i) = ada4(2,i)-adda1
      adda1 = 0.
    endif
  end do
endif

end subroutine adcs_limiters


subroutine adcs_profile( a4, ada4, delp, addelp, km, i1, i2, iv )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.50  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: km
real, intent(inout) :: a4(4,i1:i2,km)
real, intent(inout) :: ada4(4,i1:i2,km)
real, intent(inout) :: addelp(i1:i2,km)
real, intent(in) :: delp(i1:i2,km)
integer, intent(in) :: iv

!==============================================
! declare local variables
!==============================================
real :: a4h
real :: a4i
real :: a4j
real :: a4k
real :: a4l
real :: a4m
real :: a4n
real :: a4o
real :: a4p
real :: a4q
real :: a4r(lbound(a4,1):ubound(a4,1),lbound(a4,2):ubound(a4,2),lbound(a4,3):ubound(a4,3))
real :: a4s(lbound(a4,1):ubound(a4,1),lbound(a4,2):ubound(a4,2),lbound(a4,3):ubound(a4,3))
real :: a_bot
real :: ada4h
real :: ada4i
real :: ada4j
real :: ada4k
real :: ada4l
real :: ada4m
real :: ada4n
real :: ada4o
real :: ada4p
real :: ada4q
real :: ada_bot
real :: adbet
real :: add4(i1:i2)
real :: adgam(i1:i2,km)
real :: adgrat
real :: adlac
real :: adpmp
real :: adq(i1:i2,km+1)
real :: adqh
real :: adqi
real :: adqj
real :: adqk
real :: adql
real :: adqm
real :: adqn
real :: adqo
real :: bet
real :: d4(i1:i2)
real :: gam(i1:i2,km)
real :: grat
integer :: i
integer :: ib2
integer :: ib3
integer :: ib4
integer :: ib5
integer :: im
integer :: k
integer :: k1
integer :: k2
integer :: k3
integer :: k4
integer :: k5
integer :: ka1
integer :: ka2
integer :: ka3
integer :: ka4
integer :: kb1
real :: lac
real :: pmp
real :: q(i1:i2,km+1)
real :: qh
real :: qi
real :: qj
real :: qk
real :: ql
real :: qm
real :: qn
real :: qo

!----------------------------------------------
! SAVE REQUIRED INPUT VARIABLES
!----------------------------------------------
a4s(:,:,:) = a4(:,:,:)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
ada_bot = 0.
adbet = 0.
add4(:) = 0.
adgam(:,:) = 0.
adgrat = 0.
adlac = 0.
adpmp = 0.
adq(:,:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = ((grat+grat)*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = 2, km
  do i = i1, i2
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+d4(i)+d4(i)-gam(i,k-1)
    q(i,k) = (3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/bet
    gam(i,k) = d4(i)/bet
  end do
end do
do i = i1, i2
  a_bot = 1.+d4(i)*(d4(i)+1.5)
  q(i,km+1) = (2.*d4(i)*(d4(i)+1.)*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))/(d4(i)*(d4(i)+0.5)-a_bot*gam(i,km))
end do
do k = km, 1, -1
  do i = i1, i2
    q(i,k) = q(i,k)-gam(i,k)*q(i,k+1)
  end do
end do
im = i2-i1+1
do k = 2, km
  do i = i1, i2
    gam(i,k) = a4(1,i,k)-a4(1,i,k-1)
  end do
end do
do i = i1, i2
  if ((q(i,2)-q(i,1))*(q(i,3)-q(i,2)) .gt. 0.) then
    q(i,2) = min(q(i,2),max(a4(1,i,1),a4(1,i,2)))
    q(i,2) = max(q(i,2),min(a4(1,i,1),a4(1,i,2)))
  else if (iv .eq. 0) then
    q(i,2) = max(0.,q(i,2))
  endif
end do
do k = 3, km-1
  do i = i1, i2
    if (gam(i,k-1)*gam(i,k+1) .gt. 0.) then
      q(i,k) = min(q(i,k),max(a4(1,i,k-1),a4(1,i,k)))
      q(i,k) = max(q(i,k),min(a4(1,i,k-1),a4(1,i,k)))
    else
      if (gam(i,k-1) .gt. 0.) then
        q(i,k) = max(q(i,k),min(a4(1,i,k-1),a4(1,i,k)))
      else
        if (iv .eq. 0) then
          q(i,k) = max(0.,q(i,k))
        else
          q(i,k) = min(q(i,k),max(a4(1,i,k-1),a4(1,i,k)))
        endif
      endif
    endif
  end do
end do
do i = i1, i2
  if ((q(i,km)-q(i,km-1))*(q(i,km+1)-q(i,km)) .gt. 0.) then
    q(i,km) = min(q(i,km),max(a4(1,i,km-1),a4(1,i,km)))
    q(i,km) = max(q(i,km),min(a4(1,i,km-1),a4(1,i,km)))
  else if (iv .eq. 0) then
    q(i,km) = max(0.,q(i,km))
  endif
end do
do k = 1, km
  do i = i1, i2
    a4(2,i,k) = q(i,k)
    a4(3,i,k) = q(i,k+1)
  end do
end do
do i = i1, i2
  if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
    a4(2,i,1) = 0.
  endif
  if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
    a4(3,i,km) = 0.
  endif
end do
do k = 1, 2
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call cs_limiters( im,a4(1,i1,k),1 )
end do
do k = 3, km-2
  do i = i1, i2
    pmp = a4(1,i,k)-2.*gam(i,k+1)
    lac = pmp+1.5*gam(i,k+2)
    a4(2,i,k) = min(max(a4(2,i,k),min(a4(1,i,k),pmp,lac)),max(a4(1,i,k),pmp,lac))
    pmp = a4(1,i,k)+2.*gam(i,k)
    lac = pmp-1.5*gam(i,k-1)
    a4(3,i,k) = min(max(a4(3,i,k),min(a4(1,i,k),pmp,lac)),max(a4(1,i,k),pmp,lac))
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  if (iv .eq. 0) then
    call cs_limiters( im,a4(1,i1,k),0 )
  endif
end do
do k = km, km-1, -1
  do ka1 = 1, km
    do i = i1, i2
      a4(2,i,ka1) = q(i,ka1)
      a4(3,i,ka1) = q(i,ka1+1)
    end do
  end do
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
    if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
      a4(3,i,km) = 0.
    endif
  end do
  do ka1 = 1, 2
    do i = i1, i2
      a4(4,i,ka1) = 3.*(2.*a4(1,i,ka1)-(a4(2,i,ka1)+a4(3,i,ka1)))
    end do
    call cs_limiters( im,a4(1,i1,ka1),1 )
  end do
  do ka1 = 3, km-2
    do i = i1, i2
      pmp = a4(1,i,ka1)-2.*gam(i,ka1+1)
      lac = pmp+1.5*gam(i,ka1+2)
      a4(2,i,ka1) = min(max(a4(2,i,ka1),min(a4(1,i,ka1),pmp,lac)),max(a4(1,i,ka1),pmp,lac))
      pmp = a4(1,i,ka1)+2.*gam(i,ka1)
      lac = pmp-1.5*gam(i,ka1-1)
      a4(3,i,ka1) = min(max(a4(3,i,ka1),min(a4(1,i,ka1),pmp,lac)),max(a4(1,i,ka1),pmp,lac))
      a4(4,i,ka1) = 3.*(2.*a4(1,i,ka1)-(a4(2,i,ka1)+a4(3,i,ka1)))
    end do
    if (iv .eq. 0) then
      call cs_limiters( im,a4(1,i1,ka1),0 )
    endif
  end do
  do k1 = km-1, k-1
    do i = i1, i2
      a4(4,i,k1) = 3.*(2.*a4(1,i,k1)-(a4(2,i,k1)+a4(3,i,k1)))
    end do
    call cs_limiters( im,a4(1,i1,k1),1 )
  end do
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call adcs_limiters( im,a4(1,i1,k),ada4(1,i1,k),1 )
  do i = i1, i2
    ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
    ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
    ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
    ada4(4,i,k) = 0.
  end do
end do
do k = 1, km
  do i = i1, i2
    a4(2,i,k) = q(i,k)
    a4(3,i,k) = q(i,k+1)
  end do
end do
do i = i1, i2
  if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
    a4(2,i,1) = 0.
  endif
  if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
    a4(3,i,km) = 0.
  endif
end do
do k = 1, 2
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call cs_limiters( im,a4(1,i1,k),1 )
end do
do k = km-2, 3, -1
  do ka2 = 1, km
    do i = i1, i2
      a4(2,i,ka2) = q(i,ka2)
      a4(3,i,ka2) = q(i,ka2+1)
    end do
  end do
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
    if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
      a4(3,i,km) = 0.
    endif
  end do
  do ka2 = 1, 2
    do i = i1, i2
      a4(4,i,ka2) = 3.*(2.*a4(1,i,ka2)-(a4(2,i,ka2)+a4(3,i,ka2)))
    end do
    call cs_limiters( im,a4(1,i1,ka2),1 )
  end do
  do k2 = 3, k-1
    do i = i1, i2
      pmp = a4(1,i,k2)-2.*gam(i,k2+1)
      lac = pmp+1.5*gam(i,k2+2)
      a4(2,i,k2) = min(max(a4(2,i,k2),min(a4(1,i,k2),pmp,lac)),max(a4(1,i,k2),pmp,lac))
      pmp = a4(1,i,k2)+2.*gam(i,k2)
      lac = pmp-1.5*gam(i,k2-1)
      a4(3,i,k2) = min(max(a4(3,i,k2),min(a4(1,i,k2),pmp,lac)),max(a4(1,i,k2),pmp,lac))
      a4(4,i,k2) = 3.*(2.*a4(1,i,k2)-(a4(2,i,k2)+a4(3,i,k2)))
    end do
    if (iv .eq. 0) then
      call cs_limiters( im,a4(1,i1,k2),0 )
    endif
  end do
  a4r(:,:,:) = a4(:,:,:)
  do i = i1, i2
    pmp = a4(1,i,k)-2.*gam(i,k+1)
    lac = pmp+1.5*gam(i,k+2)
    a4(2,i,k) = min(max(a4(2,i,k),min(a4(1,i,k),pmp,lac)),max(a4(1,i,k),pmp,lac))
    pmp = a4(1,i,k)+2.*gam(i,k)
    lac = pmp-1.5*gam(i,k-1)
    a4(3,i,k) = min(max(a4(3,i,k),min(a4(1,i,k),pmp,lac)),max(a4(1,i,k),pmp,lac))
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  if (iv .eq. 0) then
    call adcs_limiters( im,a4(1,i1,k),ada4(1,i1,k),0 )
  endif
  a4(:,:,:) = a4r(:,:,:)
  do i = i2, i1, -1
    adlac = 0.
    adpmp = 0.
    pmp = a4(1,i,k)-2.*gam(i,k+1)
    lac = pmp+1.5*gam(i,k+2)
    a4(2,i,k) = min(max(a4(2,i,k),min(a4(1,i,k),pmp,lac)),max(a4(1,i,k),pmp,lac))
    pmp = a4(1,i,k)+2.*gam(i,k)
    lac = pmp-1.5*gam(i,k-1)
    ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
    ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
    ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
    ada4(4,i,k) = 0.
    a4i = min(a4(1,i,k),pmp)
    a4j = min(a4i,lac)
    a4h = max(a4(3,i,k),a4j)
    a4k = max(a4(1,i,k),pmp)
    a4l = max(a4k,lac)
    ada4h = ada4(3,i,k)*(0.5+sign(0.5,a4l-a4h))
    ada4l = ada4(3,i,k)*(0.5-sign(0.5,a4l-a4h))
    ada4k = ada4l*(0.5+sign(0.5,a4k-lac))
    adlac = adlac+ada4l*(0.5-sign(0.5,a4k-lac))
    ada4(1,i,k) = ada4(1,i,k)+ada4k*(0.5+sign(0.5,a4(1,i,k)-pmp))
    adpmp = adpmp+ada4k*(0.5-sign(0.5,a4(1,i,k)-pmp))
    ada4(3,i,k) = ada4h*(0.5+sign(0.5,a4(3,i,k)-a4j))
    ada4j = ada4h*(0.5-sign(0.5,a4(3,i,k)-a4j))
    ada4i = ada4j*(0.5+sign(0.5,lac-a4i))
    adlac = adlac+ada4j*(0.5-sign(0.5,lac-a4i))
    ada4(1,i,k) = ada4(1,i,k)+ada4i*(0.5+sign(0.5,pmp-a4(1,i,k)))
    adpmp = adpmp+ada4i*(0.5-sign(0.5,pmp-a4(1,i,k)))
    adgam(i,k-1) = adgam(i,k-1)-1.5*adlac
    adpmp = adpmp+adlac
    adlac = 0.
    ada4(1,i,k) = ada4(1,i,k)+adpmp
    adgam(i,k) = adgam(i,k)+2*adpmp
    adpmp = 0.
    a4(:,:,:) = a4r(:,:,:)
    pmp = a4(1,i,k)-2.*gam(i,k+1)
    lac = pmp+1.5*gam(i,k+2)
    a4n = min(a4(1,i,k),pmp)
    a4o = min(a4n,lac)
    a4m = max(a4(2,i,k),a4o)
    a4p = max(a4(1,i,k),pmp)
    a4q = max(a4p,lac)
    ada4m = ada4(2,i,k)*(0.5+sign(0.5,a4q-a4m))
    ada4q = ada4(2,i,k)*(0.5-sign(0.5,a4q-a4m))
    ada4p = ada4q*(0.5+sign(0.5,a4p-lac))
    adlac = adlac+ada4q*(0.5-sign(0.5,a4p-lac))
    ada4(1,i,k) = ada4(1,i,k)+ada4p*(0.5+sign(0.5,a4(1,i,k)-pmp))
    adpmp = adpmp+ada4p*(0.5-sign(0.5,a4(1,i,k)-pmp))
    ada4(2,i,k) = ada4m*(0.5+sign(0.5,a4(2,i,k)-a4o))
    ada4o = ada4m*(0.5-sign(0.5,a4(2,i,k)-a4o))
    ada4n = ada4o*(0.5+sign(0.5,lac-a4n))
    adlac = adlac+ada4o*(0.5-sign(0.5,lac-a4n))
    ada4(1,i,k) = ada4(1,i,k)+ada4n*(0.5+sign(0.5,pmp-a4(1,i,k)))
    adpmp = adpmp+ada4n*(0.5-sign(0.5,pmp-a4(1,i,k)))
    adgam(i,k+2) = adgam(i,k+2)+1.5*adlac
    adpmp = adpmp+adlac
    adlac = 0.
    ada4(1,i,k) = ada4(1,i,k)+adpmp
    adgam(i,k+1) = adgam(i,k+1)-2*adpmp
    adpmp = 0.
  end do
end do
do k = 1, km
  do i = i1, i2
    a4(2,i,k) = q(i,k)
    a4(3,i,k) = q(i,k+1)
  end do
end do
do i = i1, i2
  if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
    a4(2,i,1) = 0.
  endif
  if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
    a4(3,i,km) = 0.
  endif
end do
do k = 2, 1, -1
  do ka3 = 1, km
    do i = i1, i2
      a4(2,i,ka3) = q(i,ka3)
      a4(3,i,ka3) = q(i,ka3+1)
    end do
  end do
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
    if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
      a4(3,i,km) = 0.
    endif
  end do
  do k3 = 1, k-1
    do i = i1, i2
      a4(4,i,k3) = 3.*(2.*a4(1,i,k3)-(a4(2,i,k3)+a4(3,i,k3)))
    end do
    call cs_limiters( im,a4(1,i1,k3),1 )
  end do
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call adcs_limiters( im,a4(1,i1,k),ada4(1,i1,k),1 )
  do i = i1, i2
    ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
    ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
    ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
    ada4(4,i,k) = 0.
  end do
end do
do k = 1, km
  do i = i1, i2
    a4(2,i,k) = q(i,k)
    a4(3,i,k) = q(i,k+1)
  end do
end do
do i = i1, i2
  if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
    a4(2,i,1) = 0.
  endif
  if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
    ada4(3,i,km) = 0.
  endif
  do k = 1, km
    do ib2 = i1, i2
      a4(2,ib2,k) = q(ib2,k)
      a4(3,ib2,k) = q(ib2,k+1)
    end do
  end do
  if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
    ada4(2,i,1) = 0.
  endif
end do
do k = 1, km
  do i = i1, i2
    adq(i,k+1) = adq(i,k+1)+ada4(3,i,k)
    ada4(3,i,k) = 0.
    adq(i,k) = adq(i,k)+ada4(2,i,k)
    ada4(2,i,k) = 0.
  end do
end do
a4(:,:,:) = a4s(:,:,:)
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = ((grat+grat)*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = 2, km
  do i = i1, i2
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+d4(i)+d4(i)-gam(i,k-1)
    q(i,k) = (3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/bet
    gam(i,k) = d4(i)/bet
  end do
end do
do i = i1, i2
  a_bot = 1.+d4(i)*(d4(i)+1.5)
  q(i,km+1) = (2.*d4(i)*(d4(i)+1.)*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))/(d4(i)*(d4(i)+0.5)-a_bot*gam(i,km))
end do
do k = km, 1, -1
  do i = i1, i2
    q(i,k) = q(i,k)-gam(i,k)*q(i,k+1)
  end do
end do
do k = 2, km
  do i = i1, i2
    gam(i,k) = a4(1,i,k)-a4(1,i,k-1)
  end do
end do
do i = i1, i2
  if ((q(i,2)-q(i,1))*(q(i,3)-q(i,2)) .gt. 0.) then
    q(i,2) = min(q(i,2),max(a4(1,i,1),a4(1,i,2)))
    q(i,2) = max(q(i,2),min(a4(1,i,1),a4(1,i,2)))
  else if (iv .eq. 0) then
    q(i,2) = max(0.,q(i,2))
  endif
end do
do k = 3, km-1
  do i = i1, i2
    if (gam(i,k-1)*gam(i,k+1) .gt. 0.) then
      q(i,k) = min(q(i,k),max(a4(1,i,k-1),a4(1,i,k)))
      q(i,k) = max(q(i,k),min(a4(1,i,k-1),a4(1,i,k)))
    else
      if (gam(i,k-1) .gt. 0.) then
        q(i,k) = max(q(i,k),min(a4(1,i,k-1),a4(1,i,k)))
      else
        if (iv .eq. 0) then
          q(i,k) = max(0.,q(i,k))
        else
          q(i,k) = min(q(i,k),max(a4(1,i,k-1),a4(1,i,k)))
        endif
      endif
    endif
  end do
end do
do i = i1, i2
  if ((q(i,km)-q(i,km-1))*(q(i,km+1)-q(i,km)) .gt. 0.) then
    q(i,km) = min(q(i,km),max(a4(1,i,km-1),a4(1,i,km)))
    qh = min(a4(1,i,km-1),a4(1,i,km))
    adqh = adq(i,km)*(0.5-sign(0.5,q(i,km)-qh))
    adq(i,km) = adq(i,km)*(0.5+sign(0.5,q(i,km)-qh))
    ada4(1,i,km-1) = ada4(1,i,km-1)+adqh*(0.5+sign(0.5,a4(1,i,km)-a4(1,i,km-1)))
    ada4(1,i,km) = ada4(1,i,km)+adqh*(0.5-sign(0.5,a4(1,i,km)-a4(1,i,km-1)))
    do ib3 = i1, i2
      grat = delp(ib3,2)/delp(ib3,1)
      bet = grat*(grat+0.5)
      q(ib3,1) = ((grat+grat)*(grat+1.)*a4(1,ib3,1)+a4(1,ib3,2))/bet
      gam(ib3,1) = (1.+grat*(grat+1.5))/bet
    end do
    do k = 2, km
      do ib3 = i1, i2
        d4(ib3) = delp(ib3,k-1)/delp(ib3,k)
        bet = 2.+d4(ib3)+d4(ib3)-gam(ib3,k-1)
        q(ib3,k) = (3.*(a4(1,ib3,k-1)+d4(ib3)*a4(1,ib3,k))-q(ib3,k-1))/bet
        gam(ib3,k) = d4(ib3)/bet
      end do
    end do
    do ib3 = i1, i2
      a_bot = 1.+d4(ib3)*(d4(ib3)+1.5)
      q(ib3,km+1) = (2.*d4(ib3)*(d4(ib3)+1.)*a4(1,ib3,km)+a4(1,ib3,km-1)-a_bot*q(ib3,km))/(d4(ib3)*(d4(ib3)+0.5)-a_bot*gam(ib3,km))
    end do
    do k = km, 1, -1
      do ib3 = i1, i2
        q(ib3,k) = q(ib3,k)-gam(ib3,k)*q(ib3,k+1)
      end do
    end do
    do k = 2, km
      do ib3 = i1, i2
        gam(ib3,k) = a4(1,ib3,k)-a4(1,ib3,k-1)
      end do
    end do
    do ib3 = i1, i2
      if ((q(ib3,2)-q(ib3,1))*(q(ib3,3)-q(ib3,2)) .gt. 0.) then
        q(ib3,2) = min(q(ib3,2),max(a4(1,ib3,1),a4(1,ib3,2)))
        q(ib3,2) = max(q(ib3,2),min(a4(1,ib3,1),a4(1,ib3,2)))
      else if (iv .eq. 0) then
        q(ib3,2) = max(0.,q(ib3,2))
      endif
    end do
    do k = 3, km-1
      do ib3 = i1, i2
        if (gam(ib3,k-1)*gam(ib3,k+1) .gt. 0.) then
          q(ib3,k) = min(q(ib3,k),max(a4(1,ib3,k-1),a4(1,ib3,k)))
          q(ib3,k) = max(q(ib3,k),min(a4(1,ib3,k-1),a4(1,ib3,k)))
        else
          if (gam(ib3,k-1) .gt. 0.) then
            q(ib3,k) = max(q(ib3,k),min(a4(1,ib3,k-1),a4(1,ib3,k)))
          else
            if (iv .eq. 0) then
              q(ib3,k) = max(0.,q(ib3,k))
            else
              q(ib3,k) = min(q(ib3,k),max(a4(1,ib3,k-1),a4(1,ib3,k)))
            endif
          endif
        endif
      end do
    end do
    qi = max(a4(1,i,km-1),a4(1,i,km))
    adqi = adq(i,km)*(0.5-sign(0.5,qi-q(i,km)))
    adq(i,km) = adq(i,km)*(0.5+sign(0.5,qi-q(i,km)))
    ada4(1,i,km-1) = ada4(1,i,km-1)+adqi*(0.5+sign(0.5,a4(1,i,km-1)-a4(1,i,km)))
    ada4(1,i,km) = ada4(1,i,km)+adqi*(0.5-sign(0.5,a4(1,i,km-1)-a4(1,i,km)))
  else if (iv .eq. 0) then
    adq(i,km) = adq(i,km)*(0.5-sign(0.5,0.-q(i,km)))
  endif
end do
a4(:,:,:) = a4s(:,:,:)
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = ((grat+grat)*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = 2, km
  do i = i1, i2
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+d4(i)+d4(i)-gam(i,k-1)
    q(i,k) = (3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/bet
    gam(i,k) = d4(i)/bet
  end do
end do
do i = i1, i2
  a_bot = 1.+d4(i)*(d4(i)+1.5)
  q(i,km+1) = (2.*d4(i)*(d4(i)+1.)*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))/(d4(i)*(d4(i)+0.5)-a_bot*gam(i,km))
end do
do k = km, 1, -1
  do i = i1, i2
    q(i,k) = q(i,k)-gam(i,k)*q(i,k+1)
  end do
end do
do k = 2, km
  do i = i1, i2
    gam(i,k) = a4(1,i,k)-a4(1,i,k-1)
  end do
end do
do i = i1, i2
  if ((q(i,2)-q(i,1))*(q(i,3)-q(i,2)) .gt. 0.) then
    q(i,2) = min(q(i,2),max(a4(1,i,1),a4(1,i,2)))
    q(i,2) = max(q(i,2),min(a4(1,i,1),a4(1,i,2)))
  else if (iv .eq. 0) then
    q(i,2) = max(0.,q(i,2))
  endif
end do
do k = 3, km-1
  do i = i1, i2
    if (gam(i,k-1)*gam(i,k+1) .gt. 0.) then
      q(i,k) = min(q(i,k),max(a4(1,i,k-1),a4(1,i,k)))
      ql = min(a4(1,i,k-1),a4(1,i,k))
      adql = adq(i,k)*(0.5-sign(0.5,q(i,k)-ql))
      adq(i,k) = adq(i,k)*(0.5+sign(0.5,q(i,k)-ql))
      ada4(1,i,k-1) = ada4(1,i,k-1)+adql*(0.5+sign(0.5,a4(1,i,k)-a4(1,i,k-1)))
      ada4(1,i,k) = ada4(1,i,k)+adql*(0.5-sign(0.5,a4(1,i,k)-a4(1,i,k-1)))
      do ib4 = i1, i2
        grat = delp(ib4,2)/delp(ib4,1)
        bet = grat*(grat+0.5)
        q(ib4,1) = ((grat+grat)*(grat+1.)*a4(1,ib4,1)+a4(1,ib4,2))/bet
        gam(ib4,1) = (1.+grat*(grat+1.5))/bet
      end do
      do kb1 = 2, km
        do ib4 = i1, i2
          d4(ib4) = delp(ib4,kb1-1)/delp(ib4,kb1)
          bet = 2.+d4(ib4)+d4(ib4)-gam(ib4,kb1-1)
          q(ib4,kb1) = (3.*(a4(1,ib4,kb1-1)+d4(ib4)*a4(1,ib4,kb1))-q(ib4,kb1-1))/bet
          gam(ib4,kb1) = d4(ib4)/bet
        end do
      end do
      do ib4 = i1, i2
        a_bot = 1.+d4(ib4)*(d4(ib4)+1.5)
        q(ib4,km+1) = (2.*d4(ib4)*(d4(ib4)+1.)*a4(1,ib4,km)+a4(1,ib4,km-1)-a_bot*q(ib4,km))/(d4(ib4)*(d4(ib4)+0.5)-a_bot*gam(ib4,&
&km))
      end do
      do kb1 = km, 1, -1
        do ib4 = i1, i2
          q(ib4,kb1) = q(ib4,kb1)-gam(ib4,kb1)*q(ib4,kb1+1)
        end do
      end do
      do kb1 = 2, km
        do ib4 = i1, i2
          gam(ib4,kb1) = a4(1,ib4,kb1)-a4(1,ib4,kb1-1)
        end do
      end do
      do ib4 = i1, i2
        if ((q(ib4,2)-q(ib4,1))*(q(ib4,3)-q(ib4,2)) .gt. 0.) then
          q(ib4,2) = min(q(ib4,2),max(a4(1,ib4,1),a4(1,ib4,2)))
          q(ib4,2) = max(q(ib4,2),min(a4(1,ib4,1),a4(1,ib4,2)))
        else if (iv .eq. 0) then
          q(ib4,2) = max(0.,q(ib4,2))
        endif
      end do
      qm = max(a4(1,i,k-1),a4(1,i,k))
      adqm = adq(i,k)*(0.5-sign(0.5,qm-q(i,k)))
      adq(i,k) = adq(i,k)*(0.5+sign(0.5,qm-q(i,k)))
      ada4(1,i,k-1) = ada4(1,i,k-1)+adqm*(0.5+sign(0.5,a4(1,i,k-1)-a4(1,i,k)))
      ada4(1,i,k) = ada4(1,i,k)+adqm*(0.5-sign(0.5,a4(1,i,k-1)-a4(1,i,k)))
    else
      if (gam(i,k-1) .gt. 0.) then
        qk = min(a4(1,i,k-1),a4(1,i,k))
        adqk = adq(i,k)*(0.5-sign(0.5,q(i,k)-qk))
        adq(i,k) = adq(i,k)*(0.5+sign(0.5,q(i,k)-qk))
        ada4(1,i,k-1) = ada4(1,i,k-1)+adqk*(0.5+sign(0.5,a4(1,i,k)-a4(1,i,k-1)))
        ada4(1,i,k) = ada4(1,i,k)+adqk*(0.5-sign(0.5,a4(1,i,k)-a4(1,i,k-1)))
      else
        if (iv .eq. 0) then
          adq(i,k) = adq(i,k)*(0.5-sign(0.5,0.-q(i,k)))
        else
          qj = max(a4(1,i,k-1),a4(1,i,k))
          adqj = adq(i,k)*(0.5-sign(0.5,qj-q(i,k)))
          adq(i,k) = adq(i,k)*(0.5+sign(0.5,qj-q(i,k)))
          ada4(1,i,k-1) = ada4(1,i,k-1)+adqj*(0.5+sign(0.5,a4(1,i,k-1)-a4(1,i,k)))
          ada4(1,i,k) = ada4(1,i,k)+adqj*(0.5-sign(0.5,a4(1,i,k-1)-a4(1,i,k)))
        endif
      endif
    endif
  end do
end do
a4(:,:,:) = a4s(:,:,:)
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = ((grat+grat)*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = 2, km
  do i = i1, i2
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+d4(i)+d4(i)-gam(i,k-1)
    q(i,k) = (3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/bet
    gam(i,k) = d4(i)/bet
  end do
end do
do i = i1, i2
  a_bot = 1.+d4(i)*(d4(i)+1.5)
  q(i,km+1) = (2.*d4(i)*(d4(i)+1.)*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))/(d4(i)*(d4(i)+0.5)-a_bot*gam(i,km))
end do
do k = km, 1, -1
  do i = i1, i2
    q(i,k) = q(i,k)-gam(i,k)*q(i,k+1)
  end do
end do
do i = i1, i2
  if ((q(i,2)-q(i,1))*(q(i,3)-q(i,2)) .gt. 0.) then
    q(i,2) = min(q(i,2),max(a4(1,i,1),a4(1,i,2)))
    qn = min(a4(1,i,1),a4(1,i,2))
    adqn = adq(i,2)*(0.5-sign(0.5,q(i,2)-qn))
    adq(i,2) = adq(i,2)*(0.5+sign(0.5,q(i,2)-qn))
    ada4(1,i,2) = ada4(1,i,2)+adqn*(0.5-sign(0.5,a4(1,i,2)-a4(1,i,1)))
    ada4(1,i,1) = ada4(1,i,1)+adqn*(0.5+sign(0.5,a4(1,i,2)-a4(1,i,1)))
    do ib5 = i1, i2
      grat = delp(ib5,2)/delp(ib5,1)
      bet = grat*(grat+0.5)
      q(ib5,1) = ((grat+grat)*(grat+1.)*a4(1,ib5,1)+a4(1,ib5,2))/bet
      gam(ib5,1) = (1.+grat*(grat+1.5))/bet
    end do
    do k = 2, km
      do ib5 = i1, i2
        d4(ib5) = delp(ib5,k-1)/delp(ib5,k)
        bet = 2.+d4(ib5)+d4(ib5)-gam(ib5,k-1)
        q(ib5,k) = (3.*(a4(1,ib5,k-1)+d4(ib5)*a4(1,ib5,k))-q(ib5,k-1))/bet
        gam(ib5,k) = d4(ib5)/bet
      end do
    end do
    do ib5 = i1, i2
      a_bot = 1.+d4(ib5)*(d4(ib5)+1.5)
      q(ib5,km+1) = (2.*d4(ib5)*(d4(ib5)+1.)*a4(1,ib5,km)+a4(1,ib5,km-1)-a_bot*q(ib5,km))/(d4(ib5)*(d4(ib5)+0.5)-a_bot*gam(ib5,km))
    end do
    do k = km, 1, -1
      do ib5 = i1, i2
        q(ib5,k) = q(ib5,k)-gam(ib5,k)*q(ib5,k+1)
      end do
    end do
    do k = 2, km
      do ib5 = i1, i2
        gam(ib5,k) = a4(1,ib5,k)-a4(1,ib5,k-1)
      end do
    end do
    qo = max(a4(1,i,1),a4(1,i,2))
    adqo = adq(i,2)*(0.5-sign(0.5,qo-q(i,2)))
    adq(i,2) = adq(i,2)*(0.5+sign(0.5,qo-q(i,2)))
    ada4(1,i,2) = ada4(1,i,2)+adqo*(0.5-sign(0.5,a4(1,i,1)-a4(1,i,2)))
    ada4(1,i,1) = ada4(1,i,1)+adqo*(0.5+sign(0.5,a4(1,i,1)-a4(1,i,2)))
  else if (iv .eq. 0) then
    adq(i,2) = adq(i,2)*(0.5-sign(0.5,0.-q(i,2)))
  endif
end do
do k = 2, km
  do i = i1, i2
    ada4(1,i,k-1) = ada4(1,i,k-1)-adgam(i,k)
    ada4(1,i,k) = ada4(1,i,k)+adgam(i,k)
    adgam(i,k) = 0.
  end do
end do
a4(:,:,:) = a4s(:,:,:)
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = ((grat+grat)*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = 2, km
  do i = i1, i2
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+d4(i)+d4(i)-gam(i,k-1)
    q(i,k) = (3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/bet
    gam(i,k) = d4(i)/bet
  end do
end do
do i = i1, i2
  a_bot = 1.+d4(i)*(d4(i)+1.5)
  q(i,km+1) = (2.*d4(i)*(d4(i)+1.)*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))/(d4(i)*(d4(i)+0.5)-a_bot*gam(i,km))
end do
do k = 1, km
  do i = i1, i2
    grat = delp(i,2)/delp(i,1)
    bet = grat*(grat+0.5)
    q(i,1) = ((grat+grat)*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
    gam(i,1) = (1.+grat*(grat+1.5))/bet
  end do
  do ka4 = 2, km
    do i = i1, i2
      d4(i) = delp(i,ka4-1)/delp(i,ka4)
      bet = 2.+d4(i)+d4(i)-gam(i,ka4-1)
      q(i,ka4) = (3.*(a4(1,i,ka4-1)+d4(i)*a4(1,i,ka4))-q(i,ka4-1))/bet
      gam(i,ka4) = d4(i)/bet
    end do
  end do
  do i = i1, i2
    a_bot = 1.+d4(i)*(d4(i)+1.5)
    q(i,km+1) = (2.*d4(i)*(d4(i)+1.)*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))/(d4(i)*(d4(i)+0.5)-a_bot*gam(i,km))
  end do
  do k4 = km, k-(-1), -1
    do i = i1, i2
      q(i,k4) = q(i,k4)-gam(i,k4)*q(i,k4+1)
    end do
  end do
  do i = i1, i2
    adgam(i,k) = adgam(i,k)-adq(i,k)*q(i,k+1)
    adq(i,k+1) = adq(i,k+1)-adq(i,k)*gam(i,k)
  end do
end do
a4(:,:,:) = a4s(:,:,:)
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = ((grat+grat)*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = 2, km
  do i = i1, i2
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+d4(i)+d4(i)-gam(i,k-1)
    q(i,k) = (3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/bet
    gam(i,k) = d4(i)/bet
  end do
end do
do i = i2, i1, -1
  ada_bot = 0.
  a_bot = 1.+d4(i)*(d4(i)+1.5)
  ada4(1,i,km-1) = ada4(1,i,km-1)+adq(i,km+1)/(d4(i)*(0.5+d4(i))-a_bot*gam(i,km))
  ada4(1,i,km) = ada4(1,i,km)+adq(i,km+1)*(2*d4(i)*(1.+d4(i))/(d4(i)*(0.5+d4(i))-a_bot*gam(i,km)))
  ada_bot = ada_bot+adq(i,km+1)*((-(q(i,km)/(d4(i)*(0.5+d4(i))-a_bot*gam(i,km))))+(2.*d4(i)*(1.+d4(i))*a4(1,i,km)+a4(1,i,km-1)-&
&a_bot*q(i,km))*gam(i,km)/((d4(i)*(0.5+d4(i))-a_bot*gam(i,km))*(d4(i)*(0.5+d4(i))-a_bot*gam(i,km))))
  add4(i) = add4(i)+adq(i,km+1)*((2*d4(i)+2*(1.+d4(i)))*a4(1,i,km)/(d4(i)*(0.5+d4(i))-a_bot*gam(i,km))-(2.*d4(i)*(1.+d4(i))*a4(1,i,&
&km)+a4(1,i,km-1)-a_bot*q(i,km))*(0.5+2*d4(i))/((d4(i)*(0.5+d4(i))-a_bot*gam(i,km))*(d4(i)*(0.5+d4(i))-a_bot*gam(i,km))))
  adgam(i,km) = adgam(i,km)+adq(i,km+1)*((2.*d4(i)*(1.+d4(i))*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))*a_bot/((d4(i)*(0.5+d4(i))-&
&a_bot*gam(i,km))*(d4(i)*(0.5+d4(i))-a_bot*gam(i,km))))
  adq(i,km) = adq(i,km)-adq(i,km+1)*(a_bot/(d4(i)*(0.5+d4(i))-a_bot*gam(i,km)))
  adq(i,km+1) = 0.
  add4(i) = add4(i)+ada_bot*(1.5+2*d4(i))
  ada_bot = 0.
end do
a4(:,:,:) = a4s(:,:,:)
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = ((grat+grat)*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = km, 2, -1
  do i = i1, i2
    grat = delp(i,2)/delp(i,1)
    bet = grat*(grat+0.5)
    q(i,1) = ((grat+grat)*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
    gam(i,1) = (1.+grat*(grat+1.5))/bet
  end do
  do k5 = 2, k-1
    do i = i1, i2
      d4(i) = delp(i,k5-1)/delp(i,k5)
      bet = 2.+d4(i)+d4(i)-gam(i,k5-1)
      q(i,k5) = (3.*(a4(1,i,k5-1)+d4(i)*a4(1,i,k5))-q(i,k5-1))/bet
      gam(i,k5) = d4(i)/bet
    end do
  end do
  do i = i2, i1, -1
    adbet = 0.
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+d4(i)+d4(i)-gam(i,k-1)
    adbet = adbet-adgam(i,k)*(d4(i)/(bet*bet))
    add4(i) = add4(i)+adgam(i,k)/bet
    adgam(i,k) = 0.
    ada4(1,i,k-1) = ada4(1,i,k-1)+adq(i,k)*(3/bet)
    ada4(1,i,k) = ada4(1,i,k)+adq(i,k)*(3.*d4(i)/bet)
    adbet = adbet-adq(i,k)*((3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/(bet*bet))
    add4(i) = add4(i)+adq(i,k)*(3.*a4(1,i,k)/bet)
    adq(i,k-1) = adq(i,k-1)-adq(i,k)/bet
    adq(i,k) = 0.
    add4(i) = add4(i)+2*adbet
    adgam(i,k-1) = adgam(i,k-1)-adbet
    adbet = 0.
    addelp(i,k-1) = addelp(i,k-1)+add4(i)/delp(i,k)
    addelp(i,k) = addelp(i,k)-add4(i)*(delp(i,k-1)/(delp(i,k)*delp(i,k)))
    add4(i) = 0.
  end do
end do
a4(:,:,:) = a4s(:,:,:)
do i = i2, i1, -1
  adbet = 0.
  adgrat = 0.
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  adbet = adbet-adgam(i,1)*((1.+grat*(1.5+grat))/(bet*bet))
  adgrat = adgrat+adgam(i,1)*((1.5+2*grat)/bet)
  adgam(i,1) = 0.
  ada4(1,i,2) = ada4(1,i,2)+adq(i,1)/bet
  ada4(1,i,1) = ada4(1,i,1)+adq(i,1)*(2*grat*(1.+grat)/bet)
  adbet = adbet-adq(i,1)*((2*grat*(1.+grat)*a4(1,i,1)+a4(1,i,2))/(bet*bet))
  adgrat = adgrat+adq(i,1)*((2*grat+2*(1.+grat))*a4(1,i,1)/bet)
  adq(i,1) = 0.
  adgrat = adgrat+adbet*(0.5+2*grat)
  adbet = 0.
  addelp(i,2) = addelp(i,2)+adgrat/delp(i,1)
  addelp(i,1) = addelp(i,1)-adgrat*(delp(i,2)/(delp(i,1)*delp(i,1)))
  adgrat = 0.
end do

!----------------------------------------------
! FREE DYNAMIC MEMORY
!----------------------------------------------

end subroutine adcs_profile


subroutine adlagrangian_to_eulerian( consv, pe, adpe, delp, addelp, pkz, adpkz, pk, adpk, km, is, ie, js, je, isd, ied, jsd, jed, &
&nq, sphum, u, adu, v, adv, w, adw, delz, addelz, pt, adpt, q, adq, hs, r_vir, cp, akap, kord_mt, kord_tr, kord_tm, peln, adpeln, &
&te0_2d, adte0_2d, ua, adua, va, adva, omga, adomga, te, adte, fill, reproduce_sum, ak, bk, ks, ze0, adze0, remap_t, hydrostatic, &
&hybrid_z, ktop, ncnst )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.50  **
!******************************************************************
!******************************************************************
!==============================================
! referencing used modules
!==============================================
use fv_my_mpp, only : mpp_update_domains_dummy
use fv_grid_utils_mod, only : adcubed_to_latlon
use adfv_my_mpp, only : admpp_update_domains_dummy
use adfv_fill_mod, only : adfillz

!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: ied
integer, intent(in) :: isd
integer, intent(in) :: jed
integer, intent(in) :: jsd
integer, intent(in) :: km
real, intent(inout) :: addelp(isd:ied,jsd:jed,km)
integer, intent(in) :: ie
integer, intent(in) :: is
integer, intent(in) :: je
integer, intent(in) :: js
real, intent(inout) :: addelz(is:ie,js:je,km)
real, intent(inout) :: adomga(isd:ied,jsd:jed,km)
real, intent(inout) :: adpe(is-1:ie+1,km+1,js-1:je+1)
real, intent(inout) :: adpeln(is:ie,km+1,js:je)
real, intent(inout) :: adpk(is:ie,js:je,km+1)
real, intent(inout) :: adpkz(is:ie,js:je,km)
real, intent(inout) :: adpt(isd:ied,jsd:jed,km)
integer, intent(in) :: ncnst
real, intent(inout) :: adq(isd:ied,jsd:jed,km,ncnst)
real, intent(inout) :: adte(is:ie,js:je,km)
real, intent(inout) :: adte0_2d(is:ie,js:je)
real, intent(inout) :: adu(isd:ied,jsd:jed+1,km)
real, intent(inout) :: adua(isd:ied,jsd:jed,km)
real, intent(inout) :: adv(isd:ied+1,jsd:jed,km)
real, intent(inout) :: adva(isd:ied,jsd:jed,km)
real, intent(inout) :: adw(isd:ied,jsd:jed,km)
real, intent(inout) :: adze0(is:ie,js:je,km+1)
real, intent(in) :: ak(km+1)
real, intent(in) :: akap
real, intent(in) :: bk(km+1)
real, intent(in) :: consv
real, intent(in) :: cp
real, intent(inout) :: delp(isd:ied,jsd:jed,km)
real, intent(inout) :: delz(is:ie,js:je,km)
logical, intent(in) :: fill
real, intent(in) :: hs(isd:ied,jsd:jed)
logical, intent(in) :: hybrid_z
logical, intent(in) :: hydrostatic
integer, intent(in) :: kord_mt
integer, intent(in) :: kord_tm
integer, intent(in) :: kord_tr
integer, intent(in) :: ks
integer, intent(in) :: ktop
integer, intent(in) :: nq
real, intent(inout) :: omga(isd:ied,jsd:jed,km)
real, intent(inout) :: pe(is-1:ie+1,km+1,js-1:je+1)
real, intent(inout) :: peln(is:ie,km+1,js:je)
real, intent(inout) :: pk(is:ie,js:je,km+1)
real, intent(out) :: pkz(is:ie,js:je,km)
real, intent(inout) :: pt(isd:ied,jsd:jed,km)
real, intent(inout) :: q(isd:ied,jsd:jed,km,ncnst)
real, intent(in) :: r_vir
logical, intent(in) :: remap_t
logical, intent(in) :: reproduce_sum
integer, intent(in) :: sphum
real, intent(out) :: te(is:ie,js:je,km)
real, intent(in) :: te0_2d(is:ie,js:je)
real, intent(inout) :: u(isd:ied,jsd:jed+1,km)
real, intent(inout) :: ua(isd:ied,jsd:jed,km)
real, intent(inout) :: v(isd:ied+1,jsd:jed,km)
real, intent(inout) :: va(isd:ied,jsd:jed,km)
real, intent(inout) :: w(isd:ied,jsd:jed,km)
real, intent(inout) :: ze0(is:ie,js:je,km+1)

!==============================================
! declare local variables
!==============================================
real :: addeng(is:ie,km)
real :: addlnp
real :: addp2(is:ie,km)
real :: addtmp
real :: adgz(is:ie)
real :: adhelp_7(isd:ied+1,jsd:jed,km)
real :: adhelp_8(isd:ied,jsd:jed+1,km)
real :: adhelp_9(isd:ied+1,jsd:jed,km)
real :: adhelp_aa(isd:ied,jsd:jed+1,km)
real :: adhelp_ab(is:ie,js:je,km)
real :: adhelp_ac(isd:ied,jsd:jed,km)
real :: adhelp_ad(isd:ied,jsd:jed,km)
real :: adhelp_ae(isd:ied,jsd:jed,km)
real :: adhelp_af(is:ie,js:je,km)
real :: adhelp_ag(is:ie,km)
real :: adpe0(is:ie+1,km+1)
real :: adpe1(is:ie,km+1)
real :: adpe2(is:ie,km+1)
real :: adpe3(is:ie+1,km+1)
real :: adphis(is:ie,km+1)
real :: adpk1(is:ie,km+1)
real :: adpk2(is:ie,km+1)
real :: adpkzi
real :: adpn2(is:ie,km+1)
real :: adq2(is:ie,km)
real :: adte_2d(is:ie,js:je)
real :: adtmp
real :: adtpe
real :: adze1(is:ie,km+1)
real :: adze2(is:ie,km+1)
real :: adzg_sum1
real :: adzg_sum2
real :: adzsum0(is:ie,js:je)
real :: adzsum1(is:ie,js:je)
real :: bkh
real :: cv
real :: delph(lbound(delp,1):ubound(delp,1),lbound(delp,2):ubound(delp,2),lbound(delp,3):ubound(delp,3))
real :: delzh(lbound(delz,1):ubound(delz,1),lbound(delz,2):ubound(delz,2),lbound(delz,3):ubound(delz,3))
real :: deng(is:ie,km)
real :: dlnp
real :: dp2(is:ie,km)
real :: dtmp
real :: gz(is:ie)
real :: help_7(isd:ied+1,jsd:jed,km)
real :: help_8(isd:ied,jsd:jed+1,km)
real :: help_9(isd:ied+1,jsd:jed,km)
real :: help_aa(isd:ied,jsd:jed+1,km)
real :: help_ab(is:ie,js:je,km)
real :: help_ac(isd:ied,jsd:jed,km)
real :: help_ad(isd:ied,jsd:jed,km)
real :: help_ae(isd:ied,jsd:jed,km)
real :: help_af(is:ie,js:je,km)
real :: help_ag(is:ie,km)
integer :: help_h
integer :: help_i
integer :: help_j
integer :: help_k
integer :: help_l
integer :: help_m
integer :: help_n
integer :: help_o
integer :: help_p
integer :: help_q
integer :: help_r
integer :: help_s
integer :: help_t
integer :: help_u
integer :: help_v
integer :: help_w
integer :: i
integer :: iq
integer :: iq2
integer :: j
integer :: k
real :: k1k
integer :: k3
integer :: k4
integer :: k_next
real :: kapag
logical :: km_flag
integer :: kp
integer :: n
real :: pe0(is:ie+1,km+1)
real :: pe1(is:ie,km+1)
real :: pe2(is:ie,km+1)
real :: pe3(is:ie+1,km+1)
real :: peh(is-1:ie+1,km+1,js-1:je+1)
real :: pei(lbound(pe,1):ubound(pe,1),lbound(pe,2):ubound(pe,2),lbound(pe,3):ubound(pe,3))
real :: pelnh(lbound(peln,1):ubound(peln,1),lbound(peln,2):ubound(peln,2),lbound(peln,3):ubound(peln,3))
real :: phis(is:ie,km+1)
real :: pk1(is:ie,km+1)
real :: pk2(is:ie,km+1)
real :: pkh(lbound(pk,1):ubound(pk,1),lbound(pk,2):ubound(pk,2),lbound(pk,3):ubound(pk,3))
real :: pkzi
real :: pn2(is:ie,km+1)
real :: pth(lbound(pt,1):ubound(pt,1),lbound(pt,2):ubound(pt,2),lbound(pt,3):ubound(pt,3))
real :: q2(is:ie,km)
real :: rcp
real :: rg
real :: rgama
real, allocatable :: tape_l2e_a_delp_16h(:,:,:,:)
real, allocatable :: tape_l2e_a_delz_17h(:,:,:,:)
integer :: tape_l2e_a_lagrangian_to_euleri
real, allocatable :: tape_l2e_a_pe1_20h(:,:,:)
real, allocatable :: tape_l2e_a_pe2_21h(:,:,:)
real, allocatable :: tape_l2e_a_peln_4h(:,:,:,:)
real, allocatable :: tape_l2e_a_peln_8h(:,:,:,:)
real, allocatable :: tape_l2e_a_pk_3h(:,:,:,:)
real, allocatable :: tape_l2e_a_pk_7h(:,:,:,:)
real, allocatable :: tape_l2e_a_pkz_36h(:,:,:,:)
real, allocatable :: tape_l2e_a_pkz_39h(:,:,:,:)
real, allocatable :: tape_l2e_a_pt_15h(:,:,:,:)
real, allocatable :: tape_l2e_a_pt_2h(:,:,:,:)
real, allocatable :: tape_l2e_a_pt_35h(:,:,:,:)
real, allocatable :: tape_l2e_a_pt_38h(:,:,:,:)
real, allocatable :: tape_l2e_a_q_37h(:,:,:,:,:)
real, allocatable :: tape_l2e_a_q_40h(:,:,:,:,:)
real, allocatable :: tape_l2e_a_u_24h(:,:,:,:)
real, allocatable :: tape_l2e_a_ua_13h(:,:,:,:)
real, allocatable :: tape_l2e_a_ua_23h(:,:,:,:)
real, allocatable :: tape_l2e_a_v_25h(:,:,:,:)
real, allocatable :: tape_l2e_a_va_14h(:,:,:,:)
real, allocatable :: tape_l2e_b_delp_101h(:,:,:)
real, allocatable :: tape_l2e_b_delp_19h(:,:,:)
real, allocatable :: tape_l2e_b_delz_102h(:,:,:)
real, allocatable :: tape_l2e_b_delz_20h(:,:,:)
real, allocatable :: tape_l2e_b_delz_26h(:,:,:)
real, allocatable :: tape_l2e_b_delz_84h(:,:,:)
real, allocatable :: tape_l2e_b_deng_27h(:,:,:)
real, allocatable :: tape_l2e_b_dp2_106h(:,:,:)
real, allocatable :: tape_l2e_b_dp2_44h(:,:,:)
real, allocatable :: tape_l2e_b_dp2_85h(:,:,:)
integer :: tape_l2e_b_lagrangian_to_euleri
real, allocatable :: tape_l2e_b_pe0_107h(:,:,:)
real, allocatable :: tape_l2e_b_pe0_119h(:,:,:)
real, allocatable :: tape_l2e_b_pe0_125h(:,:,:)
real, allocatable :: tape_l2e_b_pe1_40h(:,:,:)
real, allocatable :: tape_l2e_b_pe1_65h(:,:,:)
real, allocatable :: tape_l2e_b_pe1_68h(:,:,:)
real, allocatable :: tape_l2e_b_pe1_69h(:,:,:)
real, allocatable :: tape_l2e_b_pe1_78h(:,:,:)
real, allocatable :: tape_l2e_b_pe1_81h(:,:,:)
real, allocatable :: tape_l2e_b_pe2_42h(:,:,:)
real, allocatable :: tape_l2e_b_pe2_57h(:,:,:)
real, allocatable :: tape_l2e_b_pe2_70h(:,:,:)
real, allocatable :: tape_l2e_b_pe2_79h(:,:,:)
real, allocatable :: tape_l2e_b_pe2_82h(:,:,:)
real, allocatable :: tape_l2e_b_pe3_109h(:,:,:)
real, allocatable :: tape_l2e_b_pe3_120h(:,:,:)
real, allocatable :: tape_l2e_b_pe3_126h(:,:,:)
real, allocatable :: tape_l2e_b_peln_72h(:,:,:,:)
real, allocatable :: tape_l2e_b_peln_96h(:,:,:)
real, allocatable :: tape_l2e_b_peln_99h(:,:,:)
real, allocatable :: tape_l2e_b_phis_64h(:,:,:)
real, allocatable :: tape_l2e_b_phis_67h(:,:,:)
real, allocatable :: tape_l2e_b_pk1_63h(:,:,:)
real, allocatable :: tape_l2e_b_pk1_75h(:,:,:)
real, allocatable :: tape_l2e_b_pk2_76h(:,:,:)
real, allocatable :: tape_l2e_b_pk2_95h(:,:,:)
real, allocatable :: tape_l2e_b_pk2_98h(:,:,:)
real, allocatable :: tape_l2e_b_pn2_74h(:,:,:)
real, allocatable :: tape_l2e_b_pt_103h(:,:,:)
real, allocatable :: tape_l2e_b_pt_62h(:,:,:)
real, allocatable :: tape_l2e_b_q_41h(:,:,:,:,:)
real, allocatable :: tape_l2e_b_ze1_21h(:,:,:)
real, allocatable :: tape_l2e_b_ze2_22h(:,:,:)
real, allocatable :: tape_l2e_c_delp_12h(:,:,:)
real, allocatable :: tape_l2e_c_delp_20h(:,:,:)
real, allocatable :: tape_l2e_c_delp_31h(:,:,:)
real, allocatable :: tape_l2e_c_delp_37h(:,:,:)
real, allocatable :: tape_l2e_c_delp_46h(:,:)
real, allocatable :: tape_l2e_c_delp_49h(:,:,:)
real, allocatable :: tape_l2e_c_delp_63h(:,:,:)
real, allocatable :: tape_l2e_c_delp_9h(:,:)
real, allocatable :: tape_l2e_c_gz_60h(:,:)
integer :: tape_l2e_c_lagrangian_to_euleri
real, allocatable :: tape_l2e_c_pe0_6h(:,:,:)
real, allocatable :: tape_l2e_c_pe3_7h(:,:,:)
real, allocatable :: tape_l2e_c_pe_17h(:,:,:)
real, allocatable :: tape_l2e_c_pe_18h(:,:)
real, allocatable :: tape_l2e_c_pe_26h(:,:)
real, allocatable :: tape_l2e_c_pe_27h(:,:)
real, allocatable :: tape_l2e_c_pe_62h(:,:,:)
real, allocatable :: tape_l2e_c_peln_15h(:,:,:)
real, allocatable :: tape_l2e_c_peln_61h(:,:,:)
real, allocatable :: tape_l2e_c_phis_40h(:,:,:)
real, allocatable :: tape_l2e_c_pk_25h(:,:,:)
real, allocatable :: tape_l2e_c_pkz_29h(:,:,:)
real, allocatable :: tape_l2e_c_pkz_39h(:,:,:)
real, allocatable :: tape_l2e_c_pkz_45h(:,:)
real, allocatable :: tape_l2e_c_pkz_48h(:,:,:)
real, allocatable :: tape_l2e_c_pkz_65h(:,:,:)
real, allocatable :: tape_l2e_c_pt_14h(:,:,:)
real, allocatable :: tape_l2e_c_pt_21h(:,:,:)
real, allocatable :: tape_l2e_c_pt_24h(:,:,:)
real, allocatable :: tape_l2e_c_pt_30h(:,:,:)
real, allocatable :: tape_l2e_c_pt_38h(:,:,:)
real, allocatable :: tape_l2e_c_q_64h(:,:,:)
real, allocatable :: tape_l2e_c_te_11h(:,:,:)
real, allocatable :: tape_l2e_c_te_57h(:,:,:)
real, allocatable :: tape_l2e_c_te_8h(:,:)
real, allocatable :: tape_l2e_c_ua_22h(:,:,:)
real, allocatable :: tape_l2e_c_ua_33h(:,:,:)
real, allocatable :: tape_l2e_c_ua_41h(:,:,:)
real, allocatable :: tape_l2e_c_ua_58h(:,:,:)
real, allocatable :: tape_l2e_c_va_23h(:,:,:)
real, allocatable :: tape_l2e_c_va_34h(:,:,:)
real, allocatable :: tape_l2e_c_va_42h(:,:,:)
real, allocatable :: tape_l2e_c_va_59h(:,:,:)
real, allocatable :: tape_l2e_c_w_43h(:,:,:)
integer :: tape_mapz_kp_4h(1)
real :: te_2d(is:ie,js:je)
logical :: te_map
real :: tmp
real :: tpe
real :: ze0h(lbound(ze0,1):ubound(ze0,1),lbound(ze0,2):ubound(ze0,2),lbound(ze0,3):ubound(ze0,3))
real :: ze1(is:ie,km+1)
real :: ze2(is:ie,km+1)
real :: zg_sum1
real :: zg_sum2
real :: zsum0(is:ie,js:je)
real :: zsum1(is:ie,js:je)

!----------------------------------------------
! SAVE REQUIRED INPUT VARIABLES
!----------------------------------------------
ze0h(:,:,:) = ze0(:,:,:)
pth(:,:,:) = pt(:,:,:)
pkh(:,:,:) = pk(:,:,:)
pelnh(:,:,:) = peln(:,:,:)
pei(:,:,:) = pe(:,:,:)
delzh(:,:,:) = delz(:,:,:)
delph(:,:,:) = delp(:,:,:)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
addeng(:,:) = 0.
addlnp = 0.
addp2(:,:) = 0.
addtmp = 0.
adgz(:) = 0.
adpe0(:,:) = 0.
adpe1(:,:) = 0.
adpe2(:,:) = 0.
adpe3(:,:) = 0.
adphis(:,:) = 0.
adpk1(:,:) = 0.
adpk2(:,:) = 0.
adpn2(:,:) = 0.
adq2(:,:) = 0.
adte_2d(:,:) = 0.
adtmp = 0.
adtpe = 0.
adze1(:,:) = 0.
adze2(:,:) = 0.
adzg_sum1 = 0.
adzg_sum2 = 0.
adzsum0(:,:) = 0.
adzsum1(:,:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
k1k = akap/(1.-akap)
kapag = -(akap/grav)
rg = akap*cp
cv = cp-rg
rgama = cv/cp
rcp = 1./cp
!----------------------------------------------
! OPEN TAPE tape_l2e_a
!----------------------------------------------
tape_l2e_a_lagrangian_to_euleri = 1

!----------------------------------------------
! OPEN TAPE tape_l2e_b
!----------------------------------------------
tape_l2e_b_lagrangian_to_euleri = je+1-js+1

!----------------------------------------------
! OPEN TAPE tape_l2e_c
!----------------------------------------------
tape_l2e_c_lagrangian_to_euleri = je-js+1

!----------------------------------------------
! TAPE COMPUTATIONS
!----------------------------------------------
if (kord_tm .lt. 0) then
  te_map =  .false. 
  if (remap_t) then
    if ( .not. allocated(tape_l2e_a_pt_2h)) then
      allocate( tape_l2e_a_pt_2h(isd:ied,jsd:jed,1:km,tape_l2e_a_lagrangian_to_euleri) )
    endif
    tape_l2e_a_pt_2h(:,:,:,1) = pt
    if ( .not. allocated(tape_l2e_a_pk_3h)) then
      allocate( tape_l2e_a_pk_3h(is:ie,js:je,1:km+1,tape_l2e_a_lagrangian_to_euleri) )
    endif
    tape_l2e_a_pk_3h(:,:,:,1) = pk
    if ( .not. allocated(tape_l2e_a_peln_4h)) then
      allocate( tape_l2e_a_peln_4h(is:ie,1:km+1,js:je,tape_l2e_a_lagrangian_to_euleri) )
    endif
    tape_l2e_a_peln_4h(:,:,:,1) = peln
    do k = 1, km
      do j = js, je
        do i = is, ie
          pt(i,j,k) = pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))/(rg*(peln(i,k+1,j)-peln(i,k,j)))
        end do
      end do
    end do
  endif
else
  te_map =  .true. 
  if ( .not. allocated(tape_l2e_a_pk_7h)) then
    allocate( tape_l2e_a_pk_7h(is:ie,js:je,1:km+1,tape_l2e_a_lagrangian_to_euleri) )
  endif
  tape_l2e_a_pk_7h(:,:,:,1) = pk
  if ( .not. allocated(tape_l2e_a_peln_8h)) then
    allocate( tape_l2e_a_peln_8h(is:ie,1:km+1,js:je,tape_l2e_a_lagrangian_to_euleri) )
  endif
  tape_l2e_a_peln_8h(:,:,:,1) = peln
  call pkez( km,is,ie,js,je,pe,pk,akap,peln,pkz )
  call cubed_to_latlon( u,v,ua,va,dx,dy,rdxa,rdya,km,1 )
  if ( .not. allocated(tape_l2e_a_ua_13h)) then
    allocate( tape_l2e_a_ua_13h(isd:ied,jsd:jed,1:km,tape_l2e_a_lagrangian_to_euleri) )
  endif
  tape_l2e_a_ua_13h(:,:,:,1) = ua
  if ( .not. allocated(tape_l2e_a_va_14h)) then
    allocate( tape_l2e_a_va_14h(isd:ied,jsd:jed,1:km,tape_l2e_a_lagrangian_to_euleri) )
  endif
  tape_l2e_a_va_14h(:,:,:,1) = va
  if ( .not. allocated(tape_l2e_a_pt_15h)) then
    allocate( tape_l2e_a_pt_15h(isd:ied,jsd:jed,1:km,tape_l2e_a_lagrangian_to_euleri) )
  endif
  tape_l2e_a_pt_15h(:,:,:,1) = pt
  do k = 1, km
    do j = js, je
      do i = is, ie
        te(i,j,k) = 0.5*(ua(i,j,k)**2+va(i,j,k)**2)+pt(i,j,k)*pkz(i,j,k)
      end do
    end do
  end do
endif
if (( .not. hydrostatic) .and. ( .not. hybrid_z)) then
  if ( .not. allocated(tape_l2e_a_delp_16h)) then
    allocate( tape_l2e_a_delp_16h(isd:ied,jsd:jed,1:km,tape_l2e_a_lagrangian_to_euleri) )
  endif
  tape_l2e_a_delp_16h(:,:,:,1) = delp
  if ( .not. allocated(tape_l2e_a_delz_17h)) then
    allocate( tape_l2e_a_delz_17h(is:ie,js:je,1:km,tape_l2e_a_lagrangian_to_euleri) )
  endif
  tape_l2e_a_delz_17h(:,:,:,1) = delz
  do k = 1, km
    do j = js, je
      do i = is, ie
        delz(i,j,k) = -(delz(i,j,k)/delp(i,j,k))
      end do
    end do
  end do
endif
do j = js, je+1
  do k = 1, km+1
    do i = is, ie
      pe1(i,k) = pe(i,k,j)
    end do
  end do
  do i = is, ie
    pe2(i,1) = ptop
    pe2(i,km+1) = pe(i,km+1,j)
  end do
  if (j .lt. je+1) then
    if (hybrid_z) then
      do i = is, ie
        ze1(i,km+1) = ze0(i,j,km+1)
      end do
      do k = km, 1, -1
        do i = is, ie
          ze1(i,k) = ze1(i,k+1)-delz(i,j,k)
        end do
      end do
      do i = is, ie
        ze2(i,1) = ze1(i,1)
        ze0(i,j,1) = ze1(i,1)
      end do
      do k = 2, km+1
        do i = is, ie
          ze2(i,k) = ze0(i,j,k)
        end do
      end do
      if ( .not. allocated(tape_l2e_b_delp_19h)) then
        allocate( tape_l2e_b_delp_19h(isd:ied,1:km,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_delp_19h(:,:,j-js+1) = delp(:,j,:)
      if ( .not. allocated(tape_l2e_b_delz_20h)) then
        allocate( tape_l2e_b_delz_20h(is:ie,1:km,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_delz_20h(:,:,j-js+1) = delz(:,j,:)
      do k = 1, km
        do i = is, ie
          deng(i,k) = -(delp(i,j,k)/delz(i,j,k))
        end do
      end do
      if ( .not. allocated(tape_l2e_b_ze1_21h)) then
        allocate( tape_l2e_b_ze1_21h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_ze1_21h(:,:,j-js+1) = ze1
      if ( .not. allocated(tape_l2e_b_ze2_22h)) then
        allocate( tape_l2e_b_ze2_22h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_ze2_22h(:,:,j-js+1) = ze2
      help_h = abs(kord_tm)
      call remap_z( km,ze1,deng,km,ze2,deng,is,ie,help_h )
      do k = 1, km
        do i = is, ie
          delz(i,j,k) = ze2(i,k+1)-ze2(i,k)
        end do
      end do
      if ( .not. allocated(tape_l2e_b_delz_26h)) then
        allocate( tape_l2e_b_delz_26h(is:ie,1:km,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_delz_26h(:,:,j-js+1) = delz(:,j,:)
      if ( .not. allocated(tape_l2e_b_deng_27h)) then
        allocate( tape_l2e_b_deng_27h(is:ie,1:km,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_deng_27h(:,:,j-js+1) = deng
      do k = 1, km-1
        do i = is, ie
          dp2(i,k) = -(delz(i,j,k)*deng(i,k))
          pe2(i,k+1) = pe2(i,k)+dp2(i,k)
        end do
      end do
      do i = is, ie
        dp2(i,km) = pe2(i,km+1)-pe2(i,km)
      end do
    else
      do k = 2, ks+1
        do i = is, ie
          pe2(i,k) = ak(k)
        end do
      end do
      do k = ks+2, km
        do i = is, ie
          pe2(i,k) = ak(k)+bk(k)*pe(i,km+1,j)
        end do
      end do
      do k = 1, km
        do i = is, ie
          dp2(i,k) = pe2(i,k+1)-pe2(i,k)
        end do
      end do
    endif
    do k = 1, km
      do i = is, ie
        delp(i,j,k) = dp2(i,k)
      end do
    end do
    if (nq .ne. 0) then
      if ( .not. allocated(tape_l2e_b_pe1_40h)) then
        allocate( tape_l2e_b_pe1_40h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pe1_40h(:,:,j-js+1) = pe1
      if ( .not. allocated(tape_l2e_b_q_41h)) then
        allocate( tape_l2e_b_q_41h(isd:ied,jsd:jed,1:km,1:ncnst,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_q_41h(:,:,:,:,j-js+1) = q
      if ( .not. allocated(tape_l2e_b_pe2_42h)) then
        allocate( tape_l2e_b_pe2_42h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pe2_42h(:,:,j-js+1) = pe2
      if ( .not. allocated(tape_l2e_b_dp2_44h)) then
        allocate( tape_l2e_b_dp2_44h(is:ie,1:km,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_dp2_44h(:,:,j-js+1) = dp2
      do iq = 1, nq
        call map1_q2( km,pe1,q(isd,jsd,1,iq),km,pe2,q2,dp2,is,ie,0,kord_tr,j,isd,ied,jsd,jed )
        if (fill) then
          help_i = ie-is+1
          call fillz( help_i,km,1,q2,dp2 )
        endif
        do k = 1, km
          do i = is, ie
            q(i,j,k,iq) = q2(i,k)
          end do
        end do
      end do
    endif
    do k = 1, km+1
      do i = is, ie
        pk1(i,k) = pk(i,j,k)
      end do
    end do
    do i = is, ie
      pn2(i,1) = peln(i,1,j)
      pn2(i,km+1) = peln(i,km+1,j)
      pk2(i,1) = pk1(i,1)
      pk2(i,km+1) = pk1(i,km+1)
    end do
    if ( .not. allocated(tape_l2e_b_pe2_57h)) then
      allocate( tape_l2e_b_pe2_57h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
    endif
    tape_l2e_b_pe2_57h(:,:,j-js+1) = pe2
    do k = 2, km
      do i = is, ie
        pn2(i,k) = log(pe2(i,k))
        pk2(i,k) = exp(akap*pn2(i,k))
      end do
    end do
    if (te_map) then
      do i = is, ie
        phis(i,km+1) = hs(i,j)
      end do
      if ( .not. allocated(tape_l2e_b_pt_62h)) then
        allocate( tape_l2e_b_pt_62h(isd:ied,1:km,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pt_62h(:,:,j-js+1) = pt(:,j,:)
      if ( .not. allocated(tape_l2e_b_pk1_63h)) then
        allocate( tape_l2e_b_pk1_63h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pk1_63h(:,:,j-js+1) = pk1
      do k = km, 1, -1
        do i = is, ie
          phis(i,k) = phis(i,k+1)+pt(i,j,k)*(pk1(i,k+1)-pk1(i,k))
        end do
      end do
      if ( .not. allocated(tape_l2e_b_phis_64h)) then
        allocate( tape_l2e_b_phis_64h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_phis_64h(:,:,j-js+1) = phis
      if ( .not. allocated(tape_l2e_b_pe1_65h)) then
        allocate( tape_l2e_b_pe1_65h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pe1_65h(:,:,j-js+1) = pe1
      do k = 1, km+1
        do i = is, ie
          phis(i,k) = phis(i,k)*pe1(i,k)
        end do
      end do
      if ( .not. allocated(tape_l2e_b_phis_67h)) then
        allocate( tape_l2e_b_phis_67h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_phis_67h(:,:,j-js+1) = phis
      if ( .not. allocated(tape_l2e_b_pe1_68h)) then
        allocate( tape_l2e_b_pe1_68h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pe1_68h(:,:,j-js+1) = pe1
      do k = 1, km
        do i = is, ie
          te(i,j,k) = te(i,j,k)+(phis(i,k+1)-phis(i,k))/(pe1(i,k+1)-pe1(i,k))
        end do
      end do
      if ( .not. allocated(tape_l2e_b_pe1_69h)) then
        allocate( tape_l2e_b_pe1_69h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pe1_69h(:,:,j-js+1) = pe1
      if ( .not. allocated(tape_l2e_b_pe2_70h)) then
        allocate( tape_l2e_b_pe2_70h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pe2_70h(:,:,j-js+1) = pe2
      call map1_ppm( km,pe1,te,km,pe2,te,is,ie,j,is,ie,js,je,1,kord_tm )
    else
      if (remap_t) then
        if ( .not. allocated(tape_l2e_b_peln_72h)) then
          allocate( tape_l2e_b_peln_72h(is:ie,1:km+1,js:je,tape_l2e_b_lagrangian_to_euleri) )
        endif
        tape_l2e_b_peln_72h(:,:,:,j-js+1) = peln
        if ( .not. allocated(tape_l2e_b_pn2_74h)) then
          allocate( tape_l2e_b_pn2_74h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
        endif
        tape_l2e_b_pn2_74h(:,:,j-js+1) = pn2
        help_j = abs(kord_tm)
        call map1_ppm( km,peln(is,1,j),pt,km,pn2,pt,is,ie,j,isd,ied,jsd,jed,1,help_j )
      else
        if ( .not. allocated(tape_l2e_b_pk1_75h)) then
          allocate( tape_l2e_b_pk1_75h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
        endif
        tape_l2e_b_pk1_75h(:,:,j-js+1) = pk1
        if ( .not. allocated(tape_l2e_b_pk2_76h)) then
          allocate( tape_l2e_b_pk2_76h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
        endif
        tape_l2e_b_pk2_76h(:,:,j-js+1) = pk2
        help_k = abs(kord_tm)
        call map1_ppm( km,pk1,pt,km,pk2,pt,is,ie,j,isd,ied,jsd,jed,1,help_k )
      endif
    endif
    if ( .not. hydrostatic) then
      if ( .not. allocated(tape_l2e_b_pe1_78h)) then
        allocate( tape_l2e_b_pe1_78h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pe1_78h(:,:,j-js+1) = pe1
      if ( .not. allocated(tape_l2e_b_pe2_79h)) then
        allocate( tape_l2e_b_pe2_79h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pe2_79h(:,:,j-js+1) = pe2
      help_l = -1
      call map1_ppm( km,pe1,w,km,pe2,w,is,ie,j,isd,ied,jsd,jed,help_l,kord_mt )
      if ( .not. hybrid_z) then
        if ( .not. allocated(tape_l2e_b_pe1_81h)) then
          allocate( tape_l2e_b_pe1_81h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
        endif
        tape_l2e_b_pe1_81h(:,:,j-js+1) = pe1
        if ( .not. allocated(tape_l2e_b_pe2_82h)) then
          allocate( tape_l2e_b_pe2_82h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
        endif
        tape_l2e_b_pe2_82h(:,:,j-js+1) = pe2
        help_m = abs(kord_tm)
        call map1_ppm( km,pe1,delz,km,pe2,delz,is,ie,j,is,ie,js,je,1,help_m )
        if ( .not. allocated(tape_l2e_b_delz_84h)) then
          allocate( tape_l2e_b_delz_84h(is:ie,1:km,tape_l2e_b_lagrangian_to_euleri) )
        endif
        tape_l2e_b_delz_84h(:,:,j-js+1) = delz(:,j,:)
        if ( .not. allocated(tape_l2e_b_dp2_85h)) then
          allocate( tape_l2e_b_dp2_85h(is:ie,1:km,tape_l2e_b_lagrangian_to_euleri) )
        endif
        tape_l2e_b_dp2_85h(:,:,j-js+1) = dp2
        do k = 1, km
          do i = is, ie
            delz(i,j,k) = -(delz(i,j,k)*dp2(i,k))
          end do
        end do
      endif
    endif
    do k = 2, km
      do i = is, ie
        pk(i,j,k) = pk2(i,k)
      end do
    end do
    do i = is, ie
      pe3(i,1) = 0.
    end do
    do k = 2, km+1
      do i = is, ie
        pe3(i,k) = omga(i,j,k-1)
      end do
    end do
    do k = 1, km+1
      do i = is, ie
        pe0(i,k) = peln(i,k,j)
        peln(i,k,j) = pn2(i,k)
      end do
    end do
    if (hydrostatic) then
      if ( .not. allocated(tape_l2e_b_pk2_95h)) then
        allocate( tape_l2e_b_pk2_95h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pk2_95h(:,:,j-js+1) = pk2
      if ( .not. allocated(tape_l2e_b_peln_96h)) then
        allocate( tape_l2e_b_peln_96h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_peln_96h(:,:,j-js+1) = peln(:,:,j)
      do k = 1, km
        do i = is, ie
          pkz(i,j,k) = (pk2(i,k+1)-pk2(i,k))/(akap*(peln(i,k+1,j)-peln(i,k,j)))
        end do
      end do
    else
      if (ktop .gt. 1) then
        if ( .not. allocated(tape_l2e_b_pk2_98h)) then
          allocate( tape_l2e_b_pk2_98h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
        endif
        tape_l2e_b_pk2_98h(:,:,j-js+1) = pk2
        if ( .not. allocated(tape_l2e_b_peln_99h)) then
          allocate( tape_l2e_b_peln_99h(is:ie,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
        endif
        tape_l2e_b_peln_99h(:,:,j-js+1) = peln(:,:,j)
        do k = 1, ktop-1
          do i = is, ie
            pkz(i,j,k) = (pk2(i,k+1)-pk2(i,k))/(akap*(peln(i,k+1,j)-peln(i,k,j)))
          end do
        end do
      endif
      if ( .not. allocated(tape_l2e_b_delp_101h)) then
        allocate( tape_l2e_b_delp_101h(isd:ied,1:km,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_delp_101h(:,:,j-js+1) = delp(:,j,:)
      if ( .not. allocated(tape_l2e_b_delz_102h)) then
        allocate( tape_l2e_b_delz_102h(is:ie,1:km,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_delz_102h(:,:,j-js+1) = delz(:,j,:)
      if ( .not. allocated(tape_l2e_b_pt_103h)) then
        allocate( tape_l2e_b_pt_103h(isd:ied,1:km,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pt_103h(:,:,j-js+1) = pt(:,j,:)
      do k = ktop, km
        do i = is, ie
          pkz(i,j,k) = exp(k1k*log(kapag*delp(i,j,k)/delz(i,j,k)*pt(i,j,k)))
        end do
      end do
    endif
    do k = 1, km
      do i = is, ie
        dp2(i,k) = 0.5*(peln(i,k,j)+peln(i,k+1,j))
      end do
    end do
    if ( .not. allocated(tape_l2e_b_dp2_106h)) then
      allocate( tape_l2e_b_dp2_106h(is:ie,1:km,tape_l2e_b_lagrangian_to_euleri) )
    endif
    tape_l2e_b_dp2_106h(:,:,j-js+1) = dp2
    if ( .not. allocated(tape_l2e_b_pe0_107h)) then
      allocate( tape_l2e_b_pe0_107h(is:ie+1,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
    endif
    tape_l2e_b_pe0_107h(:,:,j-js+1) = pe0
    if ( .not. allocated(tape_l2e_b_pe3_109h)) then
      allocate( tape_l2e_b_pe3_109h(is:ie+1,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
    endif
    tape_l2e_b_pe3_109h(:,:,j-js+1) = pe3
    do i = is, ie
      k_next = 1
      do n = 1, km
        kp = k_next
        km_flag =  .false. 
        tape_mapz_kp_4h(1) = kp
        do k = kp, km
          if (km_flag .eqv.  .false. ) then
            if (dp2(i,n) .le. pe0(i,k+1) .and. dp2(i,n) .ge. pe0(i,k)) then
              omga(i,j,n) = pe3(i,k)+(pe3(i,k+1)-pe3(i,k))*(dp2(i,n)-pe0(i,k))/(pe0(i,k+1)-pe0(i,k))
              k_next = k
              km_flag =  .true. 
            endif
          endif
        end do
      end do
    end do
  endif
  if ( .not. hybrid_z) then
    do i = is, ie+1
      pe0(i,1) = pe(i,1,j)
    end do
    do k = 2, km+1
      do i = is, ie
        pe0(i,k) = 0.5*(pe(i,k,j-1)+pe1(i,k))
      end do
    end do
    do k = 1, ks+1
      do i = is, ie+1
        pe3(i,k) = ak(k)
      end do
    end do
    do k = ks+2, km+1
      bkh = 0.5*bk(k)
      do i = is, ie
        pe3(i,k) = ak(k)+bkh*(pe(i,km+1,j-1)+pe1(i,km+1))
      end do
    end do
    if ( .not. allocated(tape_l2e_b_pe0_119h)) then
      allocate( tape_l2e_b_pe0_119h(is:ie+1,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
    endif
    tape_l2e_b_pe0_119h(:,:,j-js+1) = pe0
    if ( .not. allocated(tape_l2e_b_pe3_120h)) then
      allocate( tape_l2e_b_pe3_120h(is:ie+1,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
    endif
    tape_l2e_b_pe3_120h(:,:,j-js+1) = pe3
    help_n = jed+1
    help_o = -1
    call map1_ppm( km,pe0(is:ie,:),u,km,pe3(is:ie,:),u,is,ie,j,isd,ied,jsd,help_n,help_o,kord_mt )
    if (j .lt. je+1) then
      do k = 2, km+1
        do i = is, ie+1
          pe0(i,k) = 0.5*(pe(i-1,k,j)+pe(i,k,j))
        end do
      end do
      do k = ks+2, km+1
        bkh = 0.5*bk(k)
        do i = is, ie+1
          pe3(i,k) = ak(k)+bkh*(pe(i-1,km+1,j)+pe(i,km+1,j))
        end do
      end do
      if ( .not. allocated(tape_l2e_b_pe0_125h)) then
        allocate( tape_l2e_b_pe0_125h(is:ie+1,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pe0_125h(:,:,j-js+1) = pe0
      if ( .not. allocated(tape_l2e_b_pe3_126h)) then
        allocate( tape_l2e_b_pe3_126h(is:ie+1,1:km+1,tape_l2e_b_lagrangian_to_euleri) )
      endif
      tape_l2e_b_pe3_126h(:,:,j-js+1) = pe3
      help_p = ie+1
      help_q = ied+1
      help_r = -1
      call map1_ppm( km,pe0,v,km,pe3,v,is,help_p,j,isd,help_q,jsd,jed,help_r,kord_mt )
    endif
  endif
  do k = 1, km
    do i = is, ie
      ua(i,j,k) = pe2(i,k+1)
    end do
  end do
end do
if (hybrid_z) then
  call mpp_update_domains_dummy( ua,is,ie,js,je,isd,ied,jsd,jed,km )
  do j = js, je+1
    do i = is, ie
      pe1(i,1) = ptop
      pe2(i,1) = ptop
    end do
    do k = 2, km+1
      do i = is, ie
        pe1(i,k) = 0.5*(pe(i,k,j-1)+pe(i,k,j))
        pe2(i,k) = 0.5*(ua(i,j-1,k-1)+ua(i,j,k-1))
      end do
    end do
    if ( .not. allocated(tape_l2e_a_pe1_20h)) then
      allocate( tape_l2e_a_pe1_20h(is:ie,1:km+1,tape_l2e_a_lagrangian_to_euleri) )
    endif
    tape_l2e_a_pe1_20h(:,:,j-js+1) = pe1
    if ( .not. allocated(tape_l2e_a_pe2_21h)) then
      allocate( tape_l2e_a_pe2_21h(is:ie,1:km+1,tape_l2e_a_lagrangian_to_euleri) )
    endif
    tape_l2e_a_pe2_21h(:,:,j-js+1) = pe2
    help_s = jed+1
    help_t = -1
    call map1_ppm( km,pe1,u,km,pe2,u,is,ie,j,isd,ied,jsd,help_s,help_t,kord_mt )
  end do
  do j = js, je
    do i = is, ie+1
      pe0(i,1) = ptop
      pe3(i,1) = ptop
    end do
    do k = 2, km+1
      do i = is, ie+1
        pe0(i,k) = 0.5*(pe(i-1,k,j)+pe(i,k,j))
        pe3(i,k) = 0.5*(ua(i-1,j,k-1)+ua(i,j,k-1))
      end do
    end do
    if ( .not. allocated(tape_l2e_c_pe0_6h)) then
      allocate( tape_l2e_c_pe0_6h(is:ie+1,1:km+1,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_pe0_6h(:,:,j-js+1) = pe0
    if ( .not. allocated(tape_l2e_c_pe3_7h)) then
      allocate( tape_l2e_c_pe3_7h(is:ie+1,1:km+1,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_pe3_7h(:,:,j-js+1) = pe3
    help_u = ie+1
    help_v = ied+1
    help_w = -1
    call map1_ppm( km,pe0,v,km,pe3,v,is,help_u,j,isd,help_v,jsd,jed,help_w,kord_mt )
  end do
endif
if ( .not. allocated(tape_l2e_a_ua_23h)) then
  allocate( tape_l2e_a_ua_23h(isd:ied,jsd:jed,1:km,tape_l2e_a_lagrangian_to_euleri) )
endif
tape_l2e_a_ua_23h(:,:,:,1) = ua
do k = 2, km
  do j = js, je
    do i = is, ie
      pe(i,k,j) = ua(i,j,k-1)
    end do
  end do
end do
if ( .not. allocated(tape_l2e_a_u_24h)) then
  allocate( tape_l2e_a_u_24h(isd:ied,jsd:jed+1,1:km,tape_l2e_a_lagrangian_to_euleri) )
endif
tape_l2e_a_u_24h(:,:,:,1) = u
if ( .not. allocated(tape_l2e_a_v_25h)) then
  allocate( tape_l2e_a_v_25h(isd:ied+1,jsd:jed,1:km,tape_l2e_a_lagrangian_to_euleri) )
endif
tape_l2e_a_v_25h(:,:,:,1) = v
call cubed_to_latlon( u,v,ua,va,dx,dy,rdxa,rdya,km,1 )
if (consv .gt. 0.) then
  if (te_map) then
    do j = js, je
      if ( .not. allocated(tape_l2e_c_te_8h)) then
        allocate( tape_l2e_c_te_8h(is:ie,tape_l2e_c_lagrangian_to_euleri) )
      endif
      tape_l2e_c_te_8h(:,j-js+1) = te(:,j,1)
      if ( .not. allocated(tape_l2e_c_delp_9h)) then
        allocate( tape_l2e_c_delp_9h(isd:ied,tape_l2e_c_lagrangian_to_euleri) )
      endif
      tape_l2e_c_delp_9h(:,j-js+1) = delp(:,j,1)
      do i = is, ie
        te_2d(i,j) = te(i,j,1)*delp(i,j,1)
      end do
      if ( .not. allocated(tape_l2e_c_te_11h)) then
        allocate( tape_l2e_c_te_11h(is:ie,1:km,tape_l2e_c_lagrangian_to_euleri) )
      endif
      tape_l2e_c_te_11h(:,:,j-js+1) = te(:,j,:)
      if ( .not. allocated(tape_l2e_c_delp_12h)) then
        allocate( tape_l2e_c_delp_12h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
      endif
      tape_l2e_c_delp_12h(:,:,j-js+1) = delp(:,j,:)
    end do
  else
    do j = js, je-1
      if (remap_t) then
        if ( .not. allocated(tape_l2e_c_pt_14h)) then
          allocate( tape_l2e_c_pt_14h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_pt_14h(:,:,j-js+1) = pt(:,j,:)
        if ( .not. allocated(tape_l2e_c_peln_15h)) then
          allocate( tape_l2e_c_peln_15h(is:ie,1:km+1,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_peln_15h(:,:,j-js+1) = peln(:,:,j)
        do i = is, ie
          gz(i) = hs(i,j)
          do k = 1, km
            gz(i) = gz(i)+rg*pt(i,j,k)*(peln(i,k+1,j)-peln(i,k,j))
          end do
        end do
        if ( .not. allocated(tape_l2e_c_pe_17h)) then
          allocate( tape_l2e_c_pe_17h(is-1:ie+1,1:km+1,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_pe_17h(:,:,j-js+1) = pe(:,:,j)
        if ( .not. allocated(tape_l2e_c_pe_18h)) then
          allocate( tape_l2e_c_pe_18h(is-1:ie+1,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_pe_18h(:,j-js+1) = pe(:,1,j)
        do i = is, ie
          te_2d(i,j) = pe(i,km+1,j)*hs(i,j)-pe(i,1,j)*gz(i)
        end do
        if ( .not. allocated(tape_l2e_c_delp_20h)) then
          allocate( tape_l2e_c_delp_20h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_delp_20h(:,:,j-js+1) = delp(:,j,:)
        if ( .not. allocated(tape_l2e_c_pt_21h)) then
          allocate( tape_l2e_c_pt_21h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_pt_21h(:,:,j-js+1) = pt(:,j,:)
        if ( .not. allocated(tape_l2e_c_ua_22h)) then
          allocate( tape_l2e_c_ua_22h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_ua_22h(:,:,j-js+1) = ua(:,j,:)
        if ( .not. allocated(tape_l2e_c_va_23h)) then
          allocate( tape_l2e_c_va_23h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_va_23h(:,:,j-js+1) = va(:,j,:)
        do k = 1, km
          do i = is, ie
            te_2d(i,j) = te_2d(i,j)+delp(i,j,k)*(cp*pt(i,j,k)+0.5*(ua(i,j,k)**2+va(i,j,k)**2))
          end do
        end do
      else
        if (hydrostatic) then
          if ( .not. allocated(tape_l2e_c_pt_24h)) then
            allocate( tape_l2e_c_pt_24h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_pt_24h(:,:,j-js+1) = pt(:,j,:)
          if ( .not. allocated(tape_l2e_c_pk_25h)) then
            allocate( tape_l2e_c_pk_25h(is:ie,1:km+1,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_pk_25h(:,:,j-js+1) = pk(:,j,:)
          do i = is, ie
            gz(i) = hs(i,j)
            do k = 1, km
              gz(i) = gz(i)+pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))
            end do
          end do
          if ( .not. allocated(tape_l2e_c_pe_26h)) then
            allocate( tape_l2e_c_pe_26h(is-1:ie+1,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_pe_26h(:,j-js+1) = pe(:,km+1,j)
          if ( .not. allocated(tape_l2e_c_pe_27h)) then
            allocate( tape_l2e_c_pe_27h(is-1:ie+1,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_pe_27h(:,j-js+1) = pe(:,1,j)
          do i = is, ie
            te_2d(i,j) = pe(i,km+1,j)*hs(i,j)-pe(i,1,j)*gz(i)
          end do
          if ( .not. allocated(tape_l2e_c_pkz_29h)) then
            allocate( tape_l2e_c_pkz_29h(is:ie,1:km,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_pkz_29h(:,:,j-js+1) = pkz(:,j,:)
          if ( .not. allocated(tape_l2e_c_pt_30h)) then
            allocate( tape_l2e_c_pt_30h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_pt_30h(:,:,j-js+1) = pt(:,j,:)
          if ( .not. allocated(tape_l2e_c_delp_31h)) then
            allocate( tape_l2e_c_delp_31h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_delp_31h(:,:,j-js+1) = delp(:,j,:)
          if ( .not. allocated(tape_l2e_c_ua_33h)) then
            allocate( tape_l2e_c_ua_33h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_ua_33h(:,:,j-js+1) = ua(:,j,:)
          if ( .not. allocated(tape_l2e_c_va_34h)) then
            allocate( tape_l2e_c_va_34h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_va_34h(:,:,j-js+1) = va(:,j,:)
          do k = 1, km
            do i = is, ie
              te_2d(i,j) = te_2d(i,j)+delp(i,j,k)*(pt(i,j,k)*pkz(i,j,k)+0.5*(ua(i,j,k)**2+va(i,j,k)**2))
            end do
          end do
        else
          do i = is, ie
            phis(i,km+1) = hs(i,j)
            do k = km, 1, -1
              phis(i,k) = phis(i,k+1)-grav*delz(i,j,k)
            end do
          end do
          do i = is, ie
            te_2d(i,j) = 0.
          end do
          if ( .not. allocated(tape_l2e_c_delp_37h)) then
            allocate( tape_l2e_c_delp_37h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_delp_37h(:,:,j-js+1) = delp(:,j,:)
          if ( .not. allocated(tape_l2e_c_pt_38h)) then
            allocate( tape_l2e_c_pt_38h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_pt_38h(:,:,j-js+1) = pt(:,j,:)
          if ( .not. allocated(tape_l2e_c_pkz_39h)) then
            allocate( tape_l2e_c_pkz_39h(is:ie,1:km,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_pkz_39h(:,:,j-js+1) = pkz(:,j,:)
          if ( .not. allocated(tape_l2e_c_phis_40h)) then
            allocate( tape_l2e_c_phis_40h(is:ie,1:km+1,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_phis_40h(:,:,j-js+1) = phis
          if ( .not. allocated(tape_l2e_c_ua_41h)) then
            allocate( tape_l2e_c_ua_41h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_ua_41h(:,:,j-js+1) = ua(:,j,:)
          if ( .not. allocated(tape_l2e_c_va_42h)) then
            allocate( tape_l2e_c_va_42h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_va_42h(:,:,j-js+1) = va(:,j,:)
          if ( .not. allocated(tape_l2e_c_w_43h)) then
            allocate( tape_l2e_c_w_43h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
          endif
          tape_l2e_c_w_43h(:,:,j-js+1) = w(:,j,:)
          do k = 1, km
            do i = is, ie
              te_2d(i,j) = te_2d(i,j)+delp(i,j,k)*(rgama*pt(i,j,k)*pkz(i,j,k)+0.5*(phis(i,k)+phis(i,k+1)+ua(i,j,k)**2+va(i,j,k)**2+&
&w(i,j,k)**2))
            end do
          end do
        endif
      endif
    end do
    j = je
    if (remap_t) then
      if ( .not. allocated(tape_l2e_c_pt_14h)) then
        allocate( tape_l2e_c_pt_14h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
      endif
      tape_l2e_c_pt_14h(:,:,j-js+1) = pt(:,j,:)
      if ( .not. allocated(tape_l2e_c_peln_15h)) then
        allocate( tape_l2e_c_peln_15h(is:ie,1:km+1,tape_l2e_c_lagrangian_to_euleri) )
      endif
      tape_l2e_c_peln_15h(:,:,j-js+1) = peln(:,:,j)
      do i = is, ie
        gz(i) = hs(i,j)
        do k = 1, km
          gz(i) = gz(i)+rg*pt(i,j,k)*(peln(i,k+1,j)-peln(i,k,j))
        end do
      end do
      if ( .not. allocated(tape_l2e_c_pe_17h)) then
        allocate( tape_l2e_c_pe_17h(is-1:ie+1,1:km+1,tape_l2e_c_lagrangian_to_euleri) )
      endif
      tape_l2e_c_pe_17h(:,:,j-js+1) = pe(:,:,j)
      if ( .not. allocated(tape_l2e_c_pe_18h)) then
        allocate( tape_l2e_c_pe_18h(is-1:ie+1,tape_l2e_c_lagrangian_to_euleri) )
      endif
      tape_l2e_c_pe_18h(:,j-js+1) = pe(:,1,j)
      do i = is, ie
        te_2d(i,j) = pe(i,km+1,j)*hs(i,j)-pe(i,1,j)*gz(i)
      end do
      if ( .not. allocated(tape_l2e_c_delp_20h)) then
        allocate( tape_l2e_c_delp_20h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
      endif
      tape_l2e_c_delp_20h(:,:,j-js+1) = delp(:,j,:)
      if ( .not. allocated(tape_l2e_c_pt_21h)) then
        allocate( tape_l2e_c_pt_21h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
      endif
      tape_l2e_c_pt_21h(:,:,j-js+1) = pt(:,j,:)
      if ( .not. allocated(tape_l2e_c_ua_22h)) then
        allocate( tape_l2e_c_ua_22h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
      endif
      tape_l2e_c_ua_22h(:,:,j-js+1) = ua(:,j,:)
      if ( .not. allocated(tape_l2e_c_va_23h)) then
        allocate( tape_l2e_c_va_23h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
      endif
      tape_l2e_c_va_23h(:,:,j-js+1) = va(:,j,:)
    else
      if (hydrostatic) then
        if ( .not. allocated(tape_l2e_c_pt_24h)) then
          allocate( tape_l2e_c_pt_24h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_pt_24h(:,:,j-js+1) = pt(:,j,:)
        if ( .not. allocated(tape_l2e_c_pk_25h)) then
          allocate( tape_l2e_c_pk_25h(is:ie,1:km+1,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_pk_25h(:,:,j-js+1) = pk(:,j,:)
        do i = is, ie
          gz(i) = hs(i,j)
          do k = 1, km
            gz(i) = gz(i)+pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))
          end do
        end do
        if ( .not. allocated(tape_l2e_c_pe_26h)) then
          allocate( tape_l2e_c_pe_26h(is-1:ie+1,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_pe_26h(:,j-js+1) = pe(:,km+1,j)
        if ( .not. allocated(tape_l2e_c_pe_27h)) then
          allocate( tape_l2e_c_pe_27h(is-1:ie+1,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_pe_27h(:,j-js+1) = pe(:,1,j)
        do i = is, ie
          te_2d(i,j) = pe(i,km+1,j)*hs(i,j)-pe(i,1,j)*gz(i)
        end do
        if ( .not. allocated(tape_l2e_c_pkz_29h)) then
          allocate( tape_l2e_c_pkz_29h(is:ie,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_pkz_29h(:,:,j-js+1) = pkz(:,j,:)
        if ( .not. allocated(tape_l2e_c_pt_30h)) then
          allocate( tape_l2e_c_pt_30h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_pt_30h(:,:,j-js+1) = pt(:,j,:)
        if ( .not. allocated(tape_l2e_c_delp_31h)) then
          allocate( tape_l2e_c_delp_31h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_delp_31h(:,:,j-js+1) = delp(:,j,:)
        if ( .not. allocated(tape_l2e_c_ua_33h)) then
          allocate( tape_l2e_c_ua_33h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_ua_33h(:,:,j-js+1) = ua(:,j,:)
        if ( .not. allocated(tape_l2e_c_va_34h)) then
          allocate( tape_l2e_c_va_34h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_va_34h(:,:,j-js+1) = va(:,j,:)
      else
        do i = is, ie
          phis(i,km+1) = hs(i,j)
          do k = km, 1, -1
            phis(i,k) = phis(i,k+1)-grav*delz(i,j,k)
          end do
        end do
        do i = is, ie
          te_2d(i,j) = 0.
        end do
        if ( .not. allocated(tape_l2e_c_delp_37h)) then
          allocate( tape_l2e_c_delp_37h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_delp_37h(:,:,j-js+1) = delp(:,j,:)
        if ( .not. allocated(tape_l2e_c_pt_38h)) then
          allocate( tape_l2e_c_pt_38h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_pt_38h(:,:,j-js+1) = pt(:,j,:)
        if ( .not. allocated(tape_l2e_c_pkz_39h)) then
          allocate( tape_l2e_c_pkz_39h(is:ie,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_pkz_39h(:,:,j-js+1) = pkz(:,j,:)
        if ( .not. allocated(tape_l2e_c_phis_40h)) then
          allocate( tape_l2e_c_phis_40h(is:ie,1:km+1,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_phis_40h(:,:,j-js+1) = phis
        if ( .not. allocated(tape_l2e_c_ua_41h)) then
          allocate( tape_l2e_c_ua_41h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_ua_41h(:,:,j-js+1) = ua(:,j,:)
        if ( .not. allocated(tape_l2e_c_va_42h)) then
          allocate( tape_l2e_c_va_42h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_va_42h(:,:,j-js+1) = va(:,j,:)
        if ( .not. allocated(tape_l2e_c_w_43h)) then
          allocate( tape_l2e_c_w_43h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
        endif
        tape_l2e_c_w_43h(:,:,j-js+1) = w(:,j,:)
      endif
    endif
  endif
  do j = js, je
    if ( .not. allocated(tape_l2e_c_pkz_45h)) then
      allocate( tape_l2e_c_pkz_45h(is:ie,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_pkz_45h(:,j-js+1) = pkz(:,j,1)
    if ( .not. allocated(tape_l2e_c_delp_46h)) then
      allocate( tape_l2e_c_delp_46h(isd:ied,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_delp_46h(:,j-js+1) = delp(:,j,1)
    do i = is, ie
      zsum1(i,j) = pkz(i,j,1)*delp(i,j,1)
    end do
    if ( .not. allocated(tape_l2e_c_pkz_48h)) then
      allocate( tape_l2e_c_pkz_48h(is:ie,1:km,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_pkz_48h(:,:,j-js+1) = pkz(:,j,:)
    if ( .not. allocated(tape_l2e_c_delp_49h)) then
      allocate( tape_l2e_c_delp_49h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_delp_49h(:,:,j-js+1) = delp(:,j,:)
  end do
endif
if (te_map) then
  do j = js, je
    do i = is, ie
      gz(i) = hs(i,j)
    end do
    if ( .not. allocated(tape_l2e_c_te_57h)) then
      allocate( tape_l2e_c_te_57h(is:ie,1:km,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_te_57h(:,:,j-js+1) = te(:,j,:)
    if ( .not. allocated(tape_l2e_c_ua_58h)) then
      allocate( tape_l2e_c_ua_58h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_ua_58h(:,:,j-js+1) = ua(:,j,:)
    if ( .not. allocated(tape_l2e_c_va_59h)) then
      allocate( tape_l2e_c_va_59h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_va_59h(:,:,j-js+1) = va(:,j,:)
    if ( .not. allocated(tape_l2e_c_gz_60h)) then
      allocate( tape_l2e_c_gz_60h(is:ie,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_gz_60h(:,j-js+1) = gz
    if ( .not. allocated(tape_l2e_c_peln_61h)) then
      allocate( tape_l2e_c_peln_61h(is:ie,1:km+1,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_peln_61h(:,:,j-js+1) = peln(:,:,j)
    if ( .not. allocated(tape_l2e_c_pe_62h)) then
      allocate( tape_l2e_c_pe_62h(is-1:ie+1,1:km+1,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_pe_62h(:,:,j-js+1) = pe(:,:,j)
    if ( .not. allocated(tape_l2e_c_delp_63h)) then
      allocate( tape_l2e_c_delp_63h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_delp_63h(:,:,j-js+1) = delp(:,j,:)
    if ( .not. allocated(tape_l2e_c_q_64h)) then
      allocate( tape_l2e_c_q_64h(isd:ied,1:km,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_q_64h(:,:,j-js+1) = q(:,j,:,sphum)
    if ( .not. allocated(tape_l2e_c_pkz_65h)) then
      allocate( tape_l2e_c_pkz_65h(is:ie,1:km,tape_l2e_c_lagrangian_to_euleri) )
    endif
    tape_l2e_c_pkz_65h(:,:,j-js+1) = pkz(:,j,:)
  end do
else
  if (remap_t) then
    if ( .not. allocated(tape_l2e_a_pt_35h)) then
      allocate( tape_l2e_a_pt_35h(isd:ied,jsd:jed,1:km,tape_l2e_a_lagrangian_to_euleri) )
    endif
    tape_l2e_a_pt_35h(:,:,:,1) = pt
    if ( .not. allocated(tape_l2e_a_pkz_36h)) then
      allocate( tape_l2e_a_pkz_36h(is:ie,js:je,1:km,tape_l2e_a_lagrangian_to_euleri) )
    endif
    tape_l2e_a_pkz_36h(:,:,:,1) = pkz
    if ( .not. allocated(tape_l2e_a_q_37h)) then
      allocate( tape_l2e_a_q_37h(isd:ied,jsd:jed,1:km,1:ncnst,tape_l2e_a_lagrangian_to_euleri) )
    endif
    tape_l2e_a_q_37h(:,:,:,:,1) = q
  else
    if ( .not. allocated(tape_l2e_a_pt_38h)) then
      allocate( tape_l2e_a_pt_38h(isd:ied,jsd:jed,1:km,tape_l2e_a_lagrangian_to_euleri) )
    endif
    tape_l2e_a_pt_38h(:,:,:,1) = pt
    if ( .not. allocated(tape_l2e_a_pkz_39h)) then
      allocate( tape_l2e_a_pkz_39h(is:ie,js:je,1:km,tape_l2e_a_lagrangian_to_euleri) )
    endif
    tape_l2e_a_pkz_39h(:,:,:,1) = pkz
    if ( .not. allocated(tape_l2e_a_q_40h)) then
      allocate( tape_l2e_a_q_40h(isd:ied,jsd:jed,1:km,1:ncnst,tape_l2e_a_lagrangian_to_euleri) )
    endif
    tape_l2e_a_q_40h(:,:,:,:,1) = q
  endif
endif

                     call timing_on('adl2e_adj')
!----------------------------------------------
! ADJOINT COMPUTATIONS
!----------------------------------------------
delp(:,:,:) = delph(:,:,:)
delz(:,:,:) = delzh(:,:,:)
pe(:,:,:) = pei(:,:,:)
peln(:,:,:) = pelnh(:,:,:)
pk(:,:,:) = pkh(:,:,:)
pt(:,:,:) = pth(:,:,:)
ze0(:,:,:) = ze0h(:,:,:)
peh(:,:,:) = pe(:,:,:)
if (kord_tm .lt. 0) then
  if (remap_t) then
    do k = 1, km
      do j = js, je
        do i = is, ie
          pt(i,j,k) = pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))/(rg*(peln(i,k+1,j)-peln(i,k,j)))
        end do
      end do
    end do
  endif
else
  call pkez( km,is,ie,js,je,pe,pk,akap,peln,pkz )
endif
if (( .not. hydrostatic) .and. ( .not. hybrid_z)) then
  do k = 1, km
    do j = js, je
      do i = is, ie
        delz(i,j,k) = -(delz(i,j,k)/delp(i,j,k))
      end do
    end do
  end do
endif
do j = js, je
  do k = 1, km+1
    do i = is, ie
      pe1(i,k) = pe(i,k,j)
    end do
  end do
  do i = is, ie
    pe2(i,1) = ptop
    pe2(i,km+1) = pe(i,km+1,j)
  end do
  if (j .lt. je+1) then
    if (hybrid_z) then
      do i = is, ie
        ze1(i,km+1) = ze0(i,j,km+1)
      end do
      do k = km, 1, -1
        do i = is, ie
          ze1(i,k) = ze1(i,k+1)-delz(i,j,k)
        end do
      end do
      do i = is, ie
        ze2(i,1) = ze1(i,1)
        ze0(i,j,1) = ze1(i,1)
      end do
      do k = 2, km+1
        do i = is, ie
          ze2(i,k) = ze0(i,j,k)
        end do
      end do
      do k = 1, km
        do i = is, ie
          deng(i,k) = -(delp(i,j,k)/delz(i,j,k))
        end do
      end do
      help_h = abs(kord_tm)
      call remap_z( km,ze1,deng,km,ze2,deng,is,ie,help_h )
      do k = 1, km
        do i = is, ie
          delz(i,j,k) = ze2(i,k+1)-ze2(i,k)
        end do
      end do
      do k = 1, km-1
        do i = is, ie
          dp2(i,k) = -(delz(i,j,k)*deng(i,k))
          pe2(i,k+1) = pe2(i,k)+dp2(i,k)
        end do
      end do
      do i = is, ie
        dp2(i,km) = pe2(i,km+1)-pe2(i,km)
      end do
    else
      do k = 2, ks+1
        do i = is, ie
          pe2(i,k) = ak(k)
        end do
      end do
      do k = ks+2, km
        do i = is, ie
          pe2(i,k) = ak(k)+bk(k)*pe(i,km+1,j)
        end do
      end do
      do k = 1, km
        do i = is, ie
          dp2(i,k) = pe2(i,k+1)-pe2(i,k)
        end do
      end do
    endif
    do k = 1, km
      do i = is, ie
        delp(i,j,k) = dp2(i,k)
      end do
    end do
    do k = 1, km+1
      do i = is, ie
        pk1(i,k) = pk(i,j,k)
      end do
    end do
    do i = is, ie
      pn2(i,1) = peln(i,1,j)
      pn2(i,km+1) = peln(i,km+1,j)
      pk2(i,1) = pk1(i,1)
      pk2(i,km+1) = pk1(i,km+1)
    end do
    do k = 2, km
      do i = is, ie
        pn2(i,k) = log(pe2(i,k))
        pk2(i,k) = exp(akap*pn2(i,k))
      end do
    end do
    if (te_map) then
      do i = is, ie
        phis(i,km+1) = hs(i,j)
      end do
      do k = km, 1, -1
        do i = is, ie
          phis(i,k) = phis(i,k+1)+pt(i,j,k)*(pk1(i,k+1)-pk1(i,k))
        end do
      end do
      do k = 1, km+1
        do i = is, ie
          phis(i,k) = phis(i,k)*pe1(i,k)
        end do
      end do
    else
      if (remap_t) then
        help_j = abs(kord_tm)
        call map1_ppm( km,peln(is,1,j),pt,km,pn2,pt,is,ie,j,isd,ied,jsd,jed,1,help_j )
      else
        help_k = abs(kord_tm)
        call map1_ppm( km,pk1,pt,km,pk2,pt,is,ie,j,isd,ied,jsd,jed,1,help_k )
      endif
    endif
    if ( .not. hydrostatic) then
      if ( .not. hybrid_z) then
        help_m = abs(kord_tm)
        call map1_ppm( km,pe1,delz,km,pe2,delz,is,ie,j,is,ie,js,je,1,help_m )
        do k = 1, km
          do i = is, ie
            delz(i,j,k) = -(delz(i,j,k)*dp2(i,k))
          end do
        end do
      endif
    endif
    do k = 2, km
      do i = is, ie
        pk(i,j,k) = pk2(i,k)
      end do
    end do
    do k = 1, km+1
      do i = is, ie
        peln(i,k,j) = pn2(i,k)
      end do
    end do
    do k = 1, km
      do i = is, ie
        dp2(i,k) = 0.5*(peln(i,k,j)+peln(i,k+1,j))
      end do
    end do
  endif
end do
j = je+1
do k = 1, km+1
  do i = is, ie
    pe1(i,k) = pe(i,k,j)
  end do
end do
if (j .lt. je+1) then
  do k = 1, km+1
    do i = is, ie
      pk1(i,k) = pk(i,j,k)
    end do
  end do
  if (te_map) then
    do i = is, ie
      phis(i,km+1) = hs(i,j)
    end do
    do k = km, 1, -1
      do i = is, ie
        phis(i,k) = phis(i,k+1)+pt(i,j,k)*(pk1(i,k+1)-pk1(i,k))
      end do
    end do
    do k = 1, km+1
      do i = is, ie
        phis(i,k) = phis(i,k)*pe1(i,k)
      end do
    end do
  endif
endif
pe(:,:,:) = peh(:,:,:)
if (consv .gt. 0.) then
  if (te_map) then
    do j = js, je
      do i = is, ie
        te_2d(i,j) = te(i,j,1)*delp(i,j,1)
      end do
      do k = 2, km
        do i = is, ie
          te_2d(i,j) = te_2d(i,j)+te(i,j,k)*delp(i,j,k)
        end do
      end do
    end do
  else
    do j = js, je
      if (remap_t) then
        do i = is, ie
          gz(i) = hs(i,j)
          do k = 1, km
            gz(i) = gz(i)+rg*pt(i,j,k)*(peln(i,k+1,j)-peln(i,k,j))
          end do
        end do
        do i = is, ie
          te_2d(i,j) = pe(i,km+1,j)*hs(i,j)-pe(i,1,j)*gz(i)
        end do
        do k = 1, km
          do i = is, ie
            te_2d(i,j) = te_2d(i,j)+delp(i,j,k)*(cp*pt(i,j,k)+0.5*(ua(i,j,k)**2+va(i,j,k)**2))
          end do
        end do
      else
        if (hydrostatic) then
          do i = is, ie
            gz(i) = hs(i,j)
            do k = 1, km
              gz(i) = gz(i)+pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))
            end do
          end do
          do i = is, ie
            te_2d(i,j) = pe(i,km+1,j)*hs(i,j)-pe(i,1,j)*gz(i)
          end do
          do k = 1, km
            do i = is, ie
              te_2d(i,j) = te_2d(i,j)+delp(i,j,k)*(pt(i,j,k)*pkz(i,j,k)+0.5*(ua(i,j,k)**2+va(i,j,k)**2))
            end do
          end do
        else
          do i = is, ie
            phis(i,km+1) = hs(i,j)
            do k = km, 1, -1
              phis(i,k) = phis(i,k+1)-grav*delz(i,j,k)
            end do
          end do
          do i = is, ie
            te_2d(i,j) = 0.
          end do
          do k = 1, km
            do i = is, ie
              te_2d(i,j) = te_2d(i,j)+delp(i,j,k)*(rgama*pt(i,j,k)*pkz(i,j,k)+0.5*(phis(i,k)+phis(i,k+1)+ua(i,j,k)**2+va(i,j,k)**2+&
&w(i,j,k)**2))
            end do
          end do
        endif
      endif
    end do
  endif
  do j = js, je
    do i = is, ie
      zsum1(i,j) = pkz(i,j,1)*delp(i,j,1)
    end do
    do k = 2, km
      do i = is, ie
        zsum1(i,j) = zsum1(i,j)+pkz(i,j,k)*delp(i,j,k)
      end do
    end do
    do i = is, ie
      zsum0(i,j) = ptop*(pk(i,j,1)-pk(i,j,km+1))+zsum1(i,j)
      te_2d(i,j) = te0_2d(i,j)-te_2d(i,j)
    end do
  end do
  zg_sum1 = 0.
  do j = js, je
    do i = is, ie
      zg_sum1 = zg_sum1+te_2d(i,j)*area(i,j)
    end do
  end do
  tpe = consv*zg_sum1
  if (hydrostatic) then
    zg_sum2 = 0.
    do j = js, je
      do i = is, ie
        zg_sum2 = zg_sum2+zsum0(i,j)*area(i,j)
      end do
    end do
    dtmp = tpe/(cp*zg_sum2)
  else
    zg_sum2 = 0.
    do j = js, je
      do i = is, ie
        zg_sum2 = zg_sum2+zsum1(i,j)*area(i,j)
      end do
    end do
    dtmp = tpe/(cv*zg_sum2)
  endif
  if (reproduce_sum) then
    dtmp = real(dtmp,4)
  endif
else
  dtmp = 0.
endif
if (te_map) then
  do j = je, js, -1
    addlnp = 0.
    adtmp = 0.
    adtpe = 0.
    te(:,j,:) = tape_l2e_c_te_57h(:,:,j-js+1)
    ua(:,j,:) = tape_l2e_c_ua_58h(:,:,j-js+1)
    va(:,j,:) = tape_l2e_c_va_59h(:,:,j-js+1)
    gz = tape_l2e_c_gz_60h(:,j-js+1)
    peln(:,:,j) = tape_l2e_c_peln_61h(:,:,j-js+1)
    pe(:,:,j) = tape_l2e_c_pe_62h(:,:,j-js+1)
    delp(:,j,:) = tape_l2e_c_delp_63h(:,:,j-js+1)
    q(:,j,:,sphum) = tape_l2e_c_q_64h(:,:,j-js+1)
    pkz(:,j,:) = tape_l2e_c_pkz_65h(:,:,j-js+1)
    do k = 1, km
      gz = tape_l2e_c_gz_60h(:,j-js+1)
      do k3 = km, k-(-1), -1
        do i = is, ie
          tpe = te(i,j,k3)-0.5*(ua(i,j,k3)**2+va(i,j,k3)**2)-gz(i)
          dlnp = rg*(peln(i,k3+1,j)-peln(i,k3,j))
          tmp = tpe/((cp-pe(i,k3,j)*dlnp/delp(i,j,k3))*(1.+r_vir*q(i,j,k3,sphum)))
          gz(i) = gz(i)+dlnp*tmp*(1.+r_vir*q(i,j,k3,sphum))
        end do
      end do
      do i = ie, is, -1
        addlnp = 0.
        adtmp = 0.
        adtpe = 0.
        tpe = te(i,j,k)-0.5*(ua(i,j,k)**2+va(i,j,k)**2)-gz(i)
        dlnp = rg*(peln(i,k+1,j)-peln(i,k,j))
        tmp = tpe/((cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,sphum)))
        addlnp = addlnp+adgz(i)*tmp*(1.+r_vir*q(i,j,k,sphum))
        adq(i,j,k,sphum) = adq(i,j,k,sphum)+adgz(i)*dlnp*tmp*r_vir
        adtmp = adtmp+adgz(i)*dlnp*(1.+r_vir*q(i,j,k,sphum))
        adgz(i) = adgz(i)+adpt(i,j,k)
        adtpe = adtpe+adpt(i,j,k)
        adpt(i,j,k) = 0.
        addtmp = addtmp+adpt(i,j,k)*(pkz(i,j,k)/(1.+r_vir*q(i,j,k,sphum)))
        adpkz(i,j,k) = adpkz(i,j,k)+adpt(i,j,k)*(dtmp/(1.+r_vir*q(i,j,k,sphum)))
        adq(i,j,k,sphum) = adq(i,j,k,sphum)-adpt(i,j,k)*(dtmp*pkz(i,j,k)*r_vir/((1.+r_vir*q(i,j,k,sphum))*(1.+r_vir*q(i,j,k,sphum))&
&))
        adtmp = adtmp+adpt(i,j,k)
        adpt(i,j,k) = 0.
        addelp(i,j,k) = addelp(i,j,k)-adtmp*(tpe*pe(i,k,j)*dlnp/(delp(i,j,k)*delp(i,j,k))*(1.+r_vir*q(i,j,k,sphum))/((cp-pe(i,k,j)*&
&dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,sphum))*(cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,sphum))))
        addlnp = addlnp+adtmp*(tpe*pe(i,k,j)/delp(i,j,k)*(1.+r_vir*q(i,j,k,sphum))/((cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,&
&j,k,sphum))*(cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,sphum))))
        adpe(i,k,j) = adpe(i,k,j)+adtmp*(tpe*dlnp/delp(i,j,k)*(1.+r_vir*q(i,j,k,sphum))/((cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*&
&q(i,j,k,sphum))*(cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,sphum))))
        adq(i,j,k,sphum) = adq(i,j,k,sphum)-adtmp*(tpe*(cp-pe(i,k,j)*dlnp/delp(i,j,k))*r_vir/((cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+&
&r_vir*q(i,j,k,sphum))*(cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,sphum))))
        adtpe = adtpe+adtmp/((cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,sphum)))
        adtmp = 0.
        adpeln(i,k+1,j) = adpeln(i,k+1,j)+addlnp*rg
        adpeln(i,k,j) = adpeln(i,k,j)-addlnp*rg
        addlnp = 0.
        adgz(i) = adgz(i)-adtpe
        adte(i,j,k) = adte(i,j,k)+adtpe
        adua(i,j,k) = adua(i,j,k)-adtpe*ua(i,j,k)
        adva(i,j,k) = adva(i,j,k)-adtpe*va(i,j,k)
        adtpe = 0.
      end do
    end do
    do i = is, ie
      adgz(i) = 0.
    end do
  end do
else
  if (remap_t) then
    pt = tape_l2e_a_pt_35h(:,:,:,1)
    pkz = tape_l2e_a_pkz_36h(:,:,:,1)
    q = tape_l2e_a_q_37h(:,:,:,:,1)
    do k = 1, km
      do j = js, je
        do i = is, ie
          addtmp = addtmp+adpt(i,j,k)*(pkz(i,j,k)/(1.+r_vir*q(i,j,k,sphum)))
          adpkz(i,j,k) = adpkz(i,j,k)+adpt(i,j,k)*(dtmp/(1.+r_vir*q(i,j,k,sphum)))
          adq(i,j,k,sphum) = adq(i,j,k,sphum)-adpt(i,j,k)*((pt(i,j,k)+dtmp*pkz(i,j,k))*r_vir/((1.+r_vir*q(i,j,k,sphum))*(1.+r_vir*&
&q(i,j,k,sphum))))
          adpt(i,j,k) = adpt(i,j,k)/(1.+r_vir*q(i,j,k,sphum))
        end do
      end do
    end do
  else
    pt = tape_l2e_a_pt_38h(:,:,:,1)
    pkz = tape_l2e_a_pkz_39h(:,:,:,1)
    q = tape_l2e_a_q_40h(:,:,:,:,1)
    do k = 1, km
      do j = js, je
        do i = is, ie
          addtmp = addtmp+adpt(i,j,k)*(pkz(i,j,k)/(1.+r_vir*q(i,j,k,sphum)))
          adpkz(i,j,k) = adpkz(i,j,k)+adpt(i,j,k)*((rcp*pt(i,j,k)+dtmp)/(1.+r_vir*q(i,j,k,sphum)))
          adq(i,j,k,sphum) = adq(i,j,k,sphum)-adpt(i,j,k)*((rcp*pt(i,j,k)+dtmp)*pkz(i,j,k)*r_vir/((1.+r_vir*q(i,j,k,sphum))*(1.+&
&r_vir*q(i,j,k,sphum))))
          adpt(i,j,k) = adpt(i,j,k)*(rcp*pkz(i,j,k)/(1.+r_vir*q(i,j,k,sphum)))
        end do
      end do
    end do
  endif
endif
if (consv .gt. 0.) then
  tpe = consv*zg_sum1
  if (reproduce_sum) then
    addtmp = real(addtmp)
  endif
  if (hydrostatic) then
    adtpe = adtpe+addtmp/(cp*zg_sum2)
    adzg_sum2 = adzg_sum2-addtmp*(tpe*cp/(cp*zg_sum2*cp*zg_sum2))
    addtmp = 0.
    do j = js, je
      do i = is, ie
        adzsum0(i,j) = adzsum0(i,j)+adzg_sum2*area(i,j)
      end do
    end do
  else
    adtpe = adtpe+addtmp/(cv*zg_sum2)
    adzg_sum2 = adzg_sum2-addtmp*(tpe*cv/(cv*zg_sum2*cv*zg_sum2))
    addtmp = 0.
    do j = js, je
      do i = is, ie
        adzsum1(i,j) = adzsum1(i,j)+adzg_sum2*area(i,j)
      end do
    end do
  endif
  adzg_sum1 = adzg_sum1+adtpe*consv
  adtpe = 0.
  do j = js, je
    do i = is, ie
      adte_2d(i,j) = adte_2d(i,j)+adzg_sum1*area(i,j)
    end do
  end do
  do j = js, je
    pkz(:,j,:) = tape_l2e_c_pkz_48h(:,:,j-js+1)
    delp(:,j,:) = tape_l2e_c_delp_49h(:,:,j-js+1)
    do i = is, ie
      adte0_2d(i,j) = adte0_2d(i,j)+adte_2d(i,j)
      adte_2d(i,j) = -adte_2d(i,j)
      adpk(i,j,km+1) = adpk(i,j,km+1)-adzsum0(i,j)*ptop
      adpk(i,j,1) = adpk(i,j,1)+adzsum0(i,j)*ptop
      adzsum1(i,j) = adzsum1(i,j)+adzsum0(i,j)
      adzsum0(i,j) = 0.
    end do
    do k = km, 2, -1
      do i = is, ie
        addelp(i,j,k) = addelp(i,j,k)+adzsum1(i,j)*pkz(i,j,k)
        adpkz(i,j,k) = adpkz(i,j,k)+adzsum1(i,j)*delp(i,j,k)
      end do
    end do
    pkz(:,j,1) = tape_l2e_c_pkz_45h(:,j-js+1)
    delp(:,j,1) = tape_l2e_c_delp_46h(:,j-js+1)
    do i = is, ie
      addelp(i,j,1) = addelp(i,j,1)+adzsum1(i,j)*pkz(i,j,1)
      adpkz(i,j,1) = adpkz(i,j,1)+adzsum1(i,j)*delp(i,j,1)
      adzsum1(i,j) = 0.
    end do
  end do
  if (te_map) then
    do j = js, je
      te(:,j,:) = tape_l2e_c_te_11h(:,:,j-js+1)
      delp(:,j,:) = tape_l2e_c_delp_12h(:,:,j-js+1)
      do k = km, 2, -1
        do i = is, ie
          addelp(i,j,k) = addelp(i,j,k)+adte_2d(i,j)*te(i,j,k)
          adte(i,j,k) = adte(i,j,k)+adte_2d(i,j)*delp(i,j,k)
        end do
      end do
      te(:,j,1) = tape_l2e_c_te_8h(:,j-js+1)
      delp(:,j,1) = tape_l2e_c_delp_9h(:,j-js+1)
      do i = is, ie
        addelp(i,j,1) = addelp(i,j,1)+adte_2d(i,j)*te(i,j,1)
        adte(i,j,1) = adte(i,j,1)+adte_2d(i,j)*delp(i,j,1)
        adte_2d(i,j) = 0.
      end do
    end do
  else
    do j = je, js, -1
      if (remap_t) then
        pt(:,j,:) = tape_l2e_c_pt_14h(:,:,j-js+1)
        peln(:,:,j) = tape_l2e_c_peln_15h(:,:,j-js+1)
        do i = is, ie
          gz(i) = hs(i,j)
          do k = 1, km
            gz(i) = gz(i)+rg*pt(i,j,k)*(peln(i,k+1,j)-peln(i,k,j))
          end do
        end do
        pe(:,:,j) = tape_l2e_c_pe_17h(:,:,j-js+1)
        pe(:,1,j) = tape_l2e_c_pe_18h(:,j-js+1)
        delp(:,j,:) = tape_l2e_c_delp_20h(:,:,j-js+1)
        pt(:,j,:) = tape_l2e_c_pt_21h(:,:,j-js+1)
        ua(:,j,:) = tape_l2e_c_ua_22h(:,:,j-js+1)
        va(:,j,:) = tape_l2e_c_va_23h(:,:,j-js+1)
        do k = km, 1, -1
          do i = is, ie
            addelp(i,j,k) = addelp(i,j,k)+adte_2d(i,j)*(cp*pt(i,j,k)+0.5*(ua(i,j,k)**2+va(i,j,k)**2))
            adpt(i,j,k) = adpt(i,j,k)+adte_2d(i,j)*delp(i,j,k)*cp
            adua(i,j,k) = adua(i,j,k)+adte_2d(i,j)*delp(i,j,k)*ua(i,j,k)
            adva(i,j,k) = adva(i,j,k)+adte_2d(i,j)*delp(i,j,k)*va(i,j,k)
          end do
        end do
        do i = is, ie
          adgz(i) = adgz(i)-adte_2d(i,j)*pe(i,1,j)
          adpe(i,km+1,j) = adpe(i,km+1,j)+adte_2d(i,j)*hs(i,j)
          adpe(i,1,j) = adpe(i,1,j)-adte_2d(i,j)*gz(i)
          adte_2d(i,j) = 0.
        end do
        pt(:,j,:) = tape_l2e_c_pt_14h(:,:,j-js+1)
        do i = is, ie
          do k = 1, km
            adpeln(i,k+1,j) = adpeln(i,k+1,j)+adgz(i)*rg*pt(i,j,k)
            adpeln(i,k,j) = adpeln(i,k,j)-adgz(i)*rg*pt(i,j,k)
            adpt(i,j,k) = adpt(i,j,k)+adgz(i)*rg*(peln(i,k+1,j)-peln(i,k,j))
          end do
          adgz(i) = 0.
        end do
      else
        if (hydrostatic) then
          pt(:,j,:) = tape_l2e_c_pt_24h(:,:,j-js+1)
          pk(:,j,:) = tape_l2e_c_pk_25h(:,:,j-js+1)
          do i = is, ie
            gz(i) = hs(i,j)
            do k = 1, km
              gz(i) = gz(i)+pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))
            end do
          end do
          pe(:,km+1,j) = tape_l2e_c_pe_26h(:,j-js+1)
          pe(:,1,j) = tape_l2e_c_pe_27h(:,j-js+1)
          pkz(:,j,:) = tape_l2e_c_pkz_29h(:,:,j-js+1)
          pt(:,j,:) = tape_l2e_c_pt_30h(:,:,j-js+1)
          delp(:,j,:) = tape_l2e_c_delp_31h(:,:,j-js+1)
          ua(:,j,:) = tape_l2e_c_ua_33h(:,:,j-js+1)
          va(:,j,:) = tape_l2e_c_va_34h(:,:,j-js+1)
          do k = km, 1, -1
            do i = is, ie
              addelp(i,j,k) = addelp(i,j,k)+adte_2d(i,j)*(pt(i,j,k)*pkz(i,j,k)+0.5*(ua(i,j,k)**2+va(i,j,k)**2))
              adpkz(i,j,k) = adpkz(i,j,k)+adte_2d(i,j)*delp(i,j,k)*pt(i,j,k)
              adpt(i,j,k) = adpt(i,j,k)+adte_2d(i,j)*delp(i,j,k)*pkz(i,j,k)
              adua(i,j,k) = adua(i,j,k)+adte_2d(i,j)*delp(i,j,k)*ua(i,j,k)
              adva(i,j,k) = adva(i,j,k)+adte_2d(i,j)*delp(i,j,k)*va(i,j,k)
            end do
          end do
          do i = is, ie
            adgz(i) = adgz(i)-adte_2d(i,j)*pe(i,1,j)
            adpe(i,km+1,j) = adpe(i,km+1,j)+adte_2d(i,j)*hs(i,j)
            adpe(i,1,j) = adpe(i,1,j)-adte_2d(i,j)*gz(i)
            adte_2d(i,j) = 0.
          end do
          pt(:,j,:) = tape_l2e_c_pt_24h(:,:,j-js+1)
          do i = is, ie
            do k = 1, km
              adpk(i,j,k+1) = adpk(i,j,k+1)+adgz(i)*pt(i,j,k)
              adpk(i,j,k) = adpk(i,j,k)-adgz(i)*pt(i,j,k)
              adpt(i,j,k) = adpt(i,j,k)+adgz(i)*(pk(i,j,k+1)-pk(i,j,k))
            end do
            adgz(i) = 0.
          end do
        else
          delp(:,j,:) = tape_l2e_c_delp_37h(:,:,j-js+1)
          pt(:,j,:) = tape_l2e_c_pt_38h(:,:,j-js+1)
          pkz(:,j,:) = tape_l2e_c_pkz_39h(:,:,j-js+1)
          phis = tape_l2e_c_phis_40h(:,:,j-js+1)
          ua(:,j,:) = tape_l2e_c_ua_41h(:,:,j-js+1)
          va(:,j,:) = tape_l2e_c_va_42h(:,:,j-js+1)
          w(:,j,:) = tape_l2e_c_w_43h(:,:,j-js+1)
          do k = km, 1, -1
            do i = is, ie
              addelp(i,j,k) = addelp(i,j,k)+adte_2d(i,j)*(rgama*pt(i,j,k)*pkz(i,j,k)+0.5*(phis(i,k)+phis(i,k+1)+ua(i,j,k)**2+va(i,&
&j,k)**2+w(i,j,k)**2))
              adphis(i,k+1) = adphis(i,k+1)+0.5*adte_2d(i,j)*delp(i,j,k)
              adphis(i,k) = adphis(i,k)+0.5*adte_2d(i,j)*delp(i,j,k)
              adpkz(i,j,k) = adpkz(i,j,k)+adte_2d(i,j)*delp(i,j,k)*rgama*pt(i,j,k)
              adpt(i,j,k) = adpt(i,j,k)+adte_2d(i,j)*delp(i,j,k)*rgama*pkz(i,j,k)
              adua(i,j,k) = adua(i,j,k)+adte_2d(i,j)*delp(i,j,k)*ua(i,j,k)
              adva(i,j,k) = adva(i,j,k)+adte_2d(i,j)*delp(i,j,k)*va(i,j,k)
              adw(i,j,k) = adw(i,j,k)+adte_2d(i,j)*delp(i,j,k)*w(i,j,k)
            end do
          end do
          do i = is, ie
            adte_2d(i,j) = 0.
          end do
          do i = is, ie
            do k = 1, km
              addelz(i,j,k) = addelz(i,j,k)-adphis(i,k)*grav
              adphis(i,k+1) = adphis(i,k+1)+adphis(i,k)
              adphis(i,k) = 0.
            end do
            adphis(i,km+1) = 0.
          end do
        endif
      endif
    end do
  endif
endif
call adcubed_to_latlon( adu,adv,adua,adva,dx,dy,rdxa,rdya,km )
do k = 2, km
  do j = js, je
    do i = is, ie
      adua(i,j,k-1) = adua(i,j,k-1)+adpe(i,k,j)
      adpe(i,k,j) = 0.
    end do
  end do
end do
if (hybrid_z) then
  do j = je, js, -1
    pe0 = tape_l2e_c_pe0_6h(:,:,j-js+1)
    pe3 = tape_l2e_c_pe3_7h(:,:,j-js+1)
    help_u = ie+1
    help_v = ied+1
    help_w = -1
    adhelp_7(:,:,:) = 0.
    help_7 = v
    call admap1_ppm( km,pe0,adpe0,help_7,adhelp_7,km,pe3,adpe3,adv,is,help_u,j,isd,help_v,jsd,jed,help_w,kord_mt )
    adv(:,:,:) = adv(:,:,:)+adhelp_7(:,:,:)
    do k = 2, km+1
      do i = is, ie+1
        adua(i-1,j,k-1) = adua(i-1,j,k-1)+0.5*adpe3(i,k)
        adua(i,j,k-1) = adua(i,j,k-1)+0.5*adpe3(i,k)
        adpe3(i,k) = 0.
        adpe(i-1,k,j) = adpe(i-1,k,j)+0.5*adpe0(i,k)
        adpe(i,k,j) = adpe(i,k,j)+0.5*adpe0(i,k)
        adpe0(i,k) = 0.
      end do
    end do
    do i = is, ie+1
      adpe3(i,1) = 0.
      adpe0(i,1) = 0.
    end do
  end do
  do j = je+1, js, -1
    pe1 = tape_l2e_a_pe1_20h(:,:,j-js+1)
    pe2 = tape_l2e_a_pe2_21h(:,:,j-js+1)
    help_s = jed+1
    help_t = -1
    adhelp_8(:,:,:) = 0.
    help_8 = u
    call admap1_ppm( km,pe1,adpe1,help_8,adhelp_8,km,pe2,adpe2,adu,is,ie,j,isd,ied,jsd,help_s,help_t,kord_mt )
    adu(:,:,:) = adu(:,:,:)+adhelp_8(:,:,:)
    do k = 2, km+1
      do i = is, ie
        adua(i,j-1,k-1) = adua(i,j-1,k-1)+0.5*adpe2(i,k)
        adua(i,j,k-1) = adua(i,j,k-1)+0.5*adpe2(i,k)
        adpe2(i,k) = 0.
        adpe(i,k,j-1) = adpe(i,k,j-1)+0.5*adpe1(i,k)
        adpe(i,k,j) = adpe(i,k,j)+0.5*adpe1(i,k)
        adpe1(i,k) = 0.
      end do
    end do
    do i = is, ie
      adpe2(i,1) = 0.
      adpe1(i,1) = 0.
    end do
  end do
  call admpp_update_domains_dummy( adua,is,ie,js,je,isd,ied,jsd,jed,km )
endif
do j = je+1, js, -1
  do k = 1, km
    do i = is, ie
      adpe2(i,k+1) = adpe2(i,k+1)+adua(i,j,k)
      adua(i,j,k) = 0.
    end do
  end do
  if ( .not. hybrid_z) then
    help_n = jed+1
    help_o = -1
    if (j .lt. je+1) then
      pe0 = tape_l2e_b_pe0_125h(:,:,j-js+1)
      pe3 = tape_l2e_b_pe3_126h(:,:,j-js+1)
      help_p = ie+1
      help_q = ied+1
      help_r = -1
      adhelp_9(:,:,:) = 0.
      help_9 = v
      call admap1_ppm( km,pe0,adpe0,help_9,adhelp_9,km,pe3,adpe3,adv,is,help_p,j,isd,help_q,jsd,jed,help_r,kord_mt )
      adv(:,:,:) = adv(:,:,:)+adhelp_9(:,:,:)
      do k = ks+2, km+1
        bkh = 0.5*bk(k)
        do i = is, ie+1
          adpe(i-1,km+1,j) = adpe(i-1,km+1,j)+adpe3(i,k)*bkh
          adpe(i,km+1,j) = adpe(i,km+1,j)+adpe3(i,k)*bkh
          adpe3(i,k) = 0.
        end do
      end do
      do k = 2, km+1
        do i = is, ie+1
          adpe(i-1,k,j) = adpe(i-1,k,j)+0.5*adpe0(i,k)
          adpe(i,k,j) = adpe(i,k,j)+0.5*adpe0(i,k)
          adpe0(i,k) = 0.
        end do
      end do
    endif
    pe0 = tape_l2e_b_pe0_119h(:,:,j-js+1)
    pe3 = tape_l2e_b_pe3_120h(:,:,j-js+1)
    adhelp_aa(:,:,:) = 0.
    help_aa = u
    call admap1_ppm( km,pe0(is:ie,:),adpe0(is:ie,:),help_aa,adhelp_aa,km,pe3(is:ie,:),adpe3(is:ie,:),adu,is,ie,j,isd,ied,jsd,&
&help_n,help_o,kord_mt )
    adu(:,:,:) = adu(:,:,:)+adhelp_aa(:,:,:)
    do k = ks+2, km+1
      bkh = 0.5*bk(k)
      do i = is, ie
        adpe(i,km+1,j-1) = adpe(i,km+1,j-1)+adpe3(i,k)*bkh
        adpe1(i,km+1) = adpe1(i,km+1)+adpe3(i,k)*bkh
        adpe3(i,k) = 0.
      end do
    end do
    do k = 1, ks+1
      do i = is, ie+1
        adpe3(i,k) = 0.
      end do
    end do
    do k = 2, km+1
      do i = is, ie
        adpe(i,k,j-1) = adpe(i,k,j-1)+0.5*adpe0(i,k)
        adpe1(i,k) = adpe1(i,k)+0.5*adpe0(i,k)
        adpe0(i,k) = 0.
      end do
    end do
    do i = is, ie+1
      adpe(i,1,j) = adpe(i,1,j)+adpe0(i,1)
      adpe0(i,1) = 0.
    end do
  endif
  if (j .lt. je+1) then
    dp2 = tape_l2e_b_dp2_106h(:,:,j-js+1)
    pe0 = tape_l2e_b_pe0_107h(:,:,j-js+1)
    pe3 = tape_l2e_b_pe3_109h(:,:,j-js+1)
    do i = is, ie
      do n = km, 1, -1
        km_flag =  .false. 
        kp = tape_mapz_kp_4h(1)
        do k = km, kp, -1
          km_flag =  .false. 
          do k4 = kp, k-1
            if (km_flag .eqv.  .false. ) then
              if (dp2(i,n) .le. pe0(i,k4+1) .and. dp2(i,n) .ge. pe0(i,k4)) then
km_flag =  .true. 
              endif
            endif
          end do
          if (km_flag .eqv.  .false. ) then
            if (dp2(i,n) .le. pe0(i,k+1) .and. dp2(i,n) .ge. pe0(i,k)) then
              addp2(i,n) = addp2(i,n)+adomga(i,j,n)*((pe3(i,k+1)-pe3(i,k))/(pe0(i,k+1)-pe0(i,k)))
              adpe0(i,k+1) = adpe0(i,k+1)-adomga(i,j,n)*((pe3(i,k+1)-pe3(i,k))*(dp2(i,n)-pe0(i,k))/((pe0(i,k+1)-pe0(i,k))*(pe0(i,k+&
&1)-pe0(i,k))))
              adpe0(i,k) = adpe0(i,k)+adomga(i,j,n)*((-((pe3(i,k+1)-pe3(i,k))/(pe0(i,k+1)-pe0(i,k))))+(pe3(i,k+1)-pe3(i,k))*(dp2(i,&
&n)-pe0(i,k))/((pe0(i,k+1)-pe0(i,k))*(pe0(i,k+1)-pe0(i,k))))
              adpe3(i,k+1) = adpe3(i,k+1)+adomga(i,j,n)*((dp2(i,n)-pe0(i,k))/(pe0(i,k+1)-pe0(i,k)))
              adpe3(i,k) = adpe3(i,k)+adomga(i,j,n)*(1-(dp2(i,n)-pe0(i,k))/(pe0(i,k+1)-pe0(i,k)))
              adomga(i,j,n) = 0.
            endif
          endif
        end do
      end do
    end do
    do k = 1, km
      do i = is, ie
        adpeln(i,k+1,j) = adpeln(i,k+1,j)+0.5*addp2(i,k)
        adpeln(i,k,j) = adpeln(i,k,j)+0.5*addp2(i,k)
        addp2(i,k) = 0.
      end do
    end do
    if (hydrostatic) then
      pk2 = tape_l2e_b_pk2_95h(:,:,j-js+1)
      peln(:,:,j) = tape_l2e_b_peln_96h(:,:,j-js+1)
      do k = 1, km
        do i = is, ie
          adpeln(i,k+1,j) = adpeln(i,k+1,j)-adpkz(i,j,k)*((pk2(i,k+1)-pk2(i,k))*akap/(akap*(peln(i,k+1,j)-peln(i,k,j))*akap*&
&(peln(i,k+1,j)-peln(i,k,j))))
          adpeln(i,k,j) = adpeln(i,k,j)+adpkz(i,j,k)*((pk2(i,k+1)-pk2(i,k))*akap/(akap*(peln(i,k+1,j)-peln(i,k,j))*akap*(peln(i,k+&
&1,j)-peln(i,k,j))))
          adpk2(i,k+1) = adpk2(i,k+1)+adpkz(i,j,k)/(akap*(peln(i,k+1,j)-peln(i,k,j)))
          adpk2(i,k) = adpk2(i,k)-adpkz(i,j,k)/(akap*(peln(i,k+1,j)-peln(i,k,j)))
          adpkz(i,j,k) = 0.
        end do
      end do
    else
      delp(:,j,:) = tape_l2e_b_delp_101h(:,:,j-js+1)
      delz(:,j,:) = tape_l2e_b_delz_102h(:,:,j-js+1)
      pt(:,j,:) = tape_l2e_b_pt_103h(:,:,j-js+1)
      do k = ktop, km
        do i = is, ie
          pkzi = kapag*delp(i,j,k)/delz(i,j,k)*pt(i,j,k)
          adpkzi = adpkz(i,j,k)*k1k*(1./pkzi)*exp(k1k*log(pkzi))
          addelp(i,j,k) = addelp(i,j,k)+adpkzi*kapag/delz(i,j,k)*pt(i,j,k)
          addelz(i,j,k) = addelz(i,j,k)-adpkzi*kapag*delp(i,j,k)/(delz(i,j,k)*delz(i,j,k))*pt(i,j,k)
          adpt(i,j,k) = adpt(i,j,k)+adpkzi*(kapag*delp(i,j,k)/delz(i,j,k))
          adpkz(i,j,k) = 0.
        end do
      end do
      if (ktop .gt. 1) then
        pk2 = tape_l2e_b_pk2_98h(:,:,j-js+1)
        peln(:,:,j) = tape_l2e_b_peln_99h(:,:,j-js+1)
        do k = 1, ktop-1
          do i = is, ie
            adpeln(i,k+1,j) = adpeln(i,k+1,j)-adpkz(i,j,k)*((pk2(i,k+1)-pk2(i,k))*akap/(akap*(peln(i,k+1,j)-peln(i,k,j))*akap*&
&(peln(i,k+1,j)-peln(i,k,j))))
            adpeln(i,k,j) = adpeln(i,k,j)+adpkz(i,j,k)*((pk2(i,k+1)-pk2(i,k))*akap/(akap*(peln(i,k+1,j)-peln(i,k,j))*akap*(peln(i,&
&k+1,j)-peln(i,k,j))))
            adpk2(i,k+1) = adpk2(i,k+1)+adpkz(i,j,k)/(akap*(peln(i,k+1,j)-peln(i,k,j)))
            adpk2(i,k) = adpk2(i,k)-adpkz(i,j,k)/(akap*(peln(i,k+1,j)-peln(i,k,j)))
            adpkz(i,j,k) = 0.
          end do
        end do
      endif
    endif
    do k = 1, km+1
      do i = is, ie
        adpn2(i,k) = adpn2(i,k)+adpeln(i,k,j)
        adpeln(i,k,j) = 0.
        adpeln(i,k,j) = adpeln(i,k,j)+adpe0(i,k)
        adpe0(i,k) = 0.
      end do
    end do
    do k = 2, km+1
      do i = is, ie
        adomga(i,j,k-1) = adomga(i,j,k-1)+adpe3(i,k)
        adpe3(i,k) = 0.
      end do
    end do
    do i = is, ie
      adpe3(i,1) = 0.
    end do
    do k = 2, km
      do i = is, ie
        adpk2(i,k) = adpk2(i,k)+adpk(i,j,k)
        adpk(i,j,k) = 0.
      end do
    end do
    if ( .not. hydrostatic) then
      help_l = -1
      if ( .not. hybrid_z) then
        pe1 = tape_l2e_b_pe1_81h(:,:,j-js+1)
        pe2 = tape_l2e_b_pe2_82h(:,:,j-js+1)
        help_m = abs(kord_tm)
        delz(:,j,:) = tape_l2e_b_delz_84h(:,:,j-js+1)
        dp2 = tape_l2e_b_dp2_85h(:,:,j-js+1)
        do k = 1, km
          do i = is, ie
            addp2(i,k) = addp2(i,k)-addelz(i,j,k)*delz(i,j,k)
            addelz(i,j,k) = -(addelz(i,j,k)*dp2(i,k))
          end do
        end do
        adhelp_ab(:,:,:) = 0.
        help_ab = delz
        call admap1_ppm( km,pe1,adpe1,help_ab,adhelp_ab,km,pe2,adpe2,addelz,is,ie,j,is,ie,js,je,1,help_m )
        addelz(:,:,:) = addelz(:,:,:)+adhelp_ab(:,:,:)
      endif
      pe1 = tape_l2e_b_pe1_78h(:,:,j-js+1)
      pe2 = tape_l2e_b_pe2_79h(:,:,j-js+1)
      adhelp_ac(:,:,:) = 0.
      help_ac = w
      call admap1_ppm( km,pe1,adpe1,help_ac,adhelp_ac,km,pe2,adpe2,adw,is,ie,j,isd,ied,jsd,jed,help_l,kord_mt )
      adw(:,:,:) = adw(:,:,:)+adhelp_ac(:,:,:)
    endif
    if (te_map) then
      pt(:,j,:) = tape_l2e_b_pt_62h(:,:,j-js+1)
      pk1 = tape_l2e_b_pk1_63h(:,:,j-js+1)
      phis = tape_l2e_b_phis_67h(:,:,j-js+1)
      pe1 = tape_l2e_b_pe1_69h(:,:,j-js+1)
      pe2 = tape_l2e_b_pe2_70h(:,:,j-js+1)
      adhelp_af(:,:,:) = 0.
      help_af = te
      call admap1_ppm( km,pe1,adpe1,help_af,adhelp_af,km,pe2,adpe2,adte,is,ie,j,is,ie,js,je,1,kord_tm )
      adte(:,:,:) = adte(:,:,:)+adhelp_af(:,:,:)
      pe1 = tape_l2e_b_pe1_68h(:,:,j-js+1)
      do k = 1, km
        do i = is, ie
          adpe1(i,k+1) = adpe1(i,k+1)-adte(i,j,k)*((phis(i,k+1)-phis(i,k))/((pe1(i,k+1)-pe1(i,k))*(pe1(i,k+1)-pe1(i,k))))
          adpe1(i,k) = adpe1(i,k)+adte(i,j,k)*((phis(i,k+1)-phis(i,k))/((pe1(i,k+1)-pe1(i,k))*(pe1(i,k+1)-pe1(i,k))))
          adphis(i,k+1) = adphis(i,k+1)+adte(i,j,k)/(pe1(i,k+1)-pe1(i,k))
          adphis(i,k) = adphis(i,k)-adte(i,j,k)/(pe1(i,k+1)-pe1(i,k))
        end do
      end do
      phis = tape_l2e_b_phis_64h(:,:,j-js+1)
      pe1 = tape_l2e_b_pe1_65h(:,:,j-js+1)
      do k = 1, km+1
        do i = is, ie
          adpe1(i,k) = adpe1(i,k)+adphis(i,k)*phis(i,k)
          adphis(i,k) = adphis(i,k)*pe1(i,k)
        end do
      end do
      do k = 1, km
        do i = is, ie
          adphis(i,k+1) = adphis(i,k+1)+adphis(i,k)
          adpk1(i,k+1) = adpk1(i,k+1)+adphis(i,k)*pt(i,j,k)
          adpk1(i,k) = adpk1(i,k)-adphis(i,k)*pt(i,j,k)
          adpt(i,j,k) = adpt(i,j,k)+adphis(i,k)*(pk1(i,k+1)-pk1(i,k))
          adphis(i,k) = 0.
        end do
      end do
      do i = is, ie
        adphis(i,km+1) = 0.
      end do
    else
      if (remap_t) then
        peln = tape_l2e_b_peln_72h(:,:,:,j-js+1)
        pn2 = tape_l2e_b_pn2_74h(:,:,j-js+1)
        help_j = abs(kord_tm)
        adhelp_ae(:,:,:) = 0.
        help_ae = pt
        call admap1_ppm( km,peln(is,1,j),adpeln(is,1,j),help_ae,adhelp_ae,km,pn2,adpn2,adpt,is,ie,j,isd,ied,jsd,jed,1,help_j )
        adpt(:,:,:) = adpt(:,:,:)+adhelp_ae(:,:,:)
      else
        pk1 = tape_l2e_b_pk1_75h(:,:,j-js+1)
        pk2 = tape_l2e_b_pk2_76h(:,:,j-js+1)
        help_k = abs(kord_tm)
        adhelp_ad(:,:,:) = 0.
        help_ad = pt
        call admap1_ppm( km,pk1,adpk1,help_ad,adhelp_ad,km,pk2,adpk2,adpt,is,ie,j,isd,ied,jsd,jed,1,help_k )
        adpt(:,:,:) = adpt(:,:,:)+adhelp_ad(:,:,:)
      endif
    endif
    pe2 = tape_l2e_b_pe2_57h(:,:,j-js+1)
    do k = 2, km
      do i = is, ie
        pn2(i,k) = log(pe2(i,k))
        adpn2(i,k) = adpn2(i,k)+adpk2(i,k)*akap*exp(akap*pn2(i,k))
        adpk2(i,k) = 0.
        adpe2(i,k) = adpe2(i,k)+adpn2(i,k)*(1./pe2(i,k))
        adpn2(i,k) = 0.
      end do
    end do
    do i = is, ie
      adpk1(i,km+1) = adpk1(i,km+1)+adpk2(i,km+1)
      adpk2(i,km+1) = 0.
      adpk1(i,1) = adpk1(i,1)+adpk2(i,1)
      adpk2(i,1) = 0.
      adpeln(i,km+1,j) = adpeln(i,km+1,j)+adpn2(i,km+1)
      adpn2(i,km+1) = 0.
      adpeln(i,1,j) = adpeln(i,1,j)+adpn2(i,1)
      adpn2(i,1) = 0.
    end do
    do k = 1, km+1
      do i = is, ie
        adpk(i,j,k) = adpk(i,j,k)+adpk1(i,k)
        adpk1(i,k) = 0.
      end do
    end do
    if (nq .ne. 0) then
      pe1 = tape_l2e_b_pe1_40h(:,:,j-js+1)
      q = tape_l2e_b_q_41h(:,:,:,:,j-js+1)
      pe2 = tape_l2e_b_pe2_42h(:,:,j-js+1)
      dp2 = tape_l2e_b_dp2_44h(:,:,j-js+1)
      do iq = nq, 1, -1
        q = tape_l2e_b_q_41h(:,:,:,:,j-js+1)
        do iq2 = 1, iq-1
          call map1_q2( km,pe1,q(isd,jsd,1,iq2),km,pe2,q2,dp2,is,ie,0,kord_tr,j,isd,ied,jsd,jed )
          if (fill) then
            help_i = ie-is+1
            call fillz( help_i,km,1,q2,dp2 )
          endif
          do k = 1, km
            do i = is, ie
              q(i,j,k,iq2) = q2(i,k)
            end do
          end do
        end do
        call map1_q2( km,pe1,q(isd,jsd,1,iq),km,pe2,q2,dp2,is,ie,0,kord_tr,j,isd,ied,jsd,jed )
        do k = 1, km
          do i = is, ie
            adq2(i,k) = adq2(i,k)+adq(i,j,k,iq)
            adq(i,j,k,iq) = 0.
          end do
        end do
        if (fill) then
          help_i = ie-is+1
          call adfillz( help_i,km,1,q2,adq2,dp2,addp2 )
        endif
        call admap1_q2( km,pe1,adpe1,q(isd,jsd,1,iq),adq(isd,jsd,1,iq),km,pe2,adpe2,adq2,is,ie,0,kord_tr,j,isd,ied,jsd,jed )
      end do
    endif
    do k = 1, km
      do i = is, ie
        addp2(i,k) = addp2(i,k)+addelp(i,j,k)
        addelp(i,j,k) = 0.
      end do
    end do
    if (hybrid_z) then
      delp(:,j,:) = tape_l2e_b_delp_19h(:,:,j-js+1)
      ze1 = tape_l2e_b_ze1_21h(:,:,j-js+1)
      ze2 = tape_l2e_b_ze2_22h(:,:,j-js+1)
      help_h = abs(kord_tm)
      delz(:,j,:) = tape_l2e_b_delz_26h(:,:,j-js+1)
      deng = tape_l2e_b_deng_27h(:,:,j-js+1)
      do i = is, ie
        adpe2(i,km+1) = adpe2(i,km+1)+addp2(i,km)
        adpe2(i,km) = adpe2(i,km)-addp2(i,km)
        addp2(i,km) = 0.
      end do
      do k = km-1, 1, -1
        do i = is, ie
          addp2(i,k) = addp2(i,k)+adpe2(i,k+1)
          adpe2(i,k) = adpe2(i,k)+adpe2(i,k+1)
          adpe2(i,k+1) = 0.
          addelz(i,j,k) = addelz(i,j,k)-addp2(i,k)*deng(i,k)
          addeng(i,k) = addeng(i,k)-addp2(i,k)*delz(i,j,k)
          addp2(i,k) = 0.
        end do
      end do
      do k = 1, km
        do i = is, ie
          adze2(i,k+1) = adze2(i,k+1)+addelz(i,j,k)
          adze2(i,k) = adze2(i,k)-addelz(i,j,k)
          addelz(i,j,k) = 0.
        end do
      end do
      adhelp_ag(:,:) = 0.
      help_ag = deng
      call adremap_z( km,ze1,adze1,help_ag,adhelp_ag,km,ze2,adze2,addeng,is,ie,help_h )
      addeng(:,:) = addeng(:,:)+adhelp_ag(:,:)
      delz(:,j,:) = tape_l2e_b_delz_20h(:,:,j-js+1)
      do k = 1, km
        do i = is, ie
          addelp(i,j,k) = addelp(i,j,k)-addeng(i,k)/delz(i,j,k)
          addelz(i,j,k) = addelz(i,j,k)+addeng(i,k)*(delp(i,j,k)/(delz(i,j,k)*delz(i,j,k)))
          addeng(i,k) = 0.
        end do
      end do
      do k = 2, km+1
        do i = is, ie
          adze0(i,j,k) = adze0(i,j,k)+adze2(i,k)
          adze2(i,k) = 0.
        end do
      end do
      do i = is, ie
        adze1(i,1) = adze1(i,1)+adze0(i,j,1)
        adze0(i,j,1) = 0.
        adze1(i,1) = adze1(i,1)+adze2(i,1)
        adze2(i,1) = 0.
      end do
      do k = 1, km
        do i = is, ie
          addelz(i,j,k) = addelz(i,j,k)-adze1(i,k)
          adze1(i,k+1) = adze1(i,k+1)+adze1(i,k)
          adze1(i,k) = 0.
        end do
      end do
      do i = is, ie
        adze0(i,j,km+1) = adze0(i,j,km+1)+adze1(i,km+1)
        adze1(i,km+1) = 0.
      end do
    else
      do k = 1, km
        do i = is, ie
          adpe2(i,k+1) = adpe2(i,k+1)+addp2(i,k)
          adpe2(i,k) = adpe2(i,k)-addp2(i,k)
          addp2(i,k) = 0.
        end do
      end do
      do k = ks+2, km
        do i = is, ie
          adpe(i,km+1,j) = adpe(i,km+1,j)+adpe2(i,k)*bk(k)
          adpe2(i,k) = 0.
        end do
      end do
      do k = 2, ks+1
        do i = is, ie
          adpe2(i,k) = 0.
        end do
      end do
    endif
  endif
  do i = is, ie
    adpe(i,km+1,j) = adpe(i,km+1,j)+adpe2(i,km+1)
    adpe2(i,km+1) = 0.
    adpe2(i,1) = 0.
  end do
  do k = 1, km+1
    do i = is, ie
      adpe(i,k,j) = adpe(i,k,j)+adpe1(i,k)
      adpe1(i,k) = 0.
    end do
  end do
end do
if (( .not. hydrostatic) .and. ( .not. hybrid_z)) then
  delp = tape_l2e_a_delp_16h(:,:,:,1)
  delz = tape_l2e_a_delz_17h(:,:,:,1)
  do k = 1, km
    do j = js, je
      do i = is, ie
        addelp(i,j,k) = addelp(i,j,k)+addelz(i,j,k)*(delz(i,j,k)/(delp(i,j,k)*delp(i,j,k)))
        addelz(i,j,k) = -(addelz(i,j,k)/delp(i,j,k))
      end do
    end do
  end do
endif
if (kord_tm .lt. 0) then
  if (remap_t) then
    pt = tape_l2e_a_pt_2h(:,:,:,1)
    pk = tape_l2e_a_pk_3h(:,:,:,1)
    peln = tape_l2e_a_peln_4h(:,:,:,1)
    do k = 1, km
      do j = js, je
        do i = is, ie
          adpeln(i,k+1,j) = adpeln(i,k+1,j)-adpt(i,j,k)*(pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))*rg/(rg*(peln(i,k+1,j)-peln(i,k,j))*rg*&
&(peln(i,k+1,j)-peln(i,k,j))))
          adpeln(i,k,j) = adpeln(i,k,j)+adpt(i,j,k)*(pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))*rg/(rg*(peln(i,k+1,j)-peln(i,k,j))*rg*&
&(peln(i,k+1,j)-peln(i,k,j))))
          adpk(i,j,k+1) = adpk(i,j,k+1)+adpt(i,j,k)*(pt(i,j,k)/(rg*(peln(i,k+1,j)-peln(i,k,j))))
          adpk(i,j,k) = adpk(i,j,k)-adpt(i,j,k)*(pt(i,j,k)/(rg*(peln(i,k+1,j)-peln(i,k,j))))
          adpt(i,j,k) = adpt(i,j,k)*((pk(i,j,k+1)-pk(i,j,k))/(rg*(peln(i,k+1,j)-peln(i,k,j))))
        end do
      end do
    end do
  endif
else
  pk = tape_l2e_a_pk_7h(:,:,:,1)
  peln = tape_l2e_a_peln_8h(:,:,:,1)
  call pkez( km,is,ie,js,je,pe,pk,akap,peln,pkz )
  ua = tape_l2e_a_ua_13h(:,:,:,1)
  va = tape_l2e_a_va_14h(:,:,:,1)
  pt = tape_l2e_a_pt_15h(:,:,:,1)
  do k = 1, km
    do j = js, je
      do i = is, ie
        adpkz(i,j,k) = adpkz(i,j,k)+adte(i,j,k)*pt(i,j,k)
        adpt(i,j,k) = adpt(i,j,k)+adte(i,j,k)*pkz(i,j,k)
        adua(i,j,k) = adua(i,j,k)+adte(i,j,k)*ua(i,j,k)
        adva(i,j,k) = adva(i,j,k)+adte(i,j,k)*va(i,j,k)
        adte(i,j,k) = 0.
      end do
    end do
  end do
  call adcubed_to_latlon( adu,adv,adua,adva,dx,dy,rdxa,rdya,km )
  peln = tape_l2e_a_peln_8h(:,:,:,1)
  call adpkez( km,is,ie,js,je,pk,adpk,akap,peln,adpeln,adpkz )
endif

!----------------------------------------------
! CLOSE TAPE tape_l2e_a
!----------------------------------------------
if (allocated(tape_l2e_a_pt_2h)) then
  deallocate( tape_l2e_a_pt_2h )
endif
if (allocated(tape_l2e_a_pk_3h)) then
  deallocate( tape_l2e_a_pk_3h )
endif
if (allocated(tape_l2e_a_peln_4h)) then
  deallocate( tape_l2e_a_peln_4h )
endif
if (allocated(tape_l2e_a_pk_7h)) then
  deallocate( tape_l2e_a_pk_7h )
endif
if (allocated(tape_l2e_a_peln_8h)) then
  deallocate( tape_l2e_a_peln_8h )
endif
if (allocated(tape_l2e_a_ua_13h)) then
  deallocate( tape_l2e_a_ua_13h )
endif
if (allocated(tape_l2e_a_va_14h)) then
  deallocate( tape_l2e_a_va_14h )
endif
if (allocated(tape_l2e_a_pt_15h)) then
  deallocate( tape_l2e_a_pt_15h )
endif
if (allocated(tape_l2e_a_delp_16h)) then
  deallocate( tape_l2e_a_delp_16h )
endif
if (allocated(tape_l2e_a_delz_17h)) then
  deallocate( tape_l2e_a_delz_17h )
endif
if (allocated(tape_l2e_a_pe1_20h)) then
  deallocate( tape_l2e_a_pe1_20h )
endif
if (allocated(tape_l2e_a_pe2_21h)) then
  deallocate( tape_l2e_a_pe2_21h )
endif
if (allocated(tape_l2e_a_ua_23h)) then
  deallocate( tape_l2e_a_ua_23h )
endif
if (allocated(tape_l2e_a_u_24h)) then
  deallocate( tape_l2e_a_u_24h )
endif
if (allocated(tape_l2e_a_v_25h)) then
  deallocate( tape_l2e_a_v_25h )
endif
if (allocated(tape_l2e_a_pt_35h)) then
  deallocate( tape_l2e_a_pt_35h )
endif
if (allocated(tape_l2e_a_pkz_36h)) then
  deallocate( tape_l2e_a_pkz_36h )
endif
if (allocated(tape_l2e_a_q_37h)) then
  deallocate( tape_l2e_a_q_37h )
endif
if (allocated(tape_l2e_a_pt_38h)) then
  deallocate( tape_l2e_a_pt_38h )
endif
if (allocated(tape_l2e_a_pkz_39h)) then
  deallocate( tape_l2e_a_pkz_39h )
endif
if (allocated(tape_l2e_a_q_40h)) then
  deallocate( tape_l2e_a_q_40h )
endif

!----------------------------------------------
! CLOSE TAPE tape_l2e_b
!----------------------------------------------
if (allocated(tape_l2e_b_delp_19h)) then
  deallocate( tape_l2e_b_delp_19h )
endif
if (allocated(tape_l2e_b_delz_20h)) then
  deallocate( tape_l2e_b_delz_20h )
endif
if (allocated(tape_l2e_b_ze1_21h)) then
  deallocate( tape_l2e_b_ze1_21h )
endif
if (allocated(tape_l2e_b_ze2_22h)) then
  deallocate( tape_l2e_b_ze2_22h )
endif
if (allocated(tape_l2e_b_delz_26h)) then
  deallocate( tape_l2e_b_delz_26h )
endif
if (allocated(tape_l2e_b_deng_27h)) then
  deallocate( tape_l2e_b_deng_27h )
endif
if (allocated(tape_l2e_b_pe1_40h)) then
  deallocate( tape_l2e_b_pe1_40h )
endif
if (allocated(tape_l2e_b_q_41h)) then
  deallocate( tape_l2e_b_q_41h )
endif
if (allocated(tape_l2e_b_pe2_42h)) then
  deallocate( tape_l2e_b_pe2_42h )
endif
if (allocated(tape_l2e_b_dp2_44h)) then
  deallocate( tape_l2e_b_dp2_44h )
endif
if (allocated(tape_l2e_b_pe2_57h)) then
  deallocate( tape_l2e_b_pe2_57h )
endif
if (allocated(tape_l2e_b_pt_62h)) then
  deallocate( tape_l2e_b_pt_62h )
endif
if (allocated(tape_l2e_b_pk1_63h)) then
  deallocate( tape_l2e_b_pk1_63h )
endif
if (allocated(tape_l2e_b_phis_64h)) then
  deallocate( tape_l2e_b_phis_64h )
endif
if (allocated(tape_l2e_b_pe1_65h)) then
  deallocate( tape_l2e_b_pe1_65h )
endif
if (allocated(tape_l2e_b_phis_67h)) then
  deallocate( tape_l2e_b_phis_67h )
endif
if (allocated(tape_l2e_b_pe1_68h)) then
  deallocate( tape_l2e_b_pe1_68h )
endif
if (allocated(tape_l2e_b_pe1_69h)) then
  deallocate( tape_l2e_b_pe1_69h )
endif
if (allocated(tape_l2e_b_pe2_70h)) then
  deallocate( tape_l2e_b_pe2_70h )
endif
if (allocated(tape_l2e_b_peln_72h)) then
  deallocate( tape_l2e_b_peln_72h )
endif
if (allocated(tape_l2e_b_pn2_74h)) then
  deallocate( tape_l2e_b_pn2_74h )
endif
if (allocated(tape_l2e_b_pk1_75h)) then
  deallocate( tape_l2e_b_pk1_75h )
endif
if (allocated(tape_l2e_b_pk2_76h)) then
  deallocate( tape_l2e_b_pk2_76h )
endif
if (allocated(tape_l2e_b_pe1_78h)) then
  deallocate( tape_l2e_b_pe1_78h )
endif
if (allocated(tape_l2e_b_pe2_79h)) then
  deallocate( tape_l2e_b_pe2_79h )
endif
if (allocated(tape_l2e_b_pe1_81h)) then
  deallocate( tape_l2e_b_pe1_81h )
endif
if (allocated(tape_l2e_b_pe2_82h)) then
  deallocate( tape_l2e_b_pe2_82h )
endif
if (allocated(tape_l2e_b_delz_84h)) then
  deallocate( tape_l2e_b_delz_84h )
endif
if (allocated(tape_l2e_b_dp2_85h)) then
  deallocate( tape_l2e_b_dp2_85h )
endif
if (allocated(tape_l2e_b_pk2_95h)) then
  deallocate( tape_l2e_b_pk2_95h )
endif
if (allocated(tape_l2e_b_peln_96h)) then
  deallocate( tape_l2e_b_peln_96h )
endif
if (allocated(tape_l2e_b_pk2_98h)) then
  deallocate( tape_l2e_b_pk2_98h )
endif
if (allocated(tape_l2e_b_peln_99h)) then
  deallocate( tape_l2e_b_peln_99h )
endif
if (allocated(tape_l2e_b_delp_101h)) then
  deallocate( tape_l2e_b_delp_101h )
endif
if (allocated(tape_l2e_b_delz_102h)) then
  deallocate( tape_l2e_b_delz_102h )
endif
if (allocated(tape_l2e_b_pt_103h)) then
  deallocate( tape_l2e_b_pt_103h )
endif
if (allocated(tape_l2e_b_dp2_106h)) then
  deallocate( tape_l2e_b_dp2_106h )
endif
if (allocated(tape_l2e_b_pe0_107h)) then
  deallocate( tape_l2e_b_pe0_107h )
endif
if (allocated(tape_l2e_b_pe3_109h)) then
  deallocate( tape_l2e_b_pe3_109h )
endif
if (allocated(tape_l2e_b_pe0_119h)) then
  deallocate( tape_l2e_b_pe0_119h )
endif
if (allocated(tape_l2e_b_pe3_120h)) then
  deallocate( tape_l2e_b_pe3_120h )
endif
if (allocated(tape_l2e_b_pe0_125h)) then
  deallocate( tape_l2e_b_pe0_125h )
endif
if (allocated(tape_l2e_b_pe3_126h)) then
  deallocate( tape_l2e_b_pe3_126h )
endif

!----------------------------------------------
! CLOSE TAPE tape_l2e_c
!----------------------------------------------
if (allocated(tape_l2e_c_pe0_6h)) then
  deallocate( tape_l2e_c_pe0_6h )
endif
if (allocated(tape_l2e_c_pe3_7h)) then
  deallocate( tape_l2e_c_pe3_7h )
endif
if (allocated(tape_l2e_c_te_8h)) then
  deallocate( tape_l2e_c_te_8h )
endif
if (allocated(tape_l2e_c_delp_9h)) then
  deallocate( tape_l2e_c_delp_9h )
endif
if (allocated(tape_l2e_c_te_11h)) then
  deallocate( tape_l2e_c_te_11h )
endif
if (allocated(tape_l2e_c_delp_12h)) then
  deallocate( tape_l2e_c_delp_12h )
endif
if (allocated(tape_l2e_c_pt_14h)) then
  deallocate( tape_l2e_c_pt_14h )
endif
if (allocated(tape_l2e_c_peln_15h)) then
  deallocate( tape_l2e_c_peln_15h )
endif
if (allocated(tape_l2e_c_pe_17h)) then
  deallocate( tape_l2e_c_pe_17h )
endif
if (allocated(tape_l2e_c_pe_18h)) then
  deallocate( tape_l2e_c_pe_18h )
endif
if (allocated(tape_l2e_c_delp_20h)) then
  deallocate( tape_l2e_c_delp_20h )
endif
if (allocated(tape_l2e_c_pt_21h)) then
  deallocate( tape_l2e_c_pt_21h )
endif
if (allocated(tape_l2e_c_ua_22h)) then
  deallocate( tape_l2e_c_ua_22h )
endif
if (allocated(tape_l2e_c_va_23h)) then
  deallocate( tape_l2e_c_va_23h )
endif
if (allocated(tape_l2e_c_pt_24h)) then
  deallocate( tape_l2e_c_pt_24h )
endif
if (allocated(tape_l2e_c_pk_25h)) then
  deallocate( tape_l2e_c_pk_25h )
endif
if (allocated(tape_l2e_c_pe_26h)) then
  deallocate( tape_l2e_c_pe_26h )
endif
if (allocated(tape_l2e_c_pe_27h)) then
  deallocate( tape_l2e_c_pe_27h )
endif
if (allocated(tape_l2e_c_pkz_29h)) then
  deallocate( tape_l2e_c_pkz_29h )
endif
if (allocated(tape_l2e_c_pt_30h)) then
  deallocate( tape_l2e_c_pt_30h )
endif
if (allocated(tape_l2e_c_delp_31h)) then
  deallocate( tape_l2e_c_delp_31h )
endif
if (allocated(tape_l2e_c_ua_33h)) then
  deallocate( tape_l2e_c_ua_33h )
endif
if (allocated(tape_l2e_c_va_34h)) then
  deallocate( tape_l2e_c_va_34h )
endif
if (allocated(tape_l2e_c_delp_37h)) then
  deallocate( tape_l2e_c_delp_37h )
endif
if (allocated(tape_l2e_c_pt_38h)) then
  deallocate( tape_l2e_c_pt_38h )
endif
if (allocated(tape_l2e_c_pkz_39h)) then
  deallocate( tape_l2e_c_pkz_39h )
endif
if (allocated(tape_l2e_c_phis_40h)) then
  deallocate( tape_l2e_c_phis_40h )
endif
if (allocated(tape_l2e_c_ua_41h)) then
  deallocate( tape_l2e_c_ua_41h )
endif
if (allocated(tape_l2e_c_va_42h)) then
  deallocate( tape_l2e_c_va_42h )
endif
if (allocated(tape_l2e_c_w_43h)) then
  deallocate( tape_l2e_c_w_43h )
endif
if (allocated(tape_l2e_c_pkz_45h)) then
  deallocate( tape_l2e_c_pkz_45h )
endif
if (allocated(tape_l2e_c_delp_46h)) then
  deallocate( tape_l2e_c_delp_46h )
endif
if (allocated(tape_l2e_c_pkz_48h)) then
  deallocate( tape_l2e_c_pkz_48h )
endif
if (allocated(tape_l2e_c_delp_49h)) then
  deallocate( tape_l2e_c_delp_49h )
endif
if (allocated(tape_l2e_c_te_57h)) then
  deallocate( tape_l2e_c_te_57h )
endif
if (allocated(tape_l2e_c_ua_58h)) then
  deallocate( tape_l2e_c_ua_58h )
endif
if (allocated(tape_l2e_c_va_59h)) then
  deallocate( tape_l2e_c_va_59h )
endif
if (allocated(tape_l2e_c_gz_60h)) then
  deallocate( tape_l2e_c_gz_60h )
endif
if (allocated(tape_l2e_c_peln_61h)) then
  deallocate( tape_l2e_c_peln_61h )
endif
if (allocated(tape_l2e_c_pe_62h)) then
  deallocate( tape_l2e_c_pe_62h )
endif
if (allocated(tape_l2e_c_delp_63h)) then
  deallocate( tape_l2e_c_delp_63h )
endif
if (allocated(tape_l2e_c_q_64h)) then
  deallocate( tape_l2e_c_q_64h )
endif
if (allocated(tape_l2e_c_pkz_65h)) then
  deallocate( tape_l2e_c_pkz_65h )
endif


!----------------------------------------------
! FREE DYNAMIC MEMORY
!----------------------------------------------
                     call timing_off('adl2e_adj')

end subroutine adlagrangian_to_eulerian


subroutine admap1_ppm( km, pe1, adpe1, q1, adq1, kn, pe2, adpe2, adq2, i1, i2, j, ibeg, iend, jbeg, jend, iv, kord )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.50  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: km
real, intent(inout) :: adpe1(i1:i2,km+1)
integer, intent(in) :: kn
real, intent(inout) :: adpe2(i1:i2,kn+1)
integer, intent(in) :: ibeg
integer, intent(in) :: iend
integer, intent(in) :: jbeg
integer, intent(in) :: jend
real, intent(inout) :: adq1(ibeg:iend,jbeg:jend,km)
real, intent(inout) :: adq2(ibeg:iend,jbeg:jend,kn)
integer, intent(in) :: iv
integer, intent(in) :: j
integer, intent(in) :: kord
real, intent(in) :: pe1(i1:i2,km+1)
real, intent(in) :: pe2(i1:i2,kn+1)
real, intent(in) :: q1(ibeg:iend,jbeg:jend,km)

!==============================================
! declare local variables
!==============================================
real :: addp1(i1:i2,km)
real :: adq4(4,i1:i2,km)
real :: dp1(i1:i2,km)
integer :: i
integer :: k
real :: q4(4,i1:i2,km)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
addp1(:,:) = 0.
adq4(:,:,:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
do k = 1, km
  do i = i1, i2
    dp1(i,k) = pe1(i,k+1)-pe1(i,k)
    q4(1,i,k) = q1(i,j,k)
  end do
end do
if (kord .gt. 7) then
  call cs_profile( q4,dp1,km,i1,i2,iv )
else
  call ppm_profile( q4,dp1,km,i1,i2,iv,kord )
endif
do i = i2, i1, -1
  call admapz( pe1(i,:),adpe1(i,:),pe2(i,:),adpe2(i,:),dp1(i,:),addp1(i,:),q4(:,i,:),adq4(:,i,:),adq2(i,j,:),km,kn,1 )
end do
do k = 1, km
  do i = i1, i2
    q4(1,i,k) = q1(i,j,k)
  end do
end do
if (kord .gt. 7) then
  call adcs_profile( q4,adq4,dp1,addp1,km,i1,i2,iv )
else
  call adppm_profile( q4,adq4,dp1,addp1,km,i1,i2,iv,kord )
endif
do k = 1, km
  do i = i1, i2
    adq1(i,j,k) = adq1(i,j,k)+adq4(1,i,k)
    adq4(1,i,k) = 0.
    adpe1(i,k+1) = adpe1(i,k+1)+addp1(i,k)
    adpe1(i,k) = adpe1(i,k)-addp1(i,k)
    addp1(i,k) = 0.
  end do
end do

end subroutine admap1_ppm


subroutine admap1_q2( km, pe1, adpe1, q1, adq1, kn, pe2, adpe2, adq2, i1, i2, iv, kord, j, ibeg, iend, jbeg, jend )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.50  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: km
real, intent(inout) :: adpe1(i1:i2,km+1)
integer, intent(in) :: kn
real, intent(inout) :: adpe2(i1:i2,kn+1)
integer, intent(in) :: ibeg
integer, intent(in) :: iend
integer, intent(in) :: jbeg
integer, intent(in) :: jend
real, intent(inout) :: adq1(ibeg:iend,jbeg:jend,km)
real, intent(inout) :: adq2(i1:i2,kn)
integer, intent(in) :: iv
integer, intent(in) :: j
integer, intent(in) :: kord
real, intent(in) :: pe1(i1:i2,km+1)
real, intent(in) :: pe2(i1:i2,kn+1)
real, intent(in) :: q1(ibeg:iend,jbeg:jend,km)

!==============================================
! declare local variables
!==============================================
real :: addp1(i1:i2,km)
real :: adq4(4,i1:i2,km)
real :: dp1(i1:i2,km)
integer :: i
integer :: k
real :: q4(4,i1:i2,km)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
addp1(:,:) = 0.
adq4(:,:,:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
do k = 1, km
  do i = i1, i2
    dp1(i,k) = pe1(i,k+1)-pe1(i,k)
    q4(1,i,k) = q1(i,j,k)
  end do
end do
if (kord .gt. 7) then
  call cs_profile( q4,dp1,km,i1,i2,iv )
else
  call ppm_profile( q4,dp1,km,i1,i2,iv,kord )
endif
do i = i2, i1, -1
  call admapz( pe1(i,:),adpe1(i,:),pe2(i,:),adpe2(i,:),dp1(i,:),addp1(i,:),q4(:,i,:),adq4(:,i,:),adq2(i,:),km,kn,1 )
end do
do k = 1, km
  do i = i1, i2
    q4(1,i,k) = q1(i,j,k)
  end do
end do
if (kord .gt. 7) then
  call adcs_profile( q4,adq4,dp1,addp1,km,i1,i2,iv )
else
  call adppm_profile( q4,adq4,dp1,addp1,km,i1,i2,iv,kord )
endif
do k = 1, km
  do i = i1, i2
    adq1(i,j,k) = adq1(i,j,k)+adq4(1,i,k)
    adq4(1,i,k) = 0.
    adpe1(i,k+1) = adpe1(i,k+1)+addp1(i,k)
    adpe1(i,k) = adpe1(i,k)-addp1(i,k)
    addp1(i,k) = 0.
  end do
end do

end subroutine admap1_q2


subroutine admapz( pe1, adpe1, pe2, adpe2, dp1, addp1, q4, adq4, adq2, km, kn, order )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.50  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r23 = 2./3.
real, parameter :: r3 = 1./3.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: km
real, intent(inout) :: addp1(km)
real, intent(inout) :: adpe1(km+1)
integer, intent(in) :: kn
real, intent(inout) :: adpe2(kn+1)
real, intent(inout) :: adq2(kn)
real, intent(inout) :: adq4(4,km)
real, intent(in) :: dp1(km)
integer, intent(in) :: order
real, intent(in) :: pe1(km+1)
real, intent(in) :: pe2(kn+1)
real, intent(in) :: q4(4,km)

!==============================================
! declare local variables
!==============================================
real :: addp
real :: adesl
real :: adpl
real :: adpr
real :: adqsum
real :: dp
real :: esl
logical :: i_am_done
logical :: i_am_doneh
logical :: i_am_donei
integer :: k
integer :: k0
integer :: k1
integer :: k2
integer :: l
integer :: l1
integer :: l2
integer :: m
integer :: m1
integer :: m2
real :: pl
real :: pr
real :: qsum

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
addp = 0.
adesl = 0.
adpl = 0.
adpr = 0.
adqsum = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
if (order .eq. 1) then
  k0 = 1
  do k = kn, 1, -1
    k0 = 1
    do k2 = 1, k-1
      i_am_done =  .false. 
      do l = k0, km
        if (pe2(k2) .ge. pe1(l) .and. pe2(k2) .le. pe1(l+1) .and. ( .not. i_am_done)) then
          if (pe2(k2+1) .le. pe1(l+1)) then
            k0 = l
            i_am_done =  .true. 
          else
            do m = l+1, km
              if ( .not. i_am_done) then
if (pe2(k2+1) .gt. pe1(m+1)) then
else
  k0 = m
  i_am_done =  .true. 
endif
              endif
            end do
            i_am_done =  .true. 
          endif
        endif
      end do
    end do
    i_am_done =  .false. 
    do l = km, k0, -1
      i_am_done =  .false. 
      do l2 = k0, l-1
        if (pe2(k) .ge. pe1(l2) .and. pe2(k) .le. pe1(l2+1) .and. ( .not. i_am_done)) then
          if (pe2(k+1) .le. pe1(l2+1)) then
            i_am_done =  .true. 
          else
            i_am_done =  .true. 
          endif
        endif
      end do
      i_am_donei = i_am_done
      if (pe2(k) .ge. pe1(l) .and. pe2(k) .le. pe1(l+1) .and. ( .not. i_am_done)) then
        pl = (pe2(k)-pe1(l))/dp1(l)
        if (pe2(k+1) .le. pe1(l+1)) then
          pr = (pe2(k+1)-pe1(l))/dp1(l)
          adpl = adpl+adq2(k)*(0.5*(q4(4,l)+q4(3,l)-q4(2,l))-q4(4,l)*r3*(pr+2*pl))
          adpr = adpr+adq2(k)*(0.5*(q4(4,l)+q4(3,l)-q4(2,l))-q4(4,l)*r3*(2*pr+pl))
          adq4(4,l) = adq4(4,l)+adq2(k)*(0.5*(pr+pl)-r3*(pr*(pr+pl)+pl**2))
          adq4(3,l) = adq4(3,l)+0.5*adq2(k)*(pr+pl)
          adq4(2,l) = adq4(2,l)+adq2(k)*(1+(-0.5)*(pr+pl))
          adq2(k) = 0.
          addp1(l) = addp1(l)-adpr*((pe2(k+1)-pe1(l))/(dp1(l)*dp1(l)))
          adpe1(l) = adpe1(l)-adpr/dp1(l)
          adpe2(k+1) = adpe2(k+1)+adpr/dp1(l)
          adpr = 0.
        else
          qsum = (pe1(l+1)-pe2(k))*(q4(2,l)+0.5*(q4(4,l)+q4(3,l)-q4(2,l))*(1.+pl)-q4(4,l)*r3*(1.+pl*(1.+pl)))
          do m = l+1, km
            if ( .not. i_am_done) then
              if (pe2(k+1) .gt. pe1(m+1)) then
qsum = qsum+dp1(m)*q4(1,m)
              else
dp = pe2(k+1)-pe1(m)
esl = dp/dp1(m)
qsum = qsum+dp*(q4(2,m)+0.5*esl*(q4(3,m)-q4(2,m)+q4(4,m)*(1.-r23*esl)))
i_am_done =  .true. 
              endif
            endif
          end do
          if ( .not. i_am_done) then
            adpe2(k+1) = adpe2(k+1)-adq2(k)*(qsum/((pe2(k+1)-pe2(k))*(pe2(k+1)-pe2(k))))
            adpe2(k) = adpe2(k)+adq2(k)*(qsum/((pe2(k+1)-pe2(k))*(pe2(k+1)-pe2(k))))
            adqsum = adqsum+adq2(k)/(pe2(k+1)-pe2(k))
            adq2(k) = 0.
          endif
          i_am_done = i_am_donei
          qsum = (pe1(l+1)-pe2(k))*(q4(2,l)+0.5*(q4(4,l)+q4(3,l)-q4(2,l))*(1.+pl)-q4(4,l)*r3*(1.+pl*(1.+pl)))
          do m = km, l+1, -1
            i_am_done = i_am_donei
            qsum = (pe1(l+1)-pe2(k))*(q4(2,l)+0.5*(q4(4,l)+q4(3,l)-q4(2,l))*(1.+pl)-q4(4,l)*r3*(1.+pl*(1.+pl)))
            do m2 = l+1, m-1
              if ( .not. i_am_done) then
if (pe2(k+1) .gt. pe1(m2+1)) then
  qsum = qsum+dp1(m2)*q4(1,m2)
else
  dp = pe2(k+1)-pe1(m2)
  esl = dp/dp1(m2)
  qsum = qsum+dp*(q4(2,m2)+0.5*esl*(q4(3,m2)-q4(2,m2)+q4(4,m2)*(1.-r23*esl)))
  i_am_done =  .true. 
endif
              endif
            end do
            if ( .not. i_am_done) then
              if (pe2(k+1) .gt. pe1(m+1)) then
addp1(m) = addp1(m)+adqsum*q4(1,m)
adq4(1,m) = adq4(1,m)+adqsum*dp1(m)
              else
dp = pe2(k+1)-pe1(m)
esl = dp/dp1(m)
qsum = qsum+dp*(q4(2,m)+0.5*esl*(q4(3,m)-q4(2,m)+q4(4,m)*(1.-r23*esl)))
adpe2(k+1) = adpe2(k+1)-adq2(k)*(qsum/((pe2(k+1)-pe2(k))*(pe2(k+1)-pe2(k))))
adpe2(k) = adpe2(k)+adq2(k)*(qsum/((pe2(k+1)-pe2(k))*(pe2(k+1)-pe2(k))))
adqsum = adqsum+adq2(k)/(pe2(k+1)-pe2(k))
adq2(k) = 0.
addp = addp+adqsum*(q4(2,m)+0.5*esl*(q4(3,m)-q4(2,m)+q4(4,m)*(1.-r23*esl)))
adesl = adesl+adqsum*dp*((-(0.5*esl*q4(4,m)*r23))+0.5*(q4(3,m)-q4(2,m)+q4(4,m)*(1.-r23*esl)))
adq4(4,m) = adq4(4,m)+0.5*adqsum*dp*esl*(1.-r23*esl)
adq4(3,m) = adq4(3,m)+0.5*adqsum*dp*esl
adq4(2,m) = adq4(2,m)+adqsum*dp*(1+(-0.5)*esl)
addp = addp+adesl/dp1(m)
addp1(m) = addp1(m)-adesl*(dp/(dp1(m)*dp1(m)))
adesl = 0.
adpe1(m) = adpe1(m)-addp
adpe2(k+1) = adpe2(k+1)+addp
addp = 0.
              endif
            endif
          end do
          adpe1(l+1) = adpe1(l+1)+adqsum*(q4(2,l)+0.5*(q4(4,l)+q4(3,l)-q4(2,l))*(1.+pl)-q4(4,l)*r3*(1.+pl*(1.+pl)))
          adpe2(k) = adpe2(k)-adqsum*(q4(2,l)+0.5*(q4(4,l)+q4(3,l)-q4(2,l))*(1.+pl)-q4(4,l)*r3*(1.+pl*(1.+pl)))
          adpl = adpl+adqsum*(pe1(l+1)-pe2(k))*(0.5*(q4(4,l)+q4(3,l)-q4(2,l))-q4(4,l)*r3*(1+2*pl))
          adq4(4,l) = adq4(4,l)+adqsum*(pe1(l+1)-pe2(k))*(0.5*(1.+pl)-r3*(1.+pl*(1.+pl)))
          adq4(3,l) = adq4(3,l)+0.5*adqsum*(pe1(l+1)-pe2(k))*(1.+pl)
          adq4(2,l) = adq4(2,l)+adqsum*(pe1(l+1)-pe2(k))*(1+(-0.5)*(1.+pl))
          adqsum = 0.
        endif
        addp1(l) = addp1(l)-adpl*((pe2(k)-pe1(l))/(dp1(l)*dp1(l)))
        adpe1(l) = adpe1(l)-adpl/dp1(l)
        adpe2(k) = adpe2(k)+adpl/dp1(l)
        adpl = 0.
      endif
    end do
  end do
else
  k0 = 1
  do k = kn, 1, -1
    k0 = 1
    do k1 = 1, k-1
      i_am_done =  .false. 
      do l = k0, km
        if (pe2(k1) .le. pe1(l) .and. pe2(k1) .ge. pe1(l+1) .and. ( .not. i_am_done)) then
          if (pe2(k1+1) .ge. pe1(l+1)) then
            k0 = l
            i_am_done =  .true. 
          else
            do m = l+1, km
              if ( .not. i_am_done) then
if (pe2(k1+1) .lt. pe1(m+1)) then
else
  k0 = m
  i_am_done =  .true. 
endif
              endif
            end do
            i_am_done =  .true. 
          endif
        endif
      end do
    end do
    i_am_done =  .false. 
    do l = km, k0, -1
      i_am_done =  .false. 
      do l1 = k0, l-1
        if (pe2(k) .le. pe1(l1) .and. pe2(k) .ge. pe1(l1+1) .and. ( .not. i_am_done)) then
          if (pe2(k+1) .ge. pe1(l1+1)) then
            i_am_done =  .true. 
          else
            i_am_done =  .true. 
          endif
        endif
      end do
      i_am_doneh = i_am_done
      if (pe2(k) .le. pe1(l) .and. pe2(k) .ge. pe1(l+1) .and. ( .not. i_am_done)) then
        pl = (pe2(k)-pe1(l))/dp1(l)
        if (pe2(k+1) .ge. pe1(l+1)) then
          pr = (pe2(k+1)-pe1(l))/dp1(l)
          adpl = adpl+adq2(k)*(0.5*(q4(4,l)+q4(3,l)-q4(2,l))-q4(4,l)*r3*(pr+2*pl))
          adpr = adpr+adq2(k)*(0.5*(q4(4,l)+q4(3,l)-q4(2,l))-q4(4,l)*r3*(2*pr+pl))
          adq4(4,l) = adq4(4,l)+adq2(k)*(0.5*(pr+pl)-r3*(pr*(pr+pl)+pl**2))
          adq4(3,l) = adq4(3,l)+0.5*adq2(k)*(pr+pl)
          adq4(2,l) = adq4(2,l)+adq2(k)*(1+(-0.5)*(pr+pl))
          adq2(k) = 0.
          addp1(l) = addp1(l)-adpr*((pe2(k+1)-pe1(l))/(dp1(l)*dp1(l)))
          adpe1(l) = adpe1(l)-adpr/dp1(l)
          adpe2(k+1) = adpe2(k+1)+adpr/dp1(l)
          adpr = 0.
        else
          qsum = (pe1(l+1)-pe2(k))*(q4(2,l)+0.5*(q4(4,l)+q4(3,l)-q4(2,l))*(1.+pl)-q4(4,l)*r3*(1.+pl*(1.+pl)))
          do m = l+1, km
            if ( .not. i_am_done) then
              if (pe2(k+1) .lt. pe1(m+1)) then
qsum = qsum+dp1(m)*q4(1,m)
              else
dp = pe2(k+1)-pe1(m)
esl = dp/dp1(m)
qsum = qsum+dp*(q4(2,m)+0.5*esl*(q4(3,m)-q4(2,m)+q4(4,m)*(1.-r23*esl)))
i_am_done =  .true. 
              endif
            endif
          end do
          if ( .not. i_am_done) then
            adpe2(k+1) = adpe2(k+1)-adq2(k)*(qsum/((pe2(k+1)-pe2(k))*(pe2(k+1)-pe2(k))))
            adpe2(k) = adpe2(k)+adq2(k)*(qsum/((pe2(k+1)-pe2(k))*(pe2(k+1)-pe2(k))))
            adqsum = adqsum+adq2(k)/(pe2(k+1)-pe2(k))
            adq2(k) = 0.
          endif
          i_am_done = i_am_doneh
          qsum = (pe1(l+1)-pe2(k))*(q4(2,l)+0.5*(q4(4,l)+q4(3,l)-q4(2,l))*(1.+pl)-q4(4,l)*r3*(1.+pl*(1.+pl)))
          do m = km, l+1, -1
            i_am_done = i_am_doneh
            qsum = (pe1(l+1)-pe2(k))*(q4(2,l)+0.5*(q4(4,l)+q4(3,l)-q4(2,l))*(1.+pl)-q4(4,l)*r3*(1.+pl*(1.+pl)))
            do m1 = l+1, m-1
              if ( .not. i_am_done) then
if (pe2(k+1) .lt. pe1(m1+1)) then
  qsum = qsum+dp1(m1)*q4(1,m1)
else
  dp = pe2(k+1)-pe1(m1)
  esl = dp/dp1(m1)
  qsum = qsum+dp*(q4(2,m1)+0.5*esl*(q4(3,m1)-q4(2,m1)+q4(4,m1)*(1.-r23*esl)))
  i_am_done =  .true. 
endif
              endif
            end do
            if ( .not. i_am_done) then
              if (pe2(k+1) .lt. pe1(m+1)) then
addp1(m) = addp1(m)+adqsum*q4(1,m)
adq4(1,m) = adq4(1,m)+adqsum*dp1(m)
              else
dp = pe2(k+1)-pe1(m)
esl = dp/dp1(m)
qsum = qsum+dp*(q4(2,m)+0.5*esl*(q4(3,m)-q4(2,m)+q4(4,m)*(1.-r23*esl)))
adpe2(k+1) = adpe2(k+1)-adq2(k)*(qsum/((pe2(k+1)-pe2(k))*(pe2(k+1)-pe2(k))))
adpe2(k) = adpe2(k)+adq2(k)*(qsum/((pe2(k+1)-pe2(k))*(pe2(k+1)-pe2(k))))
adqsum = adqsum+adq2(k)/(pe2(k+1)-pe2(k))
adq2(k) = 0.
addp = addp+adqsum*(q4(2,m)+0.5*esl*(q4(3,m)-q4(2,m)+q4(4,m)*(1.-r23*esl)))
adesl = adesl+adqsum*dp*((-(0.5*esl*q4(4,m)*r23))+0.5*(q4(3,m)-q4(2,m)+q4(4,m)*(1.-r23*esl)))
adq4(4,m) = adq4(4,m)+0.5*adqsum*dp*esl*(1.-r23*esl)
adq4(3,m) = adq4(3,m)+0.5*adqsum*dp*esl
adq4(2,m) = adq4(2,m)+adqsum*dp*(1+(-0.5)*esl)
addp = addp+adesl/dp1(m)
addp1(m) = addp1(m)-adesl*(dp/(dp1(m)*dp1(m)))
adesl = 0.
adpe1(m) = adpe1(m)-addp
adpe2(k+1) = adpe2(k+1)+addp
addp = 0.
              endif
            endif
          end do
          adpe1(l+1) = adpe1(l+1)+adqsum*(q4(2,l)+0.5*(q4(4,l)+q4(3,l)-q4(2,l))*(1.+pl)-q4(4,l)*r3*(1.+pl*(1.+pl)))
          adpe2(k) = adpe2(k)-adqsum*(q4(2,l)+0.5*(q4(4,l)+q4(3,l)-q4(2,l))*(1.+pl)-q4(4,l)*r3*(1.+pl*(1.+pl)))
          adpl = adpl+adqsum*(pe1(l+1)-pe2(k))*(0.5*(q4(4,l)+q4(3,l)-q4(2,l))-q4(4,l)*r3*(1+2*pl))
          adq4(4,l) = adq4(4,l)+adqsum*(pe1(l+1)-pe2(k))*(0.5*(1.+pl)-r3*(1.+pl*(1.+pl)))
          adq4(3,l) = adq4(3,l)+0.5*adqsum*(pe1(l+1)-pe2(k))*(1.+pl)
          adq4(2,l) = adq4(2,l)+adqsum*(pe1(l+1)-pe2(k))*(1+(-0.5)*(1.+pl))
          adqsum = 0.
        endif
        addp1(l) = addp1(l)-adpl*((pe2(k)-pe1(l))/(dp1(l)*dp1(l)))
        adpe1(l) = adpe1(l)-adpl/dp1(l)
        adpe2(k) = adpe2(k)+adpl/dp1(l)
        adpl = 0.
      endif
    end do
  end do
endif

end subroutine admapz


subroutine adpkez( km, ifirst, ilast, jfirst, jlast, pk, adpk, akap, peln, adpeln, adpkz )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.50  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: ifirst
integer, intent(in) :: ilast
integer, intent(in) :: jfirst
integer, intent(in) :: jlast
integer, intent(in) :: km
real, intent(inout) :: adpeln(ifirst:ilast,km+1,jfirst:jlast)
real, intent(inout) :: adpk(ifirst:ilast,jfirst:jlast,km+1)
real, intent(inout) :: adpkz(ifirst:ilast,jfirst:jlast,km)
real, intent(in) :: akap
real, intent(out) :: peln(ifirst:ilast,km+1,jfirst:jlast)
real, intent(in) :: pk(ifirst:ilast,jfirst:jlast,km+1)

!==============================================
! declare local variables
!==============================================
real :: adpek
real :: adpk2(ifirst:ilast,km+1)
real :: ak1
integer :: i
integer :: j
integer :: k
real :: lnp
real :: pek
real :: pk2(ifirst:ilast,km+1)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
adpek = 0.
adpk2(:,:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
ak1 = (akap+1.)/akap
do j = jlast, jfirst, -1
  adpek = 0.
  pek = pk(ifirst,j,1)
  do i = ifirst, ilast
    pk2(i,1) = pek
  end do
  do k = 2, km+1
    do i = ifirst, ilast
      pk2(i,k) = pk(i,j,k)
    end do
  end do
  if (ptop .lt. ptop_min) then
    do i = ifirst, ilast
      peln(i,1,j) = peln(i,2,j)-ak1
    end do
  else
    lnp = log(ptop)
    do i = ifirst, ilast
      peln(i,1,j) = lnp
    end do
  endif
  do k = 1, km
    do i = ifirst, ilast
      adpeln(i,k+1,j) = adpeln(i,k+1,j)-adpkz(i,j,k)*((pk2(i,k+1)-pk2(i,k))*akap/(akap*(peln(i,k+1,j)-peln(i,k,j))*akap*(peln(i,k+&
&1,j)-peln(i,k,j))))
      adpeln(i,k,j) = adpeln(i,k,j)+adpkz(i,j,k)*((pk2(i,k+1)-pk2(i,k))*akap/(akap*(peln(i,k+1,j)-peln(i,k,j))*akap*(peln(i,k+1,j)-&
&peln(i,k,j))))
      adpk2(i,k+1) = adpk2(i,k+1)+adpkz(i,j,k)/(akap*(peln(i,k+1,j)-peln(i,k,j)))
      adpk2(i,k) = adpk2(i,k)-adpkz(i,j,k)/(akap*(peln(i,k+1,j)-peln(i,k,j)))
      adpkz(i,j,k) = 0.
    end do
  end do
  if (ptop .lt. ptop_min) then
    do i = ifirst, ilast
      adpeln(i,2,j) = adpeln(i,2,j)+adpeln(i,1,j)
      adpeln(i,1,j) = 0.
    end do
  else
    do i = ifirst, ilast
      adpeln(i,1,j) = 0.
    end do
  endif
  do k = 2, km+1
    do i = ifirst, ilast
      adpk(i,j,k) = adpk(i,j,k)+adpk2(i,k)
      adpk2(i,k) = 0.
    end do
  end do
  do i = ifirst, ilast
    adpek = adpek+adpk2(i,1)
    adpk2(i,1) = 0.
  end do
  adpk(ifirst,j,1) = adpk(ifirst,j,1)+adpek
  adpek = 0.
end do

end subroutine adpkez


subroutine adppm_limiters( dm, addm, a4, ada4, itot, lmt )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.50  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r12 = 1./12.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: itot
real, intent(inout) :: a4(4,itot)
real, intent(inout) :: ada4(4,itot)
real, intent(inout) :: addm(itot)
real, intent(in) :: dm(itot)
integer, intent(in) :: lmt

!==============================================
! declare local variables
!==============================================
real :: a4k
real :: a4l
real :: a6da
real :: ada4l
real :: ada4m
real :: ada4n
real :: ada4o
real :: ada6da
real :: adda1
real :: adda2
real :: adfmin
real :: adqmp
real :: da1
real :: da2
real :: fmin
integer :: i
real :: qmp
real, allocatable :: tape_a4_in4_a4_1h(:,:)
integer :: tape_a4_in4_ppm_limiters

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
ada6da = 0.
adda1 = 0.
adda2 = 0.
adfmin = 0.
adqmp = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
if (lmt .ne. 3) then
  if (lmt .eq. 0) then
    do i = itot, 1, -1
      ada6da = 0.
      adda1 = 0.
      adda2 = 0.
      if (dm(i) .eq. 0.) then
        ada4(4,i) = 0.
        ada4(1,i) = ada4(1,i)+ada4(3,i)
        ada4(3,i) = 0.
        ada4(1,i) = ada4(1,i)+ada4(2,i)
        ada4(2,i) = 0.
      else
        da1 = a4(3,i)-a4(2,i)
        da2 = da1**2
        a6da = a4(4,i)*da1
        if (a6da .lt. (-da2)) then
          ada4(4,i) = ada4(4,i)-ada4(3,i)
          ada4(2,i) = ada4(2,i)+ada4(3,i)
          ada4(3,i) = 0.
          ada4(2,i) = ada4(2,i)+3*ada4(4,i)
          ada4(1,i) = ada4(1,i)-3*ada4(4,i)
          ada4(4,i) = 0.
        else if (a6da .gt. da2) then
          ada4(4,i) = ada4(4,i)-ada4(2,i)
          ada4(3,i) = ada4(3,i)+ada4(2,i)
          ada4(2,i) = 0.
          ada4(3,i) = ada4(3,i)+3*ada4(4,i)
          ada4(1,i) = ada4(1,i)-3*ada4(4,i)
          ada4(4,i) = 0.
        endif
        ada4(4,i) = ada4(4,i)+ada6da*da1
        adda1 = adda1+ada6da*a4(4,i)
        ada6da = 0.
        adda1 = adda1+2*adda2*da1
        adda2 = 0.
        ada4(3,i) = ada4(3,i)+adda1
        ada4(2,i) = ada4(2,i)-adda1
        adda1 = 0.
      endif
    end do
  else if (lmt .eq. 1) then
!----------------------------------------------
! OPEN TAPE tape_a4_in4
!----------------------------------------------
    tape_a4_in4_ppm_limiters = itot

!----------------------------------------------
! TAPE COMPUTATIONS
!----------------------------------------------
    do i = 1, itot
      if ( .not. allocated(tape_a4_in4_a4_1h)) then
        allocate( tape_a4_in4_a4_1h(1:4,tape_a4_in4_ppm_limiters) )
      endif
      tape_a4_in4_a4_1h(:,i) = a4(:,i)
    end do

!----------------------------------------------
! ADJOINT COMPUTATIONS
!----------------------------------------------
    do i = itot, 1, -1
      adqmp = 0.
      a4(:,i) = tape_a4_in4_a4_1h(:,i)
      qmp = 2.*dm(i)
      a4(2,i) = a4(1,i)-sign(min(abs(qmp),abs(a4(2,i)-a4(1,i))),qmp)
      ada4(3,i) = ada4(3,i)-3*ada4(4,i)
      ada4(2,i) = ada4(2,i)-3*ada4(4,i)
      ada4(1,i) = ada4(1,i)+6*ada4(4,i)
      ada4(4,i) = 0.
      a4k = a4(3,i)-a4(1,i)
      ada4(1,i) = ada4(1,i)+ada4(3,i)
      ada4l = ada4(3,i)*sign(1.,min(abs(qmp),abs(a4k)))*sign(1.,qmp)
      ada4m = ada4l*(0.5-sign(0.5,abs(a4k)-abs(qmp)))*sign(1.,a4k)
      adqmp = adqmp+ada4l*(0.5+sign(0.5,abs(a4k)-abs(qmp)))*sign(1.,qmp)
      ada4(3,i) = ada4m
      ada4(1,i) = ada4(1,i)-ada4m
      a4(:,i) = tape_a4_in4_a4_1h(:,i)
      a4l = a4(2,i)-a4(1,i)
      ada4(1,i) = ada4(1,i)+ada4(2,i)
      ada4n = -(ada4(2,i)*sign(1.,min(abs(qmp),abs(a4l)))*sign(1.,qmp))
      ada4o = ada4n*(0.5-sign(0.5,abs(a4l)-abs(qmp)))*sign(1.,a4l)
      adqmp = adqmp+ada4n*(0.5+sign(0.5,abs(a4l)-abs(qmp)))*sign(1.,qmp)
      ada4(2,i) = ada4o
      ada4(1,i) = ada4(1,i)-ada4o
      addm(i) = addm(i)+2*adqmp
      adqmp = 0.
    end do

!----------------------------------------------
! CLOSE TAPE tape_a4_in4
!----------------------------------------------
    if (allocated(tape_a4_in4_a4_1h)) then
      deallocate( tape_a4_in4_a4_1h )
    endif

  else if (lmt .eq. 2) then
    do i = itot, 1, -1
      adfmin = 0.
      if (abs(a4(3,i)-a4(2,i)) .lt. (-a4(4,i))) then
        fmin = a4(1,i)+0.25*(a4(3,i)-a4(2,i))**2/a4(4,i)+a4(4,i)*r12
        if (fmin .lt. 0.) then
          if (a4(1,i) .lt. a4(3,i) .and. a4(1,i) .lt. a4(2,i)) then
            ada4(4,i) = 0.
            ada4(1,i) = ada4(1,i)+ada4(2,i)
            ada4(2,i) = 0.
            ada4(1,i) = ada4(1,i)+ada4(3,i)
            ada4(3,i) = 0.
          else if (a4(3,i) .gt. a4(2,i)) then
            ada4(4,i) = ada4(4,i)-ada4(3,i)
            ada4(2,i) = ada4(2,i)+ada4(3,i)
            ada4(3,i) = 0.
            ada4(2,i) = ada4(2,i)+3*ada4(4,i)
            ada4(1,i) = ada4(1,i)-3*ada4(4,i)
            ada4(4,i) = 0.
          else
            ada4(4,i) = ada4(4,i)-ada4(2,i)
            ada4(3,i) = ada4(3,i)+ada4(2,i)
            ada4(2,i) = 0.
            ada4(3,i) = ada4(3,i)+3*ada4(4,i)
            ada4(1,i) = ada4(1,i)-3*ada4(4,i)
            ada4(4,i) = 0.
          endif
        endif
        ada4(4,i) = ada4(4,i)+adfmin*((-(0.25*(a4(3,i)-a4(2,i))**2/(a4(4,i)*a4(4,i))))+r12)
        ada4(3,i) = ada4(3,i)+adfmin*(0.5*(a4(3,i)-a4(2,i))/a4(4,i))
        ada4(2,i) = ada4(2,i)+adfmin*((-0.5)*(a4(3,i)-a4(2,i))/a4(4,i))
        ada4(1,i) = ada4(1,i)+adfmin
        adfmin = 0.
      endif
    end do
  endif
endif

end subroutine adppm_limiters


subroutine adppm_profile( a4, ada4, delp, addelp, km, i1, i2, iv, kord )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.50  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: km
real, intent(inout) :: a4(4,i1:i2,km)
real, intent(inout) :: ada4(4,i1:i2,km)
real, intent(inout) :: addelp(i1:i2,km)
real, intent(in) :: delp(i1:i2,km)
integer, intent(in) :: iv
integer, intent(in) :: kord

!==============================================
! declare local variables
!==============================================
real :: a1
real :: a2
real :: a4h(lbound(a4,1):ubound(a4,1),lbound(a4,2):ubound(a4,2),lbound(a4,3):ubound(a4,3))
real :: a4i
real :: a4j
real :: a4k
real :: a4l
real :: a4m
real :: a4n
real :: a4o
real :: a4p
real :: a4q
real :: a4r
real :: a4s(lbound(a4,1):ubound(a4,1),lbound(a4,2):ubound(a4,2),lbound(a4,3):ubound(a4,3))
real :: a4t
real :: a4u
real :: a4v
real :: a4w
real :: ada1
real :: ada2
real :: ada4i
real :: ada4j
real :: ada4k
real :: ada4l
real :: ada4m
real :: ada4n
real :: ada4o
real :: ada4p
real :: ada4q
real :: ada4r
real :: ada4t
real :: ada4u
real :: ada4v
real :: ada4w
real :: adc1
real :: adc2
real :: adc3
real :: add1
real :: add2
real :: add4(i1:i2,km)
real :: addc(i1:i2,km)
real :: addch
real :: addci
real :: addck
real :: addcl
real :: addcm
real :: addcn
real :: addco
real :: addcp
real :: addelq(i1:i2,km)
real :: addf2(i1:i2,km)
real :: addq
real :: adh2(i1:i2,km)
real :: adlac
real :: adpmp
real :: adqm
real :: adqmp
real :: c1
real :: c2
real :: c3
real :: d1
real :: d2
real :: d4(i1:i2,km)
real :: dc(i1:i2,km)
real :: dch
real :: dci
real :: dck
real :: dcl
real :: dcn
real :: dco
real :: delq(i1:i2,km)
real :: df2(i1:i2,km)
real :: dq
real :: fac
real :: h2(i1:i2,km)
integer :: i
integer :: ib2
integer :: ib4
integer :: ib5
integer :: ib6
integer :: ib7
integer :: ib8
integer :: ib9
integer :: ica
integer :: it
integer :: k
integer :: k1
integer :: k2
integer :: k3
integer :: k4
integer :: ka1
integer :: ka2
integer :: ka3
integer :: ka4
integer :: km1
real :: lac
integer :: lmt
real :: pmp
real :: qm
real :: qmp

!----------------------------------------------
! SAVE REQUIRED INPUT VARIABLES
!----------------------------------------------
a4h(:,:,:) = a4(:,:,:)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
ada1 = 0.
ada2 = 0.
adc1 = 0.
adc2 = 0.
adc3 = 0.
add1 = 0.
add2 = 0.
add4(:,:) = 0.
addc(:,:) = 0.
addelq(:,:) = 0.
addf2(:,:) = 0.
addq = 0.
adh2(:,:) = 0.
adlac = 0.
adpmp = 0.
adqm = 0.
adqmp = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
km1 = km-1
it = i2-i1+1
do k = 2, km
  do i = i1, i2
    delq(i,k-1) = a4(1,i,k)-a4(1,i,k-1)
    d4(i,k) = delp(i,k-1)+delp(i,k)
  end do
end do
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i1, i2
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
  dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,1) = max(0.,a4(2,i,1))
    a4(2,i,2) = max(0.,a4(2,i,2))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
  end do
endif
do i = i1, i2
  d1 = delp(i,km)
  d2 = delp(i,km1)
  qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
  dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
  c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
  a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
  a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
  a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
  dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,km) = max(0.,a4(2,i,km))
    a4(3,i,km) = max(0.,a4(3,i,km))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
      a4(3,i,km) = 0.
    endif
  end do
endif
do k = 1, km1
  do i = i1, i2
    a4(3,i,k) = a4(2,i,k+1)
  end do
end do
do k = 1, 2
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call ppm_limiters( dc(i1,k),a4(1,i1,k),it,0 )
end do
if (kord .ge. 7) then
  do k = 2, km1
    do i = i1, i2
      h2(i,k) = 2.*(dc(i,k+1)/delp(i,k+1)-dc(i,k-1)/delp(i,k-1))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*delp(i,k)**2
    end do
  end do
  fac = 1.5
  do k = 3, km-2
    do i = i1, i2
      pmp = 2.*dc(i,k)
      qmp = a4(1,i,k)+pmp
      lac = a4(1,i,k)+fac*h2(i,k-1)+dc(i,k)
      a4(3,i,k) = min(max(a4(3,i,k),min(a4(1,i,k),qmp,lac)),max(a4(1,i,k),qmp,lac))
      qmp = a4(1,i,k)-pmp
      lac = a4(1,i,k)+fac*h2(i,k+1)-dc(i,k)
      a4(2,i,k) = min(max(a4(2,i,k),min(a4(1,i,k),qmp,lac)),max(a4(1,i,k),qmp,lac))
      a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
    end do
    if (iv .eq. 0 .and. kord .ge. 6) then
      call ppm_limiters( dc(i1,k),a4(1,i1,k),it,2 )
    endif
  end do
else
  lmt = kord-3
  lmt = max(0,lmt)
  if (iv .eq. 0) then
    lmt = min(2,lmt)
  endif
  do k = 3, km-2
    if (kord .ne. 4) then
      do i = i1, i2
        a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
      end do
    endif
    if (kord .ne. 6) then
      call ppm_limiters( dc(i1,k),a4(1,i1,k),it,lmt )
    endif
  end do
endif
do k = km, km1, -1
  a4(:,:,:) = a4h(:,:,:)
  do ka1 = 2, km1
    do i = i1, i2
      c1 = (delp(i,ka1-1)+0.5*delp(i,ka1))/d4(i,ka1+1)
      c2 = (delp(i,ka1+1)+0.5*delp(i,ka1))/d4(i,ka1)
      df2(i,ka1) = delp(i,ka1)*(c1*delq(i,ka1)+c2*delq(i,ka1-1))/(d4(i,ka1)+delp(i,ka1+1))
      dc(i,ka1) = sign(min(abs(df2(i,ka1)),max(a4(1,i,ka1-1),a4(1,i,ka1),a4(1,i,ka1+1))-a4(1,i,ka1),a4(1,i,ka1)-min(a4(1,i,ka1-1),&
&a4(1,i,ka1),a4(1,i,ka1+1))),df2(i,ka1))
    end do
  end do
  do ka1 = 3, km1
    do i = i1, i2
      c1 = delq(i,ka1-1)*delp(i,ka1-1)/d4(i,ka1)
      a1 = d4(i,ka1-1)/(d4(i,ka1)+delp(i,ka1-1))
      a2 = d4(i,ka1+1)/(d4(i,ka1)+delp(i,ka1))
      a4(2,i,ka1) = a4(1,i,ka1-1)+c1+2./(d4(i,ka1-1)+d4(i,ka1+1))*(delp(i,ka1)*(c1*(a1-a2)+a2*dc(i,ka1-1))-delp(i,ka1-1)*a1*dc(i,&
&ka1))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  do i = i1, i2
    d1 = delp(i,1)
    d2 = delp(i,2)
    qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
    dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
    c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
    a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
    a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
    a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
    dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
  end do
  if (iv .eq. 0) then
    do i = i1, i2
      a4(2,i,1) = max(0.,a4(2,i,1))
      a4(2,i,2) = max(0.,a4(2,i,2))
    end do
  else if (iv .eq. (-1)) then
    do i = i1, i2
      if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
        a4(2,i,1) = 0.
      endif
    end do
  endif
  do i = i1, i2
    d1 = delp(i,km)
    d2 = delp(i,km1)
    qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
    dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
    c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
    a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
    a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
    a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
    dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
  end do
  if (iv .eq. 0) then
    do i = i1, i2
      a4(2,i,km) = max(0.,a4(2,i,km))
      a4(3,i,km) = max(0.,a4(3,i,km))
    end do
  else if (iv .eq. (-1)) then
    do i = i1, i2
      if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
        a4(3,i,km) = 0.
      endif
    end do
  endif
  do ka1 = 1, km1
    do i = i1, i2
      a4(3,i,ka1) = a4(2,i,ka1+1)
    end do
  end do
  do ka1 = 1, 2
    do i = i1, i2
      a4(4,i,ka1) = 3.*(2.*a4(1,i,ka1)-(a4(2,i,ka1)+a4(3,i,ka1)))
    end do
    call ppm_limiters( dc(i1,ka1),a4(1,i1,ka1),it,0 )
  end do
  if (kord .ge. 7) then
    do ka1 = 2, km1
      do i = i1, i2
        h2(i,ka1) = 2.*(dc(i,ka1+1)/delp(i,ka1+1)-dc(i,ka1-1)/delp(i,ka1-1))/(delp(i,ka1)+0.5*(delp(i,ka1-1)+delp(i,ka1+1)))*&
&delp(i,ka1)**2
      end do
    end do
    fac = 1.5
    do ka1 = 3, km-2
      do i = i1, i2
        pmp = 2.*dc(i,ka1)
        qmp = a4(1,i,ka1)+pmp
        lac = a4(1,i,ka1)+fac*h2(i,ka1-1)+dc(i,ka1)
        a4(3,i,ka1) = min(max(a4(3,i,ka1),min(a4(1,i,ka1),qmp,lac)),max(a4(1,i,ka1),qmp,lac))
        qmp = a4(1,i,ka1)-pmp
        lac = a4(1,i,ka1)+fac*h2(i,ka1+1)-dc(i,ka1)
        a4(2,i,ka1) = min(max(a4(2,i,ka1),min(a4(1,i,ka1),qmp,lac)),max(a4(1,i,ka1),qmp,lac))
        a4(4,i,ka1) = 3.*(2.*a4(1,i,ka1)-(a4(2,i,ka1)+a4(3,i,ka1)))
      end do
      if (iv .eq. 0 .and. kord .ge. 6) then
        call ppm_limiters( dc(i1,ka1),a4(1,i1,ka1),it,2 )
      endif
    end do
  else
    lmt = kord-3
    lmt = max(0,lmt)
    if (iv .eq. 0) then
      lmt = min(2,lmt)
    endif
    do ka1 = 3, km-2
      if (kord .ne. 4) then
        do i = i1, i2
          a4(4,i,ka1) = 3.*(2.*a4(1,i,ka1)-(a4(2,i,ka1)+a4(3,i,ka1)))
        end do
      endif
      if (kord .ne. 6) then
        call ppm_limiters( dc(i1,ka1),a4(1,i1,ka1),it,lmt )
      endif
    end do
  endif
  do k1 = km1, k-1
    do i = i1, i2
      a4(4,i,k1) = 3.*(2.*a4(1,i,k1)-(a4(2,i,k1)+a4(3,i,k1)))
    end do
    call ppm_limiters( dc(i1,k1),a4(1,i1,k1),it,0 )
  end do
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call adppm_limiters( dc(i1,k),addc(i1,k),a4(1,i1,k),ada4(1,i1,k),it,0 )
  do i = i1, i2
    ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
    ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
    ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
    ada4(4,i,k) = 0.
  end do
end do
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i1, i2
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
  dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,1) = max(0.,a4(2,i,1))
    a4(2,i,2) = max(0.,a4(2,i,2))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
  end do
endif
do i = i1, i2
  d1 = delp(i,km)
  d2 = delp(i,km1)
  qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
  dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
  c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
  a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
  a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
  a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
  dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,km) = max(0.,a4(2,i,km))
    a4(3,i,km) = max(0.,a4(3,i,km))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
      a4(3,i,km) = 0.
    endif
  end do
endif
do k = 1, km1
  do i = i1, i2
    a4(3,i,k) = a4(2,i,k+1)
  end do
end do
do k = 1, 2
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call ppm_limiters( dc(i1,k),a4(1,i1,k),it,0 )
end do
if (kord .ge. 7) then
  do k = 2, km1
    do i = i1, i2
      h2(i,k) = 2.*(dc(i,k+1)/delp(i,k+1)-dc(i,k-1)/delp(i,k-1))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*delp(i,k)**2
    end do
  end do
  fac = 1.5
  do k = km-2, 3, -1
    a4(:,:,:) = a4h(:,:,:)
    do ka3 = 2, km1
      do i = i1, i2
        c1 = (delp(i,ka3-1)+0.5*delp(i,ka3))/d4(i,ka3+1)
        c2 = (delp(i,ka3+1)+0.5*delp(i,ka3))/d4(i,ka3)
        df2(i,ka3) = delp(i,ka3)*(c1*delq(i,ka3)+c2*delq(i,ka3-1))/(d4(i,ka3)+delp(i,ka3+1))
        dc(i,ka3) = sign(min(abs(df2(i,ka3)),max(a4(1,i,ka3-1),a4(1,i,ka3),a4(1,i,ka3+1))-a4(1,i,ka3),a4(1,i,ka3)-min(a4(1,i,ka3-1)&
&,a4(1,i,ka3),a4(1,i,ka3+1))),df2(i,ka3))
      end do
    end do
    do ka3 = 3, km1
      do i = i1, i2
        c1 = delq(i,ka3-1)*delp(i,ka3-1)/d4(i,ka3)
        a1 = d4(i,ka3-1)/(d4(i,ka3)+delp(i,ka3-1))
        a2 = d4(i,ka3+1)/(d4(i,ka3)+delp(i,ka3))
        a4(2,i,ka3) = a4(1,i,ka3-1)+c1+2./(d4(i,ka3-1)+d4(i,ka3+1))*(delp(i,ka3)*(c1*(a1-a2)+a2*dc(i,ka3-1))-delp(i,ka3-1)*a1*dc(i,&
&ka3))
      end do
    end do
    if (km .gt. 8 .and. kord .gt. 3) then
      call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
    endif
    do i = i1, i2
      d1 = delp(i,1)
      d2 = delp(i,2)
      qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
      dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
      c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
      c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
      a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
      a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
      a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
      a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
      dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
    end do
    if (iv .eq. 0) then
      do i = i1, i2
        a4(2,i,1) = max(0.,a4(2,i,1))
        a4(2,i,2) = max(0.,a4(2,i,2))
      end do
    else if (iv .eq. (-1)) then
      do i = i1, i2
        if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
          a4(2,i,1) = 0.
        endif
      end do
    endif
    do i = i1, i2
      d1 = delp(i,km)
      d2 = delp(i,km1)
      qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
      dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
      c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
      c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
      a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
      a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
      a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
      a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
      dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
    end do
    if (iv .eq. 0) then
      do i = i1, i2
        a4(2,i,km) = max(0.,a4(2,i,km))
        a4(3,i,km) = max(0.,a4(3,i,km))
      end do
    else if (iv .eq. (-1)) then
      do i = i1, i2
        if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
          a4(3,i,km) = 0.
        endif
      end do
    endif
    do ka3 = 1, km1
      do i = i1, i2
        a4(3,i,ka3) = a4(2,i,ka3+1)
      end do
    end do
    do ka3 = 1, 2
      do i = i1, i2
        a4(4,i,ka3) = 3.*(2.*a4(1,i,ka3)-(a4(2,i,ka3)+a4(3,i,ka3)))
      end do
      call ppm_limiters( dc(i1,ka3),a4(1,i1,ka3),it,0 )
    end do
    do k3 = 3, k-1
      do i = i1, i2
        pmp = 2.*dc(i,k3)
        qmp = a4(1,i,k3)+pmp
        lac = a4(1,i,k3)+fac*h2(i,k3-1)+dc(i,k3)
        a4(3,i,k3) = min(max(a4(3,i,k3),min(a4(1,i,k3),qmp,lac)),max(a4(1,i,k3),qmp,lac))
        qmp = a4(1,i,k3)-pmp
        lac = a4(1,i,k3)+fac*h2(i,k3+1)-dc(i,k3)
        a4(2,i,k3) = min(max(a4(2,i,k3),min(a4(1,i,k3),qmp,lac)),max(a4(1,i,k3),qmp,lac))
        a4(4,i,k3) = 3.*(2.*a4(1,i,k3)-(a4(2,i,k3)+a4(3,i,k3)))
      end do
      if (iv .eq. 0 .and. kord .ge. 6) then
        call ppm_limiters( dc(i1,k3),a4(1,i1,k3),it,2 )
      endif
    end do
    a4s(:,:,:) = a4(:,:,:)
    do i = i1, i2
      pmp = 2.*dc(i,k)
      qmp = a4(1,i,k)+pmp
      lac = a4(1,i,k)+fac*h2(i,k-1)+dc(i,k)
      a4(3,i,k) = min(max(a4(3,i,k),min(a4(1,i,k),qmp,lac)),max(a4(1,i,k),qmp,lac))
      qmp = a4(1,i,k)-pmp
      lac = a4(1,i,k)+fac*h2(i,k+1)-dc(i,k)
      a4(2,i,k) = min(max(a4(2,i,k),min(a4(1,i,k),qmp,lac)),max(a4(1,i,k),qmp,lac))
      a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
    end do
    if (iv .eq. 0 .and. kord .ge. 6) then
      call adppm_limiters( dc(i1,k),addc(i1,k),a4(1,i1,k),ada4(1,i1,k),it,2 )
    endif
    a4(:,:,:) = a4s(:,:,:)
    do i = i2, i1, -1
      adlac = 0.
      adpmp = 0.
      adqmp = 0.
      pmp = 2.*dc(i,k)
      qmp = a4(1,i,k)+pmp
      lac = a4(1,i,k)+fac*h2(i,k-1)+dc(i,k)
      a4(3,i,k) = min(max(a4(3,i,k),min(a4(1,i,k),qmp,lac)),max(a4(1,i,k),qmp,lac))
      qmp = a4(1,i,k)-pmp
      lac = a4(1,i,k)+fac*h2(i,k+1)-dc(i,k)
      ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
      ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
      ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
      ada4(4,i,k) = 0.
      a4j = min(a4(1,i,k),qmp)
      a4k = min(a4j,lac)
      a4i = max(a4(2,i,k),a4k)
      a4l = max(a4(1,i,k),qmp)
      a4m = max(a4l,lac)
      ada4i = ada4(2,i,k)*(0.5+sign(0.5,a4m-a4i))
      ada4m = ada4(2,i,k)*(0.5-sign(0.5,a4m-a4i))
      ada4l = ada4m*(0.5+sign(0.5,a4l-lac))
      adlac = adlac+ada4m*(0.5-sign(0.5,a4l-lac))
      ada4(1,i,k) = ada4(1,i,k)+ada4l*(0.5+sign(0.5,a4(1,i,k)-qmp))
      adqmp = adqmp+ada4l*(0.5-sign(0.5,a4(1,i,k)-qmp))
      ada4(2,i,k) = ada4i*(0.5+sign(0.5,a4(2,i,k)-a4k))
      ada4k = ada4i*(0.5-sign(0.5,a4(2,i,k)-a4k))
      ada4j = ada4k*(0.5+sign(0.5,lac-a4j))
      adlac = adlac+ada4k*(0.5-sign(0.5,lac-a4j))
      ada4(1,i,k) = ada4(1,i,k)+ada4j*(0.5+sign(0.5,qmp-a4(1,i,k)))
      adqmp = adqmp+ada4j*(0.5-sign(0.5,qmp-a4(1,i,k)))
      ada4(1,i,k) = ada4(1,i,k)+adlac
      addc(i,k) = addc(i,k)-adlac
      adh2(i,k+1) = adh2(i,k+1)+adlac*fac
      adlac = 0.
      ada4(1,i,k) = ada4(1,i,k)+adqmp
      adpmp = adpmp-adqmp
      adqmp = 0.
      a4(:,:,:) = a4s(:,:,:)
      qmp = a4(1,i,k)+pmp
      lac = a4(1,i,k)+fac*h2(i,k-1)+dc(i,k)
      a4o = min(a4(1,i,k),qmp)
      a4p = min(a4o,lac)
      a4n = max(a4(3,i,k),a4p)
      a4q = max(a4(1,i,k),qmp)
      a4r = max(a4q,lac)
      ada4n = ada4(3,i,k)*(0.5+sign(0.5,a4r-a4n))
      ada4r = ada4(3,i,k)*(0.5-sign(0.5,a4r-a4n))
      ada4q = ada4r*(0.5+sign(0.5,a4q-lac))
      adlac = adlac+ada4r*(0.5-sign(0.5,a4q-lac))
      ada4(1,i,k) = ada4(1,i,k)+ada4q*(0.5+sign(0.5,a4(1,i,k)-qmp))
      adqmp = adqmp+ada4q*(0.5-sign(0.5,a4(1,i,k)-qmp))
      ada4(3,i,k) = ada4n*(0.5+sign(0.5,a4(3,i,k)-a4p))
      ada4p = ada4n*(0.5-sign(0.5,a4(3,i,k)-a4p))
      ada4o = ada4p*(0.5+sign(0.5,lac-a4o))
      adlac = adlac+ada4p*(0.5-sign(0.5,lac-a4o))
      ada4(1,i,k) = ada4(1,i,k)+ada4o*(0.5+sign(0.5,qmp-a4(1,i,k)))
      adqmp = adqmp+ada4o*(0.5-sign(0.5,qmp-a4(1,i,k)))
      ada4(1,i,k) = ada4(1,i,k)+adlac
      addc(i,k) = addc(i,k)+adlac
      adh2(i,k-1) = adh2(i,k-1)+adlac*fac
      adlac = 0.
      ada4(1,i,k) = ada4(1,i,k)+adqmp
      adpmp = adpmp+adqmp
      adqmp = 0.
      addc(i,k) = addc(i,k)+2*adpmp
      adpmp = 0.
    end do
  end do
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do i = i1, i2
      c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
      c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
      df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
      dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,&
&k+1))),df2(i,k))
    end do
  end do
  do k = 3, km1
    do i = i1, i2
      c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
      a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
      a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
      a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  do i = i1, i2
    d1 = delp(i,1)
    d2 = delp(i,2)
    qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
    dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
    c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
    a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
    a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
    a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
    dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
  end do
  if (iv .eq. 0) then
    do i = i1, i2
      a4(2,i,1) = max(0.,a4(2,i,1))
      a4(2,i,2) = max(0.,a4(2,i,2))
    end do
  else if (iv .eq. (-1)) then
    do i = i1, i2
      if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
        a4(2,i,1) = 0.
      endif
    end do
  endif
  do i = i1, i2
    d1 = delp(i,km)
    d2 = delp(i,km1)
    qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
    dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
    c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
    a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
    a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
    a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
    dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
  end do
  if (iv .eq. 0) then
    do i = i1, i2
      a4(2,i,km) = max(0.,a4(2,i,km))
      a4(3,i,km) = max(0.,a4(3,i,km))
    end do
  else if (iv .eq. (-1)) then
    do i = i1, i2
      if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
        a4(3,i,km) = 0.
      endif
    end do
  endif
  do k = 1, km1
    do i = i1, i2
      a4(3,i,k) = a4(2,i,k+1)
    end do
  end do
  do k = 1, 2
    do i = i1, i2
      a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
    end do
    call ppm_limiters( dc(i1,k),a4(1,i1,k),it,0 )
  end do
  do k = 2, km1
    do i = i1, i2
      addc(i,k-1) = addc(i,k-1)-adh2(i,k)*2.*(1/delp(i,k-1))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*delp(i,k)**2
      addc(i,k+1) = addc(i,k+1)+adh2(i,k)*2.*(1/delp(i,k+1))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*delp(i,k)**2
      addelp(i,k-1) = addelp(i,k-1)+adh2(i,k)*(2.*(dc(i,k-1)/(delp(i,k-1)*delp(i,k-1)))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))-&
&(dc(i,k+1)/delp(i,k+1)-dc(i,k-1)/delp(i,k-1))/((delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*(delp(i,k)+0.5*(delp(i,k-1)+delp(i,&
&k+1)))))*delp(i,k)**2
      addelp(i,k+1) = addelp(i,k+1)-adh2(i,k)*(2.*(dc(i,k+1)/(delp(i,k+1)*delp(i,k+1)))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))+&
&(dc(i,k+1)/delp(i,k+1)-dc(i,k-1)/delp(i,k-1))/((delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*(delp(i,k)+0.5*(delp(i,k-1)+delp(i,&
&k+1)))))*delp(i,k)**2
      addelp(i,k) = addelp(i,k)+adh2(i,k)*(2*2.*(dc(i,k+1)/delp(i,k+1)-dc(i,k-1)/delp(i,k-1))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+&
&1)))*delp(i,k)-2*(dc(i,k+1)/delp(i,k+1)-dc(i,k-1)/delp(i,k-1))/((delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*(delp(i,k)+0.5*&
&(delp(i,k-1)+delp(i,k+1))))*delp(i,k)**2)
      adh2(i,k) = 0.
    end do
  end do
else
  lmt = kord-3
  lmt = max(0,lmt)
  if (iv .eq. 0) then
    lmt = min(2,lmt)
  endif
  do k = km-2, 3, -1
    a4(:,:,:) = a4h(:,:,:)
    do ka2 = 2, km1
      do i = i1, i2
        c1 = (delp(i,ka2-1)+0.5*delp(i,ka2))/d4(i,ka2+1)
        c2 = (delp(i,ka2+1)+0.5*delp(i,ka2))/d4(i,ka2)
        df2(i,ka2) = delp(i,ka2)*(c1*delq(i,ka2)+c2*delq(i,ka2-1))/(d4(i,ka2)+delp(i,ka2+1))
        dc(i,ka2) = sign(min(abs(df2(i,ka2)),max(a4(1,i,ka2-1),a4(1,i,ka2),a4(1,i,ka2+1))-a4(1,i,ka2),a4(1,i,ka2)-min(a4(1,i,ka2-1)&
&,a4(1,i,ka2),a4(1,i,ka2+1))),df2(i,ka2))
      end do
    end do
    do ka2 = 3, km1
      do i = i1, i2
        c1 = delq(i,ka2-1)*delp(i,ka2-1)/d4(i,ka2)
        a1 = d4(i,ka2-1)/(d4(i,ka2)+delp(i,ka2-1))
        a2 = d4(i,ka2+1)/(d4(i,ka2)+delp(i,ka2))
        a4(2,i,ka2) = a4(1,i,ka2-1)+c1+2./(d4(i,ka2-1)+d4(i,ka2+1))*(delp(i,ka2)*(c1*(a1-a2)+a2*dc(i,ka2-1))-delp(i,ka2-1)*a1*dc(i,&
&ka2))
      end do
    end do
    if (km .gt. 8 .and. kord .gt. 3) then
      call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
    endif
    do i = i1, i2
      d1 = delp(i,1)
      d2 = delp(i,2)
      qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
      dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
      c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
      c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
      a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
      a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
      a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
      a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
      dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
    end do
    if (iv .eq. 0) then
      do i = i1, i2
        a4(2,i,1) = max(0.,a4(2,i,1))
        a4(2,i,2) = max(0.,a4(2,i,2))
      end do
    else if (iv .eq. (-1)) then
      do i = i1, i2
        if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
          a4(2,i,1) = 0.
        endif
      end do
    endif
    do i = i1, i2
      d1 = delp(i,km)
      d2 = delp(i,km1)
      qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
      dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
      c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
      c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
      a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
      a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
      a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
      a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
      dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
    end do
    if (iv .eq. 0) then
      do i = i1, i2
        a4(2,i,km) = max(0.,a4(2,i,km))
        a4(3,i,km) = max(0.,a4(3,i,km))
      end do
    else if (iv .eq. (-1)) then
      do i = i1, i2
        if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
          a4(3,i,km) = 0.
        endif
      end do
    endif
    do ka2 = 1, km1
      do i = i1, i2
        a4(3,i,ka2) = a4(2,i,ka2+1)
      end do
    end do
    do ka2 = 1, 2
      do i = i1, i2
        a4(4,i,ka2) = 3.*(2.*a4(1,i,ka2)-(a4(2,i,ka2)+a4(3,i,ka2)))
      end do
      call ppm_limiters( dc(i1,ka2),a4(1,i1,ka2),it,0 )
    end do
    do k2 = 3, k-1
      if (kord .ne. 4) then
        do i = i1, i2
          a4(4,i,k2) = 3.*(2.*a4(1,i,k2)-(a4(2,i,k2)+a4(3,i,k2)))
        end do
      endif
      if (kord .ne. 6) then
        call ppm_limiters( dc(i1,k2),a4(1,i1,k2),it,lmt )
      endif
    end do
    if (kord .ne. 4) then
      do i = i1, i2
        a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
      end do
    endif
    if (kord .ne. 6) then
      call adppm_limiters( dc(i1,k),addc(i1,k),a4(1,i1,k),ada4(1,i1,k),it,lmt )
    endif
    if (kord .ne. 4) then
      do i = i1, i2
        ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
        ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
        ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
        ada4(4,i,k) = 0.
      end do
    endif
  end do
endif
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i1, i2
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
  dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,1) = max(0.,a4(2,i,1))
    a4(2,i,2) = max(0.,a4(2,i,2))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
  end do
endif
do i = i1, i2
  d1 = delp(i,km)
  d2 = delp(i,km1)
  qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
  dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
  c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
  a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
  a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
  a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
  dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,km) = max(0.,a4(2,i,km))
    a4(3,i,km) = max(0.,a4(3,i,km))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
      a4(3,i,km) = 0.
    endif
  end do
endif
do k = 1, km1
  do i = i1, i2
    a4(3,i,k) = a4(2,i,k+1)
  end do
end do
do k = 2, 1, -1
  a4(:,:,:) = a4h(:,:,:)
  do ka4 = 2, km1
    do i = i1, i2
      c1 = (delp(i,ka4-1)+0.5*delp(i,ka4))/d4(i,ka4+1)
      c2 = (delp(i,ka4+1)+0.5*delp(i,ka4))/d4(i,ka4)
      df2(i,ka4) = delp(i,ka4)*(c1*delq(i,ka4)+c2*delq(i,ka4-1))/(d4(i,ka4)+delp(i,ka4+1))
      dc(i,ka4) = sign(min(abs(df2(i,ka4)),max(a4(1,i,ka4-1),a4(1,i,ka4),a4(1,i,ka4+1))-a4(1,i,ka4),a4(1,i,ka4)-min(a4(1,i,ka4-1),&
&a4(1,i,ka4),a4(1,i,ka4+1))),df2(i,ka4))
    end do
  end do
  do ka4 = 3, km1
    do i = i1, i2
      c1 = delq(i,ka4-1)*delp(i,ka4-1)/d4(i,ka4)
      a1 = d4(i,ka4-1)/(d4(i,ka4)+delp(i,ka4-1))
      a2 = d4(i,ka4+1)/(d4(i,ka4)+delp(i,ka4))
      a4(2,i,ka4) = a4(1,i,ka4-1)+c1+2./(d4(i,ka4-1)+d4(i,ka4+1))*(delp(i,ka4)*(c1*(a1-a2)+a2*dc(i,ka4-1))-delp(i,ka4-1)*a1*dc(i,&
&ka4))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  do i = i1, i2
    d1 = delp(i,1)
    d2 = delp(i,2)
    qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
    dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
    c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
    a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
    a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
    a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
    dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
  end do
  if (iv .eq. 0) then
    do i = i1, i2
      a4(2,i,1) = max(0.,a4(2,i,1))
      a4(2,i,2) = max(0.,a4(2,i,2))
    end do
  else if (iv .eq. (-1)) then
    do i = i1, i2
      if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
        a4(2,i,1) = 0.
      endif
    end do
  endif
  do i = i1, i2
    d1 = delp(i,km)
    d2 = delp(i,km1)
    qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
    dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
    c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
    a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
    a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
    a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
    dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
  end do
  if (iv .eq. 0) then
    do i = i1, i2
      a4(2,i,km) = max(0.,a4(2,i,km))
      a4(3,i,km) = max(0.,a4(3,i,km))
    end do
  else if (iv .eq. (-1)) then
    do i = i1, i2
      if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
        a4(3,i,km) = 0.
      endif
    end do
  endif
  do ka4 = 1, km1
    do i = i1, i2
      a4(3,i,ka4) = a4(2,i,ka4+1)
    end do
  end do
  do k4 = 1, k-1
    do i = i1, i2
      a4(4,i,k4) = 3.*(2.*a4(1,i,k4)-(a4(2,i,k4)+a4(3,i,k4)))
    end do
    call ppm_limiters( dc(i1,k4),a4(1,i1,k4),it,0 )
  end do
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call adppm_limiters( dc(i1,k),addc(i1,k),a4(1,i1,k),ada4(1,i1,k),it,0 )
  do i = i1, i2
    ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
    ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
    ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
    ada4(4,i,k) = 0.
  end do
end do
do k = 1, km1
  do i = i1, i2
    ada4(2,i,k+1) = ada4(2,i,k+1)+ada4(3,i,k)
    ada4(3,i,k) = 0.
  end do
end do
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i1, i2
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,1) = max(0.,a4(2,i,1))
    a4(2,i,2) = max(0.,a4(2,i,2))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
  end do
endif
do i = i1, i2
  d1 = delp(i,km)
  d2 = delp(i,km1)
  qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
  dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
  c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
  a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
  a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
  a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,km) = max(0.,a4(2,i,km))
    ada4(3,i,km) = ada4(3,i,km)*(0.5-sign(0.5,0.-a4(3,i,km)))
    a4(:,:,:) = a4h(:,:,:)
    do k = 2, km1
      do ib2 = i1, i2
        c1 = (delp(ib2,k-1)+0.5*delp(ib2,k))/d4(ib2,k+1)
        c2 = (delp(ib2,k+1)+0.5*delp(ib2,k))/d4(ib2,k)
        df2(ib2,k) = delp(ib2,k)*(c1*delq(ib2,k)+c2*delq(ib2,k-1))/(d4(ib2,k)+delp(ib2,k+1))
        dc(ib2,k) = sign(min(abs(df2(ib2,k)),max(a4(1,ib2,k-1),a4(1,ib2,k),a4(1,ib2,k+1))-a4(1,ib2,k),a4(1,ib2,k)-min(a4(1,ib2,k-1)&
&,a4(1,ib2,k),a4(1,ib2,k+1))),df2(ib2,k))
      end do
    end do
    do k = 3, km1
      do ib2 = i1, i2
        c1 = delq(ib2,k-1)*delp(ib2,k-1)/d4(ib2,k)
        a1 = d4(ib2,k-1)/(d4(ib2,k)+delp(ib2,k-1))
        a2 = d4(ib2,k+1)/(d4(ib2,k)+delp(ib2,k))
        a4(2,ib2,k) = a4(1,ib2,k-1)+c1+2./(d4(ib2,k-1)+d4(ib2,k+1))*(delp(ib2,k)*(c1*(a1-a2)+a2*dc(ib2,k-1))-delp(ib2,k-1)*a1*&
&dc(ib2,k))
      end do
    end do
    if (km .gt. 8 .and. kord .gt. 3) then
      call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
    endif
    do ib2 = i1, i2
      d1 = delp(ib2,1)
      d2 = delp(ib2,2)
      qm = (d2*a4(1,ib2,1)+d1*a4(1,ib2,2))/(d1+d2)
      dq = 2.*(a4(1,ib2,2)-a4(1,ib2,1))/(d1+d2)
      c1 = 4.*(a4(2,ib2,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
      c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
      a4(2,ib2,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
      a4(2,ib2,1) = d1*(2.*c1*d1**2-c3)+a4(2,ib2,2)
      a4(2,ib2,2) = max(a4(2,ib2,2),min(a4(1,ib2,1),a4(1,ib2,2)))
      a4(2,ib2,2) = min(a4(2,ib2,2),max(a4(1,ib2,1),a4(1,ib2,2)))
      dc(ib2,1) = 0.5*(a4(2,ib2,2)-a4(1,ib2,1))
    end do
    if (iv .eq. 0) then
      do ib2 = i1, i2
        a4(2,ib2,1) = max(0.,a4(2,ib2,1))
        a4(2,ib2,2) = max(0.,a4(2,ib2,2))
      end do
    else if (iv .eq. (-1)) then
      do ib2 = i1, i2
        if (a4(2,ib2,1)*a4(1,ib2,1) .le. 0.) then
          a4(2,ib2,1) = 0.
        endif
      end do
    endif
    do ib2 = i1, i2
      d1 = delp(ib2,km)
      d2 = delp(ib2,km1)
      qm = (d2*a4(1,ib2,km)+d1*a4(1,ib2,km1))/(d1+d2)
      dq = 2.*(a4(1,ib2,km1)-a4(1,ib2,km))/(d1+d2)
      c1 = (a4(2,ib2,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
      c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
      a4(2,ib2,km) = qm-c1*d1*d2*(d2+3.*d1)
      a4(3,ib2,km) = d1*(8.*c1*d1**2-c3)+a4(2,ib2,km)
      a4(2,ib2,km) = max(a4(2,ib2,km),min(a4(1,ib2,km),a4(1,ib2,km1)))
      a4(2,ib2,km) = min(a4(2,ib2,km),max(a4(1,ib2,km),a4(1,ib2,km1)))
      dc(ib2,km) = 0.5*(a4(1,ib2,km)-a4(2,ib2,km))
    end do
    ada4(2,i,km) = ada4(2,i,km)*(0.5-sign(0.5,0.-a4(2,i,km)))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
      ada4(3,i,km) = 0.
    endif
  end do
endif
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i1, i2
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,1) = max(0.,a4(2,i,1))
    a4(2,i,2) = max(0.,a4(2,i,2))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
  end do
endif
do i = i2, i1, -1
  adc1 = 0.
  adc3 = 0.
  add1 = 0.
  add2 = 0.
  addq = 0.
  adqm = 0.
  d1 = delp(i,km)
  d2 = delp(i,km1)
  qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
  dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
  c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
  a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
  a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
  ada4(2,i,km) = ada4(2,i,km)-0.5*addc(i,km)
  ada4(1,i,km) = ada4(1,i,km)+0.5*addc(i,km)
  addc(i,km) = 0.
  a4t = max(a4(1,i,km),a4(1,i,km1))
  ada4t = ada4(2,i,km)*(0.5-sign(0.5,a4t-a4(2,i,km)))
  ada4(2,i,km) = ada4(2,i,km)*(0.5+sign(0.5,a4t-a4(2,i,km)))
  ada4(1,i,km) = ada4(1,i,km)+ada4t*(0.5+sign(0.5,a4(1,i,km)-a4(1,i,km1)))
  ada4(1,i,km1) = ada4(1,i,km1)+ada4t*(0.5-sign(0.5,a4(1,i,km)-a4(1,i,km1)))
  a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
  a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
  a4u = min(a4(1,i,km),a4(1,i,km1))
  ada4u = ada4(2,i,km)*(0.5-sign(0.5,a4(2,i,km)-a4u))
  ada4(2,i,km) = ada4(2,i,km)*(0.5+sign(0.5,a4(2,i,km)-a4u))
  ada4(1,i,km) = ada4(1,i,km)+ada4u*(0.5+sign(0.5,a4(1,i,km1)-a4(1,i,km)))
  ada4(1,i,km1) = ada4(1,i,km1)+ada4u*(0.5-sign(0.5,a4(1,i,km1)-a4(1,i,km)))
  ada4(2,i,km) = ada4(2,i,km)+ada4(3,i,km)
  adc1 = adc1+8*ada4(3,i,km)*d1*d1**2
  adc3 = adc3-ada4(3,i,km)*d1
  add1 = add1+ada4(3,i,km)*(2*8.*d1*c1*d1+8.*c1*d1**2-c3)
  ada4(3,i,km) = 0.
  adc1 = adc1-ada4(2,i,km)*d1*d2*(d2+3.*d1)
  add1 = add1-ada4(2,i,km)*(3*c1*d1*d2+c1*d2*(d2+3.*d1))
  add2 = add2-ada4(2,i,km)*c1*d1*(2*d2+3.*d1)
  adqm = adqm+ada4(2,i,km)
  ada4(2,i,km) = 0.
  adc1 = adc1-2*adc3*(d2*(5.*d1+d2)-3.*d1*d1)
  add1 = add1-2.*adc3*c1*(5*d2-6*d1)
  add2 = add2-2.*adc3*c1*(d2+5.*d1+d2)
  addq = addq+adc3
  adc3 = 0.
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do ib4 = i1, i2
      c1 = (delp(ib4,k-1)+0.5*delp(ib4,k))/d4(ib4,k+1)
      c2 = (delp(ib4,k+1)+0.5*delp(ib4,k))/d4(ib4,k)
      df2(ib4,k) = delp(ib4,k)*(c1*delq(ib4,k)+c2*delq(ib4,k-1))/(d4(ib4,k)+delp(ib4,k+1))
      dc(ib4,k) = sign(min(abs(df2(ib4,k)),max(a4(1,ib4,k-1),a4(1,ib4,k),a4(1,ib4,k+1))-a4(1,ib4,k),a4(1,ib4,k)-min(a4(1,ib4,k-1),&
&a4(1,ib4,k),a4(1,ib4,k+1))),df2(ib4,k))
    end do
  end do
  do k = 3, km1
    do ib4 = i1, i2
      c1 = delq(ib4,k-1)*delp(ib4,k-1)/d4(ib4,k)
      a1 = d4(ib4,k-1)/(d4(ib4,k)+delp(ib4,k-1))
      a2 = d4(ib4,k+1)/(d4(ib4,k)+delp(ib4,k))
      a4(2,ib4,k) = a4(1,ib4,k-1)+c1+2./(d4(ib4,k-1)+d4(ib4,k+1))*(delp(ib4,k)*(c1*(a1-a2)+a2*dc(ib4,k-1))-delp(ib4,k-1)*a1*dc(ib4,&
&k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  do ib4 = i1, i2
    d1 = delp(ib4,1)
    d2 = delp(ib4,2)
    qm = (d2*a4(1,ib4,1)+d1*a4(1,ib4,2))/(d1+d2)
    dq = 2.*(a4(1,ib4,2)-a4(1,ib4,1))/(d1+d2)
    c1 = 4.*(a4(2,ib4,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,ib4,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
    a4(2,ib4,1) = d1*(2.*c1*d1**2-c3)+a4(2,ib4,2)
    a4(2,ib4,2) = max(a4(2,ib4,2),min(a4(1,ib4,1),a4(1,ib4,2)))
    a4(2,ib4,2) = min(a4(2,ib4,2),max(a4(1,ib4,1),a4(1,ib4,2)))
    dc(ib4,1) = 0.5*(a4(2,ib4,2)-a4(1,ib4,1))
  end do
  if (iv .eq. 0) then
    do ib4 = i1, i2
      a4(2,ib4,1) = max(0.,a4(2,ib4,1))
      a4(2,ib4,2) = max(0.,a4(2,ib4,2))
    end do
  else if (iv .eq. (-1)) then
    do ib4 = i1, i2
      if (a4(2,ib4,1)*a4(1,ib4,1) .le. 0.) then
        a4(2,ib4,1) = 0.
      endif
    end do
  endif
  d1 = delp(i,km)
  d2 = delp(i,km1)
  qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
  dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
  ada4(2,i,km1) = ada4(2,i,km1)+adc1/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  add1 = add1-adc1*((a4(2,i,km1)-qm-d2*dq)*d2*(3*d1+d2+3.*d1)/(d2*(2.*d2*d2+d1*(d2+3.*d1))*d2*(2.*d2*d2+d1*(d2+3.*d1))))
  add2 = add2-adc1*(dq/(d2*(2.*d2*d2+d1*(d2+3.*d1)))+(a4(2,i,km1)-qm-d2*dq)*(d2*(4*d2+d1)+2.*d2*d2+d1*(d2+3.*d1))/(d2*(2.*d2*d2+d1*&
&(d2+3.*d1))*d2*(2.*d2*d2+d1*(d2+3.*d1))))
  addq = addq-adc1*(d2/(d2*(2.*d2*d2+d1*(d2+3.*d1))))
  adqm = adqm-adc1/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  adc1 = 0.
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do ib5 = i1, i2
      c1 = (delp(ib5,k-1)+0.5*delp(ib5,k))/d4(ib5,k+1)
      c2 = (delp(ib5,k+1)+0.5*delp(ib5,k))/d4(ib5,k)
      df2(ib5,k) = delp(ib5,k)*(c1*delq(ib5,k)+c2*delq(ib5,k-1))/(d4(ib5,k)+delp(ib5,k+1))
      dc(ib5,k) = sign(min(abs(df2(ib5,k)),max(a4(1,ib5,k-1),a4(1,ib5,k),a4(1,ib5,k+1))-a4(1,ib5,k),a4(1,ib5,k)-min(a4(1,ib5,k-1),&
&a4(1,ib5,k),a4(1,ib5,k+1))),df2(ib5,k))
    end do
  end do
  do k = 3, km1
    do ib5 = i1, i2
      c1 = delq(ib5,k-1)*delp(ib5,k-1)/d4(ib5,k)
      a1 = d4(ib5,k-1)/(d4(ib5,k)+delp(ib5,k-1))
      a2 = d4(ib5,k+1)/(d4(ib5,k)+delp(ib5,k))
      a4(2,ib5,k) = a4(1,ib5,k-1)+c1+2./(d4(ib5,k-1)+d4(ib5,k+1))*(delp(ib5,k)*(c1*(a1-a2)+a2*dc(ib5,k-1))-delp(ib5,k-1)*a1*dc(ib5,&
&k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  do ib5 = i1, i2
    d1 = delp(ib5,1)
    d2 = delp(ib5,2)
    qm = (d2*a4(1,ib5,1)+d1*a4(1,ib5,2))/(d1+d2)
    dq = 2.*(a4(1,ib5,2)-a4(1,ib5,1))/(d1+d2)
    c1 = 4.*(a4(2,ib5,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,ib5,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
    a4(2,ib5,1) = d1*(2.*c1*d1**2-c3)+a4(2,ib5,2)
    a4(2,ib5,2) = max(a4(2,ib5,2),min(a4(1,ib5,1),a4(1,ib5,2)))
    a4(2,ib5,2) = min(a4(2,ib5,2),max(a4(1,ib5,1),a4(1,ib5,2)))
    dc(ib5,1) = 0.5*(a4(2,ib5,2)-a4(1,ib5,1))
  end do
  if (iv .eq. 0) then
    do ib5 = i1, i2
      a4(2,ib5,1) = max(0.,a4(2,ib5,1))
      a4(2,ib5,2) = max(0.,a4(2,ib5,2))
    end do
  else if (iv .eq. (-1)) then
    do ib5 = i1, i2
      if (a4(2,ib5,1)*a4(1,ib5,1) .le. 0.) then
        a4(2,ib5,1) = 0.
      endif
    end do
  endif
  d1 = delp(i,km)
  d2 = delp(i,km1)
  ada4(1,i,km) = ada4(1,i,km)+addq*((-2)/(d1+d2))
  ada4(1,i,km1) = ada4(1,i,km1)+addq*(2/(d1+d2))
  add1 = add1-addq*(2*(a4(1,i,km1)-a4(1,i,km))/((d1+d2)*(d1+d2)))
  add2 = add2-addq*(2*(a4(1,i,km1)-a4(1,i,km))/((d1+d2)*(d1+d2)))
  addq = 0.
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do ib6 = i1, i2
      c1 = (delp(ib6,k-1)+0.5*delp(ib6,k))/d4(ib6,k+1)
      c2 = (delp(ib6,k+1)+0.5*delp(ib6,k))/d4(ib6,k)
      df2(ib6,k) = delp(ib6,k)*(c1*delq(ib6,k)+c2*delq(ib6,k-1))/(d4(ib6,k)+delp(ib6,k+1))
      dc(ib6,k) = sign(min(abs(df2(ib6,k)),max(a4(1,ib6,k-1),a4(1,ib6,k),a4(1,ib6,k+1))-a4(1,ib6,k),a4(1,ib6,k)-min(a4(1,ib6,k-1),&
&a4(1,ib6,k),a4(1,ib6,k+1))),df2(ib6,k))
    end do
  end do
  do k = 3, km1
    do ib6 = i1, i2
      c1 = delq(ib6,k-1)*delp(ib6,k-1)/d4(ib6,k)
      a1 = d4(ib6,k-1)/(d4(ib6,k)+delp(ib6,k-1))
      a2 = d4(ib6,k+1)/(d4(ib6,k)+delp(ib6,k))
      a4(2,ib6,k) = a4(1,ib6,k-1)+c1+2./(d4(ib6,k-1)+d4(ib6,k+1))*(delp(ib6,k)*(c1*(a1-a2)+a2*dc(ib6,k-1))-delp(ib6,k-1)*a1*dc(ib6,&
&k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  do ib6 = i1, i2
    d1 = delp(ib6,1)
    d2 = delp(ib6,2)
    qm = (d2*a4(1,ib6,1)+d1*a4(1,ib6,2))/(d1+d2)
    dq = 2.*(a4(1,ib6,2)-a4(1,ib6,1))/(d1+d2)
    c1 = 4.*(a4(2,ib6,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,ib6,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
    a4(2,ib6,1) = d1*(2.*c1*d1**2-c3)+a4(2,ib6,2)
    a4(2,ib6,2) = max(a4(2,ib6,2),min(a4(1,ib6,1),a4(1,ib6,2)))
    a4(2,ib6,2) = min(a4(2,ib6,2),max(a4(1,ib6,1),a4(1,ib6,2)))
    dc(ib6,1) = 0.5*(a4(2,ib6,2)-a4(1,ib6,1))
  end do
  if (iv .eq. 0) then
    do ib6 = i1, i2
      a4(2,ib6,1) = max(0.,a4(2,ib6,1))
      a4(2,ib6,2) = max(0.,a4(2,ib6,2))
    end do
  else if (iv .eq. (-1)) then
    do ib6 = i1, i2
      if (a4(2,ib6,1)*a4(1,ib6,1) .le. 0.) then
        a4(2,ib6,1) = 0.
      endif
    end do
  endif
  d1 = delp(i,km)
  d2 = delp(i,km1)
  ada4(1,i,km) = ada4(1,i,km)+adqm*(d2/(d1+d2))
  ada4(1,i,km1) = ada4(1,i,km1)+adqm*(d1/(d1+d2))
  add1 = add1+adqm*(a4(1,i,km1)/(d1+d2)-(d2*a4(1,i,km)+d1*a4(1,i,km1))/((d1+d2)*(d1+d2)))
  add2 = add2+adqm*(a4(1,i,km)/(d1+d2)-(d2*a4(1,i,km)+d1*a4(1,i,km1))/((d1+d2)*(d1+d2)))
  adqm = 0.
  addelp(i,km1) = addelp(i,km1)+add2
  add2 = 0.
  addelp(i,km) = addelp(i,km)+add1
  add1 = 0.
end do
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i1, i2
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,1) = max(0.,a4(2,i,1))
    ada4(2,i,2) = ada4(2,i,2)*(0.5-sign(0.5,0.-a4(2,i,2)))
    a4(:,:,:) = a4h(:,:,:)
    do k = 2, km1
      do ib7 = i1, i2
        c1 = (delp(ib7,k-1)+0.5*delp(ib7,k))/d4(ib7,k+1)
        c2 = (delp(ib7,k+1)+0.5*delp(ib7,k))/d4(ib7,k)
        df2(ib7,k) = delp(ib7,k)*(c1*delq(ib7,k)+c2*delq(ib7,k-1))/(d4(ib7,k)+delp(ib7,k+1))
        dc(ib7,k) = sign(min(abs(df2(ib7,k)),max(a4(1,ib7,k-1),a4(1,ib7,k),a4(1,ib7,k+1))-a4(1,ib7,k),a4(1,ib7,k)-min(a4(1,ib7,k-1)&
&,a4(1,ib7,k),a4(1,ib7,k+1))),df2(ib7,k))
      end do
    end do
    do k = 3, km1
      do ib7 = i1, i2
        c1 = delq(ib7,k-1)*delp(ib7,k-1)/d4(ib7,k)
        a1 = d4(ib7,k-1)/(d4(ib7,k)+delp(ib7,k-1))
        a2 = d4(ib7,k+1)/(d4(ib7,k)+delp(ib7,k))
        a4(2,ib7,k) = a4(1,ib7,k-1)+c1+2./(d4(ib7,k-1)+d4(ib7,k+1))*(delp(ib7,k)*(c1*(a1-a2)+a2*dc(ib7,k-1))-delp(ib7,k-1)*a1*&
&dc(ib7,k))
      end do
    end do
    if (km .gt. 8 .and. kord .gt. 3) then
      call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
    endif
    do ib7 = i1, i2
      d1 = delp(ib7,1)
      d2 = delp(ib7,2)
      qm = (d2*a4(1,ib7,1)+d1*a4(1,ib7,2))/(d1+d2)
      dq = 2.*(a4(1,ib7,2)-a4(1,ib7,1))/(d1+d2)
      c1 = 4.*(a4(2,ib7,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
      c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
      a4(2,ib7,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
      a4(2,ib7,1) = d1*(2.*c1*d1**2-c3)+a4(2,ib7,2)
      a4(2,ib7,2) = max(a4(2,ib7,2),min(a4(1,ib7,1),a4(1,ib7,2)))
      a4(2,ib7,2) = min(a4(2,ib7,2),max(a4(1,ib7,1),a4(1,ib7,2)))
      dc(ib7,1) = 0.5*(a4(2,ib7,2)-a4(1,ib7,1))
    end do
    ada4(2,i,1) = ada4(2,i,1)*(0.5-sign(0.5,0.-a4(2,i,1)))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      ada4(2,i,1) = 0.
    endif
  end do
endif
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i2, i1, -1
  adc1 = 0.
  adc3 = 0.
  add1 = 0.
  add2 = 0.
  addq = 0.
  adqm = 0.
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  ada4(2,i,2) = ada4(2,i,2)+0.5*addc(i,1)
  ada4(1,i,1) = ada4(1,i,1)-0.5*addc(i,1)
  addc(i,1) = 0.
  a4v = max(a4(1,i,1),a4(1,i,2))
  ada4v = ada4(2,i,2)*(0.5-sign(0.5,a4v-a4(2,i,2)))
  ada4(2,i,2) = ada4(2,i,2)*(0.5+sign(0.5,a4v-a4(2,i,2)))
  ada4(1,i,2) = ada4(1,i,2)+ada4v*(0.5-sign(0.5,a4(1,i,1)-a4(1,i,2)))
  ada4(1,i,1) = ada4(1,i,1)+ada4v*(0.5+sign(0.5,a4(1,i,1)-a4(1,i,2)))
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4w = min(a4(1,i,1),a4(1,i,2))
  ada4w = ada4(2,i,2)*(0.5-sign(0.5,a4(2,i,2)-a4w))
  ada4(2,i,2) = ada4(2,i,2)*(0.5+sign(0.5,a4(2,i,2)-a4w))
  ada4(1,i,2) = ada4(1,i,2)+ada4w*(0.5-sign(0.5,a4(1,i,2)-a4(1,i,1)))
  ada4(1,i,1) = ada4(1,i,1)+ada4w*(0.5+sign(0.5,a4(1,i,2)-a4(1,i,1)))
  ada4(2,i,2) = ada4(2,i,2)+ada4(2,i,1)
  adc1 = adc1+2*ada4(2,i,1)*d1*d1**2
  adc3 = adc3-ada4(2,i,1)*d1
  add1 = add1+ada4(2,i,1)*(2*2.*d1*c1*d1+2.*c1*d1**2-c3)
  ada4(2,i,1) = 0.
  adc1 = adc1-0.25*ada4(2,i,2)*d1*d2*(d2+3.*d1)
  add1 = add1-ada4(2,i,2)*(0.75*c1*d1*d2+0.25*c1*d2*(d2+3.*d1))
  add2 = add2-ada4(2,i,2)*(0.25*c1*d1*d2+0.25*c1*d1*(d2+3.*d1))
  adqm = adqm+ada4(2,i,2)
  ada4(2,i,2) = 0.
  adc1 = adc1-0.5*adc3*(d2*(5.*d1+d2)-3.*d1*d1)
  add1 = add1-0.5*adc3*c1*(5*d2-6*d1)
  add2 = add2-0.5*adc3*c1*(d2+5.*d1+d2)
  addq = addq+adc3
  adc3 = 0.
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do ib8 = i1, i2
      c1 = (delp(ib8,k-1)+0.5*delp(ib8,k))/d4(ib8,k+1)
      c2 = (delp(ib8,k+1)+0.5*delp(ib8,k))/d4(ib8,k)
      df2(ib8,k) = delp(ib8,k)*(c1*delq(ib8,k)+c2*delq(ib8,k-1))/(d4(ib8,k)+delp(ib8,k+1))
      dc(ib8,k) = sign(min(abs(df2(ib8,k)),max(a4(1,ib8,k-1),a4(1,ib8,k),a4(1,ib8,k+1))-a4(1,ib8,k),a4(1,ib8,k)-min(a4(1,ib8,k-1),&
&a4(1,ib8,k),a4(1,ib8,k+1))),df2(ib8,k))
    end do
  end do
  do k = 3, km1
    do ib8 = i1, i2
      c1 = delq(ib8,k-1)*delp(ib8,k-1)/d4(ib8,k)
      a1 = d4(ib8,k-1)/(d4(ib8,k)+delp(ib8,k-1))
      a2 = d4(ib8,k+1)/(d4(ib8,k)+delp(ib8,k))
      a4(2,ib8,k) = a4(1,ib8,k-1)+c1+2./(d4(ib8,k-1)+d4(ib8,k+1))*(delp(ib8,k)*(c1*(a1-a2)+a2*dc(ib8,k-1))-delp(ib8,k-1)*a1*dc(ib8,&
&k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  ada4(2,i,3) = ada4(2,i,3)+adc1*(4/(d2*(2.*d2*d2+d1*(d2+3.*d1))))
  add1 = add1-adc1*(4.*(a4(2,i,3)-qm-d2*dq)*d2*(3*d1+d2+3.*d1)/(d2*(2.*d2*d2+d1*(d2+3.*d1))*d2*(2.*d2*d2+d1*(d2+3.*d1))))
  add2 = add2-adc1*(4.*dq/(d2*(2.*d2*d2+d1*(d2+3.*d1)))+4.*(a4(2,i,3)-qm-d2*dq)*(d2*(4*d2+d1)+2.*d2*d2+d1*(d2+3.*d1))/(d2*(2.*d2*&
&d2+d1*(d2+3.*d1))*d2*(2.*d2*d2+d1*(d2+3.*d1))))
  addq = addq-adc1*(4.*d2/(d2*(2.*d2*d2+d1*(d2+3.*d1))))
  adqm = adqm+adc1*((-4)/(d2*(2.*d2*d2+d1*(d2+3.*d1))))
  adc1 = 0.
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do ib9 = i1, i2
      c1 = (delp(ib9,k-1)+0.5*delp(ib9,k))/d4(ib9,k+1)
      c2 = (delp(ib9,k+1)+0.5*delp(ib9,k))/d4(ib9,k)
      df2(ib9,k) = delp(ib9,k)*(c1*delq(ib9,k)+c2*delq(ib9,k-1))/(d4(ib9,k)+delp(ib9,k+1))
      dc(ib9,k) = sign(min(abs(df2(ib9,k)),max(a4(1,ib9,k-1),a4(1,ib9,k),a4(1,ib9,k+1))-a4(1,ib9,k),a4(1,ib9,k)-min(a4(1,ib9,k-1),&
&a4(1,ib9,k),a4(1,ib9,k+1))),df2(ib9,k))
    end do
  end do
  do k = 3, km1
    do ib9 = i1, i2
      c1 = delq(ib9,k-1)*delp(ib9,k-1)/d4(ib9,k)
      a1 = d4(ib9,k-1)/(d4(ib9,k)+delp(ib9,k-1))
      a2 = d4(ib9,k+1)/(d4(ib9,k)+delp(ib9,k))
      a4(2,ib9,k) = a4(1,ib9,k-1)+c1+2./(d4(ib9,k-1)+d4(ib9,k+1))*(delp(ib9,k)*(c1*(a1-a2)+a2*dc(ib9,k-1))-delp(ib9,k-1)*a1*dc(ib9,&
&k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  ada4(1,i,2) = ada4(1,i,2)+addq*(2/(d1+d2))
  ada4(1,i,1) = ada4(1,i,1)+addq*((-2)/(d1+d2))
  add1 = add1-addq*(2*(a4(1,i,2)-a4(1,i,1))/((d1+d2)*(d1+d2)))
  add2 = add2-addq*(2*(a4(1,i,2)-a4(1,i,1))/((d1+d2)*(d1+d2)))
  addq = 0.
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do ica = i1, i2
      c1 = (delp(ica,k-1)+0.5*delp(ica,k))/d4(ica,k+1)
      c2 = (delp(ica,k+1)+0.5*delp(ica,k))/d4(ica,k)
      df2(ica,k) = delp(ica,k)*(c1*delq(ica,k)+c2*delq(ica,k-1))/(d4(ica,k)+delp(ica,k+1))
      dc(ica,k) = sign(min(abs(df2(ica,k)),max(a4(1,ica,k-1),a4(1,ica,k),a4(1,ica,k+1))-a4(1,ica,k),a4(1,ica,k)-min(a4(1,ica,k-1),&
&a4(1,ica,k),a4(1,ica,k+1))),df2(ica,k))
    end do
  end do
  do k = 3, km1
    do ica = i1, i2
      c1 = delq(ica,k-1)*delp(ica,k-1)/d4(ica,k)
      a1 = d4(ica,k-1)/(d4(ica,k)+delp(ica,k-1))
      a2 = d4(ica,k+1)/(d4(ica,k)+delp(ica,k))
      a4(2,ica,k) = a4(1,ica,k-1)+c1+2./(d4(ica,k-1)+d4(ica,k+1))*(delp(ica,k)*(c1*(a1-a2)+a2*dc(ica,k-1))-delp(ica,k-1)*a1*dc(ica,&
&k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  ada4(1,i,2) = ada4(1,i,2)+adqm*(d1/(d1+d2))
  ada4(1,i,1) = ada4(1,i,1)+adqm*(d2/(d1+d2))
  add1 = add1+adqm*(a4(1,i,2)/(d1+d2)-(d2*a4(1,i,1)+d1*a4(1,i,2))/((d1+d2)*(d1+d2)))
  add2 = add2+adqm*(a4(1,i,1)/(d1+d2)-(d2*a4(1,i,1)+d1*a4(1,i,2))/((d1+d2)*(d1+d2)))
  adqm = 0.
  addelp(i,2) = addelp(i,2)+add2
  add2 = 0.
  addelp(i,1) = addelp(i,1)+add1
  add1 = 0.
end do
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call adsteepz( i1,i2,km,a4,ada4,df2,addf2,dc,addc,delq,addelq,delp,addelp,d4,add4 )
endif
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = km1, 3, -1
  ada1 = 0.
  ada2 = 0.
  adc1 = 0.
  do i = i2, i1, -1
    ada1 = 0.
    ada2 = 0.
    adc1 = 0.
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    ada1 = ada1+ada4(2,i,k)*2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*c1-delp(i,k-1)*dc(i,k))
    ada2 = ada2+ada4(2,i,k)*2./(d4(i,k-1)+d4(i,k+1))*delp(i,k)*((-c1)+dc(i,k-1))
    ada4(1,i,k-1) = ada4(1,i,k-1)+ada4(2,i,k)
    adc1 = adc1+ada4(2,i,k)*(1+2./(d4(i,k-1)+d4(i,k+1))*delp(i,k)*(a1-a2))
    add4(i,k-1) = add4(i,k-1)-ada4(2,i,k)*2/((d4(i,k-1)+d4(i,k+1))*(d4(i,k-1)+d4(i,k+1)))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-&
&delp(i,k-1)*a1*dc(i,k))
    add4(i,k+1) = add4(i,k+1)-ada4(2,i,k)*2/((d4(i,k-1)+d4(i,k+1))*(d4(i,k-1)+d4(i,k+1)))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-&
&delp(i,k-1)*a1*dc(i,k))
    addc(i,k-1) = addc(i,k-1)+ada4(2,i,k)*2./(d4(i,k-1)+d4(i,k+1))*delp(i,k)*a2
    addc(i,k) = addc(i,k)-ada4(2,i,k)*2./(d4(i,k-1)+d4(i,k+1))*delp(i,k-1)*a1
    addelp(i,k-1) = addelp(i,k-1)-ada4(2,i,k)*2./(d4(i,k-1)+d4(i,k+1))*a1*dc(i,k)
    addelp(i,k) = addelp(i,k)+ada4(2,i,k)*2./(d4(i,k-1)+d4(i,k+1))*(c1*(a1-a2)+a2*dc(i,k-1))
    ada4(2,i,k) = 0.
    add4(i,k+1) = add4(i,k+1)+ada2/(d4(i,k)+delp(i,k))
    add4(i,k) = add4(i,k)-ada2*(d4(i,k+1)/((d4(i,k)+delp(i,k))*(d4(i,k)+delp(i,k))))
    addelp(i,k) = addelp(i,k)-ada2*(d4(i,k+1)/((d4(i,k)+delp(i,k))*(d4(i,k)+delp(i,k))))
    ada2 = 0.
    add4(i,k-1) = add4(i,k-1)+ada1/(d4(i,k)+delp(i,k-1))
    add4(i,k) = add4(i,k)-ada1*(d4(i,k-1)/((d4(i,k)+delp(i,k-1))*(d4(i,k)+delp(i,k-1))))
    addelp(i,k-1) = addelp(i,k-1)-ada1*(d4(i,k-1)/((d4(i,k)+delp(i,k-1))*(d4(i,k)+delp(i,k-1))))
    ada1 = 0.
    add4(i,k) = add4(i,k)-adc1*(delq(i,k-1)*delp(i,k-1)/(d4(i,k)*d4(i,k)))
    addelp(i,k-1) = addelp(i,k-1)+adc1*(delq(i,k-1)/d4(i,k))
    addelq(i,k-1) = addelq(i,k-1)+adc1*(delp(i,k-1)/d4(i,k))
    adc1 = 0.
  end do
end do
a4(:,:,:) = a4h(:,:,:)
do k = km1, 2, -1
  adc1 = 0.
  adc2 = 0.
  do i = i2, i1, -1
    adc1 = 0.
    adc2 = 0.
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dch = abs(df2(i,k))
    dci = max(a4(1,i,k-1),a4(1,i,k))
    dck = max(dci,a4(1,i,k+1))-a4(1,i,k)
    dcl = min(a4(1,i,k-1),a4(1,i,k))
    dcn = a4(1,i,k)-min(dcl,a4(1,i,k+1))
    dco = min(dch,dck)
    addcp = addc(i,k)*sign(1.,min(dco,dcn))*sign(1.,df2(i,k))
    addcn = addcp*(0.5-sign(0.5,dcn-dco))
    addco = addcp*(0.5+sign(0.5,dcn-dco))
    addch = addco*(0.5+sign(0.5,dck-dch))
    addck = addco*(0.5-sign(0.5,dck-dch))
    ada4(1,i,k) = ada4(1,i,k)+addcn
    addcm = -addcn
    ada4(1,i,k+1) = ada4(1,i,k+1)+addcm*(0.5-sign(0.5,a4(1,i,k+1)-dcl))
    addcl = addcm*(0.5+sign(0.5,a4(1,i,k+1)-dcl))
    ada4(1,i,k-1) = ada4(1,i,k-1)+addcl*(0.5+sign(0.5,a4(1,i,k)-a4(1,i,k-1)))
    ada4(1,i,k) = ada4(1,i,k)+addcl*(0.5-sign(0.5,a4(1,i,k)-a4(1,i,k-1)))
    ada4(1,i,k) = ada4(1,i,k)-addck
    ada4(1,i,k+1) = ada4(1,i,k+1)+addck*(0.5-sign(0.5,dci-a4(1,i,k+1)))
    addci = addck*(0.5+sign(0.5,dci-a4(1,i,k+1)))
    ada4(1,i,k-1) = ada4(1,i,k-1)+addci*(0.5+sign(0.5,a4(1,i,k-1)-a4(1,i,k)))
    ada4(1,i,k) = ada4(1,i,k)+addci*(0.5-sign(0.5,a4(1,i,k-1)-a4(1,i,k)))
    addf2(i,k) = addf2(i,k)+addch*sign(1.,df2(i,k))
    addc(i,k) = 0.
    adc1 = adc1+addf2(i,k)*(delp(i,k)*delq(i,k)/(d4(i,k)+delp(i,k+1)))
    adc2 = adc2+addf2(i,k)*(delp(i,k)*delq(i,k-1)/(d4(i,k)+delp(i,k+1)))
    add4(i,k) = add4(i,k)-addf2(i,k)*(delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/((d4(i,k)+delp(i,k+1))*(d4(i,k)+delp(i,k+1))))
    addelp(i,k+1) = addelp(i,k+1)-addf2(i,k)*(delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/((d4(i,k)+delp(i,k+1))*(d4(i,k)+delp(i,k+1))))
    addelp(i,k) = addelp(i,k)+addf2(i,k)*((c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1)))
    addelq(i,k-1) = addelq(i,k-1)+addf2(i,k)*(delp(i,k)*c2/(d4(i,k)+delp(i,k+1)))
    addelq(i,k) = addelq(i,k)+addf2(i,k)*(delp(i,k)*c1/(d4(i,k)+delp(i,k+1)))
    addf2(i,k) = 0.
    add4(i,k) = add4(i,k)-adc2*((delp(i,k+1)+0.5*delp(i,k))/(d4(i,k)*d4(i,k)))
    addelp(i,k+1) = addelp(i,k+1)+adc2/d4(i,k)
    addelp(i,k) = addelp(i,k)+adc2*(0.5/d4(i,k))
    adc2 = 0.
    add4(i,k+1) = add4(i,k+1)-adc1*((delp(i,k-1)+0.5*delp(i,k))/(d4(i,k+1)*d4(i,k+1)))
    addelp(i,k-1) = addelp(i,k-1)+adc1/d4(i,k+1)
    addelp(i,k) = addelp(i,k)+adc1*(0.5/d4(i,k+1))
    adc1 = 0.
  end do
end do
do k = 2, km
  do i = i1, i2
    addelp(i,k-1) = addelp(i,k-1)+add4(i,k)
    addelp(i,k) = addelp(i,k)+add4(i,k)
    add4(i,k) = 0.
    ada4(1,i,k-1) = ada4(1,i,k-1)-addelq(i,k-1)
    ada4(1,i,k) = ada4(1,i,k)+addelq(i,k-1)
    addelq(i,k-1) = 0.
  end do
end do

!----------------------------------------------
! FREE DYNAMIC MEMORY
!----------------------------------------------

end subroutine adppm_profile


subroutine adremap_z( km, pe1, adpe1, q1, adq1, kn, pe2, adpe2, adq2, i1, i2, kord )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.50  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: km
real, intent(inout) :: adpe1(i1:i2,km+1)
integer, intent(in) :: kn
real, intent(inout) :: adpe2(i1:i2,kn+1)
real, intent(inout) :: adq1(i1:i2,km)
real, intent(inout) :: adq2(i1:i2,kn)
integer, intent(in) :: kord
real, intent(in) :: pe1(i1:i2,km+1)
real, intent(in) :: pe2(i1:i2,kn+1)
real, intent(in) :: q1(i1:i2,km)

!==============================================
! declare local variables
!==============================================
real :: addp1(i1:i2,km)
real :: adq4(4,i1:i2,km)
real :: dp1(i1:i2,km)
integer :: i
integer :: k
real :: q4(4,i1:i2,km)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
addp1(:,:) = 0.
adq4(:,:,:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
do k = 1, km
  do i = i1, i2
    dp1(i,k) = pe1(i,k+1)-pe1(i,k)
    q4(1,i,k) = q1(i,k)
  end do
end do
if (kord .gt. 7) then
  call cs_profile( q4,dp1,km,i1,i2,1 )
else
  call ppm_profile( q4,dp1,km,i1,i2,1,kord )
endif
do i = i2, i1, -1
  call admapz( pe1(i,:),adpe1(i,:),pe2(i,:),adpe2(i,:),dp1(i,:),addp1(i,:),q4(:,i,:),adq4(:,i,:),adq2(i,:),km,kn,0 )
end do
do k = 1, km
  do i = i1, i2
    q4(1,i,k) = q1(i,k)
  end do
end do
if (kord .gt. 7) then
  call adcs_profile( q4,adq4,dp1,addp1,km,i1,i2,1 )
else
  call adppm_profile( q4,adq4,dp1,addp1,km,i1,i2,1,kord )
endif
do k = 1, km
  do i = i1, i2
    adq1(i,k) = adq1(i,k)+adq4(1,i,k)
    adq4(1,i,k) = 0.
    adpe1(i,k+1) = adpe1(i,k+1)+addp1(i,k)
    adpe1(i,k) = adpe1(i,k)-addp1(i,k)
    addp1(i,k) = 0.
  end do
end do

end subroutine adremap_z


subroutine adsteepz( i1, i2, km, a4, ada4, df2, addf2, dm, addm, dq, addq, dp, addp, d4, add4 )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.50  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: km
real, intent(inout) :: a4(4,i1:i2,km)
real, intent(inout) :: ada4(4,i1:i2,km)
real, intent(inout) :: add4(i1:i2,km)
real, intent(inout) :: addf2(i1:i2,km)
real, intent(inout) :: addm(i1:i2,km)
real, intent(inout) :: addp(i1:i2,km)
real, intent(inout) :: addq(i1:i2,km)
real, intent(in) :: d4(i1:i2,km)
real, intent(in) :: df2(i1:i2,km)
real, intent(in) :: dm(i1:i2,km)
real, intent(in) :: dp(i1:i2,km)
real, intent(in) :: dq(i1:i2,km)

!==============================================
! declare local variables
!==============================================
real :: adalfa(i1:i2,km)
real :: adalfah
real :: addg2
real :: adf(i1:i2,km)
real :: adrat(i1:i2,km)
real :: alfa(i1:i2,km)
real :: dg2
real :: f(i1:i2,km)
integer :: i
integer :: k
real :: rat(i1:i2,km)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
adalfa(:,:) = 0.
addg2 = 0.
adf(:,:) = 0.
adrat(:,:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
do k = 2, km
  do i = i1, i2
    rat(i,k) = dq(i,k-1)/d4(i,k)
  end do
end do
do k = 2, km-1
  do i = i1, i2
    f(i,k) = (rat(i,k+1)-rat(i,k))/(dp(i,k-1)+dp(i,k)+dp(i,k+1))
  end do
end do
do k = 3, km-2
  do i = i1, i2
    if (f(i,k+1)*f(i,k-1) .lt. 0. .and. df2(i,k) .ne. 0.) then
      dg2 = (f(i,k+1)-f(i,k-1))*((dp(i,k+1)-dp(i,k-1))**2+d4(i,k)*d4(i,k+1))
      alfa(i,k) = max(0.,min(0.5,-(0.1875*dg2/df2(i,k))))
    else
      alfa(i,k) = 0.
    endif
  end do
end do
do k = 4, km-2
  do i = i1, i2
    ada4(1,i,k-1) = ada4(1,i,k-1)+ada4(2,i,k)*alfa(i,k)
    ada4(1,i,k) = ada4(1,i,k)+ada4(2,i,k)*alfa(i,k-1)
    adalfa(i,k-1) = adalfa(i,k-1)+ada4(2,i,k)*((-a4(2,i,k))+a4(1,i,k)-dm(i,k))
    adalfa(i,k) = adalfa(i,k)+ada4(2,i,k)*((-a4(2,i,k))+a4(1,i,k-1)+dm(i,k-1))
    addm(i,k-1) = addm(i,k-1)+ada4(2,i,k)*alfa(i,k)
    addm(i,k) = addm(i,k)-ada4(2,i,k)*alfa(i,k-1)
    ada4(2,i,k) = ada4(2,i,k)*(1.-alfa(i,k-1)-alfa(i,k))
  end do
end do
do k = km-2, 3, -1
  do i = i2, i1, -1
    if (f(i,k+1)*f(i,k-1) .lt. 0. .and. df2(i,k) .ne. 0.) then
      dg2 = (f(i,k+1)-f(i,k-1))*((dp(i,k+1)-dp(i,k-1))**2+d4(i,k)*d4(i,k+1))
      adalfah = adalfa(i,k)*(0.5-sign(0.5,0.-min(0.5,-(0.1875*dg2/df2(i,k)))))
      addf2(i,k) = addf2(i,k)+adalfah*(0.5-sign(0.5,(-(0.1875*dg2/df2(i,k)))-0.5))*(0.1875*dg2/(df2(i,k)*df2(i,k)))
      addg2 = addg2-adalfah*(0.5-sign(0.5,(-(0.1875*dg2/df2(i,k)))-0.5))*(0.1875/df2(i,k))
      adalfa(i,k) = 0.
      add4(i,k+1) = add4(i,k+1)+addg2*(f(i,k+1)-f(i,k-1))*d4(i,k)
      add4(i,k) = add4(i,k)+addg2*(f(i,k+1)-f(i,k-1))*d4(i,k+1)
      addp(i,k-1) = addp(i,k-1)-2*addg2*(f(i,k+1)-f(i,k-1))*(dp(i,k+1)-dp(i,k-1))
      addp(i,k+1) = addp(i,k+1)+2*addg2*(f(i,k+1)-f(i,k-1))*(dp(i,k+1)-dp(i,k-1))
      adf(i,k-1) = adf(i,k-1)-addg2*((dp(i,k+1)-dp(i,k-1))**2+d4(i,k)*d4(i,k+1))
      adf(i,k+1) = adf(i,k+1)+addg2*((dp(i,k+1)-dp(i,k-1))**2+d4(i,k)*d4(i,k+1))
      addg2 = 0.
    else
      adalfa(i,k) = 0.
    endif
  end do
end do
do k = 2, km-1
  do i = i1, i2
    addp(i,k-1) = addp(i,k-1)-adf(i,k)*((rat(i,k+1)-rat(i,k))/((dp(i,k-1)+dp(i,k)+dp(i,k+1))*(dp(i,k-1)+dp(i,k)+dp(i,k+1))))
    addp(i,k+1) = addp(i,k+1)-adf(i,k)*((rat(i,k+1)-rat(i,k))/((dp(i,k-1)+dp(i,k)+dp(i,k+1))*(dp(i,k-1)+dp(i,k)+dp(i,k+1))))
    addp(i,k) = addp(i,k)-adf(i,k)*((rat(i,k+1)-rat(i,k))/((dp(i,k-1)+dp(i,k)+dp(i,k+1))*(dp(i,k-1)+dp(i,k)+dp(i,k+1))))
    adrat(i,k+1) = adrat(i,k+1)+adf(i,k)/(dp(i,k-1)+dp(i,k)+dp(i,k+1))
    adrat(i,k) = adrat(i,k)-adf(i,k)/(dp(i,k-1)+dp(i,k)+dp(i,k+1))
    adf(i,k) = 0.
  end do
end do
do k = 2, km
  do i = i1, i2
    add4(i,k) = add4(i,k)-adrat(i,k)*(dq(i,k-1)/(d4(i,k)*d4(i,k)))
    addq(i,k-1) = addq(i,k-1)+adrat(i,k)/d4(i,k)
    adrat(i,k) = 0.
  end do
end do

end subroutine adsteepz



 subroutine get_pt(pt,hs,gz,te,ua,va,peln,pe,delp,q,pkz,rg,cp,r_vir,ncnst,sphum,dtmp,is,ie,js,je,isd,ied,jsd,jed,km)
  integer :: is,ie,js,je,isd,ied,jsd,jed,km,ncnst,sphum

  real :: hs(isd:ied,jsd:jed) ! surface geopotential
  real :: pt(isd:ied ,jsd:jed ,km) ! cp*virtual potential temperature
  real :: ua(isd:ied,jsd:jed,km) ! u-wind (m/s) on physics grid
  real :: va(isd:ied,jsd:jed,km) ! v-wind (m/s) on physics grid
  real :: te(is:ie,js:je,km)
  real :: gz(is:ie)
  real :: peln(is:ie,km+1,js:je)
  real :: q(isd:ied,jsd:jed,km,ncnst)
  real :: delp(isd:ied,jsd:jed,km) 
  real :: pe(is-1:ie+1,km+1,js-1:je+1) 
  real :: pkz(is:ie,js:je,km) ! layer-mean pk for converting t to pt

  integer i,j,k
  real :: tpe,dlnp,tmp,rg,cp,r_vir,dtmp

      do j=js,je
         do i=is,ie
            gz(i) = hs(i,j)
         enddo
         do k=km,1,-1
            do i=is,ie
               tpe = te(i,j,k) -0.5*(ua(i,j,k)**2 + va(i,j,k)**2) - gz(i)
               dlnp = rg*(peln(i,k+1,j) - peln(i,k,j))
               tmp = tpe/((cp - pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,sphum)))
               pt(i,j,k) = tmp + dtmp*pkz(i,j,k) / (1.+r_vir*q(i,j,k,sphum))
               gz(i) = gz(i) + dlnp*tmp*(1.+r_vir*q(i,j,k,sphum))
            enddo
         enddo ! end k-loop
      enddo

 end subroutine get_pt

end module     adfv_mapz_mod


