!                           DISCLAIMER
!
!   This file was generated by TAF version 1.9.22
!
!   FASTOPT DISCLAIMS  ALL  WARRANTIES,  EXPRESS  OR  IMPLIED,
!   INCLUDING (WITHOUT LIMITATION) ALL IMPLIED  WARRANTIES  OF
!   MERCHANTABILITY  OR FITNESS FOR A PARTICULAR PURPOSE, WITH
!   RESPECT TO THE SOFTWARE AND USER PROGRAMS.   IN  NO  EVENT
!   SHALL  FASTOPT BE LIABLE FOR ANY LOST OR ANTICIPATED PROF-
!   ITS, OR ANY INDIRECT, INCIDENTAL, EXEMPLARY,  SPECIAL,  OR
!   CONSEQUENTIAL  DAMAGES, WHETHER OR NOT FASTOPT WAS ADVISED
!   OF THE POSSIBILITY OF SUCH DAMAGES.
!
!                           Haftungsbeschraenkung
!   FastOpt gibt ausdruecklich keine Gewaehr, explizit oder indirekt,
!   bezueglich der Brauchbarkeit  der Software  fuer einen bestimmten
!   Zweck.   Unter  keinen  Umstaenden   ist  FastOpt   haftbar  fuer
!   irgendeinen Verlust oder nicht eintretenden erwarteten Gewinn und
!   allen indirekten,  zufaelligen,  exemplarischen  oder  speziellen
!   Schaeden  oder  Folgeschaeden  unabhaengig  von einer eventuellen
!   Mitteilung darueber an FastOpt.
!
module     admapz_module
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! referencing used modules
!==============================================
use pre_direct
use constants_mod, only : pi,radius,rdgas,rvgas
use grid_tools, only : area,dx,dxa,dy,dya
use grid_utils, only : ied,isd,jed,jsd,ptop,ptop_min,cubed_to_latlon, g_sum
use fill_module, only : fillz
use mp_mod, only : gid,domain
use mpp_domains_mod, only : mpp_update_domains
use mapz_module

!==============================================
! all entries are defined explicitly
!==============================================
implicit none

contains
subroutine adcompute_total_energy( isd, ied, jsd, jed, km, adu, adv, adua, adva )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! referencing used modules
!==============================================
use grid_utils, only : adcubed_to_latlon

!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: ied
integer, intent(in) :: isd
integer, intent(in) :: jed
integer, intent(in) :: jsd
integer, intent(in) :: km
real, intent(inout) :: adu(isd:ied,jsd:jed+1,km)
real, intent(inout) :: adua(isd:ied,jsd:jed,km)
real, intent(inout) :: adv(isd:ied+1,jsd:jed,km)
real, intent(inout) :: adva(isd:ied,jsd:jed,km)

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
call adcubed_to_latlon( adu,adv,adua,adva,dx,dy,dxa,dya,km )

end subroutine adcompute_total_energy


subroutine adcs_limiters( im, a4, ada4, iv )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r12 = 1./12.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: im
real, intent(inout) :: a4(4,im)
real, intent(inout) :: ada4(4,im)
integer, intent(in) :: iv

!==============================================
! declare local variables
!==============================================
real :: a6da
real :: ada6da
real :: adda1
real :: adda2
real :: adfmin
real :: da1
real :: da2
real :: fmin
integer :: i

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
ada6da = 0.
adda1 = 0.
adda2 = 0.
adfmin = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
if (iv .eq. 0) then
  do i = 1, im
    adfmin = 0.
    if (abs(a4(3,i)-a4(2,i)) .lt. (-a4(4,i))) then
      fmin = a4(1,i)+0.25*(a4(3,i)-a4(2,i))**2/a4(4,i)+a4(4,i)*r12
      if (fmin .lt. 0.) then
        if (a4(1,i) .lt. a4(3,i) .and. a4(1,i) .lt. a4(2,i)) then
          ada4(4,i) = 0.
          ada4(1,i) = ada4(1,i)+ada4(2,i)
          ada4(2,i) = 0.
          ada4(1,i) = ada4(1,i)+ada4(3,i)
          ada4(3,i) = 0.
        else if (a4(3,i) .gt. a4(2,i)) then
          ada4(4,i) = ada4(4,i)-ada4(3,i)
          ada4(2,i) = ada4(2,i)+ada4(3,i)
          ada4(3,i) = 0.
          ada4(2,i) = ada4(2,i)+3*ada4(4,i)
          ada4(1,i) = ada4(1,i)-3*ada4(4,i)
          ada4(4,i) = 0.
        else
          ada4(4,i) = ada4(4,i)-ada4(2,i)
          ada4(3,i) = ada4(3,i)+ada4(2,i)
          ada4(2,i) = 0.
          ada4(3,i) = ada4(3,i)+3*ada4(4,i)
          ada4(1,i) = ada4(1,i)-3*ada4(4,i)
          ada4(4,i) = 0.
        endif
      endif
      ada4(4,i) = ada4(4,i)+adfmin*((-(0.25*(a4(3,i)-a4(2,i))**2/(a4(4,i)*a4(4,i))))+r12)
      ada4(3,i) = ada4(3,i)+adfmin*(0.5*(a4(3,i)-a4(2,i))/a4(4,i))
      ada4(2,i) = ada4(2,i)+adfmin*((-0.5)*(a4(3,i)-a4(2,i))/a4(4,i))
      ada4(1,i) = ada4(1,i)+adfmin
      adfmin = 0.
    endif
  end do
else
  do i = 1, im
    ada6da = 0.
    adda1 = 0.
    adda2 = 0.
    if ((a4(1,i)-a4(2,i))*(a4(1,i)-a4(3,i)) .ge. 0.) then
      ada4(4,i) = 0.
      ada4(1,i) = ada4(1,i)+ada4(3,i)
      ada4(3,i) = 0.
      ada4(1,i) = ada4(1,i)+ada4(2,i)
      ada4(2,i) = 0.
    else
      da1 = a4(3,i)-a4(2,i)
      da2 = da1**2
      a6da = a4(4,i)*da1
      if (a6da .lt. (-da2)) then
        ada4(4,i) = ada4(4,i)-ada4(3,i)
        ada4(2,i) = ada4(2,i)+ada4(3,i)
        ada4(3,i) = 0.
        ada4(2,i) = ada4(2,i)+3*ada4(4,i)
        ada4(1,i) = ada4(1,i)-3*ada4(4,i)
        ada4(4,i) = 0.
      else if (a6da .gt. da2) then
        ada4(4,i) = ada4(4,i)-ada4(2,i)
        ada4(3,i) = ada4(3,i)+ada4(2,i)
        ada4(2,i) = 0.
        ada4(3,i) = ada4(3,i)+3*ada4(4,i)
        ada4(1,i) = ada4(1,i)-3*ada4(4,i)
        ada4(4,i) = 0.
      endif
      ada4(4,i) = ada4(4,i)+ada6da*da1
      adda1 = adda1+ada6da*a4(4,i)
      ada6da = 0.
      adda1 = adda1+2*adda2*da1
      adda2 = 0.
      ada4(3,i) = ada4(3,i)+adda1
      ada4(2,i) = ada4(2,i)-adda1
      adda1 = 0.
    endif
  end do
endif

end subroutine adcs_limiters


subroutine adcs_profile( a4, ada4, delp, addelp, km, i1, i2, iv )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: km
real, intent(inout) :: a4(4,i1:i2,km)
real, intent(inout) :: ada4(4,i1:i2,km)
real, intent(inout) :: addelp(i1:i2,km)
real, intent(in) :: delp(i1:i2,km)
integer, intent(in) :: iv

!==============================================
! declare local variables
!==============================================
real :: a4h
real :: a4i
real :: a4j
real :: a4k
real :: a4l
real :: a4m
real :: a4n
real :: a4o
real :: a4p
real :: a4q
real :: a4r(lbound(a4,1):ubound(a4,1),lbound(a4,2):ubound(a4,2),lbound(a4,3):ubound(a4,3))
real :: a4s(lbound(a4,1):ubound(a4,1),lbound(a4,2):ubound(a4,2),lbound(a4,3):ubound(a4,3))
real :: a_bot
real :: ada4h
real :: ada4i
real :: ada4j
real :: ada4k
real :: ada4l
real :: ada4m
real :: ada4n
real :: ada4o
real :: ada4p
real :: ada4q
real :: ada_bot
real :: adbet
real :: add4(i1:i2)
real :: adgam(i1:i2,km)
real :: adgrat
real :: adlac
real :: adpmp
real :: adq(i1:i2,km+1)
real :: adqh
real :: adqi
real :: adqj
real :: adqk
real :: adql
real :: adqm
real :: bet
real :: d4(i1:i2)
real :: gam(i1:i2,km)
real :: grat
integer :: i
integer :: ib2
integer :: ib3
integer :: ib4
integer :: ib5
integer :: im
integer :: k
integer :: k1
integer :: k2
integer :: k3
integer :: k4
integer :: k5
integer :: ka1
integer :: ka2
integer :: ka3
integer :: ka4
integer :: kb1
real :: lac
real :: pmp
real :: q(i1:i2,km+1)
real :: qh
real :: qi
real :: qj
real :: qk
real :: ql
real :: qm

!----------------------------------------------
! SAVE REQUIRED INPUT VARIABLES
!----------------------------------------------
a4s(:,:,:) = a4(:,:,:)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
ada_bot = 0.
adbet = 0.
add4(:) = 0.
adgam(:,:) = 0.
adgrat = 0.
adlac = 0.
adpmp = 0.
adq(:,:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = (2.*grat*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = 2, km
  do i = i1, i2
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+2.*d4(i)-gam(i,k-1)
    q(i,k) = (3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/bet
    gam(i,k) = d4(i)/bet
  end do
end do
do i = i1, i2
  a_bot = 1.+d4(i)*(d4(i)+1.5)
  q(i,km+1) = (2.*d4(i)*(d4(i)+1.)*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))/(d4(i)*(d4(i)+0.5)-a_bot*gam(i,km))
end do
do k = km, 1, -1
  do i = i1, i2
    q(i,k) = q(i,k)-gam(i,k)*q(i,k+1)
  end do
end do
im = i2-i1+1
do k = 2, km
  do i = i1, i2
    gam(i,k) = a4(1,i,k)-a4(1,i,k-1)
  end do
end do
do i = i1, i2
  if ((q(i,2)-q(i,1))*(q(i,3)-q(i,2)) .gt. 0.) then
    q(i,2) = min(q(i,2),max(a4(1,i,1),a4(1,i,2)))
    q(i,2) = max(q(i,2),min(a4(1,i,1),a4(1,i,2)))
  else if (iv .eq. 0) then
    q(i,2) = max(0.,q(i,2))
  endif
end do
do k = 3, km-1
  do i = i1, i2
    if (gam(i,k-1)*gam(i,k+1) .gt. 0.) then
      q(i,k) = min(q(i,k),max(a4(1,i,k-1),a4(1,i,k)))
      q(i,k) = max(q(i,k),min(a4(1,i,k-1),a4(1,i,k)))
    else if (iv .eq. 0) then
      q(i,k) = max(0.,q(i,k))
    endif
  end do
end do
do i = i1, i2
  if ((q(i,km)-q(i,km-1))*(q(i,km+1)-q(i,km)) .gt. 0.) then
    q(i,km) = min(q(i,km),max(a4(1,i,km-1),a4(1,i,km)))
    q(i,km) = max(q(i,km),min(a4(1,i,km-1),a4(1,i,km)))
  else if (iv .eq. 0) then
    q(i,km) = max(0.,q(i,km))
  endif
end do
do k = 1, km
  do i = i1, i2
    a4(2,i,k) = q(i,k)
    a4(3,i,k) = q(i,k+1)
  end do
end do
do i = i1, i2
  if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
    a4(2,i,1) = 0.
  endif
  if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
    a4(3,i,km) = 0.
  endif
end do
do k = 1, 2
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call cs_limiters( im,a4(1,i1,k),1 )
end do
do k = 3, km-2
  do i = i1, i2
    pmp = a4(1,i,k)-2.*gam(i,k+1)
    lac = pmp+1.5*gam(i,k+2)
    a4(2,i,k) = min(max(a4(2,i,k),min(a4(1,i,k),pmp,lac)),max(a4(1,i,k),pmp,lac))
    pmp = a4(1,i,k)+2.*gam(i,k)
    lac = pmp-1.5*gam(i,k-1)
    a4(3,i,k) = min(max(a4(3,i,k),min(a4(1,i,k),pmp,lac)),max(a4(1,i,k),pmp,lac))
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  if (iv .eq. 0) then
    call cs_limiters( im,a4(1,i1,k),0 )
  endif
end do
do k = km, km-1, -1
  do ka1 = 1, km
    do i = i1, i2
      a4(2,i,ka1) = q(i,ka1)
      a4(3,i,ka1) = q(i,ka1+1)
    end do
  end do
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
    if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
      a4(3,i,km) = 0.
    endif
  end do
  do ka1 = 1, 2
    do i = i1, i2
      a4(4,i,ka1) = 3.*(2.*a4(1,i,ka1)-(a4(2,i,ka1)+a4(3,i,ka1)))
    end do
    call cs_limiters( im,a4(1,i1,ka1),1 )
  end do
  do ka1 = 3, km-2
    do i = i1, i2
      pmp = a4(1,i,ka1)-2.*gam(i,ka1+1)
      lac = pmp+1.5*gam(i,ka1+2)
      a4(2,i,ka1) = min(max(a4(2,i,ka1),min(a4(1,i,ka1),pmp,lac)),max(a4(1,i,ka1),pmp,lac))
      pmp = a4(1,i,ka1)+2.*gam(i,ka1)
      lac = pmp-1.5*gam(i,ka1-1)
      a4(3,i,ka1) = min(max(a4(3,i,ka1),min(a4(1,i,ka1),pmp,lac)),max(a4(1,i,ka1),pmp,lac))
      a4(4,i,ka1) = 3.*(2.*a4(1,i,ka1)-(a4(2,i,ka1)+a4(3,i,ka1)))
    end do
    if (iv .eq. 0) then
      call cs_limiters( im,a4(1,i1,ka1),0 )
    endif
  end do
  do k1 = km-1, k-1
    do i = i1, i2
      a4(4,i,k1) = 3.*(2.*a4(1,i,k1)-(a4(2,i,k1)+a4(3,i,k1)))
    end do
    call cs_limiters( im,a4(1,i1,k1),1 )
  end do
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call adcs_limiters( im,a4(1,i1,k),ada4(1,i1,k),1 )
  do i = i1, i2
    ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
    ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
    ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
    ada4(4,i,k) = 0.
  end do
end do
do k = 1, km
  do i = i1, i2
    a4(2,i,k) = q(i,k)
    a4(3,i,k) = q(i,k+1)
  end do
end do
do i = i1, i2
  if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
    a4(2,i,1) = 0.
  endif
  if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
    a4(3,i,km) = 0.
  endif
end do
do k = 1, 2
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call cs_limiters( im,a4(1,i1,k),1 )
end do
do k = km-2, 3, -1
  do ka2 = 1, km
    do i = i1, i2
      a4(2,i,ka2) = q(i,ka2)
      a4(3,i,ka2) = q(i,ka2+1)
    end do
  end do
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
    if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
      a4(3,i,km) = 0.
    endif
  end do
  do ka2 = 1, 2
    do i = i1, i2
      a4(4,i,ka2) = 3.*(2.*a4(1,i,ka2)-(a4(2,i,ka2)+a4(3,i,ka2)))
    end do
    call cs_limiters( im,a4(1,i1,ka2),1 )
  end do
  do k2 = 3, k-1
    do i = i1, i2
      pmp = a4(1,i,k2)-2.*gam(i,k2+1)
      lac = pmp+1.5*gam(i,k2+2)
      a4(2,i,k2) = min(max(a4(2,i,k2),min(a4(1,i,k2),pmp,lac)),max(a4(1,i,k2),pmp,lac))
      pmp = a4(1,i,k2)+2.*gam(i,k2)
      lac = pmp-1.5*gam(i,k2-1)
      a4(3,i,k2) = min(max(a4(3,i,k2),min(a4(1,i,k2),pmp,lac)),max(a4(1,i,k2),pmp,lac))
      a4(4,i,k2) = 3.*(2.*a4(1,i,k2)-(a4(2,i,k2)+a4(3,i,k2)))
    end do
    if (iv .eq. 0) then
      call cs_limiters( im,a4(1,i1,k2),0 )
    endif
  end do
  a4r(:,:,:) = a4(:,:,:)
  do i = i1, i2
    pmp = a4(1,i,k)-2.*gam(i,k+1)
    lac = pmp+1.5*gam(i,k+2)
    a4(2,i,k) = min(max(a4(2,i,k),min(a4(1,i,k),pmp,lac)),max(a4(1,i,k),pmp,lac))
    pmp = a4(1,i,k)+2.*gam(i,k)
    lac = pmp-1.5*gam(i,k-1)
    a4(3,i,k) = min(max(a4(3,i,k),min(a4(1,i,k),pmp,lac)),max(a4(1,i,k),pmp,lac))
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  if (iv .eq. 0) then
    call adcs_limiters( im,a4(1,i1,k),ada4(1,i1,k),0 )
  endif
  a4(:,:,:) = a4r(:,:,:)
  do i = i1, i2
    adlac = 0.
    adpmp = 0.
    pmp = a4(1,i,k)-2.*gam(i,k+1)
    lac = pmp+1.5*gam(i,k+2)
    a4(2,i,k) = min(max(a4(2,i,k),min(a4(1,i,k),pmp,lac)),max(a4(1,i,k),pmp,lac))
    pmp = a4(1,i,k)+2.*gam(i,k)
    lac = pmp-1.5*gam(i,k-1)
    ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
    ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
    ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
    ada4(4,i,k) = 0.
    a4i = min(a4(1,i,k),pmp)
    a4j = min(a4i,lac)
    a4h = max(a4(3,i,k),a4j)
    a4k = max(a4(1,i,k),pmp)
    a4l = max(a4k,lac)
    ada4h = ada4(3,i,k)*(0.5+sign(0.5,a4l-a4h))
    ada4l = ada4(3,i,k)*(0.5-sign(0.5,a4l-a4h))
    ada4k = ada4l*(0.5+sign(0.5,a4k-lac))
    adlac = adlac+ada4l*(0.5-sign(0.5,a4k-lac))
    ada4(1,i,k) = ada4(1,i,k)+ada4k*(0.5+sign(0.5,a4(1,i,k)-pmp))
    adpmp = adpmp+ada4k*(0.5-sign(0.5,a4(1,i,k)-pmp))
    ada4j = ada4h*(0.5-sign(0.5,a4(3,i,k)-a4j))
    ada4i = ada4j*(0.5+sign(0.5,lac-a4i))
    adlac = adlac+ada4j*(0.5-sign(0.5,lac-a4i))
    ada4(1,i,k) = ada4(1,i,k)+ada4i*(0.5+sign(0.5,pmp-a4(1,i,k)))
    adpmp = adpmp+ada4i*(0.5-sign(0.5,pmp-a4(1,i,k)))
    ada4(3,i,k) = ada4h*(0.5+sign(0.5,a4(3,i,k)-a4j))
    adgam(i,k-1) = adgam(i,k-1)-1.5*adlac
    adpmp = adpmp+adlac
    adlac = 0.
    ada4(1,i,k) = ada4(1,i,k)+adpmp
    adgam(i,k) = adgam(i,k)+2*adpmp
    adpmp = 0.
    a4(:,:,:) = a4r(:,:,:)
    pmp = a4(1,i,k)-2.*gam(i,k+1)
    lac = pmp+1.5*gam(i,k+2)
    a4n = min(a4(1,i,k),pmp)
    a4o = min(a4n,lac)
    a4m = max(a4(2,i,k),a4o)
    a4p = max(a4(1,i,k),pmp)
    a4q = max(a4p,lac)
    ada4m = ada4(2,i,k)*(0.5+sign(0.5,a4q-a4m))
    ada4q = ada4(2,i,k)*(0.5-sign(0.5,a4q-a4m))
    ada4p = ada4q*(0.5+sign(0.5,a4p-lac))
    adlac = adlac+ada4q*(0.5-sign(0.5,a4p-lac))
    ada4(1,i,k) = ada4(1,i,k)+ada4p*(0.5+sign(0.5,a4(1,i,k)-pmp))
    adpmp = adpmp+ada4p*(0.5-sign(0.5,a4(1,i,k)-pmp))
    ada4o = ada4m*(0.5-sign(0.5,a4(2,i,k)-a4o))
    ada4n = ada4o*(0.5+sign(0.5,lac-a4n))
    adlac = adlac+ada4o*(0.5-sign(0.5,lac-a4n))
    ada4(1,i,k) = ada4(1,i,k)+ada4n*(0.5+sign(0.5,pmp-a4(1,i,k)))
    adpmp = adpmp+ada4n*(0.5-sign(0.5,pmp-a4(1,i,k)))
    ada4(2,i,k) = ada4m*(0.5+sign(0.5,a4(2,i,k)-a4o))
    adgam(i,k+2) = adgam(i,k+2)+1.5*adlac
    adpmp = adpmp+adlac
    adlac = 0.
    ada4(1,i,k) = ada4(1,i,k)+adpmp
    adgam(i,k+1) = adgam(i,k+1)-2*adpmp
    adpmp = 0.
  end do
end do
do k = 1, km
  do i = i1, i2
    a4(2,i,k) = q(i,k)
    a4(3,i,k) = q(i,k+1)
  end do
end do
do i = i1, i2
  if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
    a4(2,i,1) = 0.
  endif
  if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
    a4(3,i,km) = 0.
  endif
end do
do k = 2, 1, -1
  do ka3 = 1, km
    do i = i1, i2
      a4(2,i,ka3) = q(i,ka3)
      a4(3,i,ka3) = q(i,ka3+1)
    end do
  end do
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
    if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
      a4(3,i,km) = 0.
    endif
  end do
  do k3 = 1, k-1
    do i = i1, i2
      a4(4,i,k3) = 3.*(2.*a4(1,i,k3)-(a4(2,i,k3)+a4(3,i,k3)))
    end do
    call cs_limiters( im,a4(1,i1,k3),1 )
  end do
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call adcs_limiters( im,a4(1,i1,k),ada4(1,i1,k),1 )
  do i = i1, i2
    ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
    ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
    ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
    ada4(4,i,k) = 0.
  end do
end do
do k = 1, km
  do i = i1, i2
    a4(2,i,k) = q(i,k)
    a4(3,i,k) = q(i,k+1)
  end do
end do
do i = i1, i2
  if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
    a4(2,i,1) = 0.
  endif
  if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
    ada4(3,i,km) = 0.
  endif
  do k = 1, km
    do ib2 = i1, i2
      a4(2,ib2,k) = q(ib2,k)
      a4(3,ib2,k) = q(ib2,k+1)
    end do
  end do
  if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
    ada4(2,i,1) = 0.
  endif
end do
do k = 1, km
  do i = i1, i2
    adq(i,k+1) = adq(i,k+1)+ada4(3,i,k)
    ada4(3,i,k) = 0.
    adq(i,k) = adq(i,k)+ada4(2,i,k)
    ada4(2,i,k) = 0.
  end do
end do
a4(:,:,:) = a4s(:,:,:)
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = (2.*grat*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = 2, km
  do i = i1, i2
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+2.*d4(i)-gam(i,k-1)
    q(i,k) = (3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/bet
    gam(i,k) = d4(i)/bet
  end do
end do
do i = i1, i2
  a_bot = 1.+d4(i)*(d4(i)+1.5)
  q(i,km+1) = (2.*d4(i)*(d4(i)+1.)*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))/(d4(i)*(d4(i)+0.5)-a_bot*gam(i,km))
end do
do k = km, 1, -1
  do i = i1, i2
    q(i,k) = q(i,k)-gam(i,k)*q(i,k+1)
  end do
end do
do k = 2, km
  do i = i1, i2
    gam(i,k) = a4(1,i,k)-a4(1,i,k-1)
  end do
end do
do i = i1, i2
  if ((q(i,2)-q(i,1))*(q(i,3)-q(i,2)) .gt. 0.) then
    q(i,2) = min(q(i,2),max(a4(1,i,1),a4(1,i,2)))
    q(i,2) = max(q(i,2),min(a4(1,i,1),a4(1,i,2)))
  else if (iv .eq. 0) then
    q(i,2) = max(0.,q(i,2))
  endif
end do
do k = 3, km-1
  do i = i1, i2
    if (gam(i,k-1)*gam(i,k+1) .gt. 0.) then
      q(i,k) = min(q(i,k),max(a4(1,i,k-1),a4(1,i,k)))
      q(i,k) = max(q(i,k),min(a4(1,i,k-1),a4(1,i,k)))
    else if (iv .eq. 0) then
      q(i,k) = max(0.,q(i,k))
    endif
  end do
end do
do i = i1, i2
  if ((q(i,km)-q(i,km-1))*(q(i,km+1)-q(i,km)) .gt. 0.) then
    q(i,km) = min(q(i,km),max(a4(1,i,km-1),a4(1,i,km)))
    qh = min(a4(1,i,km-1),a4(1,i,km))
    adqh = adq(i,km)*(0.5-sign(0.5,q(i,km)-qh))
    ada4(1,i,km-1) = ada4(1,i,km-1)+adqh*(0.5+sign(0.5,a4(1,i,km)-a4(1,i,km-1)))
    ada4(1,i,km) = ada4(1,i,km)+adqh*(0.5-sign(0.5,a4(1,i,km)-a4(1,i,km-1)))
    adq(i,km) = adq(i,km)*(0.5+sign(0.5,q(i,km)-qh))
    do ib3 = i1, i2
      grat = delp(ib3,2)/delp(ib3,1)
      bet = grat*(grat+0.5)
      q(ib3,1) = (2.*grat*(grat+1.)*a4(1,ib3,1)+a4(1,ib3,2))/bet
      gam(ib3,1) = (1.+grat*(grat+1.5))/bet
    end do
    do k = 2, km
      do ib3 = i1, i2
        d4(ib3) = delp(ib3,k-1)/delp(ib3,k)
        bet = 2.+2.*d4(ib3)-gam(ib3,k-1)
        q(ib3,k) = (3.*(a4(1,ib3,k-1)+d4(ib3)*a4(1,ib3,k))-q(ib3,k-1))/bet
        gam(ib3,k) = d4(ib3)/bet
      end do
    end do
    do ib3 = i1, i2
      a_bot = 1.+d4(ib3)*(d4(ib3)+1.5)
      q(ib3,km+1) = (2.*d4(ib3)*(d4(ib3)+1.)*a4(1,ib3,km)+a4(1,ib3,km-1)-a_bot*q(ib3,km))/(d4(ib3)*(d4(ib3)+0.5)-a_bot*gam(ib3,km))
    end do
    do k = km, 1, -1
      do ib3 = i1, i2
        q(ib3,k) = q(ib3,k)-gam(ib3,k)*q(ib3,k+1)
      end do
    end do
    do k = 2, km
      do ib3 = i1, i2
        gam(ib3,k) = a4(1,ib3,k)-a4(1,ib3,k-1)
      end do
    end do
    do ib3 = i1, i2
      if ((q(ib3,2)-q(ib3,1))*(q(ib3,3)-q(ib3,2)) .gt. 0.) then
        q(ib3,2) = min(q(ib3,2),max(a4(1,ib3,1),a4(1,ib3,2)))
        q(ib3,2) = max(q(ib3,2),min(a4(1,ib3,1),a4(1,ib3,2)))
      else if (iv .eq. 0) then
        q(ib3,2) = max(0.,q(ib3,2))
      endif
    end do
    do k = 3, km-1
      do ib3 = i1, i2
        if (gam(ib3,k-1)*gam(ib3,k+1) .gt. 0.) then
          q(ib3,k) = min(q(ib3,k),max(a4(1,ib3,k-1),a4(1,ib3,k)))
          q(ib3,k) = max(q(ib3,k),min(a4(1,ib3,k-1),a4(1,ib3,k)))
        else if (iv .eq. 0) then
          q(ib3,k) = max(0.,q(ib3,k))
        endif
      end do
    end do
    qi = max(a4(1,i,km-1),a4(1,i,km))
    adqi = adq(i,km)*(0.5-sign(0.5,qi-q(i,km)))
    ada4(1,i,km-1) = ada4(1,i,km-1)+adqi*(0.5+sign(0.5,a4(1,i,km-1)-a4(1,i,km)))
    ada4(1,i,km) = ada4(1,i,km)+adqi*(0.5-sign(0.5,a4(1,i,km-1)-a4(1,i,km)))
    adq(i,km) = adq(i,km)*(0.5+sign(0.5,qi-q(i,km)))
  else if (iv .eq. 0) then
    adq(i,km) = adq(i,km)*(0.5-sign(0.5,0.-q(i,km)))
  endif
end do
a4(:,:,:) = a4s(:,:,:)
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = (2.*grat*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = 2, km
  do i = i1, i2
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+2.*d4(i)-gam(i,k-1)
    q(i,k) = (3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/bet
    gam(i,k) = d4(i)/bet
  end do
end do
do i = i1, i2
  a_bot = 1.+d4(i)*(d4(i)+1.5)
  q(i,km+1) = (2.*d4(i)*(d4(i)+1.)*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))/(d4(i)*(d4(i)+0.5)-a_bot*gam(i,km))
end do
do k = km, 1, -1
  do i = i1, i2
    q(i,k) = q(i,k)-gam(i,k)*q(i,k+1)
  end do
end do
do k = 2, km
  do i = i1, i2
    gam(i,k) = a4(1,i,k)-a4(1,i,k-1)
  end do
end do
do i = i1, i2
  if ((q(i,2)-q(i,1))*(q(i,3)-q(i,2)) .gt. 0.) then
    q(i,2) = min(q(i,2),max(a4(1,i,1),a4(1,i,2)))
    q(i,2) = max(q(i,2),min(a4(1,i,1),a4(1,i,2)))
  else if (iv .eq. 0) then
    q(i,2) = max(0.,q(i,2))
  endif
end do
do k = 3, km-1
  do i = i1, i2
    if (gam(i,k-1)*gam(i,k+1) .gt. 0.) then
      q(i,k) = min(q(i,k),max(a4(1,i,k-1),a4(1,i,k)))
      qj = min(a4(1,i,k-1),a4(1,i,k))
      adqj = adq(i,k)*(0.5-sign(0.5,q(i,k)-qj))
      ada4(1,i,k-1) = ada4(1,i,k-1)+adqj*(0.5+sign(0.5,a4(1,i,k)-a4(1,i,k-1)))
      ada4(1,i,k) = ada4(1,i,k)+adqj*(0.5-sign(0.5,a4(1,i,k)-a4(1,i,k-1)))
      adq(i,k) = adq(i,k)*(0.5+sign(0.5,q(i,k)-qj))
      do ib4 = i1, i2
        grat = delp(ib4,2)/delp(ib4,1)
        bet = grat*(grat+0.5)
        q(ib4,1) = (2.*grat*(grat+1.)*a4(1,ib4,1)+a4(1,ib4,2))/bet
        gam(ib4,1) = (1.+grat*(grat+1.5))/bet
      end do
      do kb1 = 2, km
        do ib4 = i1, i2
          d4(ib4) = delp(ib4,kb1-1)/delp(ib4,kb1)
          bet = 2.+2.*d4(ib4)-gam(ib4,kb1-1)
          q(ib4,kb1) = (3.*(a4(1,ib4,kb1-1)+d4(ib4)*a4(1,ib4,kb1))-q(ib4,kb1-1))/bet
          gam(ib4,kb1) = d4(ib4)/bet
        end do
      end do
      do ib4 = i1, i2
        a_bot = 1.+d4(ib4)*(d4(ib4)+1.5)
        q(ib4,km+1) = (2.*d4(ib4)*(d4(ib4)+1.)*a4(1,ib4,km)+a4(1,ib4,km-1)-a_bot*q(ib4,km))/(d4(ib4)*(d4(ib4)+0.5)-a_bot*gam(ib4,&
&km))
      end do
      do kb1 = km, 1, -1
        do ib4 = i1, i2
          q(ib4,kb1) = q(ib4,kb1)-gam(ib4,kb1)*q(ib4,kb1+1)
        end do
      end do
      do kb1 = 2, km
        do ib4 = i1, i2
          gam(ib4,kb1) = a4(1,ib4,kb1)-a4(1,ib4,kb1-1)
        end do
      end do
      do ib4 = i1, i2
        if ((q(ib4,2)-q(ib4,1))*(q(ib4,3)-q(ib4,2)) .gt. 0.) then
          q(ib4,2) = min(q(ib4,2),max(a4(1,ib4,1),a4(1,ib4,2)))
          q(ib4,2) = max(q(ib4,2),min(a4(1,ib4,1),a4(1,ib4,2)))
        else if (iv .eq. 0) then
          q(ib4,2) = max(0.,q(ib4,2))
        endif
      end do
      qk = max(a4(1,i,k-1),a4(1,i,k))
      adqk = adq(i,k)*(0.5-sign(0.5,qk-q(i,k)))
      ada4(1,i,k-1) = ada4(1,i,k-1)+adqk*(0.5+sign(0.5,a4(1,i,k-1)-a4(1,i,k)))
      ada4(1,i,k) = ada4(1,i,k)+adqk*(0.5-sign(0.5,a4(1,i,k-1)-a4(1,i,k)))
      adq(i,k) = adq(i,k)*(0.5+sign(0.5,qk-q(i,k)))
    else if (iv .eq. 0) then
      adq(i,k) = adq(i,k)*(0.5-sign(0.5,0.-q(i,k)))
    endif
  end do
end do
a4(:,:,:) = a4s(:,:,:)
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = (2.*grat*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = 2, km
  do i = i1, i2
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+2.*d4(i)-gam(i,k-1)
    q(i,k) = (3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/bet
    gam(i,k) = d4(i)/bet
  end do
end do
do i = i1, i2
  a_bot = 1.+d4(i)*(d4(i)+1.5)
  q(i,km+1) = (2.*d4(i)*(d4(i)+1.)*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))/(d4(i)*(d4(i)+0.5)-a_bot*gam(i,km))
end do
do k = km, 1, -1
  do i = i1, i2
    q(i,k) = q(i,k)-gam(i,k)*q(i,k+1)
  end do
end do
do i = i1, i2
  if ((q(i,2)-q(i,1))*(q(i,3)-q(i,2)) .gt. 0.) then
    q(i,2) = min(q(i,2),max(a4(1,i,1),a4(1,i,2)))
    ql = min(a4(1,i,1),a4(1,i,2))
    adql = adq(i,2)*(0.5-sign(0.5,q(i,2)-ql))
    ada4(1,i,2) = ada4(1,i,2)+adql*(0.5-sign(0.5,a4(1,i,2)-a4(1,i,1)))
    ada4(1,i,1) = ada4(1,i,1)+adql*(0.5+sign(0.5,a4(1,i,2)-a4(1,i,1)))
    adq(i,2) = adq(i,2)*(0.5+sign(0.5,q(i,2)-ql))
    do ib5 = i1, i2
      grat = delp(ib5,2)/delp(ib5,1)
      bet = grat*(grat+0.5)
      q(ib5,1) = (2.*grat*(grat+1.)*a4(1,ib5,1)+a4(1,ib5,2))/bet
      gam(ib5,1) = (1.+grat*(grat+1.5))/bet
    end do
    do k = 2, km
      do ib5 = i1, i2
        d4(ib5) = delp(ib5,k-1)/delp(ib5,k)
        bet = 2.+2.*d4(ib5)-gam(ib5,k-1)
        q(ib5,k) = (3.*(a4(1,ib5,k-1)+d4(ib5)*a4(1,ib5,k))-q(ib5,k-1))/bet
        gam(ib5,k) = d4(ib5)/bet
      end do
    end do
    do ib5 = i1, i2
      a_bot = 1.+d4(ib5)*(d4(ib5)+1.5)
      q(ib5,km+1) = (2.*d4(ib5)*(d4(ib5)+1.)*a4(1,ib5,km)+a4(1,ib5,km-1)-a_bot*q(ib5,km))/(d4(ib5)*(d4(ib5)+0.5)-a_bot*gam(ib5,km))
    end do
    do k = km, 1, -1
      do ib5 = i1, i2
        q(ib5,k) = q(ib5,k)-gam(ib5,k)*q(ib5,k+1)
      end do
    end do
    do k = 2, km
      do ib5 = i1, i2
        gam(ib5,k) = a4(1,ib5,k)-a4(1,ib5,k-1)
      end do
    end do
    qm = max(a4(1,i,1),a4(1,i,2))
    adqm = adq(i,2)*(0.5-sign(0.5,qm-q(i,2)))
    ada4(1,i,2) = ada4(1,i,2)+adqm*(0.5-sign(0.5,a4(1,i,1)-a4(1,i,2)))
    ada4(1,i,1) = ada4(1,i,1)+adqm*(0.5+sign(0.5,a4(1,i,1)-a4(1,i,2)))
    adq(i,2) = adq(i,2)*(0.5+sign(0.5,qm-q(i,2)))
  else if (iv .eq. 0) then
    adq(i,2) = adq(i,2)*(0.5-sign(0.5,0.-q(i,2)))
  endif
end do
do k = 2, km
  do i = i1, i2
    ada4(1,i,k-1) = ada4(1,i,k-1)-adgam(i,k)
    ada4(1,i,k) = ada4(1,i,k)+adgam(i,k)
    adgam(i,k) = 0.
  end do
end do
a4(:,:,:) = a4s(:,:,:)
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = (2.*grat*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = 2, km
  do i = i1, i2
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+2.*d4(i)-gam(i,k-1)
    q(i,k) = (3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/bet
    gam(i,k) = d4(i)/bet
  end do
end do
do i = i1, i2
  a_bot = 1.+d4(i)*(d4(i)+1.5)
  q(i,km+1) = (2.*d4(i)*(d4(i)+1.)*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))/(d4(i)*(d4(i)+0.5)-a_bot*gam(i,km))
end do
do k = 1, km
  do i = i1, i2
    grat = delp(i,2)/delp(i,1)
    bet = grat*(grat+0.5)
    q(i,1) = (2.*grat*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
    gam(i,1) = (1.+grat*(grat+1.5))/bet
  end do
  do ka4 = 2, km
    do i = i1, i2
      d4(i) = delp(i,ka4-1)/delp(i,ka4)
      bet = 2.+2.*d4(i)-gam(i,ka4-1)
      q(i,ka4) = (3.*(a4(1,i,ka4-1)+d4(i)*a4(1,i,ka4))-q(i,ka4-1))/bet
      gam(i,ka4) = d4(i)/bet
    end do
  end do
  do i = i1, i2
    a_bot = 1.+d4(i)*(d4(i)+1.5)
    q(i,km+1) = (2.*d4(i)*(d4(i)+1.)*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))/(d4(i)*(d4(i)+0.5)-a_bot*gam(i,km))
  end do
  do k4 = km, k-(-1), -1
    do i = i1, i2
      q(i,k4) = q(i,k4)-gam(i,k4)*q(i,k4+1)
    end do
  end do
  do i = i1, i2
    adgam(i,k) = adgam(i,k)-adq(i,k)*q(i,k+1)
    adq(i,k+1) = adq(i,k+1)-adq(i,k)*gam(i,k)
  end do
end do
a4(:,:,:) = a4s(:,:,:)
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = (2.*grat*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = 2, km
  do i = i1, i2
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+2.*d4(i)-gam(i,k-1)
    q(i,k) = (3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/bet
    gam(i,k) = d4(i)/bet
  end do
end do
do i = i1, i2
  ada_bot = 0.
  a_bot = 1.+d4(i)*(d4(i)+1.5)
  ada4(1,i,km-1) = ada4(1,i,km-1)+adq(i,km+1)/(d4(i)*(0.5+d4(i))-a_bot*gam(i,km))
  ada4(1,i,km) = ada4(1,i,km)+adq(i,km+1)*(2*d4(i)*(1.+d4(i))/(d4(i)*(0.5+d4(i))-a_bot*gam(i,km)))
  ada_bot = ada_bot+adq(i,km+1)*((-(q(i,km)/(d4(i)*(0.5+d4(i))-a_bot*gam(i,km))))+(2.*d4(i)*(1.+d4(i))*a4(1,i,km)+a4(1,i,km-1)-&
&a_bot*q(i,km))*gam(i,km)/((d4(i)*(0.5+d4(i))-a_bot*gam(i,km))*(d4(i)*(0.5+d4(i))-a_bot*gam(i,km))))
  add4(i) = add4(i)+adq(i,km+1)*((2*d4(i)+2*(1.+d4(i)))*a4(1,i,km)/(d4(i)*(0.5+d4(i))-a_bot*gam(i,km))-(2.*d4(i)*(1.+d4(i))*a4(1,i,&
&km)+a4(1,i,km-1)-a_bot*q(i,km))*(0.5+2*d4(i))/((d4(i)*(0.5+d4(i))-a_bot*gam(i,km))*(d4(i)*(0.5+d4(i))-a_bot*gam(i,km))))
  adgam(i,km) = adgam(i,km)+adq(i,km+1)*((2.*d4(i)*(1.+d4(i))*a4(1,i,km)+a4(1,i,km-1)-a_bot*q(i,km))*a_bot/((d4(i)*(0.5+d4(i))-&
&a_bot*gam(i,km))*(d4(i)*(0.5+d4(i))-a_bot*gam(i,km))))
  adq(i,km) = adq(i,km)-adq(i,km+1)*(a_bot/(d4(i)*(0.5+d4(i))-a_bot*gam(i,km)))
  adq(i,km+1) = 0.
  add4(i) = add4(i)+ada_bot*(1.5+2*d4(i))
  ada_bot = 0.
end do
a4(:,:,:) = a4s(:,:,:)
do i = i1, i2
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  q(i,1) = (2.*grat*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
  gam(i,1) = (1.+grat*(grat+1.5))/bet
end do
do k = km, 2, -1
  do i = i1, i2
    grat = delp(i,2)/delp(i,1)
    bet = grat*(grat+0.5)
    q(i,1) = (2.*grat*(grat+1.)*a4(1,i,1)+a4(1,i,2))/bet
    gam(i,1) = (1.+grat*(grat+1.5))/bet
  end do
  do k5 = 2, k-1
    do i = i1, i2
      d4(i) = delp(i,k5-1)/delp(i,k5)
      bet = 2.+2.*d4(i)-gam(i,k5-1)
      q(i,k5) = (3.*(a4(1,i,k5-1)+d4(i)*a4(1,i,k5))-q(i,k5-1))/bet
      gam(i,k5) = d4(i)/bet
    end do
  end do
  do i = i1, i2
    adbet = 0.
    d4(i) = delp(i,k-1)/delp(i,k)
    bet = 2.+2.*d4(i)-gam(i,k-1)
    adbet = adbet-adgam(i,k)*(d4(i)/(bet*bet))
    add4(i) = add4(i)+adgam(i,k)/bet
    adgam(i,k) = 0.
    ada4(1,i,k-1) = ada4(1,i,k-1)+adq(i,k)*(3/bet)
    ada4(1,i,k) = ada4(1,i,k)+adq(i,k)*(3.*d4(i)/bet)
    adbet = adbet-adq(i,k)*((3.*(a4(1,i,k-1)+d4(i)*a4(1,i,k))-q(i,k-1))/(bet*bet))
    add4(i) = add4(i)+adq(i,k)*(3.*a4(1,i,k)/bet)
    adq(i,k-1) = adq(i,k-1)-adq(i,k)/bet
    adq(i,k) = 0.
    add4(i) = add4(i)+2*adbet
    adgam(i,k-1) = adgam(i,k-1)-adbet
    adbet = 0.
    addelp(i,k-1) = addelp(i,k-1)+add4(i)/delp(i,k)
    addelp(i,k) = addelp(i,k)-add4(i)*(delp(i,k-1)/(delp(i,k)*delp(i,k)))
    add4(i) = 0.
  end do
end do
a4(:,:,:) = a4s(:,:,:)
do i = i1, i2
  adbet = 0.
  adgrat = 0.
  grat = delp(i,2)/delp(i,1)
  bet = grat*(grat+0.5)
  adbet = adbet-adgam(i,1)*((1.+grat*(1.5+grat))/(bet*bet))
  adgrat = adgrat+adgam(i,1)*((1.5+2*grat)/bet)
  adgam(i,1) = 0.
  ada4(1,i,2) = ada4(1,i,2)+adq(i,1)/bet
  ada4(1,i,1) = ada4(1,i,1)+adq(i,1)*(2*grat*(1.+grat)/bet)
  adbet = adbet-adq(i,1)*((2.*grat*(1.+grat)*a4(1,i,1)+a4(1,i,2))/(bet*bet))
  adgrat = adgrat+adq(i,1)*((2*grat+2*(1.+grat))*a4(1,i,1)/bet)
  adq(i,1) = 0.
  adgrat = adgrat+adbet*(0.5+2*grat)
  adbet = 0.
  addelp(i,2) = addelp(i,2)+adgrat/delp(i,1)
  addelp(i,1) = addelp(i,1)-adgrat*(delp(i,2)/(delp(i,1)*delp(i,1)))
  adgrat = 0.
end do

!----------------------------------------------
! FREE DYNAMIC MEMORY
!----------------------------------------------

end subroutine adcs_profile


subroutine adlagrangian_to_eulerian( consv, pe, adpe, delp, addelp, pkz, adpkz, pk, adpk, km, is, ie, js, je, isd, ied, jsd, jed, &
&nq, u, adu, v, adv, delz, addelz, pt, adpt, q, adq, hs, grav, r_vir, cp, akap, kord_mt, kord_tr, kord_tm, peln, adpeln, ua, adua, &
&va, adva, omga, adomga, te, adte, fill, reproduce_sum, ak, bk, ks, ze0, adze0, remap_t, hydrostatic, hybrid_z, ktop, ncnst )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! referencing used modules
!==============================================
use grid_utils, only : adcubed_to_latlon
use fill_module, only : adfillz

!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: ied
integer, intent(in) :: isd
integer, intent(in) :: jed
integer, intent(in) :: jsd
integer, intent(in) :: km
real, intent(inout) :: addelp(isd:ied,jsd:jed,km)
integer, intent(in) :: ie
integer, intent(in) :: is
integer, intent(in) :: je
integer, intent(in) :: js
real, intent(inout) :: addelz(is:ie,js:je,km)
real, intent(inout) :: adomga(isd:ied,jsd:jed,km)
real, intent(inout) :: adpe(is-1:ie+1,km+1,js-1:je+1)
real, intent(inout) :: adpeln(is:ie,km+1,js:je)
real, intent(inout) :: adpk(is:ie,js:je,km+1)
real, intent(inout) :: adpkz(is:ie,js:je,km)
real, intent(inout) :: adpt(isd:ied,jsd:jed,km)
integer, intent(in) :: ncnst
real, intent(inout) :: adq(isd:ied,jsd:jed,km,ncnst)
real, intent(inout) :: adte(is:ie,js:je,km)
real, intent(inout) :: adu(isd:ied,jsd:jed+1,km)
real, intent(inout) :: adua(isd:ied,jsd:jed,km)
real, intent(inout) :: adv(isd:ied+1,jsd:jed,km)
real, intent(inout) :: adva(isd:ied,jsd:jed,km)
real, intent(inout) :: adze0(is:ie,js:je,km+1)
real, intent(in) :: ak(km+1)
real, intent(in) :: akap
real, intent(in) :: bk(km+1)
real, intent(in) :: consv
real, intent(in) :: cp
real, intent(inout) :: delp(isd:ied,jsd:jed,km)
real, intent(inout) :: delz(is:ie,js:je,km)
logical, intent(in) :: fill
real, intent(in) :: grav
real, intent(in) :: hs(isd:ied,jsd:jed)
logical, intent(in) :: hybrid_z
logical, intent(in) :: hydrostatic
integer, intent(in) :: kord_mt
integer, intent(in) :: kord_tm
integer, intent(in) :: kord_tr
integer, intent(in) :: ks
integer, intent(in) :: ktop
integer, intent(in) :: nq
real, intent(inout) :: omga(isd:ied,jsd:jed,km)
real, intent(inout) :: pe(is-1:ie+1,km+1,js-1:je+1)
real, intent(out) :: peln(is:ie,km+1,js:je)
real, intent(inout) :: pk(is:ie,js:je,km+1)
real, intent(out) :: pkz(is:ie,js:je,km)
real, intent(inout) :: pt(isd:ied,jsd:jed,km)
real, intent(inout) :: q(isd:ied,jsd:jed,km,ncnst)
real, intent(in) :: r_vir
logical, intent(in) :: remap_t
logical, intent(in) :: reproduce_sum
real, intent(out) :: te(is:ie,js:je,km)
real, intent(inout) :: u(isd:ied,jsd:jed+1,km)
real, intent(inout) :: ua(isd:ied,jsd:jed,km)
real, intent(inout) :: v(isd:ied+1,jsd:jed,km)
real, intent(inout) :: va(isd:ied,jsd:jed,km)
real, intent(inout) :: ze0(is:ie,js:je,km+1)

!==============================================
! declare local variables
!==============================================
real :: addeng(is:ie,km)
real :: addlnp
real :: addp2(is:ie,km)
real :: addtmp
real :: adgz(is:ie)
real :: adhelp_x
real :: adhelp_y
real :: adhelp_z(isd:ied+1,jsd:jed,km)
real :: adhelp_za(isd:ied,jsd:jed+1,km)
real :: adhelp_zb(isd:ied+1,jsd:jed,km)
real :: adhelp_zc(isd:ied,jsd:jed+1,km)
real :: adhelp_zd(is:ie,js:je,km)
real :: adhelp_ze(isd:ied,jsd:jed,km)
real :: adhelp_zf(isd:ied,jsd:jed,km)
real :: adhelp_zg(is:ie,js:je,km)
real :: adhelp_zh(is:ie,km)
real :: adpe0(is:ie+1,km+1)
real :: adpe1(is:ie,km+1)
real :: adpe2(is:ie,km+1)
real :: adpe3(is:ie+1,km+1)
real :: adphis(is:ie,km+1)
real :: adpk1(is:ie,km+1)
real :: adpk2(is:ie,km+1)
real :: adpn2(is:ie,km+1)
real :: adq2(is:ie,km)
real :: adtmp
real :: adtpe
real :: adze1(is:ie,km+1)
real :: adze2(is:ie,km+1)
real :: ak1
real :: bkh
real :: delph(lbound(delp,1):ubound(delp,1),lbound(delp,2):ubound(delp,2),lbound(delp,3):ubound(delp,3))
real :: delpi(lbound(delp,1):ubound(delp,1),lbound(delp,2):ubound(delp,2),lbound(delp,3):ubound(delp,3))
real :: delzh(lbound(delz,1):ubound(delz,1),lbound(delz,2):ubound(delz,2),lbound(delz,3):ubound(delz,3))
real :: delzi(lbound(delz,1):ubound(delz,1),lbound(delz,2):ubound(delz,2),lbound(delz,3):ubound(delz,3))
real :: deng(is:ie,km)
real :: dengh(lbound(deng,1):ubound(deng,1),lbound(deng,2):ubound(deng,2))
real :: dlnp
real :: dp2(is:ie,km)
real :: dtmp
real :: gz(is:ie)
integer :: help_h
integer :: help_i
integer :: help_j
integer :: help_k
integer :: help_m
integer :: help_n
integer :: help_o
integer :: help_p
integer :: help_q
integer :: help_r
integer :: help_s
integer :: help_t
integer :: help_u
integer :: help_v
integer :: help_w
real :: help_x
real :: help_y
real :: help_z(isd:ied+1,jsd:jed,km)
real :: help_za(isd:ied,jsd:jed+1,km)
real :: help_zb(isd:ied+1,jsd:jed,km)
real :: help_zc(isd:ied,jsd:jed+1,km)
real :: help_zd(is:ie,js:je,km)
real :: help_ze(isd:ied,jsd:jed,km)
real :: help_zf(isd:ied,jsd:jed,km)
real :: help_zg(is:ie,js:je,km)
real :: help_zh(is:ie,km)
integer :: i
integer :: idow
integer :: idow1
integer :: iq
integer :: iq1
integer :: j
integer :: j1
integer :: ja1
integer :: k
integer :: k1
real :: k1k
logical :: k_loop
integer :: k_next
real :: kapag
integer :: kp
integer :: n
integer :: n1
integer :: ndow
integer :: ng
integer :: nrec
real :: omgah(lbound(omga,1):ubound(omga,1),lbound(omga,2):ubound(omga,2),lbound(omga,3):ubound(omga,3))
real :: pe0(is:ie+1,km+1)
real :: pe0h(lbound(pe0,1):ubound(pe0,1),lbound(pe0,2):ubound(pe0,2))
real :: pe1(is:ie,km+1)
real :: pe2(is:ie,km+1)
real :: pe3(is:ie+1,km+1)
real :: pe3h(lbound(pe3,1):ubound(pe3,1),lbound(pe3,2):ubound(pe3,2))
real :: peh(lbound(pe,1):ubound(pe,1),lbound(pe,2):ubound(pe,2),lbound(pe,3):ubound(pe,3))
real :: pelnh(lbound(peln,1):ubound(peln,1),lbound(peln,2):ubound(peln,2),lbound(peln,3):ubound(peln,3))
real :: pelni(lbound(peln,1):ubound(peln,1),lbound(peln,2):ubound(peln,2),lbound(peln,3):ubound(peln,3))
real :: phis(is:ie,km+1)
real :: pk1(is:ie,km+1)
real :: pk2(is:ie,km+1)
real :: pkh(lbound(pk,1):ubound(pk,1),lbound(pk,2):ubound(pk,2),lbound(pk,3):ubound(pk,3))
real :: pn2(is:ie,km+1)
real :: pth(lbound(pt,1):ubound(pt,1),lbound(pt,2):ubound(pt,2),lbound(pt,3):ubound(pt,3))
real :: pti(lbound(pt,1):ubound(pt,1),lbound(pt,2):ubound(pt,2),lbound(pt,3):ubound(pt,3))
real :: q2(is:ie,km)
real :: qh(lbound(q,1):ubound(q,1),lbound(q,2):ubound(q,2),lbound(q,3):ubound(q,3),lbound(q,4):ubound(q,4))
real :: qi(lbound(q,1):ubound(q,1),lbound(q,2):ubound(q,2),lbound(q,3):ubound(q,3),lbound(q,4):ubound(q,4))
real :: rcp
real :: rg
real :: te_2d(is:ie,js:je)
logical :: te_map
real :: tmp
real :: tpe
real :: uh(lbound(u,1):ubound(u,1),lbound(u,2):ubound(u,2),lbound(u,3):ubound(u,3))
real :: vh(lbound(v,1):ubound(v,1),lbound(v,2):ubound(v,2),lbound(v,3):ubound(v,3))
real :: ze0h(lbound(ze0,1):ubound(ze0,1),lbound(ze0,2):ubound(ze0,2),lbound(ze0,3):ubound(ze0,3))
real :: ze0i(lbound(ze0,1):ubound(ze0,1),lbound(ze0,2):ubound(ze0,2),lbound(ze0,3):ubound(ze0,3))
real :: ze1(is:ie,km+1)
real :: ze1h(lbound(ze1,1):ubound(ze1,1),lbound(ze1,2):ubound(ze1,2))
real :: ze2(is:ie,km+1)
real :: ze2h(lbound(ze2,1):ubound(ze2,1),lbound(ze2,2):ubound(ze2,2))
real :: zsum(is:ie,js:je)

!==============================================
! declare external procedures and functions
!==============================================
integer, external :: adsubcl

!----------------------------------------------
! SAVE REQUIRED INPUT VARIABLES
!----------------------------------------------
ze0h(:,:,:) = ze0(:,:,:)
vh(:,:,:) = v(:,:,:)
uh(:,:,:) = u(:,:,:)
qi(:,:,:,:) = q(:,:,:,:)
pti(:,:,:) = pt(:,:,:)
pkh(:,:,:) = pk(:,:,:)
pelni(:,:,:) = peln(:,:,:)
peh(:,:,:) = pe(:,:,:)
omgah(:,:,:) = omga(:,:,:)
delzh(:,:,:) = delz(:,:,:)
delph(:,:,:) = delp(:,:,:)

!----------------------------------------------
! COUNT DOWN SUBROUTINE CALLS
!----------------------------------------------
call adcount( 2,-1 )

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
addeng(:,:) = 0.
addlnp = 0.
addp2(:,:) = 0.
addtmp = 0.
adgz(:) = 0.
adhelp_x = 0.
adhelp_y = 0.
adpe0(:,:) = 0.
adpe1(:,:) = 0.
adpe2(:,:) = 0.
adpe3(:,:) = 0.
adphis(:,:) = 0.
adpk1(:,:) = 0.
adpk2(:,:) = 0.
adpn2(:,:) = 0.
adq2(:,:) = 0.
adtmp = 0.
adtpe = 0.
adze1(:,:) = 0.
adze2(:,:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
k1k = akap/(1.-akap)
kapag = -(akap/grav)
rg = akap*cp
rcp = 1./cp
ak1 = (akap+1.)/akap
if (kord_tm .lt. 0) then
  te_map =  .false. 
  do j = js, je
    do k = 2, km+1
      do i = is, ie
        peln(i,k,j) = log(pe(i,k,j))
      end do
    end do
  end do
  if (remap_t) then
    do k = 1, km
      do j = js, je
        do i = is, ie
          pt(i,j,k) = pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))/(rg*(peln(i,k+1,j)-peln(i,k,j)))
        end do
      end do
    end do
  endif
else
  te_map =  .true. 
  call pkez( km,is,ie,js,je,pe,pk,akap,peln,pkz )
  call cubed_to_latlon( u,v,ua,va,dx,dy,dxa,dya,km )
  do k = 1, km
    do j = js, je
      do i = is, ie
        te(i,j,k) = 0.5*(ua(i,j,k)**2+va(i,j,k)**2)+pt(i,j,k)*pkz(i,j,k)
      end do
    end do
  end do
endif
if (( .not. hydrostatic) .and. ( .not. hybrid_z)) then
  do k = 1, km
    do j = js, je
      do i = is, ie
        delz(i,j,k) = -(delz(i,j,k)/delp(i,j,k))
      end do
    end do
  end do
endif
do j = js, je+1
  do k = 1, km+1
    do i = is, ie
      pe1(i,k) = pe(i,k,j)
    end do
  end do
  do i = is, ie
    pe2(i,1) = ptop
    pe2(i,km+1) = pe(i,km+1,j)
  end do
  if (j .lt. je+1) then
    if (hybrid_z) then
      do i = is, ie
        ze1(i,km+1) = ze0(i,j,km+1)
      end do
      do k = km, 1, -1
        do i = is, ie
          ze1(i,k) = ze1(i,k+1)-delz(i,j,k)
        end do
      end do
      do k = 2, km+1
        do i = is, ie
          ze2(i,k) = ze0(i,j,k)
        end do
      end do
      do i = is, ie
        ze2(i,1) = ze1(i,1)
        ze0(i,j,1) = ze1(i,1)
      end do
      do k = 1, km
        do i = is, ie
          deng(i,k) = -(delp(i,j,k)/delz(i,j,k))
        end do
      end do
      help_h = abs(kord_tm)
      call remap_z( km,ze1,deng,km,ze2,deng,is,ie,help_h )
      do k = 1, km
        do i = is, ie
          delz(i,j,k) = ze2(i,k+1)-ze2(i,k)
        end do
      end do
      do k = 1, km-1
        do i = is, ie
          dp2(i,k) = -(deng(i,k)*delz(i,j,k))
          pe2(i,k+1) = pe2(i,k)+dp2(i,k)
        end do
      end do
      do i = is, ie
        dp2(i,km) = pe2(i,km+1)-pe2(i,km)
      end do
    else
      do k = 2, ks+1
        do i = is, ie
          pe2(i,k) = ak(k)
        end do
      end do
      do k = ks+2, km
        do i = is, ie
          pe2(i,k) = ak(k)+bk(k)*pe(i,km+1,j)
        end do
      end do
      do k = 1, km
        do i = is, ie
          dp2(i,k) = pe2(i,k+1)-pe2(i,k)
        end do
      end do
    endif
    do k = 1, km
      do i = is, ie
        delp(i,j,k) = dp2(i,k)
      end do
    end do
    if (nq .ne. 0) then
      do iq = 1, nq
        call map1_q2( km,pe1,q(isd,jsd,1,iq),km,pe2,q2,dp2,is,ie,0,kord_tr,j,isd,ied,jsd,jed )
        if (fill) then
          help_i = ie-is+1
          call fillz( help_i,km,1,q2,dp2 )
        endif
        do k = 1, km
          do i = is, ie
            q(i,j,k,iq) = q2(i,k)
          end do
        end do
      end do
    endif
    do k = 1, km+1
      do i = is, ie
        pk1(i,k) = pk(i,j,k)
      end do
    end do
    do i = is, ie
      pk2(i,1) = pk1(i,1)
      pk2(i,km+1) = pk1(i,km+1)
    end do
    do k = 2, km
      do i = is, ie
        pk2(i,k) = pe2(i,k)**akap
      end do
    end do
    if (te_map) then
      do i = is, ie
        phis(i,km+1) = hs(i,j)
      end do
      do k = km, 1, -1
        do i = is, ie
          phis(i,k) = phis(i,k+1)+pt(i,j,k)*(pk1(i,k+1)-pk1(i,k))
        end do
      end do
      do k = 1, km+1
        do i = is, ie
          phis(i,k) = phis(i,k)*pe1(i,k)
        end do
      end do
      do k = 1, km
        do i = is, ie
          te(i,j,k) = te(i,j,k)+(phis(i,k+1)-phis(i,k))/(pe1(i,k+1)-pe1(i,k))
        end do
      end do
      call map1_ppm( km,pe1,te,km,pe2,te,is,ie,j,is,ie,js,je,1,kord_tm )
    else
      if (remap_t) then
        do k = 1, km+1
          do i = is, ie
            pn2(i,k) = log(pe2(i,k))
          end do
        end do
        help_j = abs(kord_tm)
        call map1_ppm( km,peln(is,1,j),pt,km,pn2,pt,is,ie,j,isd,ied,jsd,jed,1,help_j )
      else
        help_k = abs(kord_tm)
        call map1_ppm( km,pk1,pt,km,pk2,pt,is,ie,j,isd,ied,jsd,jed,1,help_k )
      endif
    endif
    if ( .not. hydrostatic) then
      if ( .not. hybrid_z) then
        help_m = abs(kord_tm)
        call map1_ppm( km,pe1,delz,km,pe2,delz,is,ie,j,is,ie,js,je,1,help_m )
        do k = 1, km
          do i = is, ie
            delz(i,j,k) = -(delz(i,j,k)*dp2(i,k))
          end do
        end do
      endif
    endif
    do k = 2, km
      do i = is, ie
        pk(i,j,k) = pk2(i,k)
      end do
    end do
    do i = is, ie
      pe3(i,1) = 0.
    end do
    do k = 2, km+1
      do i = is, ie
        pe3(i,k) = omga(i,j,k-1)
      end do
    end do
    do k = 1, km+1
      do i = is, ie
        pe0(i,k) = peln(i,k,j)
      end do
    end do
    if (hybrid_z) then
      do k = 2, km+1
        do i = is, ie
          peln(i,k,j) = log(pe2(i,k))
        end do
      end do
    else
      if (remap_t) then
        do k = 1, km+1
          do i = is, ie
            peln(i,k,j) = pn2(i,k)
          end do
        end do
      else
        do k = 2, ks+1
          tmp = log(ak(k))
          do i = is, ie
            peln(i,k,j) = tmp
          end do
        end do
        do k = ks+2, km+1
          do i = is, ie
            peln(i,k,j) = log(pe2(i,k))
          end do
        end do
        if (ptop .lt. ptop_min) then
          do i = is, ie
            peln(i,1,j) = peln(i,2,j)-ak1
          end do
        else
          tmp = log(ptop)
          do i = is, ie
            peln(i,1,j) = tmp
          end do
        endif
      endif
    endif
    if (hydrostatic) then
      do k = 1, km
        do i = is, ie
          pkz(i,j,k) = (pk2(i,k+1)-pk2(i,k))/(akap*(peln(i,k+1,j)-peln(i,k,j)))
        end do
      end do
    else
      if (ktop .gt. 1) then
        do k = 1, ktop-1
          do i = is, ie
            pkz(i,j,k) = (pk2(i,k+1)-pk2(i,k))/(akap*(peln(i,k+1,j)-peln(i,k,j)))
          end do
        end do
      endif
      do k = ktop, km
        do i = is, ie
          pkz(i,j,k) = (kapag*delp(i,j,k)*pt(i,j,k)/(delz(i,j,k)*(1.+r_vir*q(i,j,k,1))))**k1k
        end do
      end do
    endif
    do k = 1, km
      do i = is, ie
        dp2(i,k) = 0.5*(peln(i,k,j)+peln(i,k+1,j))
      end do
    end do
    do i = is, ie
      k_next = 1
      do n = 1, km
        kp = k_next
        k = kp
        k_loop =  .false. 
        if (dp2(i,n) .le. pe0(i,k+1) .and. dp2(i,n) .ge. pe0(i,k)) then
          omga(i,j,n) = pe3(i,k)+(pe3(i,k+1)-pe3(i,k))*(dp2(i,n)-pe0(i,k))/(pe0(i,k+1)-pe0(i,k))
          k_next = k
          k_loop =  .true. 
        endif
        do while ( k_loop .eq.  .false.  .or. k .lt. km )
          k = k+1
          if (dp2(i,n) .le. pe0(i,k+1) .and. dp2(i,n) .ge. pe0(i,k)) then
            omga(i,j,n) = pe3(i,k)+(pe3(i,k+1)-pe3(i,k))*(dp2(i,n)-pe0(i,k))/(pe0(i,k+1)-pe0(i,k))
            k_next = k
            k_loop =  .true. 
          endif
        end do
      end do
    end do
  endif
  if ( .not. hybrid_z) then
    do i = is, ie+1
      pe0(i,1) = pe(i,1,j)
    end do
    do k = 2, km+1
      do i = is, ie
        pe0(i,k) = 0.5*(pe(i,k,j-1)+pe1(i,k))
      end do
    end do
    do k = 1, ks+1
      do i = is, ie+1
        pe3(i,k) = ak(k)
      end do
    end do
    do k = ks+2, km+1
      bkh = 0.5*bk(k)
      do i = is, ie
        pe3(i,k) = ak(k)+bkh*(pe(i,km+1,j-1)+pe1(i,km+1))
      end do
    end do
    help_n = jed+1
    help_o = -1
    call map1_ppm( km,pe0(is:ie,:),u,km,pe3(is:ie,:),u,is,ie,j,isd,ied,jsd,help_n,help_o,kord_mt )
    if (j .lt. je+1) then
      do k = 2, km+1
        do i = is, ie+1
          pe0(i,k) = 0.5*(pe(i-1,k,j)+pe(i,k,j))
        end do
      end do
      do k = ks+2, km+1
        bkh = 0.5*bk(k)
        do i = is, ie+1
          pe3(i,k) = ak(k)+bkh*(pe(i-1,km+1,j)+pe(i,km+1,j))
        end do
      end do
      help_p = ie+1
      help_q = ied+1
      help_r = -1
      call map1_ppm( km,pe0,v,km,pe3,v,is,help_p,j,isd,help_q,jsd,jed,help_r,kord_mt )
    endif
  endif
  do k = 1, km
    do i = is, ie
      ua(i,j,k) = pe2(i,k+1)
    end do
  end do
end do
if (hybrid_z) then
  do j = js, je+1
    do i = is, ie
      pe1(i,1) = ptop
      pe2(i,1) = ptop
    end do
    do k = 2, km+1
      do i = is, ie
        pe1(i,k) = 0.5*(pe(i,k,j-1)+pe(i,k,j))
        pe2(i,k) = 0.5*(ua(i,j-1,k-1)+ua(i,j,k-1))
      end do
    end do
    help_s = jed+1
    help_t = -1
    call map1_ppm( km,pe1,u,km,pe2,u,is,ie,j,isd,ied,jsd,help_s,help_t,kord_mt )
  end do
  do j = js, je
    do i = is, ie+1
      pe0(i,1) = ptop
      pe3(i,1) = ptop
    end do
    do k = 2, km+1
      do i = is, ie+1
        pe0(i,k) = 0.5*(pe(i-1,k,j)+pe(i,k,j))
        pe3(i,k) = 0.5*(ua(i-1,j,k-1)+ua(i,j,k-1))
      end do
    end do
    help_u = ie+1
    help_v = ied+1
    help_w = -1
    call map1_ppm( km,pe0,v,km,pe3,v,is,help_u,j,isd,help_v,jsd,jed,help_w,kord_mt )
  end do
endif
do k = 2, km
  do j = js, je
    do i = is, ie
      pe(i,k,j) = ua(i,j,k-1)
    end do
  end do
end do
call cubed_to_latlon( u,v,ua,va,dx,dy,dxa,dya,km )
if (consv .gt. 0.) then
  help_x = g_sum(te_2d,is,ie,js,je,ng,area)
  tpe = consv*help_x
  help_y = g_sum(zsum,is,ie,js,je,ng,area)
  dtmp = tpe/(cp*help_y)
  if (reproduce_sum) then
    dtmp = real(dtmp,4)
  endif
else
  dtmp = 0.
endif
if (te_map) then
  do j = js, je
    addlnp = 0.
    adtmp = 0.
    adtpe = 0.
    do i = is, ie
      gz(i) = hs(i,j)
    end do
    do k = 1, km
      do i = is, ie
        gz(i) = hs(i,j)
      end do
      do k1 = km, k-(-1), -1
        do i = is, ie
          tpe = te(i,j,k1)-0.5*(ua(i,j,k1)**2+va(i,j,k1)**2)-gz(i)
          dlnp = rg*(peln(i,k1+1,j)-peln(i,k1,j))
          tmp = tpe/((cp-pe(i,k1,j)*dlnp/delp(i,j,k1))*(1.+r_vir*q(i,j,k1,1)))
          gz(i) = gz(i)+dlnp*tmp*(1.+r_vir*q(i,j,k1,1))
        end do
      end do
      do i = is, ie
        addlnp = 0.
        adtmp = 0.
        adtpe = 0.
        tpe = te(i,j,k)-0.5*(ua(i,j,k)**2+va(i,j,k)**2)-gz(i)
        dlnp = rg*(peln(i,k+1,j)-peln(i,k,j))
        tmp = tpe/((cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,1)))
        addlnp = addlnp+adgz(i)*tmp*(1.+r_vir*q(i,j,k,1))
        adq(i,j,k,1) = adq(i,j,k,1)+adgz(i)*dlnp*tmp*r_vir
        adtmp = adtmp+adgz(i)*dlnp*(1.+r_vir*q(i,j,k,1))
        addtmp = addtmp+adpt(i,j,k)*(pkz(i,j,k)/(1.+r_vir*q(i,j,k,1)))
        adpkz(i,j,k) = adpkz(i,j,k)+adpt(i,j,k)*(dtmp/(1.+r_vir*q(i,j,k,1)))
        adq(i,j,k,1) = adq(i,j,k,1)-adpt(i,j,k)*(dtmp*pkz(i,j,k)*r_vir/((1.+r_vir*q(i,j,k,1))*(1.+r_vir*q(i,j,k,1))))
        adtmp = adtmp+adpt(i,j,k)
        adpt(i,j,k) = 0.
        addelp(i,j,k) = addelp(i,j,k)-adtmp*(tpe*pe(i,k,j)*dlnp/(delp(i,j,k)*delp(i,j,k))*(1.+r_vir*q(i,j,k,1))/((cp-pe(i,k,j)*&
&dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,1))*(cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,1))))
        addlnp = addlnp+adtmp*(tpe*pe(i,k,j)/delp(i,j,k)*(1.+r_vir*q(i,j,k,1))/((cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,&
&1))*(cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,1))))
        adpe(i,k,j) = adpe(i,k,j)+adtmp*(tpe*dlnp/delp(i,j,k)*(1.+r_vir*q(i,j,k,1))/((cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,&
&j,k,1))*(cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,1))))
        adq(i,j,k,1) = adq(i,j,k,1)-adtmp*(tpe*(cp-pe(i,k,j)*dlnp/delp(i,j,k))*r_vir/((cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*&
&q(i,j,k,1))*(cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,1))))
        adtpe = adtpe+adtmp/((cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,1)))
        adtmp = 0.
        adpeln(i,k+1,j) = adpeln(i,k+1,j)+addlnp*rg
        adpeln(i,k,j) = adpeln(i,k,j)-addlnp*rg
        addlnp = 0.
        adgz(i) = adgz(i)-adtpe
        adte(i,j,k) = adte(i,j,k)+adtpe
        adua(i,j,k) = adua(i,j,k)-adtpe*ua(i,j,k)
        adva(i,j,k) = adva(i,j,k)-adtpe*va(i,j,k)
        adtpe = 0.
      end do
    end do
    do i = is, ie
      adgz(i) = 0.
    end do
  end do
else
  if (remap_t) then
    do k = 1, km
      do j = js, je
        do i = is, ie
          addtmp = addtmp+adpt(i,j,k)*(pkz(i,j,k)/(1.+r_vir*q(i,j,k,1)))
          adpkz(i,j,k) = adpkz(i,j,k)+adpt(i,j,k)*(dtmp/(1.+r_vir*q(i,j,k,1)))
          adq(i,j,k,1) = adq(i,j,k,1)-adpt(i,j,k)*((pt(i,j,k)+dtmp*pkz(i,j,k))*r_vir/((1.+r_vir*q(i,j,k,1))*(1.+r_vir*q(i,j,k,1))))
          adpt(i,j,k) = adpt(i,j,k)/(1.+r_vir*q(i,j,k,1))
        end do
      end do
    end do
  else
    do k = 1, km
      do j = js, je
        do i = is, ie
          addtmp = addtmp+adpt(i,j,k)*(pkz(i,j,k)/(1.+r_vir*q(i,j,k,1)))
          adpkz(i,j,k) = adpkz(i,j,k)+adpt(i,j,k)*((rcp*pt(i,j,k)+dtmp)/(1.+r_vir*q(i,j,k,1)))
          adq(i,j,k,1) = adq(i,j,k,1)-adpt(i,j,k)*((rcp*pt(i,j,k)+dtmp)*pkz(i,j,k)*r_vir/((1.+r_vir*q(i,j,k,1))*(1.+r_vir*q(i,j,k,&
&1))))
          adpt(i,j,k) = adpt(i,j,k)*(rcp*pkz(i,j,k)/(1.+r_vir*q(i,j,k,1)))
        end do
      end do
    end do
  endif
endif
if (consv .gt. 0.) then
  tpe = consv*help_x
  if (reproduce_sum) then
    addtmp = real(addtmp,4)
  endif
  adhelp_y = adhelp_y-addtmp*(tpe*cp/(cp*help_y*cp*help_y))
  adtpe = adtpe+addtmp/(cp*help_y)
  addtmp = 0.
  adhelp_x = adhelp_x+adtpe*consv
  adtpe = 0.
  if (te_map) then
  else
    do j = js, je
      if (remap_t) then
        do i = is, ie
          do k = 1, km
            adpeln(i,k+1,j) = adpeln(i,k+1,j)+adgz(i)*rg*pt(i,j,k)
            adpeln(i,k,j) = adpeln(i,k,j)-adgz(i)*rg*pt(i,j,k)
            adpt(i,j,k) = adpt(i,j,k)+adgz(i)*rg*(peln(i,k+1,j)-peln(i,k,j))
          end do
          adgz(i) = 0.
        end do
      else
        do i = is, ie
          do k = 1, km
            adpk(i,j,k+1) = adpk(i,j,k+1)+adgz(i)*pt(i,j,k)
            adpk(i,j,k) = adpk(i,j,k)-adgz(i)*pt(i,j,k)
            adpt(i,j,k) = adpt(i,j,k)+adgz(i)*(pk(i,j,k+1)-pk(i,j,k))
          end do
          adgz(i) = 0.
        end do
      endif
    end do
  endif
endif
call adcubed_to_latlon( adu,adv,adua,adva,dx,dy,dxa,dya,km )
do k = 2, km
  do j = js, je
    do i = is, ie
      adua(i,j,k-1) = adua(i,j,k-1)+adpe(i,k,j)
      adpe(i,k,j) = 0.
    end do
  end do
end do
delp(:,:,:) = delph(:,:,:)
delz(:,:,:) = delzh(:,:,:)
pe(:,:,:) = peh(:,:,:)
u(:,:,:) = uh(:,:,:)
v(:,:,:) = vh(:,:,:)
ze0(:,:,:) = ze0h(:,:,:)
if (kord_tm .lt. 0) then
  do j = js, je
    do k = 2, km+1
      do i = is, ie
        peln(i,k,j) = log(pe(i,k,j))
      end do
    end do
  end do
else
  call pkez( km,is,ie,js,je,pe,pk,akap,peln,pkz )
  call cubed_to_latlon( u,v,ua,va,dx,dy,dxa,dya,km )
endif
if (( .not. hydrostatic) .and. ( .not. hybrid_z)) then
  do k = 1, km
    do j = js, je
      do i = is, ie
        delz(i,j,k) = -(delz(i,j,k)/delp(i,j,k))
      end do
    end do
  end do
endif
do j = js, je+1
  do k = 1, km+1
    do i = is, ie
      pe1(i,k) = pe(i,k,j)
    end do
  end do
  do i = is, ie
    pe2(i,1) = ptop
    pe2(i,km+1) = pe(i,km+1,j)
  end do
  if (j .lt. je+1) then
    if (hybrid_z) then
      do i = is, ie
        ze1(i,km+1) = ze0(i,j,km+1)
      end do
      do k = km, 1, -1
        do i = is, ie
          ze1(i,k) = ze1(i,k+1)-delz(i,j,k)
        end do
      end do
      do k = 2, km+1
        do i = is, ie
          ze2(i,k) = ze0(i,j,k)
        end do
      end do
      do i = is, ie
        ze2(i,1) = ze1(i,1)
        ze0(i,j,1) = ze1(i,1)
      end do
      do k = 1, km
        do i = is, ie
          deng(i,k) = -(delp(i,j,k)/delz(i,j,k))
        end do
      end do
      help_h = abs(kord_tm)
      call remap_z( km,ze1,deng,km,ze2,deng,is,ie,help_h )
      do k = 1, km
        do i = is, ie
          delz(i,j,k) = ze2(i,k+1)-ze2(i,k)
        end do
      end do
      do k = 1, km-1
        do i = is, ie
          dp2(i,k) = -(deng(i,k)*delz(i,j,k))
          pe2(i,k+1) = pe2(i,k)+dp2(i,k)
        end do
      end do
      do i = is, ie
        dp2(i,km) = pe2(i,km+1)-pe2(i,km)
      end do
    else
      do k = 2, ks+1
        do i = is, ie
          pe2(i,k) = ak(k)
        end do
      end do
      do k = ks+2, km
        do i = is, ie
          pe2(i,k) = ak(k)+bk(k)*pe(i,km+1,j)
        end do
      end do
      do k = 1, km
        do i = is, ie
          dp2(i,k) = pe2(i,k+1)-pe2(i,k)
        end do
      end do
    endif
    do k = 1, km
      do i = is, ie
        delp(i,j,k) = dp2(i,k)
      end do
    end do
    if (te_map) then
    else
      if (remap_t) then
        do k = 1, km+1
          do i = is, ie
            pn2(i,k) = log(pe2(i,k))
          end do
        end do
      endif
    endif
    if ( .not. hydrostatic) then
      if ( .not. hybrid_z) then
        help_m = abs(kord_tm)
        call map1_ppm( km,pe1,delz,km,pe2,delz,is,ie,j,is,ie,js,je,1,help_m )
        do k = 1, km
          do i = is, ie
            delz(i,j,k) = -(delz(i,j,k)*dp2(i,k))
          end do
        end do
      endif
    endif
    if (hybrid_z) then
      do k = 2, km+1
        do i = is, ie
          peln(i,k,j) = log(pe2(i,k))
        end do
      end do
    else
      if (remap_t) then
        do k = 1, km+1
          do i = is, ie
            peln(i,k,j) = pn2(i,k)
          end do
        end do
      else
        do k = 2, ks+1
          tmp = log(ak(k))
          do i = is, ie
            peln(i,k,j) = tmp
          end do
        end do
        do k = ks+2, km+1
          do i = is, ie
            peln(i,k,j) = log(pe2(i,k))
          end do
        end do
        if (ptop .lt. ptop_min) then
          do i = is, ie
            peln(i,1,j) = peln(i,2,j)-ak1
          end do
        else
          tmp = log(ptop)
          do i = is, ie
            peln(i,1,j) = tmp
          end do
        endif
      endif
    endif
    do k = 1, km
      do i = is, ie
        dp2(i,k) = 0.5*(peln(i,k,j)+peln(i,k+1,j))
      end do
    end do
  endif
  do k = 1, km
    do i = is, ie
      ua(i,j,k) = pe2(i,k+1)
    end do
  end do
end do
if (hybrid_z) then
  do j = je, js, -1
    do i = is, ie+1
      pe0(i,1) = ptop
      pe3(i,1) = ptop
    end do
    do k = 2, km+1
      do i = is, ie+1
        pe0(i,k) = 0.5*(pe(i-1,k,j)+pe(i,k,j))
        pe3(i,k) = 0.5*(ua(i-1,j,k-1)+ua(i,j,k-1))
      end do
    end do
    help_u = ie+1
    help_v = ied+1
    help_w = -1
    adhelp_z(:,:,:) = 0.
    help_z = v
    call admap1_ppm( km,pe0,adpe0,help_z,adhelp_z,km,pe3,adpe3,adv,is,help_u,j,isd,help_v,jsd,jed,help_w,kord_mt )
    adv(:,:,:) = adv(:,:,:)+adhelp_z(:,:,:)
    do k = 2, km+1
      do i = is, ie+1
        adua(i-1,j,k-1) = adua(i-1,j,k-1)+0.5*adpe3(i,k)
        adua(i,j,k-1) = adua(i,j,k-1)+0.5*adpe3(i,k)
        adpe3(i,k) = 0.
        adpe(i-1,k,j) = adpe(i-1,k,j)+0.5*adpe0(i,k)
        adpe(i,k,j) = adpe(i,k,j)+0.5*adpe0(i,k)
        adpe0(i,k) = 0.
      end do
    end do
    do i = is, ie+1
      adpe3(i,1) = 0.
      adpe0(i,1) = 0.
    end do
  end do
  do j = je+1, js, -1
    do i = is, ie
      pe1(i,1) = ptop
      pe2(i,1) = ptop
    end do
    do k = 2, km+1
      do i = is, ie
        pe1(i,k) = 0.5*(pe(i,k,j-1)+pe(i,k,j))
        pe2(i,k) = 0.5*(ua(i,j-1,k-1)+ua(i,j,k-1))
      end do
    end do
    help_s = jed+1
    help_t = -1
    adhelp_za(:,:,:) = 0.
    help_za = u
    call admap1_ppm( km,pe1,adpe1,help_za,adhelp_za,km,pe2,adpe2,adu,is,ie,j,isd,ied,jsd,help_s,help_t,kord_mt )
    adu(:,:,:) = adu(:,:,:)+adhelp_za(:,:,:)
    do k = 2, km+1
      do i = is, ie
        adua(i,j-1,k-1) = adua(i,j-1,k-1)+0.5*adpe2(i,k)
        adua(i,j,k-1) = adua(i,j,k-1)+0.5*adpe2(i,k)
        adpe2(i,k) = 0.
        adpe(i,k,j-1) = adpe(i,k,j-1)+0.5*adpe1(i,k)
        adpe(i,k,j) = adpe(i,k,j)+0.5*adpe1(i,k)
        adpe1(i,k) = 0.
      end do
    end do
    do i = is, ie
      adpe2(i,1) = 0.
      adpe1(i,1) = 0.
    end do
  end do
endif
delp(:,:,:) = delph(:,:,:)
delz(:,:,:) = delzh(:,:,:)
omga(:,:,:) = omgah(:,:,:)
pe(:,:,:) = peh(:,:,:)
pk(:,:,:) = pkh(:,:,:)
pt(:,:,:) = pti(:,:,:)
q(:,:,:,:) = qi(:,:,:,:)
ze0(:,:,:) = ze0h(:,:,:)
if (kord_tm .lt. 0) then
  do j = js, je
    do k = 2, km+1
      do i = is, ie
        peln(i,k,j) = log(pe(i,k,j))
      end do
    end do
  end do
  if (remap_t) then
    do k = 1, km
      do j = js, je
        do i = is, ie
          pt(i,j,k) = pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))/(rg*(peln(i,k+1,j)-peln(i,k,j)))
        end do
      end do
    end do
  endif
else
  call pkez( km,is,ie,js,je,pe,pk,akap,peln,pkz )
endif
if (( .not. hydrostatic) .and. ( .not. hybrid_z)) then
  do k = 1, km
    do j = js, je
      do i = is, ie
        delz(i,j,k) = -(delz(i,j,k)/delp(i,j,k))
      end do
    end do
  end do
endif
do j = je+1, js, -1
  delp(:,:,:) = delph(:,:,:)
  delz(:,:,:) = delzh(:,:,:)
  omga(:,:,:) = omgah(:,:,:)
  pk(:,:,:) = pkh(:,:,:)
  pt(:,:,:) = pti(:,:,:)
  q(:,:,:,:) = qi(:,:,:,:)
  ze0(:,:,:) = ze0h(:,:,:)
  if (kord_tm .lt. 0) then
    do ja1 = js, je
      do k = 2, km+1
        do i = is, ie
          peln(i,k,ja1) = log(pe(i,k,ja1))
        end do
      end do
    end do
    if (remap_t) then
      do k = 1, km
        do ja1 = js, je
          do i = is, ie
            pt(i,ja1,k) = pt(i,ja1,k)*(pk(i,ja1,k+1)-pk(i,ja1,k))/(rg*(peln(i,k+1,ja1)-peln(i,k,ja1)))
          end do
        end do
      end do
    endif
  else
    call pkez( km,is,ie,js,je,pe,pk,akap,peln,pkz )
    call cubed_to_latlon( u,v,ua,va,dx,dy,dxa,dya,km )
    do k = 1, km
      do ja1 = js, je
        do i = is, ie
          te(i,ja1,k) = 0.5*(ua(i,ja1,k)**2+va(i,ja1,k)**2)+pt(i,ja1,k)*pkz(i,ja1,k)
        end do
      end do
    end do
  endif
  if (( .not. hydrostatic) .and. ( .not. hybrid_z)) then
    do k = 1, km
      do ja1 = js, je
        do i = is, ie
          delz(i,ja1,k) = -(delz(i,ja1,k)/delp(i,ja1,k))
        end do
      end do
    end do
  endif
  do j1 = js, j-1
    do k = 1, km+1
      do i = is, ie
        pe1(i,k) = pe(i,k,j1)
      end do
    end do
    do i = is, ie
      pe2(i,1) = ptop
      pe2(i,km+1) = pe(i,km+1,j1)
    end do
    if (j1 .lt. je+1) then
      if (hybrid_z) then
        do i = is, ie
          ze1(i,km+1) = ze0(i,j1,km+1)
        end do
        do k = km, 1, -1
          do i = is, ie
            ze1(i,k) = ze1(i,k+1)-delz(i,j1,k)
          end do
        end do
        do k = 2, km+1
          do i = is, ie
            ze2(i,k) = ze0(i,j1,k)
          end do
        end do
        do i = is, ie
          ze2(i,1) = ze1(i,1)
          ze0(i,j1,1) = ze1(i,1)
        end do
        do k = 1, km
          do i = is, ie
            deng(i,k) = -(delp(i,j1,k)/delz(i,j1,k))
          end do
        end do
        help_h = abs(kord_tm)
        call remap_z( km,ze1,deng,km,ze2,deng,is,ie,help_h )
        do k = 1, km
          do i = is, ie
            delz(i,j1,k) = ze2(i,k+1)-ze2(i,k)
          end do
        end do
        do k = 1, km-1
          do i = is, ie
            dp2(i,k) = -(deng(i,k)*delz(i,j1,k))
            pe2(i,k+1) = pe2(i,k)+dp2(i,k)
          end do
        end do
        do i = is, ie
          dp2(i,km) = pe2(i,km+1)-pe2(i,km)
        end do
      else
        do k = 2, ks+1
          do i = is, ie
            pe2(i,k) = ak(k)
          end do
        end do
        do k = ks+2, km
          do i = is, ie
            pe2(i,k) = ak(k)+bk(k)*pe(i,km+1,j1)
          end do
        end do
        do k = 1, km
          do i = is, ie
            dp2(i,k) = pe2(i,k+1)-pe2(i,k)
          end do
        end do
      endif
      do k = 1, km
        do i = is, ie
          delp(i,j1,k) = dp2(i,k)
        end do
      end do
      if (nq .ne. 0) then
        do iq = 1, nq
          call map1_q2( km,pe1,q(isd,jsd,1,iq),km,pe2,q2,dp2,is,ie,0,kord_tr,j1,isd,ied,jsd,jed )
          if (fill) then
            help_i = ie-is+1
            call fillz( help_i,km,1,q2,dp2 )
          endif
          do k = 1, km
            do i = is, ie
              q(i,j1,k,iq) = q2(i,k)
            end do
          end do
        end do
      endif
      do k = 1, km+1
        do i = is, ie
          pk1(i,k) = pk(i,j1,k)
        end do
      end do
      do i = is, ie
        pk2(i,1) = pk1(i,1)
        pk2(i,km+1) = pk1(i,km+1)
      end do
      do k = 2, km
        do i = is, ie
          pk2(i,k) = pe2(i,k)**akap
        end do
      end do
      if (te_map) then
        do i = is, ie
          phis(i,km+1) = hs(i,j1)
        end do
        do k = km, 1, -1
          do i = is, ie
            phis(i,k) = phis(i,k+1)+pt(i,j1,k)*(pk1(i,k+1)-pk1(i,k))
          end do
        end do
        do k = 1, km+1
          do i = is, ie
            phis(i,k) = phis(i,k)*pe1(i,k)
          end do
        end do
      else
        if (remap_t) then
          do k = 1, km+1
            do i = is, ie
              pn2(i,k) = log(pe2(i,k))
            end do
          end do
          help_j = abs(kord_tm)
          call map1_ppm( km,peln(is,1,j1),pt,km,pn2,pt,is,ie,j1,isd,ied,jsd,jed,1,help_j )
        else
          help_k = abs(kord_tm)
          call map1_ppm( km,pk1,pt,km,pk2,pt,is,ie,j1,isd,ied,jsd,jed,1,help_k )
        endif
      endif
      if ( .not. hydrostatic) then
        if ( .not. hybrid_z) then
          help_m = abs(kord_tm)
          call map1_ppm( km,pe1,delz,km,pe2,delz,is,ie,j1,is,ie,js,je,1,help_m )
          do k = 1, km
            do i = is, ie
              delz(i,j1,k) = -(delz(i,j1,k)*dp2(i,k))
            end do
          end do
        endif
      endif
      do k = 2, km
        do i = is, ie
          pk(i,j1,k) = pk2(i,k)
        end do
      end do
      do i = is, ie
        pe3(i,1) = 0.
      end do
      do k = 2, km+1
        do i = is, ie
          pe3(i,k) = omga(i,j1,k-1)
        end do
      end do
      do k = 1, km+1
        do i = is, ie
          pe0(i,k) = peln(i,k,j1)
        end do
      end do
      if (hybrid_z) then
        do k = 2, km+1
          do i = is, ie
            peln(i,k,j1) = log(pe2(i,k))
          end do
        end do
      else
        if (remap_t) then
          do k = 1, km+1
            do i = is, ie
              peln(i,k,j1) = pn2(i,k)
            end do
          end do
        else
          do k = 2, ks+1
            tmp = log(ak(k))
            do i = is, ie
              peln(i,k,j1) = tmp
            end do
          end do
          do k = ks+2, km+1
            do i = is, ie
              peln(i,k,j1) = log(pe2(i,k))
            end do
          end do
          if (ptop .lt. ptop_min) then
            do i = is, ie
              peln(i,1,j1) = peln(i,2,j1)-ak1
            end do
          else
            tmp = log(ptop)
            do i = is, ie
              peln(i,1,j1) = tmp
            end do
          endif
        endif
      endif
      do k = 1, km
        do i = is, ie
          dp2(i,k) = 0.5*(peln(i,k,j1)+peln(i,k+1,j1))
        end do
      end do
      do i = is, ie
        k_next = 1
        do n = 1, km
          kp = k_next
          k = kp
          k_loop =  .false. 
          if (dp2(i,n) .le. pe0(i,k+1) .and. dp2(i,n) .ge. pe0(i,k)) then
            omga(i,j1,n) = pe3(i,k)+(pe3(i,k+1)-pe3(i,k))*(dp2(i,n)-pe0(i,k))/(pe0(i,k+1)-pe0(i,k))
            k_next = k
            k_loop =  .true. 
          endif
          do while ( k_loop .eq.  .false.  .or. k .lt. km )
            k = k+1
            if (dp2(i,n) .le. pe0(i,k+1) .and. dp2(i,n) .ge. pe0(i,k)) then
              omga(i,j1,n) = pe3(i,k)+(pe3(i,k+1)-pe3(i,k))*(dp2(i,n)-pe0(i,k))/(pe0(i,k+1)-pe0(i,k))
              k_next = k
              k_loop =  .true. 
            endif
          end do
        end do
      end do
    endif
    if ( .not. hybrid_z) then
      do i = is, ie+1
        pe0(i,1) = pe(i,1,j1)
      end do
      do k = 2, km+1
        do i = is, ie
          pe0(i,k) = 0.5*(pe(i,k,j1-1)+pe1(i,k))
        end do
      end do
      do k = 1, ks+1
        do i = is, ie+1
          pe3(i,k) = ak(k)
        end do
      end do
      do k = ks+2, km+1
        bkh = 0.5*bk(k)
        do i = is, ie
          pe3(i,k) = ak(k)+bkh*(pe(i,km+1,j1-1)+pe1(i,km+1))
        end do
      end do
      if (j1 .lt. je+1) then
        do k = 2, km+1
          do i = is, ie+1
            pe0(i,k) = 0.5*(pe(i-1,k,j1)+pe(i,k,j1))
          end do
        end do
        do k = ks+2, km+1
          bkh = 0.5*bk(k)
          do i = is, ie+1
            pe3(i,k) = ak(k)+bkh*(pe(i-1,km+1,j1)+pe(i,km+1,j1))
          end do
        end do
      endif
    endif
  end do
  ze2h(:,:) = ze2(:,:)
  ze1h(:,:) = ze1(:,:)
  ze0i(:,:,:) = ze0(:,:,:)
  qh(:,:,:,:) = q(:,:,:,:)
  pth(:,:,:) = pt(:,:,:)
  pelnh(:,:,:) = peln(:,:,:)
  pe3h(:,:) = pe3(:,:)
  pe0h(:,:) = pe0(:,:)
  dengh(:,:) = deng(:,:)
  delzi(:,:,:) = delz(:,:,:)
  delpi(:,:,:) = delp(:,:,:)
  do k = 1, km+1
    do i = is, ie
      pe1(i,k) = pe(i,k,j)
    end do
  end do
  if (j .lt. je+1) then
    do i = is, ie
      pe3(i,1) = 0.
    end do
    do k = 2, km+1
      do i = is, ie
        pe3(i,k) = omga(i,j,k-1)
      end do
    end do
    do k = 1, km+1
      do i = is, ie
        pe0(i,k) = peln(i,k,j)
      end do
    end do
  endif
  do k = 1, km
    do i = is, ie
      adpe2(i,k+1) = adpe2(i,k+1)+adua(i,j,k)
      adua(i,j,k) = 0.
    end do
  end do
  if ( .not. hybrid_z) then
    do i = is, ie+1
      pe0(i,1) = pe(i,1,j)
    end do
    do k = 2, km+1
      do i = is, ie
        pe0(i,k) = 0.5*(pe(i,k,j-1)+pe1(i,k))
      end do
    end do
    do k = 1, ks+1
      do i = is, ie+1
        pe3(i,k) = ak(k)
      end do
    end do
    do k = ks+2, km+1
      bkh = 0.5*bk(k)
      do i = is, ie
        pe3(i,k) = ak(k)+bkh*(pe(i,km+1,j-1)+pe1(i,km+1))
      end do
    end do
    help_n = jed+1
    help_o = -1
    if (j .lt. je+1) then
      do k = 2, km+1
        do i = is, ie+1
          pe0(i,k) = 0.5*(pe(i-1,k,j)+pe(i,k,j))
        end do
      end do
      do k = ks+2, km+1
        bkh = 0.5*bk(k)
        do i = is, ie+1
          pe3(i,k) = ak(k)+bkh*(pe(i-1,km+1,j)+pe(i,km+1,j))
        end do
      end do
      help_p = ie+1
      help_q = ied+1
      help_r = -1
      adhelp_zb(:,:,:) = 0.
      help_zb = v
      call admap1_ppm( km,pe0,adpe0,help_zb,adhelp_zb,km,pe3,adpe3,adv,is,help_p,j,isd,help_q,jsd,jed,help_r,kord_mt )
      adv(:,:,:) = adv(:,:,:)+adhelp_zb(:,:,:)
      do k = ks+2, km+1
        bkh = 0.5*bk(k)
        do i = is, ie+1
          adpe(i-1,km+1,j) = adpe(i-1,km+1,j)+adpe3(i,k)*bkh
          adpe(i,km+1,j) = adpe(i,km+1,j)+adpe3(i,k)*bkh
          adpe3(i,k) = 0.
        end do
      end do
      do k = 2, km+1
        do i = is, ie+1
          adpe(i-1,k,j) = adpe(i-1,k,j)+0.5*adpe0(i,k)
          adpe(i,k,j) = adpe(i,k,j)+0.5*adpe0(i,k)
          adpe0(i,k) = 0.
        end do
      end do
    endif
    do i = is, ie+1
      pe0(i,1) = pe(i,1,j)
    end do
    do k = 2, km+1
      do i = is, ie
        pe0(i,k) = 0.5*(pe(i,k,j-1)+pe1(i,k))
      end do
    end do
    do k = 1, ks+1
      do i = is, ie+1
        pe3(i,k) = ak(k)
      end do
    end do
    do k = ks+2, km+1
      bkh = 0.5*bk(k)
      do i = is, ie
        pe3(i,k) = ak(k)+bkh*(pe(i,km+1,j-1)+pe1(i,km+1))
      end do
    end do
    adhelp_zc(:,:,:) = 0.
    help_zc = u
    call admap1_ppm( km,pe0(is:ie,:),adpe0(is:ie,:),help_zc,adhelp_zc,km,pe3(is:ie,:),adpe3(is:ie,:),adu,is,ie,j,isd,ied,jsd,&
&help_n,help_o,kord_mt )
    adu(:,:,:) = adu(:,:,:)+adhelp_zc(:,:,:)
    do k = ks+2, km+1
      bkh = 0.5*bk(k)
      do i = is, ie
        adpe(i,km+1,j-1) = adpe(i,km+1,j-1)+adpe3(i,k)*bkh
        adpe1(i,km+1) = adpe1(i,km+1)+adpe3(i,k)*bkh
        adpe3(i,k) = 0.
      end do
    end do
    do k = 1, ks+1
      do i = is, ie+1
        adpe3(i,k) = 0.
      end do
    end do
    do k = 2, km+1
      do i = is, ie
        adpe(i,k,j-1) = adpe(i,k,j-1)+0.5*adpe0(i,k)
        adpe1(i,k) = adpe1(i,k)+0.5*adpe0(i,k)
        adpe0(i,k) = 0.
      end do
    end do
    do i = is, ie+1
      adpe(i,1,j) = adpe(i,1,j)+adpe0(i,1)
      adpe0(i,1) = 0.
    end do
  endif
  pe0(:,:) = pe0h(:,:)
  pe3(:,:) = pe3h(:,:)
  do i = is, ie
    pe2(i,1) = ptop
    pe2(i,km+1) = pe(i,km+1,j)
  end do
  if (j .lt. je+1) then
    if (hybrid_z) then
      do i = is, ie
        ze1(i,km+1) = ze0(i,j,km+1)
      end do
      do k = km, 1, -1
        do i = is, ie
          ze1(i,k) = ze1(i,k+1)-delz(i,j,k)
        end do
      end do
      do k = 2, km+1
        do i = is, ie
          ze2(i,k) = ze0(i,j,k)
        end do
      end do
      do i = is, ie
        ze2(i,1) = ze1(i,1)
        ze0(i,j,1) = ze1(i,1)
      end do
      do k = 1, km
        do i = is, ie
          deng(i,k) = -(delp(i,j,k)/delz(i,j,k))
        end do
      end do
      help_h = abs(kord_tm)
      call remap_z( km,ze1,deng,km,ze2,deng,is,ie,help_h )
      do k = 1, km
        do i = is, ie
          delz(i,j,k) = ze2(i,k+1)-ze2(i,k)
        end do
      end do
      do k = 1, km-1
        do i = is, ie
          dp2(i,k) = -(deng(i,k)*delz(i,j,k))
          pe2(i,k+1) = pe2(i,k)+dp2(i,k)
        end do
      end do
      do i = is, ie
        dp2(i,km) = pe2(i,km+1)-pe2(i,km)
      end do
    else
      do k = 2, ks+1
        do i = is, ie
          pe2(i,k) = ak(k)
        end do
      end do
      do k = ks+2, km
        do i = is, ie
          pe2(i,k) = ak(k)+bk(k)*pe(i,km+1,j)
        end do
      end do
      do k = 1, km
        do i = is, ie
          dp2(i,k) = pe2(i,k+1)-pe2(i,k)
        end do
      end do
    endif
    do k = 1, km
      do i = is, ie
        delp(i,j,k) = dp2(i,k)
      end do
    end do
    if (nq .ne. 0) then
      do iq = 1, nq
        call map1_q2( km,pe1,q(isd,jsd,1,iq),km,pe2,q2,dp2,is,ie,0,kord_tr,j,isd,ied,jsd,jed )
        if (fill) then
          help_i = ie-is+1
          call fillz( help_i,km,1,q2,dp2 )
        endif
        do k = 1, km
          do i = is, ie
            q(i,j,k,iq) = q2(i,k)
          end do
        end do
      end do
    endif
    do k = 1, km+1
      do i = is, ie
        pk1(i,k) = pk(i,j,k)
      end do
    end do
    do i = is, ie
      pk2(i,1) = pk1(i,1)
      pk2(i,km+1) = pk1(i,km+1)
    end do
    do k = 2, km
      do i = is, ie
        pk2(i,k) = pe2(i,k)**akap
      end do
    end do
    if (te_map) then
    else
      if (remap_t) then
        do k = 1, km+1
          do i = is, ie
            pn2(i,k) = log(pe2(i,k))
          end do
        end do
        help_j = abs(kord_tm)
        call map1_ppm( km,peln(is,1,j),pt,km,pn2,pt,is,ie,j,isd,ied,jsd,jed,1,help_j )
      else
        help_k = abs(kord_tm)
        call map1_ppm( km,pk1,pt,km,pk2,pt,is,ie,j,isd,ied,jsd,jed,1,help_k )
      endif
    endif
    if ( .not. hydrostatic) then
      if ( .not. hybrid_z) then
        help_m = abs(kord_tm)
        call map1_ppm( km,pe1,delz,km,pe2,delz,is,ie,j,is,ie,js,je,1,help_m )
        do k = 1, km
          do i = is, ie
            delz(i,j,k) = -(delz(i,j,k)*dp2(i,k))
          end do
        end do
      endif
    endif
    do i = is, ie
      pe3(i,1) = 0.
    end do
    do k = 2, km+1
      do i = is, ie
        pe3(i,k) = omga(i,j,k-1)
      end do
    end do
    do k = 1, km+1
      do i = is, ie
        pe0(i,k) = peln(i,k,j)
      end do
    end do
    if (hybrid_z) then
      do k = 2, km+1
        do i = is, ie
          peln(i,k,j) = log(pe2(i,k))
        end do
      end do
    else
      if (remap_t) then
        do k = 1, km+1
          do i = is, ie
            peln(i,k,j) = pn2(i,k)
          end do
        end do
      else
        do k = 2, ks+1
          tmp = log(ak(k))
          do i = is, ie
            peln(i,k,j) = tmp
          end do
        end do
        do k = ks+2, km+1
          do i = is, ie
            peln(i,k,j) = log(pe2(i,k))
          end do
        end do
        if (ptop .lt. ptop_min) then
          do i = is, ie
            peln(i,1,j) = peln(i,2,j)-ak1
          end do
        else
          tmp = log(ptop)
          do i = is, ie
            peln(i,1,j) = tmp
          end do
        endif
      endif
    endif
    do k = 1, km
      do i = is, ie
        dp2(i,k) = 0.5*(peln(i,k,j)+peln(i,k+1,j))
      end do
    end do
    do i = is, ie
      k_next = 1
      do n = km, 1, -1
        k_next = 1
        do n1 = 1, n-1
          kp = k_next
          k = kp
          k_loop =  .false. 
          if (dp2(i,n1) .le. pe0(i,k+1) .and. dp2(i,n1) .ge. pe0(i,k)) then
            k_next = k
            k_loop =  .true. 
          endif
          do while ( k_loop .eq.  .false.  .or. k .lt. km )
            k = k+1
            if (dp2(i,n1) .le. pe0(i,k+1) .and. dp2(i,n1) .ge. pe0(i,k)) then
              k_next = k
              k_loop =  .true. 
            endif
          end do
        end do
        kp = k_next
        k = kp
        call getkey( 2,3,((j-js+i-is)*(1+j-js+i-is)/2+j-js+n-1)*(1+(j-js+i-is)*(1+j-js+i-is)/2+j-js+n-1)/2+(j-js+i-is)*(1+j-js+i-&
&is)/2+j-js,0,adsubcl(1,2),nrec )
        call adresto( 'memory_3_f_dyn_idow',19,idow,4,1,nrec )
        ndow = idow
        do idow = ndow, 1, -1
          k = kp
          do idow1 = 1, idow-1
            k = k+1
          end do
          k = k+1
          if (dp2(i,n) .le. pe0(i,k+1) .and. dp2(i,n) .ge. pe0(i,k)) then
            addp2(i,n) = addp2(i,n)+adomga(i,j,n)*((pe3(i,k+1)-pe3(i,k))/(pe0(i,k+1)-pe0(i,k)))
            adpe0(i,k+1) = adpe0(i,k+1)-adomga(i,j,n)*((pe3(i,k+1)-pe3(i,k))*(dp2(i,n)-pe0(i,k))/((pe0(i,k+1)-pe0(i,k))*(pe0(i,k+1)&
&-pe0(i,k))))
            adpe0(i,k) = adpe0(i,k)+adomga(i,j,n)*((-((pe3(i,k+1)-pe3(i,k))/(pe0(i,k+1)-pe0(i,k))))+(pe3(i,k+1)-pe3(i,k))*(dp2(i,n)&
&-pe0(i,k))/((pe0(i,k+1)-pe0(i,k))*(pe0(i,k+1)-pe0(i,k))))
            adpe3(i,k+1) = adpe3(i,k+1)+adomga(i,j,n)*((dp2(i,n)-pe0(i,k))/(pe0(i,k+1)-pe0(i,k)))
            adpe3(i,k) = adpe3(i,k)+adomga(i,j,n)*(1-(dp2(i,n)-pe0(i,k))/(pe0(i,k+1)-pe0(i,k)))
            adomga(i,j,n) = 0.
          endif
        end do
        k = kp
        if (dp2(i,n) .le. pe0(i,k+1) .and. dp2(i,n) .ge. pe0(i,k)) then
          addp2(i,n) = addp2(i,n)+adomga(i,j,n)*((pe3(i,k+1)-pe3(i,k))/(pe0(i,k+1)-pe0(i,k)))
          adpe0(i,k+1) = adpe0(i,k+1)-adomga(i,j,n)*((pe3(i,k+1)-pe3(i,k))*(dp2(i,n)-pe0(i,k))/((pe0(i,k+1)-pe0(i,k))*(pe0(i,k+1)-&
&pe0(i,k))))
          adpe0(i,k) = adpe0(i,k)+adomga(i,j,n)*((-((pe3(i,k+1)-pe3(i,k))/(pe0(i,k+1)-pe0(i,k))))+(pe3(i,k+1)-pe3(i,k))*(dp2(i,n)-&
&pe0(i,k))/((pe0(i,k+1)-pe0(i,k))*(pe0(i,k+1)-pe0(i,k))))
          adpe3(i,k+1) = adpe3(i,k+1)+adomga(i,j,n)*((dp2(i,n)-pe0(i,k))/(pe0(i,k+1)-pe0(i,k)))
          adpe3(i,k) = adpe3(i,k)+adomga(i,j,n)*(1-(dp2(i,n)-pe0(i,k))/(pe0(i,k+1)-pe0(i,k)))
          adomga(i,j,n) = 0.
        endif
      end do
    end do
    do k = 1, km
      do i = is, ie
        adpeln(i,k+1,j) = adpeln(i,k+1,j)+0.5*addp2(i,k)
        adpeln(i,k,j) = adpeln(i,k,j)+0.5*addp2(i,k)
        addp2(i,k) = 0.
      end do
    end do
    if (hydrostatic) then
      do k = 1, km
        do i = is, ie
          adpeln(i,k+1,j) = adpeln(i,k+1,j)-adpkz(i,j,k)*((pk2(i,k+1)-pk2(i,k))*akap/(akap*(peln(i,k+1,j)-peln(i,k,j))*akap*&
&(peln(i,k+1,j)-peln(i,k,j))))
          adpeln(i,k,j) = adpeln(i,k,j)+adpkz(i,j,k)*((pk2(i,k+1)-pk2(i,k))*akap/(akap*(peln(i,k+1,j)-peln(i,k,j))*akap*(peln(i,k+&
&1,j)-peln(i,k,j))))
          adpk2(i,k+1) = adpk2(i,k+1)+adpkz(i,j,k)/(akap*(peln(i,k+1,j)-peln(i,k,j)))
          adpk2(i,k) = adpk2(i,k)-adpkz(i,j,k)/(akap*(peln(i,k+1,j)-peln(i,k,j)))
          adpkz(i,j,k) = 0.
        end do
      end do
    else
      do k = ktop, km
        do i = is, ie
          addelp(i,j,k) = addelp(i,j,k)+adpkz(i,j,k)*kapag*pt(i,j,k)/(delz(i,j,k)*(1.+r_vir*q(i,j,k,1)))*k1k*(kapag*delp(i,j,k)*&
&pt(i,j,k)/(delz(i,j,k)*(1.+r_vir*q(i,j,k,1))))**(k1k-1)
          addelz(i,j,k) = addelz(i,j,k)-adpkz(i,j,k)*kapag*delp(i,j,k)*pt(i,j,k)*(1+r_vir*q(i,j,k,1))/(delz(i,j,k)*(1.+r_vir*q(i,j,&
&k,1))*delz(i,j,k)*(1.+r_vir*q(i,j,k,1)))*k1k*(kapag*delp(i,j,k)*pt(i,j,k)/(delz(i,j,k)*(1.+r_vir*q(i,j,k,1))))**(k1k-1)
          adpt(i,j,k) = adpt(i,j,k)+adpkz(i,j,k)*kapag*delp(i,j,k)/(delz(i,j,k)*(1.+r_vir*q(i,j,k,1)))*k1k*(kapag*delp(i,j,k)*pt(i,&
&j,k)/(delz(i,j,k)*(1.+r_vir*q(i,j,k,1))))**(k1k-1)
          adq(i,j,k,1) = adq(i,j,k,1)-adpkz(i,j,k)*kapag*delp(i,j,k)*pt(i,j,k)*delz(i,j,k)*r_vir/(delz(i,j,k)*(1.+r_vir*q(i,j,k,1))&
&*delz(i,j,k)*(1.+r_vir*q(i,j,k,1)))*k1k*(kapag*delp(i,j,k)*pt(i,j,k)/(delz(i,j,k)*(1.+r_vir*q(i,j,k,1))))**(k1k-1)
          adpkz(i,j,k) = 0.
        end do
      end do
      if (ktop .gt. 1) then
        do k = 1, ktop-1
          do i = is, ie
            adpeln(i,k+1,j) = adpeln(i,k+1,j)-adpkz(i,j,k)*((pk2(i,k+1)-pk2(i,k))*akap/(akap*(peln(i,k+1,j)-peln(i,k,j))*akap*&
&(peln(i,k+1,j)-peln(i,k,j))))
            adpeln(i,k,j) = adpeln(i,k,j)+adpkz(i,j,k)*((pk2(i,k+1)-pk2(i,k))*akap/(akap*(peln(i,k+1,j)-peln(i,k,j))*akap*(peln(i,&
&k+1,j)-peln(i,k,j))))
            adpk2(i,k+1) = adpk2(i,k+1)+adpkz(i,j,k)/(akap*(peln(i,k+1,j)-peln(i,k,j)))
            adpk2(i,k) = adpk2(i,k)-adpkz(i,j,k)/(akap*(peln(i,k+1,j)-peln(i,k,j)))
            adpkz(i,j,k) = 0.
          end do
        end do
      endif
    endif
    if (hybrid_z) then
      do k = 2, km+1
        do i = is, ie
          adpe2(i,k) = adpe2(i,k)+adpeln(i,k,j)*(1./pe2(i,k))
          adpeln(i,k,j) = 0.
        end do
      end do
    else
      if (remap_t) then
        do k = 1, km+1
          do i = is, ie
            adpn2(i,k) = adpn2(i,k)+adpeln(i,k,j)
            adpeln(i,k,j) = 0.
          end do
        end do
      else
        if (ptop .lt. ptop_min) then
          do i = is, ie
            adpeln(i,2,j) = adpeln(i,2,j)+adpeln(i,1,j)
            adpeln(i,1,j) = 0.
          end do
        else
          do i = is, ie
            adtmp = adtmp+adpeln(i,1,j)
            adpeln(i,1,j) = 0.
          end do
        endif
        do k = ks+2, km+1
          do i = is, ie
            adpe2(i,k) = adpe2(i,k)+adpeln(i,k,j)*(1./pe2(i,k))
            adpeln(i,k,j) = 0.
          end do
        end do
        do k = 2, ks+1
          adtmp = 0.
          do i = is, ie
            adtmp = adtmp+adpeln(i,k,j)
            adpeln(i,k,j) = 0.
          end do
        end do
      endif
    endif
    do k = 1, km+1
      do i = is, ie
        adpeln(i,k,j) = adpeln(i,k,j)+adpe0(i,k)
        adpe0(i,k) = 0.
      end do
    end do
    do k = 2, km+1
      do i = is, ie
        adomga(i,j,k-1) = adomga(i,j,k-1)+adpe3(i,k)
        adpe3(i,k) = 0.
      end do
    end do
    do i = is, ie
      adpe3(i,1) = 0.
    end do
    do k = 2, km
      do i = is, ie
        adpk2(i,k) = adpk2(i,k)+adpk(i,j,k)
        adpk(i,j,k) = 0.
      end do
    end do
    delz(:,:,:) = delzi(:,:,:)
    do i = is, ie
      pe2(i,1) = ptop
      pe2(i,km+1) = pe(i,km+1,j)
    end do
    if (hybrid_z) then
      do i = is, ie
        ze1(i,km+1) = ze0(i,j,km+1)
      end do
      do k = km, 1, -1
        do i = is, ie
          ze1(i,k) = ze1(i,k+1)-delz(i,j,k)
        end do
      end do
      do k = 2, km+1
        do i = is, ie
          ze2(i,k) = ze0(i,j,k)
        end do
      end do
      do i = is, ie
        ze2(i,1) = ze1(i,1)
      end do
      do k = 1, km
        do i = is, ie
          deng(i,k) = -(delp(i,j,k)/delz(i,j,k))
        end do
      end do
      help_h = abs(kord_tm)
      call remap_z( km,ze1,deng,km,ze2,deng,is,ie,help_h )
      do k = 1, km
        do i = is, ie
          delz(i,j,k) = ze2(i,k+1)-ze2(i,k)
        end do
      end do
      do k = 1, km-1
        do i = is, ie
          dp2(i,k) = -(deng(i,k)*delz(i,j,k))
          pe2(i,k+1) = pe2(i,k)+dp2(i,k)
        end do
      end do
      do i = is, ie
        dp2(i,km) = pe2(i,km+1)-pe2(i,km)
      end do
    else
      do k = 2, ks+1
        do i = is, ie
          pe2(i,k) = ak(k)
        end do
      end do
      do k = ks+2, km
        do i = is, ie
          pe2(i,k) = ak(k)+bk(k)*pe(i,km+1,j)
        end do
      end do
      do k = 1, km
        do i = is, ie
          dp2(i,k) = pe2(i,k+1)-pe2(i,k)
        end do
      end do
    endif
    if ( .not. hydrostatic) then
      if ( .not. hybrid_z) then
        call map1_ppm( km,pe1,delz,km,pe2,delz,is,ie,j,is,ie,js,je,1,help_m )
        do k = 1, km
          do i = is, ie
            addp2(i,k) = addp2(i,k)-addelz(i,j,k)*delz(i,j,k)
            addelz(i,j,k) = -(addelz(i,j,k)*dp2(i,k))
          end do
        end do
        adhelp_zd(:,:,:) = 0.
        help_zd = delz
        call admap1_ppm( km,pe1,adpe1,help_zd,adhelp_zd,km,pe2,adpe2,addelz,is,ie,j,is,ie,js,je,1,help_m )
        addelz(:,:,:) = addelz(:,:,:)+adhelp_zd(:,:,:)
      endif
    endif
    delz(:,:,:) = delzi(:,:,:)
    peln(:,:,:) = pelnh(:,:,:)
    pt(:,:,:) = pth(:,:,:)
    do i = is, ie
      pe2(i,1) = ptop
      pe2(i,km+1) = pe(i,km+1,j)
    end do
    if (hybrid_z) then
      do i = is, ie
        ze1(i,km+1) = ze0(i,j,km+1)
      end do
      do k = km, 1, -1
        do i = is, ie
          ze1(i,k) = ze1(i,k+1)-delz(i,j,k)
        end do
      end do
      do k = 2, km+1
        do i = is, ie
          ze2(i,k) = ze0(i,j,k)
        end do
      end do
      do i = is, ie
        ze2(i,1) = ze1(i,1)
      end do
      do k = 1, km
        do i = is, ie
          deng(i,k) = -(delp(i,j,k)/delz(i,j,k))
        end do
      end do
      help_h = abs(kord_tm)
      call remap_z( km,ze1,deng,km,ze2,deng,is,ie,help_h )
      do k = 1, km
        do i = is, ie
          delz(i,j,k) = ze2(i,k+1)-ze2(i,k)
        end do
      end do
      do k = 1, km-1
        do i = is, ie
          dp2(i,k) = -(deng(i,k)*delz(i,j,k))
          pe2(i,k+1) = pe2(i,k)+dp2(i,k)
        end do
      end do
    else
      do k = 2, ks+1
        do i = is, ie
          pe2(i,k) = ak(k)
        end do
      end do
      do k = ks+2, km
        do i = is, ie
          pe2(i,k) = ak(k)+bk(k)*pe(i,km+1,j)
        end do
      end do
    endif
    if (te_map) then
      do i = is, ie
        phis(i,km+1) = hs(i,j)
      end do
      do k = km, 1, -1
        do i = is, ie
          phis(i,k) = phis(i,k+1)+pt(i,j,k)*(pk1(i,k+1)-pk1(i,k))
        end do
      end do
      do k = 1, km+1
        do i = is, ie
          phis(i,k) = phis(i,k)*pe1(i,k)
        end do
      end do
      adhelp_zg(:,:,:) = 0.
      help_zg = te
      call admap1_ppm( km,pe1,adpe1,help_zg,adhelp_zg,km,pe2,adpe2,adte,is,ie,j,is,ie,js,je,1,kord_tm )
      adte(:,:,:) = adte(:,:,:)+adhelp_zg(:,:,:)
      do k = 1, km
        do i = is, ie
          adpe1(i,k+1) = adpe1(i,k+1)-adte(i,j,k)*((phis(i,k+1)-phis(i,k))/((pe1(i,k+1)-pe1(i,k))*(pe1(i,k+1)-pe1(i,k))))
          adpe1(i,k) = adpe1(i,k)+adte(i,j,k)*((phis(i,k+1)-phis(i,k))/((pe1(i,k+1)-pe1(i,k))*(pe1(i,k+1)-pe1(i,k))))
          adphis(i,k+1) = adphis(i,k+1)+adte(i,j,k)/(pe1(i,k+1)-pe1(i,k))
          adphis(i,k) = adphis(i,k)-adte(i,j,k)/(pe1(i,k+1)-pe1(i,k))
        end do
      end do
      do i = is, ie
        phis(i,km+1) = hs(i,j)
      end do
      do k = km, 1, -1
        do i = is, ie
          phis(i,k) = phis(i,k+1)+pt(i,j,k)*(pk1(i,k+1)-pk1(i,k))
        end do
      end do
      do k = 1, km+1
        do i = is, ie
          adpe1(i,k) = adpe1(i,k)+adphis(i,k)*phis(i,k)
          adphis(i,k) = adphis(i,k)*pe1(i,k)
        end do
      end do
      do k = 1, km
        do i = is, ie
          adphis(i,k+1) = adphis(i,k+1)+adphis(i,k)
          adpk1(i,k+1) = adpk1(i,k+1)+adphis(i,k)*pt(i,j,k)
          adpk1(i,k) = adpk1(i,k)-adphis(i,k)*pt(i,j,k)
          adpt(i,j,k) = adpt(i,j,k)+adphis(i,k)*(pk1(i,k+1)-pk1(i,k))
          adphis(i,k) = 0.
        end do
      end do
      do i = is, ie
        adphis(i,km+1) = 0.
      end do
    else
      if (remap_t) then
        adhelp_zf(:,:,:) = 0.
        help_zf = pt
        call admap1_ppm( km,peln(is,1,j),adpeln(is,1,j),help_zf,adhelp_zf,km,pn2,adpn2,adpt,is,ie,j,isd,ied,jsd,jed,1,help_j )
        adpt(:,:,:) = adpt(:,:,:)+adhelp_zf(:,:,:)
        do k = 1, km+1
          do i = is, ie
            adpe2(i,k) = adpe2(i,k)+adpn2(i,k)*(1./pe2(i,k))
            adpn2(i,k) = 0.
          end do
        end do
      else
        adhelp_ze(:,:,:) = 0.
        help_ze = pt
        call admap1_ppm( km,pk1,adpk1,help_ze,adhelp_ze,km,pk2,adpk2,adpt,is,ie,j,isd,ied,jsd,jed,1,help_k )
        adpt(:,:,:) = adpt(:,:,:)+adhelp_ze(:,:,:)
      endif
    endif
    delz(:,:,:) = delzi(:,:,:)
    do i = is, ie
      pe2(i,1) = ptop
      pe2(i,km+1) = pe(i,km+1,j)
    end do
    if (hybrid_z) then
      do i = is, ie
        ze1(i,km+1) = ze0(i,j,km+1)
      end do
      do k = km, 1, -1
        do i = is, ie
          ze1(i,k) = ze1(i,k+1)-delz(i,j,k)
        end do
      end do
      do k = 2, km+1
        do i = is, ie
          ze2(i,k) = ze0(i,j,k)
        end do
      end do
      do i = is, ie
        ze2(i,1) = ze1(i,1)
      end do
      do k = 1, km
        do i = is, ie
          deng(i,k) = -(delp(i,j,k)/delz(i,j,k))
        end do
      end do
      help_h = abs(kord_tm)
      call remap_z( km,ze1,deng,km,ze2,deng,is,ie,help_h )
      do k = 1, km
        do i = is, ie
          delz(i,j,k) = ze2(i,k+1)-ze2(i,k)
        end do
      end do
      do k = 1, km-1
        do i = is, ie
          dp2(i,k) = -(deng(i,k)*delz(i,j,k))
          pe2(i,k+1) = pe2(i,k)+dp2(i,k)
        end do
      end do
    else
      do k = 2, ks+1
        do i = is, ie
          pe2(i,k) = ak(k)
        end do
      end do
      do k = ks+2, km
        do i = is, ie
          pe2(i,k) = ak(k)+bk(k)*pe(i,km+1,j)
        end do
      end do
    endif
    do k = 2, km
      do i = is, ie
        adpe2(i,k) = adpe2(i,k)+adpk2(i,k)*akap*pe2(i,k)**(akap-1)
        adpk2(i,k) = 0.
      end do
    end do
    do i = is, ie
      adpk1(i,km+1) = adpk1(i,km+1)+adpk2(i,km+1)
      adpk2(i,km+1) = 0.
      adpk1(i,1) = adpk1(i,1)+adpk2(i,1)
      adpk2(i,1) = 0.
    end do
    do k = 1, km+1
      do i = is, ie
        adpk(i,j,k) = adpk(i,j,k)+adpk1(i,k)
        adpk1(i,k) = 0.
      end do
    end do
    delz(:,:,:) = delzi(:,:,:)
    q(:,:,:,:) = qh(:,:,:,:)
    do i = is, ie
      pe2(i,1) = ptop
      pe2(i,km+1) = pe(i,km+1,j)
    end do
    if (hybrid_z) then
      do i = is, ie
        ze1(i,km+1) = ze0(i,j,km+1)
      end do
      do k = km, 1, -1
        do i = is, ie
          ze1(i,k) = ze1(i,k+1)-delz(i,j,k)
        end do
      end do
      do k = 2, km+1
        do i = is, ie
          ze2(i,k) = ze0(i,j,k)
        end do
      end do
      do i = is, ie
        ze2(i,1) = ze1(i,1)
      end do
      do k = 1, km
        do i = is, ie
          deng(i,k) = -(delp(i,j,k)/delz(i,j,k))
        end do
      end do
      help_h = abs(kord_tm)
      call remap_z( km,ze1,deng,km,ze2,deng,is,ie,help_h )
      do k = 1, km
        do i = is, ie
          delz(i,j,k) = ze2(i,k+1)-ze2(i,k)
        end do
      end do
      do k = 1, km-1
        do i = is, ie
          dp2(i,k) = -(deng(i,k)*delz(i,j,k))
          pe2(i,k+1) = pe2(i,k)+dp2(i,k)
        end do
      end do
      do i = is, ie
        dp2(i,km) = pe2(i,km+1)-pe2(i,km)
      end do
    else
      do k = 2, ks+1
        do i = is, ie
          pe2(i,k) = ak(k)
        end do
      end do
      do k = ks+2, km
        do i = is, ie
          pe2(i,k) = ak(k)+bk(k)*pe(i,km+1,j)
        end do
      end do
      do k = 1, km
        do i = is, ie
          dp2(i,k) = pe2(i,k+1)-pe2(i,k)
        end do
      end do
    endif
    if (nq .ne. 0) then
      do iq = nq, 1, -1
        delz(:,:,:) = delzi(:,:,:)
        q(:,:,:,:) = qh(:,:,:,:)
        do i = is, ie
          pe2(i,1) = ptop
          pe2(i,km+1) = pe(i,km+1,j)
        end do
        if (hybrid_z) then
          do i = is, ie
            ze1(i,km+1) = ze0(i,j,km+1)
          end do
          do k = km, 1, -1
            do i = is, ie
              ze1(i,k) = ze1(i,k+1)-delz(i,j,k)
            end do
          end do
          do k = 2, km+1
            do i = is, ie
              ze2(i,k) = ze0(i,j,k)
            end do
          end do
          do i = is, ie
            ze2(i,1) = ze1(i,1)
          end do
          do k = 1, km
            do i = is, ie
              deng(i,k) = -(delp(i,j,k)/delz(i,j,k))
            end do
          end do
          help_h = abs(kord_tm)
          call remap_z( km,ze1,deng,km,ze2,deng,is,ie,help_h )
          do k = 1, km
            do i = is, ie
              delz(i,j,k) = ze2(i,k+1)-ze2(i,k)
            end do
          end do
          do k = 1, km-1
            do i = is, ie
              dp2(i,k) = -(deng(i,k)*delz(i,j,k))
              pe2(i,k+1) = pe2(i,k)+dp2(i,k)
            end do
          end do
          do i = is, ie
            dp2(i,km) = pe2(i,km+1)-pe2(i,km)
          end do
        else
          do k = 2, ks+1
            do i = is, ie
              pe2(i,k) = ak(k)
            end do
          end do
          do k = ks+2, km
            do i = is, ie
              pe2(i,k) = ak(k)+bk(k)*pe(i,km+1,j)
            end do
          end do
          do k = 1, km
            do i = is, ie
              dp2(i,k) = pe2(i,k+1)-pe2(i,k)
            end do
          end do
        endif
        do iq1 = 1, iq-1
          call map1_q2( km,pe1,q(isd,jsd,1,iq1),km,pe2,q2,dp2,is,ie,0,kord_tr,j,isd,ied,jsd,jed )
          if (fill) then
            help_i = ie-is+1
            call fillz( help_i,km,1,q2,dp2 )
          endif
          do k = 1, km
            do i = is, ie
              q(i,j,k,iq1) = q2(i,k)
            end do
          end do
        end do
        call map1_q2( km,pe1,q(isd,jsd,1,iq),km,pe2,q2,dp2,is,ie,0,kord_tr,j,isd,ied,jsd,jed )
        do k = 1, km
          do i = is, ie
            adq2(i,k) = adq2(i,k)+adq(i,j,k,iq)
            adq(i,j,k,iq) = 0.
          end do
        end do
        if (fill) then
          help_i = ie-is+1
          call adfillz( help_i,km,1,q2,adq2,dp2,addp2 )
        endif
        call admap1_q2( km,pe1,adpe1,q(isd,jsd,1,iq),adq(isd,jsd,1,iq),km,pe2,adpe2,adq2,dp2,addp2,is,ie,0,kord_tr,j,isd,ied,jsd,&
&jed )
      end do
    endif
    do k = 1, km
      do i = is, ie
        addp2(i,k) = addp2(i,k)+addelp(i,j,k)
        addelp(i,j,k) = 0.
      end do
    end do
    delp(:,:,:) = delpi(:,:,:)
    delz(:,:,:) = delzi(:,:,:)
    deng(:,:) = dengh(:,:)
    ze0(:,:,:) = ze0i(:,:,:)
    ze1(:,:) = ze1h(:,:)
    ze2(:,:) = ze2h(:,:)
    do i = is, ie
      pe2(i,1) = ptop
      pe2(i,km+1) = pe(i,km+1,j)
    end do
    if (hybrid_z) then
      do i = is, ie
        ze1(i,km+1) = ze0(i,j,km+1)
      end do
      do k = km, 1, -1
        do i = is, ie
          ze1(i,k) = ze1(i,k+1)-delz(i,j,k)
        end do
      end do
      do k = 2, km+1
        do i = is, ie
          ze2(i,k) = ze0(i,j,k)
        end do
      end do
      do i = is, ie
        ze2(i,1) = ze1(i,1)
      end do
      do k = 1, km
        do i = is, ie
          deng(i,k) = -(delp(i,j,k)/delz(i,j,k))
        end do
      end do
      help_h = abs(kord_tm)
      call remap_z( km,ze1,deng,km,ze2,deng,is,ie,help_h )
      do k = 1, km
        do i = is, ie
          delz(i,j,k) = ze2(i,k+1)-ze2(i,k)
        end do
      end do
      do i = is, ie
        adpe2(i,km+1) = adpe2(i,km+1)+addp2(i,km)
        adpe2(i,km) = adpe2(i,km)-addp2(i,km)
        addp2(i,km) = 0.
      end do
      do k = km-1, 1, -1
        do i = is, ie
          addp2(i,k) = addp2(i,k)+adpe2(i,k+1)
          adpe2(i,k) = adpe2(i,k)+adpe2(i,k+1)
          adpe2(i,k+1) = 0.
          addelz(i,j,k) = addelz(i,j,k)-addp2(i,k)*deng(i,k)
          addeng(i,k) = addeng(i,k)-addp2(i,k)*delz(i,j,k)
          addp2(i,k) = 0.
        end do
      end do
      do k = 1, km
        do i = is, ie
          adze2(i,k+1) = adze2(i,k+1)+addelz(i,j,k)
          adze2(i,k) = adze2(i,k)-addelz(i,j,k)
          addelz(i,j,k) = 0.
        end do
      end do
      adhelp_zh(:,:) = 0.
      help_zh = deng
      call adremap_z( km,ze1,adze1,help_zh,adhelp_zh,km,ze2,adze2,addeng,is,ie,help_h )
      addeng(:,:) = addeng(:,:)+adhelp_zh(:,:)
      delz(:,:,:) = delzi(:,:,:)
      do i = is, ie
        pe2(i,1) = ptop
        pe2(i,km+1) = pe(i,km+1,j)
      end do
      do k = 1, km
        do i = is, ie
          addelp(i,j,k) = addelp(i,j,k)-addeng(i,k)/delz(i,j,k)
          addelz(i,j,k) = addelz(i,j,k)+addeng(i,k)*(delp(i,j,k)/(delz(i,j,k)*delz(i,j,k)))
          addeng(i,k) = 0.
        end do
      end do
      do i = is, ie
        adze1(i,1) = adze1(i,1)+adze0(i,j,1)
        adze0(i,j,1) = 0.
        adze1(i,1) = adze1(i,1)+adze2(i,1)
        adze2(i,1) = 0.
      end do
      do k = 2, km+1
        do i = is, ie
          adze0(i,j,k) = adze0(i,j,k)+adze2(i,k)
          adze2(i,k) = 0.
        end do
      end do
      do k = 1, km
        do i = is, ie
          addelz(i,j,k) = addelz(i,j,k)-adze1(i,k)
          adze1(i,k+1) = adze1(i,k+1)+adze1(i,k)
          adze1(i,k) = 0.
        end do
      end do
      do i = is, ie
        adze0(i,j,km+1) = adze0(i,j,km+1)+adze1(i,km+1)
        adze1(i,km+1) = 0.
      end do
    else
      do k = 1, km
        do i = is, ie
          adpe2(i,k+1) = adpe2(i,k+1)+addp2(i,k)
          adpe2(i,k) = adpe2(i,k)-addp2(i,k)
          addp2(i,k) = 0.
        end do
      end do
      do k = ks+2, km
        do i = is, ie
          adpe(i,km+1,j) = adpe(i,km+1,j)+adpe2(i,k)*bk(k)
          adpe2(i,k) = 0.
        end do
      end do
      do k = 2, ks+1
        do i = is, ie
          adpe2(i,k) = 0.
        end do
      end do
    endif
  endif
  do i = is, ie
    adpe(i,km+1,j) = adpe(i,km+1,j)+adpe2(i,km+1)
    adpe2(i,km+1) = 0.
    adpe2(i,1) = 0.
  end do
  do k = 1, km+1
    do i = is, ie
      adpe(i,k,j) = adpe(i,k,j)+adpe1(i,k)
      adpe1(i,k) = 0.
    end do
  end do
end do
delp(:,:,:) = delph(:,:,:)
delz(:,:,:) = delzh(:,:,:)
if (( .not. hydrostatic) .and. ( .not. hybrid_z)) then
  do k = 1, km
    do j = js, je
      do i = is, ie
        addelp(i,j,k) = addelp(i,j,k)+addelz(i,j,k)*(delz(i,j,k)/(delp(i,j,k)*delp(i,j,k)))
        addelz(i,j,k) = -(addelz(i,j,k)/delp(i,j,k))
      end do
    end do
  end do
endif
pe(:,:,:) = peh(:,:,:)
peln(:,:,:) = pelni(:,:,:)
pk(:,:,:) = pkh(:,:,:)
pt(:,:,:) = pti(:,:,:)
u(:,:,:) = uh(:,:,:)
v(:,:,:) = vh(:,:,:)
if (kord_tm .lt. 0) then
  do j = js, je
    do k = 2, km+1
      do i = is, ie
        peln(i,k,j) = log(pe(i,k,j))
      end do
    end do
  end do
  if (remap_t) then
    do k = 1, km
      do j = js, je
        do i = is, ie
          adpeln(i,k+1,j) = adpeln(i,k+1,j)-adpt(i,j,k)*(pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))*rg/(rg*(peln(i,k+1,j)-peln(i,k,j))*rg*&
&(peln(i,k+1,j)-peln(i,k,j))))
          adpeln(i,k,j) = adpeln(i,k,j)+adpt(i,j,k)*(pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))*rg/(rg*(peln(i,k+1,j)-peln(i,k,j))*rg*&
&(peln(i,k+1,j)-peln(i,k,j))))
          adpk(i,j,k+1) = adpk(i,j,k+1)+adpt(i,j,k)*(pt(i,j,k)/(rg*(peln(i,k+1,j)-peln(i,k,j))))
          adpk(i,j,k) = adpk(i,j,k)-adpt(i,j,k)*(pt(i,j,k)/(rg*(peln(i,k+1,j)-peln(i,k,j))))
          adpt(i,j,k) = adpt(i,j,k)*((pk(i,j,k+1)-pk(i,j,k))/(rg*(peln(i,k+1,j)-peln(i,k,j))))
        end do
      end do
    end do
  endif
  do j = js, je
    do k = 2, km+1
      do i = is, ie
        adpe(i,k,j) = adpe(i,k,j)+adpeln(i,k,j)*(1./pe(i,k,j))
        adpeln(i,k,j) = 0.
      end do
    end do
  end do
else
  call pkez( km,is,ie,js,je,pe,pk,akap,peln,pkz )
  call cubed_to_latlon( u,v,ua,va,dx,dy,dxa,dya,km )
  do k = 1, km
    do j = js, je
      do i = is, ie
        adpkz(i,j,k) = adpkz(i,j,k)+adte(i,j,k)*pt(i,j,k)
        adpt(i,j,k) = adpt(i,j,k)+adte(i,j,k)*pkz(i,j,k)
        adua(i,j,k) = adua(i,j,k)+adte(i,j,k)*ua(i,j,k)
        adva(i,j,k) = adva(i,j,k)+adte(i,j,k)*va(i,j,k)
        adte(i,j,k) = 0.
      end do
    end do
  end do
  call adcubed_to_latlon( adu,adv,adua,adva,dx,dy,dxa,dya,km )
  call adpkez( km,is,ie,js,je,pe,adpe,pk,adpk,akap,peln,adpeln,adpkz )
endif

!----------------------------------------------
! FREE DYNAMIC MEMORY
!----------------------------------------------

end subroutine adlagrangian_to_eulerian


subroutine admap1_ppm( km, pe1, adpe1, q1, adq1, kn, pe2, adpe2, adq2, i1, i2, j, ibeg, iend, jbeg, jend, iv, kord )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r23 = 2./3.
real, parameter :: r3 = 1./3.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: km
real, intent(inout) :: adpe1(i1:i2,km+1)
integer, intent(in) :: kn
real, intent(inout) :: adpe2(i1:i2,kn+1)
integer, intent(in) :: ibeg
integer, intent(in) :: iend
integer, intent(in) :: jbeg
integer, intent(in) :: jend
real, intent(inout) :: adq1(ibeg:iend,jbeg:jend,km)
real, intent(inout) :: adq2(ibeg:iend,jbeg:jend,kn)
integer, intent(in) :: iv
integer, intent(in) :: j
integer, intent(in) :: kord
real, intent(in) :: pe1(i1:i2,km+1)
real, intent(in) :: pe2(i1:i2,kn+1)
real, intent(in) :: q1(ibeg:iend,jbeg:jend,km)

!==============================================
! declare local variables
!==============================================
real :: addp
real :: addp1(i1:i2,km)
real :: adesl
real :: adpl
real :: adpr
real :: adq4(4,i1:i2,km)
real :: adqsum
real :: dp
real :: dp1(i1:i2,km)
real :: esl
integer :: i
integer :: i3
integer :: idow
integer :: idow1
integer :: idox
integer :: idox1
integer :: k
integer :: k0
integer :: k0h
integer :: k1
integer :: l
logical :: l_123
logical :: l_555
logical :: l_loop
integer :: m
logical :: m_123
logical :: m_123h
logical :: m_123i
integer :: ndow
integer :: ndox
integer :: nrec
real :: pl
real :: pr
real :: q4(4,i1:i2,km)
real :: qsum
real :: qsumh

!==============================================
! declare external procedures and functions
!==============================================
integer, external :: adsubcl

!----------------------------------------------
! COUNT DOWN SUBROUTINE CALLS
!----------------------------------------------
call adcount( 1,-1 )

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
addp = 0.
addp1(:,:) = 0.
adesl = 0.
adpl = 0.
adpr = 0.
adq4(:,:,:) = 0.
adqsum = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
do k = 1, km
  do i = i1, i2
    dp1(i,k) = pe1(i,k+1)-pe1(i,k)
    q4(1,i,k) = q1(i,j,k)
  end do
end do
if (kord .gt. 7) then
  call cs_profile( q4,dp1,km,i1,i2,iv,kord )
else
  call ppm_profile( q4,dp1,km,i1,i2,iv,kord )
endif
do i = i2, i1, -1
  do i3 = i1, i-1
    k0 = 1
    do k = 1, kn
      l_123 =  .false. 
      l_555 =  .false. 
      l_loop =  .false. 
      l = k0
      if (l_loop .eq.  .false. ) then
        if (pe2(i3,k) .ge. pe1(i3,l) .and. pe2(i3,k) .le. pe1(i3,l+1)) then
          pl = (pe2(i3,k)-pe1(i3,l))/dp1(i3,l)
          if (pe2(i3,k+1) .le. pe1(i3,l+1)) then
            k0 = l
            l_555 =  .true. 
          else
            if (l_123 .eq.  .false. ) then
              qsum = (pe1(i3,l+1)-pe2(i3,k))*(q4(2,i3,l)+0.5*(q4(4,i3,l)+q4(3,i3,l)-q4(2,i3,l))*(1.+pl)-q4(4,i3,l)*r3*(1.+pl*(1.+&
&pl)))
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i3,k+1) .gt. pe1(i3,m+1)) then
  qsum = qsum+dp1(i3,m)*q4(1,i3,m)
else
  dp = pe2(i3,k+1)-pe1(i3,m)
  esl = dp/dp1(i3,m)
  qsum = qsum+dp*(q4(2,i3,m)+0.5*esl*(q4(3,i3,m)-q4(2,i3,m)+q4(4,i3,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i3,k+1) .gt. pe1(i3,m+1)) then
    qsum = qsum+dp1(i3,m)*q4(1,i3,m)
  else
    dp = pe2(i3,k+1)-pe1(i3,m)
    esl = dp/dp1(i3,m)
    qsum = qsum+dp*(q4(2,i3,m)+0.5*esl*(q4(3,i3,m)-q4(2,i3,m)+q4(4,i3,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
              end do
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
      do while ( l_loop .eq.  .false.  .and. l .le. km )
        if (l_loop .eq.  .false. ) then
          if (pe2(i3,k) .ge. pe1(i3,l) .and. pe2(i3,k) .le. pe1(i3,l+1)) then
            pl = (pe2(i3,k)-pe1(i3,l))/dp1(i3,l)
            if (pe2(i3,k+1) .le. pe1(i3,l+1)) then
              k0 = l
              l_555 =  .true. 
            else
              if (l_123 .eq.  .false. ) then
qsum = (pe1(i3,l+1)-pe2(i3,k))*(q4(2,i3,l)+0.5*(q4(4,i3,l)+q4(3,i3,l)-q4(2,i3,l))*(1.+pl)-q4(4,i3,l)*r3*(1.+pl*(1.+pl)))
m_123 =  .false. 
m = l+1
if (m_123 .eq.  .false. ) then
  if (pe2(i3,k+1) .gt. pe1(i3,m+1)) then
    qsum = qsum+dp1(i3,m)*q4(1,i3,m)
  else
    dp = pe2(i3,k+1)-pe1(i3,m)
    esl = dp/dp1(i3,m)
    qsum = qsum+dp*(q4(2,i3,m)+0.5*esl*(q4(3,i3,m)-q4(2,i3,m)+q4(4,i3,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
do while ( m_123 .eq.  .false.  .or. m .lt. km )
  m = m+1
  if (m_123 .eq.  .false. ) then
    if (pe2(i3,k+1) .gt. pe1(i3,m+1)) then
      qsum = qsum+dp1(i3,m)*q4(1,i3,m)
    else
      dp = pe2(i3,k+1)-pe1(i3,m)
      esl = dp/dp1(i3,m)
      qsum = qsum+dp*(q4(2,i3,m)+0.5*esl*(q4(3,i3,m)-q4(2,i3,m)+q4(4,i3,m)*(1.-r23*esl)))
      k0 = m
      m_123 =  .true. 
    endif
  endif
end do
l_123 =  .true. 
              endif
            endif
          endif
          if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
            l_loop =  .true. 
          endif
        endif
        if (l_loop .eq.  .false.  .and. l .lt. km) then
          l = l+1
        endif
      end do
    end do
  end do
  qsumh = qsum
  m_123i = m_123
  k0 = 1
  do k = kn, 1, -1
    m_123 = m_123i
    qsum = qsumh
    k0 = 1
    do k1 = 1, k-1
      l_123 =  .false. 
      l_555 =  .false. 
      l_loop =  .false. 
      l = k0
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k1) .ge. pe1(i,l) .and. pe2(i,k1) .le. pe1(i,l+1)) then
          pl = (pe2(i,k1)-pe1(i,l))/dp1(i,l)
          if (pe2(i,k1+1) .le. pe1(i,l+1)) then
            k0 = l
            l_555 =  .true. 
          else
            if (l_123 .eq.  .false. ) then
              qsum = (pe1(i,l+1)-pe2(i,k1))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k1+1) .gt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  dp = pe2(i,k1+1)-pe1(i,m)
  esl = dp/dp1(i,m)
  qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k1+1) .gt. pe1(i,m+1)) then
    qsum = qsum+dp1(i,m)*q4(1,i,m)
  else
    dp = pe2(i,k1+1)-pe1(i,m)
    esl = dp/dp1(i,m)
    qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
              end do
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
      do while ( l_loop .eq.  .false.  .and. l .le. km )
        if (l_loop .eq.  .false. ) then
          if (pe2(i,k1) .ge. pe1(i,l) .and. pe2(i,k1) .le. pe1(i,l+1)) then
            pl = (pe2(i,k1)-pe1(i,l))/dp1(i,l)
            if (pe2(i,k1+1) .le. pe1(i,l+1)) then
              k0 = l
              l_555 =  .true. 
            else
              if (l_123 .eq.  .false. ) then
qsum = (pe1(i,l+1)-pe2(i,k1))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
m_123 =  .false. 
m = l+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k1+1) .gt. pe1(i,m+1)) then
    qsum = qsum+dp1(i,m)*q4(1,i,m)
  else
    dp = pe2(i,k1+1)-pe1(i,m)
    esl = dp/dp1(i,m)
    qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
do while ( m_123 .eq.  .false.  .or. m .lt. km )
  m = m+1
  if (m_123 .eq.  .false. ) then
    if (pe2(i,k1+1) .gt. pe1(i,m+1)) then
      qsum = qsum+dp1(i,m)*q4(1,i,m)
    else
      dp = pe2(i,k1+1)-pe1(i,m)
      esl = dp/dp1(i,m)
      qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
      k0 = m
      m_123 =  .true. 
    endif
  endif
end do
l_123 =  .true. 
              endif
            endif
          endif
          if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
            l_loop =  .true. 
          endif
        endif
        if (l_loop .eq.  .false.  .and. l .lt. km) then
          l = l+1
        endif
      end do
    end do
    m_123h = m_123
    k0h = k0
    l_123 =  .false. 
    l_555 =  .false. 
    l_loop =  .false. 
    l = k0
    if (l_loop .eq.  .false. ) then
      if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
        pl = (pe2(i,k)-pe1(i,l))/dp1(i,l)
        if (pe2(i,k+1) .le. pe1(i,l+1)) then
          k0 = l
          l_555 =  .true. 
        else
          if (l_123 .eq.  .false. ) then
            qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
            m_123 =  .false. 
            m = l+1
            if (m_123 .eq.  .false. ) then
              if (pe2(i,k+1) .gt. pe1(i,m+1)) then
qsum = qsum+dp1(i,m)*q4(1,i,m)
              else
dp = pe2(i,k+1)-pe1(i,m)
esl = dp/dp1(i,m)
qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
k0 = m
m_123 =  .true. 
              endif
            endif
            do while ( m_123 .eq.  .false.  .or. m .lt. km )
              m = m+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  dp = pe2(i,k+1)-pe1(i,m)
  esl = dp/dp1(i,m)
  qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
            end do
            l_123 =  .true. 
          endif
        endif
      endif
      if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
        l_loop =  .true. 
      endif
    endif
    if (l_loop .eq.  .false.  .and. l .lt. km) then
      l = l+1
    endif
    do while ( l_loop .eq.  .false.  .and. l .le. km )
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
          pl = (pe2(i,k)-pe1(i,l))/dp1(i,l)
          if (pe2(i,k+1) .le. pe1(i,l+1)) then
            l_555 =  .true. 
          else
            if (l_123 .eq.  .false. ) then
              qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  dp = pe2(i,k+1)-pe1(i,m)
  esl = dp/dp1(i,m)
  qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  m_123 =  .true. 
endif
              endif
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .gt. pe1(i,m+1)) then
    qsum = qsum+dp1(i,m)*q4(1,i,m)
  else
    dp = pe2(i,k+1)-pe1(i,m)
    esl = dp/dp1(i,m)
    qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    m_123 =  .true. 
  endif
endif
              end do
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
    end do
    if (l_555 .eq.  .false. ) then
      adpe2(i,k+1) = adpe2(i,k+1)-adq2(i,j,k)*(qsum/((pe2(i,k+1)-pe2(i,k))*(pe2(i,k+1)-pe2(i,k))))
      adpe2(i,k) = adpe2(i,k)+adq2(i,j,k)*(qsum/((pe2(i,k+1)-pe2(i,k))*(pe2(i,k+1)-pe2(i,k))))
      adqsum = adqsum+adq2(i,j,k)/(pe2(i,k+1)-pe2(i,k))
      adq2(i,j,k) = 0.
    endif
    m_123 = m_123h
    l_123 =  .false. 
    l_555 =  .false. 
    l_loop =  .false. 
    l = k0
    if (l_loop .eq.  .false. ) then
      if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
        if (pe2(i,k+1) .le. pe1(i,l+1)) then
          l_555 =  .true. 
        else
          if (l_123 .eq.  .false. ) then
            m_123 =  .false. 
            m = l+1
            if (m_123 .eq.  .false. ) then
              if (pe2(i,k+1) .gt. pe1(i,m+1)) then
              else
m_123 =  .true. 
              endif
            endif
            do while ( m_123 .eq.  .false.  .or. m .lt. km )
              m = m+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
else
  m_123 =  .true. 
endif
              endif
            end do
            l_123 =  .true. 
          endif
        endif
      endif
      if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
        l_loop =  .true. 
      endif
    endif
    if (l_loop .eq.  .false.  .and. l .lt. km) then
      l = l+1
    endif
    call getkey( 2,2,(i-i1+k-1)*(1+i-i1+k-1)/2+i-i1,0,adsubcl(1,1),nrec )
    call adresto( 'memory_2_f_dyn_idow',19,idow,4,1,nrec )
    ndow = idow
    do idow = ndow, 1, -1
      m_123 = m_123h
      l_123 =  .false. 
      l_555 =  .false. 
      l_loop =  .false. 
      l = k0
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
          if (pe2(i,k+1) .le. pe1(i,l+1)) then
            l_555 =  .true. 
          else
            if (l_123 .eq.  .false. ) then
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
else
  m_123 =  .true. 
endif
              endif
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  else
    m_123 =  .true. 
  endif
endif
              end do
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
      do idow1 = 1, idow-1
        if (l_loop .eq.  .false. ) then
          if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
            if (pe2(i,k+1) .le. pe1(i,l+1)) then
              l_555 =  .true. 
            else
              if (l_123 .eq.  .false. ) then
m_123 =  .false. 
m = l+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  else
    m_123 =  .true. 
  endif
endif
do while ( m_123 .eq.  .false.  .or. m .lt. km )
  m = m+1
  if (m_123 .eq.  .false. ) then
    if (pe2(i,k+1) .gt. pe1(i,m+1)) then
    else
      m_123 =  .true. 
    endif
  endif
end do
l_123 =  .true. 
              endif
            endif
          endif
          if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
            l_loop =  .true. 
          endif
        endif
        if (l_loop .eq.  .false.  .and. l .lt. km) then
          l = l+1
        endif
      end do
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
          if (pe2(i,k+1) .le. pe1(i,l+1)) then
            pr = (pe2(i,k+1)-pe1(i,l))/dp1(i,l)
            adpl = adpl+adq2(i,j,k)*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(pr+2*pl))
            adpr = adpr+adq2(i,j,k)*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(2*pr+pl))
            adq4(4,i,l) = adq4(4,i,l)+adq2(i,j,k)*(0.5*(pr+pl)-r3*(pr*(pr+pl)+pl**2))
            adq4(3,i,l) = adq4(3,i,l)+0.5*adq2(i,j,k)*(pr+pl)
            adq4(2,i,l) = adq4(2,i,l)+adq2(i,j,k)*(1+(-0.5)*(pr+pl))
            adq2(i,j,k) = 0.
            addp1(i,l) = addp1(i,l)-adpr*((pe2(i,k+1)-pe1(i,l))/(dp1(i,l)*dp1(i,l)))
            adpe1(i,l) = adpe1(i,l)-adpr/dp1(i,l)
            adpe2(i,k+1) = adpe2(i,k+1)+adpr/dp1(i,l)
            adpr = 0.
          else
            if (l_123 .eq.  .false. ) then
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
else
  m_123 =  .true. 
endif
              endif
              call getkey( 2,1,((i-i1+k-1)*(1+i-i1+k-1)/2+i-i1+idow-1)*(1+(i-i1+k-1)*(1+i-i1+k-1)/2+i-i1+idow-1)/2+(i-i1+k-1)*(1+i-&
&i1+k-1)/2+i-i1,0,adsubcl(1,1),nrec )
              call adresto( 'memory_1_f_dyn_idox',19,idox,4,1,nrec )
              ndox = idox
              do idox = ndox, 1, -1
m_123 =  .false. 
m = l+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  else
    m_123 =  .true. 
  endif
endif
do idox1 = 1, idox-1
  m = m+1
  if (m_123 .eq.  .false. ) then
    if (pe2(i,k+1) .gt. pe1(i,m+1)) then
    else
      m_123 =  .true. 
    endif
  endif
end do
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .gt. pe1(i,m+1)) then
    addp1(i,m) = addp1(i,m)+adqsum*q4(1,i,m)
    adq4(1,i,m) = adq4(1,i,m)+adqsum*dp1(i,m)
  else
    addp = addp+adqsum*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    adesl = adesl+adqsum*dp*((-(0.5*esl*q4(4,i,m)*r23))+0.5*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    adq4(4,i,m) = adq4(4,i,m)+0.5*adqsum*dp*esl*(1.-r23*esl)
    adq4(3,i,m) = adq4(3,i,m)+0.5*adqsum*dp*esl
    adq4(2,i,m) = adq4(2,i,m)+adqsum*dp*(1+(-0.5)*esl)
    addp = addp+adesl/dp1(i,m)
    addp1(i,m) = addp1(i,m)-adesl*(dp/(dp1(i,m)*dp1(i,m)))
    adesl = 0.
    adpe1(i,m) = adpe1(i,m)-addp
    adpe2(i,k+1) = adpe2(i,k+1)+addp
    addp = 0.
  endif
endif
              end do
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  addp1(i,m) = addp1(i,m)+adqsum*q4(1,i,m)
  adq4(1,i,m) = adq4(1,i,m)+adqsum*dp1(i,m)
else
  dp = pe2(i,k+1)-pe1(i,m)
  esl = dp/dp1(i,m)
  addp = addp+adqsum*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  adesl = adesl+adqsum*dp*((-(0.5*esl*q4(4,i,m)*r23))+0.5*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  adq4(4,i,m) = adq4(4,i,m)+0.5*adqsum*dp*esl*(1.-r23*esl)
  adq4(3,i,m) = adq4(3,i,m)+0.5*adqsum*dp*esl
  adq4(2,i,m) = adq4(2,i,m)+adqsum*dp*(1+(-0.5)*esl)
  addp = addp+adesl/dp1(i,m)
  addp1(i,m) = addp1(i,m)-adesl*(dp/(dp1(i,m)*dp1(i,m)))
  adesl = 0.
  adpe1(i,m) = adpe1(i,m)-addp
  adpe2(i,k+1) = adpe2(i,k+1)+addp
  addp = 0.
endif
              endif
              adpe1(i,l+1) = adpe1(i,l+1)+adqsum*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)&
&))
              adpe2(i,k) = adpe2(i,k)-adqsum*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
              adpl = adpl+adqsum*(pe1(i,l+1)-pe2(i,k))*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(1+2*pl))
              adq4(4,i,l) = adq4(4,i,l)+adqsum*(pe1(i,l+1)-pe2(i,k))*(0.5*(1.+pl)-r3*(1.+pl*(1.+pl)))
              adq4(3,i,l) = adq4(3,i,l)+0.5*adqsum*(pe1(i,l+1)-pe2(i,k))*(1.+pl)
              adq4(2,i,l) = adq4(2,i,l)+adqsum*(pe1(i,l+1)-pe2(i,k))*(1+(-0.5)*(1.+pl))
              adqsum = 0.
            endif
          endif
          addp1(i,l) = addp1(i,l)-adpl*((pe2(i,k)-pe1(i,l))/(dp1(i,l)*dp1(i,l)))
          adpe1(i,l) = adpe1(i,l)-adpl/dp1(i,l)
          adpe2(i,k) = adpe2(i,k)+adpl/dp1(i,l)
          adpl = 0.
        endif
      endif
    end do
    k0 = k0h
    l_loop =  .false. 
    l = k0
    if (l_loop .eq.  .false. ) then
      if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
        if (pe2(i,k+1) .le. pe1(i,l+1)) then
          pr = (pe2(i,k+1)-pe1(i,l))/dp1(i,l)
          adpl = adpl+adq2(i,j,k)*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(pr+2*pl))
          adpr = adpr+adq2(i,j,k)*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(2*pr+pl))
          adq4(4,i,l) = adq4(4,i,l)+adq2(i,j,k)*(0.5*(pr+pl)-r3*(pr*(pr+pl)+pl**2))
          adq4(3,i,l) = adq4(3,i,l)+0.5*adq2(i,j,k)*(pr+pl)
          adq4(2,i,l) = adq4(2,i,l)+adq2(i,j,k)*(1+(-0.5)*(pr+pl))
          adq2(i,j,k) = 0.
          addp1(i,l) = addp1(i,l)-adpr*((pe2(i,k+1)-pe1(i,l))/(dp1(i,l)*dp1(i,l)))
          adpe1(i,l) = adpe1(i,l)-adpr/dp1(i,l)
          adpe2(i,k+1) = adpe2(i,k+1)+adpr/dp1(i,l)
          adpr = 0.
        endif
        addp1(i,l) = addp1(i,l)-adpl*((pe2(i,k)-pe1(i,l))/(dp1(i,l)*dp1(i,l)))
        adpe1(i,l) = adpe1(i,l)-adpl/dp1(i,l)
        adpe2(i,k) = adpe2(i,k)+adpl/dp1(i,l)
        adpl = 0.
      endif
    endif
  end do
end do
do k = 1, km
  do i = i1, i2
    q4(1,i,k) = q1(i,j,k)
  end do
end do
if (kord .gt. 7) then
  call adcs_profile( q4,adq4,dp1,addp1,km,i1,i2,iv )
else
  call adppm_profile( q4,adq4,dp1,addp1,km,i1,i2,iv,kord )
endif
do k = 1, km
  do i = i1, i2
    adq1(i,j,k) = adq1(i,j,k)+adq4(1,i,k)
    adq4(1,i,k) = 0.
    adpe1(i,k+1) = adpe1(i,k+1)+addp1(i,k)
    adpe1(i,k) = adpe1(i,k)-addp1(i,k)
    addp1(i,k) = 0.
  end do
end do

end subroutine admap1_ppm


subroutine admap1_q2( km, pe1, adpe1, q1, adq1, kn, pe2, adpe2, adq2, dp2, addp2, i1, i2, iv, kord, j, ibeg, iend, jbeg, jend )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r23 = 2./3.
real, parameter :: r3 = 1./3.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: kn
real, intent(inout) :: addp2(i1:i2,kn)
integer, intent(in) :: km
real, intent(inout) :: adpe1(i1:i2,km+1)
real, intent(inout) :: adpe2(i1:i2,kn+1)
integer, intent(in) :: ibeg
integer, intent(in) :: iend
integer, intent(in) :: jbeg
integer, intent(in) :: jend
real, intent(inout) :: adq1(ibeg:iend,jbeg:jend,km)
real, intent(inout) :: adq2(i1:i2,kn)
real, intent(in) :: dp2(i1:i2,kn)
integer, intent(in) :: iv
integer, intent(in) :: j
integer, intent(in) :: kord
real, intent(in) :: pe1(i1:i2,km+1)
real, intent(in) :: pe2(i1:i2,kn+1)
real, intent(in) :: q1(ibeg:iend,jbeg:jend,km)

!==============================================
! declare local variables
!==============================================
real :: addp
real :: addp1(i1:i2,km)
real :: adesl
real :: adpl
real :: adpr
real :: adq4(4,i1:i2,km)
real :: adqsum
real :: dp
real :: dp1(i1:i2,km)
real :: esl
integer :: i
integer :: i3
integer :: idow
integer :: idow1
integer :: idox
integer :: idox1
integer :: k
integer :: k0
integer :: k0h
integer :: k1
integer :: l
logical :: l_123
logical :: l_555
logical :: l_loop
integer :: m
logical :: m_123
logical :: m_123h
logical :: m_123i
integer :: ndow
integer :: ndox
integer :: nrec
real :: pl
real :: pr
real :: q4(4,i1:i2,km)
real :: qsum
real :: qsumh

!==============================================
! declare external procedures and functions
!==============================================
integer, external :: adsubcl

!----------------------------------------------
! COUNT DOWN SUBROUTINE CALLS
!----------------------------------------------
call adcount( 3,-1 )

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
addp = 0.
addp1(:,:) = 0.
adesl = 0.
adpl = 0.
adpr = 0.
adq4(:,:,:) = 0.
adqsum = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
do k = 1, km
  do i = i1, i2
    dp1(i,k) = pe1(i,k+1)-pe1(i,k)
    q4(1,i,k) = q1(i,j,k)
  end do
end do
if (kord .gt. 7) then
  call cs_profile( q4,dp1,km,i1,i2,iv,kord )
else
  call ppm_profile( q4,dp1,km,i1,i2,iv,kord )
endif
do i = i2, i1, -1
  do i3 = i1, i-1
    k0 = 1
    do k = 1, kn
      l_123 =  .false. 
      l_555 =  .false. 
      l_loop =  .false. 
      l = k0
      if (l_loop .eq.  .false. ) then
        if (pe2(i3,k) .ge. pe1(i3,l) .and. pe2(i3,k) .le. pe1(i3,l+1)) then
          pl = (pe2(i3,k)-pe1(i3,l))/dp1(i3,l)
          if (pe2(i3,k+1) .le. pe1(i3,l+1)) then
            k0 = l
            l_555 =  .true. 
          else
            if (l_123 .eq.  .false. ) then
              qsum = (pe1(i3,l+1)-pe2(i3,k))*(q4(2,i3,l)+0.5*(q4(4,i3,l)+q4(3,i3,l)-q4(2,i3,l))*(1.+pl)-q4(4,i3,l)*r3*(1.+pl*(1.+&
&pl)))
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i3,k+1) .gt. pe1(i3,m+1)) then
  qsum = qsum+dp1(i3,m)*q4(1,i3,m)
else
  dp = pe2(i3,k+1)-pe1(i3,m)
  esl = dp/dp1(i3,m)
  qsum = qsum+dp*(q4(2,i3,m)+0.5*esl*(q4(3,i3,m)-q4(2,i3,m)+q4(4,i3,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i3,k+1) .gt. pe1(i3,m+1)) then
    qsum = qsum+dp1(i3,m)*q4(1,i3,m)
  else
    dp = pe2(i3,k+1)-pe1(i3,m)
    esl = dp/dp1(i3,m)
    qsum = qsum+dp*(q4(2,i3,m)+0.5*esl*(q4(3,i3,m)-q4(2,i3,m)+q4(4,i3,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
              end do
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
      do while ( l_loop .eq.  .false.  .and. l .le. km )
        if (l_loop .eq.  .false. ) then
          if (pe2(i3,k) .ge. pe1(i3,l) .and. pe2(i3,k) .le. pe1(i3,l+1)) then
            pl = (pe2(i3,k)-pe1(i3,l))/dp1(i3,l)
            if (pe2(i3,k+1) .le. pe1(i3,l+1)) then
              k0 = l
              l_555 =  .true. 
            else
              if (l_123 .eq.  .false. ) then
qsum = (pe1(i3,l+1)-pe2(i3,k))*(q4(2,i3,l)+0.5*(q4(4,i3,l)+q4(3,i3,l)-q4(2,i3,l))*(1.+pl)-q4(4,i3,l)*r3*(1.+pl*(1.+pl)))
m_123 =  .false. 
m = l+1
if (m_123 .eq.  .false. ) then
  if (pe2(i3,k+1) .gt. pe1(i3,m+1)) then
    qsum = qsum+dp1(i3,m)*q4(1,i3,m)
  else
    dp = pe2(i3,k+1)-pe1(i3,m)
    esl = dp/dp1(i3,m)
    qsum = qsum+dp*(q4(2,i3,m)+0.5*esl*(q4(3,i3,m)-q4(2,i3,m)+q4(4,i3,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
do while ( m_123 .eq.  .false.  .or. m .lt. km )
  m = m+1
  if (m_123 .eq.  .false. ) then
    if (pe2(i3,k+1) .gt. pe1(i3,m+1)) then
      qsum = qsum+dp1(i3,m)*q4(1,i3,m)
    else
      dp = pe2(i3,k+1)-pe1(i3,m)
      esl = dp/dp1(i3,m)
      qsum = qsum+dp*(q4(2,i3,m)+0.5*esl*(q4(3,i3,m)-q4(2,i3,m)+q4(4,i3,m)*(1.-r23*esl)))
      k0 = m
      m_123 =  .true. 
    endif
  endif
end do
l_123 =  .true. 
              endif
            endif
          endif
          if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
            l_loop =  .true. 
          endif
        endif
        if (l_loop .eq.  .false.  .and. l .lt. km) then
          l = l+1
        endif
      end do
    end do
  end do
  qsumh = qsum
  m_123i = m_123
  k0 = 1
  do k = kn, 1, -1
    m_123 = m_123i
    qsum = qsumh
    k0 = 1
    do k1 = 1, k-1
      l_123 =  .false. 
      l_555 =  .false. 
      l_loop =  .false. 
      l = k0
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k1) .ge. pe1(i,l) .and. pe2(i,k1) .le. pe1(i,l+1)) then
          pl = (pe2(i,k1)-pe1(i,l))/dp1(i,l)
          if (pe2(i,k1+1) .le. pe1(i,l+1)) then
            k0 = l
            l_555 =  .true. 
          else
            if (l_123 .eq.  .false. ) then
              qsum = (pe1(i,l+1)-pe2(i,k1))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k1+1) .gt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  dp = pe2(i,k1+1)-pe1(i,m)
  esl = dp/dp1(i,m)
  qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k1+1) .gt. pe1(i,m+1)) then
    qsum = qsum+dp1(i,m)*q4(1,i,m)
  else
    dp = pe2(i,k1+1)-pe1(i,m)
    esl = dp/dp1(i,m)
    qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
              end do
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
      do while ( l_loop .eq.  .false.  .and. l .le. km )
        if (l_loop .eq.  .false. ) then
          if (pe2(i,k1) .ge. pe1(i,l) .and. pe2(i,k1) .le. pe1(i,l+1)) then
            pl = (pe2(i,k1)-pe1(i,l))/dp1(i,l)
            if (pe2(i,k1+1) .le. pe1(i,l+1)) then
              k0 = l
              l_555 =  .true. 
            else
              if (l_123 .eq.  .false. ) then
qsum = (pe1(i,l+1)-pe2(i,k1))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
m_123 =  .false. 
m = l+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k1+1) .gt. pe1(i,m+1)) then
    qsum = qsum+dp1(i,m)*q4(1,i,m)
  else
    dp = pe2(i,k1+1)-pe1(i,m)
    esl = dp/dp1(i,m)
    qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
do while ( m_123 .eq.  .false.  .or. m .lt. km )
  m = m+1
  if (m_123 .eq.  .false. ) then
    if (pe2(i,k1+1) .gt. pe1(i,m+1)) then
      qsum = qsum+dp1(i,m)*q4(1,i,m)
    else
      dp = pe2(i,k1+1)-pe1(i,m)
      esl = dp/dp1(i,m)
      qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
      k0 = m
      m_123 =  .true. 
    endif
  endif
end do
l_123 =  .true. 
              endif
            endif
          endif
          if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
            l_loop =  .true. 
          endif
        endif
        if (l_loop .eq.  .false.  .and. l .lt. km) then
          l = l+1
        endif
      end do
    end do
    m_123h = m_123
    k0h = k0
    l_123 =  .false. 
    l_555 =  .false. 
    l_loop =  .false. 
    l = k0
    if (l_loop .eq.  .false. ) then
      if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
        pl = (pe2(i,k)-pe1(i,l))/dp1(i,l)
        if (pe2(i,k+1) .le. pe1(i,l+1)) then
          k0 = l
          l_555 =  .true. 
        else
          if (l_123 .eq.  .false. ) then
            qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
            m_123 =  .false. 
            m = l+1
            if (m_123 .eq.  .false. ) then
              if (pe2(i,k+1) .gt. pe1(i,m+1)) then
qsum = qsum+dp1(i,m)*q4(1,i,m)
              else
dp = pe2(i,k+1)-pe1(i,m)
esl = dp/dp1(i,m)
qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
k0 = m
m_123 =  .true. 
              endif
            endif
            do while ( m_123 .eq.  .false.  .or. m .lt. km )
              m = m+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  dp = pe2(i,k+1)-pe1(i,m)
  esl = dp/dp1(i,m)
  qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
            end do
            l_123 =  .true. 
          endif
        endif
      endif
      if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
        l_loop =  .true. 
      endif
    endif
    if (l_loop .eq.  .false.  .and. l .lt. km) then
      l = l+1
    endif
    do while ( l_loop .eq.  .false.  .and. l .le. km )
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
          pl = (pe2(i,k)-pe1(i,l))/dp1(i,l)
          if (pe2(i,k+1) .le. pe1(i,l+1)) then
            l_555 =  .true. 
          else
            if (l_123 .eq.  .false. ) then
              qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  dp = pe2(i,k+1)-pe1(i,m)
  esl = dp/dp1(i,m)
  qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  m_123 =  .true. 
endif
              endif
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .gt. pe1(i,m+1)) then
    qsum = qsum+dp1(i,m)*q4(1,i,m)
  else
    dp = pe2(i,k+1)-pe1(i,m)
    esl = dp/dp1(i,m)
    qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    m_123 =  .true. 
  endif
endif
              end do
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
    end do
    if (l_555 .eq.  .false. ) then
      addp2(i,k) = addp2(i,k)-adq2(i,k)*(qsum/(dp2(i,k)*dp2(i,k)))
      adqsum = adqsum+adq2(i,k)/dp2(i,k)
      adq2(i,k) = 0.
    endif
    m_123 = m_123h
    l_123 =  .false. 
    l_555 =  .false. 
    l_loop =  .false. 
    l = k0
    if (l_loop .eq.  .false. ) then
      if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
        if (pe2(i,k+1) .le. pe1(i,l+1)) then
          l_555 =  .true. 
        else
          if (l_123 .eq.  .false. ) then
            m_123 =  .false. 
            m = l+1
            if (m_123 .eq.  .false. ) then
              if (pe2(i,k+1) .gt. pe1(i,m+1)) then
              else
m_123 =  .true. 
              endif
            endif
            do while ( m_123 .eq.  .false.  .or. m .lt. km )
              m = m+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
else
  m_123 =  .true. 
endif
              endif
            end do
            l_123 =  .true. 
          endif
        endif
      endif
      if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
        l_loop =  .true. 
      endif
    endif
    if (l_loop .eq.  .false.  .and. l .lt. km) then
      l = l+1
    endif
    call getkey( 2,5,(i-i1+k-1)*(1+i-i1+k-1)/2+i-i1,0,adsubcl(1,3),nrec )
    call adresto( 'memory_5_f_dyn_idow',19,idow,4,1,nrec )
    ndow = idow
    do idow = ndow, 1, -1
      m_123 = m_123h
      l_123 =  .false. 
      l_555 =  .false. 
      l_loop =  .false. 
      l = k0
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
          if (pe2(i,k+1) .le. pe1(i,l+1)) then
            l_555 =  .true. 
          else
            if (l_123 .eq.  .false. ) then
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
else
  m_123 =  .true. 
endif
              endif
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  else
    m_123 =  .true. 
  endif
endif
              end do
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
      do idow1 = 1, idow-1
        if (l_loop .eq.  .false. ) then
          if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
            if (pe2(i,k+1) .le. pe1(i,l+1)) then
              l_555 =  .true. 
            else
              if (l_123 .eq.  .false. ) then
m_123 =  .false. 
m = l+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  else
    m_123 =  .true. 
  endif
endif
do while ( m_123 .eq.  .false.  .or. m .lt. km )
  m = m+1
  if (m_123 .eq.  .false. ) then
    if (pe2(i,k+1) .gt. pe1(i,m+1)) then
    else
      m_123 =  .true. 
    endif
  endif
end do
l_123 =  .true. 
              endif
            endif
          endif
          if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
            l_loop =  .true. 
          endif
        endif
        if (l_loop .eq.  .false.  .and. l .lt. km) then
          l = l+1
        endif
      end do
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
          if (pe2(i,k+1) .le. pe1(i,l+1)) then
            pr = (pe2(i,k+1)-pe1(i,l))/dp1(i,l)
            adpl = adpl+adq2(i,k)*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(pr+2*pl))
            adpr = adpr+adq2(i,k)*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(2*pr+pl))
            adq4(4,i,l) = adq4(4,i,l)+adq2(i,k)*(0.5*(pr+pl)-r3*(pr*(pr+pl)+pl**2))
            adq4(3,i,l) = adq4(3,i,l)+0.5*adq2(i,k)*(pr+pl)
            adq4(2,i,l) = adq4(2,i,l)+adq2(i,k)*(1+(-0.5)*(pr+pl))
            adq2(i,k) = 0.
            addp1(i,l) = addp1(i,l)-adpr*((pe2(i,k+1)-pe1(i,l))/(dp1(i,l)*dp1(i,l)))
            adpe1(i,l) = adpe1(i,l)-adpr/dp1(i,l)
            adpe2(i,k+1) = adpe2(i,k+1)+adpr/dp1(i,l)
            adpr = 0.
          else
            if (l_123 .eq.  .false. ) then
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
else
  m_123 =  .true. 
endif
              endif
              call getkey( 2,4,((i-i1+k-1)*(1+i-i1+k-1)/2+i-i1+idow-1)*(1+(i-i1+k-1)*(1+i-i1+k-1)/2+i-i1+idow-1)/2+(i-i1+k-1)*(1+i-&
&i1+k-1)/2+i-i1,0,adsubcl(1,3),nrec )
              call adresto( 'memory_4_f_dyn_idox',19,idox,4,1,nrec )
              ndox = idox
              do idox = ndox, 1, -1
m_123 =  .false. 
m = l+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  else
    m_123 =  .true. 
  endif
endif
do idox1 = 1, idox-1
  m = m+1
  if (m_123 .eq.  .false. ) then
    if (pe2(i,k+1) .gt. pe1(i,m+1)) then
    else
      m_123 =  .true. 
    endif
  endif
end do
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .gt. pe1(i,m+1)) then
    addp1(i,m) = addp1(i,m)+adqsum*q4(1,i,m)
    adq4(1,i,m) = adq4(1,i,m)+adqsum*dp1(i,m)
  else
    addp = addp+adqsum*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    adesl = adesl+adqsum*dp*((-(0.5*esl*q4(4,i,m)*r23))+0.5*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    adq4(4,i,m) = adq4(4,i,m)+0.5*adqsum*dp*esl*(1.-r23*esl)
    adq4(3,i,m) = adq4(3,i,m)+0.5*adqsum*dp*esl
    adq4(2,i,m) = adq4(2,i,m)+adqsum*dp*(1+(-0.5)*esl)
    addp = addp+adesl/dp1(i,m)
    addp1(i,m) = addp1(i,m)-adesl*(dp/(dp1(i,m)*dp1(i,m)))
    adesl = 0.
    adpe1(i,m) = adpe1(i,m)-addp
    adpe2(i,k+1) = adpe2(i,k+1)+addp
    addp = 0.
  endif
endif
              end do
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  addp1(i,m) = addp1(i,m)+adqsum*q4(1,i,m)
  adq4(1,i,m) = adq4(1,i,m)+adqsum*dp1(i,m)
else
  dp = pe2(i,k+1)-pe1(i,m)
  esl = dp/dp1(i,m)
  addp = addp+adqsum*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  adesl = adesl+adqsum*dp*((-(0.5*esl*q4(4,i,m)*r23))+0.5*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  adq4(4,i,m) = adq4(4,i,m)+0.5*adqsum*dp*esl*(1.-r23*esl)
  adq4(3,i,m) = adq4(3,i,m)+0.5*adqsum*dp*esl
  adq4(2,i,m) = adq4(2,i,m)+adqsum*dp*(1+(-0.5)*esl)
  addp = addp+adesl/dp1(i,m)
  addp1(i,m) = addp1(i,m)-adesl*(dp/(dp1(i,m)*dp1(i,m)))
  adesl = 0.
  adpe1(i,m) = adpe1(i,m)-addp
  adpe2(i,k+1) = adpe2(i,k+1)+addp
  addp = 0.
endif
              endif
              adpe1(i,l+1) = adpe1(i,l+1)+adqsum*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)&
&))
              adpe2(i,k) = adpe2(i,k)-adqsum*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
              adpl = adpl+adqsum*(pe1(i,l+1)-pe2(i,k))*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(1+2*pl))
              adq4(4,i,l) = adq4(4,i,l)+adqsum*(pe1(i,l+1)-pe2(i,k))*(0.5*(1.+pl)-r3*(1.+pl*(1.+pl)))
              adq4(3,i,l) = adq4(3,i,l)+0.5*adqsum*(pe1(i,l+1)-pe2(i,k))*(1.+pl)
              adq4(2,i,l) = adq4(2,i,l)+adqsum*(pe1(i,l+1)-pe2(i,k))*(1+(-0.5)*(1.+pl))
              adqsum = 0.
            endif
          endif
          addp1(i,l) = addp1(i,l)-adpl*((pe2(i,k)-pe1(i,l))/(dp1(i,l)*dp1(i,l)))
          adpe1(i,l) = adpe1(i,l)-adpl/dp1(i,l)
          adpe2(i,k) = adpe2(i,k)+adpl/dp1(i,l)
          adpl = 0.
        endif
      endif
    end do
    k0 = k0h
    l_loop =  .false. 
    l = k0
    if (l_loop .eq.  .false. ) then
      if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
        if (pe2(i,k+1) .le. pe1(i,l+1)) then
          pr = (pe2(i,k+1)-pe1(i,l))/dp1(i,l)
          adpl = adpl+adq2(i,k)*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(pr+2*pl))
          adpr = adpr+adq2(i,k)*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(2*pr+pl))
          adq4(4,i,l) = adq4(4,i,l)+adq2(i,k)*(0.5*(pr+pl)-r3*(pr*(pr+pl)+pl**2))
          adq4(3,i,l) = adq4(3,i,l)+0.5*adq2(i,k)*(pr+pl)
          adq4(2,i,l) = adq4(2,i,l)+adq2(i,k)*(1+(-0.5)*(pr+pl))
          adq2(i,k) = 0.
          addp1(i,l) = addp1(i,l)-adpr*((pe2(i,k+1)-pe1(i,l))/(dp1(i,l)*dp1(i,l)))
          adpe1(i,l) = adpe1(i,l)-adpr/dp1(i,l)
          adpe2(i,k+1) = adpe2(i,k+1)+adpr/dp1(i,l)
          adpr = 0.
        endif
        addp1(i,l) = addp1(i,l)-adpl*((pe2(i,k)-pe1(i,l))/(dp1(i,l)*dp1(i,l)))
        adpe1(i,l) = adpe1(i,l)-adpl/dp1(i,l)
        adpe2(i,k) = adpe2(i,k)+adpl/dp1(i,l)
        adpl = 0.
      endif
    endif
  end do
end do
do k = 1, km
  do i = i1, i2
    q4(1,i,k) = q1(i,j,k)
  end do
end do
if (kord .gt. 7) then
  call adcs_profile( q4,adq4,dp1,addp1,km,i1,i2,iv )
else
  call adppm_profile( q4,adq4,dp1,addp1,km,i1,i2,iv,kord )
endif
do k = 1, km
  do i = i1, i2
    adq1(i,j,k) = adq1(i,j,k)+adq4(1,i,k)
    adq4(1,i,k) = 0.
    adpe1(i,k+1) = adpe1(i,k+1)+addp1(i,k)
    adpe1(i,k) = adpe1(i,k)-addp1(i,k)
    addp1(i,k) = 0.
  end do
end do

end subroutine admap1_q2


subroutine adpkez( km, ifirst, ilast, jfirst, jlast, pe, adpe, pk, adpk, akap, peln, adpeln, adpkz )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: ifirst
integer, intent(in) :: ilast
integer, intent(in) :: jfirst
integer, intent(in) :: jlast
integer, intent(in) :: km
real, intent(inout) :: adpe(ifirst-1:ilast+1,km+1,jfirst-1:jlast+1)
real, intent(inout) :: adpeln(ifirst:ilast,km+1,jfirst:jlast)
real, intent(inout) :: adpk(ifirst:ilast,jfirst:jlast,km+1)
real, intent(inout) :: adpkz(ifirst:ilast,jfirst:jlast,km)
real, intent(in) :: akap
real, intent(in) :: pe(ifirst-1:ilast+1,km+1,jfirst-1:jlast+1)
real, intent(out) :: peln(ifirst:ilast,km+1,jfirst:jlast)
real, intent(in) :: pk(ifirst:ilast,jfirst:jlast,km+1)

!==============================================
! declare local variables
!==============================================
real :: adpek
real :: adpk2(ifirst:ilast,km+1)
real :: ak1
integer :: i
integer :: j
integer :: k
real :: lnp
real :: pek
real :: pk2(ifirst:ilast,km+1)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
adpek = 0.
adpk2(:,:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
ak1 = (akap+1.)/akap
do j = jfirst, jlast
  adpek = 0.
  pek = pk(ifirst,j,1)
  do i = ifirst, ilast
    pk2(i,1) = pek
  end do
  do k = 2, km+1
    do i = ifirst, ilast
      peln(i,k,j) = log(pe(i,k,j))
      pk2(i,k) = pk(i,j,k)
    end do
  end do
  if (ptop .lt. ptop_min) then
    do i = ifirst, ilast
      peln(i,1,j) = peln(i,2,j)-ak1
    end do
  else
    lnp = log(ptop)
    do i = ifirst, ilast
      peln(i,1,j) = lnp
    end do
  endif
  do k = 1, km
    do i = ifirst, ilast
      adpeln(i,k+1,j) = adpeln(i,k+1,j)-adpkz(i,j,k)*((pk2(i,k+1)-pk2(i,k))*akap/(akap*(peln(i,k+1,j)-peln(i,k,j))*akap*(peln(i,k+&
&1,j)-peln(i,k,j))))
      adpeln(i,k,j) = adpeln(i,k,j)+adpkz(i,j,k)*((pk2(i,k+1)-pk2(i,k))*akap/(akap*(peln(i,k+1,j)-peln(i,k,j))*akap*(peln(i,k+1,j)-&
&peln(i,k,j))))
      adpk2(i,k+1) = adpk2(i,k+1)+adpkz(i,j,k)/(akap*(peln(i,k+1,j)-peln(i,k,j)))
      adpk2(i,k) = adpk2(i,k)-adpkz(i,j,k)/(akap*(peln(i,k+1,j)-peln(i,k,j)))
      adpkz(i,j,k) = 0.
    end do
  end do
  if (ptop .lt. ptop_min) then
    do i = ifirst, ilast
      adpeln(i,2,j) = adpeln(i,2,j)+adpeln(i,1,j)
      adpeln(i,1,j) = 0.
    end do
  else
    do i = ifirst, ilast
      adpeln(i,1,j) = 0.
    end do
  endif
  do k = 2, km+1
    do i = ifirst, ilast
      adpk(i,j,k) = adpk(i,j,k)+adpk2(i,k)
      adpk2(i,k) = 0.
      adpe(i,k,j) = adpe(i,k,j)+adpeln(i,k,j)*(1./pe(i,k,j))
      adpeln(i,k,j) = 0.
    end do
  end do
  do i = ifirst, ilast
    adpek = adpek+adpk2(i,1)
    adpk2(i,1) = 0.
  end do
  adpk(ifirst,j,1) = adpk(ifirst,j,1)+adpek
  adpek = 0.
end do

end subroutine adpkez


subroutine adppm_limiters( dm, addm, a4, ada4, itot, lmt )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r12 = 1./12.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: itot
real, intent(inout) :: a4(4,itot)
real, intent(inout) :: ada4(4,itot)
real, intent(inout) :: addm(itot)
real, intent(in) :: dm(itot)
integer, intent(in) :: lmt

!==============================================
! declare local variables
!==============================================
real :: a4h(lbound(a4,1):ubound(a4,1),lbound(a4,2):ubound(a4,2))
real :: a4i
real :: a4j
real :: a6da
real :: ada4h
real :: ada4i
real :: ada4j
real :: ada4k
real :: ada6da
real :: adda1
real :: adda2
real :: adfmin
real :: adqmp
real :: da1
real :: da2
real :: fmin
integer :: i
real :: qmp

!----------------------------------------------
! SAVE REQUIRED INPUT VARIABLES
!----------------------------------------------
a4h(:,:) = a4(:,:)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
ada6da = 0.
adda1 = 0.
adda2 = 0.
adfmin = 0.
adqmp = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
if (lmt .ne. 3) then
  if (lmt .eq. 0) then
    do i = 1, itot
      ada6da = 0.
      adda1 = 0.
      adda2 = 0.
      if (dm(i) .eq. 0.) then
        ada4(4,i) = 0.
        ada4(1,i) = ada4(1,i)+ada4(3,i)
        ada4(3,i) = 0.
        ada4(1,i) = ada4(1,i)+ada4(2,i)
        ada4(2,i) = 0.
      else
        da1 = a4(3,i)-a4(2,i)
        da2 = da1**2
        a6da = a4(4,i)*da1
        if (a6da .lt. (-da2)) then
          ada4(4,i) = ada4(4,i)-ada4(3,i)
          ada4(2,i) = ada4(2,i)+ada4(3,i)
          ada4(3,i) = 0.
          ada4(2,i) = ada4(2,i)+3*ada4(4,i)
          ada4(1,i) = ada4(1,i)-3*ada4(4,i)
          ada4(4,i) = 0.
        else if (a6da .gt. da2) then
          ada4(4,i) = ada4(4,i)-ada4(2,i)
          ada4(3,i) = ada4(3,i)+ada4(2,i)
          ada4(2,i) = 0.
          ada4(3,i) = ada4(3,i)+3*ada4(4,i)
          ada4(1,i) = ada4(1,i)-3*ada4(4,i)
          ada4(4,i) = 0.
        endif
        ada4(4,i) = ada4(4,i)+ada6da*da1
        adda1 = adda1+ada6da*a4(4,i)
        ada6da = 0.
        adda1 = adda1+2*adda2*da1
        adda2 = 0.
        ada4(3,i) = ada4(3,i)+adda1
        ada4(2,i) = ada4(2,i)-adda1
        adda1 = 0.
      endif
    end do
  else if (lmt .eq. 1) then
    do i = 1, itot
      adqmp = 0.
      qmp = 2.*dm(i)
      a4(2,i) = a4(1,i)-sign(min(abs(qmp),abs(a4(2,i)-a4(1,i))),qmp)
      ada4(3,i) = ada4(3,i)-3*ada4(4,i)
      ada4(2,i) = ada4(2,i)-3*ada4(4,i)
      ada4(1,i) = ada4(1,i)+6*ada4(4,i)
      ada4(4,i) = 0.
      a4i = a4(3,i)-a4(1,i)
      ada4(1,i) = ada4(1,i)+ada4(3,i)
      ada4h = ada4(3,i)*sign(1.,min(abs(qmp),abs(a4i)))*sign(1.,qmp)
      ada4i = ada4h*(0.5-sign(0.5,abs(a4i)-abs(qmp)))*sign(1.,a4i)
      adqmp = adqmp+ada4h*(0.5+sign(0.5,abs(a4i)-abs(qmp)))*sign(1.,qmp)
      ada4(1,i) = ada4(1,i)-ada4i
      ada4(3,i) = ada4i
      a4(:,:) = a4h(:,:)
      a4j = a4(2,i)-a4(1,i)
      ada4(1,i) = ada4(1,i)+ada4(2,i)
      ada4j = -(ada4(2,i)*sign(1.,min(abs(qmp),abs(a4j)))*sign(1.,qmp))
      ada4k = ada4j*(0.5-sign(0.5,abs(a4j)-abs(qmp)))*sign(1.,a4j)
      adqmp = adqmp+ada4j*(0.5+sign(0.5,abs(a4j)-abs(qmp)))*sign(1.,qmp)
      ada4(1,i) = ada4(1,i)-ada4k
      ada4(2,i) = ada4k
      addm(i) = addm(i)+2*adqmp
      adqmp = 0.
    end do
  else if (lmt .eq. 2) then
    do i = 1, itot
      adfmin = 0.
      if (abs(a4(3,i)-a4(2,i)) .lt. (-a4(4,i))) then
        fmin = a4(1,i)+0.25*(a4(3,i)-a4(2,i))**2/a4(4,i)+a4(4,i)*r12
        if (fmin .lt. 0.) then
          if (a4(1,i) .lt. a4(3,i) .and. a4(1,i) .lt. a4(2,i)) then
            ada4(4,i) = 0.
            ada4(1,i) = ada4(1,i)+ada4(2,i)
            ada4(2,i) = 0.
            ada4(1,i) = ada4(1,i)+ada4(3,i)
            ada4(3,i) = 0.
          else if (a4(3,i) .gt. a4(2,i)) then
            ada4(4,i) = ada4(4,i)-ada4(3,i)
            ada4(2,i) = ada4(2,i)+ada4(3,i)
            ada4(3,i) = 0.
            ada4(2,i) = ada4(2,i)+3*ada4(4,i)
            ada4(1,i) = ada4(1,i)-3*ada4(4,i)
            ada4(4,i) = 0.
          else
            ada4(4,i) = ada4(4,i)-ada4(2,i)
            ada4(3,i) = ada4(3,i)+ada4(2,i)
            ada4(2,i) = 0.
            ada4(3,i) = ada4(3,i)+3*ada4(4,i)
            ada4(1,i) = ada4(1,i)-3*ada4(4,i)
            ada4(4,i) = 0.
          endif
        endif
        ada4(4,i) = ada4(4,i)+adfmin*((-(0.25*(a4(3,i)-a4(2,i))**2/(a4(4,i)*a4(4,i))))+r12)
        ada4(3,i) = ada4(3,i)+adfmin*(0.5*(a4(3,i)-a4(2,i))/a4(4,i))
        ada4(2,i) = ada4(2,i)+adfmin*((-0.5)*(a4(3,i)-a4(2,i))/a4(4,i))
        ada4(1,i) = ada4(1,i)+adfmin
        adfmin = 0.
      endif
    end do
  endif
endif

!----------------------------------------------
! FREE DYNAMIC MEMORY
!----------------------------------------------

end subroutine adppm_limiters


subroutine adppm_profile( a4, ada4, delp, addelp, km, i1, i2, iv, kord )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: km
real, intent(inout) :: a4(4,i1:i2,km)
real, intent(inout) :: ada4(4,i1:i2,km)
real, intent(inout) :: addelp(i1:i2,km)
real, intent(in) :: delp(i1:i2,km)
integer, intent(in) :: iv
integer, intent(in) :: kord

!==============================================
! declare local variables
!==============================================
real :: a1
real :: a2
real :: a4h(lbound(a4,1):ubound(a4,1),lbound(a4,2):ubound(a4,2),lbound(a4,3):ubound(a4,3))
real :: a4i
real :: a4j
real :: a4k
real :: a4l
real :: a4m
real :: a4n
real :: a4o
real :: a4p
real :: a4q
real :: a4r
real :: a4s(lbound(a4,1):ubound(a4,1),lbound(a4,2):ubound(a4,2),lbound(a4,3):ubound(a4,3))
real :: a4t
real :: a4u
real :: a4v
real :: a4w
real :: ada1
real :: ada2
real :: ada4i
real :: ada4j
real :: ada4k
real :: ada4l
real :: ada4m
real :: ada4n
real :: ada4o
real :: ada4p
real :: ada4q
real :: ada4r
real :: ada4t
real :: ada4u
real :: ada4v
real :: ada4w
real :: adc1
real :: adc2
real :: adc3
real :: add1
real :: add2
real :: add4(i1:i2,km)
real :: addc(i1:i2,km)
real :: addch
real :: addci
real :: addck
real :: addcl
real :: addcm
real :: addcn
real :: addco
real :: addcp
real :: addelq(i1:i2,km)
real :: addf2(i1:i2,km)
real :: addq
real :: addqh
real :: addqi
real :: addqj
real :: addqk
real :: addql
real :: adh2(i1:i2,km)
real :: adlac
real :: adpmp
real :: adqm
real :: adqmp
real :: c1
real :: c2
real :: c3
real :: d1
real :: d2
real :: d4(i1:i2,km)
real :: dc(i1:i2,km)
real :: dch
real :: dci
real :: dck
real :: dcl
real :: dcn
real :: dco
real :: delq(i1:i2,km)
real :: df2(i1:i2,km)
real :: dq
real :: dqh
real :: dqi
real :: dqj
real :: dqk
real :: fac
real :: h2(i1:i2,km)
integer :: i
integer :: ib2
integer :: ib4
integer :: ib5
integer :: ib6
integer :: ib7
integer :: ib8
integer :: ib9
integer :: ib9a
integer :: it
integer :: k
integer :: k1
integer :: k2
integer :: k3
integer :: k4
integer :: ka1
integer :: ka2
integer :: ka3
integer :: ka4
integer :: km1
real :: lac
integer :: lmt
real :: pmp
real :: qm
real :: qmp

!----------------------------------------------
! SAVE REQUIRED INPUT VARIABLES
!----------------------------------------------
a4h(:,:,:) = a4(:,:,:)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
ada1 = 0.
ada2 = 0.
adc1 = 0.
adc2 = 0.
adc3 = 0.
add1 = 0.
add2 = 0.
add4(:,:) = 0.
addc(:,:) = 0.
addelq(:,:) = 0.
addf2(:,:) = 0.
addq = 0.
adh2(:,:) = 0.
adlac = 0.
adpmp = 0.
adqm = 0.
adqmp = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
km1 = km-1
it = i2-i1+1
do k = 2, km
  do i = i1, i2
    delq(i,k-1) = a4(1,i,k)-a4(1,i,k-1)
    d4(i,k) = delp(i,k-1)+delp(i,k)
  end do
end do
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i1, i2
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
  dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,1) = max(0.,a4(2,i,1))
    a4(2,i,2) = max(0.,a4(2,i,2))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
  end do
endif
do i = i1, i2
  d1 = delp(i,km)
  d2 = delp(i,km1)
  qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
  dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
  c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
  a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
  a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
  a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
  dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
end do
if (bot_mono_kim) then
  do i = i1, i2
    a4(4,i,km) = 0
    if (a4(3,i,km)*a4(1,i,km) .le. 0.) then
      a4(3,i,km) = 0.
    endif
    d1 = a4(1,i,km)-a4(2,i,km)
    d2 = a4(3,i,km)-a4(1,i,km)
    if (d1*d2 .lt. 0.) then
      a4(2,i,km) = a4(1,i,km)
      a4(3,i,km) = a4(1,i,km)
    else
      dq = sign(min(abs(d1),abs(d2),0.5*abs(delq(i,km-1))),d1)
      a4(2,i,km) = a4(1,i,km)-dq
      a4(3,i,km) = a4(1,i,km)+dq
    endif
  end do
else
  if (iv .eq. 0) then
    do i = i1, i2
      a4(2,i,km) = max(0.,a4(2,i,km))
      a4(3,i,km) = max(0.,a4(3,i,km))
    end do
  else if (iv .eq. (-1)) then
    do i = i1, i2
      if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
        a4(3,i,km) = 0.
      endif
    end do
  endif
endif
do k = 1, km1
  do i = i1, i2
    a4(3,i,k) = a4(2,i,k+1)
  end do
end do
do k = 1, 2
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call ppm_limiters( dc(i1,k),a4(1,i1,k),it,0 )
end do
if (kord .ge. 7) then
  do k = 2, km1
    do i = i1, i2
      h2(i,k) = 2.*(dc(i,k+1)/delp(i,k+1)-dc(i,k-1)/delp(i,k-1))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*delp(i,k)**2
    end do
  end do
  fac = 1.5
  do k = 3, km-2
    do i = i1, i2
      pmp = 2.*dc(i,k)
      qmp = a4(1,i,k)+pmp
      lac = a4(1,i,k)+fac*h2(i,k-1)+dc(i,k)
      a4(3,i,k) = min(max(a4(3,i,k),min(a4(1,i,k),qmp,lac)),max(a4(1,i,k),qmp,lac))
      qmp = a4(1,i,k)-pmp
      lac = a4(1,i,k)+fac*h2(i,k+1)-dc(i,k)
      a4(2,i,k) = min(max(a4(2,i,k),min(a4(1,i,k),qmp,lac)),max(a4(1,i,k),qmp,lac))
      a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
    end do
    if (iv .eq. 0 .and. kord .ge. 6) then
      call ppm_limiters( dc(i1,k),a4(1,i1,k),it,2 )
    endif
  end do
else
  lmt = kord-3
  lmt = max(0,lmt)
  if (iv .eq. 0) then
    lmt = min(2,lmt)
  endif
  do k = 3, km-2
    if (kord .ne. 4) then
      do i = i1, i2
        a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
      end do
    endif
    if (kord .ne. 6) then
      call ppm_limiters( dc(i1,k),a4(1,i1,k),it,lmt )
    endif
  end do
endif
do k = km, km1, -1
  a4(:,:,:) = a4h(:,:,:)
  do ka1 = 2, km1
    do i = i1, i2
      c1 = (delp(i,ka1-1)+0.5*delp(i,ka1))/d4(i,ka1+1)
      c2 = (delp(i,ka1+1)+0.5*delp(i,ka1))/d4(i,ka1)
      df2(i,ka1) = delp(i,ka1)*(c1*delq(i,ka1)+c2*delq(i,ka1-1))/(d4(i,ka1)+delp(i,ka1+1))
      dc(i,ka1) = sign(min(abs(df2(i,ka1)),max(a4(1,i,ka1-1),a4(1,i,ka1),a4(1,i,ka1+1))-a4(1,i,ka1),a4(1,i,ka1)-min(a4(1,i,ka1-1),&
&a4(1,i,ka1),a4(1,i,ka1+1))),df2(i,ka1))
    end do
  end do
  do ka1 = 3, km1
    do i = i1, i2
      c1 = delq(i,ka1-1)*delp(i,ka1-1)/d4(i,ka1)
      a1 = d4(i,ka1-1)/(d4(i,ka1)+delp(i,ka1-1))
      a2 = d4(i,ka1+1)/(d4(i,ka1)+delp(i,ka1))
      a4(2,i,ka1) = a4(1,i,ka1-1)+c1+2./(d4(i,ka1-1)+d4(i,ka1+1))*(delp(i,ka1)*(c1*(a1-a2)+a2*dc(i,ka1-1))-delp(i,ka1-1)*a1*dc(i,&
&ka1))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  do i = i1, i2
    d1 = delp(i,1)
    d2 = delp(i,2)
    qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
    dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
    c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
    a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
    a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
    a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
    dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
  end do
  if (iv .eq. 0) then
    do i = i1, i2
      a4(2,i,1) = max(0.,a4(2,i,1))
      a4(2,i,2) = max(0.,a4(2,i,2))
    end do
  else if (iv .eq. (-1)) then
    do i = i1, i2
      if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
        a4(2,i,1) = 0.
      endif
    end do
  endif
  do i = i1, i2
    d1 = delp(i,km)
    d2 = delp(i,km1)
    qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
    dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
    c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
    a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
    a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
    a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
    dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
  end do
  if (bot_mono_kim) then
    do i = i1, i2
      a4(4,i,km) = 0
      if (a4(3,i,km)*a4(1,i,km) .le. 0.) then
        a4(3,i,km) = 0.
      endif
      d1 = a4(1,i,km)-a4(2,i,km)
      d2 = a4(3,i,km)-a4(1,i,km)
      if (d1*d2 .lt. 0.) then
        a4(2,i,km) = a4(1,i,km)
        a4(3,i,km) = a4(1,i,km)
      else
        dq = sign(min(abs(d1),abs(d2),0.5*abs(delq(i,km-1))),d1)
        a4(2,i,km) = a4(1,i,km)-dq
        a4(3,i,km) = a4(1,i,km)+dq
      endif
    end do
  else
    if (iv .eq. 0) then
      do i = i1, i2
        a4(2,i,km) = max(0.,a4(2,i,km))
        a4(3,i,km) = max(0.,a4(3,i,km))
      end do
    else if (iv .eq. (-1)) then
      do i = i1, i2
        if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
          a4(3,i,km) = 0.
        endif
      end do
    endif
  endif
  do ka1 = 1, km1
    do i = i1, i2
      a4(3,i,ka1) = a4(2,i,ka1+1)
    end do
  end do
  do ka1 = 1, 2
    do i = i1, i2
      a4(4,i,ka1) = 3.*(2.*a4(1,i,ka1)-(a4(2,i,ka1)+a4(3,i,ka1)))
    end do
    call ppm_limiters( dc(i1,ka1),a4(1,i1,ka1),it,0 )
  end do
  if (kord .ge. 7) then
    do ka1 = 2, km1
      do i = i1, i2
        h2(i,ka1) = 2.*(dc(i,ka1+1)/delp(i,ka1+1)-dc(i,ka1-1)/delp(i,ka1-1))/(delp(i,ka1)+0.5*(delp(i,ka1-1)+delp(i,ka1+1)))*&
&delp(i,ka1)**2
      end do
    end do
    fac = 1.5
    do ka1 = 3, km-2
      do i = i1, i2
        pmp = 2.*dc(i,ka1)
        qmp = a4(1,i,ka1)+pmp
        lac = a4(1,i,ka1)+fac*h2(i,ka1-1)+dc(i,ka1)
        a4(3,i,ka1) = min(max(a4(3,i,ka1),min(a4(1,i,ka1),qmp,lac)),max(a4(1,i,ka1),qmp,lac))
        qmp = a4(1,i,ka1)-pmp
        lac = a4(1,i,ka1)+fac*h2(i,ka1+1)-dc(i,ka1)
        a4(2,i,ka1) = min(max(a4(2,i,ka1),min(a4(1,i,ka1),qmp,lac)),max(a4(1,i,ka1),qmp,lac))
        a4(4,i,ka1) = 3.*(2.*a4(1,i,ka1)-(a4(2,i,ka1)+a4(3,i,ka1)))
      end do
      if (iv .eq. 0 .and. kord .ge. 6) then
        call ppm_limiters( dc(i1,ka1),a4(1,i1,ka1),it,2 )
      endif
    end do
  else
    lmt = kord-3
    lmt = max(0,lmt)
    if (iv .eq. 0) then
      lmt = min(2,lmt)
    endif
    do ka1 = 3, km-2
      if (kord .ne. 4) then
        do i = i1, i2
          a4(4,i,ka1) = 3.*(2.*a4(1,i,ka1)-(a4(2,i,ka1)+a4(3,i,ka1)))
        end do
      endif
      if (kord .ne. 6) then
        call ppm_limiters( dc(i1,ka1),a4(1,i1,ka1),it,lmt )
      endif
    end do
  endif
  do k1 = km1, k-1
    do i = i1, i2
      a4(4,i,k1) = 3.*(2.*a4(1,i,k1)-(a4(2,i,k1)+a4(3,i,k1)))
    end do
    call ppm_limiters( dc(i1,k1),a4(1,i1,k1),it,0 )
  end do
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call adppm_limiters( dc(i1,k),addc(i1,k),a4(1,i1,k),ada4(1,i1,k),it,0 )
  do i = i1, i2
    ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
    ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
    ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
    ada4(4,i,k) = 0.
  end do
end do
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i1, i2
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
  dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,1) = max(0.,a4(2,i,1))
    a4(2,i,2) = max(0.,a4(2,i,2))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
  end do
endif
do i = i1, i2
  d1 = delp(i,km)
  d2 = delp(i,km1)
  qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
  dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
  c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
  a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
  a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
  a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
  dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
end do
if (bot_mono_kim) then
  do i = i1, i2
    a4(4,i,km) = 0
    if (a4(3,i,km)*a4(1,i,km) .le. 0.) then
      a4(3,i,km) = 0.
    endif
    d1 = a4(1,i,km)-a4(2,i,km)
    d2 = a4(3,i,km)-a4(1,i,km)
    if (d1*d2 .lt. 0.) then
      a4(2,i,km) = a4(1,i,km)
      a4(3,i,km) = a4(1,i,km)
    else
      dq = sign(min(abs(d1),abs(d2),0.5*abs(delq(i,km-1))),d1)
      a4(2,i,km) = a4(1,i,km)-dq
      a4(3,i,km) = a4(1,i,km)+dq
    endif
  end do
else
  if (iv .eq. 0) then
    do i = i1, i2
      a4(2,i,km) = max(0.,a4(2,i,km))
      a4(3,i,km) = max(0.,a4(3,i,km))
    end do
  else if (iv .eq. (-1)) then
    do i = i1, i2
      if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
        a4(3,i,km) = 0.
      endif
    end do
  endif
endif
do k = 1, km1
  do i = i1, i2
    a4(3,i,k) = a4(2,i,k+1)
  end do
end do
do k = 1, 2
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call ppm_limiters( dc(i1,k),a4(1,i1,k),it,0 )
end do
if (kord .ge. 7) then
  do k = 2, km1
    do i = i1, i2
      h2(i,k) = 2.*(dc(i,k+1)/delp(i,k+1)-dc(i,k-1)/delp(i,k-1))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*delp(i,k)**2
    end do
  end do
  fac = 1.5
  do k = km-2, 3, -1
    a4(:,:,:) = a4h(:,:,:)
    do ka3 = 2, km1
      do i = i1, i2
        c1 = (delp(i,ka3-1)+0.5*delp(i,ka3))/d4(i,ka3+1)
        c2 = (delp(i,ka3+1)+0.5*delp(i,ka3))/d4(i,ka3)
        df2(i,ka3) = delp(i,ka3)*(c1*delq(i,ka3)+c2*delq(i,ka3-1))/(d4(i,ka3)+delp(i,ka3+1))
        dc(i,ka3) = sign(min(abs(df2(i,ka3)),max(a4(1,i,ka3-1),a4(1,i,ka3),a4(1,i,ka3+1))-a4(1,i,ka3),a4(1,i,ka3)-min(a4(1,i,ka3-1)&
&,a4(1,i,ka3),a4(1,i,ka3+1))),df2(i,ka3))
      end do
    end do
    do ka3 = 3, km1
      do i = i1, i2
        c1 = delq(i,ka3-1)*delp(i,ka3-1)/d4(i,ka3)
        a1 = d4(i,ka3-1)/(d4(i,ka3)+delp(i,ka3-1))
        a2 = d4(i,ka3+1)/(d4(i,ka3)+delp(i,ka3))
        a4(2,i,ka3) = a4(1,i,ka3-1)+c1+2./(d4(i,ka3-1)+d4(i,ka3+1))*(delp(i,ka3)*(c1*(a1-a2)+a2*dc(i,ka3-1))-delp(i,ka3-1)*a1*dc(i,&
&ka3))
      end do
    end do
    if (km .gt. 8 .and. kord .gt. 3) then
      call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
    endif
    do i = i1, i2
      d1 = delp(i,1)
      d2 = delp(i,2)
      qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
      dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
      c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
      c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
      a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
      a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
      a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
      a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
      dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
    end do
    if (iv .eq. 0) then
      do i = i1, i2
        a4(2,i,1) = max(0.,a4(2,i,1))
        a4(2,i,2) = max(0.,a4(2,i,2))
      end do
    else if (iv .eq. (-1)) then
      do i = i1, i2
        if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
          a4(2,i,1) = 0.
        endif
      end do
    endif
    do i = i1, i2
      d1 = delp(i,km)
      d2 = delp(i,km1)
      qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
      dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
      c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
      c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
      a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
      a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
      a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
      a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
      dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
    end do
    if (bot_mono_kim) then
      do i = i1, i2
        a4(4,i,km) = 0
        if (a4(3,i,km)*a4(1,i,km) .le. 0.) then
          a4(3,i,km) = 0.
        endif
        d1 = a4(1,i,km)-a4(2,i,km)
        d2 = a4(3,i,km)-a4(1,i,km)
        if (d1*d2 .lt. 0.) then
          a4(2,i,km) = a4(1,i,km)
          a4(3,i,km) = a4(1,i,km)
        else
          dq = sign(min(abs(d1),abs(d2),0.5*abs(delq(i,km-1))),d1)
          a4(2,i,km) = a4(1,i,km)-dq
          a4(3,i,km) = a4(1,i,km)+dq
        endif
      end do
    else
      if (iv .eq. 0) then
        do i = i1, i2
          a4(2,i,km) = max(0.,a4(2,i,km))
          a4(3,i,km) = max(0.,a4(3,i,km))
        end do
      else if (iv .eq. (-1)) then
        do i = i1, i2
          if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
            a4(3,i,km) = 0.
          endif
        end do
      endif
    endif
    do ka3 = 1, km1
      do i = i1, i2
        a4(3,i,ka3) = a4(2,i,ka3+1)
      end do
    end do
    do ka3 = 1, 2
      do i = i1, i2
        a4(4,i,ka3) = 3.*(2.*a4(1,i,ka3)-(a4(2,i,ka3)+a4(3,i,ka3)))
      end do
      call ppm_limiters( dc(i1,ka3),a4(1,i1,ka3),it,0 )
    end do
    do k3 = 3, k-1
      do i = i1, i2
        pmp = 2.*dc(i,k3)
        qmp = a4(1,i,k3)+pmp
        lac = a4(1,i,k3)+fac*h2(i,k3-1)+dc(i,k3)
        a4(3,i,k3) = min(max(a4(3,i,k3),min(a4(1,i,k3),qmp,lac)),max(a4(1,i,k3),qmp,lac))
        qmp = a4(1,i,k3)-pmp
        lac = a4(1,i,k3)+fac*h2(i,k3+1)-dc(i,k3)
        a4(2,i,k3) = min(max(a4(2,i,k3),min(a4(1,i,k3),qmp,lac)),max(a4(1,i,k3),qmp,lac))
        a4(4,i,k3) = 3.*(2.*a4(1,i,k3)-(a4(2,i,k3)+a4(3,i,k3)))
      end do
      if (iv .eq. 0 .and. kord .ge. 6) then
        call ppm_limiters( dc(i1,k3),a4(1,i1,k3),it,2 )
      endif
    end do
    a4s(:,:,:) = a4(:,:,:)
    do i = i1, i2
      pmp = 2.*dc(i,k)
      qmp = a4(1,i,k)+pmp
      lac = a4(1,i,k)+fac*h2(i,k-1)+dc(i,k)
      a4(3,i,k) = min(max(a4(3,i,k),min(a4(1,i,k),qmp,lac)),max(a4(1,i,k),qmp,lac))
      qmp = a4(1,i,k)-pmp
      lac = a4(1,i,k)+fac*h2(i,k+1)-dc(i,k)
      a4(2,i,k) = min(max(a4(2,i,k),min(a4(1,i,k),qmp,lac)),max(a4(1,i,k),qmp,lac))
      a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
    end do
    if (iv .eq. 0 .and. kord .ge. 6) then
      call adppm_limiters( dc(i1,k),addc(i1,k),a4(1,i1,k),ada4(1,i1,k),it,2 )
    endif
    a4(:,:,:) = a4s(:,:,:)
    do i = i1, i2
      adlac = 0.
      adpmp = 0.
      adqmp = 0.
      pmp = 2.*dc(i,k)
      qmp = a4(1,i,k)+pmp
      lac = a4(1,i,k)+fac*h2(i,k-1)+dc(i,k)
      a4(3,i,k) = min(max(a4(3,i,k),min(a4(1,i,k),qmp,lac)),max(a4(1,i,k),qmp,lac))
      qmp = a4(1,i,k)-pmp
      lac = a4(1,i,k)+fac*h2(i,k+1)-dc(i,k)
      ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
      ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
      ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
      ada4(4,i,k) = 0.
      a4j = min(a4(1,i,k),qmp)
      a4k = min(a4j,lac)
      a4i = max(a4(2,i,k),a4k)
      a4l = max(a4(1,i,k),qmp)
      a4m = max(a4l,lac)
      ada4i = ada4(2,i,k)*(0.5+sign(0.5,a4m-a4i))
      ada4m = ada4(2,i,k)*(0.5-sign(0.5,a4m-a4i))
      ada4l = ada4m*(0.5+sign(0.5,a4l-lac))
      adlac = adlac+ada4m*(0.5-sign(0.5,a4l-lac))
      ada4(1,i,k) = ada4(1,i,k)+ada4l*(0.5+sign(0.5,a4(1,i,k)-qmp))
      adqmp = adqmp+ada4l*(0.5-sign(0.5,a4(1,i,k)-qmp))
      ada4k = ada4i*(0.5-sign(0.5,a4(2,i,k)-a4k))
      ada4j = ada4k*(0.5+sign(0.5,lac-a4j))
      adlac = adlac+ada4k*(0.5-sign(0.5,lac-a4j))
      ada4(1,i,k) = ada4(1,i,k)+ada4j*(0.5+sign(0.5,qmp-a4(1,i,k)))
      adqmp = adqmp+ada4j*(0.5-sign(0.5,qmp-a4(1,i,k)))
      ada4(2,i,k) = ada4i*(0.5+sign(0.5,a4(2,i,k)-a4k))
      ada4(1,i,k) = ada4(1,i,k)+adlac
      addc(i,k) = addc(i,k)-adlac
      adh2(i,k+1) = adh2(i,k+1)+adlac*fac
      adlac = 0.
      ada4(1,i,k) = ada4(1,i,k)+adqmp
      adpmp = adpmp-adqmp
      adqmp = 0.
      a4(:,:,:) = a4s(:,:,:)
      qmp = a4(1,i,k)+pmp
      lac = a4(1,i,k)+fac*h2(i,k-1)+dc(i,k)
      a4o = min(a4(1,i,k),qmp)
      a4p = min(a4o,lac)
      a4n = max(a4(3,i,k),a4p)
      a4q = max(a4(1,i,k),qmp)
      a4r = max(a4q,lac)
      ada4n = ada4(3,i,k)*(0.5+sign(0.5,a4r-a4n))
      ada4r = ada4(3,i,k)*(0.5-sign(0.5,a4r-a4n))
      ada4q = ada4r*(0.5+sign(0.5,a4q-lac))
      adlac = adlac+ada4r*(0.5-sign(0.5,a4q-lac))
      ada4(1,i,k) = ada4(1,i,k)+ada4q*(0.5+sign(0.5,a4(1,i,k)-qmp))
      adqmp = adqmp+ada4q*(0.5-sign(0.5,a4(1,i,k)-qmp))
      ada4p = ada4n*(0.5-sign(0.5,a4(3,i,k)-a4p))
      ada4o = ada4p*(0.5+sign(0.5,lac-a4o))
      adlac = adlac+ada4p*(0.5-sign(0.5,lac-a4o))
      ada4(1,i,k) = ada4(1,i,k)+ada4o*(0.5+sign(0.5,qmp-a4(1,i,k)))
      adqmp = adqmp+ada4o*(0.5-sign(0.5,qmp-a4(1,i,k)))
      ada4(3,i,k) = ada4n*(0.5+sign(0.5,a4(3,i,k)-a4p))
      ada4(1,i,k) = ada4(1,i,k)+adlac
      addc(i,k) = addc(i,k)+adlac
      adh2(i,k-1) = adh2(i,k-1)+adlac*fac
      adlac = 0.
      ada4(1,i,k) = ada4(1,i,k)+adqmp
      adpmp = adpmp+adqmp
      adqmp = 0.
      addc(i,k) = addc(i,k)+2*adpmp
      adpmp = 0.
    end do
  end do
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do i = i1, i2
      c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
      c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
      df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
      dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,&
&k+1))),df2(i,k))
    end do
  end do
  do k = 3, km1
    do i = i1, i2
      c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
      a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
      a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
      a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  do i = i1, i2
    d1 = delp(i,1)
    d2 = delp(i,2)
    qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
    dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
    c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
    a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
    a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
    a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
    dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
  end do
  if (iv .eq. 0) then
    do i = i1, i2
      a4(2,i,1) = max(0.,a4(2,i,1))
      a4(2,i,2) = max(0.,a4(2,i,2))
    end do
  else if (iv .eq. (-1)) then
    do i = i1, i2
      if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
        a4(2,i,1) = 0.
      endif
    end do
  endif
  do i = i1, i2
    d1 = delp(i,km)
    d2 = delp(i,km1)
    qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
    dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
    c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
    a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
    a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
    a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
    dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
  end do
  if (bot_mono_kim) then
    do i = i1, i2
      a4(4,i,km) = 0
      if (a4(3,i,km)*a4(1,i,km) .le. 0.) then
        a4(3,i,km) = 0.
      endif
      d1 = a4(1,i,km)-a4(2,i,km)
      d2 = a4(3,i,km)-a4(1,i,km)
      if (d1*d2 .lt. 0.) then
        a4(2,i,km) = a4(1,i,km)
        a4(3,i,km) = a4(1,i,km)
      else
        dq = sign(min(abs(d1),abs(d2),0.5*abs(delq(i,km-1))),d1)
        a4(2,i,km) = a4(1,i,km)-dq
        a4(3,i,km) = a4(1,i,km)+dq
      endif
    end do
  else
    if (iv .eq. 0) then
      do i = i1, i2
        a4(2,i,km) = max(0.,a4(2,i,km))
        a4(3,i,km) = max(0.,a4(3,i,km))
      end do
    else if (iv .eq. (-1)) then
      do i = i1, i2
        if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
          a4(3,i,km) = 0.
        endif
      end do
    endif
  endif
  do k = 1, km1
    do i = i1, i2
      a4(3,i,k) = a4(2,i,k+1)
    end do
  end do
  do k = 1, 2
    do i = i1, i2
      a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
    end do
    call ppm_limiters( dc(i1,k),a4(1,i1,k),it,0 )
  end do
  do k = 2, km1
    do i = i1, i2
      addc(i,k-1) = addc(i,k-1)-adh2(i,k)*2.*(1/delp(i,k-1))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*delp(i,k)**2
      addc(i,k+1) = addc(i,k+1)+adh2(i,k)*2.*(1/delp(i,k+1))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*delp(i,k)**2
      addelp(i,k-1) = addelp(i,k-1)+adh2(i,k)*(2.*(dc(i,k-1)/(delp(i,k-1)*delp(i,k-1)))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))-&
&(dc(i,k+1)/delp(i,k+1)-dc(i,k-1)/delp(i,k-1))/((delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*(delp(i,k)+0.5*(delp(i,k-1)+delp(i,&
&k+1)))))*delp(i,k)**2
      addelp(i,k+1) = addelp(i,k+1)-adh2(i,k)*(2.*(dc(i,k+1)/(delp(i,k+1)*delp(i,k+1)))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))+&
&(dc(i,k+1)/delp(i,k+1)-dc(i,k-1)/delp(i,k-1))/((delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*(delp(i,k)+0.5*(delp(i,k-1)+delp(i,&
&k+1)))))*delp(i,k)**2
      addelp(i,k) = addelp(i,k)+adh2(i,k)*(2*2.*(dc(i,k+1)/delp(i,k+1)-dc(i,k-1)/delp(i,k-1))/(delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+&
&1)))*delp(i,k)-2*(dc(i,k+1)/delp(i,k+1)-dc(i,k-1)/delp(i,k-1))/((delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)))*(delp(i,k)+0.5*&
&(delp(i,k-1)+delp(i,k+1))))*delp(i,k)**2)
      adh2(i,k) = 0.
    end do
  end do
else
  lmt = kord-3
  lmt = max(0,lmt)
  if (iv .eq. 0) then
    lmt = min(2,lmt)
  endif
  do k = km-2, 3, -1
    a4(:,:,:) = a4h(:,:,:)
    do ka2 = 2, km1
      do i = i1, i2
        c1 = (delp(i,ka2-1)+0.5*delp(i,ka2))/d4(i,ka2+1)
        c2 = (delp(i,ka2+1)+0.5*delp(i,ka2))/d4(i,ka2)
        df2(i,ka2) = delp(i,ka2)*(c1*delq(i,ka2)+c2*delq(i,ka2-1))/(d4(i,ka2)+delp(i,ka2+1))
        dc(i,ka2) = sign(min(abs(df2(i,ka2)),max(a4(1,i,ka2-1),a4(1,i,ka2),a4(1,i,ka2+1))-a4(1,i,ka2),a4(1,i,ka2)-min(a4(1,i,ka2-1)&
&,a4(1,i,ka2),a4(1,i,ka2+1))),df2(i,ka2))
      end do
    end do
    do ka2 = 3, km1
      do i = i1, i2
        c1 = delq(i,ka2-1)*delp(i,ka2-1)/d4(i,ka2)
        a1 = d4(i,ka2-1)/(d4(i,ka2)+delp(i,ka2-1))
        a2 = d4(i,ka2+1)/(d4(i,ka2)+delp(i,ka2))
        a4(2,i,ka2) = a4(1,i,ka2-1)+c1+2./(d4(i,ka2-1)+d4(i,ka2+1))*(delp(i,ka2)*(c1*(a1-a2)+a2*dc(i,ka2-1))-delp(i,ka2-1)*a1*dc(i,&
&ka2))
      end do
    end do
    if (km .gt. 8 .and. kord .gt. 3) then
      call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
    endif
    do i = i1, i2
      d1 = delp(i,1)
      d2 = delp(i,2)
      qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
      dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
      c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
      c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
      a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
      a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
      a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
      a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
      dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
    end do
    if (iv .eq. 0) then
      do i = i1, i2
        a4(2,i,1) = max(0.,a4(2,i,1))
        a4(2,i,2) = max(0.,a4(2,i,2))
      end do
    else if (iv .eq. (-1)) then
      do i = i1, i2
        if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
          a4(2,i,1) = 0.
        endif
      end do
    endif
    do i = i1, i2
      d1 = delp(i,km)
      d2 = delp(i,km1)
      qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
      dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
      c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
      c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
      a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
      a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
      a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
      a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
      dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
    end do
    if (bot_mono_kim) then
      do i = i1, i2
        a4(4,i,km) = 0
        if (a4(3,i,km)*a4(1,i,km) .le. 0.) then
          a4(3,i,km) = 0.
        endif
        d1 = a4(1,i,km)-a4(2,i,km)
        d2 = a4(3,i,km)-a4(1,i,km)
        if (d1*d2 .lt. 0.) then
          a4(2,i,km) = a4(1,i,km)
          a4(3,i,km) = a4(1,i,km)
        else
          dq = sign(min(abs(d1),abs(d2),0.5*abs(delq(i,km-1))),d1)
          a4(2,i,km) = a4(1,i,km)-dq
          a4(3,i,km) = a4(1,i,km)+dq
        endif
      end do
    else
      if (iv .eq. 0) then
        do i = i1, i2
          a4(2,i,km) = max(0.,a4(2,i,km))
          a4(3,i,km) = max(0.,a4(3,i,km))
        end do
      else if (iv .eq. (-1)) then
        do i = i1, i2
          if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
            a4(3,i,km) = 0.
          endif
        end do
      endif
    endif
    do ka2 = 1, km1
      do i = i1, i2
        a4(3,i,ka2) = a4(2,i,ka2+1)
      end do
    end do
    do ka2 = 1, 2
      do i = i1, i2
        a4(4,i,ka2) = 3.*(2.*a4(1,i,ka2)-(a4(2,i,ka2)+a4(3,i,ka2)))
      end do
      call ppm_limiters( dc(i1,ka2),a4(1,i1,ka2),it,0 )
    end do
    do k2 = 3, k-1
      if (kord .ne. 4) then
        do i = i1, i2
          a4(4,i,k2) = 3.*(2.*a4(1,i,k2)-(a4(2,i,k2)+a4(3,i,k2)))
        end do
      endif
      if (kord .ne. 6) then
        call ppm_limiters( dc(i1,k2),a4(1,i1,k2),it,lmt )
      endif
    end do
    if (kord .ne. 4) then
      do i = i1, i2
        a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
      end do
    endif
    if (kord .ne. 6) then
      call adppm_limiters( dc(i1,k),addc(i1,k),a4(1,i1,k),ada4(1,i1,k),it,lmt )
    endif
    if (kord .ne. 4) then
      do i = i1, i2
        ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
        ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
        ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
        ada4(4,i,k) = 0.
      end do
    endif
  end do
endif
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i1, i2
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
  dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,1) = max(0.,a4(2,i,1))
    a4(2,i,2) = max(0.,a4(2,i,2))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
  end do
endif
do i = i1, i2
  d1 = delp(i,km)
  d2 = delp(i,km1)
  qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
  dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
  c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
  a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
  a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
  a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
  dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
end do
if (bot_mono_kim) then
  do i = i1, i2
    a4(4,i,km) = 0
    if (a4(3,i,km)*a4(1,i,km) .le. 0.) then
      a4(3,i,km) = 0.
    endif
    d1 = a4(1,i,km)-a4(2,i,km)
    d2 = a4(3,i,km)-a4(1,i,km)
    if (d1*d2 .lt. 0.) then
      a4(2,i,km) = a4(1,i,km)
      a4(3,i,km) = a4(1,i,km)
    else
      dq = sign(min(abs(d1),abs(d2),0.5*abs(delq(i,km-1))),d1)
      a4(2,i,km) = a4(1,i,km)-dq
      a4(3,i,km) = a4(1,i,km)+dq
    endif
  end do
else
  if (iv .eq. 0) then
    do i = i1, i2
      a4(2,i,km) = max(0.,a4(2,i,km))
      a4(3,i,km) = max(0.,a4(3,i,km))
    end do
  else if (iv .eq. (-1)) then
    do i = i1, i2
      if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
        a4(3,i,km) = 0.
      endif
    end do
  endif
endif
do k = 1, km1
  do i = i1, i2
    a4(3,i,k) = a4(2,i,k+1)
  end do
end do
do k = 2, 1, -1
  a4(:,:,:) = a4h(:,:,:)
  do ka4 = 2, km1
    do i = i1, i2
      c1 = (delp(i,ka4-1)+0.5*delp(i,ka4))/d4(i,ka4+1)
      c2 = (delp(i,ka4+1)+0.5*delp(i,ka4))/d4(i,ka4)
      df2(i,ka4) = delp(i,ka4)*(c1*delq(i,ka4)+c2*delq(i,ka4-1))/(d4(i,ka4)+delp(i,ka4+1))
      dc(i,ka4) = sign(min(abs(df2(i,ka4)),max(a4(1,i,ka4-1),a4(1,i,ka4),a4(1,i,ka4+1))-a4(1,i,ka4),a4(1,i,ka4)-min(a4(1,i,ka4-1),&
&a4(1,i,ka4),a4(1,i,ka4+1))),df2(i,ka4))
    end do
  end do
  do ka4 = 3, km1
    do i = i1, i2
      c1 = delq(i,ka4-1)*delp(i,ka4-1)/d4(i,ka4)
      a1 = d4(i,ka4-1)/(d4(i,ka4)+delp(i,ka4-1))
      a2 = d4(i,ka4+1)/(d4(i,ka4)+delp(i,ka4))
      a4(2,i,ka4) = a4(1,i,ka4-1)+c1+2./(d4(i,ka4-1)+d4(i,ka4+1))*(delp(i,ka4)*(c1*(a1-a2)+a2*dc(i,ka4-1))-delp(i,ka4-1)*a1*dc(i,&
&ka4))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  do i = i1, i2
    d1 = delp(i,1)
    d2 = delp(i,2)
    qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
    dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
    c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
    a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
    a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
    a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
    dc(i,1) = 0.5*(a4(2,i,2)-a4(1,i,1))
  end do
  if (iv .eq. 0) then
    do i = i1, i2
      a4(2,i,1) = max(0.,a4(2,i,1))
      a4(2,i,2) = max(0.,a4(2,i,2))
    end do
  else if (iv .eq. (-1)) then
    do i = i1, i2
      if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
        a4(2,i,1) = 0.
      endif
    end do
  endif
  do i = i1, i2
    d1 = delp(i,km)
    d2 = delp(i,km1)
    qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
    dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
    c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
    a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
    a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
    a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
    dc(i,km) = 0.5*(a4(1,i,km)-a4(2,i,km))
  end do
  if (bot_mono_kim) then
    do i = i1, i2
      a4(4,i,km) = 0
      if (a4(3,i,km)*a4(1,i,km) .le. 0.) then
        a4(3,i,km) = 0.
      endif
      d1 = a4(1,i,km)-a4(2,i,km)
      d2 = a4(3,i,km)-a4(1,i,km)
      if (d1*d2 .lt. 0.) then
        a4(2,i,km) = a4(1,i,km)
        a4(3,i,km) = a4(1,i,km)
      else
        dq = sign(min(abs(d1),abs(d2),0.5*abs(delq(i,km-1))),d1)
        a4(2,i,km) = a4(1,i,km)-dq
        a4(3,i,km) = a4(1,i,km)+dq
      endif
    end do
  else
    if (iv .eq. 0) then
      do i = i1, i2
        a4(2,i,km) = max(0.,a4(2,i,km))
        a4(3,i,km) = max(0.,a4(3,i,km))
      end do
    else if (iv .eq. (-1)) then
      do i = i1, i2
        if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
          a4(3,i,km) = 0.
        endif
      end do
    endif
  endif
  do ka4 = 1, km1
    do i = i1, i2
      a4(3,i,ka4) = a4(2,i,ka4+1)
    end do
  end do
  do k4 = 1, k-1
    do i = i1, i2
      a4(4,i,k4) = 3.*(2.*a4(1,i,k4)-(a4(2,i,k4)+a4(3,i,k4)))
    end do
    call ppm_limiters( dc(i1,k4),a4(1,i1,k4),it,0 )
  end do
  do i = i1, i2
    a4(4,i,k) = 3.*(2.*a4(1,i,k)-(a4(2,i,k)+a4(3,i,k)))
  end do
  call adppm_limiters( dc(i1,k),addc(i1,k),a4(1,i1,k),ada4(1,i1,k),it,0 )
  do i = i1, i2
    ada4(3,i,k) = ada4(3,i,k)-3*ada4(4,i,k)
    ada4(2,i,k) = ada4(2,i,k)-3*ada4(4,i,k)
    ada4(1,i,k) = ada4(1,i,k)+6*ada4(4,i,k)
    ada4(4,i,k) = 0.
  end do
end do
do k = 1, km1
  do i = i1, i2
    ada4(2,i,k+1) = ada4(2,i,k+1)+ada4(3,i,k)
    ada4(3,i,k) = 0.
  end do
end do
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i1, i2
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,1) = max(0.,a4(2,i,1))
    a4(2,i,2) = max(0.,a4(2,i,2))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
  end do
endif
do i = i1, i2
  d1 = delp(i,km)
  d2 = delp(i,km1)
  qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
  dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
  c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
  a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
  a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
  a4(2,i,km) = min(a4(2,i,km),max(a4(1,i,km),a4(1,i,km1)))
end do
if (bot_mono_kim) then
  do i = i1, i2
    add1 = 0.
    add2 = 0.
    addq = 0.
    a4(4,i,km) = 0
    if (a4(3,i,km)*a4(1,i,km) .le. 0.) then
      a4(3,i,km) = 0.
    endif
    d1 = a4(1,i,km)-a4(2,i,km)
    d2 = a4(3,i,km)-a4(1,i,km)
    if (d1*d2 .lt. 0.) then
      ada4(1,i,km) = ada4(1,i,km)+ada4(3,i,km)
      ada4(3,i,km) = 0.
      ada4(1,i,km) = ada4(1,i,km)+ada4(2,i,km)
      ada4(2,i,km) = 0.
    else
      ada4(1,i,km) = ada4(1,i,km)+ada4(3,i,km)
      addq = addq+ada4(3,i,km)
      ada4(3,i,km) = 0.
      ada4(1,i,km) = ada4(1,i,km)+ada4(2,i,km)
      addq = addq-ada4(2,i,km)
      ada4(2,i,km) = 0.
      dqh = abs(d1)
      dqi = abs(d2)
      dqj = 0.5*abs(delq(i,km-1))
      dqk = min(dqh,dqi)
      addql = addq*sign(1.,min(dqk,dqj))*sign(1.,d1)
      addqj = addql*(0.5-sign(0.5,dqj-dqk))
      addqk = addql*(0.5+sign(0.5,dqj-dqk))
      addqh = addqk*(0.5+sign(0.5,dqi-dqh))
      addqi = addqk*(0.5-sign(0.5,dqi-dqh))
      addelq(i,km-1) = addelq(i,km-1)+0.5*addqj*sign(1.,delq(i,km-1))
      add2 = add2+addqi*sign(1.,d2)
      add1 = add1+addqh*sign(1.,d1)
      addq = 0.
    endif
    ada4(3,i,km) = ada4(3,i,km)+add2
    ada4(1,i,km) = ada4(1,i,km)-add2
    add2 = 0.
    ada4(2,i,km) = ada4(2,i,km)-add1
    ada4(1,i,km) = ada4(1,i,km)+add1
    add1 = 0.
    a4(4,i,km) = 0
    if (a4(3,i,km)*a4(1,i,km) .le. 0.) then
      ada4(3,i,km) = 0.
    endif
    ada4(4,i,km) = 0.
  end do
else
  if (iv .eq. 0) then
    do i = i1, i2
      a4(2,i,km) = max(0.,a4(2,i,km))
      ada4(3,i,km) = ada4(3,i,km)*(0.5-sign(0.5,0.-a4(3,i,km)))
      a4(:,:,:) = a4h(:,:,:)
      do k = 2, km1
        do ib2 = i1, i2
          c1 = (delp(ib2,k-1)+0.5*delp(ib2,k))/d4(ib2,k+1)
          c2 = (delp(ib2,k+1)+0.5*delp(ib2,k))/d4(ib2,k)
          df2(ib2,k) = delp(ib2,k)*(c1*delq(ib2,k)+c2*delq(ib2,k-1))/(d4(ib2,k)+delp(ib2,k+1))
          dc(ib2,k) = sign(min(abs(df2(ib2,k)),max(a4(1,ib2,k-1),a4(1,ib2,k),a4(1,ib2,k+1))-a4(1,ib2,k),a4(1,ib2,k)-min(a4(1,ib2,k-&
&1),a4(1,ib2,k),a4(1,ib2,k+1))),df2(ib2,k))
        end do
      end do
      do k = 3, km1
        do ib2 = i1, i2
          c1 = delq(ib2,k-1)*delp(ib2,k-1)/d4(ib2,k)
          a1 = d4(ib2,k-1)/(d4(ib2,k)+delp(ib2,k-1))
          a2 = d4(ib2,k+1)/(d4(ib2,k)+delp(ib2,k))
          a4(2,ib2,k) = a4(1,ib2,k-1)+c1+2./(d4(ib2,k-1)+d4(ib2,k+1))*(delp(ib2,k)*(c1*(a1-a2)+a2*dc(ib2,k-1))-delp(ib2,k-1)*a1*&
&dc(ib2,k))
        end do
      end do
      if (km .gt. 8 .and. kord .gt. 3) then
        call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
      endif
      do ib2 = i1, i2
        d1 = delp(ib2,1)
        d2 = delp(ib2,2)
        qm = (d2*a4(1,ib2,1)+d1*a4(1,ib2,2))/(d1+d2)
        dq = 2.*(a4(1,ib2,2)-a4(1,ib2,1))/(d1+d2)
        c1 = 4.*(a4(2,ib2,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
        c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
        a4(2,ib2,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
        a4(2,ib2,1) = d1*(2.*c1*d1**2-c3)+a4(2,ib2,2)
        a4(2,ib2,2) = max(a4(2,ib2,2),min(a4(1,ib2,1),a4(1,ib2,2)))
        a4(2,ib2,2) = min(a4(2,ib2,2),max(a4(1,ib2,1),a4(1,ib2,2)))
        dc(ib2,1) = 0.5*(a4(2,ib2,2)-a4(1,ib2,1))
      end do
      if (iv .eq. 0) then
        do ib2 = i1, i2
          a4(2,ib2,1) = max(0.,a4(2,ib2,1))
          a4(2,ib2,2) = max(0.,a4(2,ib2,2))
        end do
      else if (iv .eq. (-1)) then
        do ib2 = i1, i2
          if (a4(2,ib2,1)*a4(1,ib2,1) .le. 0.) then
            a4(2,ib2,1) = 0.
          endif
        end do
      endif
      do ib2 = i1, i2
        d1 = delp(ib2,km)
        d2 = delp(ib2,km1)
        qm = (d2*a4(1,ib2,km)+d1*a4(1,ib2,km1))/(d1+d2)
        dq = 2.*(a4(1,ib2,km1)-a4(1,ib2,km))/(d1+d2)
        c1 = (a4(2,ib2,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
        c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
        a4(2,ib2,km) = qm-c1*d1*d2*(d2+3.*d1)
        a4(3,ib2,km) = d1*(8.*c1*d1**2-c3)+a4(2,ib2,km)
        a4(2,ib2,km) = max(a4(2,ib2,km),min(a4(1,ib2,km),a4(1,ib2,km1)))
        a4(2,ib2,km) = min(a4(2,ib2,km),max(a4(1,ib2,km),a4(1,ib2,km1)))
        dc(ib2,km) = 0.5*(a4(1,ib2,km)-a4(2,ib2,km))
      end do
      ada4(2,i,km) = ada4(2,i,km)*(0.5-sign(0.5,0.-a4(2,i,km)))
    end do
  else if (iv .eq. (-1)) then
    do i = i1, i2
      if (a4(1,i,km)*a4(3,i,km) .le. 0.) then
        ada4(3,i,km) = 0.
      endif
    end do
  endif
endif
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i1, i2
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,1) = max(0.,a4(2,i,1))
    a4(2,i,2) = max(0.,a4(2,i,2))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      a4(2,i,1) = 0.
    endif
  end do
endif
do i = i1, i2
  adc1 = 0.
  adc3 = 0.
  add1 = 0.
  add2 = 0.
  addq = 0.
  adqm = 0.
  d1 = delp(i,km)
  d2 = delp(i,km1)
  qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
  dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
  c1 = (a4(2,i,km1)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-2.*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
  a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
  a4(2,i,km) = max(a4(2,i,km),min(a4(1,i,km),a4(1,i,km1)))
  ada4(2,i,km) = ada4(2,i,km)-0.5*addc(i,km)
  ada4(1,i,km) = ada4(1,i,km)+0.5*addc(i,km)
  addc(i,km) = 0.
  a4t = max(a4(1,i,km),a4(1,i,km1))
  ada4t = ada4(2,i,km)*(0.5-sign(0.5,a4t-a4(2,i,km)))
  ada4(1,i,km) = ada4(1,i,km)+ada4t*(0.5+sign(0.5,a4(1,i,km)-a4(1,i,km1)))
  ada4(1,i,km1) = ada4(1,i,km1)+ada4t*(0.5-sign(0.5,a4(1,i,km)-a4(1,i,km1)))
  ada4(2,i,km) = ada4(2,i,km)*(0.5+sign(0.5,a4t-a4(2,i,km)))
  a4(2,i,km) = qm-c1*d1*d2*(d2+3.*d1)
  a4(3,i,km) = d1*(8.*c1*d1**2-c3)+a4(2,i,km)
  a4u = min(a4(1,i,km),a4(1,i,km1))
  ada4u = ada4(2,i,km)*(0.5-sign(0.5,a4(2,i,km)-a4u))
  ada4(1,i,km) = ada4(1,i,km)+ada4u*(0.5+sign(0.5,a4(1,i,km1)-a4(1,i,km)))
  ada4(1,i,km1) = ada4(1,i,km1)+ada4u*(0.5-sign(0.5,a4(1,i,km1)-a4(1,i,km)))
  ada4(2,i,km) = ada4(2,i,km)*(0.5+sign(0.5,a4(2,i,km)-a4u))
  ada4(2,i,km) = ada4(2,i,km)+ada4(3,i,km)
  adc1 = adc1+8*ada4(3,i,km)*d1*d1**2
  adc3 = adc3-ada4(3,i,km)*d1
  add1 = add1+ada4(3,i,km)*(2*8.*d1*c1*d1+8.*c1*d1**2-c3)
  ada4(3,i,km) = 0.
  adc1 = adc1-ada4(2,i,km)*d1*d2*(d2+3.*d1)
  add1 = add1-ada4(2,i,km)*(3*c1*d1*d2+c1*d2*(d2+3.*d1))
  add2 = add2-ada4(2,i,km)*c1*d1*(2*d2+3.*d1)
  adqm = adqm+ada4(2,i,km)
  ada4(2,i,km) = 0.
  adc1 = adc1-2*adc3*(d2*(5.*d1+d2)-3.*d1*d1)
  add1 = add1-2.*adc3*c1*(5*d2-6*d1)
  add2 = add2-2.*adc3*c1*(d2+5.*d1+d2)
  addq = addq+adc3
  adc3 = 0.
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do ib4 = i1, i2
      c1 = (delp(ib4,k-1)+0.5*delp(ib4,k))/d4(ib4,k+1)
      c2 = (delp(ib4,k+1)+0.5*delp(ib4,k))/d4(ib4,k)
      df2(ib4,k) = delp(ib4,k)*(c1*delq(ib4,k)+c2*delq(ib4,k-1))/(d4(ib4,k)+delp(ib4,k+1))
      dc(ib4,k) = sign(min(abs(df2(ib4,k)),max(a4(1,ib4,k-1),a4(1,ib4,k),a4(1,ib4,k+1))-a4(1,ib4,k),a4(1,ib4,k)-min(a4(1,ib4,k-1),&
&a4(1,ib4,k),a4(1,ib4,k+1))),df2(ib4,k))
    end do
  end do
  do k = 3, km1
    do ib4 = i1, i2
      c1 = delq(ib4,k-1)*delp(ib4,k-1)/d4(ib4,k)
      a1 = d4(ib4,k-1)/(d4(ib4,k)+delp(ib4,k-1))
      a2 = d4(ib4,k+1)/(d4(ib4,k)+delp(ib4,k))
      a4(2,ib4,k) = a4(1,ib4,k-1)+c1+2./(d4(ib4,k-1)+d4(ib4,k+1))*(delp(ib4,k)*(c1*(a1-a2)+a2*dc(ib4,k-1))-delp(ib4,k-1)*a1*dc(ib4,&
&k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  do ib4 = i1, i2
    d1 = delp(ib4,1)
    d2 = delp(ib4,2)
    qm = (d2*a4(1,ib4,1)+d1*a4(1,ib4,2))/(d1+d2)
    dq = 2.*(a4(1,ib4,2)-a4(1,ib4,1))/(d1+d2)
    c1 = 4.*(a4(2,ib4,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,ib4,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
    a4(2,ib4,1) = d1*(2.*c1*d1**2-c3)+a4(2,ib4,2)
    a4(2,ib4,2) = max(a4(2,ib4,2),min(a4(1,ib4,1),a4(1,ib4,2)))
    a4(2,ib4,2) = min(a4(2,ib4,2),max(a4(1,ib4,1),a4(1,ib4,2)))
    dc(ib4,1) = 0.5*(a4(2,ib4,2)-a4(1,ib4,1))
  end do
  if (iv .eq. 0) then
    do ib4 = i1, i2
      a4(2,ib4,1) = max(0.,a4(2,ib4,1))
      a4(2,ib4,2) = max(0.,a4(2,ib4,2))
    end do
  else if (iv .eq. (-1)) then
    do ib4 = i1, i2
      if (a4(2,ib4,1)*a4(1,ib4,1) .le. 0.) then
        a4(2,ib4,1) = 0.
      endif
    end do
  endif
  d1 = delp(i,km)
  d2 = delp(i,km1)
  qm = (d2*a4(1,i,km)+d1*a4(1,i,km1))/(d1+d2)
  dq = 2.*(a4(1,i,km1)-a4(1,i,km))/(d1+d2)
  ada4(2,i,km1) = ada4(2,i,km1)+adc1/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  add1 = add1-adc1*((a4(2,i,km1)-qm-d2*dq)*d2*(3*d1+d2+3.*d1)/(d2*(2.*d2*d2+d1*(d2+3.*d1))*d2*(2.*d2*d2+d1*(d2+3.*d1))))
  add2 = add2-adc1*(dq/(d2*(2.*d2*d2+d1*(d2+3.*d1)))+(a4(2,i,km1)-qm-d2*dq)*(d2*(4*d2+d1)+2.*d2*d2+d1*(d2+3.*d1))/(d2*(2.*d2*d2+d1*&
&(d2+3.*d1))*d2*(2.*d2*d2+d1*(d2+3.*d1))))
  addq = addq-adc1*(d2/(d2*(2.*d2*d2+d1*(d2+3.*d1))))
  adqm = adqm-adc1/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  adc1 = 0.
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do ib5 = i1, i2
      c1 = (delp(ib5,k-1)+0.5*delp(ib5,k))/d4(ib5,k+1)
      c2 = (delp(ib5,k+1)+0.5*delp(ib5,k))/d4(ib5,k)
      df2(ib5,k) = delp(ib5,k)*(c1*delq(ib5,k)+c2*delq(ib5,k-1))/(d4(ib5,k)+delp(ib5,k+1))
      dc(ib5,k) = sign(min(abs(df2(ib5,k)),max(a4(1,ib5,k-1),a4(1,ib5,k),a4(1,ib5,k+1))-a4(1,ib5,k),a4(1,ib5,k)-min(a4(1,ib5,k-1),&
&a4(1,ib5,k),a4(1,ib5,k+1))),df2(ib5,k))
    end do
  end do
  do k = 3, km1
    do ib5 = i1, i2
      c1 = delq(ib5,k-1)*delp(ib5,k-1)/d4(ib5,k)
      a1 = d4(ib5,k-1)/(d4(ib5,k)+delp(ib5,k-1))
      a2 = d4(ib5,k+1)/(d4(ib5,k)+delp(ib5,k))
      a4(2,ib5,k) = a4(1,ib5,k-1)+c1+2./(d4(ib5,k-1)+d4(ib5,k+1))*(delp(ib5,k)*(c1*(a1-a2)+a2*dc(ib5,k-1))-delp(ib5,k-1)*a1*dc(ib5,&
&k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  do ib5 = i1, i2
    d1 = delp(ib5,1)
    d2 = delp(ib5,2)
    qm = (d2*a4(1,ib5,1)+d1*a4(1,ib5,2))/(d1+d2)
    dq = 2.*(a4(1,ib5,2)-a4(1,ib5,1))/(d1+d2)
    c1 = 4.*(a4(2,ib5,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,ib5,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
    a4(2,ib5,1) = d1*(2.*c1*d1**2-c3)+a4(2,ib5,2)
    a4(2,ib5,2) = max(a4(2,ib5,2),min(a4(1,ib5,1),a4(1,ib5,2)))
    a4(2,ib5,2) = min(a4(2,ib5,2),max(a4(1,ib5,1),a4(1,ib5,2)))
    dc(ib5,1) = 0.5*(a4(2,ib5,2)-a4(1,ib5,1))
  end do
  if (iv .eq. 0) then
    do ib5 = i1, i2
      a4(2,ib5,1) = max(0.,a4(2,ib5,1))
      a4(2,ib5,2) = max(0.,a4(2,ib5,2))
    end do
  else if (iv .eq. (-1)) then
    do ib5 = i1, i2
      if (a4(2,ib5,1)*a4(1,ib5,1) .le. 0.) then
        a4(2,ib5,1) = 0.
      endif
    end do
  endif
  d1 = delp(i,km)
  d2 = delp(i,km1)
  ada4(1,i,km) = ada4(1,i,km)+addq*((-2)/(d1+d2))
  ada4(1,i,km1) = ada4(1,i,km1)+addq*(2/(d1+d2))
  add1 = add1-addq*(2*(a4(1,i,km1)-a4(1,i,km))/((d1+d2)*(d1+d2)))
  add2 = add2-addq*(2*(a4(1,i,km1)-a4(1,i,km))/((d1+d2)*(d1+d2)))
  addq = 0.
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do ib6 = i1, i2
      c1 = (delp(ib6,k-1)+0.5*delp(ib6,k))/d4(ib6,k+1)
      c2 = (delp(ib6,k+1)+0.5*delp(ib6,k))/d4(ib6,k)
      df2(ib6,k) = delp(ib6,k)*(c1*delq(ib6,k)+c2*delq(ib6,k-1))/(d4(ib6,k)+delp(ib6,k+1))
      dc(ib6,k) = sign(min(abs(df2(ib6,k)),max(a4(1,ib6,k-1),a4(1,ib6,k),a4(1,ib6,k+1))-a4(1,ib6,k),a4(1,ib6,k)-min(a4(1,ib6,k-1),&
&a4(1,ib6,k),a4(1,ib6,k+1))),df2(ib6,k))
    end do
  end do
  do k = 3, km1
    do ib6 = i1, i2
      c1 = delq(ib6,k-1)*delp(ib6,k-1)/d4(ib6,k)
      a1 = d4(ib6,k-1)/(d4(ib6,k)+delp(ib6,k-1))
      a2 = d4(ib6,k+1)/(d4(ib6,k)+delp(ib6,k))
      a4(2,ib6,k) = a4(1,ib6,k-1)+c1+2./(d4(ib6,k-1)+d4(ib6,k+1))*(delp(ib6,k)*(c1*(a1-a2)+a2*dc(ib6,k-1))-delp(ib6,k-1)*a1*dc(ib6,&
&k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  do ib6 = i1, i2
    d1 = delp(ib6,1)
    d2 = delp(ib6,2)
    qm = (d2*a4(1,ib6,1)+d1*a4(1,ib6,2))/(d1+d2)
    dq = 2.*(a4(1,ib6,2)-a4(1,ib6,1))/(d1+d2)
    c1 = 4.*(a4(2,ib6,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
    c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
    a4(2,ib6,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
    a4(2,ib6,1) = d1*(2.*c1*d1**2-c3)+a4(2,ib6,2)
    a4(2,ib6,2) = max(a4(2,ib6,2),min(a4(1,ib6,1),a4(1,ib6,2)))
    a4(2,ib6,2) = min(a4(2,ib6,2),max(a4(1,ib6,1),a4(1,ib6,2)))
    dc(ib6,1) = 0.5*(a4(2,ib6,2)-a4(1,ib6,1))
  end do
  if (iv .eq. 0) then
    do ib6 = i1, i2
      a4(2,ib6,1) = max(0.,a4(2,ib6,1))
      a4(2,ib6,2) = max(0.,a4(2,ib6,2))
    end do
  else if (iv .eq. (-1)) then
    do ib6 = i1, i2
      if (a4(2,ib6,1)*a4(1,ib6,1) .le. 0.) then
        a4(2,ib6,1) = 0.
      endif
    end do
  endif
  d1 = delp(i,km)
  d2 = delp(i,km1)
  ada4(1,i,km) = ada4(1,i,km)+adqm*(d2/(d1+d2))
  ada4(1,i,km1) = ada4(1,i,km1)+adqm*(d1/(d1+d2))
  add1 = add1+adqm*(a4(1,i,km1)/(d1+d2)-(d2*a4(1,i,km)+d1*a4(1,i,km1))/((d1+d2)*(d1+d2)))
  add2 = add2+adqm*(a4(1,i,km)/(d1+d2)-(d2*a4(1,i,km)+d1*a4(1,i,km1))/((d1+d2)*(d1+d2)))
  adqm = 0.
  addelp(i,km1) = addelp(i,km1)+add2
  add2 = 0.
  addelp(i,km) = addelp(i,km)+add1
  add1 = 0.
end do
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i1, i2
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  a4(2,i,2) = min(a4(2,i,2),max(a4(1,i,1),a4(1,i,2)))
end do
if (iv .eq. 0) then
  do i = i1, i2
    a4(2,i,1) = max(0.,a4(2,i,1))
    ada4(2,i,2) = ada4(2,i,2)*(0.5-sign(0.5,0.-a4(2,i,2)))
    a4(:,:,:) = a4h(:,:,:)
    do k = 2, km1
      do ib7 = i1, i2
        c1 = (delp(ib7,k-1)+0.5*delp(ib7,k))/d4(ib7,k+1)
        c2 = (delp(ib7,k+1)+0.5*delp(ib7,k))/d4(ib7,k)
        df2(ib7,k) = delp(ib7,k)*(c1*delq(ib7,k)+c2*delq(ib7,k-1))/(d4(ib7,k)+delp(ib7,k+1))
        dc(ib7,k) = sign(min(abs(df2(ib7,k)),max(a4(1,ib7,k-1),a4(1,ib7,k),a4(1,ib7,k+1))-a4(1,ib7,k),a4(1,ib7,k)-min(a4(1,ib7,k-1)&
&,a4(1,ib7,k),a4(1,ib7,k+1))),df2(ib7,k))
      end do
    end do
    do k = 3, km1
      do ib7 = i1, i2
        c1 = delq(ib7,k-1)*delp(ib7,k-1)/d4(ib7,k)
        a1 = d4(ib7,k-1)/(d4(ib7,k)+delp(ib7,k-1))
        a2 = d4(ib7,k+1)/(d4(ib7,k)+delp(ib7,k))
        a4(2,ib7,k) = a4(1,ib7,k-1)+c1+2./(d4(ib7,k-1)+d4(ib7,k+1))*(delp(ib7,k)*(c1*(a1-a2)+a2*dc(ib7,k-1))-delp(ib7,k-1)*a1*&
&dc(ib7,k))
      end do
    end do
    if (km .gt. 8 .and. kord .gt. 3) then
      call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
    endif
    do ib7 = i1, i2
      d1 = delp(ib7,1)
      d2 = delp(ib7,2)
      qm = (d2*a4(1,ib7,1)+d1*a4(1,ib7,2))/(d1+d2)
      dq = 2.*(a4(1,ib7,2)-a4(1,ib7,1))/(d1+d2)
      c1 = 4.*(a4(2,ib7,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
      c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
      a4(2,ib7,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
      a4(2,ib7,1) = d1*(2.*c1*d1**2-c3)+a4(2,ib7,2)
      a4(2,ib7,2) = max(a4(2,ib7,2),min(a4(1,ib7,1),a4(1,ib7,2)))
      a4(2,ib7,2) = min(a4(2,ib7,2),max(a4(1,ib7,1),a4(1,ib7,2)))
      dc(ib7,1) = 0.5*(a4(2,ib7,2)-a4(1,ib7,1))
    end do
    ada4(2,i,1) = ada4(2,i,1)*(0.5-sign(0.5,0.-a4(2,i,1)))
  end do
else if (iv .eq. (-1)) then
  do i = i1, i2
    if (a4(2,i,1)*a4(1,i,1) .le. 0.) then
      ada4(2,i,1) = 0.
    endif
  end do
endif
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
endif
do i = i1, i2
  adc1 = 0.
  adc3 = 0.
  add1 = 0.
  add2 = 0.
  addq = 0.
  adqm = 0.
  d1 = delp(i,1)
  d2 = delp(i,2)
  qm = (d2*a4(1,i,1)+d1*a4(1,i,2))/(d1+d2)
  dq = 2.*(a4(1,i,2)-a4(1,i,1))/(d1+d2)
  c1 = 4.*(a4(2,i,3)-qm-d2*dq)/(d2*(2.*d2*d2+d1*(d2+3.*d1)))
  c3 = dq-0.5*c1*(d2*(5.*d1+d2)-3.*d1*d1)
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4(2,i,2) = max(a4(2,i,2),min(a4(1,i,1),a4(1,i,2)))
  ada4(2,i,2) = ada4(2,i,2)+0.5*addc(i,1)
  ada4(1,i,1) = ada4(1,i,1)-0.5*addc(i,1)
  addc(i,1) = 0.
  a4v = max(a4(1,i,1),a4(1,i,2))
  ada4v = ada4(2,i,2)*(0.5-sign(0.5,a4v-a4(2,i,2)))
  ada4(1,i,2) = ada4(1,i,2)+ada4v*(0.5-sign(0.5,a4(1,i,1)-a4(1,i,2)))
  ada4(1,i,1) = ada4(1,i,1)+ada4v*(0.5+sign(0.5,a4(1,i,1)-a4(1,i,2)))
  ada4(2,i,2) = ada4(2,i,2)*(0.5+sign(0.5,a4v-a4(2,i,2)))
  a4(2,i,2) = qm-0.25*c1*d1*d2*(d2+3.*d1)
  a4(2,i,1) = d1*(2.*c1*d1**2-c3)+a4(2,i,2)
  a4w = min(a4(1,i,1),a4(1,i,2))
  ada4w = ada4(2,i,2)*(0.5-sign(0.5,a4(2,i,2)-a4w))
  ada4(1,i,2) = ada4(1,i,2)+ada4w*(0.5-sign(0.5,a4(1,i,2)-a4(1,i,1)))
  ada4(1,i,1) = ada4(1,i,1)+ada4w*(0.5+sign(0.5,a4(1,i,2)-a4(1,i,1)))
  ada4(2,i,2) = ada4(2,i,2)*(0.5+sign(0.5,a4(2,i,2)-a4w))
  ada4(2,i,2) = ada4(2,i,2)+ada4(2,i,1)
  adc1 = adc1+2*ada4(2,i,1)*d1*d1**2
  adc3 = adc3-ada4(2,i,1)*d1
  add1 = add1+ada4(2,i,1)*(2*2.*d1*c1*d1+2.*c1*d1**2-c3)
  ada4(2,i,1) = 0.
  adc1 = adc1-0.25*ada4(2,i,2)*d1*d2*(d2+3.*d1)
  add1 = add1-ada4(2,i,2)*(0.75*c1*d1*d2+0.25*c1*d2*(d2+3.*d1))
  add2 = add2-ada4(2,i,2)*(0.25*c1*d1*d2+0.25*c1*d1*(d2+3.*d1))
  adqm = adqm+ada4(2,i,2)
  ada4(2,i,2) = 0.
  adc1 = adc1-0.5*adc3*(d2*(5.*d1+d2)-3.*d1*d1)
  add1 = add1-0.5*adc3*c1*(5*d2-6*d1)
  add2 = add2-0.5*adc3*c1*(d2+5.*d1+d2)
  addq = addq+adc3
  adc3 = 0.
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do ib8 = i1, i2
      c1 = (delp(ib8,k-1)+0.5*delp(ib8,k))/d4(ib8,k+1)
      c2 = (delp(ib8,k+1)+0.5*delp(ib8,k))/d4(ib8,k)
      df2(ib8,k) = delp(ib8,k)*(c1*delq(ib8,k)+c2*delq(ib8,k-1))/(d4(ib8,k)+delp(ib8,k+1))
      dc(ib8,k) = sign(min(abs(df2(ib8,k)),max(a4(1,ib8,k-1),a4(1,ib8,k),a4(1,ib8,k+1))-a4(1,ib8,k),a4(1,ib8,k)-min(a4(1,ib8,k-1),&
&a4(1,ib8,k),a4(1,ib8,k+1))),df2(ib8,k))
    end do
  end do
  do k = 3, km1
    do ib8 = i1, i2
      c1 = delq(ib8,k-1)*delp(ib8,k-1)/d4(ib8,k)
      a1 = d4(ib8,k-1)/(d4(ib8,k)+delp(ib8,k-1))
      a2 = d4(ib8,k+1)/(d4(ib8,k)+delp(ib8,k))
      a4(2,ib8,k) = a4(1,ib8,k-1)+c1+2./(d4(ib8,k-1)+d4(ib8,k+1))*(delp(ib8,k)*(c1*(a1-a2)+a2*dc(ib8,k-1))-delp(ib8,k-1)*a1*dc(ib8,&
&k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  ada4(2,i,3) = ada4(2,i,3)+adc1*(4/(d2*(2.*d2*d2+d1*(d2+3.*d1))))
  add1 = add1-adc1*(4.*(a4(2,i,3)-qm-d2*dq)*d2*(3*d1+d2+3.*d1)/(d2*(2.*d2*d2+d1*(d2+3.*d1))*d2*(2.*d2*d2+d1*(d2+3.*d1))))
  add2 = add2-adc1*(4.*dq/(d2*(2.*d2*d2+d1*(d2+3.*d1)))+4.*(a4(2,i,3)-qm-d2*dq)*(d2*(4*d2+d1)+2.*d2*d2+d1*(d2+3.*d1))/(d2*(2.*d2*&
&d2+d1*(d2+3.*d1))*d2*(2.*d2*d2+d1*(d2+3.*d1))))
  addq = addq-adc1*(4.*d2/(d2*(2.*d2*d2+d1*(d2+3.*d1))))
  adqm = adqm+adc1*((-4)/(d2*(2.*d2*d2+d1*(d2+3.*d1))))
  adc1 = 0.
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do ib9 = i1, i2
      c1 = (delp(ib9,k-1)+0.5*delp(ib9,k))/d4(ib9,k+1)
      c2 = (delp(ib9,k+1)+0.5*delp(ib9,k))/d4(ib9,k)
      df2(ib9,k) = delp(ib9,k)*(c1*delq(ib9,k)+c2*delq(ib9,k-1))/(d4(ib9,k)+delp(ib9,k+1))
      dc(ib9,k) = sign(min(abs(df2(ib9,k)),max(a4(1,ib9,k-1),a4(1,ib9,k),a4(1,ib9,k+1))-a4(1,ib9,k),a4(1,ib9,k)-min(a4(1,ib9,k-1),&
&a4(1,ib9,k),a4(1,ib9,k+1))),df2(ib9,k))
    end do
  end do
  do k = 3, km1
    do ib9 = i1, i2
      c1 = delq(ib9,k-1)*delp(ib9,k-1)/d4(ib9,k)
      a1 = d4(ib9,k-1)/(d4(ib9,k)+delp(ib9,k-1))
      a2 = d4(ib9,k+1)/(d4(ib9,k)+delp(ib9,k))
      a4(2,ib9,k) = a4(1,ib9,k-1)+c1+2./(d4(ib9,k-1)+d4(ib9,k+1))*(delp(ib9,k)*(c1*(a1-a2)+a2*dc(ib9,k-1))-delp(ib9,k-1)*a1*dc(ib9,&
&k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  ada4(1,i,2) = ada4(1,i,2)+addq*(2/(d1+d2))
  ada4(1,i,1) = ada4(1,i,1)+addq*((-2)/(d1+d2))
  add1 = add1-addq*(2*(a4(1,i,2)-a4(1,i,1))/((d1+d2)*(d1+d2)))
  add2 = add2-addq*(2*(a4(1,i,2)-a4(1,i,1))/((d1+d2)*(d1+d2)))
  addq = 0.
  a4(:,:,:) = a4h(:,:,:)
  do k = 2, km1
    do ib9a = i1, i2
      c1 = (delp(ib9a,k-1)+0.5*delp(ib9a,k))/d4(ib9a,k+1)
      c2 = (delp(ib9a,k+1)+0.5*delp(ib9a,k))/d4(ib9a,k)
      df2(ib9a,k) = delp(ib9a,k)*(c1*delq(ib9a,k)+c2*delq(ib9a,k-1))/(d4(ib9a,k)+delp(ib9a,k+1))
      dc(ib9a,k) = sign(min(abs(df2(ib9a,k)),max(a4(1,ib9a,k-1),a4(1,ib9a,k),a4(1,ib9a,k+1))-a4(1,ib9a,k),a4(1,ib9a,k)-min(a4(1,&
&ib9a,k-1),a4(1,ib9a,k),a4(1,ib9a,k+1))),df2(ib9a,k))
    end do
  end do
  do k = 3, km1
    do ib9a = i1, i2
      c1 = delq(ib9a,k-1)*delp(ib9a,k-1)/d4(ib9a,k)
      a1 = d4(ib9a,k-1)/(d4(ib9a,k)+delp(ib9a,k-1))
      a2 = d4(ib9a,k+1)/(d4(ib9a,k)+delp(ib9a,k))
      a4(2,ib9a,k) = a4(1,ib9a,k-1)+c1+2./(d4(ib9a,k-1)+d4(ib9a,k+1))*(delp(ib9a,k)*(c1*(a1-a2)+a2*dc(ib9a,k-1))-delp(ib9a,k-1)*a1*&
&dc(ib9a,k))
    end do
  end do
  if (km .gt. 8 .and. kord .gt. 3) then
    call steepz( i1,i2,km,a4,df2,dc,delq,delp,d4 )
  endif
  ada4(1,i,2) = ada4(1,i,2)+adqm*(d1/(d1+d2))
  ada4(1,i,1) = ada4(1,i,1)+adqm*(d2/(d1+d2))
  add1 = add1+adqm*(a4(1,i,2)/(d1+d2)-(d2*a4(1,i,1)+d1*a4(1,i,2))/((d1+d2)*(d1+d2)))
  add2 = add2+adqm*(a4(1,i,1)/(d1+d2)-(d2*a4(1,i,1)+d1*a4(1,i,2))/((d1+d2)*(d1+d2)))
  adqm = 0.
  addelp(i,2) = addelp(i,2)+add2
  add2 = 0.
  addelp(i,1) = addelp(i,1)+add1
  add1 = 0.
end do
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  do i = i1, i2
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    a4(2,i,k) = a4(1,i,k-1)+c1+2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-delp(i,k-1)*a1*dc(i,k))
  end do
end do
if (km .gt. 8 .and. kord .gt. 3) then
  call adsteepz( i1,i2,km,a4,ada4,df2,addf2,dc,addc,delq,addelq,delp,addelp,d4,add4 )
endif
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  do i = i1, i2
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dc(i,k) = sign(min(abs(df2(i,k)),max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))-a4(1,i,k),a4(1,i,k)-min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+&
&1))),df2(i,k))
  end do
end do
do k = 3, km1
  ada1 = 0.
  ada2 = 0.
  adc1 = 0.
  do i = i1, i2
    ada1 = 0.
    ada2 = 0.
    adc1 = 0.
    c1 = delq(i,k-1)*delp(i,k-1)/d4(i,k)
    a1 = d4(i,k-1)/(d4(i,k)+delp(i,k-1))
    a2 = d4(i,k+1)/(d4(i,k)+delp(i,k))
    ada1 = ada1+ada4(2,i,k)*2./(d4(i,k-1)+d4(i,k+1))*(delp(i,k)*c1-delp(i,k-1)*dc(i,k))
    ada2 = ada2+ada4(2,i,k)*2./(d4(i,k-1)+d4(i,k+1))*delp(i,k)*((-c1)+dc(i,k-1))
    ada4(1,i,k-1) = ada4(1,i,k-1)+ada4(2,i,k)
    adc1 = adc1+ada4(2,i,k)*(1+2./(d4(i,k-1)+d4(i,k+1))*delp(i,k)*(a1-a2))
    add4(i,k-1) = add4(i,k-1)-ada4(2,i,k)*2/((d4(i,k-1)+d4(i,k+1))*(d4(i,k-1)+d4(i,k+1)))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-&
&delp(i,k-1)*a1*dc(i,k))
    add4(i,k+1) = add4(i,k+1)-ada4(2,i,k)*2/((d4(i,k-1)+d4(i,k+1))*(d4(i,k-1)+d4(i,k+1)))*(delp(i,k)*(c1*(a1-a2)+a2*dc(i,k-1))-&
&delp(i,k-1)*a1*dc(i,k))
    addc(i,k-1) = addc(i,k-1)+ada4(2,i,k)*2./(d4(i,k-1)+d4(i,k+1))*delp(i,k)*a2
    addc(i,k) = addc(i,k)-ada4(2,i,k)*2./(d4(i,k-1)+d4(i,k+1))*delp(i,k-1)*a1
    addelp(i,k-1) = addelp(i,k-1)-ada4(2,i,k)*2./(d4(i,k-1)+d4(i,k+1))*a1*dc(i,k)
    addelp(i,k) = addelp(i,k)+ada4(2,i,k)*2./(d4(i,k-1)+d4(i,k+1))*(c1*(a1-a2)+a2*dc(i,k-1))
    ada4(2,i,k) = 0.
    add4(i,k+1) = add4(i,k+1)+ada2/(d4(i,k)+delp(i,k))
    add4(i,k) = add4(i,k)-ada2*(d4(i,k+1)/((d4(i,k)+delp(i,k))*(d4(i,k)+delp(i,k))))
    addelp(i,k) = addelp(i,k)-ada2*(d4(i,k+1)/((d4(i,k)+delp(i,k))*(d4(i,k)+delp(i,k))))
    ada2 = 0.
    add4(i,k-1) = add4(i,k-1)+ada1/(d4(i,k)+delp(i,k-1))
    add4(i,k) = add4(i,k)-ada1*(d4(i,k-1)/((d4(i,k)+delp(i,k-1))*(d4(i,k)+delp(i,k-1))))
    addelp(i,k-1) = addelp(i,k-1)-ada1*(d4(i,k-1)/((d4(i,k)+delp(i,k-1))*(d4(i,k)+delp(i,k-1))))
    ada1 = 0.
    add4(i,k) = add4(i,k)-adc1*(delq(i,k-1)*delp(i,k-1)/(d4(i,k)*d4(i,k)))
    addelp(i,k-1) = addelp(i,k-1)+adc1*(delq(i,k-1)/d4(i,k))
    addelq(i,k-1) = addelq(i,k-1)+adc1*(delp(i,k-1)/d4(i,k))
    adc1 = 0.
  end do
end do
a4(:,:,:) = a4h(:,:,:)
do k = 2, km1
  adc1 = 0.
  adc2 = 0.
  do i = i1, i2
    adc1 = 0.
    adc2 = 0.
    c1 = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
    c2 = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
    df2(i,k) = delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1))
    dch = abs(df2(i,k))
    dci = max(a4(1,i,k-1),a4(1,i,k))
    dck = max(dci,a4(1,i,k+1))-a4(1,i,k)
    dcl = min(a4(1,i,k-1),a4(1,i,k))
    dcn = a4(1,i,k)-min(dcl,a4(1,i,k+1))
    dco = min(dch,dck)
    addcp = addc(i,k)*sign(1.,min(dco,dcn))*sign(1.,df2(i,k))
    addcn = addcp*(0.5-sign(0.5,dcn-dco))
    addco = addcp*(0.5+sign(0.5,dcn-dco))
    addch = addco*(0.5+sign(0.5,dck-dch))
    addck = addco*(0.5-sign(0.5,dck-dch))
    ada4(1,i,k) = ada4(1,i,k)+addcn
    addcm = -addcn
    ada4(1,i,k+1) = ada4(1,i,k+1)+addcm*(0.5-sign(0.5,a4(1,i,k+1)-dcl))
    addcl = addcm*(0.5+sign(0.5,a4(1,i,k+1)-dcl))
    ada4(1,i,k-1) = ada4(1,i,k-1)+addcl*(0.5+sign(0.5,a4(1,i,k)-a4(1,i,k-1)))
    ada4(1,i,k) = ada4(1,i,k)+addcl*(0.5-sign(0.5,a4(1,i,k)-a4(1,i,k-1)))
    ada4(1,i,k) = ada4(1,i,k)-addck
    ada4(1,i,k+1) = ada4(1,i,k+1)+addck*(0.5-sign(0.5,dci-a4(1,i,k+1)))
    addci = addck*(0.5+sign(0.5,dci-a4(1,i,k+1)))
    ada4(1,i,k-1) = ada4(1,i,k-1)+addci*(0.5+sign(0.5,a4(1,i,k-1)-a4(1,i,k)))
    ada4(1,i,k) = ada4(1,i,k)+addci*(0.5-sign(0.5,a4(1,i,k-1)-a4(1,i,k)))
    addf2(i,k) = addf2(i,k)+addch*sign(1.,df2(i,k))
    addc(i,k) = 0.
    adc1 = adc1+addf2(i,k)*(delp(i,k)*delq(i,k)/(d4(i,k)+delp(i,k+1)))
    adc2 = adc2+addf2(i,k)*(delp(i,k)*delq(i,k-1)/(d4(i,k)+delp(i,k+1)))
    add4(i,k) = add4(i,k)-addf2(i,k)*(delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/((d4(i,k)+delp(i,k+1))*(d4(i,k)+delp(i,k+1))))
    addelp(i,k+1) = addelp(i,k+1)-addf2(i,k)*(delp(i,k)*(c1*delq(i,k)+c2*delq(i,k-1))/((d4(i,k)+delp(i,k+1))*(d4(i,k)+delp(i,k+1))))
    addelp(i,k) = addelp(i,k)+addf2(i,k)*((c1*delq(i,k)+c2*delq(i,k-1))/(d4(i,k)+delp(i,k+1)))
    addelq(i,k-1) = addelq(i,k-1)+addf2(i,k)*(delp(i,k)*c2/(d4(i,k)+delp(i,k+1)))
    addelq(i,k) = addelq(i,k)+addf2(i,k)*(delp(i,k)*c1/(d4(i,k)+delp(i,k+1)))
    addf2(i,k) = 0.
    add4(i,k) = add4(i,k)-adc2*((delp(i,k+1)+0.5*delp(i,k))/(d4(i,k)*d4(i,k)))
    addelp(i,k+1) = addelp(i,k+1)+adc2/d4(i,k)
    addelp(i,k) = addelp(i,k)+adc2*(0.5/d4(i,k))
    adc2 = 0.
    add4(i,k+1) = add4(i,k+1)-adc1*((delp(i,k-1)+0.5*delp(i,k))/(d4(i,k+1)*d4(i,k+1)))
    addelp(i,k-1) = addelp(i,k-1)+adc1/d4(i,k+1)
    addelp(i,k) = addelp(i,k)+adc1*(0.5/d4(i,k+1))
    adc1 = 0.
  end do
end do
do k = 2, km
  do i = i1, i2
    addelp(i,k-1) = addelp(i,k-1)+add4(i,k)
    addelp(i,k) = addelp(i,k)+add4(i,k)
    add4(i,k) = 0.
    ada4(1,i,k-1) = ada4(1,i,k-1)-addelq(i,k-1)
    ada4(1,i,k) = ada4(1,i,k)+addelq(i,k-1)
    addelq(i,k-1) = 0.
  end do
end do

!----------------------------------------------
! FREE DYNAMIC MEMORY
!----------------------------------------------

end subroutine adppm_profile


subroutine adremap_z( km, pe1, adpe1, q1, adq1, kn, pe2, adpe2, adq2, i1, i2, kord )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r23 = 2./3.
real, parameter :: r3 = 1./3.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: km
real, intent(inout) :: adpe1(i1:i2,km+1)
integer, intent(in) :: kn
real, intent(inout) :: adpe2(i1:i2,kn+1)
real, intent(inout) :: adq1(i1:i2,km)
real, intent(inout) :: adq2(i1:i2,kn)
integer, intent(in) :: kord
real, intent(in) :: pe1(i1:i2,km+1)
real, intent(in) :: pe2(i1:i2,kn+1)
real, intent(in) :: q1(i1:i2,km)

!==============================================
! declare local variables
!==============================================
real :: addelp
real :: addp1(i1:i2,km)
real :: adesl
real :: adpl
real :: adpr
real :: adq4(4,i1:i2,km)
real :: adqsum
real :: delp
real :: dp1(i1:i2,km)
real :: esl
integer :: i
integer :: i3
integer :: idow
integer :: idow1
integer :: idox
integer :: idox1
integer :: k
integer :: k0
integer :: k0h
integer :: k1
integer :: l
logical :: l_123
logical :: l_555
logical :: l_loop
integer :: m
logical :: m_123
logical :: m_123h
logical :: m_123i
integer :: ndow
integer :: ndox
integer :: nrec
real :: pl
real :: pr
real :: q4(4,i1:i2,km)
real :: qsum
real :: qsumh

!==============================================
! declare external procedures and functions
!==============================================
integer, external :: adsubcl

!----------------------------------------------
! COUNT DOWN SUBROUTINE CALLS
!----------------------------------------------
call adcount( 4,-1 )

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
addelp = 0.
addp1(:,:) = 0.
adesl = 0.
adpl = 0.
adpr = 0.
adq4(:,:,:) = 0.
adqsum = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
do k = 1, km
  do i = i1, i2
    dp1(i,k) = pe1(i,k+1)-pe1(i,k)
    q4(1,i,k) = q1(i,k)
  end do
end do
if (kord .gt. 7) then
  call cs_profile( q4,dp1,km,i1,i2,1,kord )
else
  call ppm_profile( q4,dp1,km,i1,i2,1,kord )
endif
do i = i2, i1, -1
  do i3 = i1, i-1
    k0 = 1
    do k = 1, kn
      l_123 =  .false. 
      l_555 =  .false. 
      l_loop =  .false. 
      l = k0
      if (l_loop .eq.  .false. ) then
        if (pe2(i3,k) .le. pe1(i3,l) .and. pe2(i3,k) .ge. pe1(i3,l+1)) then
          pl = (pe2(i3,k)-pe1(i3,l))/dp1(i3,l)
          if (pe2(i3,k+1) .ge. pe1(i3,l+1)) then
            if (l_555 .eq.  .false. ) then
              k0 = l
              l_555 =  .true. 
            endif
          else
            if (l_123 .eq.  .false. ) then
              qsum = (pe1(i3,l+1)-pe2(i3,k))*(q4(2,i3,l)+0.5*(q4(4,i3,l)+q4(3,i3,l)-q4(2,i3,l))*(1.+pl)-q4(4,i3,l)*r3*(1.+pl*(1.+&
&pl)))
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i3,k+1) .lt. pe1(i3,m+1)) then
  qsum = qsum+dp1(i3,m)*q4(1,i3,m)
else
  delp = pe2(i3,k+1)-pe1(i3,m)
  esl = delp/dp1(i3,m)
  qsum = qsum+delp*(q4(2,i3,m)+0.5*esl*(q4(3,i3,m)-q4(2,i3,m)+q4(4,i3,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i3,k+1) .lt. pe1(i3,m+1)) then
    qsum = qsum+dp1(i3,m)*q4(1,i3,m)
  else
    delp = pe2(i3,k+1)-pe1(i3,m)
    esl = delp/dp1(i3,m)
    qsum = qsum+delp*(q4(2,i3,m)+0.5*esl*(q4(3,i3,m)-q4(2,i3,m)+q4(4,i3,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
              end do
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
      do while ( l_loop .eq.  .false.  .and. l .le. km )
        if (l_loop .eq.  .false. ) then
          if (pe2(i3,k) .le. pe1(i3,l) .and. pe2(i3,k) .ge. pe1(i3,l+1)) then
            pl = (pe2(i3,k)-pe1(i3,l))/dp1(i3,l)
            if (pe2(i3,k+1) .ge. pe1(i3,l+1)) then
              if (l_555 .eq.  .false. ) then
k0 = l
l_555 =  .true. 
              endif
            else
              if (l_123 .eq.  .false. ) then
qsum = (pe1(i3,l+1)-pe2(i3,k))*(q4(2,i3,l)+0.5*(q4(4,i3,l)+q4(3,i3,l)-q4(2,i3,l))*(1.+pl)-q4(4,i3,l)*r3*(1.+pl*(1.+pl)))
m_123 =  .false. 
m = l+1
if (m_123 .eq.  .false. ) then
  if (pe2(i3,k+1) .lt. pe1(i3,m+1)) then
    qsum = qsum+dp1(i3,m)*q4(1,i3,m)
  else
    delp = pe2(i3,k+1)-pe1(i3,m)
    esl = delp/dp1(i3,m)
    qsum = qsum+delp*(q4(2,i3,m)+0.5*esl*(q4(3,i3,m)-q4(2,i3,m)+q4(4,i3,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
do while ( m_123 .eq.  .false.  .or. m .lt. km )
  m = m+1
  if (m_123 .eq.  .false. ) then
    if (pe2(i3,k+1) .lt. pe1(i3,m+1)) then
      qsum = qsum+dp1(i3,m)*q4(1,i3,m)
    else
      delp = pe2(i3,k+1)-pe1(i3,m)
      esl = delp/dp1(i3,m)
      qsum = qsum+delp*(q4(2,i3,m)+0.5*esl*(q4(3,i3,m)-q4(2,i3,m)+q4(4,i3,m)*(1.-r23*esl)))
      k0 = m
      m_123 =  .true. 
    endif
  endif
end do
l_123 =  .true. 
              endif
            endif
          endif
          if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
            l_loop =  .true. 
          endif
        endif
        if (l_loop .eq.  .false.  .and. l .lt. km) then
          l = l+1
        endif
      end do
    end do
  end do
  qsumh = qsum
  m_123i = m_123
  k0 = 1
  do k = kn, 1, -1
    m_123 = m_123i
    qsum = qsumh
    k0 = 1
    do k1 = 1, k-1
      l_123 =  .false. 
      l_555 =  .false. 
      l_loop =  .false. 
      l = k0
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k1) .le. pe1(i,l) .and. pe2(i,k1) .ge. pe1(i,l+1)) then
          pl = (pe2(i,k1)-pe1(i,l))/dp1(i,l)
          if (pe2(i,k1+1) .ge. pe1(i,l+1)) then
            if (l_555 .eq.  .false. ) then
              k0 = l
              l_555 =  .true. 
            endif
          else
            if (l_123 .eq.  .false. ) then
              qsum = (pe1(i,l+1)-pe2(i,k1))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k1+1) .lt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  delp = pe2(i,k1+1)-pe1(i,m)
  esl = delp/dp1(i,m)
  qsum = qsum+delp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k1+1) .lt. pe1(i,m+1)) then
    qsum = qsum+dp1(i,m)*q4(1,i,m)
  else
    delp = pe2(i,k1+1)-pe1(i,m)
    esl = delp/dp1(i,m)
    qsum = qsum+delp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
              end do
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
      do while ( l_loop .eq.  .false.  .and. l .le. km )
        if (l_loop .eq.  .false. ) then
          if (pe2(i,k1) .le. pe1(i,l) .and. pe2(i,k1) .ge. pe1(i,l+1)) then
            pl = (pe2(i,k1)-pe1(i,l))/dp1(i,l)
            if (pe2(i,k1+1) .ge. pe1(i,l+1)) then
              if (l_555 .eq.  .false. ) then
k0 = l
l_555 =  .true. 
              endif
            else
              if (l_123 .eq.  .false. ) then
qsum = (pe1(i,l+1)-pe2(i,k1))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
m_123 =  .false. 
m = l+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k1+1) .lt. pe1(i,m+1)) then
    qsum = qsum+dp1(i,m)*q4(1,i,m)
  else
    delp = pe2(i,k1+1)-pe1(i,m)
    esl = delp/dp1(i,m)
    qsum = qsum+delp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
do while ( m_123 .eq.  .false.  .or. m .lt. km )
  m = m+1
  if (m_123 .eq.  .false. ) then
    if (pe2(i,k1+1) .lt. pe1(i,m+1)) then
      qsum = qsum+dp1(i,m)*q4(1,i,m)
    else
      delp = pe2(i,k1+1)-pe1(i,m)
      esl = delp/dp1(i,m)
      qsum = qsum+delp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
      k0 = m
      m_123 =  .true. 
    endif
  endif
end do
l_123 =  .true. 
              endif
            endif
          endif
          if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
            l_loop =  .true. 
          endif
        endif
        if (l_loop .eq.  .false.  .and. l .lt. km) then
          l = l+1
        endif
      end do
    end do
    m_123h = m_123
    k0h = k0
    l_123 =  .false. 
    l_555 =  .false. 
    l_loop =  .false. 
    l = k0
    if (l_loop .eq.  .false. ) then
      if (pe2(i,k) .le. pe1(i,l) .and. pe2(i,k) .ge. pe1(i,l+1)) then
        pl = (pe2(i,k)-pe1(i,l))/dp1(i,l)
        if (pe2(i,k+1) .ge. pe1(i,l+1)) then
          if (l_555 .eq.  .false. ) then
            k0 = l
            l_555 =  .true. 
          endif
        else
          if (l_123 .eq.  .false. ) then
            qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
            m_123 =  .false. 
            m = l+1
            if (m_123 .eq.  .false. ) then
              if (pe2(i,k+1) .lt. pe1(i,m+1)) then
qsum = qsum+dp1(i,m)*q4(1,i,m)
              else
delp = pe2(i,k+1)-pe1(i,m)
esl = delp/dp1(i,m)
qsum = qsum+delp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
k0 = m
m_123 =  .true. 
              endif
            endif
            do while ( m_123 .eq.  .false.  .or. m .lt. km )
              m = m+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .lt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  delp = pe2(i,k+1)-pe1(i,m)
  esl = delp/dp1(i,m)
  qsum = qsum+delp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
            end do
            l_123 =  .true. 
          endif
        endif
      endif
      if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
        l_loop =  .true. 
      endif
    endif
    if (l_loop .eq.  .false.  .and. l .lt. km) then
      l = l+1
    endif
    do while ( l_loop .eq.  .false.  .and. l .le. km )
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k) .le. pe1(i,l) .and. pe2(i,k) .ge. pe1(i,l+1)) then
          pl = (pe2(i,k)-pe1(i,l))/dp1(i,l)
          if (pe2(i,k+1) .ge. pe1(i,l+1)) then
            if (l_555 .eq.  .false. ) then
              l_555 =  .true. 
            endif
          else
            if (l_123 .eq.  .false. ) then
              qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .lt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  delp = pe2(i,k+1)-pe1(i,m)
  esl = delp/dp1(i,m)
  qsum = qsum+delp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  m_123 =  .true. 
endif
              endif
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .lt. pe1(i,m+1)) then
    qsum = qsum+dp1(i,m)*q4(1,i,m)
  else
    delp = pe2(i,k+1)-pe1(i,m)
    esl = delp/dp1(i,m)
    qsum = qsum+delp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    m_123 =  .true. 
  endif
endif
              end do
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
    end do
    if (l_555 .eq.  .false. ) then
      adpe2(i,k+1) = adpe2(i,k+1)-adq2(i,k)*(qsum/((pe2(i,k+1)-pe2(i,k))*(pe2(i,k+1)-pe2(i,k))))
      adpe2(i,k) = adpe2(i,k)+adq2(i,k)*(qsum/((pe2(i,k+1)-pe2(i,k))*(pe2(i,k+1)-pe2(i,k))))
      adqsum = adqsum+adq2(i,k)/(pe2(i,k+1)-pe2(i,k))
      adq2(i,k) = 0.
    endif
    m_123 = m_123h
    l_123 =  .false. 
    l_555 =  .false. 
    l_loop =  .false. 
    l = k0
    if (l_loop .eq.  .false. ) then
      if (pe2(i,k) .le. pe1(i,l) .and. pe2(i,k) .ge. pe1(i,l+1)) then
        if (pe2(i,k+1) .ge. pe1(i,l+1)) then
          if (l_555 .eq.  .false. ) then
            l_555 =  .true. 
          endif
        else
          if (l_123 .eq.  .false. ) then
            m_123 =  .false. 
            m = l+1
            if (m_123 .eq.  .false. ) then
              if (pe2(i,k+1) .lt. pe1(i,m+1)) then
              else
m_123 =  .true. 
              endif
            endif
            do while ( m_123 .eq.  .false.  .or. m .lt. km )
              m = m+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .lt. pe1(i,m+1)) then
else
  m_123 =  .true. 
endif
              endif
            end do
            l_123 =  .true. 
          endif
        endif
      endif
      if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
        l_loop =  .true. 
      endif
    endif
    if (l_loop .eq.  .false.  .and. l .lt. km) then
      l = l+1
    endif
    call getkey( 2,7,(i-i1+k-1)*(1+i-i1+k-1)/2+i-i1,0,adsubcl(1,4),nrec )
    call adresto( 'memory_7_f_dyn_idow',19,idow,4,1,nrec )
    ndow = idow
    do idow = ndow, 1, -1
      m_123 = m_123h
      l_123 =  .false. 
      l_555 =  .false. 
      l_loop =  .false. 
      l = k0
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k) .le. pe1(i,l) .and. pe2(i,k) .ge. pe1(i,l+1)) then
          if (pe2(i,k+1) .ge. pe1(i,l+1)) then
            if (l_555 .eq.  .false. ) then
              l_555 =  .true. 
            endif
          else
            if (l_123 .eq.  .false. ) then
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .lt. pe1(i,m+1)) then
else
  m_123 =  .true. 
endif
              endif
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .lt. pe1(i,m+1)) then
  else
    m_123 =  .true. 
  endif
endif
              end do
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
      do idow1 = 1, idow-1
        if (l_loop .eq.  .false. ) then
          if (pe2(i,k) .le. pe1(i,l) .and. pe2(i,k) .ge. pe1(i,l+1)) then
            if (pe2(i,k+1) .ge. pe1(i,l+1)) then
              if (l_555 .eq.  .false. ) then
l_555 =  .true. 
              endif
            else
              if (l_123 .eq.  .false. ) then
m_123 =  .false. 
m = l+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .lt. pe1(i,m+1)) then
  else
    m_123 =  .true. 
  endif
endif
do while ( m_123 .eq.  .false.  .or. m .lt. km )
  m = m+1
  if (m_123 .eq.  .false. ) then
    if (pe2(i,k+1) .lt. pe1(i,m+1)) then
    else
      m_123 =  .true. 
    endif
  endif
end do
l_123 =  .true. 
              endif
            endif
          endif
          if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
            l_loop =  .true. 
          endif
        endif
        if (l_loop .eq.  .false.  .and. l .lt. km) then
          l = l+1
        endif
      end do
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k) .le. pe1(i,l) .and. pe2(i,k) .ge. pe1(i,l+1)) then
          if (pe2(i,k+1) .ge. pe1(i,l+1)) then
            if (l_555 .eq.  .false. ) then
              pr = (pe2(i,k+1)-pe1(i,l))/dp1(i,l)
              adpl = adpl+adq2(i,k)*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(pr+2*pl))
              adpr = adpr+adq2(i,k)*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(2*pr+pl))
              adq4(4,i,l) = adq4(4,i,l)+adq2(i,k)*(0.5*(pr+pl)-r3*(pr*(pr+pl)+pl**2))
              adq4(3,i,l) = adq4(3,i,l)+0.5*adq2(i,k)*(pr+pl)
              adq4(2,i,l) = adq4(2,i,l)+adq2(i,k)*(1+(-0.5)*(pr+pl))
              adq2(i,k) = 0.
              addp1(i,l) = addp1(i,l)-adpr*((pe2(i,k+1)-pe1(i,l))/(dp1(i,l)*dp1(i,l)))
              adpe1(i,l) = adpe1(i,l)-adpr/dp1(i,l)
              adpe2(i,k+1) = adpe2(i,k+1)+adpr/dp1(i,l)
              adpr = 0.
            endif
          else
            if (l_123 .eq.  .false. ) then
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .lt. pe1(i,m+1)) then
else
  m_123 =  .true. 
endif
              endif
              call getkey( 2,6,((i-i1+k-1)*(1+i-i1+k-1)/2+i-i1+idow-1)*(1+(i-i1+k-1)*(1+i-i1+k-1)/2+i-i1+idow-1)/2+(i-i1+k-1)*(1+i-&
&i1+k-1)/2+i-i1,0,adsubcl(1,4),nrec )
              call adresto( 'memory_6_f_dyn_idox',19,idox,4,1,nrec )
              ndox = idox
              do idox = ndox, 1, -1
m_123 =  .false. 
m = l+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .lt. pe1(i,m+1)) then
  else
    m_123 =  .true. 
  endif
endif
do idox1 = 1, idox-1
  m = m+1
  if (m_123 .eq.  .false. ) then
    if (pe2(i,k+1) .lt. pe1(i,m+1)) then
    else
      m_123 =  .true. 
    endif
  endif
end do
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .lt. pe1(i,m+1)) then
    addp1(i,m) = addp1(i,m)+adqsum*q4(1,i,m)
    adq4(1,i,m) = adq4(1,i,m)+adqsum*dp1(i,m)
  else
    addelp = addelp+adqsum*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    adesl = adesl+adqsum*delp*((-(0.5*esl*q4(4,i,m)*r23))+0.5*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    adq4(4,i,m) = adq4(4,i,m)+0.5*adqsum*delp*esl*(1.-r23*esl)
    adq4(3,i,m) = adq4(3,i,m)+0.5*adqsum*delp*esl
    adq4(2,i,m) = adq4(2,i,m)+adqsum*delp*(1+(-0.5)*esl)
    addelp = addelp+adesl/dp1(i,m)
    addp1(i,m) = addp1(i,m)-adesl*(delp/(dp1(i,m)*dp1(i,m)))
    adesl = 0.
    adpe1(i,m) = adpe1(i,m)-addelp
    adpe2(i,k+1) = adpe2(i,k+1)+addelp
    addelp = 0.
  endif
endif
              end do
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .lt. pe1(i,m+1)) then
  addp1(i,m) = addp1(i,m)+adqsum*q4(1,i,m)
  adq4(1,i,m) = adq4(1,i,m)+adqsum*dp1(i,m)
else
  delp = pe2(i,k+1)-pe1(i,m)
  esl = delp/dp1(i,m)
  addelp = addelp+adqsum*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  adesl = adesl+adqsum*delp*((-(0.5*esl*q4(4,i,m)*r23))+0.5*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  adq4(4,i,m) = adq4(4,i,m)+0.5*adqsum*delp*esl*(1.-r23*esl)
  adq4(3,i,m) = adq4(3,i,m)+0.5*adqsum*delp*esl
  adq4(2,i,m) = adq4(2,i,m)+adqsum*delp*(1+(-0.5)*esl)
  addelp = addelp+adesl/dp1(i,m)
  addp1(i,m) = addp1(i,m)-adesl*(delp/(dp1(i,m)*dp1(i,m)))
  adesl = 0.
  adpe1(i,m) = adpe1(i,m)-addelp
  adpe2(i,k+1) = adpe2(i,k+1)+addelp
  addelp = 0.
endif
              endif
              adpe1(i,l+1) = adpe1(i,l+1)+adqsum*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)&
&))
              adpe2(i,k) = adpe2(i,k)-adqsum*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
              adpl = adpl+adqsum*(pe1(i,l+1)-pe2(i,k))*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(1+2*pl))
              adq4(4,i,l) = adq4(4,i,l)+adqsum*(pe1(i,l+1)-pe2(i,k))*(0.5*(1.+pl)-r3*(1.+pl*(1.+pl)))
              adq4(3,i,l) = adq4(3,i,l)+0.5*adqsum*(pe1(i,l+1)-pe2(i,k))*(1.+pl)
              adq4(2,i,l) = adq4(2,i,l)+adqsum*(pe1(i,l+1)-pe2(i,k))*(1+(-0.5)*(1.+pl))
              adqsum = 0.
            endif
          endif
          addp1(i,l) = addp1(i,l)-adpl*((pe2(i,k)-pe1(i,l))/(dp1(i,l)*dp1(i,l)))
          adpe1(i,l) = adpe1(i,l)-adpl/dp1(i,l)
          adpe2(i,k) = adpe2(i,k)+adpl/dp1(i,l)
          adpl = 0.
        endif
      endif
    end do
    k0 = k0h
    l_555 =  .false. 
    l_loop =  .false. 
    l = k0
    if (l_loop .eq.  .false. ) then
      if (pe2(i,k) .le. pe1(i,l) .and. pe2(i,k) .ge. pe1(i,l+1)) then
        if (pe2(i,k+1) .ge. pe1(i,l+1)) then
          if (l_555 .eq.  .false. ) then
            pr = (pe2(i,k+1)-pe1(i,l))/dp1(i,l)
            adpl = adpl+adq2(i,k)*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(pr+2*pl))
            adpr = adpr+adq2(i,k)*(0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))-q4(4,i,l)*r3*(2*pr+pl))
            adq4(4,i,l) = adq4(4,i,l)+adq2(i,k)*(0.5*(pr+pl)-r3*(pr*(pr+pl)+pl**2))
            adq4(3,i,l) = adq4(3,i,l)+0.5*adq2(i,k)*(pr+pl)
            adq4(2,i,l) = adq4(2,i,l)+adq2(i,k)*(1+(-0.5)*(pr+pl))
            adq2(i,k) = 0.
            addp1(i,l) = addp1(i,l)-adpr*((pe2(i,k+1)-pe1(i,l))/(dp1(i,l)*dp1(i,l)))
            adpe1(i,l) = adpe1(i,l)-adpr/dp1(i,l)
            adpe2(i,k+1) = adpe2(i,k+1)+adpr/dp1(i,l)
            adpr = 0.
          endif
        endif
        addp1(i,l) = addp1(i,l)-adpl*((pe2(i,k)-pe1(i,l))/(dp1(i,l)*dp1(i,l)))
        adpe1(i,l) = adpe1(i,l)-adpl/dp1(i,l)
        adpe2(i,k) = adpe2(i,k)+adpl/dp1(i,l)
        adpl = 0.
      endif
    endif
  end do
end do
do k = 1, km
  do i = i1, i2
    q4(1,i,k) = q1(i,k)
  end do
end do
if (kord .gt. 7) then
  call adcs_profile( q4,adq4,dp1,addp1,km,i1,i2,1 )
else
  call adppm_profile( q4,adq4,dp1,addp1,km,i1,i2,1,kord )
endif
do k = 1, km
  do i = i1, i2
    adq1(i,k) = adq1(i,k)+adq4(1,i,k)
    adq4(1,i,k) = 0.
    adpe1(i,k+1) = adpe1(i,k+1)+addp1(i,k)
    adpe1(i,k) = adpe1(i,k)-addp1(i,k)
    addp1(i,k) = 0.
  end do
end do

end subroutine adremap_z


subroutine adsteepz( i1, i2, km, a4, ada4, df2, addf2, dm, addm, dq, addq, dp, addp, d4, add4 )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: km
real, intent(inout) :: a4(4,i1:i2,km)
real, intent(inout) :: ada4(4,i1:i2,km)
real, intent(inout) :: add4(i1:i2,km)
real, intent(inout) :: addf2(i1:i2,km)
real, intent(inout) :: addm(i1:i2,km)
real, intent(inout) :: addp(i1:i2,km)
real, intent(inout) :: addq(i1:i2,km)
real, intent(in) :: d4(i1:i2,km)
real, intent(in) :: df2(i1:i2,km)
real, intent(in) :: dm(i1:i2,km)
real, intent(in) :: dp(i1:i2,km)
real, intent(in) :: dq(i1:i2,km)

!==============================================
! declare local variables
!==============================================
real :: adalfa(i1:i2,km)
real :: adalfah
real :: addg2
real :: adf(i1:i2,km)
real :: adrat(i1:i2,km)
real :: alfa(i1:i2,km)
real :: dg2
real :: f(i1:i2,km)
integer :: i
integer :: k
real :: rat(i1:i2,km)

!----------------------------------------------
! RESET LOCAL ADJOINT VARIABLES
!----------------------------------------------
adalfa(:,:) = 0.
addg2 = 0.
adf(:,:) = 0.
adrat(:,:) = 0.

!----------------------------------------------
! ROUTINE BODY
!----------------------------------------------
do k = 2, km
  do i = i1, i2
    rat(i,k) = dq(i,k-1)/d4(i,k)
  end do
end do
do k = 2, km-1
  do i = i1, i2
    f(i,k) = (rat(i,k+1)-rat(i,k))/(dp(i,k-1)+dp(i,k)+dp(i,k+1))
  end do
end do
do k = 3, km-2
  do i = i1, i2
    if (f(i,k+1)*f(i,k-1) .lt. 0. .and. df2(i,k) .ne. 0.) then
      dg2 = (f(i,k+1)-f(i,k-1))*((dp(i,k+1)-dp(i,k-1))**2+d4(i,k)*d4(i,k+1))
      alfa(i,k) = max(0.,min(0.5,-(0.1875*dg2/df2(i,k))))
    else
      alfa(i,k) = 0.
    endif
  end do
end do
do k = 4, km-2
  do i = i1, i2
    ada4(1,i,k-1) = ada4(1,i,k-1)+ada4(2,i,k)*alfa(i,k)
    ada4(1,i,k) = ada4(1,i,k)+ada4(2,i,k)*alfa(i,k-1)
    adalfa(i,k-1) = adalfa(i,k-1)+ada4(2,i,k)*((-a4(2,i,k))+a4(1,i,k)-dm(i,k))
    adalfa(i,k) = adalfa(i,k)+ada4(2,i,k)*((-a4(2,i,k))+a4(1,i,k-1)+dm(i,k-1))
    addm(i,k-1) = addm(i,k-1)+ada4(2,i,k)*alfa(i,k)
    addm(i,k) = addm(i,k)-ada4(2,i,k)*alfa(i,k-1)
    ada4(2,i,k) = ada4(2,i,k)*(1.-alfa(i,k-1)-alfa(i,k))
  end do
end do
do k = 3, km-2
  do i = i1, i2
    if (f(i,k+1)*f(i,k-1) .lt. 0. .and. df2(i,k) .ne. 0.) then
      dg2 = (f(i,k+1)-f(i,k-1))*((dp(i,k+1)-dp(i,k-1))**2+d4(i,k)*d4(i,k+1))
      adalfah = adalfa(i,k)*(0.5-sign(0.5,0.-min(0.5,-(0.1875*dg2/df2(i,k)))))
      addf2(i,k) = addf2(i,k)+adalfah*(0.5-sign(0.5,(-(0.1875*dg2/df2(i,k)))-0.5))*(0.1875*dg2/(df2(i,k)*df2(i,k)))
      addg2 = addg2-adalfah*(0.5-sign(0.5,(-(0.1875*dg2/df2(i,k)))-0.5))*(0.1875/df2(i,k))
      adalfa(i,k) = 0.
      add4(i,k+1) = add4(i,k+1)+addg2*(f(i,k+1)-f(i,k-1))*d4(i,k)
      add4(i,k) = add4(i,k)+addg2*(f(i,k+1)-f(i,k-1))*d4(i,k+1)
      addp(i,k-1) = addp(i,k-1)-2*addg2*(f(i,k+1)-f(i,k-1))*(dp(i,k+1)-dp(i,k-1))
      addp(i,k+1) = addp(i,k+1)+2*addg2*(f(i,k+1)-f(i,k-1))*(dp(i,k+1)-dp(i,k-1))
      adf(i,k-1) = adf(i,k-1)-addg2*((dp(i,k+1)-dp(i,k-1))**2+d4(i,k)*d4(i,k+1))
      adf(i,k+1) = adf(i,k+1)+addg2*((dp(i,k+1)-dp(i,k-1))**2+d4(i,k)*d4(i,k+1))
      addg2 = 0.
    else
      adalfa(i,k) = 0.
    endif
  end do
end do
do k = 2, km-1
  do i = i1, i2
    addp(i,k-1) = addp(i,k-1)-adf(i,k)*((rat(i,k+1)-rat(i,k))/((dp(i,k-1)+dp(i,k)+dp(i,k+1))*(dp(i,k-1)+dp(i,k)+dp(i,k+1))))
    addp(i,k+1) = addp(i,k+1)-adf(i,k)*((rat(i,k+1)-rat(i,k))/((dp(i,k-1)+dp(i,k)+dp(i,k+1))*(dp(i,k-1)+dp(i,k)+dp(i,k+1))))
    addp(i,k) = addp(i,k)-adf(i,k)*((rat(i,k+1)-rat(i,k))/((dp(i,k-1)+dp(i,k)+dp(i,k+1))*(dp(i,k-1)+dp(i,k)+dp(i,k+1))))
    adrat(i,k+1) = adrat(i,k+1)+adf(i,k)/(dp(i,k-1)+dp(i,k)+dp(i,k+1))
    adrat(i,k) = adrat(i,k)-adf(i,k)/(dp(i,k-1)+dp(i,k)+dp(i,k+1))
    adf(i,k) = 0.
  end do
end do
do k = 2, km
  do i = i1, i2
    add4(i,k) = add4(i,k)-adrat(i,k)*(dq(i,k-1)/(d4(i,k)*d4(i,k)))
    addq(i,k-1) = addq(i,k-1)+adrat(i,k)/d4(i,k)
    adrat(i,k) = 0.
  end do
end do

end subroutine adsteepz


subroutine mdlagrangian_to_eulerian( consv, ps, pe, delp, pkz, pk, mdt, km, is, ie, js, je, isd, ied, jsd, jed, nq, u, v, w, delz, &
&pt, q, hs, grav, r_vir, cp, akap, kord_mt, kord_tr, kord_tm, peln, te0_2d, ng, ua, va, omga, te, pem, fill, reproduce_sum, ak, bk,&
& ks, ze0, remap_t, hydrostatic, hybrid_z, ktop, ncnst )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: km
real, intent(in) :: ak(km+1)
real, intent(in) :: akap
real, intent(in) :: bk(km+1)
real, intent(in) :: consv
real, intent(in) :: cp
integer, intent(in) :: ied
integer, intent(in) :: isd
integer, intent(in) :: jed
integer, intent(in) :: jsd
real, intent(inout) :: delp(isd:ied,jsd:jed,km)
integer, intent(in) :: ie
integer, intent(in) :: is
integer, intent(in) :: je
integer, intent(in) :: js
real, intent(inout) :: delz(is:ie,js:je,km)
logical, intent(in) :: fill
real, intent(in) :: grav
real, intent(in) :: hs(isd:ied,jsd:jed)
logical, intent(in) :: hybrid_z
logical, intent(in) :: hydrostatic
integer, intent(in) :: kord_mt
integer, intent(in) :: kord_tm
integer, intent(in) :: kord_tr
integer, intent(in) :: ks
integer, intent(in) :: ktop
real, intent(in) :: mdt
integer, intent(in) :: ncnst
integer, intent(in) :: ng
integer, intent(in) :: nq
real, intent(inout) :: omga(isd:ied,jsd:jed,km)
real, intent(inout) :: pe(is-1:ie+1,km+1,js-1:je+1)
real, intent(out) :: peln(is:ie,km+1,js:je)
real, intent(inout) :: pem(is-1:ie+1,km+1,js-1:je+1)
real, intent(inout) :: pk(is:ie,js:je,km+1)
real, intent(out) :: pkz(is:ie,js:je,km)
real, intent(inout) :: ps(isd:ied,jsd:jed)
real, intent(inout) :: pt(isd:ied,jsd:jed,km)
real, intent(inout) :: q(isd:ied,jsd:jed,km,ncnst)
real, intent(in) :: r_vir
logical, intent(in) :: remap_t
logical, intent(in) :: reproduce_sum
real, intent(out) :: te(is:ie,js:je,km)
real, intent(in) :: te0_2d(is:ie,js:je)
real, intent(inout) :: u(isd:ied,jsd:jed+1,km)
real, intent(inout) :: ua(isd:ied,jsd:jed,km)
real, intent(inout) :: v(isd:ied+1,jsd:jed,km)
real, intent(inout) :: va(isd:ied,jsd:jed,km)
real, intent(inout) :: w(isd:ied,jsd:jed,km)
real, intent(inout) :: ze0(is:ie,js:je,km+1)

!==============================================
! declare local variables
!==============================================
real :: ak1
real :: bkh
real :: deng(is:ie,km)
real :: dlnp
real :: dp2(is:ie,km)
real :: dtmp
real :: gz(is:ie)
integer :: help_h
integer :: help_i
integer :: help_j
integer :: help_k
integer :: help_l
integer :: help_m
integer :: help_n
integer :: help_o
integer :: help_p
integer :: help_q
integer :: help_r
integer :: help_s
integer :: help_t
integer :: help_u
integer :: help_v
integer :: help_w
real :: help_x
real :: help_y
integer :: i
integer :: idow
integer :: iq
integer :: j
integer :: k
real :: k1k
logical :: k_loop
integer :: k_next
real :: kapag
integer :: kp
integer :: n
integer :: nrec
real :: pe0(is:ie+1,km+1)
real :: pe1(is:ie,km+1)
real :: pe2(is:ie,km+1)
real :: pe3(is:ie+1,km+1)
real :: phis(is:ie,km+1)
real :: pk1(is:ie,km+1)
real :: pk2(is:ie,km+1)
real :: pn2(is:ie,km+1)
real :: q2(is:ie,km)
real :: rcp
real :: rg
real :: te_2d(is:ie,js:je)
logical :: te_map
real :: tmp
real :: tpe
real :: ze1(is:ie,km+1)
real :: ze2(is:ie,km+1)
real :: zsum(is:ie,js:je)

!==============================================
! declare external procedures and functions
!==============================================
integer, external :: adsubcl

!**********************************************
! executable statements of routine
!**********************************************
k1k = akap/(1.-akap)
kapag = -(akap/grav)
rg = akap*cp
rcp = 1./cp
ak1 = (akap+1.)/akap
if (kord_tm .lt. 0) then
  te_map =  .false. 
  do j = js, je
    do k = 2, km+1
      do i = is, ie
        peln(i,k,j) = log(pe(i,k,j))
      end do
    end do
  end do
  if (remap_t) then
    do k = 1, km
      do j = js, je
        do i = is, ie
          pt(i,j,k) = pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))/(rg*(peln(i,k+1,j)-peln(i,k,j)))
        end do
      end do
    end do
  endif
else
  te_map =  .true. 
  call pkez( km,is,ie,js,je,pe,pk,akap,peln,pkz )
  call cubed_to_latlon( u,v,ua,va,dx,dy,dxa,dya,km )
  do k = 1, km
    do j = js, je
      do i = is, ie
        te(i,j,k) = 0.5*(ua(i,j,k)**2+va(i,j,k)**2)+pt(i,j,k)*pkz(i,j,k)
      end do
    end do
  end do
endif
if (( .not. hydrostatic) .and. ( .not. hybrid_z)) then
  do k = 1, km
    do j = js, je
      do i = is, ie
        delz(i,j,k) = -(delz(i,j,k)/delp(i,j,k))
      end do
    end do
  end do
endif
do j = js, je+1
  do k = 1, km+1
    do i = is, ie
      pe1(i,k) = pe(i,k,j)
    end do
  end do
  do i = is, ie
    pe2(i,1) = ptop
    pe2(i,km+1) = pe(i,km+1,j)
  end do
  if (j .lt. je+1) then
    if (hybrid_z) then
      do i = is, ie
        ze1(i,km+1) = ze0(i,j,km+1)
      end do
      do k = km, 1, -1
        do i = is, ie
          ze1(i,k) = ze1(i,k+1)-delz(i,j,k)
        end do
      end do
      do k = 2, km+1
        do i = is, ie
          ze2(i,k) = ze0(i,j,k)
        end do
      end do
      do i = is, ie
        ze2(i,1) = ze1(i,1)
        ze0(i,j,1) = ze1(i,1)
      end do
      do k = 1, km
        do i = is, ie
          deng(i,k) = -(delp(i,j,k)/delz(i,j,k))
        end do
      end do
      help_h = abs(kord_tm)
      call mdremap_z( km,ze1,deng,km,ze2,deng,is,ie,help_h )
      do k = 1, km
        do i = is, ie
          delz(i,j,k) = ze2(i,k+1)-ze2(i,k)
        end do
      end do
      do k = 1, km-1
        do i = is, ie
          dp2(i,k) = -(deng(i,k)*delz(i,j,k))
          pe2(i,k+1) = pe2(i,k)+dp2(i,k)
        end do
      end do
      do i = is, ie
        dp2(i,km) = pe2(i,km+1)-pe2(i,km)
      end do
    else
      do k = 2, ks+1
        do i = is, ie
          pe2(i,k) = ak(k)
        end do
      end do
      do k = ks+2, km
        do i = is, ie
          pe2(i,k) = ak(k)+bk(k)*pe(i,km+1,j)
        end do
      end do
      do k = 1, km
        do i = is, ie
          dp2(i,k) = pe2(i,k+1)-pe2(i,k)
        end do
      end do
    endif
    do k = 1, km
      do i = is, ie
        delp(i,j,k) = dp2(i,k)
      end do
    end do
    if (nq .ne. 0) then
      do iq = 1, nq
        call mdmap1_q2( km,pe1,q(isd,jsd,1,iq),km,pe2,q2,dp2,is,ie,0,kord_tr,j,isd,ied,jsd,jed )
        if (fill) then
          help_i = ie-is+1
          call fillz( help_i,km,1,q2,dp2 )
        endif
        do k = 1, km
          do i = is, ie
            q(i,j,k,iq) = q2(i,k)
          end do
        end do
      end do
    endif
    do k = 1, km+1
      do i = is, ie
        pk1(i,k) = pk(i,j,k)
      end do
    end do
    do i = is, ie
      pk2(i,1) = pk1(i,1)
      pk2(i,km+1) = pk1(i,km+1)
    end do
    do k = 2, km
      do i = is, ie
        pk2(i,k) = pe2(i,k)**akap
      end do
    end do
    if (te_map) then
      do i = is, ie
        phis(i,km+1) = hs(i,j)
      end do
      do k = km, 1, -1
        do i = is, ie
          phis(i,k) = phis(i,k+1)+pt(i,j,k)*(pk1(i,k+1)-pk1(i,k))
        end do
      end do
      do k = 1, km+1
        do i = is, ie
          phis(i,k) = phis(i,k)*pe1(i,k)
        end do
      end do
      do k = 1, km
        do i = is, ie
          te(i,j,k) = te(i,j,k)+(phis(i,k+1)-phis(i,k))/(pe1(i,k+1)-pe1(i,k))
        end do
      end do
      call mdmap1_ppm( km,pe1,te,km,pe2,te,is,ie,j,is,ie,js,je,1,kord_tm )
    else
      if (remap_t) then
        do k = 1, km+1
          do i = is, ie
            pn2(i,k) = log(pe2(i,k))
          end do
        end do
        help_j = abs(kord_tm)
        call mdmap1_ppm( km,peln(is,1,j),pt,km,pn2,pt,is,ie,j,isd,ied,jsd,jed,1,help_j )
      else
        help_k = abs(kord_tm)
        call mdmap1_ppm( km,pk1,pt,km,pk2,pt,is,ie,j,isd,ied,jsd,jed,1,help_k )
      endif
    endif
    if ( .not. hydrostatic) then
      call mdmap1_ppm( km,pe1,w,km,pe2,w,is,ie,j,isd,ied,jsd,jed,help_l,kord_mt )
      if ( .not. hybrid_z) then
        help_m = abs(kord_tm)
        call mdmap1_ppm( km,pe1,delz,km,pe2,delz,is,ie,j,is,ie,js,je,1,help_m )
        do k = 1, km
          do i = is, ie
            delz(i,j,k) = -(delz(i,j,k)*dp2(i,k))
          end do
        end do
      endif
    endif
    do k = 2, km
      do i = is, ie
        pk(i,j,k) = pk2(i,k)
      end do
    end do
    do i = is, ie
      pe3(i,1) = 0.
    end do
    do k = 2, km+1
      do i = is, ie
        pe3(i,k) = omga(i,j,k-1)
      end do
    end do
    do k = 1, km+1
      do i = is, ie
        pe0(i,k) = peln(i,k,j)
      end do
    end do
    if (hybrid_z) then
      do k = 2, km+1
        do i = is, ie
          peln(i,k,j) = log(pe2(i,k))
        end do
      end do
    else
      if (remap_t) then
        do k = 1, km+1
          do i = is, ie
            peln(i,k,j) = pn2(i,k)
          end do
        end do
      else
        do k = 2, ks+1
          tmp = log(ak(k))
          do i = is, ie
            peln(i,k,j) = tmp
          end do
        end do
        do k = ks+2, km+1
          do i = is, ie
            peln(i,k,j) = log(pe2(i,k))
          end do
        end do
        if (ptop .lt. ptop_min) then
          do i = is, ie
            peln(i,1,j) = peln(i,2,j)-ak1
          end do
        else
          tmp = log(ptop)
          do i = is, ie
            peln(i,1,j) = tmp
          end do
        endif
      endif
    endif
    if (hydrostatic) then
      do k = 1, km
        do i = is, ie
          pkz(i,j,k) = (pk2(i,k+1)-pk2(i,k))/(akap*(peln(i,k+1,j)-peln(i,k,j)))
        end do
      end do
    else
      if (ktop .gt. 1) then
        do k = 1, ktop-1
          do i = is, ie
            pkz(i,j,k) = (pk2(i,k+1)-pk2(i,k))/(akap*(peln(i,k+1,j)-peln(i,k,j)))
          end do
        end do
      endif
      do k = ktop, km
        do i = is, ie
          pkz(i,j,k) = (kapag*delp(i,j,k)*pt(i,j,k)/(delz(i,j,k)*(1.+r_vir*q(i,j,k,1))))**k1k
        end do
      end do
    endif
    do k = 1, km
      do i = is, ie
        dp2(i,k) = 0.5*(peln(i,k,j)+peln(i,k+1,j))
      end do
    end do
    do i = is, ie
      k_next = 1
      do n = 1, km
        kp = k_next
        k = kp
        k_loop =  .false. 
        if (dp2(i,n) .le. pe0(i,k+1) .and. dp2(i,n) .ge. pe0(i,k)) then
          omga(i,j,n) = pe3(i,k)+(pe3(i,k+1)-pe3(i,k))*(dp2(i,n)-pe0(i,k))/(pe0(i,k+1)-pe0(i,k))
          k_next = k
          k_loop =  .true. 
        endif
        idow = 0
        do while ( k_loop .eq.  .false.  .or. k .lt. km )
          idow = idow+1
          k = k+1
          if (dp2(i,n) .le. pe0(i,k+1) .and. dp2(i,n) .ge. pe0(i,k)) then
            omga(i,j,n) = pe3(i,k)+(pe3(i,k+1)-pe3(i,k))*(dp2(i,n)-pe0(i,k))/(pe0(i,k+1)-pe0(i,k))
            k_next = k
            k_loop =  .true. 
          endif
        end do
        call getkey( 2,3,((j-js+i-is)*(1+j-js+i-is)/2+j-js+n-1)*(1+(j-js+i-is)*(1+j-js+i-is)/2+j-js+n-1)/2+(j-js+i-is)*(1+j-js+i-&
&is)/2+j-js,0,adsubcl(1,2),nrec )
        call adstore( 'memory_3_f_dyn_idow',19,idow,4,1,nrec )
      end do
    end do
  endif
  if ( .not. hybrid_z) then
    do i = is, ie+1
      pe0(i,1) = pe(i,1,j)
    end do
    do k = 2, km+1
      do i = is, ie
        pe0(i,k) = 0.5*(pe(i,k,j-1)+pe1(i,k))
      end do
    end do
    do k = 1, ks+1
      do i = is, ie+1
        pe3(i,k) = ak(k)
      end do
    end do
    do k = ks+2, km+1
      bkh = 0.5*bk(k)
      do i = is, ie
        pe3(i,k) = ak(k)+bkh*(pe(i,km+1,j-1)+pe1(i,km+1))
      end do
    end do
    help_n = jed+1
    help_o = -1
    call mdmap1_ppm( km,pe0(is:ie,:),u,km,pe3(is:ie,:),u,is,ie,j,isd,ied,jsd,help_n,help_o,kord_mt )
    if (j .lt. je+1) then
      do k = 2, km+1
        do i = is, ie+1
          pe0(i,k) = 0.5*(pe(i-1,k,j)+pe(i,k,j))
        end do
      end do
      do k = ks+2, km+1
        bkh = 0.5*bk(k)
        do i = is, ie+1
          pe3(i,k) = ak(k)+bkh*(pe(i-1,km+1,j)+pe(i,km+1,j))
        end do
      end do
      help_p = ie+1
      help_q = ied+1
      help_r = -1
      call mdmap1_ppm( km,pe0,v,km,pe3,v,is,help_p,j,isd,help_q,jsd,jed,help_r,kord_mt )
    endif
  endif
  do k = 1, km
    do i = is, ie
      ua(i,j,k) = pe2(i,k+1)
    end do
  end do
end do
if (hybrid_z) then
  do j = js, je+1
    do i = is, ie
      pe1(i,1) = ptop
      pe2(i,1) = ptop
    end do
    do k = 2, km+1
      do i = is, ie
        pe1(i,k) = 0.5*(pe(i,k,j-1)+pe(i,k,j))
        pe2(i,k) = 0.5*(ua(i,j-1,k-1)+ua(i,j,k-1))
      end do
    end do
    help_s = jed+1
    help_t = -1
    call mdmap1_ppm( km,pe1,u,km,pe2,u,is,ie,j,isd,ied,jsd,help_s,help_t,kord_mt )
  end do
  do j = js, je
    do i = is, ie+1
      pe0(i,1) = ptop
      pe3(i,1) = ptop
    end do
    do k = 2, km+1
      do i = is, ie+1
        pe0(i,k) = 0.5*(pe(i-1,k,j)+pe(i,k,j))
        pe3(i,k) = 0.5*(ua(i-1,j,k-1)+ua(i,j,k-1))
      end do
    end do
    help_u = ie+1
    help_v = ied+1
    help_w = -1
    call mdmap1_ppm( km,pe0,v,km,pe3,v,is,help_u,j,isd,help_v,jsd,jed,help_w,kord_mt )
  end do
endif
do k = 2, km
  do j = js, je
    do i = is, ie
      pe(i,k,j) = ua(i,j,k-1)
    end do
  end do
end do
call cubed_to_latlon( u,v,ua,va,dx,dy,dxa,dya,km )
if (consv .gt. 0.) then
  if (te_map) then
  else
    do j = js, je
      if (remap_t) then
        do i = is, ie
          gz(i) = hs(i,j)
          do k = 1, km
            gz(i) = gz(i)+rg*pt(i,j,k)*(peln(i,k+1,j)-peln(i,k,j))
          end do
        end do
      else
        do i = is, ie
          gz(i) = hs(i,j)
          do k = 1, km
            gz(i) = gz(i)+pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))
          end do
        end do
      endif
    end do
  endif
  help_x = g_sum(te_2d,is,ie,js,je,ng,area)
  tpe = consv*help_x
  help_y = g_sum(zsum,is,ie,js,je,ng,area)
  dtmp = tpe/(cp*help_y)
  if (reproduce_sum) then
    dtmp = real(dtmp,4)
  endif
else
  dtmp = 0.
endif
if (te_map) then
  do j = js, je
    do i = is, ie
      gz(i) = hs(i,j)
    end do
    do k = km, 1, -1
      do i = is, ie
        tpe = te(i,j,k)-0.5*(ua(i,j,k)**2+va(i,j,k)**2)-gz(i)
        dlnp = rg*(peln(i,k+1,j)-peln(i,k,j))
        tmp = tpe/((cp-pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,1)))
        pt(i,j,k) = tmp+dtmp*pkz(i,j,k)/(1.+r_vir*q(i,j,k,1))
        gz(i) = gz(i)+dlnp*tmp*(1.+r_vir*q(i,j,k,1))
      end do
    end do
  end do
else
  if (remap_t) then
    do k = 1, km
      do j = js, je
        do i = is, ie
          pt(i,j,k) = (pt(i,j,k)+dtmp*pkz(i,j,k))/(1.+r_vir*q(i,j,k,1))
        end do
      end do
    end do
  else
    do k = 1, km
      do j = js, je
        do i = is, ie
          pt(i,j,k) = (rcp*pt(i,j,k)+dtmp)*pkz(i,j,k)/(1.+r_vir*q(i,j,k,1))
        end do
      end do
    end do
  endif
endif
!----------------------------------------------
! COUNT SUBROUTINE CALLS
!----------------------------------------------
call adcount( 2,1 )

end subroutine mdlagrangian_to_eulerian


subroutine mdmap1_ppm( km, pe1, q1, kn, pe2, q2, i1, i2, j, ibeg, iend, jbeg, jend, iv, kord )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r23 = 2./3.
real, parameter :: r3 = 1./3.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: ibeg
integer, intent(in) :: iend
integer, intent(in) :: iv
integer, intent(in) :: j
integer, intent(in) :: jbeg
integer, intent(in) :: jend
integer, intent(in) :: km
integer, intent(in) :: kn
integer, intent(in) :: kord
real, intent(in) :: pe1(i1:i2,km+1)
real, intent(in) :: pe2(i1:i2,kn+1)
real, intent(in) :: q1(ibeg:iend,jbeg:jend,km)
real, intent(inout) :: q2(ibeg:iend,jbeg:jend,kn)

!==============================================
! declare local variables
!==============================================
real :: dp
real :: dp1(i1:i2,km)
real :: esl
integer :: i
integer :: idow
integer :: idox
integer :: k
integer :: k0
integer :: l
logical :: l_123
logical :: l_555
logical :: l_loop
integer :: m
logical :: m_123
integer :: nrec
real :: pl
real :: pr
real :: q4(4,i1:i2,km)
real :: qsum

!==============================================
! declare external procedures and functions
!==============================================
integer, external :: adsubcl

!**********************************************
! executable statements of routine
!**********************************************
do k = 1, km
  do i = i1, i2
    dp1(i,k) = pe1(i,k+1)-pe1(i,k)
    q4(1,i,k) = q1(i,j,k)
  end do
end do
if (kord .gt. 7) then
  call cs_profile( q4,dp1,km,i1,i2,iv,kord )
else
  call ppm_profile( q4,dp1,km,i1,i2,iv,kord )
endif
do i = i1, i2
  k0 = 1
  do k = 1, kn
    l_123 =  .false. 
    l_555 =  .false. 
    l_loop =  .false. 
    l = k0
    if (l_loop .eq.  .false. ) then
      if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
        pl = (pe2(i,k)-pe1(i,l))/dp1(i,l)
        if (pe2(i,k+1) .le. pe1(i,l+1)) then
          pr = (pe2(i,k+1)-pe1(i,l))/dp1(i,l)
          q2(i,j,k) = q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(pr+pl)-q4(4,i,l)*r3*(pr*(pr+pl)+pl**2)
          k0 = l
          l_555 =  .true. 
        else
          if (l_123 .eq.  .false. ) then
            qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
            m_123 =  .false. 
            m = l+1
            if (m_123 .eq.  .false. ) then
              if (pe2(i,k+1) .gt. pe1(i,m+1)) then
qsum = qsum+dp1(i,m)*q4(1,i,m)
              else
dp = pe2(i,k+1)-pe1(i,m)
esl = dp/dp1(i,m)
qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
k0 = m
m_123 =  .true. 
              endif
            endif
            do while ( m_123 .eq.  .false.  .or. m .lt. km )
              m = m+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  dp = pe2(i,k+1)-pe1(i,m)
  esl = dp/dp1(i,m)
  qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
            end do
            l_123 =  .true. 
          endif
        endif
      endif
      if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
        l_loop =  .true. 
      endif
    endif
    if (l_loop .eq.  .false.  .and. l .lt. km) then
      l = l+1
    endif
    idow = 0
    do while ( l_loop .eq.  .false.  .and. l .le. km )
      idow = idow+1
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
          pl = (pe2(i,k)-pe1(i,l))/dp1(i,l)
          if (pe2(i,k+1) .le. pe1(i,l+1)) then
            pr = (pe2(i,k+1)-pe1(i,l))/dp1(i,l)
            q2(i,j,k) = q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(pr+pl)-q4(4,i,l)*r3*(pr*(pr+pl)+pl**2)
            k0 = l
            l_555 =  .true. 
          else
            if (l_123 .eq.  .false. ) then
              qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  dp = pe2(i,k+1)-pe1(i,m)
  esl = dp/dp1(i,m)
  qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
              idox = 0
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
idox = idox+1
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .gt. pe1(i,m+1)) then
    qsum = qsum+dp1(i,m)*q4(1,i,m)
  else
    dp = pe2(i,k+1)-pe1(i,m)
    esl = dp/dp1(i,m)
    qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
              end do
              call getkey( 2,1,((i-i1+k-1)*(1+i-i1+k-1)/2+i-i1+idow-1)*(1+(i-i1+k-1)*(1+i-i1+k-1)/2+i-i1+idow-1)/2+(i-i1+k-1)*(1+i-&
&i1+k-1)/2+i-i1,0,adsubcl(1,1),nrec )
              call adstore( 'memory_1_f_dyn_idox',19,idox,4,1,nrec )
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
    end do
    call getkey( 2,2,(i-i1+k-1)*(1+i-i1+k-1)/2+i-i1,0,adsubcl(1,1),nrec )
    call adstore( 'memory_2_f_dyn_idow',19,idow,4,1,nrec )
    if (l_555 .eq.  .false. ) then
      q2(i,j,k) = qsum/(pe2(i,k+1)-pe2(i,k))
    endif
  end do
end do
!----------------------------------------------
! COUNT SUBROUTINE CALLS
!----------------------------------------------
call adcount( 1,1 )

end subroutine mdmap1_ppm


subroutine mdmap1_q2( km, pe1, q1, kn, pe2, q2, dp2, i1, i2, iv, kord, j, ibeg, iend, jbeg, jend )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r23 = 2./3.
real, parameter :: r3 = 1./3.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: kn
real, intent(in) :: dp2(i1:i2,kn)
integer, intent(in) :: ibeg
integer, intent(in) :: iend
integer, intent(in) :: iv
integer, intent(in) :: j
integer, intent(in) :: jbeg
integer, intent(in) :: jend
integer, intent(in) :: km
integer, intent(in) :: kord
real, intent(in) :: pe1(i1:i2,km+1)
real, intent(in) :: pe2(i1:i2,kn+1)
real, intent(in) :: q1(ibeg:iend,jbeg:jend,km)
real, intent(inout) :: q2(i1:i2,kn)

!==============================================
! declare local variables
!==============================================
real :: dp
real :: dp1(i1:i2,km)
real :: esl
integer :: i
integer :: idow
integer :: idox
integer :: k
integer :: k0
integer :: l
logical :: l_123
logical :: l_555
logical :: l_loop
integer :: m
logical :: m_123
integer :: nrec
real :: pl
real :: pr
real :: q4(4,i1:i2,km)
real :: qsum

!==============================================
! declare external procedures and functions
!==============================================
integer, external :: adsubcl

!**********************************************
! executable statements of routine
!**********************************************
do k = 1, km
  do i = i1, i2
    dp1(i,k) = pe1(i,k+1)-pe1(i,k)
    q4(1,i,k) = q1(i,j,k)
  end do
end do
if (kord .gt. 7) then
  call cs_profile( q4,dp1,km,i1,i2,iv,kord )
else
  call ppm_profile( q4,dp1,km,i1,i2,iv,kord )
endif
do i = i1, i2
  k0 = 1
  do k = 1, kn
    l_123 =  .false. 
    l_555 =  .false. 
    l_loop =  .false. 
    l = k0
    if (l_loop .eq.  .false. ) then
      if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
        pl = (pe2(i,k)-pe1(i,l))/dp1(i,l)
        if (pe2(i,k+1) .le. pe1(i,l+1)) then
          pr = (pe2(i,k+1)-pe1(i,l))/dp1(i,l)
          q2(i,k) = q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(pr+pl)-q4(4,i,l)*r3*(pr*(pr+pl)+pl**2)
          k0 = l
          l_555 =  .true. 
        else
          if (l_123 .eq.  .false. ) then
            qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
            m_123 =  .false. 
            m = l+1
            if (m_123 .eq.  .false. ) then
              if (pe2(i,k+1) .gt. pe1(i,m+1)) then
qsum = qsum+dp1(i,m)*q4(1,i,m)
              else
dp = pe2(i,k+1)-pe1(i,m)
esl = dp/dp1(i,m)
qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
k0 = m
m_123 =  .true. 
              endif
            endif
            do while ( m_123 .eq.  .false.  .or. m .lt. km )
              m = m+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  dp = pe2(i,k+1)-pe1(i,m)
  esl = dp/dp1(i,m)
  qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
            end do
            l_123 =  .true. 
          endif
        endif
      endif
      if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
        l_loop =  .true. 
      endif
    endif
    if (l_loop .eq.  .false.  .and. l .lt. km) then
      l = l+1
    endif
    idow = 0
    do while ( l_loop .eq.  .false.  .and. l .le. km )
      idow = idow+1
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k) .ge. pe1(i,l) .and. pe2(i,k) .le. pe1(i,l+1)) then
          pl = (pe2(i,k)-pe1(i,l))/dp1(i,l)
          if (pe2(i,k+1) .le. pe1(i,l+1)) then
            pr = (pe2(i,k+1)-pe1(i,l))/dp1(i,l)
            q2(i,k) = q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(pr+pl)-q4(4,i,l)*r3*(pr*(pr+pl)+pl**2)
            k0 = l
            l_555 =  .true. 
          else
            if (l_123 .eq.  .false. ) then
              qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .gt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  dp = pe2(i,k+1)-pe1(i,m)
  esl = dp/dp1(i,m)
  qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
              idox = 0
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
idox = idox+1
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .gt. pe1(i,m+1)) then
    qsum = qsum+dp1(i,m)*q4(1,i,m)
  else
    dp = pe2(i,k+1)-pe1(i,m)
    esl = dp/dp1(i,m)
    qsum = qsum+dp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
              end do
              call getkey( 2,4,((i-i1+k-1)*(1+i-i1+k-1)/2+i-i1+idow-1)*(1+(i-i1+k-1)*(1+i-i1+k-1)/2+i-i1+idow-1)/2+(i-i1+k-1)*(1+i-&
&i1+k-1)/2+i-i1,0,adsubcl(1,3),nrec )
              call adstore( 'memory_4_f_dyn_idox',19,idox,4,1,nrec )
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
    end do
    call getkey( 2,5,(i-i1+k-1)*(1+i-i1+k-1)/2+i-i1,0,adsubcl(1,3),nrec )
    call adstore( 'memory_5_f_dyn_idow',19,idow,4,1,nrec )
    if (l_555 .eq.  .false. ) then
      q2(i,k) = qsum/dp2(i,k)
    endif
  end do
end do
!----------------------------------------------
! COUNT SUBROUTINE CALLS
!----------------------------------------------
call adcount( 3,1 )

end subroutine mdmap1_q2


subroutine mdremap_z( km, pe1, q1, kn, pe2, q2, i1, i2, kord )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r23 = 2./3.
real, parameter :: r3 = 1./3.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: i1
integer, intent(in) :: i2
integer, intent(in) :: km
integer, intent(in) :: kn
integer, intent(in) :: kord
real, intent(in) :: pe1(i1:i2,km+1)
real, intent(in) :: pe2(i1:i2,kn+1)
real, intent(in) :: q1(i1:i2,km)
real, intent(inout) :: q2(i1:i2,kn)

!==============================================
! declare local variables
!==============================================
real :: delp
real :: dp1(i1:i2,km)
real :: esl
integer :: i
integer :: idow
integer :: idox
integer :: k
integer :: k0
integer :: l
logical :: l_123
logical :: l_555
logical :: l_loop
integer :: m
logical :: m_123
integer :: nrec
real :: pl
real :: pr
real :: q4(4,i1:i2,km)
real :: qsum

!==============================================
! declare external procedures and functions
!==============================================
integer, external :: adsubcl

!**********************************************
! executable statements of routine
!**********************************************
do k = 1, km
  do i = i1, i2
    dp1(i,k) = pe1(i,k+1)-pe1(i,k)
    q4(1,i,k) = q1(i,k)
  end do
end do
if (kord .gt. 7) then
  call cs_profile( q4,dp1,km,i1,i2,1,kord )
else
  call ppm_profile( q4,dp1,km,i1,i2,1,kord )
endif
do i = i1, i2
  k0 = 1
  do k = 1, kn
    l_123 =  .false. 
    l_555 =  .false. 
    l_loop =  .false. 
    l = k0
    if (l_loop .eq.  .false. ) then
      if (pe2(i,k) .le. pe1(i,l) .and. pe2(i,k) .ge. pe1(i,l+1)) then
        pl = (pe2(i,k)-pe1(i,l))/dp1(i,l)
        if (pe2(i,k+1) .ge. pe1(i,l+1)) then
          if (l_555 .eq.  .false. ) then
            pr = (pe2(i,k+1)-pe1(i,l))/dp1(i,l)
            q2(i,k) = q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(pr+pl)-q4(4,i,l)*r3*(pr*(pr+pl)+pl**2)
            k0 = l
            l_555 =  .true. 
          endif
        else
          if (l_123 .eq.  .false. ) then
            qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
            m_123 =  .false. 
            m = l+1
            if (m_123 .eq.  .false. ) then
              if (pe2(i,k+1) .lt. pe1(i,m+1)) then
qsum = qsum+dp1(i,m)*q4(1,i,m)
              else
delp = pe2(i,k+1)-pe1(i,m)
esl = delp/dp1(i,m)
qsum = qsum+delp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
k0 = m
m_123 =  .true. 
              endif
            endif
            do while ( m_123 .eq.  .false.  .or. m .lt. km )
              m = m+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .lt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  delp = pe2(i,k+1)-pe1(i,m)
  esl = delp/dp1(i,m)
  qsum = qsum+delp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
            end do
            l_123 =  .true. 
          endif
        endif
      endif
      if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
        l_loop =  .true. 
      endif
    endif
    if (l_loop .eq.  .false.  .and. l .lt. km) then
      l = l+1
    endif
    idow = 0
    do while ( l_loop .eq.  .false.  .and. l .le. km )
      idow = idow+1
      if (l_loop .eq.  .false. ) then
        if (pe2(i,k) .le. pe1(i,l) .and. pe2(i,k) .ge. pe1(i,l+1)) then
          pl = (pe2(i,k)-pe1(i,l))/dp1(i,l)
          if (pe2(i,k+1) .ge. pe1(i,l+1)) then
            if (l_555 .eq.  .false. ) then
              pr = (pe2(i,k+1)-pe1(i,l))/dp1(i,l)
              q2(i,k) = q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(pr+pl)-q4(4,i,l)*r3*(pr*(pr+pl)+pl**2)
              k0 = l
              l_555 =  .true. 
            endif
          else
            if (l_123 .eq.  .false. ) then
              qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*r3*(1.+pl*(1.+pl)))
              m_123 =  .false. 
              m = l+1
              if (m_123 .eq.  .false. ) then
if (pe2(i,k+1) .lt. pe1(i,m+1)) then
  qsum = qsum+dp1(i,m)*q4(1,i,m)
else
  delp = pe2(i,k+1)-pe1(i,m)
  esl = delp/dp1(i,m)
  qsum = qsum+delp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
  k0 = m
  m_123 =  .true. 
endif
              endif
              idox = 0
              do while ( m_123 .eq.  .false.  .or. m .lt. km )
idox = idox+1
m = m+1
if (m_123 .eq.  .false. ) then
  if (pe2(i,k+1) .lt. pe1(i,m+1)) then
    qsum = qsum+dp1(i,m)*q4(1,i,m)
  else
    delp = pe2(i,k+1)-pe1(i,m)
    esl = delp/dp1(i,m)
    qsum = qsum+delp*(q4(2,i,m)+0.5*esl*(q4(3,i,m)-q4(2,i,m)+q4(4,i,m)*(1.-r23*esl)))
    k0 = m
    m_123 =  .true. 
  endif
endif
              end do
              call getkey( 2,6,((i-i1+k-1)*(1+i-i1+k-1)/2+i-i1+idow-1)*(1+(i-i1+k-1)*(1+i-i1+k-1)/2+i-i1+idow-1)/2+(i-i1+k-1)*(1+i-&
&i1+k-1)/2+i-i1,0,adsubcl(1,4),nrec )
              call adstore( 'memory_6_f_dyn_idox',19,idox,4,1,nrec )
              l_123 =  .true. 
            endif
          endif
        endif
        if (l_555 .eq. ( .true. ) .or. l_123 .eq. ( .true. ) .or. m_123 .eq. ( .true. )) then
          l_loop =  .true. 
        endif
      endif
      if (l_loop .eq.  .false.  .and. l .lt. km) then
        l = l+1
      endif
    end do
    call getkey( 2,7,(i-i1+k-1)*(1+i-i1+k-1)/2+i-i1,0,adsubcl(1,4),nrec )
    call adstore( 'memory_7_f_dyn_idow',19,idow,4,1,nrec )
    if (l_555 .eq.  .false. ) then
      q2(i,k) = qsum/(pe2(i,k+1)-pe2(i,k))
    endif
  end do
end do
!----------------------------------------------
! COUNT SUBROUTINE CALLS
!----------------------------------------------
call adcount( 4,1 )

end subroutine mdremap_z


end module     admapz_module


