!                           DISCLAIMER
!
!   This file was generated by TAF version 1.9.22
!
!   FASTOPT DISCLAIMS  ALL  WARRANTIES,  EXPRESS  OR  IMPLIED,
!   INCLUDING (WITHOUT LIMITATION) ALL IMPLIED  WARRANTIES  OF
!   MERCHANTABILITY  OR FITNESS FOR A PARTICULAR PURPOSE, WITH
!   RESPECT TO THE SOFTWARE AND USER PROGRAMS.   IN  NO  EVENT
!   SHALL  FASTOPT BE LIABLE FOR ANY LOST OR ANTICIPATED PROF-
!   ITS, OR ANY INDIRECT, INCIDENTAL, EXEMPLARY,  SPECIAL,  OR
!   CONSEQUENTIAL  DAMAGES, WHETHER OR NOT FASTOPT WAS ADVISED
!   OF THE POSSIBILITY OF SUCH DAMAGES.
!
!                           Haftungsbeschraenkung
!   FastOpt gibt ausdruecklich keine Gewaehr, explizit oder indirekt,
!   bezueglich der Brauchbarkeit  der Software  fuer einen bestimmten
!   Zweck.   Unter  keinen  Umstaenden   ist  FastOpt   haftbar  fuer
!   irgendeinen Verlust oder nicht eintretenden erwarteten Gewinn und
!   allen indirekten,  zufaelligen,  exemplarischen  oder  speziellen
!   Schaeden  oder  Folgeschaeden  unabhaengig  von einer eventuellen
!   Mitteilung darueber an FastOpt.
!
module     g_tpcore
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! referencing used modules
!==============================================
use pre_direct
use mp_mod, only : ie,ied,is,isd,je,jed,js,jsd,ng
use grid_utils, only : cx1,cx2,cy1,cy2,ne_corner,nw_corner,se_corner,sw_corner
use grid_tools, only : dxa,dya,grid_type
use tpcore

!==============================================
! all entries are defined explicitly
!==============================================
implicit none

contains
subroutine g_copy_corners( q, g_q, npx, npy, dir )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: dir
real, intent(inout) :: g_q(isd:ied,jsd:jed)
integer, intent(in) :: npx
integer, intent(in) :: npy
real, intent(inout) :: q(isd:ied,jsd:jed)

!==============================================
! declare local variables
!==============================================
integer :: i
integer :: j

!----------------------------------------------
! TANGENT LINEAR AND FUNCTION STATEMENTS
!----------------------------------------------
if (dir .eq. 1) then
  if (sw_corner) then
    do j = 1-ng, 0
      do i = 1-ng, 0
        g_q(i,j) = g_q(j,1-i)
        q(i,j) = q(j,1-i)
      end do
    end do
  endif
  if (se_corner) then
    do j = 1-ng, 0
      do i = npx, npx+ng-1
        g_q(i,j) = g_q(npy-j,1+i-npx)
        q(i,j) = q(npy-j,1+i-npx)
      end do
    end do
  endif
  if (ne_corner) then
    do j = npy, npy+ng-1
      do i = npx, npx+ng-1
        g_q(i,j) = g_q(j,2*npx-1-i)
        q(i,j) = q(j,2*npx-1-i)
      end do
    end do
  endif
  if (nw_corner) then
    do j = npy, npy+ng-1
      do i = 1-ng, 0
        g_q(i,j) = g_q(npy-j,i-1+npx)
        q(i,j) = q(npy-j,i-1+npx)
      end do
    end do
  endif
else if (dir .eq. 2) then
  if (sw_corner) then
    do j = 1-ng, 0
      do i = 1-ng, 0
        g_q(i,j) = g_q(1-j,i)
        q(i,j) = q(1-j,i)
      end do
    end do
  endif
  if (se_corner) then
    do j = 1-ng, 0
      do i = npx, npx+ng-1
        g_q(i,j) = g_q(npy+j-1,npx-i)
        q(i,j) = q(npy+j-1,npx-i)
      end do
    end do
  endif
  if (ne_corner) then
    do j = npy, npy+ng-1
      do i = npx, npx+ng-1
        g_q(i,j) = g_q(2*npy-1-j,i)
        q(i,j) = q(2*npy-1-j,i)
      end do
    end do
  endif
  if (nw_corner) then
    do j = npy, npy+ng-1
      do i = 1-ng, 0
        g_q(i,j) = g_q(1+j-npx,npy-i)
        q(i,j) = q(1+j-npx,npy-i)
      end do
    end do
  endif
endif

end subroutine g_copy_corners


subroutine g_fv_tp_2d( q, g_q, crx, g_crx, cry, g_cry, npx, npy, hord, fx, g_fx, fy, g_fy, xfx, g_xfx, yfx, g_yfx, area, ra_x, &
&g_ra_x, ra_y, g_ra_y, uni_ppm, mfx, g_mfx, mfy, g_mfy )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
real, intent(in) :: area(isd:ied,jsd:jed)
real, intent(in) :: crx(is:ie+1,jsd:jed)
real, intent(in) :: cry(isd:ied,js:je+1)
real, intent(out) :: fx(is:ie+1,js:je)
real, intent(out) :: fy(is:ie,js:je+1)
real, intent(in) :: g_crx(is:ie+1,jsd:jed)
real, intent(in) :: g_cry(isd:ied,js:je+1)
real, intent(out) :: g_fx(is:ie+1,js:je)
real, intent(out) :: g_fy(is:ie,js:je+1)
real,optional, intent(in) :: g_mfx(is:ie+1,js:je)
real,optional, intent(in) :: g_mfy(is:ie,js:je+1)
real, intent(inout) :: g_q(isd:ied,jsd:jed)
real, intent(in) :: g_ra_x(is:ie,jsd:jed)
real, intent(in) :: g_ra_y(isd:ied,js:je)
real, intent(in) :: g_xfx(is:ie+1,jsd:jed)
real, intent(in) :: g_yfx(isd:ied,js:je+1)
integer, intent(in) :: hord
real,optional, intent(in) :: mfx(is:ie+1,js:je)
real,optional, intent(in) :: mfy(is:ie,js:je+1)
integer, intent(in) :: npx
integer, intent(in) :: npy
real, intent(inout) :: q(isd:ied,jsd:jed)
real, intent(in) :: ra_x(is:ie,jsd:jed)
real, intent(in) :: ra_y(isd:ied,js:je)
logical, intent(in) :: uni_ppm
real, intent(in) :: xfx(is:ie+1,jsd:jed)
real, intent(in) :: yfx(isd:ied,js:je+1)

!==============================================
! declare local variables
!==============================================
real :: fx1(is:ie+1)
real :: fx2(is:ie+1,jsd:jed)
real :: fy2(isd:ied,js:je+1)
real :: fyy(isd:ied,js:je+1)
real :: g_fx1(is:ie+1)
real :: g_fx2(is:ie+1,jsd:jed)
real :: g_fy2(isd:ied,js:je+1)
real :: g_fyy(isd:ied,js:je+1)
real :: g_q_i(isd:ied,js:je)
real :: g_q_j(is:ie,jsd:jed)
integer :: i
integer :: j
real :: q_i(isd:ied,js:je)
real :: q_j(is:ie,jsd:jed)

!----------------------------------------------
! TANGENT LINEAR AND FUNCTION STATEMENTS
!----------------------------------------------
call g_copy_corners( q,g_q,npx,npy,2 )
call g_ytp( fy2,g_fy2,q,g_q,cry,g_cry,hord,isd,ied,js,je,npx,npy,uni_ppm )
do j = js, je+1
  do i = isd, ied
    g_fyy(i,j) = g_fy2(i,j)*yfx(i,j)+g_yfx(i,j)*fy2(i,j)
    fyy(i,j) = yfx(i,j)*fy2(i,j)
  end do
end do
do j = js, je
  do i = isd, ied
    g_q_i(i,j) = (-(g_fyy(i,j+1)/ra_y(i,j)))+g_fyy(i,j)/ra_y(i,j)+g_q(i,j)*(area(i,j)/ra_y(i,j))-g_ra_y(i,j)*((q(i,j)*area(i,j)+&
&fyy(i,j)-fyy(i,j+1))/(ra_y(i,j)*ra_y(i,j)))
    q_i(i,j) = (q(i,j)*area(i,j)+fyy(i,j)-fyy(i,j+1))/ra_y(i,j)
  end do
end do
call g_xtp( fx,g_fx,q_i,g_q_i,crx(is,js),g_crx(is,js),hord,is,ie,js,je,npx,npy,uni_ppm )
call g_copy_corners( q,g_q,npx,npy,1 )
call g_xtp( fx2,g_fx2,q,g_q,crx,g_crx,hord,is,ie,jsd,jed,npx,npy,uni_ppm )
do j = jsd, jed
  do i = is, ie+1
    g_fx1(i) = g_fx2(i,j)*xfx(i,j)+g_xfx(i,j)*fx2(i,j)
    fx1(i) = xfx(i,j)*fx2(i,j)
  end do
  do i = is, ie
    g_q_j(i,j) = (-(g_fx1(i+1)/ra_x(i,j)))+g_fx1(i)/ra_x(i,j)+g_q(i,j)*(area(i,j)/ra_x(i,j))-g_ra_x(i,j)*((q(i,j)*area(i,j)+fx1(i)-&
&fx1(i+1))/(ra_x(i,j)*ra_x(i,j)))
    q_j(i,j) = (q(i,j)*area(i,j)+fx1(i)-fx1(i+1))/ra_x(i,j)
  end do
end do
call g_ytp( fy,g_fy,q_j,g_q_j,cry,g_cry,hord,is,ie,js,je,npx,npy,uni_ppm )
if (present(mfx) .and. present(mfy)) then
  do j = js, je
    do i = is, ie+1
      g_fx(i,j) = 0.5*g_fx(i,j)*mfx(i,j)+0.5*g_fx2(i,j)*mfx(i,j)+0.5*g_mfx(i,j)*(fx(i,j)+fx2(i,j))
      fx(i,j) = 0.5*(fx(i,j)+fx2(i,j))*mfx(i,j)
    end do
  end do
  do j = js, je+1
    do i = is, ie
      g_fy(i,j) = 0.5*g_fy(i,j)*mfy(i,j)+0.5*g_fy2(i,j)*mfy(i,j)+0.5*g_mfy(i,j)*(fy(i,j)+fy2(i,j))
      fy(i,j) = 0.5*(fy(i,j)+fy2(i,j))*mfy(i,j)
    end do
  end do
else
  do j = js, je
    do i = is, ie+1
      g_fx(i,j) = 0.5*g_fx(i,j)*xfx(i,j)+0.5*g_fx2(i,j)*xfx(i,j)+0.5*g_xfx(i,j)*(fx(i,j)+fx2(i,j))
      fx(i,j) = 0.5*(fx(i,j)+fx2(i,j))*xfx(i,j)
    end do
  end do
  do j = js, je+1
    do i = is, ie
      g_fy(i,j) = 0.5*g_fy(i,j)*yfx(i,j)+0.5*g_fy2(i,j)*yfx(i,j)+0.5*g_yfx(i,j)*(fy(i,j)+fy2(i,j))
      fy(i,j) = 0.5*(fy(i,j)+fy2(i,j))*yfx(i,j)
    end do
  end do
endif

end subroutine g_fv_tp_2d


subroutine g_fxppm( c, g_c, q, g_q, flux, g_flux, iord, ifirst, ilast, jfirst, jlast, npx, npy, uniform_ppm )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: b1 = 1./30.
real, parameter :: b2 = -(13./60.)
real, parameter :: b3 = -(13./60.)
real, parameter :: b4 = 0.45
real, parameter :: b5 = -0.05
real, parameter :: r3 = 1./3.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: ifirst
integer, intent(in) :: ilast
integer, intent(in) :: jfirst
integer, intent(in) :: jlast
real, intent(in) :: c(ifirst:ilast+1,jfirst:jlast)
real, intent(out) :: flux(ifirst:ilast+1,jfirst:jlast)
real, intent(in) :: g_c(ifirst:ilast+1,jfirst:jlast)
real, intent(out) :: g_flux(ifirst:ilast+1,jfirst:jlast)
real, intent(in) :: g_q(ifirst-ng:ilast+ng,jfirst:jlast)
integer, intent(in) :: iord
integer, intent(in) :: npx
integer, intent(in) :: npy
real, intent(in) :: q(ifirst-ng:ilast+ng,jfirst:jlast)
logical, intent(in) :: uniform_ppm

!==============================================
! declare local variables
!==============================================
real :: al(ifirst-1:ilast+2)
real :: bl(ifirst-1:ilast+1)
real :: blh
real :: bli
real :: blj
real :: blk
real :: bll
real :: blm
real :: bln
real :: blo
real :: blp
real :: blq
real :: blr
real :: bls
real :: blt
real :: blu
real :: blv
real :: blw
real :: blx
real :: bly
real :: blz
real :: blza
real :: blzb
real :: blzc
real :: blzd
real :: blze
real :: blzf
real :: blzg
real :: blzh
real :: blzi
real :: blzj
real :: blzk
real :: blzl
real :: blzm
real :: blzn
real :: blzo
real :: br(ifirst-1:ilast+1)
real :: brh
real :: bri
real :: brj
real :: brk
real :: brl
real :: brm
real :: brn
real :: bro
real :: brp
real :: brq
real :: brr
real :: brs
real :: brt
real :: bru
real :: brv
real :: brw
real :: brx
real :: bry
real :: brz
real :: brza
real :: brzb
real :: brzc
real :: brzd
real :: brze
real :: brzf
real :: brzg
real :: brzh
real :: brzi
real :: brzj
real :: brzk
real :: brzl
real :: brzm
real :: brzn
real :: brzo
real :: c1
real :: dl
real :: dlh
real :: dli
real :: dlj
real :: dlk
real :: dll
real :: dm1(ifirst-2:ilast+2)
real :: dm1h
real :: dm1i
real :: dm1j
real :: dm1k
real :: dm1l
real :: dm1m
real :: dm1n
real :: dm1o
real :: dm1p
real :: dm1q
real :: dm1r
real :: dm1s
real :: dm1t
real :: dm1u
real :: dm1v
real :: dm1w
real :: dm1x
real :: dm1y
real :: dm1z
real :: dm1za
real :: dm1zb
real :: dm1zc
real :: dm1zd
real :: dm1ze
real :: dm1zf
real :: dm1zg
real :: dm1zh
real :: dm1zi
real :: dm1zj
real :: dm1zk
real :: dm1zl
real :: dm1zm
real :: dm1zn
real :: dm1zo
real :: dm1zp
real :: dm1zq
real :: dm1zr
real :: dm1zs
real :: dm1zu
real :: dm1zv
real :: dm1zx
real :: dm1zy
real :: dm1zz
real :: dq(ifirst-3:ilast+2)
real :: dr
real :: drh
real :: dri
real :: drj
real :: drk
real :: drl
real :: g_al(ifirst-1:ilast+2)
real :: g_bl(ifirst-1:ilast+1)
real :: g_bli
real :: g_blj
real :: g_blk
real :: g_bll
real :: g_blm
real :: g_bln
real :: g_blp
real :: g_blq
real :: g_blr
real :: g_bls
real :: g_blt
real :: g_blu
real :: g_blv
real :: g_blw
real :: g_blx
real :: g_bly
real :: g_blz
real :: g_blza
real :: g_blzb
real :: g_blzc
real :: g_blzd
real :: g_blze
real :: g_blzf
real :: g_blzg
real :: g_blzh
real :: g_blzi
real :: g_blzj
real :: g_blzk
real :: g_blzl
real :: g_blzm
real :: g_blzn
real :: g_blzo
real :: g_br(ifirst-1:ilast+1)
real :: g_brh
real :: g_bri
real :: g_brj
real :: g_brk
real :: g_brl
real :: g_brm
real :: g_brn
real :: g_bro
real :: g_brp
real :: g_brq
real :: g_brr
real :: g_brs
real :: g_brt
real :: g_bru
real :: g_brv
real :: g_brw
real :: g_brx
real :: g_bry
real :: g_brz
real :: g_brza
real :: g_brzb
real :: g_brzc
real :: g_brzd
real :: g_brze
real :: g_brzf
real :: g_brzg
real :: g_brzh
real :: g_brzi
real :: g_brzj
real :: g_brzk
real :: g_brzl
real :: g_brzm
real :: g_brzn
real :: g_brzo
real :: g_c1
real :: g_dl
real :: g_dlh
real :: g_dli
real :: g_dlj
real :: g_dlk
real :: g_dm1(ifirst-2:ilast+2)
real :: g_dm1h
real :: g_dm1i
real :: g_dm1j
real :: g_dm1k
real :: g_dm1l
real :: g_dm1m
real :: g_dm1n
real :: g_dm1o
real :: g_dm1p
real :: g_dm1q
real :: g_dm1r
real :: g_dm1s
real :: g_dm1t
real :: g_dm1u
real :: g_dm1v
real :: g_dm1w
real :: g_dm1x
real :: g_dm1y
real :: g_dm1z
real :: g_dm1za
real :: g_dm1zb
real :: g_dm1zc
real :: g_dm1zd
real :: g_dm1ze
real :: g_dm1zf
real :: g_dm1zg
real :: g_dm1zh
real :: g_dm1zi
real :: g_dm1zj
real :: g_dm1zk
real :: g_dm1zl
real :: g_dm1zm
real :: g_dm1zn
real :: g_dm1zo
real :: g_dm1zp
real :: g_dm1zq
real :: g_dm1zr
real :: g_dm1zs
real :: g_dm1zu
real :: g_dm1zv
real :: g_dm1zx
real :: g_dm1zy
real :: g_dm1zz
real :: g_dq(ifirst-3:ilast+2)
real :: g_dr
real :: g_drh
real :: g_dri
real :: g_drj
real :: g_drk
real :: g_drl
real :: g_lac
real :: g_pmp
real :: g_qe
real :: g_xt
real :: g_xth
real :: g_xti
real :: g_xtj
real :: g_xtk
real :: g_xtl
real :: g_xtm
real :: g_xtn
real :: g_xto
real :: g_xtq
real :: g_xtr
real :: g_xts
real :: g_xtt
real :: g_xtu
real :: g_xtv
real :: g_xtw
real :: g_xtx
real :: g_xty
real :: g_xtz
real :: g_xtza
real :: g_xtzb
real :: g_xtzc
real :: g_xtzd
real :: g_xtze
real :: g_xtzf
real :: g_xtzg
real :: g_xtzh
real :: g_xtzi
real :: g_xtzj
real :: g_xtzk
real :: g_xtzl
real :: g_xtzm
real :: g_xtzn
real :: g_xtzo
real :: g_xtzp
real :: g_xtzq
real :: g_xtzr
real :: g_xtzs
real :: g_xtzt
real :: g_xtzu
real :: g_xtzv
real :: g_xtzw
real :: g_xtzx
real :: g_xtzy
real :: g_xtzz
real :: g_xtzza
real :: g_xtzzb
real :: g_xtzzc
real :: g_xtzzd
real :: g_xtzze
real :: g_xtzzf
real :: g_xtzzg
real :: g_xtzzh
real :: g_xtzzi
real :: g_xtzzj
real :: g_xtzzk
real :: g_xtzzl
real :: g_xtzzm
real :: g_xtzzn
real :: g_xtzzo
real :: g_xtzzp
real :: g_xtzzq
real :: g_xtzzr
real :: g_xtzzs
real :: g_xtzzt
integer :: help_h
integer :: help_i
integer :: i
integer :: ie3
integer :: is3
integer :: it
integer :: j
real :: lac
real :: pmp
real :: qe
real :: xt
real :: xth
real :: xti
real :: xtj
real :: xtk
real :: xtl
real :: xtm
real :: xtn
real :: xto
real :: xtq
real :: xtr
real :: xts
real :: xtt
real :: xtu
real :: xtv
real :: xtw
real :: xtx
real :: xty
real :: xtz
real :: xtza
real :: xtzb
real :: xtzc
real :: xtzd
real :: xtze
real :: xtzf
real :: xtzg
real :: xtzh
real :: xtzi
real :: xtzj
real :: xtzk
real :: xtzl
real :: xtzm
real :: xtzn
real :: xtzo
real :: xtzp
real :: xtzq
real :: xtzr
real :: xtzs
real :: xtzt
real :: xtzu
real :: xtzv
real :: xtzw
real :: xtzx
real :: xtzy
real :: xtzz
real :: xtzza
real :: xtzzb
real :: xtzzc
real :: xtzzd
real :: xtzze
real :: xtzzf
real :: xtzzg
real :: xtzzh
real :: xtzzi
real :: xtzzj
real :: xtzzk
real :: xtzzl
real :: xtzzm
real :: xtzzn
real :: xtzzo
real :: xtzzp
real :: xtzzq
real :: xtzzr
real :: xtzzs
real :: xtzzt

!----------------------------------------------
! TANGENT LINEAR AND FUNCTION STATEMENTS
!----------------------------------------------
if (iord .le. 4) then
  do j = jfirst, jlast
    if (uniform_ppm) then
      do i = ifirst-2, ilast+2
        g_xt = (-0.25)*g_q(i-1,j)+0.25*g_q(i+1,j)
        xt = 0.25*(q(i+1,j)-q(i-1,j))
        g_dm1t = g_xt*sign(1.,xt)
        dm1t = abs(xt)
        g_dm1u = g_q(i-1,j)*(0.5+sign(0.5,q(i-1,j)-q(i,j)))+g_q(i,j)*(0.5-sign(0.5,q(i-1,j)-q(i,j)))
        dm1u = max(q(i-1,j),q(i,j))
        g_dm1w = g_dm1u*(0.5+sign(0.5,dm1u-q(i+1,j)))+g_q(i+1,j)*(0.5-sign(0.5,dm1u-q(i+1,j)))-g_q(i,j)
        dm1w = max(dm1u,q(i+1,j))-q(i,j)
        g_dm1x = g_q(i-1,j)*(0.5+sign(0.5,q(i,j)-q(i-1,j)))+g_q(i,j)*(0.5-sign(0.5,q(i,j)-q(i-1,j)))
        dm1x = min(q(i-1,j),q(i,j))
        g_dm1z = (-(g_dm1x*(0.5+sign(0.5,q(i+1,j)-dm1x))+g_q(i+1,j)*(0.5-sign(0.5,q(i+1,j)-dm1x))))+g_q(i,j)
        dm1z = q(i,j)-min(dm1x,q(i+1,j))
        g_dm1za = g_dm1t*(0.5+sign(0.5,dm1w-dm1t))+g_dm1w*(0.5-sign(0.5,dm1w-dm1t))
        dm1za = min(dm1t,dm1w)
        g_dm1zb = g_dm1z*(0.5-sign(0.5,dm1z-dm1za))+g_dm1za*(0.5+sign(0.5,dm1z-dm1za))
        dm1zb = min(dm1za,dm1z)
        g_dm1(i) = g_dm1zb*sign(1.,dm1zb)*sign(1.,xt)
        dm1(i) = sign(dm1zb,xt)
      end do
    else
      do i = ifirst-3, ilast+2
        g_dq(i) = g_q(i+1,j)-g_q(i,j)
        dq(i) = q(i+1,j)-q(i,j)
      end do
      do i = ifirst-2, ilast+2
        g_xt = g_dq(i-1)*cx1(i,j)+g_dq(i)*cx2(i,j)
        xt = cx1(i,j)*dq(i-1)+cx2(i,j)*dq(i)
        g_dm1j = g_xt*sign(1.,xt)
        dm1j = abs(xt)
        g_dm1m = g_dq(i-1)*sign(1.,dq(i-1))
        dm1m = abs(dq(i-1))
        g_dm1q = g_dq(i)*sign(1.,dq(i))
        dm1q = abs(dq(i))
        g_dm1r = g_dm1j*(0.5+sign(0.5,dm1m-dm1j))+g_dm1m*(0.5-sign(0.5,dm1m-dm1j))
        dm1r = min(dm1j,dm1m)
        g_dm1s = g_dm1q*(0.5-sign(0.5,dm1q-dm1r))+g_dm1r*(0.5+sign(0.5,dm1q-dm1r))
        dm1s = min(dm1r,dm1q)
        g_dm1(i) = g_dm1s*sign(1.,dm1s)*sign(1.,xt)
        dm1(i) = sign(dm1s,xt)
      end do
    endif
    do i = ifirst-1, ilast+2
      g_al(i) = g_dm1(i-1)*r3-g_dm1(i)*r3+0.5*g_q(i-1,j)+0.5*g_q(i,j)
      al(i) = 0.5*(q(i-1,j)+q(i,j))+r3*(dm1(i-1)-dm1(i))
    end do
    do i = ifirst, ilast+1
      if (c(i,j) .gt. 0.) then
        g_xt = 2*g_dm1(i-1)
        xt = 2.*dm1(i-1)
        g_dlk = g_al(i-1)-g_q(i-1,j)
        dlk = al(i-1)-q(i-1,j)
        g_dlj = g_dlk*(0.5-sign(0.5,abs(dlk)-abs(xt)))*sign(1.,dlk)+g_xt*(0.5+sign(0.5,abs(dlk)-abs(xt)))*sign(1.,xt)
        dlj = min(abs(xt),abs(dlk))
        g_dl = g_dlj*sign(1.,dlj)*sign(1.,xt)
        dl = sign(dlj,xt)
        g_drk = g_al(i)-g_q(i-1,j)
        drk = al(i)-q(i-1,j)
        g_drj = g_drk*(0.5-sign(0.5,abs(drk)-abs(xt)))*sign(1.,drk)+g_xt*(0.5+sign(0.5,abs(drk)-abs(xt)))*sign(1.,xt)
        drj = min(abs(xt),abs(drk))
        g_dr = g_drj*sign(1.,drj)*sign(1.,xt)
        dr = sign(drj,xt)
        g_flux(i,j) = g_c(i,j)*((1.-c(i,j))*(dl-dr)-(c(i,j)*(dl-dr)+dr))+g_dl*(1.-c(i,j))*c(i,j)+g_dr*(1.-c(i,j))*(1-c(i,j))+g_q(i-&
&1,j)
        flux(i,j) = q(i-1,j)+(1.-c(i,j))*(c(i,j)*(dl-dr)+dr)
      else
        g_xt = 2*g_dm1(i)
        xt = 2.*dm1(i)
        g_dli = g_al(i)-g_q(i,j)
        dli = al(i)-q(i,j)
        g_dlh = g_dli*(0.5-sign(0.5,abs(dli)-abs(xt)))*sign(1.,dli)+g_xt*(0.5+sign(0.5,abs(dli)-abs(xt)))*sign(1.,xt)
        dlh = min(abs(xt),abs(dli))
        g_dl = g_dlh*sign(1.,dlh)*sign(1.,xt)
        dl = sign(dlh,xt)
        g_dri = g_al(i+1)-g_q(i,j)
        dri = al(i+1)-q(i,j)
        g_drh = g_dri*(0.5-sign(0.5,abs(dri)-abs(xt)))*sign(1.,dri)+g_xt*(0.5+sign(0.5,abs(dri)-abs(xt)))*sign(1.,xt)
        drh = min(abs(xt),abs(dri))
        g_dr = g_drh*sign(1.,drh)*sign(1.,xt)
        dr = sign(drh,xt)
        g_flux(i,j) = (-(g_c(i,j)*((1.+2*c(i,j))*(dl-dr)+dl)+g_dl*(1.+c(i,j))*(1+c(i,j))))+g_dr*(1.+c(i,j))*c(i,j)+g_q(i,j)
        flux(i,j) = q(i,j)-(1.+c(i,j))*(c(i,j)*(dl-dr)+dl)
      endif
    end do
  end do
else if (iord .eq. 5) then
  do j = jfirst, jlast
    do i = ifirst-3, ilast+2
      g_dq(i) = g_q(i+1,j)-g_q(i,j)
      dq(i) = q(i+1,j)-q(i,j)
    end do
    if (uniform_ppm) then
      do i = ifirst-2, ilast+2
        g_xt = (-0.25)*g_q(i-1,j)+0.25*g_q(i+1,j)
        xt = 0.25*(q(i+1,j)-q(i-1,j))
        g_dm1zr = g_xt*sign(1.,xt)
        dm1zr = abs(xt)
        g_dm1zs = g_q(i-1,j)*(0.5+sign(0.5,q(i-1,j)-q(i,j)))+g_q(i,j)*(0.5-sign(0.5,q(i-1,j)-q(i,j)))
        dm1zs = max(q(i-1,j),q(i,j))
        g_dm1zu = g_dm1zs*(0.5+sign(0.5,dm1zs-q(i+1,j)))+g_q(i+1,j)*(0.5-sign(0.5,dm1zs-q(i+1,j)))-g_q(i,j)
        dm1zu = max(dm1zs,q(i+1,j))-q(i,j)
        g_dm1zv = g_q(i-1,j)*(0.5+sign(0.5,q(i,j)-q(i-1,j)))+g_q(i,j)*(0.5-sign(0.5,q(i,j)-q(i-1,j)))
        dm1zv = min(q(i-1,j),q(i,j))
        g_dm1zx = (-(g_dm1zv*(0.5+sign(0.5,q(i+1,j)-dm1zv))+g_q(i+1,j)*(0.5-sign(0.5,q(i+1,j)-dm1zv))))+g_q(i,j)
        dm1zx = q(i,j)-min(dm1zv,q(i+1,j))
        g_dm1zy = g_dm1zr*(0.5+sign(0.5,dm1zu-dm1zr))+g_dm1zu*(0.5-sign(0.5,dm1zu-dm1zr))
        dm1zy = min(dm1zr,dm1zu)
        g_dm1zz = g_dm1zx*(0.5-sign(0.5,dm1zx-dm1zy))+g_dm1zy*(0.5+sign(0.5,dm1zx-dm1zy))
        dm1zz = min(dm1zy,dm1zx)
        g_dm1(i) = g_dm1zz*sign(1.,dm1zz)*sign(1.,xt)
        dm1(i) = sign(dm1zz,xt)
      end do
    else
      do i = ifirst-2, ilast+2
        g_xt = g_dq(i-1)*cx1(i,j)+g_dq(i)*cx2(i,j)
        xt = cx1(i,j)*dq(i-1)+cx2(i,j)*dq(i)
        g_dm1zh = g_xt*sign(1.,xt)
        dm1zh = abs(xt)
        g_dm1zk = g_dq(i-1)*sign(1.,dq(i-1))
        dm1zk = abs(dq(i-1))
        g_dm1zo = g_dq(i)*sign(1.,dq(i))
        dm1zo = abs(dq(i))
        g_dm1zp = g_dm1zh*(0.5+sign(0.5,dm1zk-dm1zh))+g_dm1zk*(0.5-sign(0.5,dm1zk-dm1zh))
        dm1zp = min(dm1zh,dm1zk)
        g_dm1zq = g_dm1zo*(0.5-sign(0.5,dm1zo-dm1zp))+g_dm1zp*(0.5+sign(0.5,dm1zo-dm1zp))
        dm1zq = min(dm1zp,dm1zo)
        g_dm1(i) = g_dm1zq*sign(1.,dm1zq)*sign(1.,xt)
        dm1(i) = sign(dm1zq,xt)
      end do
    endif
    do i = ifirst-1, ilast+2
      g_al(i) = g_dm1(i-1)*r3-g_dm1(i)*r3+0.5*g_q(i-1,j)+0.5*g_q(i,j)
      al(i) = 0.5*(q(i-1,j)+q(i,j))+r3*(dm1(i-1)-dm1(i))
    end do
    do i = ifirst-1, ilast+1
      g_pmp = (-2)*g_dq(i)
      pmp = -(2.*dq(i))
      g_lac = 1.5*g_dq(i+1)+g_pmp
      lac = pmp+1.5*dq(i+1)
      g_blzk = g_pmp*(0.5-sign(0.5,0.-pmp))
      blzk = max(0.,pmp)
      g_blzl = g_blzk*(0.5+sign(0.5,blzk-lac))+g_lac*(0.5-sign(0.5,blzk-lac))
      blzl = max(blzk,lac)
      g_blzn = g_pmp*(0.5-sign(0.5,pmp-0.))
      blzn = min(0.,pmp)
      g_blzo = g_blzn*(0.5+sign(0.5,lac-blzn))+g_lac*(0.5-sign(0.5,lac-blzn))
      blzo = min(blzn,lac)
      g_blzm = g_al(i)*(0.5+sign(0.5,al(i)-q(i,j)-blzo))+g_blzo*(0.5-sign(0.5,al(i)-q(i,j)-blzo))-g_q(i,j)*(0.5+sign(0.5,al(i)-q(i,&
&j)-blzo))
      blzm = max(al(i)-q(i,j),blzo)
      g_bl(i) = g_blzl*(0.5+sign(0.5,blzm-blzl))+g_blzm*(0.5-sign(0.5,blzm-blzl))
      bl(i) = min(blzl,blzm)
      g_pmp = 2*g_dq(i-1)
      pmp = 2.*dq(i-1)
      g_lac = (-1.5)*g_dq(i-2)+g_pmp
      lac = pmp-1.5*dq(i-2)
      g_brzk = g_pmp*(0.5-sign(0.5,0.-pmp))
      brzk = max(0.,pmp)
      g_brzl = g_brzk*(0.5+sign(0.5,brzk-lac))+g_lac*(0.5-sign(0.5,brzk-lac))
      brzl = max(brzk,lac)
      g_brzn = g_pmp*(0.5-sign(0.5,pmp-0.))
      brzn = min(0.,pmp)
      g_brzo = g_brzn*(0.5+sign(0.5,lac-brzn))+g_lac*(0.5-sign(0.5,lac-brzn))
      brzo = min(brzn,lac)
      g_brzm = g_al(i+1)*(0.5+sign(0.5,al(i+1)-q(i,j)-brzo))+g_brzo*(0.5-sign(0.5,al(i+1)-q(i,j)-brzo))-g_q(i,j)*(0.5+sign(0.5,&
&al(i+1)-q(i,j)-brzo))
      brzm = max(al(i+1)-q(i,j),brzo)
      g_br(i) = g_brzl*(0.5+sign(0.5,brzm-brzl))+g_brzm*(0.5-sign(0.5,brzm-brzl))
      br(i) = min(brzl,brzm)
    end do
    do i = ifirst, ilast+1
      if (c(i,j) .gt. 0.) then
        g_flux(i,j) = (-(g_bl(i-1)*(1.-c(i,j))*c(i,j)))+g_br(i-1)*(1.-c(i,j))*(1-c(i,j))-g_c(i,j)*((1.-c(i,j))*(bl(i-1)+br(i-1))+&
&br(i-1)-c(i,j)*(bl(i-1)+br(i-1)))+g_q(i-1,j)
        flux(i,j) = q(i-1,j)+(1.-c(i,j))*(br(i-1)-c(i,j)*(bl(i-1)+br(i-1)))
      else
        g_flux(i,j) = g_bl(i)*(1.+c(i,j))*(1+c(i,j))+g_br(i)*(1.+c(i,j))*c(i,j)+g_c(i,j)*((1.+c(i,j))*(bl(i)+br(i))+bl(i)+c(i,j)*&
&(bl(i)+br(i)))+g_q(i,j)
        flux(i,j) = q(i,j)+(1.+c(i,j))*(bl(i)+c(i,j)*(bl(i)+br(i)))
      endif
    end do
  end do
else if (iord .eq. 6 .or. iord .eq. 7) then
  do j = jfirst, jlast
    do i = ifirst-1, ilast+1
      g_xt = g_q(i,j)*b3
      xt = b3*q(i,j)
      g_bl(i) = g_q(i-2,j)*b5+g_q(i-1,j)*b4+g_q(i+2,j)*b1+g_q(i+1,j)*b2+g_xt
      bl(i) = b5*q(i-2,j)+b4*q(i-1,j)+xt+b2*q(i+1,j)+b1*q(i+2,j)
      g_br(i) = g_q(i-2,j)*b1+g_q(i-1,j)*b2+g_q(i+2,j)*b5+g_q(i+1,j)*b4+g_xt
      br(i) = b1*q(i-2,j)+b2*q(i-1,j)+xt+b4*q(i+1,j)+b5*q(i+2,j)
    end do
    if (iord .eq. 7) then
      do i = ifirst-2, ilast+3
        g_dq(i) = (-g_q(i-1,j))+g_q(i,j)
        dq(i) = q(i,j)-q(i-1,j)
      end do
      do i = ifirst-1, ilast+1
        dll = min(abs(bl(i)),abs(dq(i)))
        g_dl = -((g_bl(i)*(0.5+sign(0.5,abs(dq(i))-abs(bl(i))))*sign(1.,bl(i))+g_dq(i)*(0.5-sign(0.5,abs(dq(i))-abs(bl(i))))*&
&sign(1.,dq(i)))*sign(1.,dll)*sign(1.,dq(i)))
        dl = -sign(dll,dq(i))
        g_pmp = (-2)*g_dq(i+1)
        pmp = -(2.*dq(i+1))
        g_lac = 1.5*g_dq(i+2)+g_pmp
        lac = pmp+1.5*dq(i+2)
        g_blzf = g_pmp*(0.5-sign(0.5,0.-pmp))
        blzf = max(0.,pmp)
        g_blzg = g_blzf*(0.5+sign(0.5,blzf-lac))+g_lac*(0.5-sign(0.5,blzf-lac))
        blzg = max(blzf,lac)
        g_blzi = g_pmp*(0.5-sign(0.5,pmp-0.))
        blzi = min(0.,pmp)
        g_blzj = g_blzi*(0.5+sign(0.5,lac-blzi))+g_lac*(0.5-sign(0.5,lac-blzi))
        blzj = min(blzi,lac)
        g_blzh = g_blzj*(0.5-sign(0.5,dl-blzj))+g_dl*(0.5+sign(0.5,dl-blzj))
        blzh = max(dl,blzj)
        g_bl(i) = g_blzg*(0.5+sign(0.5,blzh-blzg))+g_blzh*(0.5-sign(0.5,blzh-blzg))
        bl(i) = min(blzg,blzh)
        g_drl = g_br(i)*(0.5+sign(0.5,abs(dq(i+1))-abs(br(i))))*sign(1.,br(i))+g_dq(i+1)*(0.5-sign(0.5,abs(dq(i+1))-abs(br(i))))*&
&sign(1.,dq(i+1))
        drl = min(abs(br(i)),abs(dq(i+1)))
        g_dr = g_drl*sign(1.,drl)*sign(1.,dq(i+1))
        dr = sign(drl,dq(i+1))
        g_pmp = 2*g_dq(i)
        pmp = 2.*dq(i)
        g_lac = (-1.5)*g_dq(i-1)+g_pmp
        lac = pmp-1.5*dq(i-1)
        g_brzf = g_pmp*(0.5-sign(0.5,0.-pmp))
        brzf = max(0.,pmp)
        g_brzg = g_brzf*(0.5+sign(0.5,brzf-lac))+g_lac*(0.5-sign(0.5,brzf-lac))
        brzg = max(brzf,lac)
        g_brzi = g_pmp*(0.5-sign(0.5,pmp-0.))
        brzi = min(0.,pmp)
        g_brzj = g_brzi*(0.5+sign(0.5,lac-brzi))+g_lac*(0.5-sign(0.5,lac-brzi))
        brzj = min(brzi,lac)
        g_brzh = g_brzj*(0.5-sign(0.5,dr-brzj))+g_dr*(0.5+sign(0.5,dr-brzj))
        brzh = max(dr,brzj)
        g_br(i) = g_brzg*(0.5+sign(0.5,brzh-brzg))+g_brzh*(0.5-sign(0.5,brzh-brzg))
        br(i) = min(brzg,brzh)
      end do
    endif
    do i = ifirst, ilast+1
      if (c(i,j) .gt. 0.) then
        g_flux(i,j) = (-(g_bl(i-1)*(1.-c(i,j))*c(i,j)))+g_br(i-1)*(1.-c(i,j))*(1-c(i,j))-g_c(i,j)*((1.-c(i,j))*(bl(i-1)+br(i-1))+&
&br(i-1)-c(i,j)*(bl(i-1)+br(i-1)))+g_q(i-1,j)
        flux(i,j) = q(i-1,j)+(1.-c(i,j))*(br(i-1)-c(i,j)*(bl(i-1)+br(i-1)))
      else
        g_flux(i,j) = g_bl(i)*(1.+c(i,j))*(1+c(i,j))+g_br(i)*(1.+c(i,j))*c(i,j)+g_c(i,j)*((1.+c(i,j))*(bl(i)+br(i))+bl(i)+c(i,j)*&
&(bl(i)+br(i)))+g_q(i,j)
        flux(i,j) = q(i,j)+(1.+c(i,j))*(bl(i)+c(i,j)*(bl(i)+br(i)))
      endif
    end do
  end do
else if (iord .eq. 9 .or. iord .eq. 10) then
  is3 = max(3,is-1)
  ie3 = min(npx-3,ie+1)
  do j = jfirst, jlast
    do i = is-3, ie+2
      g_dq(i) = g_q(i+1,j)-g_q(i,j)
      dq(i) = q(i+1,j)-q(i,j)
    end do
    if (uniform_ppm) then
      do i = is-2, ie+2
        g_xt = (-0.25)*g_q(i-1,j)+0.25*g_q(i+1,j)
        xt = 0.25*(q(i+1,j)-q(i-1,j))
        g_dm1zf = g_xt*sign(1.,xt)
        dm1zf = abs(xt)
        g_dm1zg = g_q(i-1,j)*(0.5+sign(0.5,q(i-1,j)-q(i,j)))+g_q(i,j)*(0.5-sign(0.5,q(i-1,j)-q(i,j)))
        dm1zg = max(q(i-1,j),q(i,j))
        g_dm1zi = g_dm1zg*(0.5+sign(0.5,dm1zg-q(i+1,j)))+g_q(i+1,j)*(0.5-sign(0.5,dm1zg-q(i+1,j)))-g_q(i,j)
        dm1zi = max(dm1zg,q(i+1,j))-q(i,j)
        g_dm1zj = g_q(i-1,j)*(0.5+sign(0.5,q(i,j)-q(i-1,j)))+g_q(i,j)*(0.5-sign(0.5,q(i,j)-q(i-1,j)))
        dm1zj = min(q(i-1,j),q(i,j))
        g_dm1zl = (-(g_dm1zj*(0.5+sign(0.5,q(i+1,j)-dm1zj))+g_q(i+1,j)*(0.5-sign(0.5,q(i+1,j)-dm1zj))))+g_q(i,j)
        dm1zl = q(i,j)-min(dm1zj,q(i+1,j))
        g_dm1zm = g_dm1zf*(0.5+sign(0.5,dm1zi-dm1zf))+g_dm1zi*(0.5-sign(0.5,dm1zi-dm1zf))
        dm1zm = min(dm1zf,dm1zi)
        g_dm1zn = g_dm1zl*(0.5-sign(0.5,dm1zl-dm1zm))+g_dm1zm*(0.5+sign(0.5,dm1zl-dm1zm))
        dm1zn = min(dm1zm,dm1zl)
        g_dm1(i) = g_dm1zn*sign(1.,dm1zn)*sign(1.,xt)
        dm1(i) = sign(dm1zn,xt)
      end do
    else
      do i = is-2, ie+2
        g_xt = g_dq(i-1)*cx1(i,j)+g_dq(i)*cx2(i,j)
        xt = cx1(i,j)*dq(i-1)+cx2(i,j)*dq(i)
        g_dm1v = g_xt*sign(1.,xt)
        dm1v = abs(xt)
        g_dm1y = g_dq(i-1)*sign(1.,dq(i-1))
        dm1y = abs(dq(i-1))
        g_dm1zc = g_dq(i)*sign(1.,dq(i))
        dm1zc = abs(dq(i))
        g_dm1zd = g_dm1v*(0.5+sign(0.5,dm1y-dm1v))+g_dm1y*(0.5-sign(0.5,dm1y-dm1v))
        dm1zd = min(dm1v,dm1y)
        g_dm1ze = g_dm1zc*(0.5-sign(0.5,dm1zc-dm1zd))+g_dm1zd*(0.5+sign(0.5,dm1zc-dm1zd))
        dm1ze = min(dm1zd,dm1zc)
        g_dm1(i) = g_dm1ze*sign(1.,dm1ze)*sign(1.,xt)
        dm1(i) = sign(dm1ze,xt)
      end do
    endif
    if (grid_type .lt. 3) then
      do i = is3, min(npx-2,ie+2)
        g_al(i) = g_dm1(i-1)*r3-g_dm1(i)*r3+0.5*g_q(i-1,j)+0.5*g_q(i,j)
        al(i) = 0.5*(q(i-1,j)+q(i,j))+r3*(dm1(i-1)-dm1(i))
      end do
      do i = is3, ie3
        g_pmp = (-2)*g_dq(i)
        pmp = -(2.*dq(i))
        g_lac = 1.5*g_dq(i+1)+g_pmp
        lac = pmp+1.5*dq(i+1)
        g_blza = g_pmp*(0.5-sign(0.5,0.-pmp))
        blza = max(0.,pmp)
        g_blzb = g_blza*(0.5+sign(0.5,blza-lac))+g_lac*(0.5-sign(0.5,blza-lac))
        blzb = max(blza,lac)
        g_blzd = g_pmp*(0.5-sign(0.5,pmp-0.))
        blzd = min(0.,pmp)
        g_blze = g_blzd*(0.5+sign(0.5,lac-blzd))+g_lac*(0.5-sign(0.5,lac-blzd))
        blze = min(blzd,lac)
        g_blzc = g_al(i)*(0.5+sign(0.5,al(i)-q(i,j)-blze))+g_blze*(0.5-sign(0.5,al(i)-q(i,j)-blze))-g_q(i,j)*(0.5+sign(0.5,al(i)-&
&q(i,j)-blze))
        blzc = max(al(i)-q(i,j),blze)
        g_bl(i) = g_blzb*(0.5+sign(0.5,blzc-blzb))+g_blzc*(0.5-sign(0.5,blzc-blzb))
        bl(i) = min(blzb,blzc)
        g_pmp = 2*g_dq(i-1)
        pmp = 2.*dq(i-1)
        g_lac = (-1.5)*g_dq(i-2)+g_pmp
        lac = pmp-1.5*dq(i-2)
        g_brza = g_pmp*(0.5-sign(0.5,0.-pmp))
        brza = max(0.,pmp)
        g_brzb = g_brza*(0.5+sign(0.5,brza-lac))+g_lac*(0.5-sign(0.5,brza-lac))
        brzb = max(brza,lac)
        g_brzd = g_pmp*(0.5-sign(0.5,pmp-0.))
        brzd = min(0.,pmp)
        g_brze = g_brzd*(0.5+sign(0.5,lac-brzd))+g_lac*(0.5-sign(0.5,lac-brzd))
        brze = min(brzd,lac)
        g_brzc = g_al(i+1)*(0.5+sign(0.5,al(i+1)-q(i,j)-brze))+g_brze*(0.5-sign(0.5,al(i+1)-q(i,j)-brze))-g_q(i,j)*(0.5+sign(0.5,&
&al(i+1)-q(i,j)-brze))
        brzc = max(al(i+1)-q(i,j),brze)
        g_br(i) = g_brzb*(0.5+sign(0.5,brzc-brzb))+g_brzc*(0.5-sign(0.5,brzc-brzb))
        br(i) = min(brzb,brzc)
      end do
      if (is .eq. 1) then
        g_br(2) = g_al(3)-g_q(2,j)
        br(2) = al(3)-q(2,j)
        g_xt = (-((g_q(-1,j)+g_q(2,j))*(0.5*dxa(1,j)/(dxa(1,j)+dxa(2,j)))))+(g_q(1,j)+g_q(0,j))*(0.5*(2.*dxa(1,j)+dxa(2,j))/(dxa(1,&
&j)+dxa(2,j)))
        xt = 0.5*((2.*dxa(1,j)+dxa(2,j))*(q(0,j)+q(1,j))-dxa(1,j)*(q(-1,j)+q(2,j)))/(dxa(1,j)+dxa(2,j))
        if (edge_mono_kim) then
          if (j .gt. (-2) .and. j .lt. 1 .or. j .gt. npy-3 .and. j .lt. npy) then
            g_xtzzl = g_q(1,j)*(0.5-sign(0.5,q(0,j)-q(1,j)))+g_q(0,j)*(0.5+sign(0.5,q(0,j)-q(1,j)))
            xtzzl = max(q(0,j),q(1,j))
            g_xtzzm = g_q(0,j-1)*(0.5-sign(0.5,xtzzl-q(0,j-1)))+g_xtzzl*(0.5+sign(0.5,xtzzl-q(0,j-1)))
            xtzzm = max(xtzzl,q(0,j-1))
            g_xtzzn = g_q(1,j-1)*(0.5-sign(0.5,xtzzm-q(1,j-1)))+g_xtzzm*(0.5+sign(0.5,xtzzm-q(1,j-1)))
            xtzzn = max(xtzzm,q(1,j-1))
            g_xt = g_xt*(0.5+sign(0.5,xtzzn-xt))+g_xtzzn*(0.5-sign(0.5,xtzzn-xt))
            xt = min(xt,xtzzn)
            g_xtzzi = g_q(1,j)*(0.5-sign(0.5,q(1,j)-q(0,j)))+g_q(0,j)*(0.5+sign(0.5,q(1,j)-q(0,j)))
            xtzzi = min(q(0,j),q(1,j))
            g_xtzzj = g_q(0,j-1)*(0.5-sign(0.5,q(0,j-1)-xtzzi))+g_xtzzi*(0.5+sign(0.5,q(0,j-1)-xtzzi))
            xtzzj = min(xtzzi,q(0,j-1))
            g_xtzzk = g_q(1,j-1)*(0.5-sign(0.5,q(1,j-1)-xtzzj))+g_xtzzj*(0.5+sign(0.5,q(1,j-1)-xtzzj))
            xtzzk = min(xtzzj,q(1,j-1))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtzzk))+g_xtzzk*(0.5-sign(0.5,xt-xtzzk))
            xt = max(xt,xtzzk)
          else if (j .lt. 3 .and. j .gt. 0 .or. j .gt. npy-1 .and. j .lt. npy+2) then
            g_xtzzr = g_q(1,j)*(0.5-sign(0.5,q(0,j)-q(1,j)))+g_q(0,j)*(0.5+sign(0.5,q(0,j)-q(1,j)))
            xtzzr = max(q(0,j),q(1,j))
            g_xtzzs = g_q(0,j+1)*(0.5-sign(0.5,xtzzr-q(0,j+1)))+g_xtzzr*(0.5+sign(0.5,xtzzr-q(0,j+1)))
            xtzzs = max(xtzzr,q(0,j+1))
            g_xtzzt = g_q(1,j+1)*(0.5-sign(0.5,xtzzs-q(1,j+1)))+g_xtzzs*(0.5+sign(0.5,xtzzs-q(1,j+1)))
            xtzzt = max(xtzzs,q(1,j+1))
            g_xt = g_xt*(0.5+sign(0.5,xtzzt-xt))+g_xtzzt*(0.5-sign(0.5,xtzzt-xt))
            xt = min(xt,xtzzt)
            g_xtzzo = g_q(1,j)*(0.5-sign(0.5,q(1,j)-q(0,j)))+g_q(0,j)*(0.5+sign(0.5,q(1,j)-q(0,j)))
            xtzzo = min(q(0,j),q(1,j))
            g_xtzzp = g_q(0,j+1)*(0.5-sign(0.5,q(0,j+1)-xtzzo))+g_xtzzo*(0.5+sign(0.5,q(0,j+1)-xtzzo))
            xtzzp = min(xtzzo,q(0,j+1))
            g_xtzzq = g_q(1,j+1)*(0.5-sign(0.5,q(1,j+1)-xtzzp))+g_xtzzp*(0.5+sign(0.5,q(1,j+1)-xtzzp))
            xtzzq = min(xtzzp,q(1,j+1))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtzzq))+g_xtzzq*(0.5-sign(0.5,xt-xtzzq))
            xt = max(xt,xtzzq)
          endif
        endif
        g_bl(1) = (-g_q(1,j))+g_xt
        bl(1) = xt-q(1,j)
        g_br(0) = (-g_q(0,j))+g_xt
        br(0) = xt-q(0,j)
        g_xt = 0.57142857*g_dm1(-1)-0.78571429*g_dq(-1)+g_q(0,j)
        xt = 4./7.*dm1(-1)-11./14.*dq(-1)+q(0,j)
        if (s_mono_kim) then
          g_xtzzh = g_q(-1,j)*(0.5+sign(0.5,q(0,j)-q(-1,j)))+g_q(0,j)*(0.5-sign(0.5,q(0,j)-q(-1,j)))
          xtzzh = min(q(-1,j),q(0,j))
          g_xt = g_xt*(0.5+sign(0.5,xt-xtzzh))+g_xtzzh*(0.5-sign(0.5,xt-xtzzh))
          xt = max(xt,xtzzh)
          g_xtzzg = g_q(-1,j)*(0.5+sign(0.5,q(-1,j)-q(0,j)))+g_q(0,j)*(0.5-sign(0.5,q(-1,j)-q(0,j)))
          xtzzg = max(q(-1,j),q(0,j))
          g_xt = g_xt*(0.5+sign(0.5,xtzzg-xt))+g_xtzzg*(0.5-sign(0.5,xtzzg-xt))
          xt = min(xt,xtzzg)
        endif
        g_bl(0) = (-g_q(0,j))+g_xt
        bl(0) = xt-q(0,j)
        g_xt = (-0.57142857)*g_dm1(2)+0.78571429*g_q(2,j)+0.21428571*g_q(1,j)
        xt = 3./14.*q(1,j)+11./14.*q(2,j)-4./7.*dm1(2)
        if (s_mono_kim) then
          g_xtzzf = g_q(2,j)*(0.5-sign(0.5,q(2,j)-q(1,j)))+g_q(1,j)*(0.5+sign(0.5,q(2,j)-q(1,j)))
          xtzzf = min(q(1,j),q(2,j))
          g_xt = g_xt*(0.5+sign(0.5,xt-xtzzf))+g_xtzzf*(0.5-sign(0.5,xt-xtzzf))
          xt = max(xt,xtzzf)
          g_xtzze = g_q(2,j)*(0.5-sign(0.5,q(1,j)-q(2,j)))+g_q(1,j)*(0.5+sign(0.5,q(1,j)-q(2,j)))
          xtzze = max(q(1,j),q(2,j))
          g_xt = g_xt*(0.5+sign(0.5,xtzze-xt))+g_xtzze*(0.5-sign(0.5,xtzze-xt))
          xt = min(xt,xtzze)
        endif
        g_br(1) = (-g_q(1,j))+g_xt
        br(1) = xt-q(1,j)
        g_bl(2) = (-g_q(2,j))+g_xt
        bl(2) = xt-q(2,j)
        if (iord .eq. 9) then
          call g_pert_ppm( 3,q(0,j),g_q(0,j),bl(0),g_bl(0),br(0),g_br(0),1 )
        endif
      endif
      if (ie+1 .eq. npx) then
        g_bl(npx-2) = g_al(npx-2)-g_q(npx-2,j)
        bl(npx-2) = al(npx-2)-q(npx-2,j)
        g_xt = (-(g_q(npx-2,j)*(0.5*dxa(npx-1,j)/(dxa(npx-1,j)+dxa(npx-2,j)))))+g_q(npx-1,j)*(0.5*(2.*dxa(npx-1,j)+dxa(npx-2,j))/&
&(dxa(npx-1,j)+dxa(npx-2,j)))-g_q(npx+1,j)*(0.5*dxa(npx-1,j)/(dxa(npx-1,j)+dxa(npx-2,j)))+g_q(npx,j)*(0.5*(2.*dxa(npx-1,j)+&
&dxa(npx-2,j))/(dxa(npx-1,j)+dxa(npx-2,j)))
        xt = 0.5*((2.*dxa(npx-1,j)+dxa(npx-2,j))*(q(npx-1,j)+q(npx,j))-dxa(npx-1,j)*(q(npx-2,j)+q(npx+1,j)))/(dxa(npx-1,j)+dxa(npx-&
&2,j))
        if (edge_mono_kim) then
          if (j .gt. (-2) .and. j .lt. 1 .or. j .gt. npy-3 .and. j .lt. npy) then
            g_xtzv = g_q(npx-1,j)*(0.5+sign(0.5,q(npx-1,j)-q(npx,j)))+g_q(npx,j)*(0.5-sign(0.5,q(npx-1,j)-q(npx,j)))
            xtzv = max(q(npx-1,j),q(npx,j))
            g_xtzw = g_q(npx-1,j-1)*(0.5-sign(0.5,xtzv-q(npx-1,j-1)))+g_xtzv*(0.5+sign(0.5,xtzv-q(npx-1,j-1)))
            xtzw = max(xtzv,q(npx-1,j-1))
            g_xtzx = g_q(npx,j-1)*(0.5-sign(0.5,xtzw-q(npx,j-1)))+g_xtzw*(0.5+sign(0.5,xtzw-q(npx,j-1)))
            xtzx = max(xtzw,q(npx,j-1))
            g_xt = g_xt*(0.5+sign(0.5,xtzx-xt))+g_xtzx*(0.5-sign(0.5,xtzx-xt))
            xt = min(xt,xtzx)
            g_xtzs = g_q(npx-1,j)*(0.5+sign(0.5,q(npx,j)-q(npx-1,j)))+g_q(npx,j)*(0.5-sign(0.5,q(npx,j)-q(npx-1,j)))
            xtzs = min(q(npx-1,j),q(npx,j))
            g_xtzt = g_q(npx-1,j-1)*(0.5-sign(0.5,q(npx-1,j-1)-xtzs))+g_xtzs*(0.5+sign(0.5,q(npx-1,j-1)-xtzs))
            xtzt = min(xtzs,q(npx-1,j-1))
            g_xtzu = g_q(npx,j-1)*(0.5-sign(0.5,q(npx,j-1)-xtzt))+g_xtzt*(0.5+sign(0.5,q(npx,j-1)-xtzt))
            xtzu = min(xtzt,q(npx,j-1))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtzu))+g_xtzu*(0.5-sign(0.5,xt-xtzu))
            xt = max(xt,xtzu)
          else if (j .lt. 3 .and. j .gt. 0 .or. j .gt. npy-1 .and. j .lt. npy+2) then
            g_xtzzb = g_q(npx-1,j)*(0.5+sign(0.5,q(npx-1,j)-q(npx,j)))+g_q(npx,j)*(0.5-sign(0.5,q(npx-1,j)-q(npx,j)))
            xtzzb = max(q(npx-1,j),q(npx,j))
            g_xtzzc = g_q(npx-1,j+1)*(0.5-sign(0.5,xtzzb-q(npx-1,j+1)))+g_xtzzb*(0.5+sign(0.5,xtzzb-q(npx-1,j+1)))
            xtzzc = max(xtzzb,q(npx-1,j+1))
            g_xtzzd = g_q(npx,j+1)*(0.5-sign(0.5,xtzzc-q(npx,j+1)))+g_xtzzc*(0.5+sign(0.5,xtzzc-q(npx,j+1)))
            xtzzd = max(xtzzc,q(npx,j+1))
            g_xt = g_xt*(0.5+sign(0.5,xtzzd-xt))+g_xtzzd*(0.5-sign(0.5,xtzzd-xt))
            xt = min(xt,xtzzd)
            g_xtzy = g_q(npx-1,j)*(0.5+sign(0.5,q(npx,j)-q(npx-1,j)))+g_q(npx,j)*(0.5-sign(0.5,q(npx,j)-q(npx-1,j)))
            xtzy = min(q(npx-1,j),q(npx,j))
            g_xtzz = g_q(npx-1,j+1)*(0.5-sign(0.5,q(npx-1,j+1)-xtzy))+g_xtzy*(0.5+sign(0.5,q(npx-1,j+1)-xtzy))
            xtzz = min(xtzy,q(npx-1,j+1))
            g_xtzza = g_q(npx,j+1)*(0.5-sign(0.5,q(npx,j+1)-xtzz))+g_xtzz*(0.5+sign(0.5,q(npx,j+1)-xtzz))
            xtzza = min(xtzz,q(npx,j+1))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtzza))+g_xtzza*(0.5-sign(0.5,xt-xtzza))
            xt = max(xt,xtzza)
          endif
        endif
        g_br(npx-1) = (-g_q(npx-1,j))+g_xt
        br(npx-1) = xt-q(npx-1,j)
        g_bl(npx) = (-g_q(npx,j))+g_xt
        bl(npx) = xt-q(npx,j)
        g_xt = (-0.57142857)*g_dm1(npx+1)+0.78571429*g_dq(npx)+g_q(npx,j)
        xt = 11./14.*dq(npx)-4./7.*dm1(npx+1)+q(npx,j)
        if (s_mono_kim) then
          g_xtzr = g_q(npx+1,j)*(0.5-sign(0.5,q(npx,j)-q(npx+1,j)))+g_q(npx,j)*(0.5+sign(0.5,q(npx,j)-q(npx+1,j)))
          xtzr = max(q(npx,j),q(npx+1,j))
          g_xt = g_xt*(0.5+sign(0.5,xtzr-xt))+g_xtzr*(0.5-sign(0.5,xtzr-xt))
          xt = min(xt,xtzr)
          g_xtzq = g_q(npx+1,j)*(0.5-sign(0.5,q(npx+1,j)-q(npx,j)))+g_q(npx,j)*(0.5+sign(0.5,q(npx+1,j)-q(npx,j)))
          xtzq = min(q(npx,j),q(npx+1,j))
          g_xt = g_xt*(0.5+sign(0.5,xt-xtzq))+g_xtzq*(0.5-sign(0.5,xt-xtzq))
          xt = max(xt,xtzq)
        endif
        g_br(npx) = (-g_q(npx,j))+g_xt
        br(npx) = xt-q(npx,j)
        g_xt = 0.57142857*g_dm1(npx-2)+0.78571429*g_q(npx-2,j)+0.21428571*g_q(npx-1,j)
        xt = 3./14.*q(npx-1,j)+11./14.*q(npx-2,j)+4./7.*dm1(npx-2)
        if (s_mono_kim) then
          g_xtzp = g_q(npx-2,j)*(0.5+sign(0.5,q(npx-2,j)-q(npx-1,j)))+g_q(npx-1,j)*(0.5-sign(0.5,q(npx-2,j)-q(npx-1,j)))
          xtzp = max(q(npx-2,j),q(npx-1,j))
          g_xt = g_xt*(0.5+sign(0.5,xtzp-xt))+g_xtzp*(0.5-sign(0.5,xtzp-xt))
          xt = min(xt,xtzp)
          g_xtzo = g_q(npx-2,j)*(0.5+sign(0.5,q(npx-1,j)-q(npx-2,j)))+g_q(npx-1,j)*(0.5-sign(0.5,q(npx-1,j)-q(npx-2,j)))
          xtzo = min(q(npx-2,j),q(npx-1,j))
          g_xt = g_xt*(0.5+sign(0.5,xt-xtzo))+g_xtzo*(0.5-sign(0.5,xt-xtzo))
          xt = max(xt,xtzo)
        endif
        g_br(npx-2) = (-g_q(npx-2,j))+g_xt
        br(npx-2) = xt-q(npx-2,j)
        g_bl(npx-1) = (-g_q(npx-1,j))+g_xt
        bl(npx-1) = xt-q(npx-1,j)
        if (iord .eq. 9) then
          call g_pert_ppm( 3,q(npx-2,j),g_q(npx-2,j),bl(npx-2),g_bl(npx-2),br(npx-2),g_br(npx-2),1 )
        endif
      endif
    else
      do i = is-1, ie+2
        g_al(i) = g_dm1(i-1)*r3-g_dm1(i)*r3+0.5*g_q(i-1,j)+0.5*g_q(i,j)
        al(i) = 0.5*(q(i-1,j)+q(i,j))+r3*(dm1(i-1)-dm1(i))
      end do
      do i = is-1, ie+1
        g_pmp = (-2)*g_dq(i)
        pmp = -(2.*dq(i))
        g_lac = 1.5*g_dq(i+1)+g_pmp
        lac = pmp+1.5*dq(i+1)
        g_blv = g_pmp*(0.5-sign(0.5,0.-pmp))
        blv = max(0.,pmp)
        g_blw = g_blv*(0.5+sign(0.5,blv-lac))+g_lac*(0.5-sign(0.5,blv-lac))
        blw = max(blv,lac)
        g_bly = g_pmp*(0.5-sign(0.5,pmp-0.))
        bly = min(0.,pmp)
        g_blz = g_bly*(0.5+sign(0.5,lac-bly))+g_lac*(0.5-sign(0.5,lac-bly))
        blz = min(bly,lac)
        g_blx = g_al(i)*(0.5+sign(0.5,al(i)-q(i,j)-blz))+g_blz*(0.5-sign(0.5,al(i)-q(i,j)-blz))-g_q(i,j)*(0.5+sign(0.5,al(i)-q(i,j)&
&-blz))
        blx = max(al(i)-q(i,j),blz)
        g_bl(i) = g_blw*(0.5+sign(0.5,blx-blw))+g_blx*(0.5-sign(0.5,blx-blw))
        bl(i) = min(blw,blx)
        g_pmp = 2*g_dq(i-1)
        pmp = 2.*dq(i-1)
        g_lac = (-1.5)*g_dq(i-2)+g_pmp
        lac = pmp-1.5*dq(i-2)
        g_brv = g_pmp*(0.5-sign(0.5,0.-pmp))
        brv = max(0.,pmp)
        g_brw = g_brv*(0.5+sign(0.5,brv-lac))+g_lac*(0.5-sign(0.5,brv-lac))
        brw = max(brv,lac)
        g_bry = g_pmp*(0.5-sign(0.5,pmp-0.))
        bry = min(0.,pmp)
        g_brz = g_bry*(0.5+sign(0.5,lac-bry))+g_lac*(0.5-sign(0.5,lac-bry))
        brz = min(bry,lac)
        g_brx = g_al(i+1)*(0.5+sign(0.5,al(i+1)-q(i,j)-brz))+g_brz*(0.5-sign(0.5,al(i+1)-q(i,j)-brz))-g_q(i,j)*(0.5+sign(0.5,al(i+&
&1)-q(i,j)-brz))
        brx = max(al(i+1)-q(i,j),brz)
        g_br(i) = g_brw*(0.5+sign(0.5,brx-brw))+g_brx*(0.5-sign(0.5,brx-brw))
        br(i) = min(brw,brx)
      end do
    endif
    do i = is, ie+1
      if (intel_opt_kim) then
        g_c1 = g_c(i,j)
        c1 = c(i,j)
        if (c1 .gt. 0.) then
          it = i-1
          g_qe = g_br(i-1)
          qe = br(i-1)
        else
          it = i
          g_qe = g_bl(i)
          qe = bl(i)
        endif
        g_c1 = -(g_c1*sign(1.,c1))
        c1 = -abs(c1)
        g_flux(i,j) = (g_bl(it)+g_br(it))*(1.+c1)*c1+g_c1*((1.+c1)*(bl(it)+br(it))+qe+c1*(bl(it)+br(it)))+g_q(it,j)+g_qe*(1+c1)
        flux(i,j) = q(it,j)+(1.+c1)*(qe+c1*(bl(it)+br(it)))
      else
        if (c(i,j) .gt. 0.) then
          g_flux(i,j) = (-(g_bl(i-1)*(1.-c(i,j))*c(i,j)))+g_br(i-1)*(1.-c(i,j))*(1-c(i,j))-g_c(i,j)*((1.-c(i,j))*(bl(i-1)+br(i-1))+&
&br(i-1)-c(i,j)*(bl(i-1)+br(i-1)))+g_q(i-1,j)
          flux(i,j) = q(i-1,j)+(1.-c(i,j))*(br(i-1)-c(i,j)*(bl(i-1)+br(i-1)))
        else
          g_flux(i,j) = g_bl(i)*(1.+c(i,j))*(1+c(i,j))+g_br(i)*(1.+c(i,j))*c(i,j)+g_c(i,j)*((1.+c(i,j))*(bl(i)+br(i))+bl(i)+c(i,j)*&
&(bl(i)+br(i)))+g_q(i,j)
          flux(i,j) = q(i,j)+(1.+c(i,j))*(bl(i)+c(i,j)*(bl(i)+br(i)))
        endif
      endif
    end do
  end do
else
  do j = jfirst, jlast
    do i = ifirst-2, ilast+2
      g_xt = (-0.25)*g_q(i-1,j)+0.25*g_q(i+1,j)
      xt = 0.25*(q(i+1,j)-q(i-1,j))
      g_dm1h = g_xt*sign(1.,xt)
      dm1h = abs(xt)
      g_dm1i = g_q(i-1,j)*(0.5+sign(0.5,q(i-1,j)-q(i,j)))+g_q(i,j)*(0.5-sign(0.5,q(i-1,j)-q(i,j)))
      dm1i = max(q(i-1,j),q(i,j))
      g_dm1k = g_dm1i*(0.5+sign(0.5,dm1i-q(i+1,j)))+g_q(i+1,j)*(0.5-sign(0.5,dm1i-q(i+1,j)))-g_q(i,j)
      dm1k = max(dm1i,q(i+1,j))-q(i,j)
      g_dm1l = g_q(i-1,j)*(0.5+sign(0.5,q(i,j)-q(i-1,j)))+g_q(i,j)*(0.5-sign(0.5,q(i,j)-q(i-1,j)))
      dm1l = min(q(i-1,j),q(i,j))
      g_dm1n = (-(g_dm1l*(0.5+sign(0.5,q(i+1,j)-dm1l))+g_q(i+1,j)*(0.5-sign(0.5,q(i+1,j)-dm1l))))+g_q(i,j)
      dm1n = q(i,j)-min(dm1l,q(i+1,j))
      g_dm1o = g_dm1h*(0.5+sign(0.5,dm1k-dm1h))+g_dm1k*(0.5-sign(0.5,dm1k-dm1h))
      dm1o = min(dm1h,dm1k)
      g_dm1p = g_dm1n*(0.5-sign(0.5,dm1n-dm1o))+g_dm1o*(0.5+sign(0.5,dm1n-dm1o))
      dm1p = min(dm1o,dm1n)
      g_dm1(i) = g_dm1p*sign(1.,dm1p)*sign(1.,xt)
      dm1(i) = sign(dm1p,xt)
    end do
    if (grid_type .lt. 3) then
      is3 = max(3,is-1)
      ie3 = min(npx-3,ie+1)
      do i = is3, min(npx-2,ie+2)
        g_al(i) = g_dm1(i-1)*r3-g_dm1(i)*r3+0.5*g_q(i-1,j)+0.5*g_q(i,j)
        al(i) = 0.5*(q(i-1,j)+q(i,j))+r3*(dm1(i-1)-dm1(i))
      end do
      if (iord .eq. 11) then
        do i = is3, ie3
          g_xt = 2*g_dm1(i)
          xt = 2.*dm1(i)
          g_blp = g_al(i)-g_q(i,j)
          blp = al(i)-q(i,j)
          blo = min(abs(xt),abs(blp))
          g_bl(i) = -((g_blp*(0.5-sign(0.5,abs(blp)-abs(xt)))*sign(1.,blp)+g_xt*(0.5+sign(0.5,abs(blp)-abs(xt)))*sign(1.,xt))*&
&sign(1.,blo)*sign(1.,xt))
          bl(i) = -sign(blo,xt)
          g_brp = g_al(i+1)-g_q(i,j)
          brp = al(i+1)-q(i,j)
          g_bro = g_brp*(0.5-sign(0.5,abs(brp)-abs(xt)))*sign(1.,brp)+g_xt*(0.5+sign(0.5,abs(brp)-abs(xt)))*sign(1.,xt)
          bro = min(abs(xt),abs(brp))
          g_br(i) = g_bro*sign(1.,bro)*sign(1.,xt)
          br(i) = sign(bro,xt)
        end do
      else if (iord .eq. 12) then
        do i = is-3, ie+2
          g_dq(i) = g_q(i+1,j)-g_q(i,j)
          dq(i) = q(i+1,j)-q(i,j)
        end do
        do i = is3, ie3
          g_pmp = (-2)*g_dq(i)
          pmp = -(2.*dq(i))
          g_lac = 1.5*g_dq(i+1)+g_pmp
          lac = pmp+1.5*dq(i+1)
          g_blq = g_pmp*(0.5-sign(0.5,0.-pmp))
          blq = max(0.,pmp)
          g_blr = g_blq*(0.5+sign(0.5,blq-lac))+g_lac*(0.5-sign(0.5,blq-lac))
          blr = max(blq,lac)
          g_blt = g_pmp*(0.5-sign(0.5,pmp-0.))
          blt = min(0.,pmp)
          g_blu = g_blt*(0.5+sign(0.5,lac-blt))+g_lac*(0.5-sign(0.5,lac-blt))
          blu = min(blt,lac)
          g_bls = g_al(i)*(0.5+sign(0.5,al(i)-q(i,j)-blu))+g_blu*(0.5-sign(0.5,al(i)-q(i,j)-blu))-g_q(i,j)*(0.5+sign(0.5,al(i)-q(i,&
&j)-blu))
          bls = max(al(i)-q(i,j),blu)
          g_bl(i) = g_blr*(0.5+sign(0.5,bls-blr))+g_bls*(0.5-sign(0.5,bls-blr))
          bl(i) = min(blr,bls)
          g_pmp = 2*g_dq(i-1)
          pmp = 2.*dq(i-1)
          g_lac = (-1.5)*g_dq(i-2)+g_pmp
          lac = pmp-1.5*dq(i-2)
          g_brq = g_pmp*(0.5-sign(0.5,0.-pmp))
          brq = max(0.,pmp)
          g_brr = g_brq*(0.5+sign(0.5,brq-lac))+g_lac*(0.5-sign(0.5,brq-lac))
          brr = max(brq,lac)
          g_brt = g_pmp*(0.5-sign(0.5,pmp-0.))
          brt = min(0.,pmp)
          g_bru = g_brt*(0.5+sign(0.5,lac-brt))+g_lac*(0.5-sign(0.5,lac-brt))
          bru = min(brt,lac)
          g_brs = g_al(i+1)*(0.5+sign(0.5,al(i+1)-q(i,j)-bru))+g_bru*(0.5-sign(0.5,al(i+1)-q(i,j)-bru))-g_q(i,j)*(0.5+sign(0.5,&
&al(i+1)-q(i,j)-bru))
          brs = max(al(i+1)-q(i,j),bru)
          g_br(i) = g_brr*(0.5+sign(0.5,brs-brr))+g_brs*(0.5-sign(0.5,brs-brr))
          br(i) = min(brr,brs)
        end do
      else
        do i = is3, ie3
          g_bl(i) = g_al(i)-g_q(i,j)
          bl(i) = al(i)-q(i,j)
          g_br(i) = g_al(i+1)-g_q(i,j)
          br(i) = al(i+1)-q(i,j)
        end do
      endif
      if (iord .ne. 11) then
        help_h = ie3-is3+1
        call g_pert_ppm( help_h,q(is3,j),g_q(is3,j),bl(is3),g_bl(is3),br(is3),g_br(is3),0 )
      endif
      if (is .eq. 1) then
        g_br(2) = g_al(3)-g_q(2,j)
        br(2) = al(3)-q(2,j)
        g_xt = (-((g_q(-1,j)+g_q(2,j))*(0.5*dxa(1,j)/(dxa(1,j)+dxa(2,j)))))+(g_q(1,j)+g_q(0,j))*(0.5*(2.*dxa(1,j)+dxa(2,j))/(dxa(1,&
&j)+dxa(2,j)))
        xt = 0.5*((2.*dxa(1,j)+dxa(2,j))*(q(0,j)+q(1,j))-dxa(1,j)*(q(-1,j)+q(2,j)))/(dxa(1,j)+dxa(2,j))
        if (edge_mono_kim) then
          if (j .gt. (-2) .and. j .lt. 1 .or. j .gt. npy-3 .and. j .lt. npy) then
            g_xtzf = g_q(1,j)*(0.5-sign(0.5,q(0,j)-q(1,j)))+g_q(0,j)*(0.5+sign(0.5,q(0,j)-q(1,j)))
            xtzf = max(q(0,j),q(1,j))
            g_xtzg = g_q(0,j-1)*(0.5-sign(0.5,xtzf-q(0,j-1)))+g_xtzf*(0.5+sign(0.5,xtzf-q(0,j-1)))
            xtzg = max(xtzf,q(0,j-1))
            g_xtzh = g_q(1,j-1)*(0.5-sign(0.5,xtzg-q(1,j-1)))+g_xtzg*(0.5+sign(0.5,xtzg-q(1,j-1)))
            xtzh = max(xtzg,q(1,j-1))
            g_xt = g_xt*(0.5+sign(0.5,xtzh-xt))+g_xtzh*(0.5-sign(0.5,xtzh-xt))
            xt = min(xt,xtzh)
            g_xtzc = g_q(1,j)*(0.5-sign(0.5,q(1,j)-q(0,j)))+g_q(0,j)*(0.5+sign(0.5,q(1,j)-q(0,j)))
            xtzc = min(q(0,j),q(1,j))
            g_xtzd = g_q(0,j-1)*(0.5-sign(0.5,q(0,j-1)-xtzc))+g_xtzc*(0.5+sign(0.5,q(0,j-1)-xtzc))
            xtzd = min(xtzc,q(0,j-1))
            g_xtze = g_q(1,j-1)*(0.5-sign(0.5,q(1,j-1)-xtzd))+g_xtzd*(0.5+sign(0.5,q(1,j-1)-xtzd))
            xtze = min(xtzd,q(1,j-1))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtze))+g_xtze*(0.5-sign(0.5,xt-xtze))
            xt = max(xt,xtze)
          else if (j .lt. 3 .and. j .gt. 0 .or. j .gt. npy-1 .and. j .lt. npy+2) then
            g_xtzl = g_q(1,j)*(0.5-sign(0.5,q(0,j)-q(1,j)))+g_q(0,j)*(0.5+sign(0.5,q(0,j)-q(1,j)))
            xtzl = max(q(0,j),q(1,j))
            g_xtzm = g_q(0,j+1)*(0.5-sign(0.5,xtzl-q(0,j+1)))+g_xtzl*(0.5+sign(0.5,xtzl-q(0,j+1)))
            xtzm = max(xtzl,q(0,j+1))
            g_xtzn = g_q(1,j+1)*(0.5-sign(0.5,xtzm-q(1,j+1)))+g_xtzm*(0.5+sign(0.5,xtzm-q(1,j+1)))
            xtzn = max(xtzm,q(1,j+1))
            g_xt = g_xt*(0.5+sign(0.5,xtzn-xt))+g_xtzn*(0.5-sign(0.5,xtzn-xt))
            xt = min(xt,xtzn)
            g_xtzi = g_q(1,j)*(0.5-sign(0.5,q(1,j)-q(0,j)))+g_q(0,j)*(0.5+sign(0.5,q(1,j)-q(0,j)))
            xtzi = min(q(0,j),q(1,j))
            g_xtzj = g_q(0,j+1)*(0.5-sign(0.5,q(0,j+1)-xtzi))+g_xtzi*(0.5+sign(0.5,q(0,j+1)-xtzi))
            xtzj = min(xtzi,q(0,j+1))
            g_xtzk = g_q(1,j+1)*(0.5-sign(0.5,q(1,j+1)-xtzj))+g_xtzj*(0.5+sign(0.5,q(1,j+1)-xtzj))
            xtzk = min(xtzj,q(1,j+1))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtzk))+g_xtzk*(0.5-sign(0.5,xt-xtzk))
            xt = max(xt,xtzk)
          else
            g_xt = g_xt*(0.5-sign(0.5,0.-xt))
            xt = max(0.,xt)
          endif
        else
          g_xt = g_xt*(0.5-sign(0.5,0.-xt))
          xt = max(0.,xt)
        endif
        g_bl(1) = (-g_q(1,j))+g_xt
        bl(1) = xt-q(1,j)
        g_br(0) = (-g_q(0,j))+g_xt
        br(0) = xt-q(0,j)
        g_xt = 0.57142857*g_dm1(-1)+0.78571429*g_q(-1,j)+0.21428571*g_q(0,j)
        xt = 4./7.*dm1(-1)+11./14.*q(-1,j)+3./14.*q(0,j)
        if (s_mono_kim) then
          g_xtzb = g_q(-1,j)*(0.5+sign(0.5,q(-1,j)-q(0,j)))+g_q(0,j)*(0.5-sign(0.5,q(-1,j)-q(0,j)))
          xtzb = max(q(-1,j),q(0,j))
          g_xt = g_xt*(0.5+sign(0.5,xtzb-xt))+g_xtzb*(0.5-sign(0.5,xtzb-xt))
          xt = min(xt,xtzb)
          g_xtza = g_q(-1,j)*(0.5+sign(0.5,q(0,j)-q(-1,j)))+g_q(0,j)*(0.5-sign(0.5,q(0,j)-q(-1,j)))
          xtza = min(q(-1,j),q(0,j))
          g_xt = g_xt*(0.5+sign(0.5,xt-xtza))+g_xtza*(0.5-sign(0.5,xt-xtza))
          xt = max(xt,xtza)
        else
          g_xt = g_xt*(0.5-sign(0.5,0.-xt))
          xt = max(0.,xt)
        endif
        g_bl(0) = (-g_q(0,j))+g_xt
        bl(0) = xt-q(0,j)
        g_xt = (-0.57142857)*g_dm1(2)+0.78571429*g_q(2,j)+0.21428571*g_q(1,j)
        xt = 3./14.*q(1,j)+11./14.*q(2,j)-4./7.*dm1(2)
        if (s_mono_kim) then
          g_xtz = g_q(2,j)*(0.5-sign(0.5,q(1,j)-q(2,j)))+g_q(1,j)*(0.5+sign(0.5,q(1,j)-q(2,j)))
          xtz = max(q(1,j),q(2,j))
          g_xt = g_xt*(0.5+sign(0.5,xtz-xt))+g_xtz*(0.5-sign(0.5,xtz-xt))
          xt = min(xt,xtz)
          g_xty = g_q(2,j)*(0.5-sign(0.5,q(2,j)-q(1,j)))+g_q(1,j)*(0.5+sign(0.5,q(2,j)-q(1,j)))
          xty = min(q(1,j),q(2,j))
          g_xt = g_xt*(0.5+sign(0.5,xt-xty))+g_xty*(0.5-sign(0.5,xt-xty))
          xt = max(xt,xty)
        else
          g_xt = g_xt*(0.5-sign(0.5,0.-xt))
          xt = max(0.,xt)
        endif
        g_br(1) = (-g_q(1,j))+g_xt
        br(1) = xt-q(1,j)
        g_bl(2) = (-g_q(2,j))+g_xt
        bl(2) = xt-q(2,j)
        call g_pert_ppm( 3,q(0,j),g_q(0,j),bl(0),g_bl(0),br(0),g_br(0),1 )
      endif
      if (ie+1 .eq. npx) then
        g_bl(npx-2) = g_al(npx-2)-g_q(npx-2,j)
        bl(npx-2) = al(npx-2)-q(npx-2,j)
        g_xt = (-(g_q(npx-2,j)*(0.5*dxa(npx-1,j)/(dxa(npx-1,j)+dxa(npx-2,j)))))+g_q(npx-1,j)*(0.5*(2.*dxa(npx-1,j)+dxa(npx-2,j))/&
&(dxa(npx-1,j)+dxa(npx-2,j)))-g_q(npx+1,j)*(0.5*dxa(npx-1,j)/(dxa(npx-1,j)+dxa(npx-2,j)))+g_q(npx,j)*(0.5*(2.*dxa(npx-1,j)+&
&dxa(npx-2,j))/(dxa(npx-1,j)+dxa(npx-2,j)))
        xt = 0.5*((2.*dxa(npx-1,j)+dxa(npx-2,j))*(q(npx-1,j)+q(npx,j))-dxa(npx-1,j)*(q(npx-2,j)+q(npx+1,j)))/(dxa(npx-1,j)+dxa(npx-&
&2,j))
        if (edge_mono_kim) then
          if (j .gt. (-2) .and. j .lt. 1 .or. j .gt. npy-3 .and. j .lt. npy) then
            g_xto = g_q(npx-1,j)*(0.5+sign(0.5,q(npx-1,j)-q(npx,j)))+g_q(npx,j)*(0.5-sign(0.5,q(npx-1,j)-q(npx,j)))
            xto = max(q(npx-1,j),q(npx,j))
            g_xtq = g_q(npx-1,j-1)*(0.5-sign(0.5,xto-q(npx-1,j-1)))+g_xto*(0.5+sign(0.5,xto-q(npx-1,j-1)))
            xtq = max(xto,q(npx-1,j-1))
            g_xtr = g_q(npx,j-1)*(0.5-sign(0.5,xtq-q(npx,j-1)))+g_xtq*(0.5+sign(0.5,xtq-q(npx,j-1)))
            xtr = max(xtq,q(npx,j-1))
            g_xt = g_xt*(0.5+sign(0.5,xtr-xt))+g_xtr*(0.5-sign(0.5,xtr-xt))
            xt = min(xt,xtr)
            g_xtl = g_q(npx-1,j)*(0.5+sign(0.5,q(npx,j)-q(npx-1,j)))+g_q(npx,j)*(0.5-sign(0.5,q(npx,j)-q(npx-1,j)))
            xtl = min(q(npx-1,j),q(npx,j))
            g_xtm = g_q(npx-1,j-1)*(0.5-sign(0.5,q(npx-1,j-1)-xtl))+g_xtl*(0.5+sign(0.5,q(npx-1,j-1)-xtl))
            xtm = min(xtl,q(npx-1,j-1))
            g_xtn = g_q(npx,j-1)*(0.5-sign(0.5,q(npx,j-1)-xtm))+g_xtm*(0.5+sign(0.5,q(npx,j-1)-xtm))
            xtn = min(xtm,q(npx,j-1))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtn))+g_xtn*(0.5-sign(0.5,xt-xtn))
            xt = max(xt,xtn)
          else if (j .lt. 3 .and. j .gt. 0 .or. j .gt. npy-1 .and. j .lt. npy+2) then
            g_xtv = g_q(npx-1,j)*(0.5+sign(0.5,q(npx-1,j)-q(npx,j)))+g_q(npx,j)*(0.5-sign(0.5,q(npx-1,j)-q(npx,j)))
            xtv = max(q(npx-1,j),q(npx,j))
            g_xtw = g_q(npx-1,j+1)*(0.5-sign(0.5,xtv-q(npx-1,j+1)))+g_xtv*(0.5+sign(0.5,xtv-q(npx-1,j+1)))
            xtw = max(xtv,q(npx-1,j+1))
            g_xtx = g_q(npx,j+1)*(0.5-sign(0.5,xtw-q(npx,j+1)))+g_xtw*(0.5+sign(0.5,xtw-q(npx,j+1)))
            xtx = max(xtw,q(npx,j+1))
            g_xt = g_xt*(0.5+sign(0.5,xtx-xt))+g_xtx*(0.5-sign(0.5,xtx-xt))
            xt = min(xt,xtx)
            g_xts = g_q(npx-1,j)*(0.5+sign(0.5,q(npx,j)-q(npx-1,j)))+g_q(npx,j)*(0.5-sign(0.5,q(npx,j)-q(npx-1,j)))
            xts = min(q(npx-1,j),q(npx,j))
            g_xtt = g_q(npx-1,j+1)*(0.5-sign(0.5,q(npx-1,j+1)-xts))+g_xts*(0.5+sign(0.5,q(npx-1,j+1)-xts))
            xtt = min(xts,q(npx-1,j+1))
            g_xtu = g_q(npx,j+1)*(0.5-sign(0.5,q(npx,j+1)-xtt))+g_xtt*(0.5+sign(0.5,q(npx,j+1)-xtt))
            xtu = min(xtt,q(npx,j+1))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtu))+g_xtu*(0.5-sign(0.5,xt-xtu))
            xt = max(xt,xtu)
          else
            g_xt = g_xt*(0.5-sign(0.5,0.-xt))
            xt = max(0.,xt)
          endif
        else
          g_xt = g_xt*(0.5-sign(0.5,0.-xt))
          xt = max(0.,xt)
        endif
        g_br(npx-1) = (-g_q(npx-1,j))+g_xt
        br(npx-1) = xt-q(npx-1,j)
        g_bl(npx) = (-g_q(npx,j))+g_xt
        bl(npx) = xt-q(npx,j)
        g_xt = (-0.57142857)*g_dm1(npx+1)+0.78571429*g_q(npx+1,j)+0.21428571*g_q(npx,j)
        xt = 11./14.*q(npx+1,j)+3./14.*q(npx,j)-4./7.*dm1(npx+1)
        if (s_mono_kim) then
          g_xtk = g_q(npx+1,j)*(0.5-sign(0.5,q(npx,j)-q(npx+1,j)))+g_q(npx,j)*(0.5+sign(0.5,q(npx,j)-q(npx+1,j)))
          xtk = max(q(npx,j),q(npx+1,j))
          g_xt = g_xt*(0.5+sign(0.5,xtk-xt))+g_xtk*(0.5-sign(0.5,xtk-xt))
          xt = min(xt,xtk)
          g_xtj = g_q(npx+1,j)*(0.5-sign(0.5,q(npx+1,j)-q(npx,j)))+g_q(npx,j)*(0.5+sign(0.5,q(npx+1,j)-q(npx,j)))
          xtj = min(q(npx,j),q(npx+1,j))
          g_xt = g_xt*(0.5+sign(0.5,xt-xtj))+g_xtj*(0.5-sign(0.5,xt-xtj))
          xt = max(xt,xtj)
        else
          g_xt = g_xt*(0.5-sign(0.5,0.-xt))
          xt = max(0.,xt)
        endif
        g_br(npx) = (-g_q(npx,j))+g_xt
        br(npx) = xt-q(npx,j)
        g_xt = 0.57142857*g_dm1(npx-2)+0.78571429*g_q(npx-2,j)+0.21428571*g_q(npx-1,j)
        xt = 3./14.*q(npx-1,j)+11./14.*q(npx-2,j)+4./7.*dm1(npx-2)
        if (s_mono_kim) then
          g_xti = g_q(npx-2,j)*(0.5+sign(0.5,q(npx-2,j)-q(npx-1,j)))+g_q(npx-1,j)*(0.5-sign(0.5,q(npx-2,j)-q(npx-1,j)))
          xti = max(q(npx-2,j),q(npx-1,j))
          g_xt = g_xt*(0.5+sign(0.5,xti-xt))+g_xti*(0.5-sign(0.5,xti-xt))
          xt = min(xt,xti)
          g_xth = g_q(npx-2,j)*(0.5+sign(0.5,q(npx-1,j)-q(npx-2,j)))+g_q(npx-1,j)*(0.5-sign(0.5,q(npx-1,j)-q(npx-2,j)))
          xth = min(q(npx-2,j),q(npx-1,j))
          g_xt = g_xt*(0.5+sign(0.5,xt-xth))+g_xth*(0.5-sign(0.5,xt-xth))
          xt = max(xt,xth)
        else
          g_xt = g_xt*(0.5-sign(0.5,0.-xt))
          xt = max(0.,xt)
        endif
        g_br(npx-2) = (-g_q(npx-2,j))+g_xt
        br(npx-2) = xt-q(npx-2,j)
        g_bl(npx-1) = (-g_q(npx-1,j))+g_xt
        bl(npx-1) = xt-q(npx-1,j)
        call g_pert_ppm( 3,q(npx-2,j),g_q(npx-2,j),bl(npx-2),g_bl(npx-2),br(npx-2),g_br(npx-2),1 )
      endif
    else
      do i = is-1, ie+2
        g_al(i) = g_dm1(i-1)*r3-g_dm1(i)*r3+0.5*g_q(i-1,j)+0.5*g_q(i,j)
        al(i) = 0.5*(q(i-1,j)+q(i,j))+r3*(dm1(i-1)-dm1(i))
      end do
      if (iord .eq. 11) then
        do i = is-1, ie+1
          g_xt = 2*g_dm1(i)
          xt = 2.*dm1(i)
          g_bli = g_al(i)-g_q(i,j)
          bli = al(i)-q(i,j)
          blh = min(abs(xt),abs(bli))
          g_bl(i) = -((g_bli*(0.5-sign(0.5,abs(bli)-abs(xt)))*sign(1.,bli)+g_xt*(0.5+sign(0.5,abs(bli)-abs(xt)))*sign(1.,xt))*&
&sign(1.,blh)*sign(1.,xt))
          bl(i) = -sign(blh,xt)
          g_bri = g_al(i+1)-g_q(i,j)
          bri = al(i+1)-q(i,j)
          g_brh = g_bri*(0.5-sign(0.5,abs(bri)-abs(xt)))*sign(1.,bri)+g_xt*(0.5+sign(0.5,abs(bri)-abs(xt)))*sign(1.,xt)
          brh = min(abs(xt),abs(bri))
          g_br(i) = g_brh*sign(1.,brh)*sign(1.,xt)
          br(i) = sign(brh,xt)
        end do
      else if (iord .eq. 12) then
        do i = is-3, ie+2
          g_dq(i) = g_q(i+1,j)-g_q(i,j)
          dq(i) = q(i+1,j)-q(i,j)
        end do
        do i = is-1, ie+1
          g_pmp = (-2)*g_dq(i)
          pmp = -(2.*dq(i))
          g_lac = 1.5*g_dq(i+1)+g_pmp
          lac = pmp+1.5*dq(i+1)
          g_blj = g_pmp*(0.5-sign(0.5,0.-pmp))
          blj = max(0.,pmp)
          g_blk = g_blj*(0.5+sign(0.5,blj-lac))+g_lac*(0.5-sign(0.5,blj-lac))
          blk = max(blj,lac)
          g_blm = g_pmp*(0.5-sign(0.5,pmp-0.))
          blm = min(0.,pmp)
          g_bln = g_blm*(0.5+sign(0.5,lac-blm))+g_lac*(0.5-sign(0.5,lac-blm))
          bln = min(blm,lac)
          g_bll = g_al(i)*(0.5+sign(0.5,al(i)-q(i,j)-bln))+g_bln*(0.5-sign(0.5,al(i)-q(i,j)-bln))-g_q(i,j)*(0.5+sign(0.5,al(i)-q(i,&
&j)-bln))
          bll = max(al(i)-q(i,j),bln)
          g_bl(i) = g_blk*(0.5+sign(0.5,bll-blk))+g_bll*(0.5-sign(0.5,bll-blk))
          bl(i) = min(blk,bll)
          g_pmp = 2*g_dq(i-1)
          pmp = 2.*dq(i-1)
          g_lac = (-1.5)*g_dq(i-2)+g_pmp
          lac = pmp-1.5*dq(i-2)
          g_brj = g_pmp*(0.5-sign(0.5,0.-pmp))
          brj = max(0.,pmp)
          g_brk = g_brj*(0.5+sign(0.5,brj-lac))+g_lac*(0.5-sign(0.5,brj-lac))
          brk = max(brj,lac)
          g_brm = g_pmp*(0.5-sign(0.5,pmp-0.))
          brm = min(0.,pmp)
          g_brn = g_brm*(0.5+sign(0.5,lac-brm))+g_lac*(0.5-sign(0.5,lac-brm))
          brn = min(brm,lac)
          g_brl = g_al(i+1)*(0.5+sign(0.5,al(i+1)-q(i,j)-brn))+g_brn*(0.5-sign(0.5,al(i+1)-q(i,j)-brn))-g_q(i,j)*(0.5+sign(0.5,&
&al(i+1)-q(i,j)-brn))
          brl = max(al(i+1)-q(i,j),brn)
          g_br(i) = g_brk*(0.5+sign(0.5,brl-brk))+g_brl*(0.5-sign(0.5,brl-brk))
          br(i) = min(brk,brl)
        end do
      else
        do i = is-1, ie+1
          g_bl(i) = g_al(i)-g_q(i,j)
          bl(i) = al(i)-q(i,j)
          g_br(i) = g_al(i+1)-g_q(i,j)
          br(i) = al(i+1)-q(i,j)
        end do
      endif
      if (iord .ne. 11) then
        help_i = ie-is+1
        call g_pert_ppm( help_i,q(is-1,j),g_q(is-1,j),bl(is-1),g_bl(is-1),br(is-1),g_br(is-1),0 )
      endif
    endif
    do i = is, ie+1
      if (c(i,j) .gt. 0.) then
        g_flux(i,j) = (-(g_bl(i-1)*(1.-c(i,j))*c(i,j)))+g_br(i-1)*(1.-c(i,j))*(1-c(i,j))-g_c(i,j)*((1.-c(i,j))*(bl(i-1)+br(i-1))+&
&br(i-1)-c(i,j)*(bl(i-1)+br(i-1)))+g_q(i-1,j)
        flux(i,j) = q(i-1,j)+(1.-c(i,j))*(br(i-1)-c(i,j)*(bl(i-1)+br(i-1)))
      else
        g_flux(i,j) = g_bl(i)*(1.+c(i,j))*(1+c(i,j))+g_br(i)*(1.+c(i,j))*c(i,j)+g_c(i,j)*((1.+c(i,j))*(bl(i)+br(i))+bl(i)+c(i,j)*&
&(bl(i)+br(i)))+g_q(i,j)
        flux(i,j) = q(i,j)+(1.+c(i,j))*(bl(i)+c(i,j)*(bl(i)+br(i)))
      endif
    end do
  end do
endif

end subroutine g_fxppm


subroutine g_fyppm( c, g_c, q, g_q, flux, g_flux, jord, ifirst, ilast, jfirst, jlast, npx, npy, uniform_ppm, dm, g_dm )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: b1 = 1./30.
real, parameter :: b2 = -(13./60.)
real, parameter :: b3 = -(13./60.)
real, parameter :: b4 = 0.45
real, parameter :: b5 = -0.05
real, parameter :: r3 = 1./3.

!==============================================
! declare arguments
!==============================================
real, intent(in) :: c(isd:ied,js:je+1)
integer, intent(in) :: ifirst
integer, intent(in) :: ilast
integer, intent(in) :: jfirst
integer, intent(in) :: jlast
real, intent(out) :: dm(ifirst:ilast,jfirst-ng:jlast+ng)
real, intent(out) :: flux(ifirst:ilast,jfirst:jlast+1)
real, intent(in) :: g_c(isd:ied,js:je+1)
real, intent(out) :: g_dm(ifirst:ilast,jfirst-ng:jlast+ng)
real, intent(out) :: g_flux(ifirst:ilast,jfirst:jlast+1)
real, intent(in) :: g_q(ifirst:ilast,jfirst-ng:jlast+ng)
integer, intent(in) :: jord
integer, intent(in) :: npx
integer, intent(in) :: npy
real, intent(in) :: q(ifirst:ilast,jfirst-ng:jlast+ng)
logical, intent(in) :: uniform_ppm

!==============================================
! declare local variables
!==============================================
real :: al(ifirst:ilast,jfirst-1:jlast+2)
real :: bl(ifirst:ilast,jfirst-1:jlast+1)
real :: blh
real :: bli
real :: blj
real :: blk
real :: bll
real :: blm
real :: bln
real :: blo
real :: blp
real :: blq
real :: blr
real :: bls
real :: blt
real :: blu
real :: blv
real :: blw
real :: blx
real :: bly
real :: blz
real :: blza
real :: blzb
real :: blzc
real :: blzd
real :: blze
real :: blzf
real :: blzg
real :: blzh
real :: blzi
real :: blzj
real :: blzk
real :: blzl
real :: blzm
real :: blzn
real :: blzo
real :: br(ifirst:ilast,jfirst-1:jlast+1)
real :: brh
real :: bri
real :: brj
real :: brk
real :: brl
real :: brm
real :: brn
real :: bro
real :: brp
real :: brq
real :: brr
real :: brs
real :: brt
real :: bru
real :: brv
real :: brw
real :: brx
real :: bry
real :: brz
real :: brza
real :: brzb
real :: brzc
real :: brzd
real :: brze
real :: brzf
real :: brzg
real :: brzh
real :: brzi
real :: brzj
real :: brzk
real :: brzl
real :: brzm
real :: brzn
real :: brzo
real :: c1
real :: dl
real :: dlh
real :: dli
real :: dlj
real :: dlk
real :: dll
real :: dmh
real :: dmi
real :: dmj
real :: dmk
real :: dml
real :: dmm
real :: dmn
real :: dmo
real :: dmp
real :: dmq
real :: dmr
real :: dms
real :: dmt
real :: dmu
real :: dmv
real :: dmw
real :: dmx
real :: dmy
real :: dmz
real :: dmza
real :: dmzb
real :: dmzc
real :: dmzd
real :: dmze
real :: dmzf
real :: dmzg
real :: dmzh
real :: dmzi
real :: dmzj
real :: dmzk
real :: dmzl
real :: dmzm
real :: dmzn
real :: dmzo
real :: dmzp
real :: dmzq
real :: dmzr
real :: dmzs
real :: dmzu
real :: dmzv
real :: dmzx
real :: dmzy
real :: dmzz
real :: dq(ifirst:ilast,jfirst-3:jlast+2)
real :: dr
real :: drh
real :: dri
real :: drj
real :: drk
real :: drl
real :: g_al(ifirst:ilast,jfirst-1:jlast+2)
real :: g_bl(ifirst:ilast,jfirst-1:jlast+1)
real :: g_bli
real :: g_blj
real :: g_blk
real :: g_bll
real :: g_blm
real :: g_bln
real :: g_blp
real :: g_blq
real :: g_blr
real :: g_bls
real :: g_blt
real :: g_blu
real :: g_blv
real :: g_blw
real :: g_blx
real :: g_bly
real :: g_blz
real :: g_blza
real :: g_blzb
real :: g_blzc
real :: g_blzd
real :: g_blze
real :: g_blzf
real :: g_blzg
real :: g_blzh
real :: g_blzi
real :: g_blzj
real :: g_blzk
real :: g_blzl
real :: g_blzm
real :: g_blzn
real :: g_blzo
real :: g_br(ifirst:ilast,jfirst-1:jlast+1)
real :: g_brh
real :: g_bri
real :: g_brj
real :: g_brk
real :: g_brl
real :: g_brm
real :: g_brn
real :: g_bro
real :: g_brp
real :: g_brq
real :: g_brr
real :: g_brs
real :: g_brt
real :: g_bru
real :: g_brv
real :: g_brw
real :: g_brx
real :: g_bry
real :: g_brz
real :: g_brza
real :: g_brzb
real :: g_brzc
real :: g_brzd
real :: g_brze
real :: g_brzf
real :: g_brzg
real :: g_brzh
real :: g_brzi
real :: g_brzj
real :: g_brzk
real :: g_brzl
real :: g_brzm
real :: g_brzn
real :: g_brzo
real :: g_c1
real :: g_dl
real :: g_dlh
real :: g_dli
real :: g_dlj
real :: g_dlk
real :: g_dmh
real :: g_dmi
real :: g_dmj
real :: g_dmk
real :: g_dml
real :: g_dmm
real :: g_dmn
real :: g_dmo
real :: g_dmp
real :: g_dmq
real :: g_dmr
real :: g_dms
real :: g_dmt
real :: g_dmu
real :: g_dmv
real :: g_dmw
real :: g_dmx
real :: g_dmy
real :: g_dmz
real :: g_dmza
real :: g_dmzb
real :: g_dmzc
real :: g_dmzd
real :: g_dmze
real :: g_dmzf
real :: g_dmzg
real :: g_dmzh
real :: g_dmzi
real :: g_dmzj
real :: g_dmzk
real :: g_dmzl
real :: g_dmzm
real :: g_dmzn
real :: g_dmzo
real :: g_dmzp
real :: g_dmzq
real :: g_dmzr
real :: g_dmzs
real :: g_dmzu
real :: g_dmzv
real :: g_dmzx
real :: g_dmzy
real :: g_dmzz
real :: g_dq(ifirst:ilast,jfirst-3:jlast+2)
real :: g_dr
real :: g_drh
real :: g_dri
real :: g_drj
real :: g_drk
real :: g_drl
real :: g_lac
real :: g_pmp
real :: g_qe
real :: g_xt
real :: g_xth
real :: g_xti
real :: g_xtj
real :: g_xtk
real :: g_xtl
real :: g_xtm
real :: g_xtn
real :: g_xto
real :: g_xtq
real :: g_xtr
real :: g_xts
real :: g_xtt
real :: g_xtu
real :: g_xtv
real :: g_xtw
real :: g_xtx
real :: g_xty
real :: g_xtz
real :: g_xtza
real :: g_xtzb
real :: g_xtzc
real :: g_xtzd
real :: g_xtze
real :: g_xtzf
real :: g_xtzg
real :: g_xtzh
real :: g_xtzi
real :: g_xtzj
real :: g_xtzk
real :: g_xtzl
real :: g_xtzm
real :: g_xtzn
real :: g_xtzo
real :: g_xtzp
real :: g_xtzq
real :: g_xtzr
real :: g_xtzs
real :: g_xtzt
real :: g_xtzu
real :: g_xtzv
real :: g_xtzw
real :: g_xtzx
real :: g_xtzy
real :: g_xtzz
real :: g_xtzza
real :: g_xtzzb
real :: g_xtzzc
real :: g_xtzzd
real :: g_xtzze
real :: g_xtzzf
real :: g_xtzzg
real :: g_xtzzh
real :: g_xtzzi
real :: g_xtzzj
real :: g_xtzzk
real :: g_xtzzl
real :: g_xtzzm
real :: g_xtzzn
real :: g_xtzzo
real :: g_xtzzp
real :: g_xtzzq
real :: g_xtzzr
real :: g_xtzzs
real :: g_xtzzt
integer :: help_h
integer :: help_i
integer :: help_j
integer :: help_k
integer :: help_l
integer :: help_m
integer :: i
integer :: j
integer :: je3
integer :: js3
integer :: jt
real :: lac
real :: pmp
real :: qe
real :: xt
real :: xth
real :: xti
real :: xtj
real :: xtk
real :: xtl
real :: xtm
real :: xtn
real :: xto
real :: xtq
real :: xtr
real :: xts
real :: xtt
real :: xtu
real :: xtv
real :: xtw
real :: xtx
real :: xty
real :: xtz
real :: xtza
real :: xtzb
real :: xtzc
real :: xtzd
real :: xtze
real :: xtzf
real :: xtzg
real :: xtzh
real :: xtzi
real :: xtzj
real :: xtzk
real :: xtzl
real :: xtzm
real :: xtzn
real :: xtzo
real :: xtzp
real :: xtzq
real :: xtzr
real :: xtzs
real :: xtzt
real :: xtzu
real :: xtzv
real :: xtzw
real :: xtzx
real :: xtzy
real :: xtzz
real :: xtzza
real :: xtzzb
real :: xtzzc
real :: xtzzd
real :: xtzze
real :: xtzzf
real :: xtzzg
real :: xtzzh
real :: xtzzi
real :: xtzzj
real :: xtzzk
real :: xtzzl
real :: xtzzm
real :: xtzzn
real :: xtzzo
real :: xtzzp
real :: xtzzq
real :: xtzzr
real :: xtzzs
real :: xtzzt

!----------------------------------------------
! TANGENT LINEAR AND FUNCTION STATEMENTS
!----------------------------------------------
if (jord .le. 4) then
  if (uniform_ppm) then
    do j = jfirst-2, jlast+2
      do i = ifirst, ilast
        g_xt = (-0.25)*g_q(i,j-1)+0.25*g_q(i,j+1)
        xt = 0.25*(q(i,j+1)-q(i,j-1))
        g_dmt = g_xt*sign(1.,xt)
        dmt = abs(xt)
        g_dmu = g_q(i,j-1)*(0.5+sign(0.5,q(i,j-1)-q(i,j)))+g_q(i,j)*(0.5-sign(0.5,q(i,j-1)-q(i,j)))
        dmu = max(q(i,j-1),q(i,j))
        g_dmw = g_dmu*(0.5+sign(0.5,dmu-q(i,j+1)))+g_q(i,j+1)*(0.5-sign(0.5,dmu-q(i,j+1)))-g_q(i,j)
        dmw = max(dmu,q(i,j+1))-q(i,j)
        g_dmx = g_q(i,j-1)*(0.5+sign(0.5,q(i,j)-q(i,j-1)))+g_q(i,j)*(0.5-sign(0.5,q(i,j)-q(i,j-1)))
        dmx = min(q(i,j-1),q(i,j))
        g_dmz = (-(g_dmx*(0.5+sign(0.5,q(i,j+1)-dmx))+g_q(i,j+1)*(0.5-sign(0.5,q(i,j+1)-dmx))))+g_q(i,j)
        dmz = q(i,j)-min(dmx,q(i,j+1))
        g_dmza = g_dmt*(0.5+sign(0.5,dmw-dmt))+g_dmw*(0.5-sign(0.5,dmw-dmt))
        dmza = min(dmt,dmw)
        g_dmzb = g_dmz*(0.5-sign(0.5,dmz-dmza))+g_dmza*(0.5+sign(0.5,dmz-dmza))
        dmzb = min(dmza,dmz)
        g_dm(i,j) = g_dmzb*sign(1.,dmzb)*sign(1.,xt)
        dm(i,j) = sign(dmzb,xt)
      end do
    end do
  else
    do j = jfirst-3, jlast+2
      do i = ifirst, ilast
        g_dq(i,j) = g_q(i,j+1)-g_q(i,j)
        dq(i,j) = q(i,j+1)-q(i,j)
      end do
    end do
    do j = jfirst-2, jlast+2
      do i = ifirst, ilast
        g_xt = g_dq(i,j-1)*cy1(i,j)+g_dq(i,j)*cy2(i,j)
        xt = cy1(i,j)*dq(i,j-1)+cy2(i,j)*dq(i,j)
        g_dmj = g_xt*sign(1.,xt)
        dmj = abs(xt)
        g_dmm = g_dq(i,j-1)*sign(1.,dq(i,j-1))
        dmm = abs(dq(i,j-1))
        g_dmq = g_dq(i,j)*sign(1.,dq(i,j))
        dmq = abs(dq(i,j))
        g_dmr = g_dmj*(0.5+sign(0.5,dmm-dmj))+g_dmm*(0.5-sign(0.5,dmm-dmj))
        dmr = min(dmj,dmm)
        g_dms = g_dmq*(0.5-sign(0.5,dmq-dmr))+g_dmr*(0.5+sign(0.5,dmq-dmr))
        dms = min(dmr,dmq)
        g_dm(i,j) = g_dms*sign(1.,dms)*sign(1.,xt)
        dm(i,j) = sign(dms,xt)
      end do
    end do
  endif
  do j = jfirst-1, jlast+2
    do i = ifirst, ilast
      g_al(i,j) = g_dm(i,j-1)*r3-g_dm(i,j)*r3+0.5*g_q(i,j-1)+0.5*g_q(i,j)
      al(i,j) = 0.5*(q(i,j-1)+q(i,j))+r3*(dm(i,j-1)-dm(i,j))
    end do
  end do
  do j = jfirst, jlast+1
    do i = ifirst, ilast
      if (c(i,j) .gt. 0.) then
        g_xt = 2*g_dm(i,j-1)
        xt = 2.*dm(i,j-1)
        g_dlk = g_al(i,j-1)-g_q(i,j-1)
        dlk = al(i,j-1)-q(i,j-1)
        g_dlj = g_dlk*(0.5-sign(0.5,abs(dlk)-abs(xt)))*sign(1.,dlk)+g_xt*(0.5+sign(0.5,abs(dlk)-abs(xt)))*sign(1.,xt)
        dlj = min(abs(xt),abs(dlk))
        g_dl = g_dlj*sign(1.,dlj)*sign(1.,xt)
        dl = sign(dlj,xt)
        g_drk = g_al(i,j)-g_q(i,j-1)
        drk = al(i,j)-q(i,j-1)
        g_drj = g_drk*(0.5-sign(0.5,abs(drk)-abs(xt)))*sign(1.,drk)+g_xt*(0.5+sign(0.5,abs(drk)-abs(xt)))*sign(1.,xt)
        drj = min(abs(xt),abs(drk))
        g_dr = g_drj*sign(1.,drj)*sign(1.,xt)
        dr = sign(drj,xt)
        g_flux(i,j) = g_c(i,j)*((1.-c(i,j))*(dl-dr)-(c(i,j)*(dl-dr)+dr))+g_dl*(1.-c(i,j))*c(i,j)+g_dr*(1.-c(i,j))*(1-c(i,j))+g_q(i,&
&j-1)
        flux(i,j) = q(i,j-1)+(1.-c(i,j))*(c(i,j)*(dl-dr)+dr)
      else
        g_xt = 2*g_dm(i,j)
        xt = 2.*dm(i,j)
        g_dli = g_al(i,j)-g_q(i,j)
        dli = al(i,j)-q(i,j)
        g_dlh = g_dli*(0.5-sign(0.5,abs(dli)-abs(xt)))*sign(1.,dli)+g_xt*(0.5+sign(0.5,abs(dli)-abs(xt)))*sign(1.,xt)
        dlh = min(abs(xt),abs(dli))
        g_dl = g_dlh*sign(1.,dlh)*sign(1.,xt)
        dl = sign(dlh,xt)
        g_dri = g_al(i,j+1)-g_q(i,j)
        dri = al(i,j+1)-q(i,j)
        g_drh = g_dri*(0.5-sign(0.5,abs(dri)-abs(xt)))*sign(1.,dri)+g_xt*(0.5+sign(0.5,abs(dri)-abs(xt)))*sign(1.,xt)
        drh = min(abs(xt),abs(dri))
        g_dr = g_drh*sign(1.,drh)*sign(1.,xt)
        dr = sign(drh,xt)
        g_flux(i,j) = (-(g_c(i,j)*((1.+2*c(i,j))*(dl-dr)+dl)+g_dl*(1.+c(i,j))*(1+c(i,j))))+g_dr*(1.+c(i,j))*c(i,j)+g_q(i,j)
        flux(i,j) = q(i,j)-(1.+c(i,j))*(c(i,j)*(dl-dr)+dl)
      endif
    end do
  end do
else if (jord .eq. 5) then
  do j = jfirst-3, jlast+2
    do i = ifirst, ilast
      g_dq(i,j) = g_q(i,j+1)-g_q(i,j)
      dq(i,j) = q(i,j+1)-q(i,j)
    end do
  end do
  if (uniform_ppm) then
    do j = jfirst-2, jlast+2
      do i = ifirst, ilast
        g_xt = (-0.25)*g_q(i,j-1)+0.25*g_q(i,j+1)
        xt = 0.25*(q(i,j+1)-q(i,j-1))
        g_dmzr = g_xt*sign(1.,xt)
        dmzr = abs(xt)
        g_dmzs = g_q(i,j-1)*(0.5+sign(0.5,q(i,j-1)-q(i,j)))+g_q(i,j)*(0.5-sign(0.5,q(i,j-1)-q(i,j)))
        dmzs = max(q(i,j-1),q(i,j))
        g_dmzu = g_dmzs*(0.5+sign(0.5,dmzs-q(i,j+1)))+g_q(i,j+1)*(0.5-sign(0.5,dmzs-q(i,j+1)))-g_q(i,j)
        dmzu = max(dmzs,q(i,j+1))-q(i,j)
        g_dmzv = g_q(i,j-1)*(0.5+sign(0.5,q(i,j)-q(i,j-1)))+g_q(i,j)*(0.5-sign(0.5,q(i,j)-q(i,j-1)))
        dmzv = min(q(i,j-1),q(i,j))
        g_dmzx = (-(g_dmzv*(0.5+sign(0.5,q(i,j+1)-dmzv))+g_q(i,j+1)*(0.5-sign(0.5,q(i,j+1)-dmzv))))+g_q(i,j)
        dmzx = q(i,j)-min(dmzv,q(i,j+1))
        g_dmzy = g_dmzr*(0.5+sign(0.5,dmzu-dmzr))+g_dmzu*(0.5-sign(0.5,dmzu-dmzr))
        dmzy = min(dmzr,dmzu)
        g_dmzz = g_dmzx*(0.5-sign(0.5,dmzx-dmzy))+g_dmzy*(0.5+sign(0.5,dmzx-dmzy))
        dmzz = min(dmzy,dmzx)
        g_dm(i,j) = g_dmzz*sign(1.,dmzz)*sign(1.,xt)
        dm(i,j) = sign(dmzz,xt)
      end do
    end do
  else
    do j = jfirst-2, jlast+2
      do i = ifirst, ilast
        g_xt = g_dq(i,j-1)*cy1(i,j)+g_dq(i,j)*cy2(i,j)
        xt = cy1(i,j)*dq(i,j-1)+cy2(i,j)*dq(i,j)
        g_dmzh = g_xt*sign(1.,xt)
        dmzh = abs(xt)
        g_dmzk = g_dq(i,j-1)*sign(1.,dq(i,j-1))
        dmzk = abs(dq(i,j-1))
        g_dmzo = g_dq(i,j)*sign(1.,dq(i,j))
        dmzo = abs(dq(i,j))
        g_dmzp = g_dmzh*(0.5+sign(0.5,dmzk-dmzh))+g_dmzk*(0.5-sign(0.5,dmzk-dmzh))
        dmzp = min(dmzh,dmzk)
        g_dmzq = g_dmzo*(0.5-sign(0.5,dmzo-dmzp))+g_dmzp*(0.5+sign(0.5,dmzo-dmzp))
        dmzq = min(dmzp,dmzo)
        g_dm(i,j) = g_dmzq*sign(1.,dmzq)*sign(1.,xt)
        dm(i,j) = sign(dmzq,xt)
      end do
    end do
  endif
  do j = jfirst-1, jlast+2
    do i = ifirst, ilast
      g_al(i,j) = g_dm(i,j-1)*r3-g_dm(i,j)*r3+0.5*g_q(i,j-1)+0.5*g_q(i,j)
      al(i,j) = 0.5*(q(i,j-1)+q(i,j))+r3*(dm(i,j-1)-dm(i,j))
    end do
  end do
  do j = jfirst-1, jlast+1
    do i = ifirst, ilast
      g_pmp = (-2)*g_dq(i,j)
      pmp = -(2.*dq(i,j))
      g_lac = 1.5*g_dq(i,j+1)+g_pmp
      lac = pmp+1.5*dq(i,j+1)
      g_blzk = g_pmp*(0.5-sign(0.5,0.-pmp))
      blzk = max(0.,pmp)
      g_blzl = g_blzk*(0.5+sign(0.5,blzk-lac))+g_lac*(0.5-sign(0.5,blzk-lac))
      blzl = max(blzk,lac)
      g_blzn = g_pmp*(0.5-sign(0.5,pmp-0.))
      blzn = min(0.,pmp)
      g_blzo = g_blzn*(0.5+sign(0.5,lac-blzn))+g_lac*(0.5-sign(0.5,lac-blzn))
      blzo = min(blzn,lac)
      g_blzm = g_al(i,j)*(0.5+sign(0.5,al(i,j)-q(i,j)-blzo))+g_blzo*(0.5-sign(0.5,al(i,j)-q(i,j)-blzo))-g_q(i,j)*(0.5+sign(0.5,&
&al(i,j)-q(i,j)-blzo))
      blzm = max(al(i,j)-q(i,j),blzo)
      g_bl(i,j) = g_blzl*(0.5+sign(0.5,blzm-blzl))+g_blzm*(0.5-sign(0.5,blzm-blzl))
      bl(i,j) = min(blzl,blzm)
      g_pmp = 2*g_dq(i,j-1)
      pmp = 2.*dq(i,j-1)
      g_lac = (-1.5)*g_dq(i,j-2)+g_pmp
      lac = pmp-1.5*dq(i,j-2)
      g_brzk = g_pmp*(0.5-sign(0.5,0.-pmp))
      brzk = max(0.,pmp)
      g_brzl = g_brzk*(0.5+sign(0.5,brzk-lac))+g_lac*(0.5-sign(0.5,brzk-lac))
      brzl = max(brzk,lac)
      g_brzn = g_pmp*(0.5-sign(0.5,pmp-0.))
      brzn = min(0.,pmp)
      g_brzo = g_brzn*(0.5+sign(0.5,lac-brzn))+g_lac*(0.5-sign(0.5,lac-brzn))
      brzo = min(brzn,lac)
      g_brzm = g_al(i,j+1)*(0.5+sign(0.5,al(i,j+1)-q(i,j)-brzo))+g_brzo*(0.5-sign(0.5,al(i,j+1)-q(i,j)-brzo))-g_q(i,j)*(0.5+&
&sign(0.5,al(i,j+1)-q(i,j)-brzo))
      brzm = max(al(i,j+1)-q(i,j),brzo)
      g_br(i,j) = g_brzl*(0.5+sign(0.5,brzm-brzl))+g_brzm*(0.5-sign(0.5,brzm-brzl))
      br(i,j) = min(brzl,brzm)
    end do
  end do
  do j = jfirst, jlast+1
    do i = ifirst, ilast
      if (c(i,j) .gt. 0.) then
        g_flux(i,j) = (-(g_bl(i,j-1)*(1.-c(i,j))*c(i,j)))+g_br(i,j-1)*(1.-c(i,j))*(1-c(i,j))-g_c(i,j)*((1.-c(i,j))*(bl(i,j-1)+br(i,&
&j-1))+br(i,j-1)-c(i,j)*(bl(i,j-1)+br(i,j-1)))+g_q(i,j-1)
        flux(i,j) = q(i,j-1)+(1.-c(i,j))*(br(i,j-1)-c(i,j)*(bl(i,j-1)+br(i,j-1)))
      else
        g_flux(i,j) = g_bl(i,j)*(1.+c(i,j))*(1+c(i,j))+g_br(i,j)*(1.+c(i,j))*c(i,j)+g_c(i,j)*((1.+c(i,j))*(bl(i,j)+br(i,j))+bl(i,j)&
&+c(i,j)*(bl(i,j)+br(i,j)))+g_q(i,j)
        flux(i,j) = q(i,j)+(1.+c(i,j))*(bl(i,j)+c(i,j)*(bl(i,j)+br(i,j)))
      endif
    end do
  end do
else if (jord .eq. 6 .or. jord .eq. 7) then
  do j = jfirst-1, jlast+1
    do i = ifirst, ilast
      g_xt = g_q(i,j)*b3
      xt = b3*q(i,j)
      g_bl(i,j) = g_q(i,j-2)*b5+g_q(i,j-1)*b4+g_q(i,j+2)*b1+g_q(i,j+1)*b2+g_xt
      bl(i,j) = b5*q(i,j-2)+b4*q(i,j-1)+xt+b2*q(i,j+1)+b1*q(i,j+2)
      g_br(i,j) = g_q(i,j-2)*b1+g_q(i,j-1)*b2+g_q(i,j+2)*b5+g_q(i,j+1)*b4+g_xt
      br(i,j) = b1*q(i,j-2)+b2*q(i,j-1)+xt+b4*q(i,j+1)+b5*q(i,j+2)
    end do
  end do
  if (jord .eq. 7) then
    do j = jfirst-2, jlast+3
      do i = ifirst, ilast
        g_dq(i,j) = (-g_q(i,j-1))+g_q(i,j)
        dq(i,j) = q(i,j)-q(i,j-1)
      end do
    end do
    do j = jfirst-1, jlast+1
      do i = ifirst, ilast
        dll = min(abs(bl(i,j)),abs(dq(i,j)))
        g_dl = -((g_bl(i,j)*(0.5+sign(0.5,abs(dq(i,j))-abs(bl(i,j))))*sign(1.,bl(i,j))+g_dq(i,j)*(0.5-sign(0.5,abs(dq(i,j))-&
&abs(bl(i,j))))*sign(1.,dq(i,j)))*sign(1.,dll)*sign(1.,dq(i,j)))
        dl = -sign(dll,dq(i,j))
        g_pmp = (-2)*g_dq(i,j+1)
        pmp = -(2.*dq(i,j+1))
        g_lac = 1.5*g_dq(i,j+2)+g_pmp
        lac = pmp+1.5*dq(i,j+2)
        g_blzf = g_pmp*(0.5-sign(0.5,0.-pmp))
        blzf = max(0.,pmp)
        g_blzg = g_blzf*(0.5+sign(0.5,blzf-lac))+g_lac*(0.5-sign(0.5,blzf-lac))
        blzg = max(blzf,lac)
        g_blzi = g_pmp*(0.5-sign(0.5,pmp-0.))
        blzi = min(0.,pmp)
        g_blzj = g_blzi*(0.5+sign(0.5,lac-blzi))+g_lac*(0.5-sign(0.5,lac-blzi))
        blzj = min(blzi,lac)
        g_blzh = g_blzj*(0.5-sign(0.5,dl-blzj))+g_dl*(0.5+sign(0.5,dl-blzj))
        blzh = max(dl,blzj)
        g_bl(i,j) = g_blzg*(0.5+sign(0.5,blzh-blzg))+g_blzh*(0.5-sign(0.5,blzh-blzg))
        bl(i,j) = min(blzg,blzh)
        g_drl = g_br(i,j)*(0.5+sign(0.5,abs(dq(i,j+1))-abs(br(i,j))))*sign(1.,br(i,j))+g_dq(i,j+1)*(0.5-sign(0.5,abs(dq(i,j+1))-&
&abs(br(i,j))))*sign(1.,dq(i,j+1))
        drl = min(abs(br(i,j)),abs(dq(i,j+1)))
        g_dr = g_drl*sign(1.,drl)*sign(1.,dq(i,j+1))
        dr = sign(drl,dq(i,j+1))
        g_pmp = 2*g_dq(i,j)
        pmp = 2.*dq(i,j)
        g_lac = (-1.5)*g_dq(i,j-1)+g_pmp
        lac = pmp-1.5*dq(i,j-1)
        g_brzf = g_pmp*(0.5-sign(0.5,0.-pmp))
        brzf = max(0.,pmp)
        g_brzg = g_brzf*(0.5+sign(0.5,brzf-lac))+g_lac*(0.5-sign(0.5,brzf-lac))
        brzg = max(brzf,lac)
        g_brzi = g_pmp*(0.5-sign(0.5,pmp-0.))
        brzi = min(0.,pmp)
        g_brzj = g_brzi*(0.5+sign(0.5,lac-brzi))+g_lac*(0.5-sign(0.5,lac-brzi))
        brzj = min(brzi,lac)
        g_brzh = g_brzj*(0.5-sign(0.5,dr-brzj))+g_dr*(0.5+sign(0.5,dr-brzj))
        brzh = max(dr,brzj)
        g_br(i,j) = g_brzg*(0.5+sign(0.5,brzh-brzg))+g_brzh*(0.5-sign(0.5,brzh-brzg))
        br(i,j) = min(brzg,brzh)
      end do
    end do
  endif
  do j = jfirst, jlast+1
    do i = ifirst, ilast
      if (c(i,j) .gt. 0.) then
        g_flux(i,j) = (-(g_bl(i,j-1)*(1.-c(i,j))*c(i,j)))+g_br(i,j-1)*(1.-c(i,j))*(1-c(i,j))-g_c(i,j)*((1.-c(i,j))*(bl(i,j-1)+br(i,&
&j-1))+br(i,j-1)-c(i,j)*(bl(i,j-1)+br(i,j-1)))+g_q(i,j-1)
        flux(i,j) = q(i,j-1)+(1.-c(i,j))*(br(i,j-1)-c(i,j)*(bl(i,j-1)+br(i,j-1)))
      else
        g_flux(i,j) = g_bl(i,j)*(1.+c(i,j))*(1+c(i,j))+g_br(i,j)*(1.+c(i,j))*c(i,j)+g_c(i,j)*((1.+c(i,j))*(bl(i,j)+br(i,j))+bl(i,j)&
&+c(i,j)*(bl(i,j)+br(i,j)))+g_q(i,j)
        flux(i,j) = q(i,j)+(1.+c(i,j))*(bl(i,j)+c(i,j)*(bl(i,j)+br(i,j)))
      endif
    end do
  end do
else if (jord .eq. 9 .or. jord .eq. 10) then
  do j = js-3, je+2
    do i = ifirst, ilast
      g_dq(i,j) = g_q(i,j+1)-g_q(i,j)
      dq(i,j) = q(i,j+1)-q(i,j)
    end do
  end do
  if (uniform_ppm) then
    do j = js-2, je+2
      do i = ifirst, ilast
        g_xt = (-0.25)*g_q(i,j-1)+0.25*g_q(i,j+1)
        xt = 0.25*(q(i,j+1)-q(i,j-1))
        g_dmzf = g_xt*sign(1.,xt)
        dmzf = abs(xt)
        g_dmzg = g_q(i,j-1)*(0.5+sign(0.5,q(i,j-1)-q(i,j)))+g_q(i,j)*(0.5-sign(0.5,q(i,j-1)-q(i,j)))
        dmzg = max(q(i,j-1),q(i,j))
        g_dmzi = g_dmzg*(0.5+sign(0.5,dmzg-q(i,j+1)))+g_q(i,j+1)*(0.5-sign(0.5,dmzg-q(i,j+1)))-g_q(i,j)
        dmzi = max(dmzg,q(i,j+1))-q(i,j)
        g_dmzj = g_q(i,j-1)*(0.5+sign(0.5,q(i,j)-q(i,j-1)))+g_q(i,j)*(0.5-sign(0.5,q(i,j)-q(i,j-1)))
        dmzj = min(q(i,j-1),q(i,j))
        g_dmzl = (-(g_dmzj*(0.5+sign(0.5,q(i,j+1)-dmzj))+g_q(i,j+1)*(0.5-sign(0.5,q(i,j+1)-dmzj))))+g_q(i,j)
        dmzl = q(i,j)-min(dmzj,q(i,j+1))
        g_dmzm = g_dmzf*(0.5+sign(0.5,dmzi-dmzf))+g_dmzi*(0.5-sign(0.5,dmzi-dmzf))
        dmzm = min(dmzf,dmzi)
        g_dmzn = g_dmzl*(0.5-sign(0.5,dmzl-dmzm))+g_dmzm*(0.5+sign(0.5,dmzl-dmzm))
        dmzn = min(dmzm,dmzl)
        g_dm(i,j) = g_dmzn*sign(1.,dmzn)*sign(1.,xt)
        dm(i,j) = sign(dmzn,xt)
      end do
    end do
  else
    do j = js-2, je+2
      do i = ifirst, ilast
        g_xt = g_dq(i,j-1)*cy1(i,j)+g_dq(i,j)*cy2(i,j)
        xt = cy1(i,j)*dq(i,j-1)+cy2(i,j)*dq(i,j)
        g_dmv = g_xt*sign(1.,xt)
        dmv = abs(xt)
        g_dmy = g_dq(i,j-1)*sign(1.,dq(i,j-1))
        dmy = abs(dq(i,j-1))
        g_dmzc = g_dq(i,j)*sign(1.,dq(i,j))
        dmzc = abs(dq(i,j))
        g_dmzd = g_dmv*(0.5+sign(0.5,dmy-dmv))+g_dmy*(0.5-sign(0.5,dmy-dmv))
        dmzd = min(dmv,dmy)
        g_dmze = g_dmzc*(0.5-sign(0.5,dmzc-dmzd))+g_dmzd*(0.5+sign(0.5,dmzc-dmzd))
        dmze = min(dmzd,dmzc)
        g_dm(i,j) = g_dmze*sign(1.,dmze)*sign(1.,xt)
        dm(i,j) = sign(dmze,xt)
      end do
    end do
  endif
  if (grid_type .lt. 3) then
    do j = max(3,js-1), min(npy-2,je+2)
      do i = ifirst, ilast
        g_al(i,j) = g_dm(i,j-1)*r3-g_dm(i,j)*r3+0.5*g_q(i,j-1)+0.5*g_q(i,j)
        al(i,j) = 0.5*(q(i,j-1)+q(i,j))+r3*(dm(i,j-1)-dm(i,j))
      end do
    end do
    do j = max(3,js-1), min(npy-3,je+1)
      do i = ifirst, ilast
        g_pmp = (-2)*g_dq(i,j)
        pmp = -(2.*dq(i,j))
        g_lac = 1.5*g_dq(i,j+1)+g_pmp
        lac = pmp+1.5*dq(i,j+1)
        g_blza = g_pmp*(0.5-sign(0.5,0.-pmp))
        blza = max(0.,pmp)
        g_blzb = g_blza*(0.5+sign(0.5,blza-lac))+g_lac*(0.5-sign(0.5,blza-lac))
        blzb = max(blza,lac)
        g_blzd = g_pmp*(0.5-sign(0.5,pmp-0.))
        blzd = min(0.,pmp)
        g_blze = g_blzd*(0.5+sign(0.5,lac-blzd))+g_lac*(0.5-sign(0.5,lac-blzd))
        blze = min(blzd,lac)
        g_blzc = g_al(i,j)*(0.5+sign(0.5,al(i,j)-q(i,j)-blze))+g_blze*(0.5-sign(0.5,al(i,j)-q(i,j)-blze))-g_q(i,j)*(0.5+sign(0.5,&
&al(i,j)-q(i,j)-blze))
        blzc = max(al(i,j)-q(i,j),blze)
        g_bl(i,j) = g_blzb*(0.5+sign(0.5,blzc-blzb))+g_blzc*(0.5-sign(0.5,blzc-blzb))
        bl(i,j) = min(blzb,blzc)
        g_pmp = 2*g_dq(i,j-1)
        pmp = 2.*dq(i,j-1)
        g_lac = (-1.5)*g_dq(i,j-2)+g_pmp
        lac = pmp-1.5*dq(i,j-2)
        g_brza = g_pmp*(0.5-sign(0.5,0.-pmp))
        brza = max(0.,pmp)
        g_brzb = g_brza*(0.5+sign(0.5,brza-lac))+g_lac*(0.5-sign(0.5,brza-lac))
        brzb = max(brza,lac)
        g_brzd = g_pmp*(0.5-sign(0.5,pmp-0.))
        brzd = min(0.,pmp)
        g_brze = g_brzd*(0.5+sign(0.5,lac-brzd))+g_lac*(0.5-sign(0.5,lac-brzd))
        brze = min(brzd,lac)
        g_brzc = g_al(i,j+1)*(0.5+sign(0.5,al(i,j+1)-q(i,j)-brze))+g_brze*(0.5-sign(0.5,al(i,j+1)-q(i,j)-brze))-g_q(i,j)*(0.5+&
&sign(0.5,al(i,j+1)-q(i,j)-brze))
        brzc = max(al(i,j+1)-q(i,j),brze)
        g_br(i,j) = g_brzb*(0.5+sign(0.5,brzc-brzb))+g_brzc*(0.5-sign(0.5,brzc-brzb))
        br(i,j) = min(brzb,brzc)
      end do
    end do
    if (js .eq. 1) then
      do i = ifirst, ilast
        g_br(i,2) = g_al(i,3)-g_q(i,2)
        br(i,2) = al(i,3)-q(i,2)
        g_xt = (-((g_q(i,-1)+g_q(i,2))*(0.5*dya(i,1)/(dya(i,1)+dya(i,2)))))+(g_q(i,1)+g_q(i,0))*(0.5*(2.*dya(i,1)+dya(i,2))/(dya(i,&
&1)+dya(i,2)))
        xt = 0.5*((2.*dya(i,1)+dya(i,2))*(q(i,0)+q(i,1))-dya(i,1)*(q(i,-1)+q(i,2)))/(dya(i,1)+dya(i,2))
        if (edge_mono_kim) then
          if (i .gt. (-2) .and. i .lt. 1 .or. i .gt. npx-3 .and. i .lt. npx) then
            g_xtzzl = g_q(i,1)*(0.5-sign(0.5,q(i,0)-q(i,1)))+g_q(i,0)*(0.5+sign(0.5,q(i,0)-q(i,1)))
            xtzzl = max(q(i,0),q(i,1))
            g_xtzzm = g_q(i-1,0)*(0.5-sign(0.5,xtzzl-q(i-1,0)))+g_xtzzl*(0.5+sign(0.5,xtzzl-q(i-1,0)))
            xtzzm = max(xtzzl,q(i-1,0))
            g_xtzzn = g_q(i-1,1)*(0.5-sign(0.5,xtzzm-q(i-1,1)))+g_xtzzm*(0.5+sign(0.5,xtzzm-q(i-1,1)))
            xtzzn = max(xtzzm,q(i-1,1))
            g_xt = g_xt*(0.5+sign(0.5,xtzzn-xt))+g_xtzzn*(0.5-sign(0.5,xtzzn-xt))
            xt = min(xt,xtzzn)
            g_xtzzi = g_q(i,1)*(0.5-sign(0.5,q(i,1)-q(i,0)))+g_q(i,0)*(0.5+sign(0.5,q(i,1)-q(i,0)))
            xtzzi = min(q(i,0),q(i,1))
            g_xtzzj = g_q(i-1,0)*(0.5-sign(0.5,q(i-1,0)-xtzzi))+g_xtzzi*(0.5+sign(0.5,q(i-1,0)-xtzzi))
            xtzzj = min(xtzzi,q(i-1,0))
            g_xtzzk = g_q(i-1,1)*(0.5-sign(0.5,q(i-1,1)-xtzzj))+g_xtzzj*(0.5+sign(0.5,q(i-1,1)-xtzzj))
            xtzzk = min(xtzzj,q(i-1,1))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtzzk))+g_xtzzk*(0.5-sign(0.5,xt-xtzzk))
            xt = max(xt,xtzzk)
          else if (i .lt. 3 .and. i .gt. 0 .or. i .gt. npx-1 .and. i .lt. npx+2) then
            g_xtzzr = g_q(i,1)*(0.5-sign(0.5,q(i,0)-q(i,1)))+g_q(i,0)*(0.5+sign(0.5,q(i,0)-q(i,1)))
            xtzzr = max(q(i,0),q(i,1))
            g_xtzzs = g_q(i+1,0)*(0.5-sign(0.5,xtzzr-q(i+1,0)))+g_xtzzr*(0.5+sign(0.5,xtzzr-q(i+1,0)))
            xtzzs = max(xtzzr,q(i+1,0))
            g_xtzzt = g_q(i+1,1)*(0.5-sign(0.5,xtzzs-q(i+1,1)))+g_xtzzs*(0.5+sign(0.5,xtzzs-q(i+1,1)))
            xtzzt = max(xtzzs,q(i+1,1))
            g_xt = g_xt*(0.5+sign(0.5,xtzzt-xt))+g_xtzzt*(0.5-sign(0.5,xtzzt-xt))
            xt = min(xt,xtzzt)
            g_xtzzo = g_q(i,1)*(0.5-sign(0.5,q(i,1)-q(i,0)))+g_q(i,0)*(0.5+sign(0.5,q(i,1)-q(i,0)))
            xtzzo = min(q(i,0),q(i,1))
            g_xtzzp = g_q(i+1,0)*(0.5-sign(0.5,q(i+1,0)-xtzzo))+g_xtzzo*(0.5+sign(0.5,q(i+1,0)-xtzzo))
            xtzzp = min(xtzzo,q(i+1,0))
            g_xtzzq = g_q(i+1,1)*(0.5-sign(0.5,q(i+1,1)-xtzzp))+g_xtzzp*(0.5+sign(0.5,q(i+1,1)-xtzzp))
            xtzzq = min(xtzzp,q(i+1,1))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtzzq))+g_xtzzq*(0.5-sign(0.5,xt-xtzzq))
            xt = max(xt,xtzzq)
          endif
        endif
        g_bl(i,1) = (-g_q(i,1))+g_xt
        bl(i,1) = xt-q(i,1)
        g_br(i,0) = (-g_q(i,0))+g_xt
        br(i,0) = xt-q(i,0)
        g_xt = 0.57142857*g_dm(i,-1)-0.78571429*g_dq(i,-1)+g_q(i,0)
        xt = 4./7.*dm(i,-1)-11./14.*dq(i,-1)+q(i,0)
        if (s_mono_kim) then
          g_xtzzh = g_q(i,-1)*(0.5+sign(0.5,q(i,-1)-q(i,0)))+g_q(i,0)*(0.5-sign(0.5,q(i,-1)-q(i,0)))
          xtzzh = max(q(i,-1),q(i,0))
          g_xt = g_xt*(0.5+sign(0.5,xtzzh-xt))+g_xtzzh*(0.5-sign(0.5,xtzzh-xt))
          xt = min(xt,xtzzh)
          g_xtzzg = g_q(i,-1)*(0.5+sign(0.5,q(i,0)-q(i,-1)))+g_q(i,0)*(0.5-sign(0.5,q(i,0)-q(i,-1)))
          xtzzg = min(q(i,-1),q(i,0))
          g_xt = g_xt*(0.5+sign(0.5,xt-xtzzg))+g_xtzzg*(0.5-sign(0.5,xt-xtzzg))
          xt = max(xt,xtzzg)
        endif
        g_bl(i,0) = (-g_q(i,0))+g_xt
        bl(i,0) = xt-q(i,0)
        g_xt = (-0.57142857)*g_dm(i,2)+0.78571429*g_q(i,2)+0.21428571*g_q(i,1)
        xt = 3./14.*q(i,1)+11./14.*q(i,2)-4./7.*dm(i,2)
        if (s_mono_kim) then
          g_xtzzf = g_q(i,2)*(0.5-sign(0.5,q(i,1)-q(i,2)))+g_q(i,1)*(0.5+sign(0.5,q(i,1)-q(i,2)))
          xtzzf = max(q(i,1),q(i,2))
          g_xt = g_xt*(0.5+sign(0.5,xtzzf-xt))+g_xtzzf*(0.5-sign(0.5,xtzzf-xt))
          xt = min(xt,xtzzf)
          g_xtzze = g_q(i,2)*(0.5-sign(0.5,q(i,2)-q(i,1)))+g_q(i,1)*(0.5+sign(0.5,q(i,2)-q(i,1)))
          xtzze = min(q(i,1),q(i,2))
          g_xt = g_xt*(0.5+sign(0.5,xt-xtzze))+g_xtzze*(0.5-sign(0.5,xt-xtzze))
          xt = max(xt,xtzze)
        endif
        g_br(i,1) = (-g_q(i,1))+g_xt
        br(i,1) = xt-q(i,1)
        g_bl(i,2) = (-g_q(i,2))+g_xt
        bl(i,2) = xt-q(i,2)
      end do
      if (jord .eq. 9) then
        do j = 0, 2
          help_h = ilast-ifirst+1
          call g_pert_ppm( help_h,q(ifirst,j),g_q(ifirst,j),bl(ifirst,j),g_bl(ifirst,j),br(ifirst,j),g_br(ifirst,j),1 )
        end do
      endif
    endif
    if (je+1 .eq. npy) then
      do i = ifirst, ilast
        g_bl(i,npy-2) = g_al(i,npy-2)-g_q(i,npy-2)
        bl(i,npy-2) = al(i,npy-2)-q(i,npy-2)
        g_xt = (-(g_q(i,npy-2)*(0.5*dya(i,npy-1)/(dya(i,npy-1)+dya(i,npy-2)))))+g_q(i,npy-1)*(0.5*(2.*dya(i,npy-1)+dya(i,npy-2))/&
&(dya(i,npy-1)+dya(i,npy-2)))-g_q(i,npy+1)*(0.5*dya(i,npy-1)/(dya(i,npy-1)+dya(i,npy-2)))+g_q(i,npy)*(0.5*(2.*dya(i,npy-1)+&
&dya(i,npy-2))/(dya(i,npy-1)+dya(i,npy-2)))
        xt = 0.5*((2.*dya(i,npy-1)+dya(i,npy-2))*(q(i,npy-1)+q(i,npy))-dya(i,npy-1)*(q(i,npy-2)+q(i,npy+1)))/(dya(i,npy-1)+dya(i,&
&npy-2))
        if (edge_mono_kim) then
          if (i .gt. (-2) .and. i .lt. 1 .or. i .gt. npx-3 .and. i .lt. npx) then
            g_xtzv = g_q(i,npy-1)*(0.5+sign(0.5,q(i,npy-1)-q(i,npy)))+g_q(i,npy)*(0.5-sign(0.5,q(i,npy-1)-q(i,npy)))
            xtzv = max(q(i,npy-1),q(i,npy))
            g_xtzw = g_q(i-1,npy-1)*(0.5-sign(0.5,xtzv-q(i-1,npy-1)))+g_xtzv*(0.5+sign(0.5,xtzv-q(i-1,npy-1)))
            xtzw = max(xtzv,q(i-1,npy-1))
            g_xtzx = g_q(i-1,npy)*(0.5-sign(0.5,xtzw-q(i-1,npy)))+g_xtzw*(0.5+sign(0.5,xtzw-q(i-1,npy)))
            xtzx = max(xtzw,q(i-1,npy))
            g_xt = g_xt*(0.5+sign(0.5,xtzx-xt))+g_xtzx*(0.5-sign(0.5,xtzx-xt))
            xt = min(xt,xtzx)
            g_xtzs = g_q(i,npy-1)*(0.5+sign(0.5,q(i,npy)-q(i,npy-1)))+g_q(i,npy)*(0.5-sign(0.5,q(i,npy)-q(i,npy-1)))
            xtzs = min(q(i,npy-1),q(i,npy))
            g_xtzt = g_q(i-1,npy-1)*(0.5-sign(0.5,q(i-1,npy-1)-xtzs))+g_xtzs*(0.5+sign(0.5,q(i-1,npy-1)-xtzs))
            xtzt = min(xtzs,q(i-1,npy-1))
            g_xtzu = g_q(i-1,npy)*(0.5-sign(0.5,q(i-1,npy)-xtzt))+g_xtzt*(0.5+sign(0.5,q(i-1,npy)-xtzt))
            xtzu = min(xtzt,q(i-1,npy))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtzu))+g_xtzu*(0.5-sign(0.5,xt-xtzu))
            xt = max(xt,xtzu)
          else if (i .lt. 3 .and. i .gt. 0 .or. i .gt. npx-1 .and. i .lt. npx+2) then
            g_xtzzb = g_q(i,npy-1)*(0.5+sign(0.5,q(i,npy-1)-q(i,npy)))+g_q(i,npy)*(0.5-sign(0.5,q(i,npy-1)-q(i,npy)))
            xtzzb = max(q(i,npy-1),q(i,npy))
            g_xtzzc = g_q(i+1,npy-1)*(0.5-sign(0.5,xtzzb-q(i+1,npy-1)))+g_xtzzb*(0.5+sign(0.5,xtzzb-q(i+1,npy-1)))
            xtzzc = max(xtzzb,q(i+1,npy-1))
            g_xtzzd = g_q(i+1,npy)*(0.5-sign(0.5,xtzzc-q(i+1,npy)))+g_xtzzc*(0.5+sign(0.5,xtzzc-q(i+1,npy)))
            xtzzd = max(xtzzc,q(i+1,npy))
            g_xt = g_xt*(0.5+sign(0.5,xtzzd-xt))+g_xtzzd*(0.5-sign(0.5,xtzzd-xt))
            xt = min(xt,xtzzd)
            g_xtzy = g_q(i,npy-1)*(0.5+sign(0.5,q(i,npy)-q(i,npy-1)))+g_q(i,npy)*(0.5-sign(0.5,q(i,npy)-q(i,npy-1)))
            xtzy = min(q(i,npy-1),q(i,npy))
            g_xtzz = g_q(i+1,npy-1)*(0.5-sign(0.5,q(i+1,npy-1)-xtzy))+g_xtzy*(0.5+sign(0.5,q(i+1,npy-1)-xtzy))
            xtzz = min(xtzy,q(i+1,npy-1))
            g_xtzza = g_q(i+1,npy)*(0.5-sign(0.5,q(i+1,npy)-xtzz))+g_xtzz*(0.5+sign(0.5,q(i+1,npy)-xtzz))
            xtzza = min(xtzz,q(i+1,npy))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtzza))+g_xtzza*(0.5-sign(0.5,xt-xtzza))
            xt = max(xt,xtzza)
          endif
        endif
        g_br(i,npy-1) = (-g_q(i,npy-1))+g_xt
        br(i,npy-1) = xt-q(i,npy-1)
        g_bl(i,npy) = (-g_q(i,npy))+g_xt
        bl(i,npy) = xt-q(i,npy)
        g_xt = (-0.57142857)*g_dm(i,npy+1)+0.78571429*g_dq(i,npy)+g_q(i,npy)
        xt = 11./14.*dq(i,npy)-4./7.*dm(i,npy+1)+q(i,npy)
        if (s_mono_kim) then
          g_xtzr = g_q(i,npy+1)*(0.5-sign(0.5,q(i,npy)-q(i,npy+1)))+g_q(i,npy)*(0.5+sign(0.5,q(i,npy)-q(i,npy+1)))
          xtzr = max(q(i,npy),q(i,npy+1))
          g_xt = g_xt*(0.5+sign(0.5,xtzr-xt))+g_xtzr*(0.5-sign(0.5,xtzr-xt))
          xt = min(xt,xtzr)
          g_xtzq = g_q(i,npy+1)*(0.5-sign(0.5,q(i,npy+1)-q(i,npy)))+g_q(i,npy)*(0.5+sign(0.5,q(i,npy+1)-q(i,npy)))
          xtzq = min(q(i,npy),q(i,npy+1))
          g_xt = g_xt*(0.5+sign(0.5,xt-xtzq))+g_xtzq*(0.5-sign(0.5,xt-xtzq))
          xt = max(xt,xtzq)
        endif
        g_br(i,npy) = (-g_q(i,npy))+g_xt
        br(i,npy) = xt-q(i,npy)
        g_xt = 0.57142857*g_dm(i,npy-2)+0.78571429*g_q(i,npy-2)+0.21428571*g_q(i,npy-1)
        xt = 3./14.*q(i,npy-1)+11./14.*q(i,npy-2)+4./7.*dm(i,npy-2)
        if (s_mono_kim) then
          g_xtzp = g_q(i,npy-2)*(0.5+sign(0.5,q(i,npy-2)-q(i,npy-1)))+g_q(i,npy-1)*(0.5-sign(0.5,q(i,npy-2)-q(i,npy-1)))
          xtzp = max(q(i,npy-2),q(i,npy-1))
          g_xt = g_xt*(0.5+sign(0.5,xtzp-xt))+g_xtzp*(0.5-sign(0.5,xtzp-xt))
          xt = min(xt,xtzp)
          g_xtzo = g_q(i,npy-2)*(0.5+sign(0.5,q(i,npy-1)-q(i,npy-2)))+g_q(i,npy-1)*(0.5-sign(0.5,q(i,npy-1)-q(i,npy-2)))
          xtzo = min(q(i,npy-2),q(i,npy-1))
          g_xt = g_xt*(0.5+sign(0.5,xt-xtzo))+g_xtzo*(0.5-sign(0.5,xt-xtzo))
          xt = max(xt,xtzo)
        endif
        g_br(i,npy-2) = (-g_q(i,npy-2))+g_xt
        br(i,npy-2) = xt-q(i,npy-2)
        g_bl(i,npy-1) = (-g_q(i,npy-1))+g_xt
        bl(i,npy-1) = xt-q(i,npy-1)
      end do
      if (jord .eq. 9) then
        do j = npy-2, npy
          help_i = ilast-ifirst+1
          call g_pert_ppm( help_i,q(ifirst,j),g_q(ifirst,j),bl(ifirst,j),g_bl(ifirst,j),br(ifirst,j),g_br(ifirst,j),1 )
        end do
      endif
    endif
  else
    do j = js-1, je+2
      do i = ifirst, ilast
        g_al(i,j) = g_dm(i,j-1)*r3-g_dm(i,j)*r3+0.5*g_q(i,j-1)+0.5*g_q(i,j)
        al(i,j) = 0.5*(q(i,j-1)+q(i,j))+r3*(dm(i,j-1)-dm(i,j))
      end do
    end do
    do j = js-1, je+1
      do i = ifirst, ilast
        g_pmp = (-2)*g_dq(i,j)
        pmp = -(2.*dq(i,j))
        g_lac = 1.5*g_dq(i,j+1)+g_pmp
        lac = pmp+1.5*dq(i,j+1)
        g_blv = g_pmp*(0.5-sign(0.5,0.-pmp))
        blv = max(0.,pmp)
        g_blw = g_blv*(0.5+sign(0.5,blv-lac))+g_lac*(0.5-sign(0.5,blv-lac))
        blw = max(blv,lac)
        g_bly = g_pmp*(0.5-sign(0.5,pmp-0.))
        bly = min(0.,pmp)
        g_blz = g_bly*(0.5+sign(0.5,lac-bly))+g_lac*(0.5-sign(0.5,lac-bly))
        blz = min(bly,lac)
        g_blx = g_al(i,j)*(0.5+sign(0.5,al(i,j)-q(i,j)-blz))+g_blz*(0.5-sign(0.5,al(i,j)-q(i,j)-blz))-g_q(i,j)*(0.5+sign(0.5,al(i,&
&j)-q(i,j)-blz))
        blx = max(al(i,j)-q(i,j),blz)
        g_bl(i,j) = g_blw*(0.5+sign(0.5,blx-blw))+g_blx*(0.5-sign(0.5,blx-blw))
        bl(i,j) = min(blw,blx)
        g_pmp = 2*g_dq(i,j-1)
        pmp = 2.*dq(i,j-1)
        g_lac = (-1.5)*g_dq(i,j-2)+g_pmp
        lac = pmp-1.5*dq(i,j-2)
        g_brv = g_pmp*(0.5-sign(0.5,0.-pmp))
        brv = max(0.,pmp)
        g_brw = g_brv*(0.5+sign(0.5,brv-lac))+g_lac*(0.5-sign(0.5,brv-lac))
        brw = max(brv,lac)
        g_bry = g_pmp*(0.5-sign(0.5,pmp-0.))
        bry = min(0.,pmp)
        g_brz = g_bry*(0.5+sign(0.5,lac-bry))+g_lac*(0.5-sign(0.5,lac-bry))
        brz = min(bry,lac)
        g_brx = g_al(i,j+1)*(0.5+sign(0.5,al(i,j+1)-q(i,j)-brz))+g_brz*(0.5-sign(0.5,al(i,j+1)-q(i,j)-brz))-g_q(i,j)*(0.5+sign(0.5,&
&al(i,j+1)-q(i,j)-brz))
        brx = max(al(i,j+1)-q(i,j),brz)
        g_br(i,j) = g_brw*(0.5+sign(0.5,brx-brw))+g_brx*(0.5-sign(0.5,brx-brw))
        br(i,j) = min(brw,brx)
      end do
    end do
  endif
  do j = js, je+1
    do i = ifirst, ilast
      if (intel_opt_kim) then
        g_c1 = g_c(i,j)
        c1 = c(i,j)
        if (c1 .gt. 0.) then
          jt = j-1
          g_qe = g_br(i,j-1)
          qe = br(i,j-1)
        else
          jt = j
          g_qe = g_bl(i,j)
          qe = bl(i,j)
        endif
        g_c1 = -(g_c1*sign(1.,c1))
        c1 = -abs(c1)
        g_flux(i,j) = (g_bl(i,jt)+g_br(i,jt))*(1.+c1)*c1+g_c1*((1.+c1)*(bl(i,jt)+br(i,jt))+qe+c1*(bl(i,jt)+br(i,jt)))+g_q(i,jt)+&
&g_qe*(1+c1)
        flux(i,j) = q(i,jt)+(1.+c1)*(qe+c1*(bl(i,jt)+br(i,jt)))
      else
        if (c(i,j) .gt. 0.) then
          g_flux(i,j) = (-(g_bl(i,j-1)*(1.-c(i,j))*c(i,j)))+g_br(i,j-1)*(1.-c(i,j))*(1-c(i,j))-g_c(i,j)*((1.-c(i,j))*(bl(i,j-1)+&
&br(i,j-1))+br(i,j-1)-c(i,j)*(bl(i,j-1)+br(i,j-1)))+g_q(i,j-1)
          flux(i,j) = q(i,j-1)+(1.-c(i,j))*(br(i,j-1)-c(i,j)*(bl(i,j-1)+br(i,j-1)))
        else
          g_flux(i,j) = g_bl(i,j)*(1.+c(i,j))*(1+c(i,j))+g_br(i,j)*(1.+c(i,j))*c(i,j)+g_c(i,j)*((1.+c(i,j))*(bl(i,j)+br(i,j))+bl(i,&
&j)+c(i,j)*(bl(i,j)+br(i,j)))+g_q(i,j)
          flux(i,j) = q(i,j)+(1.+c(i,j))*(bl(i,j)+c(i,j)*(bl(i,j)+br(i,j)))
        endif
      endif
    end do
  end do
else
  js3 = max(3,js-1)
  je3 = min(npy-3,je+1)
  do j = js-2, je+2
    do i = ifirst, ilast
      g_xt = (-0.25)*g_q(i,j-1)+0.25*g_q(i,j+1)
      xt = 0.25*(q(i,j+1)-q(i,j-1))
      g_dmh = g_xt*sign(1.,xt)
      dmh = abs(xt)
      g_dmi = g_q(i,j-1)*(0.5+sign(0.5,q(i,j-1)-q(i,j)))+g_q(i,j)*(0.5-sign(0.5,q(i,j-1)-q(i,j)))
      dmi = max(q(i,j-1),q(i,j))
      g_dmk = g_dmi*(0.5+sign(0.5,dmi-q(i,j+1)))+g_q(i,j+1)*(0.5-sign(0.5,dmi-q(i,j+1)))-g_q(i,j)
      dmk = max(dmi,q(i,j+1))-q(i,j)
      g_dml = g_q(i,j-1)*(0.5+sign(0.5,q(i,j)-q(i,j-1)))+g_q(i,j)*(0.5-sign(0.5,q(i,j)-q(i,j-1)))
      dml = min(q(i,j-1),q(i,j))
      g_dmn = (-(g_dml*(0.5+sign(0.5,q(i,j+1)-dml))+g_q(i,j+1)*(0.5-sign(0.5,q(i,j+1)-dml))))+g_q(i,j)
      dmn = q(i,j)-min(dml,q(i,j+1))
      g_dmo = g_dmh*(0.5+sign(0.5,dmk-dmh))+g_dmk*(0.5-sign(0.5,dmk-dmh))
      dmo = min(dmh,dmk)
      g_dmp = g_dmn*(0.5-sign(0.5,dmn-dmo))+g_dmo*(0.5+sign(0.5,dmn-dmo))
      dmp = min(dmo,dmn)
      g_dm(i,j) = g_dmp*sign(1.,dmp)*sign(1.,xt)
      dm(i,j) = sign(dmp,xt)
    end do
  end do
  if (grid_type .lt. 3) then
    do j = js3, min(npy-2,je+2)
      do i = ifirst, ilast
        g_al(i,j) = g_dm(i,j-1)*r3-g_dm(i,j)*r3+0.5*g_q(i,j-1)+0.5*g_q(i,j)
        al(i,j) = 0.5*(q(i,j-1)+q(i,j))+r3*(dm(i,j-1)-dm(i,j))
      end do
    end do
    if (jord .eq. 11) then
      do j = js3, je3
        do i = ifirst, ilast
          g_xt = 2*g_dm(i,j)
          xt = 2.*dm(i,j)
          g_blp = g_al(i,j)-g_q(i,j)
          blp = al(i,j)-q(i,j)
          blo = min(abs(xt),abs(blp))
          g_bl(i,j) = -((g_blp*(0.5-sign(0.5,abs(blp)-abs(xt)))*sign(1.,blp)+g_xt*(0.5+sign(0.5,abs(blp)-abs(xt)))*sign(1.,xt))*&
&sign(1.,blo)*sign(1.,xt))
          bl(i,j) = -sign(blo,xt)
          g_brp = g_al(i,j+1)-g_q(i,j)
          brp = al(i,j+1)-q(i,j)
          g_bro = g_brp*(0.5-sign(0.5,abs(brp)-abs(xt)))*sign(1.,brp)+g_xt*(0.5+sign(0.5,abs(brp)-abs(xt)))*sign(1.,xt)
          bro = min(abs(xt),abs(brp))
          g_br(i,j) = g_bro*sign(1.,bro)*sign(1.,xt)
          br(i,j) = sign(bro,xt)
        end do
      end do
    else if (jord .eq. 12) then
      do j = js-3, je+2
        do i = ifirst, ilast
          g_dq(i,j) = g_q(i,j+1)-g_q(i,j)
          dq(i,j) = q(i,j+1)-q(i,j)
        end do
      end do
      do j = js3, je3
        do i = ifirst, ilast
          g_pmp = (-2)*g_dq(i,j)
          pmp = -(2.*dq(i,j))
          g_lac = 1.5*g_dq(i,j+1)+g_pmp
          lac = pmp+1.5*dq(i,j+1)
          g_blq = g_pmp*(0.5-sign(0.5,0.-pmp))
          blq = max(0.,pmp)
          g_blr = g_blq*(0.5+sign(0.5,blq-lac))+g_lac*(0.5-sign(0.5,blq-lac))
          blr = max(blq,lac)
          g_blt = g_pmp*(0.5-sign(0.5,pmp-0.))
          blt = min(0.,pmp)
          g_blu = g_blt*(0.5+sign(0.5,lac-blt))+g_lac*(0.5-sign(0.5,lac-blt))
          blu = min(blt,lac)
          g_bls = g_al(i,j)*(0.5+sign(0.5,al(i,j)-q(i,j)-blu))+g_blu*(0.5-sign(0.5,al(i,j)-q(i,j)-blu))-g_q(i,j)*(0.5+sign(0.5,&
&al(i,j)-q(i,j)-blu))
          bls = max(al(i,j)-q(i,j),blu)
          g_bl(i,j) = g_blr*(0.5+sign(0.5,bls-blr))+g_bls*(0.5-sign(0.5,bls-blr))
          bl(i,j) = min(blr,bls)
          g_pmp = 2*g_dq(i,j-1)
          pmp = 2.*dq(i,j-1)
          g_lac = (-1.5)*g_dq(i,j-2)+g_pmp
          lac = pmp-1.5*dq(i,j-2)
          g_brq = g_pmp*(0.5-sign(0.5,0.-pmp))
          brq = max(0.,pmp)
          g_brr = g_brq*(0.5+sign(0.5,brq-lac))+g_lac*(0.5-sign(0.5,brq-lac))
          brr = max(brq,lac)
          g_brt = g_pmp*(0.5-sign(0.5,pmp-0.))
          brt = min(0.,pmp)
          g_bru = g_brt*(0.5+sign(0.5,lac-brt))+g_lac*(0.5-sign(0.5,lac-brt))
          bru = min(brt,lac)
          g_brs = g_al(i,j+1)*(0.5+sign(0.5,al(i,j+1)-q(i,j)-bru))+g_bru*(0.5-sign(0.5,al(i,j+1)-q(i,j)-bru))-g_q(i,j)*(0.5+&
&sign(0.5,al(i,j+1)-q(i,j)-bru))
          brs = max(al(i,j+1)-q(i,j),bru)
          g_br(i,j) = g_brr*(0.5+sign(0.5,brs-brr))+g_brs*(0.5-sign(0.5,brs-brr))
          br(i,j) = min(brr,brs)
        end do
      end do
    else
      do j = js3, je3
        do i = ifirst, ilast
          g_bl(i,j) = g_al(i,j)-g_q(i,j)
          bl(i,j) = al(i,j)-q(i,j)
          g_br(i,j) = g_al(i,j+1)-g_q(i,j)
          br(i,j) = al(i,j+1)-q(i,j)
        end do
      end do
    endif
    if (jord .ne. 11) then
      do j = js3, je3
        help_j = ilast-ifirst+1
        call g_pert_ppm( help_j,q(ifirst,j),g_q(ifirst,j),bl(ifirst,j),g_bl(ifirst,j),br(ifirst,j),g_br(ifirst,j),0 )
      end do
    endif
    if (js .eq. 1) then
      do i = ifirst, ilast
        g_br(i,2) = g_al(i,3)-g_q(i,2)
        br(i,2) = al(i,3)-q(i,2)
        g_xt = (-((g_q(i,-1)+g_q(i,2))*(0.5*dya(i,1)/(dya(i,1)+dya(i,2)))))+(g_q(i,1)+g_q(i,0))*(0.5*(2.*dya(i,1)+dya(i,2))/(dya(i,&
&1)+dya(i,2)))
        xt = 0.5*((2.*dya(i,1)+dya(i,2))*(q(i,0)+q(i,1))-dya(i,1)*(q(i,-1)+q(i,2)))/(dya(i,1)+dya(i,2))
        if (edge_mono_kim) then
          if (i .gt. (-2) .and. i .lt. 1 .or. i .gt. npx-3 .and. i .lt. npx) then
            g_xtzf = g_q(i,1)*(0.5-sign(0.5,q(i,0)-q(i,1)))+g_q(i,0)*(0.5+sign(0.5,q(i,0)-q(i,1)))
            xtzf = max(q(i,0),q(i,1))
            g_xtzg = g_q(i-1,0)*(0.5-sign(0.5,xtzf-q(i-1,0)))+g_xtzf*(0.5+sign(0.5,xtzf-q(i-1,0)))
            xtzg = max(xtzf,q(i-1,0))
            g_xtzh = g_q(i-1,1)*(0.5-sign(0.5,xtzg-q(i-1,1)))+g_xtzg*(0.5+sign(0.5,xtzg-q(i-1,1)))
            xtzh = max(xtzg,q(i-1,1))
            g_xt = g_xt*(0.5+sign(0.5,xtzh-xt))+g_xtzh*(0.5-sign(0.5,xtzh-xt))
            xt = min(xt,xtzh)
            g_xtzc = g_q(i,1)*(0.5-sign(0.5,q(i,1)-q(i,0)))+g_q(i,0)*(0.5+sign(0.5,q(i,1)-q(i,0)))
            xtzc = min(q(i,0),q(i,1))
            g_xtzd = g_q(i-1,0)*(0.5-sign(0.5,q(i-1,0)-xtzc))+g_xtzc*(0.5+sign(0.5,q(i-1,0)-xtzc))
            xtzd = min(xtzc,q(i-1,0))
            g_xtze = g_q(i-1,1)*(0.5-sign(0.5,q(i-1,1)-xtzd))+g_xtzd*(0.5+sign(0.5,q(i-1,1)-xtzd))
            xtze = min(xtzd,q(i-1,1))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtze))+g_xtze*(0.5-sign(0.5,xt-xtze))
            xt = max(xt,xtze)
          else if (i .lt. 3 .and. i .gt. 0 .or. i .gt. npx-1 .and. i .lt. npx+2) then
            g_xtzl = g_q(i,1)*(0.5-sign(0.5,q(i,0)-q(i,1)))+g_q(i,0)*(0.5+sign(0.5,q(i,0)-q(i,1)))
            xtzl = max(q(i,0),q(i,1))
            g_xtzm = g_q(i+1,0)*(0.5-sign(0.5,xtzl-q(i+1,0)))+g_xtzl*(0.5+sign(0.5,xtzl-q(i+1,0)))
            xtzm = max(xtzl,q(i+1,0))
            g_xtzn = g_q(i+1,1)*(0.5-sign(0.5,xtzm-q(i+1,1)))+g_xtzm*(0.5+sign(0.5,xtzm-q(i+1,1)))
            xtzn = max(xtzm,q(i+1,1))
            g_xt = g_xt*(0.5+sign(0.5,xtzn-xt))+g_xtzn*(0.5-sign(0.5,xtzn-xt))
            xt = min(xt,xtzn)
            g_xtzi = g_q(i,1)*(0.5-sign(0.5,q(i,1)-q(i,0)))+g_q(i,0)*(0.5+sign(0.5,q(i,1)-q(i,0)))
            xtzi = min(q(i,0),q(i,1))
            g_xtzj = g_q(i+1,0)*(0.5-sign(0.5,q(i+1,0)-xtzi))+g_xtzi*(0.5+sign(0.5,q(i+1,0)-xtzi))
            xtzj = min(xtzi,q(i+1,0))
            g_xtzk = g_q(i+1,1)*(0.5-sign(0.5,q(i+1,1)-xtzj))+g_xtzj*(0.5+sign(0.5,q(i+1,1)-xtzj))
            xtzk = min(xtzj,q(i+1,1))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtzk))+g_xtzk*(0.5-sign(0.5,xt-xtzk))
            xt = max(xt,xtzk)
          else
            g_xt = g_xt*(0.5-sign(0.5,0.-xt))
            xt = max(0.,xt)
          endif
        else
          g_xt = g_xt*(0.5-sign(0.5,0.-xt))
          xt = max(0.,xt)
        endif
        g_bl(i,1) = (-g_q(i,1))+g_xt
        bl(i,1) = xt-q(i,1)
        g_br(i,0) = (-g_q(i,0))+g_xt
        br(i,0) = xt-q(i,0)
        g_xt = 0.57142857*g_dm(i,-1)+0.78571429*g_q(i,-1)+0.21428571*g_q(i,0)
        xt = 4./7.*dm(i,-1)+11./14.*q(i,-1)+3./14.*q(i,0)
        if (s_mono_kim) then
          g_xtzb = g_q(i,-1)*(0.5+sign(0.5,q(i,-1)-q(i,0)))+g_q(i,0)*(0.5-sign(0.5,q(i,-1)-q(i,0)))
          xtzb = max(q(i,-1),q(i,0))
          g_xt = g_xt*(0.5+sign(0.5,xtzb-xt))+g_xtzb*(0.5-sign(0.5,xtzb-xt))
          xt = min(xt,xtzb)
          g_xtza = g_q(i,-1)*(0.5+sign(0.5,q(i,0)-q(i,-1)))+g_q(i,0)*(0.5-sign(0.5,q(i,0)-q(i,-1)))
          xtza = min(q(i,-1),q(i,0))
          g_xt = g_xt*(0.5+sign(0.5,xt-xtza))+g_xtza*(0.5-sign(0.5,xt-xtza))
          xt = max(xt,xtza)
        else
          g_xt = g_xt*(0.5-sign(0.5,0.-xt))
          xt = max(0.,xt)
        endif
        g_bl(i,0) = (-g_q(i,0))+g_xt
        bl(i,0) = xt-q(i,0)
        g_xt = (-0.57142857)*g_dm(i,2)+0.78571429*g_q(i,2)+0.21428571*g_q(i,1)
        xt = 3./14.*q(i,1)+11./14.*q(i,2)-4./7.*dm(i,2)
        if (s_mono_kim) then
          g_xtz = g_q(i,2)*(0.5-sign(0.5,q(i,1)-q(i,2)))+g_q(i,1)*(0.5+sign(0.5,q(i,1)-q(i,2)))
          xtz = max(q(i,1),q(i,2))
          g_xt = g_xt*(0.5+sign(0.5,xtz-xt))+g_xtz*(0.5-sign(0.5,xtz-xt))
          xt = min(xt,xtz)
          g_xty = g_q(i,2)*(0.5-sign(0.5,q(i,2)-q(i,1)))+g_q(i,1)*(0.5+sign(0.5,q(i,2)-q(i,1)))
          xty = min(q(i,1),q(i,2))
          g_xt = g_xt*(0.5+sign(0.5,xt-xty))+g_xty*(0.5-sign(0.5,xt-xty))
          xt = max(xt,xty)
        else
          g_xt = g_xt*(0.5-sign(0.5,0.-xt))
          xt = max(0.,xt)
        endif
        g_br(i,1) = (-g_q(i,1))+g_xt
        br(i,1) = xt-q(i,1)
        g_bl(i,2) = (-g_q(i,2))+g_xt
        bl(i,2) = xt-q(i,2)
      end do
      do j = 0, 2
        help_k = ilast-ifirst+1
        call g_pert_ppm( help_k,q(ifirst,j),g_q(ifirst,j),bl(ifirst,j),g_bl(ifirst,j),br(ifirst,j),g_br(ifirst,j),1 )
      end do
    endif
    if (je+1 .eq. npy) then
      do i = ifirst, ilast
        g_bl(i,npy-2) = g_al(i,npy-2)-g_q(i,npy-2)
        bl(i,npy-2) = al(i,npy-2)-q(i,npy-2)
        g_xt = (-(g_q(i,npy-2)*(0.5*dya(i,npy-1)/(dya(i,npy-1)+dya(i,npy-2)))))+g_q(i,npy-1)*(0.5*(2.*dya(i,npy-1)+dya(i,npy-2))/&
&(dya(i,npy-1)+dya(i,npy-2)))-g_q(i,npy+1)*(0.5*dya(i,npy-1)/(dya(i,npy-1)+dya(i,npy-2)))+g_q(i,npy)*(0.5*(2.*dya(i,npy-1)+&
&dya(i,npy-2))/(dya(i,npy-1)+dya(i,npy-2)))
        xt = 0.5*((2.*dya(i,npy-1)+dya(i,npy-2))*(q(i,npy-1)+q(i,npy))-dya(i,npy-1)*(q(i,npy-2)+q(i,npy+1)))/(dya(i,npy-1)+dya(i,&
&npy-2))
        if (edge_mono_kim) then
          if (i .gt. (-2) .and. i .lt. 1 .or. i .gt. npx-3 .and. i .lt. npx) then
            g_xto = g_q(i,npy-1)*(0.5+sign(0.5,q(i,npy-1)-q(i,npy)))+g_q(i,npy)*(0.5-sign(0.5,q(i,npy-1)-q(i,npy)))
            xto = max(q(i,npy-1),q(i,npy))
            g_xtq = g_q(i-1,npy-1)*(0.5-sign(0.5,xto-q(i-1,npy-1)))+g_xto*(0.5+sign(0.5,xto-q(i-1,npy-1)))
            xtq = max(xto,q(i-1,npy-1))
            g_xtr = g_q(i-1,npy)*(0.5-sign(0.5,xtq-q(i-1,npy)))+g_xtq*(0.5+sign(0.5,xtq-q(i-1,npy)))
            xtr = max(xtq,q(i-1,npy))
            g_xt = g_xt*(0.5+sign(0.5,xtr-xt))+g_xtr*(0.5-sign(0.5,xtr-xt))
            xt = min(xt,xtr)
            g_xtl = g_q(i,npy-1)*(0.5+sign(0.5,q(i,npy)-q(i,npy-1)))+g_q(i,npy)*(0.5-sign(0.5,q(i,npy)-q(i,npy-1)))
            xtl = min(q(i,npy-1),q(i,npy))
            g_xtm = g_q(i-1,npy-1)*(0.5-sign(0.5,q(i-1,npy-1)-xtl))+g_xtl*(0.5+sign(0.5,q(i-1,npy-1)-xtl))
            xtm = min(xtl,q(i-1,npy-1))
            g_xtn = g_q(i-1,npy)*(0.5-sign(0.5,q(i-1,npy)-xtm))+g_xtm*(0.5+sign(0.5,q(i-1,npy)-xtm))
            xtn = min(xtm,q(i-1,npy))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtn))+g_xtn*(0.5-sign(0.5,xt-xtn))
            xt = max(xt,xtn)
          else if (i .lt. 3 .and. i .gt. 0 .or. i .gt. npx-1 .and. i .lt. npx+2) then
            g_xtv = g_q(i,npy-1)*(0.5+sign(0.5,q(i,npy-1)-q(i,npy)))+g_q(i,npy)*(0.5-sign(0.5,q(i,npy-1)-q(i,npy)))
            xtv = max(q(i,npy-1),q(i,npy))
            g_xtw = g_q(i+1,npy-1)*(0.5-sign(0.5,xtv-q(i+1,npy-1)))+g_xtv*(0.5+sign(0.5,xtv-q(i+1,npy-1)))
            xtw = max(xtv,q(i+1,npy-1))
            g_xtx = g_q(i+1,npy)*(0.5-sign(0.5,xtw-q(i+1,npy)))+g_xtw*(0.5+sign(0.5,xtw-q(i+1,npy)))
            xtx = max(xtw,q(i+1,npy))
            g_xt = g_xt*(0.5+sign(0.5,xtx-xt))+g_xtx*(0.5-sign(0.5,xtx-xt))
            xt = min(xt,xtx)
            g_xts = g_q(i,npy-1)*(0.5+sign(0.5,q(i,npy)-q(i,npy-1)))+g_q(i,npy)*(0.5-sign(0.5,q(i,npy)-q(i,npy-1)))
            xts = min(q(i,npy-1),q(i,npy))
            g_xtt = g_q(i+1,npy-1)*(0.5-sign(0.5,q(i+1,npy-1)-xts))+g_xts*(0.5+sign(0.5,q(i+1,npy-1)-xts))
            xtt = min(xts,q(i+1,npy-1))
            g_xtu = g_q(i+1,npy)*(0.5-sign(0.5,q(i+1,npy)-xtt))+g_xtt*(0.5+sign(0.5,q(i+1,npy)-xtt))
            xtu = min(xtt,q(i+1,npy))
            g_xt = g_xt*(0.5+sign(0.5,xt-xtu))+g_xtu*(0.5-sign(0.5,xt-xtu))
            xt = max(xt,xtu)
          else
            g_xt = g_xt*(0.5-sign(0.5,0.-xt))
            xt = max(0.,xt)
          endif
        else
          g_xt = g_xt*(0.5-sign(0.5,0.-xt))
          xt = max(0.,xt)
        endif
        g_br(i,npy-1) = (-g_q(i,npy-1))+g_xt
        br(i,npy-1) = xt-q(i,npy-1)
        g_bl(i,npy) = (-g_q(i,npy))+g_xt
        bl(i,npy) = xt-q(i,npy)
        g_xt = (-0.57142857)*g_dm(i,npy+1)+0.78571429*g_q(i,npy+1)+0.21428571*g_q(i,npy)
        xt = 3./14.*q(i,npy)+11./14.*q(i,npy+1)-4./7.*dm(i,npy+1)
        if (s_mono_kim) then
          g_xtk = g_q(i,npy+1)*(0.5-sign(0.5,q(i,npy)-q(i,npy+1)))+g_q(i,npy)*(0.5+sign(0.5,q(i,npy)-q(i,npy+1)))
          xtk = max(q(i,npy),q(i,npy+1))
          g_xt = g_xt*(0.5+sign(0.5,xtk-xt))+g_xtk*(0.5-sign(0.5,xtk-xt))
          xt = min(xt,xtk)
          g_xtj = g_q(i,npy+1)*(0.5-sign(0.5,q(i,npy+1)-q(i,npy)))+g_q(i,npy)*(0.5+sign(0.5,q(i,npy+1)-q(i,npy)))
          xtj = min(q(i,npy),q(i,npy+1))
          g_xt = g_xt*(0.5+sign(0.5,xt-xtj))+g_xtj*(0.5-sign(0.5,xt-xtj))
          xt = max(xt,xtj)
        else
          g_xt = g_xt*(0.5-sign(0.5,0.-xt))
          xt = max(0.,xt)
        endif
        g_br(i,npy) = (-g_q(i,npy))+g_xt
        br(i,npy) = xt-q(i,npy)
        g_xt = 0.57142857*g_dm(i,npy-2)+0.78571429*g_q(i,npy-2)+0.21428571*g_q(i,npy-1)
        xt = 3./14.*q(i,npy-1)+11./14.*q(i,npy-2)+4./7.*dm(i,npy-2)
        if (s_mono_kim) then
          g_xti = g_q(i,npy-2)*(0.5+sign(0.5,q(i,npy-2)-q(i,npy-1)))+g_q(i,npy-1)*(0.5-sign(0.5,q(i,npy-2)-q(i,npy-1)))
          xti = max(q(i,npy-2),q(i,npy-1))
          g_xt = g_xt*(0.5+sign(0.5,xti-xt))+g_xti*(0.5-sign(0.5,xti-xt))
          xt = min(xt,xti)
          g_xth = g_q(i,npy-2)*(0.5+sign(0.5,q(i,npy-1)-q(i,npy-2)))+g_q(i,npy-1)*(0.5-sign(0.5,q(i,npy-1)-q(i,npy-2)))
          xth = min(q(i,npy-2),q(i,npy-1))
          g_xt = g_xt*(0.5+sign(0.5,xt-xth))+g_xth*(0.5-sign(0.5,xt-xth))
          xt = max(xt,xth)
        else
          g_xt = g_xt*(0.5-sign(0.5,0.-xt))
          xt = max(0.,xt)
        endif
        g_br(i,npy-2) = (-g_q(i,npy-2))+g_xt
        br(i,npy-2) = xt-q(i,npy-2)
        g_bl(i,npy-1) = (-g_q(i,npy-1))+g_xt
        bl(i,npy-1) = xt-q(i,npy-1)
      end do
      do j = npy-2, npy
        help_l = ilast-ifirst+1
        call g_pert_ppm( help_l,q(ifirst,j),g_q(ifirst,j),bl(ifirst,j),g_bl(ifirst,j),br(ifirst,j),g_br(ifirst,j),1 )
      end do
    endif
  else
    do j = js-1, je+2
      do i = ifirst, ilast
        g_al(i,j) = g_dm(i,j-1)*r3-g_dm(i,j)*r3+0.5*g_q(i,j-1)+0.5*g_q(i,j)
        al(i,j) = 0.5*(q(i,j-1)+q(i,j))+r3*(dm(i,j-1)-dm(i,j))
      end do
    end do
    if (jord .eq. 11) then
      do j = js-1, je+1
        do i = ifirst, ilast
          g_xt = 2*g_dm(i,j)
          xt = 2.*dm(i,j)
          g_bli = g_al(i,j)-g_q(i,j)
          bli = al(i,j)-q(i,j)
          blh = min(abs(xt),abs(bli))
          g_bl(i,j) = -((g_bli*(0.5-sign(0.5,abs(bli)-abs(xt)))*sign(1.,bli)+g_xt*(0.5+sign(0.5,abs(bli)-abs(xt)))*sign(1.,xt))*&
&sign(1.,blh)*sign(1.,xt))
          bl(i,j) = -sign(blh,xt)
          g_bri = g_al(i,j+1)-g_q(i,j)
          bri = al(i,j+1)-q(i,j)
          g_brh = g_bri*(0.5-sign(0.5,abs(bri)-abs(xt)))*sign(1.,bri)+g_xt*(0.5+sign(0.5,abs(bri)-abs(xt)))*sign(1.,xt)
          brh = min(abs(xt),abs(bri))
          g_br(i,j) = g_brh*sign(1.,brh)*sign(1.,xt)
          br(i,j) = sign(brh,xt)
        end do
      end do
    else if (jord .eq. 12) then
      do j = js-3, je+2
        do i = ifirst, ilast
          g_dq(i,j) = g_q(i,j+1)-g_q(i,j)
          dq(i,j) = q(i,j+1)-q(i,j)
        end do
      end do
      do j = js-1, je+1
        do i = ifirst, ilast
          g_pmp = (-2)*g_dq(i,j)
          pmp = -(2.*dq(i,j))
          g_lac = 1.5*g_dq(i,j+1)+g_pmp
          lac = pmp+1.5*dq(i,j+1)
          g_blj = g_pmp*(0.5-sign(0.5,0.-pmp))
          blj = max(0.,pmp)
          g_blk = g_blj*(0.5+sign(0.5,blj-lac))+g_lac*(0.5-sign(0.5,blj-lac))
          blk = max(blj,lac)
          g_blm = g_pmp*(0.5-sign(0.5,pmp-0.))
          blm = min(0.,pmp)
          g_bln = g_blm*(0.5+sign(0.5,lac-blm))+g_lac*(0.5-sign(0.5,lac-blm))
          bln = min(blm,lac)
          g_bll = g_al(i,j)*(0.5+sign(0.5,al(i,j)-q(i,j)-bln))+g_bln*(0.5-sign(0.5,al(i,j)-q(i,j)-bln))-g_q(i,j)*(0.5+sign(0.5,&
&al(i,j)-q(i,j)-bln))
          bll = max(al(i,j)-q(i,j),bln)
          g_bl(i,j) = g_blk*(0.5+sign(0.5,bll-blk))+g_bll*(0.5-sign(0.5,bll-blk))
          bl(i,j) = min(blk,bll)
          g_pmp = 2*g_dq(i,j-1)
          pmp = 2.*dq(i,j-1)
          g_lac = (-1.5)*g_dq(i,j-2)+g_pmp
          lac = pmp-1.5*dq(i,j-2)
          g_brj = g_pmp*(0.5-sign(0.5,0.-pmp))
          brj = max(0.,pmp)
          g_brk = g_brj*(0.5+sign(0.5,brj-lac))+g_lac*(0.5-sign(0.5,brj-lac))
          brk = max(brj,lac)
          g_brm = g_pmp*(0.5-sign(0.5,pmp-0.))
          brm = min(0.,pmp)
          g_brn = g_brm*(0.5+sign(0.5,lac-brm))+g_lac*(0.5-sign(0.5,lac-brm))
          brn = min(brm,lac)
          g_brl = g_al(i,j+1)*(0.5+sign(0.5,al(i,j+1)-q(i,j)-brn))+g_brn*(0.5-sign(0.5,al(i,j+1)-q(i,j)-brn))-g_q(i,j)*(0.5+&
&sign(0.5,al(i,j+1)-q(i,j)-brn))
          brl = max(al(i,j+1)-q(i,j),brn)
          g_br(i,j) = g_brk*(0.5+sign(0.5,brl-brk))+g_brl*(0.5-sign(0.5,brl-brk))
          br(i,j) = min(brk,brl)
        end do
      end do
    else
      do j = js-1, je+1
        do i = ifirst, ilast
          g_bl(i,j) = g_al(i,j)-g_q(i,j)
          bl(i,j) = al(i,j)-q(i,j)
          g_br(i,j) = g_al(i,j+1)-g_q(i,j)
          br(i,j) = al(i,j+1)-q(i,j)
        end do
      end do
    endif
    if (jord .ne. 11) then
      do j = js-1, je+1
        help_m = ilast-ifirst+1
        call g_pert_ppm( help_m,q(ifirst,j),g_q(ifirst,j),bl(ifirst,j),g_bl(ifirst,j),br(ifirst,j),g_br(ifirst,j),0 )
      end do
    endif
  endif
  do j = js, je+1
    do i = ifirst, ilast
      if (c(i,j) .gt. 0.) then
        g_flux(i,j) = (-(g_bl(i,j-1)*(1.-c(i,j))*c(i,j)))+g_br(i,j-1)*(1.-c(i,j))*(1-c(i,j))-g_c(i,j)*((1.-c(i,j))*(bl(i,j-1)+br(i,&
&j-1))+br(i,j-1)-c(i,j)*(bl(i,j-1)+br(i,j-1)))+g_q(i,j-1)
        flux(i,j) = q(i,j-1)+(1.-c(i,j))*(br(i,j-1)-c(i,j)*(bl(i,j-1)+br(i,j-1)))
      else
        g_flux(i,j) = g_bl(i,j)*(1.+c(i,j))*(1+c(i,j))+g_br(i,j)*(1.+c(i,j))*c(i,j)+g_c(i,j)*((1.+c(i,j))*(bl(i,j)+br(i,j))+bl(i,j)&
&+c(i,j)*(bl(i,j)+br(i,j)))+g_q(i,j)
        flux(i,j) = q(i,j)+(1.+c(i,j))*(bl(i,j)+c(i,j)*(bl(i,j)+br(i,j)))
      endif
    end do
  end do
endif

end subroutine g_fyppm


subroutine g_pert_ppm( im, a0, g_a0, al, g_al, ar, g_ar, iv )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare parameters
!==============================================
real, parameter :: r12 = 1./12.

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: im
real, intent(in) :: a0(im)
real, intent(inout) :: al(im)
real, intent(inout) :: ar(im)
real, intent(in) :: g_a0(im)
real, intent(inout) :: g_al(im)
real, intent(inout) :: g_ar(im)
integer, intent(in) :: iv

!==============================================
! declare local variables
!==============================================
real :: a4
real :: a6da
real :: da1
real :: da2
real :: fmin
real :: g_a4
real :: g_a6da
real :: g_da1
real :: g_da2
real :: g_fmin
integer :: i

!----------------------------------------------
! TANGENT LINEAR AND FUNCTION STATEMENTS
!----------------------------------------------
if (iv .eq. 0) then
  do i = 1, im
    g_a4 = (-3)*g_al(i)-3*g_ar(i)
    a4 = -(3.*(ar(i)+al(i)))
    g_da1 = (-g_al(i))+g_ar(i)
    da1 = ar(i)-al(i)
    if (abs(da1) .lt. (-a4)) then
      g_fmin = g_a0(i)+g_a4*((-(0.25/(a4*a4)*da1**2))+r12)+2*g_da1*0.25/a4*da1
      fmin = a0(i)+0.25/a4*da1**2+a4*r12
      if (fmin .lt. 0.) then
        if (ar(i) .gt. 0. .and. al(i) .gt. 0.) then
          g_ar(i) = 0.
          ar(i) = 0.
          g_al(i) = 0.
          al(i) = 0.
        else if (da1 .gt. 0.) then
          g_ar(i) = (-2)*g_al(i)
          ar(i) = -(2.*al(i))
        else
          g_al(i) = (-2)*g_ar(i)
          al(i) = -(2.*ar(i))
        endif
      endif
    endif
  end do
else
  do i = 1, im
    if (al(i)*ar(i) .lt. 0.) then
      g_da1 = g_al(i)-g_ar(i)
      da1 = al(i)-ar(i)
      g_da2 = 2*g_da1*da1
      da2 = da1**2
      g_a6da = 3*g_al(i)*da1+3*g_ar(i)*da1+3*g_da1*(al(i)+ar(i))
      a6da = 3.*(al(i)+ar(i))*da1
      if (a6da .lt. (-da2)) then
        g_ar(i) = (-2)*g_al(i)
        ar(i) = -(2.*al(i))
      else if (a6da .gt. da2) then
        g_al(i) = (-2)*g_ar(i)
        al(i) = -(2.*ar(i))
      endif
    else
      g_al(i) = 0.
      al(i) = 0.
      g_ar(i) = 0.
      ar(i) = 0.
    endif
  end do
endif

end subroutine g_pert_ppm


subroutine g_xmist_2d( q, g_q, dm, g_dm, ng, iord, ifirst, ilast, jfirst, jlast )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: ifirst
integer, intent(in) :: ilast
integer, intent(in) :: jfirst
integer, intent(in) :: jlast
integer, intent(in) :: ng
real, intent(inout) :: dm(ifirst-ng:ilast+ng,jfirst:jlast)
real, intent(inout) :: g_dm(ifirst-ng:ilast+ng,jfirst:jlast)
real, intent(in) :: g_q(ifirst-ng:ilast+ng,jfirst:jlast)
integer, intent(in) :: iord
real, intent(in) :: q(ifirst-ng:ilast+ng,jfirst:jlast)

!==============================================
! declare local variables
!==============================================
real :: dmh
real :: dmi
real :: dmj
real :: g_dmh
real :: g_dmi
real :: g_dmj
real :: g_qmax
real :: g_qmaxi
real :: g_qmin
real :: g_qmini
integer :: i
integer :: j
real :: qmax
real :: qmaxi
real :: qmin
real :: qmini

!----------------------------------------------
! TANGENT LINEAR AND FUNCTION STATEMENTS
!----------------------------------------------
do j = jfirst, jlast
  do i = ifirst-ng+1, ilast+ng-1
    g_dm(i,j) = (-0.25)*g_q(i-1,j)+0.25*g_q(i+1,j)
    dm(i,j) = 0.25*(q(i+1,j)-q(i-1,j))
  end do
end do
if (iord .gt. 0) then
  do j = jfirst, jlast
    do i = ifirst-ng+1, ilast+ng-1
      g_qmaxi = g_q(i-1,j)*(0.5+sign(0.5,q(i-1,j)-q(i,j)))+g_q(i,j)*(0.5-sign(0.5,q(i-1,j)-q(i,j)))
      qmaxi = max(q(i-1,j),q(i,j))
      g_qmax = (-g_q(i,j))+g_q(i+1,j)*(0.5-sign(0.5,qmaxi-q(i+1,j)))+g_qmaxi*(0.5+sign(0.5,qmaxi-q(i+1,j)))
      qmax = max(qmaxi,q(i+1,j))-q(i,j)
      g_qmini = g_q(i-1,j)*(0.5+sign(0.5,q(i,j)-q(i-1,j)))+g_q(i,j)*(0.5-sign(0.5,q(i,j)-q(i-1,j)))
      qmini = min(q(i-1,j),q(i,j))
      g_qmin = g_q(i,j)-(g_q(i+1,j)*(0.5-sign(0.5,q(i+1,j)-qmini))+g_qmini*(0.5+sign(0.5,q(i+1,j)-qmini)))
      qmin = q(i,j)-min(qmini,q(i+1,j))
      g_dmh = g_dm(i,j)*sign(1.,dm(i,j))
      dmh = abs(dm(i,j))
      g_dmi = g_dmh*(0.5+sign(0.5,qmin-dmh))+g_qmin*(0.5-sign(0.5,qmin-dmh))
      dmi = min(dmh,qmin)
      g_dmj = g_dmi*(0.5+sign(0.5,qmax-dmi))+g_qmax*(0.5-sign(0.5,qmax-dmi))
      dmj = min(dmi,qmax)
      g_dm(i,j) = g_dmj*sign(1.,dmj)*sign(1.,dm(i,j))
      dm(i,j) = sign(dmj,dm(i,j))
    end do
  end do
endif

end subroutine g_xmist_2d


subroutine g_xtp( fx, g_fx, q, g_q, c, g_c, iord, ifirst, ilast, jfirst, jlast, npx, npy, uniform_ppm )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: jfirst
integer, intent(in) :: jlast
real, intent(in) :: c(is:ie+1,jfirst:jlast)
integer, intent(in) :: ifirst
integer, intent(in) :: ilast
real, intent(out) :: fx(ifirst:ilast+1,jfirst:jlast)
real, intent(in) :: g_c(is:ie+1,jfirst:jlast)
real, intent(out) :: g_fx(ifirst:ilast+1,jfirst:jlast)
real, intent(in) :: g_q(isd:ied,jfirst:jlast)
integer, intent(in) :: iord
integer, intent(in) :: npx
integer, intent(in) :: npy
real, intent(in) :: q(isd:ied,jfirst:jlast)
logical, intent(in) :: uniform_ppm

!==============================================
! declare local variables
!==============================================
real :: dm(ifirst-ng:ilast+ng,jfirst:jlast)
real :: g_dm(ifirst-ng:ilast+ng,jfirst:jlast)
integer :: i
integer :: iu
integer :: j

!----------------------------------------------
! TANGENT LINEAR AND FUNCTION STATEMENTS
!----------------------------------------------
if (iord .eq. 1) then
  do j = jfirst, jlast
    do i = ifirst, ilast+1
      iu = floor(real(i)-c(i,j))
      g_fx(i,j) = g_q(iu,j)
      fx(i,j) = q(iu,j)
    end do
  end do
else if (abs(iord) .eq. 2) then
  call g_xmist_2d( q,g_q,dm,g_dm,ng,iord,ifirst,ilast,jfirst,jlast )
  do j = jfirst, jlast
    do i = ifirst, ilast+1
      iu = floor(real(i)-c(i,j))
      g_fx(i,j) = (-(g_c(i,j)*dm(iu,j)))+g_dm(iu,j)*(sign(1.,c(i,j))-c(i,j))+g_q(iu,j)
      fx(i,j) = q(iu,j)+(sign(1.,c(i,j))-c(i,j))*dm(iu,j)
    end do
  end do
else
  call g_fxppm( c,g_c,q,g_q,fx,g_fx,iord,ifirst,ilast,jfirst,jlast,npx,npy,uniform_ppm )
endif

end subroutine g_xtp


subroutine g_ymist( q, g_q, dm, g_dm, ng, jord, ifirst, ilast, jfirst, jlast )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
integer, intent(in) :: ifirst
integer, intent(in) :: ilast
integer, intent(in) :: jfirst
integer, intent(in) :: jlast
integer, intent(in) :: ng
real, intent(inout) :: dm(ifirst:ilast,jfirst-ng:jlast+ng)
real, intent(inout) :: g_dm(ifirst:ilast,jfirst-ng:jlast+ng)
real, intent(in) :: g_q(ifirst:ilast,jfirst-ng:jlast+ng)
integer, intent(in) :: jord
real, intent(in) :: q(ifirst:ilast,jfirst-ng:jlast+ng)

!==============================================
! declare local variables
!==============================================
real :: dmh
real :: dmi
real :: dmj
real :: g_dmh
real :: g_dmi
real :: g_dmj
real :: g_qmax
real :: g_qmaxi
real :: g_qmin
real :: g_qmini
integer :: i
integer :: j
real :: qmax
real :: qmaxi
real :: qmin
real :: qmini

!----------------------------------------------
! TANGENT LINEAR AND FUNCTION STATEMENTS
!----------------------------------------------
do j = jfirst-ng+1, jlast+ng-1
  do i = ifirst, ilast
    g_dm(i,j) = (-0.25)*g_q(i,j-1)+0.25*g_q(i,j+1)
    dm(i,j) = 0.25*(q(i,j+1)-q(i,j-1))
  end do
end do
if (jord .gt. 0) then
  do j = jfirst-ng+1, jlast+ng-1
    do i = ifirst, ilast
      g_qmaxi = g_q(i,j-1)*(0.5+sign(0.5,q(i,j-1)-q(i,j)))+g_q(i,j)*(0.5-sign(0.5,q(i,j-1)-q(i,j)))
      qmaxi = max(q(i,j-1),q(i,j))
      g_qmax = (-g_q(i,j))+g_q(i,j+1)*(0.5-sign(0.5,qmaxi-q(i,j+1)))+g_qmaxi*(0.5+sign(0.5,qmaxi-q(i,j+1)))
      qmax = max(qmaxi,q(i,j+1))-q(i,j)
      g_qmini = g_q(i,j-1)*(0.5+sign(0.5,q(i,j)-q(i,j-1)))+g_q(i,j)*(0.5-sign(0.5,q(i,j)-q(i,j-1)))
      qmini = min(q(i,j-1),q(i,j))
      g_qmin = g_q(i,j)-(g_q(i,j+1)*(0.5-sign(0.5,q(i,j+1)-qmini))+g_qmini*(0.5+sign(0.5,q(i,j+1)-qmini)))
      qmin = q(i,j)-min(qmini,q(i,j+1))
      g_dmh = g_dm(i,j)*sign(1.,dm(i,j))
      dmh = abs(dm(i,j))
      g_dmi = g_dmh*(0.5+sign(0.5,qmin-dmh))+g_qmin*(0.5-sign(0.5,qmin-dmh))
      dmi = min(dmh,qmin)
      g_dmj = g_dmi*(0.5+sign(0.5,qmax-dmi))+g_qmax*(0.5-sign(0.5,qmax-dmi))
      dmj = min(dmi,qmax)
      g_dm(i,j) = g_dmj*sign(1.,dmj)*sign(1.,dm(i,j))
      dm(i,j) = sign(dmj,dm(i,j))
    end do
  end do
endif

end subroutine g_ymist


subroutine g_ytp( fy, g_fy, q, g_q, c, g_c, jord, ifirst, ilast, jfirst, jlast, npx, npy, uniform_ppm )
!******************************************************************
!******************************************************************
!** This routine was generated by Automatic differentiation.     **
!** FastOpt: Transformation of Algorithm in Fortran, TAF 1.9.22  **
!******************************************************************
!******************************************************************
!==============================================
! all entries are defined explicitly
!==============================================
implicit none

!==============================================
! declare arguments
!==============================================
real, intent(in) :: c(isd:ied,js:je+1)
integer, intent(in) :: ifirst
integer, intent(in) :: ilast
integer, intent(in) :: jfirst
integer, intent(in) :: jlast
real, intent(out) :: fy(ifirst:ilast,jfirst:jlast+1)
real, intent(in) :: g_c(isd:ied,js:je+1)
real, intent(out) :: g_fy(ifirst:ilast,jfirst:jlast+1)
real, intent(in) :: g_q(ifirst:ilast,jfirst-ng:jlast+ng)
integer, intent(in) :: jord
integer, intent(in) :: npx
integer, intent(in) :: npy
real, intent(in) :: q(ifirst:ilast,jfirst-ng:jlast+ng)
logical, intent(in) :: uniform_ppm

!==============================================
! declare local variables
!==============================================
real :: dm(ifirst:ilast,jfirst-ng:jlast+ng)
real :: g_dm(ifirst:ilast,jfirst-ng:jlast+ng)
integer :: i
integer :: j
integer :: jt

!----------------------------------------------
! TANGENT LINEAR AND FUNCTION STATEMENTS
!----------------------------------------------
if (jord .eq. 1) then
  do j = jfirst, jlast+1
    do i = ifirst, ilast
      jt = floor(real(j)-c(i,j))
      g_fy(i,j) = g_q(i,jt)
      fy(i,j) = q(i,jt)
    end do
  end do
else if (abs(jord) .eq. 2) then
  call g_ymist( q,g_q,dm,g_dm,ng,jord,ifirst,ilast,jfirst,jlast )
  do j = jfirst, jlast+1
    do i = ifirst, ilast
      jt = floor(real(j)-c(i,j))
      g_fy(i,j) = (-(g_c(i,j)*dm(i,jt)))+g_dm(i,jt)*(sign(1.,c(i,j))-c(i,j))+g_q(i,jt)
      fy(i,j) = q(i,jt)+(sign(1.,c(i,j))-c(i,j))*dm(i,jt)
    end do
  end do
else
  call g_fyppm( c,g_c,q,g_q,fy,g_fy,jord,ifirst,ilast,jfirst,jlast,npx,npy,uniform_ppm,dm,g_dm )
endif

end subroutine g_ytp


end module     g_tpcore


